# QuantumClifford.jl

<table>
    <tr>
        <td>Documentation</td>
        <td>
            <a href="https://quantumsavory.github.io/QuantumClifford.jl/stable"><img src="https://img.shields.io/badge/docs-stable-blue.svg" alt="Documentation of latest stable version"></a>
            <a href="https://quantumsavory.github.io/QuantumClifford.jl/dev"><img src="https://img.shields.io/badge/docs-dev-blue.svg" alt="Documentation of dev version"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Continuous integration</td>
        <td>
            <a href="https://github.com/QuantumSavory/QuantumClifford.jl/actions?query=workflow%3ACI+branch%3Amaster"><img src="https://github.com/QuantumSavory/QuantumClifford.jl/actions/workflows/ci.yml/badge.svg" alt="GitHub Workflow Status"></a>
            <a href="https://buildkite.com/quantumsavory/quantumclifford"><img src="https://badge.buildkite.com/8ef137151415f29c03544c5b7963f6bc6afc1022f29cfc072a.svg?branch=master" alt="Buildkite Workflow Status"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Code coverage</td>
        <td>
            <a href="https://codecov.io/gh/QuantumSavory/QuantumClifford.jl"><img src="https://img.shields.io/codecov/c/gh/QuantumSavory/QuantumClifford.jl?label=codecov" alt="Test coverage from codecov"></a>
        </td>
    </tr><tr></tr>
    <tr>
        <td>Static analysis with</td>
        <td>
            <a href="https://github.com/aviatesk/JET.jl"><img src="https://img.shields.io/badge/%F0%9F%9B%A9%EF%B8%8F_tested_with-JET.jl-233f9a" alt="JET static analysis"></a>
            <a href="https://github.com/JuliaTesting/Aqua.jl"><img src="https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg" alt="Aqua QA"></a>
        </td>
    </tr>
</table>


A Julia package for working with quantum stabilizer states and Clifford circuits
that act on them. Graphs states are also supported. The package is already very fast for the majority of common operations, but there are still many low-hanging fruits performance-wise. See the detailed [suggested readings & references page](https://quantumsavory.github.io/QuantumClifford.jl/dev/references/#Suggested-reading) for background on the various algorithms.

To install it use:

```julia
] add QuantumClifford
```

Works efficiently with
[pure](https://qc.quantumsavory.org/dev/stab-algebra-manual/#Stabilizers) and
[mixed stabilizer](https://qc.quantumsavory.org/dev/mixed/#Mixed-Stabilizer-States)
states of thousands of qubits
as well as
[sparse or dense Clifford operations](https://qc.quantumsavory.org/dev/stab-algebra-manual/#Clifford-Operators)
acting upon them.

Implements [Pauli frames](https://qc.quantumsavory.org/dev/ecc_example_sim/) for fast sampling.

Provides
[canonicalization](https://qc.quantumsavory.org/dev/stab-algebra-manual/#Canonicalization-of-Stabilizers),
[projection](http://qc.quantumsavory.org/dev/stab-algebra-manual/#Projective-Measurements), and
[generation](https://qc.quantumsavory.org/dev/stab-algebra-manual/#Generating-a-Pauli-Operator-with-Stabilizer-Generators) operations,
as well as
[partial traces](https://qc.quantumsavory.org/dev/stab-algebra-manual/#Partial-Traces).

```jldoctest
julia> P"X" * P"Z"
-iY

julia> P"X" ⊗ P"Z"
+ XZ

julia> S"-XX
         +ZZ"
- XX
+ ZZ

julia> tCNOT * S"-XX
                 +ZZ"
- X_
+ _Z
```

The code is vectorized and multithreaded.

Fast, in-place, allocation free implementations.

<details>
    <summary>Quick Benchmarks (click to expand)</summary>

#### Comparison against other Clifford simulators

The only other simulator of similar performance I know of is [Stim](https://github.com/quantumlib/Stim).

The "low level" functionality is of similar performance in Stim and QuantumClifford but different tradeoffs are made at the higher levels: to multiply in-place 1M-qubit Pauli operators Stim and QuantumClifford.jl both need around 15μs. The difference is inconsequential and depends on compilers and hardware.

Of note is that Stim achieved this performance through high-quality C++ SIMD code of significant sophistication, while QuantumClifford.jl is implemented in pure and simple Julia.

#### Multiplying two 1 gigaqubit Paulis in 13 ms

```jldoctest
julia> a = random_pauli(1_000_000_000);
julia> b = random_pauli(1_000_000_000);
julia> @benchmark QuantumClifford.mul_left!(a,b)
BenchmarkTools.Trial: 373 samples with 1 evaluation.
 Range (min … max):  13.209 ms …  14.304 ms  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     13.355 ms               ┊ GC (median):    0.00%
 Time  (mean ± σ):   13.427 ms ± 173.503 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

 Memory estimate: 0 bytes, allocs estimate: 0.
```

#### Canonicalization of a random 1000-qubit stabilizer in 9 ms

```jldoctest
julia> @benchmark canonicalize!(s) setup=(s=random_stabilizer(1000))
BenchmarkTools.Trial: 6 samples with 1 evaluation.
 Range (min … max):  8.516 ms …  8.614 ms  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     8.536 ms              ┊ GC (median):    0.00%
 Time  (mean ± σ):   8.550 ms ± 35.883 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

 Memory estimate: 0 bytes, allocs estimate: 0.
```

#### Dense tableaux multiplication (tensor product of 500 CNOT gates acting 1000 qubits) in 17 ms

```jldoctest
julia> @benchmark apply!(s, gate) setup=(s=random_stabilizer(1000); gate=tensor_pow(tCNOT,500))
BenchmarkTools.Trial: 6 samples with 1 evaluation.
 Range (min … max):  16.879 ms … 17.064 ms  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     17.010 ms              ┊ GC (median):    0.00%
 Time  (mean ± σ):   16.997 ms ± 63.050 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

 Memory estimate: 800 bytes, allocs estimate: 4.
```

#### Sparse gate application to only specified qubits in a 1000 qubit tableau in 3 μs

```jldoctest
julia> @benchmark apply!(s, sCNOT(32,504)) setup=(s=random_stabilizer(1000))
BenchmarkTools.Trial: 6 samples with 8 evaluations.
 Range (min … max):  2.867 μs …   3.228 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     3.043 μs               ┊ GC (median):    0.00%
 Time  (mean ± σ):   3.049 μs ± 119.106 ns  ┊ GC (mean ± σ):  0.00% ± 0.00%

 Memory estimate: 0 bytes, allocs estimate: 0.
```

#### Measuring a dense 1000 qubit Pauli operator in 18 μs

```jldoctest
julia> s=random_destabilizer(1000); p=random_pauli(1000);

julia> @benchmark project!(_s,_p) setup=(_s=copy(s);_p=copy(p)) evals=1
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):  17.753 μs … 39.444 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     21.971 μs              ┊ GC (median):    0.00%
 Time  (mean ± σ):   21.893 μs ±  2.234 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

 Memory estimate: 480 bytes, allocs estimate: 4.
```

#### Measuring a single qubit in a 1000 qubit tableau in 15 μs

```jldoctest
julia> s=MixedDestabilizer(random_destabilizer(1000));

julia> @benchmark projectY!(_s,42) setup=(_s=copy(s)) evals=1
BenchmarkTools.Trial: 10000 samples with 1 evaluation.
 Range (min … max):  15.379 μs … 37.630 μs  ┊ GC (min … max): 0.00% … 0.00%
 Time  (median):     16.912 μs              ┊ GC (median):    0.00%
 Time  (mean ± σ):   17.120 μs ±  1.335 μs  ┊ GC (mean ± σ):  0.00% ± 0.00%

 Memory estimate: 464 bytes, allocs estimate: 5.
```

Benchmarks executed on a single thread on Ryzen Zen4 16-core CPU:

```
julia> versioninfo()
Julia Version 1.9.1
Commit 147bdf428cd (2023-06-07 08:27 UTC)
Platform Info:
  OS: Linux (x86_64-linux-gnu)
  CPU: 32 × AMD Ryzen 9 7950X 16-Core Processor
  WORD_SIZE: 64
  LIBM: libopenlibm
  LLVM: libLLVM-14.0.6 (ORCJIT, znver3)
  Threads: 1 on 32 virtual cores
```

More detailed benchmarks can be seen at [github.com/QuantumSavory/QuantumCliffordBenchmarksLog](https://github.com/QuantumSavory/QuantumCliffordBenchmarksLog).
</details>

## Office Hours

Office hours are held every Friday from 12:30 – 1:30 PM Eastern Time via [Zoom](https://umass-amherst.zoom.us/j/95986275946?pwd=6h7Wbai1bXIai0XQsatNRWaVbQlTDr.1). Before joining, make sure to check the [Julia community events calendar](https://julialang.org/community/#events) to confirm whether office hours are happening, rescheduled, or canceled for the week. Feel free to bring any questions or suggestions!

## Support

QuantumClifford.jl is developed by [many volunteers](https://github.com/QuantumSavory/QuantumClifford.jl/graphs/contributors), managed at [Prof. Krastanov's lab](https://lab.krastanov.org/) at [University of Massachusetts Amherst](https://www.umass.edu/quantum/).

The development effort is supported by The [NSF Engineering and Research Center for Quantum Networks](https://cqn-erc.arizona.edu/), and
by NSF Grant 2346089 "Research Infrastructure: CIRC: New: Full-stack Codesign Tools for Quantum Hardware".

## Bounties

[We run many bug bounties and encourage submissions from novices (we are happy to help onboard you in the field).](https://github.com/QuantumSavory/.github/blob/main/BUG_BOUNTIES.md)

To generate the documentation run from the project folder
```
julia --project=docs -tauto -e '
            using Pkg
            Pkg.develop(PackageSpec(path=pwd()))
            Pkg.instantiate()';
julia --project=docs -tauto -i docs/make.jl
```

You might want to modify these lines of `make.jl`
```
warnonly = [:missing_docs],
linkcheck = true,
```
in order to make sure the build succeeds locally, if you are debugging any issues.

# KernelAbstractions Extension

This directory contains the implementation for the KernelAbstractions derived functionality that may be utilised in conjunction with any of the supported hardware accelerators. Please consult the JuliaGPU documentation for comprehensive information on how to setup and configure any specific device.

# Requirements

The following packages must be imported in order to activate this extension:
- [Atomix](https://github.com/JuliaConcurrent/Atomix.jl)
- [GPUArraysCore](https://github.com/JuliaGPU/GPUArrays.jl)
- [KernelAbstractions](https://github.com/JuliaGPU/KernelAbstractions.jl)

In order to actually invoke its features, it is also pivotal to import the pertinent backend and ensure that the QuantumClifford defined objects are attached to storage residing within device memory. For convenience, an [Adapt](https://github.com/JuliaGPU/Adapt.jl) extension is also provided for handling the necessary conversion.

# Noteworthy Details

- It cannot be stressed enough that **ALL** the accelerated functionality is strictly *asynchronous* and that synchronisation barriers should be inserted as required. Please consult the relevant backend documentation for detailed instructions on this matter.
- Certain function calls are presently *synchronous* due to external limitations imposed by the toolchain dependencies. They should still be treated as *asynchronous* from a concurrency perspective as this will hopefully be resolved in a future release.
- Hardware limitations impose certain restrictions that are not present in the base package. Namely, the bitwidth of the phase variable(s) must be compatible with the usage of atomic intrinsics. The Adapt extension automatically handles this conversion but explicitly initialised objects must ensure their own compatibility.
- Wherever feasible, tuning parameters are exposed via `::Val` keyword arguments. Whilst the chosen defaults strive to be as performant as possible whilst maintaining generality, it may prove beneficial to further refine them to be more optimal for the underlying hardware.

# Warnings

The features provided herein remain an early and incomplete work-in-progress that is subject to continuous development. Bugs, missing features, and breaking changes are to be expected until such a time as when it is deemed suitable for official release. Consider this to be a thorough warning that **HERE BE DRAGONS**.

# Adapt Extension

This directory contains the implementation for the Adapt derived functionality that enables smooth interoperation between objects residing in either the host or the device memory spaces. Please consult the JuliaGPU documentation for comprehensive information on how to setup and configure any specific device.

# Requirements

The following packages must be imported in order to activate this extension:
- [Adapt](https://github.com/JuliaGPU/Adapt.jl)
- [GPUArraysCore](https://github.com/JuliaGPU/GPUArrays.jl)

To benefit from the specialised execution path(s) available via dispatching to the underlying hardware accelerators, the [KernelAbstractions](https://github.com/JuliaGPU/KernelAbstractions.jl) extension must be activated to enable those features.

# Noteworthy Details

- In order to support the utilisation of this extension in conjunction with the KernelAbstractions invocations, the bitwidth of the phase variable(s) must be compatible with the usage of atomic intrinsics. This is handled automatically by the adapt function calls but it introduces an incredibly minute discrepancy in the storage requirements depending on where the objects' memory is located.

# Warnings

The features provided herein remain an early and incomplete work-in-progress that is subject to continuous development. Bugs, missing features, and breaking changes are to be expected until such a time as when it is deemed suitable for official release. Consider this to be a thorough warning that **HERE BE DRAGONS**.

# Usage Instructions

1. Modify the parameters listed in `implementation/definitions.jl` as desired, keeping in mind the limitations of the available device memory and the extent of the benchmark runtime.
2. Ensure that all the packages listed in `implementation/imports.jl` are installed as this is not handled automatically.
3. Ensure that the backend package(s) listed in the pertinent `benchmark_platform_*.jl` script are properly setup and configured.
4. Pass said script as an argument to julia (optionally, also set the number of executing host threads) and await for the benchmark to conclude.
5. Navigate to the newly created directory in order to inspect the results.

# Noteworthy Details

- Even though OpenCL should in principle have cross-vendor compatibility, the JuliaGPU toolchain requires SPIR-V support in order to compile native julia code. At the present moment, this benchmark runs on the host and relies on `pocl_jll` to provide this intermediate representation. In the event that this is not necessary and/or desired, the line importing it may simply be removed from the OpenCL script.
- Modern hardware is able to dynamically change its clock speed depending on its current workload and operating conditions, possibly boosting performance in certain situations. This is *antithetical* to the reliability and reproducibility of any benchmark results since it sullies the measured performance metrics. As such, it is advised to consult with the relevant hardware manufacturer and/or operating system documentation for instructions on how to disable such features, or at the very least ensuring that they display minimal variation.

# KernelAbstractions Extension Tests

This directory contains the test suite for the range of KernelAbstractions-supported hardware accelerators. These tests are disabled by default since compatible hardware may not necessarily exist on all systems. Only a single platform may be tested in any individual run and it must be explicitly enabled by having the environment set `[CUDA, ROCm, OpenCL]_TEST=true` as desired.

# Noteworthy Details

- Synchronisation barriers are necessary prior to any test block in order to ensure their validity, given that all accelerated functionality is *asynchronous*.
- Some files require additional massaging and roundabout workarounds in order to perform their tests, which is due to a certain level of feature disparity between this extension and the base package. This will hopefully be resolved in a future release.

# (La)TeX hates SVG but the Plots package has issues with transparent PDFs.
const format = "svg"

# BenchmarkTools parameters.
# Evaluations per sample point.
const evals = 16
# Maximum number of samples.
const samples = 2^10
# Maximum runtime for each sample group.
const seconds = 60

# By definition, (unsigned) char is the smallest addressable unit of memory.
const MiB = 1024 * 1024 * count_zeros(zero(Cuchar))
# Avoid consuming too many resources, 1 GiB is plenty.
const n_MiB = [2^i for i = 1:10]
# TODO: Keep these or remove them now that a good default has been set?
const batch_sizes = [1, 4, 8, 16, 32, 64]

# These values are inaccessible since they originate from a package extension.
const default_block_size = 256
const default_batch_size = 32

using MacroTools

"""Turns `f(Val(x))` into `x ? f(Val(true)) : f(Val(false))` in order to avoid dynamic dispatch

See [discourse discussion](https://discourse.julialang.org/t/allocations-due-to-boolean-keyword-arguments-how-to-avoid-them/87654)"""
macro valbooldispatch(expr, bools...)
    for bool in bools
        true_branch  = MacroTools.postwalk(x->@capture(x, Val($bool)) ? :(Val(true )) : x, expr)
        false_branch = MacroTools.postwalk(x->@capture(x, Val($bool)) ? :(Val(false)) : x, expr)
        expr = quote
            if $bool
                $true_branch
            else
                $false_branch
            end
        end
    end
    esc(expr)
end

const GroupOrAdditiveGroupElem = Union{GroupElem,AdditiveGroupElem}

const GroupAlgebraElemMatrix = Union{
    Matrix{<:GroupAlgebraElem},
    LinearAlgebra.Adjoint{<:GroupAlgebraElem,<:Matrix{<:GroupAlgebraElem}}
}

const FqFieldGroupAlgebraElemMatrix = Union{
    Matrix{<:GroupAlgebraElem{FqFieldElem,<:GroupAlgebra}},
    LinearAlgebra.Adjoint{<:GroupAlgebraElem{FqFieldElem,<:GroupAlgebra},<:Matrix{<:GroupAlgebraElem{FqFieldElem,<:GroupAlgebra}}}
}

"""
Compute the conjugate of a group algebra element.
The conjugate is defined by inversing elements in the associated group.
"""
function group_algebra_conj(a::GroupAlgebraElem{T}) where T
    A = parent(a)
    d = dim(A)
    v = Vector{T}(undef, d)
    for i in 1:d
      v[i] = zero(base_ring(A))
    end
    id_index = findfirst(x -> x == 1, one(A).coeffs)
    # t = zero(base_ring(A))
    mt = multiplication_table(A, copy = false)
    acoeff = coefficients(a, copy = false)
    for i in 1:d
        if acoeff[i] != 0
            k = findfirst(x -> x==id_index, mt[i, :]) # find the inverse of i-th element in the group
            v[k] += acoeff[i]
        end
    end
    return A(v)
end

@testitem "Column-fast vs row-fast operations" begin
    using Random
    for n in [3, 300]
        for T in (Stabilizer, Destabilizer, MixedStabilizer, MixedDestabilizer)
            s = T(random_stabilizer(n,n))
            @test fastrow(copy(s)) == fastrow(fastcolumn(copy(s))) # TODO should not need to convert to the same layout for comparisons
            @test canonicalize!(fastrow(copy(s))) == fastrow(canonicalize!(fastcolumn(copy(s)))) # TODO should not need to convert to the same layout for comparisons
            c = random_clifford(n)
            layouts = []
            for layout in (fastrow, fastcolumn)
                ss = layout(copy(s))
                @test typeof(ss) == typeof(deepcopy(ss))
                apply!(ss, c)
                apply!(ss, sCNOT(1,n-1))
                push!(layouts, ss)
            end
            @test fastrow(copy(layouts[1])) == fastrow(copy(layouts[2]))
        end
    end
end

push!(LOAD_PATH,"../src/")

using Revise # for interactive doc updates
using Documenter
using DocumenterCitations
using AnythingLLMDocs
using QuantumClifford
using QuantumInterface
using QECCore
using QuantumClifford.ECC

import Hecke
const QuantumCliffordHeckeExt = Base.get_extension(QuantumClifford, :QuantumCliffordHeckeExt)

import Oscar
const QuantumCliffordOscarExt = Base.get_extension(QuantumClifford, :QuantumCliffordOscarExt)

import JuMP
const QuantumCliffordJuMPExt = Base.get_extension(QuantumClifford, :QuantumCliffordJuMPExt)

ENV["LINES"] = 80    # for forcing `displaysize(io)` to be big enough
ENV["COLUMNS"] = 80
doc_modules = [
    QuantumClifford,
    QuantumClifford.ECC,
    QuantumClifford.GraphSim,
    QuantumClifford.PauliChannelNonClifford,
    QuantumClifford.PureNonClifford,
    QuantumInterface,
    QuantumCliffordHeckeExt,
    QuantumCliffordOscarExt,
    QuantumCliffordJuMPExt,
    QECCore,
]

api_base="https://anythingllm.krastanov.org/api/v1"
anythingllm_assets = integrate_anythingllm(
    "QuantumClifford",
    doc_modules,
    @__DIR__,
    api_base;
    repo = "github.com/QuantumSavory/QuantumClifford.jl.git",
    options = EmbedOptions(),
)

bib = CitationBibliography(joinpath(@__DIR__,"src/references.bib"),style=:authoryear)

makedocs(
plugins = [bib],
doctest = false,
clean = true,
sitename = "QuantumClifford.jl",
format = Documenter.HTML(
    size_threshold_ignore = ["API.md", "ECC_API.md"],
    assets = anythingllm_assets,
),
modules = doc_modules,
warnonly = [:missing_docs, :linkcheck],
linkcheck = true,
authors = "Stefan Krastanov",
pages = [
"QuantumClifford.jl" => "index.md",
"Stabilizer Tableau Algebra" => [
    "Manual" => "stab-algebra-manual.md",
    "Canonicalization" => "canonicalization.md",
    "Mixed States" => "mixed.md",
    "Graph States" => "graphs.md",
    "Datastructure Choice" => "datastructures.md",
    "Useful States" => "commonstates.md",
],
"Circuit Simulation" => [
    "Simulation of Noisy Circuits" => "noisycircuits.md",
    "Monte Carlo" => "noisycircuits_mc.md",
    "Perturbative Expansions" => "noisycircuits_perturb.md",
    "ECC example" => "ecc_example_sim.md",
    "Circuit Operations" => "noisycircuits_ops.md",
],
"ECC compendium" => [
    "Evaluating codes and decoders" => "ECC_evaluating.md",
    "API" => "ECC_API.md"
],
"All Gates" => "allops.md",
"Visualizations" => "plotting.md",
"API" => "API.md",
"Tutorials and Publications" => "tutandpub.md",
"Suggested Readings & References" => "references.md",
],
)

deploydocs(
    repo = "github.com/QuantumSavory/QuantumClifford.jl.git"
)

@testitem "Gottesman codes should correct all single-qubit errors" tags=[:ecc] begin
    using QuantumClifford: mul_left!
    using QuantumClifford.ECC
    using QuantumClifford.ECC: AbstractECC

    for j in 3:12
        H = parity_checks(Gottesman(j))
        syndromes = Set([]) # the set automatically removes repeated entries
        for error_type in (single_x, single_y, single_z)
            for bit_index in 1:nqubits(H)
                syndrome = comm(H, error_type(nqubits(H), bit_index))
                @test any(==(0x1), syndrome) # checking the syndrome is not trivially zero
                push!(syndromes, syndrome)
            end
        end
        @test length(syndromes) == 3*nqubits(H)
    end
end

using Test
using QuantumClifford.ECC.QECCore
using QuantumClifford
using QuantumClifford.ECC
using QuantumClifford.ECC: check_repr_commutation_relation, check_repr_regular_linear
using InteractiveUtils
using SparseArrays

import Nemo: GF
import LinearAlgebra
import Hecke: group_algebra, abelian_group, gens, quo, one, small_group, polynomial_ring, GF, matrix, quo

# generate instances of all implemented codes to make sure nothing skips being checked

const H1 = sparse(Bool[1 0 1 0; 0 1 0 1; 1 1 0 0]);

const H2 = sparse(Bool[1 1 0;0 1 1]);

# We do not include smaller random circuit code because some of them has a bad distance and fails the TableDecoder test
const random_brickwork_circuit_args = repeat([((20,), 50, [1]), ((20,), 50, 1:2:20), ((5, 5), 50, [1]), ((3, 3, 3), 50, [1])], 10)
const random_all_to_all_circuit_args = repeat([(20, 200, 1), (40, 200, [1, 20])], 10)

random_circuit_code_args = vcat(
    [map(f -> getfield(random_brickwork_circuit_code(c...), f), fieldnames(CircuitCode)) for c in random_brickwork_circuit_args],
    [map(f -> getfield(random_all_to_all_circuit_code(c...), f), fieldnames(CircuitCode)) for c in random_all_to_all_circuit_args]
)

# test codes LP04 and LP118 from Appendix A of [raveendran2022finite](@cite),
B04 = Dict(
    7 => [0 0 0 0; 0 1 2 5; 0 6 3 1],
    9 => [0 0 0 0; 0 1 6 7; 0 4 5 2],
    17 => [0 0 0 0; 0 1 2 11; 0 8 12 13],
    19 => [0 0 0 0; 0 2 6 9; 0 16 7 11]
)

B118 = Dict(
    16 => [0 0 0 0 0; 0 2 4 7 11; 0 3 10 14 15],
    21 => [0 0 0 0 0; 0 4 5 7 17; 0 14 18 12 11],
    30 => [0 0 0 0 0; 0 2 14 24 25; 0 16 11 14 13],
)

LP04 = [LPCode(base_matrix, l .- base_matrix', l) for (l, base_matrix) in B04]
LP118 = [LPCode(base_matrix, l .- base_matrix', l) for (l, base_matrix) in B118]

# generalized bicyle codes from (A1) and (A2) Appendix B of [panteleev2021degenerate](@cite).
test_gb_codes = [
    generalized_bicycle_code_as_2bga([0, 15, 20, 28, 66], [0, 58, 59, 100, 121], 127), # (A1) [[254, 28, 14≤d≤20]]
    generalized_bicycle_code_as_2bga([0, 1, 14, 16, 22], [0, 3, 13, 20, 42], 63), # (A2) [[126, 28, 8]]
]

test_hcubic_codes = [
    Haah_cubic_code_as_2bga([0, 15, 20, 28, 66], [0, 58, 59, 100, 121], 3),
    Haah_cubic_code_as_2bga(8), # (D) [[1024, 30, 13 ≤ d ≤ 32]] Appendix B of [panteleev2021degenerate](@cite).
]

# honeycomb color codes from [eberhardt2024logical](@cite).
test_honeycomb_color_codes = [
    honeycomb_color_code_as_2bga(6 , 6), honeycomb_color_code_as_2bga(9 , 6),
    honeycomb_color_code_as_2bga(12, 6), honeycomb_color_code_as_2bga(12, 9),
]

# Lifted product codes using non-commutative algebras
# These are just made up, they are not known to
# specifically be good, they are not from a paper.
G = small_group(36,1)
GA = group_algebra(GF(2), G)
r, s  = gens(GA);
A = 1 + r
B = 1 + s + r^6 + s^3*r + s*r^7 + s^3*r^5
nonabel1 = two_block_group_algebra_code(A,B)

G = small_group(48,10)
GA = group_algebra(GF(2), G)
r, s  = gens(GA);
A = 1 + s*r^2
B = 1 + r + s^3 + s^4 + s^2*r^5 + s^4*r^6
nonabel2 = two_block_group_algebra_code(A,B)

G = small_group(40,8)
GA = group_algebra(GF(2), G)
r, s  = gens(GA);
A = 1 + s*r^5 + r^5 + s*r^6
B = 1 + s^2 + r + s^2*r^3
nonabel3 = two_block_group_algebra_code(A,B)

test_nonabelian_codes = [nonabel1, nonabel2, nonabel3]

other_lifted_product_codes = []

# [[882, 24, d≤24]] code from (B1) in Appendix B of [panteleev2021degenerate](@cite)
l = 63
GA = group_algebra(GF(2), abelian_group(l))
@test check_repr_commutation_relation(GA) # TODO use this check more pervasively throughout the test suite
@test check_repr_regular_linear(GA) # TODO use this check more pervasively throughout the test suite
A = zeros(GA, 7, 7)
x = gens(GA)[]
A[LinearAlgebra.diagind(A)] .= x^27
A[LinearAlgebra.diagind(A, -1)] .= x^54
A[LinearAlgebra.diagind(A, 6)] .= x^54
A[LinearAlgebra.diagind(A, -2)] .= GA(1)
A[LinearAlgebra.diagind(A, 5)] .= GA(1)
B = reshape([1 + x + x^6], (1, 1))
push!(other_lifted_product_codes, LPCode(A, B))

# coprime Bivariate Bicycle codes from Table 2 of [wang2024coprime](@cite)
# [[108,12,6]]
l=2; m=27
GA = group_algebra(GF(2), abelian_group([l*m]))
𝜋 = gens(GA)[1]
A = 𝜋^2 + 𝜋^5  + 𝜋^44
B = 𝜋^8 + 𝜋^14 + 𝜋^47
coprimeBB1 = two_block_group_algebra_code(A, B)

# [[126,12,10]]
l=7; m=9
GA = group_algebra(GF(2), abelian_group([l*m]))
𝜋 = gens(GA)[1]
A = 1   + 𝜋    + 𝜋^58
B = 𝜋^3 + 𝜋^16 + 𝜋^44
coprimeBB2 = two_block_group_algebra_code(A, B)

test_coprimeBB_codes = [coprimeBB1, coprimeBB2]

# Multivariate Bicycle codes taken from Table 1 of [voss2024multivariatebicyclecodes](@cite)
# Weight-4 [[144, 2, 12]] MBB code
l=8; m=9
GA = group_algebra(GF(2), abelian_group([l, m]))
x, y = gens(GA)
z = x*y
A = x^3 + y^7
B = x + y^5
weight4mbb = two_block_group_algebra_code(A, B)

# Weight-5 [96, 4, 8]] MBB code
l=8; m=6
GA = group_algebra(GF(2), abelian_group([l, m]))
x, y = gens(GA)
z = x*y
A = x^6 + x^3
B = z^5 + x^5 + y
weight5mbb = two_block_group_algebra_code(A, B)

# Weight-6 [[48, 4, 6]] MBB code
l=4; m=6
GA = group_algebra(GF(2), abelian_group([l, m]))
x, y = gens(GA)
z = x*y
A = x^3 + y^5
B = x + z^5 + y^5 + y^2
weight6mbb = two_block_group_algebra_code(A, B)

# Weight-7 [[30, 4, 5]] MBB code
l=5; m=3
GA = group_algebra(GF(2), abelian_group([l, m]));
x, y = gens(GA)
z = x*y
A = x^4 + x^2
B = x + x^2 + y + z^2 + z^3
weight7mbb = two_block_group_algebra_code(A, B)

test_mbb_codes = [weight4mbb, weight5mbb, weight6mbb, weight7mbb]

# Bivariate Bicycle codes
# A [[72, 12, 6]] code from Table 3 of [bravyi2024high](@cite).
l=6; m=6
GA = group_algebra(GF(2), abelian_group([l, m]))
x, y = gens(GA)
A = x^3 + y + y^2
B = y^3 + x + x^2
bb1 = two_block_group_algebra_code(A,B)

# A [[90, 8, 10]] code from Table 3 of [bravyi2024high](@cite).
l=15; m=3
GA = group_algebra(GF(2), abelian_group([l, m]))
x, y = gens(GA)
A = x^9 + y   + y^2
B = 1   + x^2 + x^7
bb2 = two_block_group_algebra_code(A,B)

# A [[360, 12, ≤ 24]]  code from Table 3 of [bravyi2024high](@cite).
l=30; m=6
GA = group_algebra(GF(2), abelian_group([l, m]))
x, y = gens(GA)
A = x^9 + y    + y^2
B = y^3 + x^25 + x^26
bb3 = two_block_group_algebra_code(A,B)

test_bb_codes = [bb1, bb2, bb3]

# Generalized Hypergraph Product codes
# [[882, 24, 18 ≤ d ≤ 24]] from Appendix B of [panteleev2021degenerate](@cite)
F = GF(2)
R, x = polynomial_ring(F, "x")
n_ghp1 = 7
l_ghp1 = 63
S_ghp1, _ =  quo(R, x^l_ghp1 - 1)
A_ghp1 = matrix(S_ghp1, n_ghp1, n_ghp1,
         [x^27  0     0     0     0     1     x^54
          x^54  x^27  0     0     0     0     1
          1     x^54  x^27  0     0     0     0
          0     1     x^54  x^27  0     0     0
          0     0     1     x^54  x^27  0     0
          0     0     0     1     x^54  x^27  0
          0     0     0     0     1     x^54  x^27])
b_ghp1 = S_ghp1(1 + x + x^6)

# [[882, 48, 16]] from Appendix B of [panteleev2021degenerate](@cite)
F = GF(2)
R, x = polynomial_ring(F, "x")
n_ghp2 = 7
l_ghp2 = 63
S_ghp2, _ =  quo(R, x^l_ghp2 - 1)
A_ghp2 = matrix(S_ghp2, n_ghp2, n_ghp2,
         [x^27   0     0     1     x^18  x^27  1
          1      x^27  0     0     1     x^18  x^27
          x^27   1     x^27  0     0     1     x^18
          x^18   x^27  1     x^27  0     0     1
          1      x^18  x^27  1     x^27  0     0
          0      1     x^18  x^27  1     x^27  0
          0      0     1     x^18  x^27  1     x^27])
b_ghp2 = S_ghp2(1 + x + x^6)

# Generalized Bicycle and Extended GB codes from [koukoulekidis2024smallquantumcodesalgebraic](@cite)
R, x = polynomial_ring(GF(2), :x)
l_gb₁ = 6
a_gb₁ = 1 + x^4
b_gb₁ = 1 + x + x^2 + x^4
c_gb₁ = GeneralizedBicycle(a_gb₁, b_gb₁, l_gb₁)
p_gb₁ = one(R)
l_gb₂ = 9
a_gb₂ = 1 + x^2
b_gb₂ = 1 + x^5
c_gb₂ = GeneralizedBicycle(a_gb₂, b_gb₂, l_gb₂)
p_gb₂ = one(R)
l_gb₃ = 10
a_gb₃ = 1 + x
b_gb₃ = 1 + x^6
c_gb₃ = GeneralizedBicycle(a_gb₃, a_gb₃, l_gb₃)
p_gb₃ = one(R) + x

# Add some codes that require Oscar, hence do not work on Windows

test_twobga_codes = []

# La-cross code polynomial
F = GF(2)
R, x = polynomial_ring(F, "x")
h₂ = 1 + x + x^2
h₃ = 1 + x + x^3
h₄ = 1 + x + x^4

# Generalized Bivariate Bicycle Codes
# [[108, 8, 10]] from [bravyi2024high](@cite)
l1 = 9
m1 = 6
A1 = [(:x, 3), (:y, 1), (:y, 2)] # A = x³ + y + y²
B1 = [(:y, 3), (:x, 1), (:x, 2)] # B = y³ + x + x²

# [[90, 8, 10]] from [bravyi2024high](@cite)
l2 = 15
m2 = 3
A2 = [(:x, 9), (:y, 1), (:y, 2)] # A = x⁹ + y + y²
B2 = [(:y, 0), (:x, 2), (:x, 7)] # B = 1 + x² + x⁷

# [[72, 12, 6]] from from [bravyi2024high](@cite)
l3 = 6
m3 = 6
A3 = [(:x, 3), (:y, 1), (:y, 2)] # A = x³ + y + y²
B3 = [(:y, 3), (:x, 1), (:x, 2)] # B = y³ + x + x²

# [[54, 8, 6]] from [wang2024coprime](@cite)
l4 = 3
m4 = 9
A4 = [(:x, 0), (:y, 2), (:y, 4)] # A = 1 + y² + y⁴
B4 = [(:y, 3), (:x, 1), (:x, 2)] # B = y³ + x + x²

# [[98, 6, 12]] from [wang2024coprime](@cite)
l5 = 7
m5 = 7
A5 = [(:x, 3), (:y, 5), (:y, 6)] # A = x³ + y⁵ + y⁶
B5 = [(:y, 2), (:x, 3), (:x, 5)] # A = y² + x³ + x⁵

const code_instance_args = Dict(
    :Toric => [(3,3), (4,4), (3,6), (4,3), (5,5)],
    :Surface => [(3,3), (4,4), (3,6), (4,3), (5,5)],
    :Gottesman => [(3,), (4,), (5,)],
    :CSS => (c -> (parity_matrix_x(c), parity_matrix_z(c))).([Shor9(), Steane7(), Toric(4, 4)]),
    :Concat => [(Perfect5(), Perfect5()), (Perfect5(), Steane7()), (Steane7(), Cleve8()), (Toric(2, 2), Shor9())],
    :CircuitCode => random_circuit_code_args,
    :LPCode => (c -> (c.A, c.B)).(vcat(LP04, LP118, test_gb_codes, test_bb_codes, test_mbb_codes, test_coprimeBB_codes, test_hcubic_codes, test_twobga_codes, test_honeycomb_color_codes, test_nonabelian_codes, other_lifted_product_codes)),
    :QuantumReedMuller => [(3,), (4,), (5,)],
    :Triangular488 => [(3,), (5,), (7,), (9,), (11,)],
    :Triangular666 => [(3,), (5,), (7,), (9,), (11,)],
    :DelfosseReichardt => [(2,1,3), (2,2,4), (4,3,5), (4,3,6)],
    :DelfosseReichardtRep => [(4,), (6,), (8,), (10,)],
    :DelfosseReichardt823 => [(2,), (3,), (4,), (5,)],
    :QuantumTannerGraphProduct => [(H1, H2),(H2, H2), (H1, H1), (H2, H1)],
    :CyclicQuantumTannerGraphProduct => [(2,), (3,), (4,)],
    :LaCross => [(5,h₂,true), (6,h₂,true), (8,h₂,true), (7,h₃,false), (7,h₃,true), (9,h₃,true), (9,h₄,true), (10,h₄,true), (12,h₄,true)],
    :TillichZemor => [(4,3,3), (5,4,4), (6,5,5), (7,6,6)],
    :BivariateBicycleViaCirculantMat => [(l1, m1, A1, B1), (l2, m2, A2,B2), (l3, m3, A3, B3), (l4, m4, A4, B4), (l5, m5, A5, B5)],
    :GeneralizedHyperGraphProduct => [(A_ghp1, b_ghp1, l_ghp1), (A_ghp2, b_ghp2, l_ghp2)],
    :GeneralizedBicycle => [(a_gb₁, b_gb₁, l_gb₁), (a_gb₂, b_gb₂, l_gb₂), (a_gb₃ ,b_gb₃, l_gb₃)],
    :ExtendedGeneralizedBicycle => [(c_gb₁, 2, p_gb₁), (c_gb₂, 3, p_gb₂), (c_gb₃, 4, p_gb₃)]
)

@static if !Sys.iswindows() && Sys.ARCH == :x86_64 && VERSION >= v"1.11"
  import Oscar: free_group, cyclic_group, direct_product, small_group_identification, describe, order, gens, quo,
  polynomial_ring, matrix, GF, transpose, laurent_polynomial_ring, ideal
  function load_oscar_codes()
    #@info "Add group theoretic codes requiring Oscar"
    # [[72, 8, 9]] 2BGA code taken from Table I Block 1 of [lin2024quantum](@cite)
    F = free_group(["r"])
    r = gens(F)[1]
    G, = quo(F, [r^36])
    GA = group_algebra(GF(2), G)
    r = gens(G)[1]
    a = [one(G), r^28]
    b = [one(G), r, r^18, r^12, r^29, r^14]
    t1b1 = twobga_from_fp_group(a, b, GA)

    # [[54, 6, 9]] 2BGA code taken from Table I Block 3 of [lin2024quantum](@cite)
    F = free_group(["r"])
    r = gens(F)[1]
    G, = quo(F, [r^27])
    GA = group_algebra(GF(2), G)
    r = gens(G)[1]
    a = [one(G), r, r^3, r^7]
    b = [one(G), r, r^12, r^19]
    t1b3 = twobga_from_fp_group(a, b, GA)

    # [[16, 4, 4]] 2BGA taken from Appendix C, Table II of [lin2024quantum](@cite)
    F = free_group(["x", "s"])
    x, s = gens(F)
    G, = quo(F, [x^4, s^2, x * s * x^-1 * s^-1])
    GA = group_algebra(GF(2), G)
    x, s = gens(G)
    a = [one(G), x]
    b = [one(G), x, s, x^2, s*x, x^3]
    tb21 = twobga_from_fp_group(a, b, GA)

    # [[32, 8, 4]] 2BGA taken from Appendix C, Table II of [lin2024quantum](@cite)
    F = free_group(["x", "s"])
    x, s = gens(F)
    G, = quo(F, [x^8, s^2, x * s * x^-1 * s^-1])
    GA = group_algebra(GF(2), G)
    x, s = gens(G)
    a = [one(G), x^6]
    b = [one(G), s * x^7, s * x^4, x^6, s * x^5, s * x^2]
    tb22 = twobga_from_fp_group(a, b, GA)

    # Examples of Abelian 2BGA codes constructed from the Direct Product of two cyclic groups, denoted as `C₂ₘ = Cₘ × C₂`.
    # [[56, 8, 7]] 2BGA taken from Appendix C, Table II of [lin2024quantum](@cite)
    m = 14; n = 2
    C₁₄ = cyclic_group(m)
    C₂ = cyclic_group(n)
    G = direct_product(C₁₄, C₂)
    GA = group_algebra(GF(2), G)
    x, s = gens(GA)[1], gens(GA)[3]
    a = [one(GA), x^8]
    b = [one(GA), x^7, s, x^8, x^9, s * x^4]
    dprod1 = twobga_from_direct_product(a, b, GA)

    # [[48, 24, 2]] 2BGA taken from Appendix C, Table II of [lin2024quantum](@cite)
    m = 12; n = 2
    C₁₂ = cyclic_group(m)
    C₂ = cyclic_group(n)
    G = direct_product(C₁₂, C₂)
    GA = group_algebra(GF(2), G)
    x, s = gens(GA)[1], gens(GA)[4]
    a = [one(GA), s * x^6]
    b = [one(GA), x^3, s * x^6, x^4, s * x^9, s * x^10]
    dprod2 = twobga_from_direct_product(a, b, GA)

    # 2BGA codes using non-abelian groups: Table III of [lin2024quantum](@cite)
    # [[24, 8, 3]]
    m = 6
    F = free_group(["r", "s"])
    r, s = gens(F)
    G, = quo(F, [r^m, s^2, (r*s)^2])
    GA = group_algebra(GF(2), G)
    r, s = gens(G)
    a = [one(G), r^4]
    b = [one(G), s*r^4, r^3, r^4, s*r^2, r]
    nonabel1 = twobga_from_fp_group(a, b, GA)

    # [[24, 12, 2]]
    F = free_group(["r", "s"])
    r, s = gens(F)
    G, = quo(F, [r^m, s^2, (r*s)^2])
    GA = group_algebra(GF(2), G)
    r, s = gens(G)
    a = [one(G), r^3]
    b = [one(G), s*r, r^3, r^4, s*r^4, r]
    nonabel2 = twobga_from_fp_group(a, b, GA)

    # [[32, 8, 4]]
    m = 8
    F = free_group(["r", "s"])
    r, s = gens(F)
    G, = quo(F, [r^m, s^2, (r*s)^2])
    GA = group_algebra(GF(2), G)
    r, s = gens(G)
    a = [one(G), r^2]
    b = [one(G), s*r^5, s*r^4, r^2, s*r^7, s*r^6]
    nonabel3 = twobga_from_fp_group(a, b, GA)

    # [[32, 16, 2]]
    F = free_group(["r", "s"])
    r, s = gens(F)
    G, = quo(F, [r^m, s^2, (r*s)^2])
    GA = group_algebra(GF(2), G)
    r, s = gens(G)
    a = [one(G), r^4]
    b = [one(G), s*r^3, s*r^6, r^4, s*r^7, s*r^2]
    nonabel4 = twobga_from_fp_group(a, b, GA)

    append!(test_twobga_codes, [t1b1, t1b3, tb21, tb22, dprod1, dprod2, nonabel1, nonabel2, nonabel3, nonabel4])

    # Homological Product Codes
    # [[117, 9, 4]] from [xu2024fastparallelizablelogicalcomputation](@cite)
    R, x = polynomial_ring(GF(2), "x")
    l₁ = 3
    H₁ = matrix(R, 2, 3, [x^2 x^2 x^2;
                          x   x^2  0])

    # [[225, 9, 6]] from [xu2024fastparallelizablelogicalcomputation](@cite)
    R, x = polynomial_ring(GF(2), "x")
    l₂ = 3
    H₂ = matrix(R, 3, 4, [x^2 x^2 x^2   0;
                          x^2   0 x^2  x^2;
                          x^2 x^2   x  x^2])

    # 3D Homological product code from [Quintavalle_2021](@cite)
    μ = 2; wc = 3; wr = 4
    c = random_Gallager_ldpc(μ, wc, wr)
    H₃ = matrix(GF(2), c)

    # 3D Homological product code from [Quintavalle_2021](@cite)
    δ₄ = matrix(GF(2), parity_matrix(RepCode(3)))

    # Double Homological product codes
    # [[241, 1, 9]] from Table I of https://arxiv.org/pdf/1805.09271
    δ₁ = [1 1 0;
          0 1 1]

    # [[486, 6, 9]] from Table I of https://arxiv.org/pdf/1805.09271
    δ₂ = [1 1 0;
          0 1 1;
          1 0 1]

    # Trivariate Tricycle Codes from [jacob2025singleshotdecodingfaulttolerantgates](@cite)

    # [[36, 3, 3]] from Table III
    F₂ = GF(2)
    l₁, m₁, p₁ = 3, 2, 2
    R, (x, y, z) = polynomial_ring(F₂, [:x, :y, :z])
    I = ideal(R, [x^l₁ - 1, y^m₁ - 1, z^p₁ - 1])
    S, _ = quo(R, I)
    A₁ = S(1 + x*y*z)
    B₁ = S(1 + x^2*z)
    C₁ = S(1 + x)

    # [[48, 3, 4]] from Table III
    l₂, m₂, p₂ = 4, 2, 2
    I = ideal(R, [x^l₂ - 1, y^m₂ - 1, z^p₂ - 1])
    S, _ = quo(R, I)
    A₂ = S(1 + x)
    B₂ = S(1 + x*z)
    C₂ = S(1 + x*y)

    # [[54, 3, 4]] from Table III
    l₃, m₃, p₃ = 3, 3, 2
    I = ideal(R, [x^l₃ - 1, y^m₃ - 1, z^p₃ - 1])
    S, _ = quo(R, I)
    A₃ = S(1 + y*z)
    B₃ = S(1 + x*z)
    C₃ = S(1 + x*y*z)

    # [[108, 6, 2]] from Table IV
    l₄, m₄, p₄ = 4, 3, 3
    I = ideal(R, [x^l₄ - 1, y^m₄ - 1, z^p₄ - 1])
    S, _ = quo(R, I)
    A₄ = S((1 + x^2)*(1 + x*z))
    B₄ = S(1 + x^2*y^2)
    C₄ = S(1 + x^2*y^2*z^2)

    # Generalized Toric Codes from [liang2025generalizedtoriccodestwisted](@cite)
    # [[12, 4, 2]] from Table I of [liang2025generalizedtoriccodestwisted](@cite)
    R, (x,y) = laurent_polynomial_ring(GF(2), [:x, :y])
    f₁ = 1 + x + x*y
    g₁ = 1 + y + x*y
    α1₁ = (0, 3)
    α2₁ = (2, 1)

    # [[14, 6, 2]] from Table I of [liang2025generalizedtoriccodestwisted](@cite)
    f₂ = 1 + x + y
    g₂ = 1 + y + x
    α1₂ = (0, 7)
    α2₂ = (1, 2)

    # [[96, 4, 12]] from Table I of [liang2025generalizedtoriccodestwisted](@cite)
    f₃ = 1 + x + x^-2*y
    g₃ = 1 + y + x*y^-2
    α1₃ = (0, 12)
    α2₃ = (4, 2)

    # [[98, 6, 12]] from Table I of [liang2025generalizedtoriccodestwisted](@cite)
    f₄ = 1 + x + x^-1*y^2
    g₄ = 1 + y + x^-2*y^-1
    α1₄ = (0,  7)
    α2₄ = (7, 0)

    # [[112, 6, 12]] from Table II of [liang2025generalizedtoriccodestwisted](@cite)
    f₅ = 1 + x + x^-1*y^2
    g₅ = 1 + y + x^-2*y^-1
    α1₅ =(0, 7)
    α2₅ =(8, 2)

    # [[114, 4, 14]] from Table II of [liang2025generalizedtoriccodestwisted](@cite)
    f₆ = 1 + x + x^-3*y
    g₆ = 1 + y + x^-5
    α1₆ = (0,  3)
    α2₆ = (19, 1)

    # Bivariate Bicycle codes using polynomial quotient ring
    # [[72, 12, 6]]
    l_bb₁=6; m_bb₁=6
    R_bb₁, (x, y) = polynomial_ring(GF(2), [:x, :y])
    I_bb₁ = ideal(R_bb₁, [x^l-1, y^m-1])
    S_bb₁, _ = quo(R_bb₁, I_bb₁)
    A_bb₁ = S_bb₁(x^3 + y + y^2)
    B_bb₁ = S_bb₁(y^3 + x + x^2)

    # [[90, 8, 10]]
    l_bb₂=15; m_bb₂=3
    R_bb₂, (x, y) = polynomial_ring(GF(2), [:x, :y])
    I_bb₂ = ideal(R_bb₂, [x^l-1, y^m-1])
    S_bb₂, _ = quo(R_bb₂, I_bb₂)
    A_bb₂ = S_bb₂(x^9 + y   + y^2)
    B_bb₂ = S_bb₂(1   + x^2 + x^7)

    # [[108, 8, 10]]
    l_bb₃=9; m_bb₃=6
    R_bb₃, (x, y) = polynomial_ring(GF(2), [:x, :y])
    I_bb₃ = ideal(R_bb₃, [x^l-1, y^m-1])
    S_bb₃, _ = quo(R_bb₃, I_bb₃)
    A_bb₃ = S_bb₃(x^3 + y + y^2)
    B_bb₃ = S_bb₃(y^3 + x + x^2)

    # [[54, 8, 6]]
    l_bb₄=3; m_bb₄=9
    R_bb₄, (x, y) = polynomial_ring(GF(2), [:x, :y])
    I_bb₄ = ideal(R_bb₄, [x^l-1, y^m-1])
    S_bb₄, _ = quo(R_bb₄, I_bb₄)
    A_bb₄ = S_bb₄(1   + y^2 + y^4)
    B_bb₄ = S_bb₄(y^3 + x   + x^2)

    # [[98, 6, 12]]
    l_bb₅=7; m_bb₅=7
    R_bb₅, (x, y) = polynomial_ring(GF(2), [:x, :y])
    I_bb₅ = ideal(R_bb₅, [x^l-1, y^m-1])
    S_bb₅, _ = quo(R_bb₅, I_bb₅)
    A_bb₅ = S_bb₅(x^3 + y^5 + y^6)
    B_bb₅ = S_bb₅(y^2 + x^3 + x^5)

    # Multivariate Multicycle Codes
    # t = 2; Bivariate Bicycle codes
    # [[72, 12, 6]]
    l_mm₁ =6; m_mm₁ = 6
    R_mm₁, (x, y) = polynomial_ring(GF(2), [:x, :y])
    I_mm₁ = ideal(R_mm₁, [x^l_mm₁-1, y^m_mm₁-1])
    S_mm₁, _ = quo(R_mm₁, I_mm₁)
    A_mm₁ = S_mm₁(x^3 + y + y^2)
    B_mm₁ = S_mm₁(y^3 + x + x^2)

    # [[90, 8, 10]]
    l_mm₂ =15; m_mm₂ = 3
    R_mm₂, (x, y) = polynomial_ring(GF(2), [:x, :y])
    I_mm₂ = ideal(R_mm₂, [x^l_mm₂-1, y^m_mm₂-1])
    S_mm₂, _ = quo(R_mm₂, I_mm₂)
    A_mm₂ = S_mm₂(x^9 + y   + y^2)
    B_mm₂ = S_mm₂(1   + x^2 + x^7)

    # t = 3; Trivariate Tricycle codes
    # [[60, 3, 4]]
    ℓ_mm₃, m_mm₃, p_mm₃ = 5, 2, 2
    F2_mm₃ = GF(2)
    R_mm₃, (x, y, z) = polynomial_ring(F2_mm₃, [:x, :y, :z])
    I_mm₃ = ideal(R_mm₃, [x^ℓ_mm₃ - 1, y^m_mm₃ - 1, z^p_mm₃ - 1])
    S_mm₃, _ = quo(R_mm₃, I_mm₃)
    A_mm₃ = S_mm₃(1 + x*z)
    B_mm₃ = S_mm₃(1 + x*y)
    C_mm₃ = S_mm₃(1 + x*y*z)

    # [[90, 3, 5]]
    ℓ_mm₄, m_mm₄, p_mm₄ = 5, 3, 2
    F2_mm₄ = GF(2)
    R_mm₄, (x, y, z) = polynomial_ring(F2_mm₄, [:x, :y, :z])
    I_mm₄ = ideal(R_mm₄, [x^ℓ_mm₄ - 1, y^m_mm₄ - 1, z^p_mm₄ - 1])
    S_mm₄, _ = quo(R_mm₄, I_mm₄)
    A_mm₄ = S_mm₄(1 + x)
    B_mm₄ = S_mm₄(1 + x*y)
    C_mm₄ = S_mm₄(1 + x^2*y^2*z)

    oscar_code_instance_args = Dict(
        :DDimensionalSurface => [(2, 3), (3, 2), (3, 3), (4, 2)],
        :DDimensionalToric => [(2, 3), (3, 2), (3, 3), (4, 2)],
        :GeneralizedToric => [(f₁, g₁, α1₁, α2₁), (f₂, g₂, α1₂, α2₂), (f₃, g₃, α1₃, α2₃), (f₄, g₄, α1₄, α2₄), (f₅, g₅, α1₅, α2₅), (f₆, g₆, α1₆, α2₆)],
        :HomologicalProduct => [([H₁, transpose(H₁)], l₁), ([H₂, transpose(H₂)], l₂), ([H₃, transpose(H₃)],), ([δ₄, δ₄, δ₄],)],
        :DoubleHomologicalProduct => [(δ₁,), (δ₂,)],
        :TrivariateTricycle => [(l₁, m₁, p₁, A₁, B₁, C₁), (l₂, m₂, p₂, A₂, B₂, C₂), (l₃, m₃, p₃, A₃, B₃, C₃), (l₄, m₄, p₄, A₄, B₄, C₄)],
        :BivariateBicycleViaPoly => [(l_bb₁, m_bb₁, A_bb₁, B_bb₁), (l_bb₂, m_bb₂, A_bb₂, B_bb₂), (l_bb₃, m_bb₃, A_bb₃, B_bb₃), (l_bb₄, m_bb₄, A_bb₄, B_bb₄), (l_bb₅, m_bb₅, A_bb₅, B_bb₅)],
        :MultivariateMulticycle =>[([l_mm₁,m_mm₁], [A_mm₁, B_mm₁]), ([l_mm₂,m_mm₂], [A_mm₂, B_mm₂]), ([ℓ_mm₃, m_mm₃, p_mm₃], [A_mm₃, B_mm₃, C_mm₃]), ([ℓ_mm₄, m_mm₄, p_mm₄], [A_mm₄, B_mm₄, C_mm₄])]
    )
    merge!(code_instance_args, oscar_code_instance_args)
  end
  load_oscar_codes()
end

function concretesubtypes(T::DataType)
    concrete = []
    for t in subtypes(T)
        isempty(subtypes(t)) ? push!(concrete, t) : append!(concrete, concretesubtypes(t))
    end
    return concrete
end

function all_testable_code_instances(; maxn=nothing)
    codeinstances = []
    i = 1
    _code_instance_args = copy(code_instance_args)
    for t in concretesubtypes(QuantumClifford.ECC.AbstractQECC)
        for c in pop!(_code_instance_args, nameof(t), [])
            codeinstance = t(c...)
            !isnothing(maxn) && nqubits(codeinstance) > maxn && continue
            push!(codeinstances, codeinstance)
            #@show i, t, code_n(codeinstance), code_k(codeinstance), code_s(codeinstance), code_n(codeinstance)-code_k(codeinstance)
            i += 1
        end
    end
    @test isempty(_code_instance_args) # if this fails, then some code instances were not tested
    return codeinstances
end

"""
The subgroup of single qubit Clifford group that commutes with CPHASE.

Specifically, this means
Uᵢ * CPHASE₁₂ = CPHASE₁₂ * Uᵢ for all U ∈ Z_COMMUTATION_SUBGROUP and i ∈ {1,2}
"""
const Z_COMMUTATION_SUBGROUP = [CliffordOperator(x, 1) for x in [sId1(1), sZ(1), sPhase(1), sInvPhase(1)]]

"""
Stabilizers needed to convert between equivalent states to satisfy the commutation constraint (see [`apply_cphase_isolated`](@ref))

!!! info "Large subgroup"

    Luckily, to satisfy the commutation constraint we don't need the whole stabilizer subgroup which is quite big, but only a selected few.
"""
const PAULI_STABILIZERS = Dict(
    # For CPHASE |++>
    true => [
        (sId1(1), sId1(1)), (sX(1), sZ(1)), (sZ(1), sX(1)), (sY(1), sY(1)),
        (CliffordOperator(sHadamard) * CliffordOperator(sZ), CliffordOperator(sZ) * CliffordOperator(sHadamard)),
        (CliffordOperator(sZ) * CliffordOperator(sHadamard), CliffordOperator(sHadamard) * CliffordOperator(sZ)),
        # Not needed for satisfying the commutation constraints
        # but good to keep it here in case we need these stabilizers for anything else
        # (CliffordOperator(sHadamard), CliffordOperator(sHadamard))
    ],
    # For |++>
    false => [
        (sId1(1), sId1(1)),
        (sX(1), sId1(1)),
        (sId1(1), sX(1)),
        (sX(1), sX(1)),
        # (CliffordOperator(sHadamard), CliffordOperator(sHadamard))
    ]
)

"""
Generate a 2-qubit graph state from the graph (represented by whether vertices are connected) and two VOPs
"""
function gen_graph_state(connected::Bool, U1::SingleQubitOperator, U2::SingleQubitOperator)
    if connected
        g = GraphState(S"XZ ZX")
    else
        g = GraphState(S"XI IX")
    end
    vops(g)[1], vops(g)[2] = U1, U2
    return g
end

"""
Given a 2-qubit graph state (characterized by VOPs U₁, U₂ and k∈{0,1}), find VOPs U₁', U₂', m∈{0,1} such that

CPHASE₁₂ U₁ ⊗ U₂ (CPHASE₁₂)ᵏ |++⟩ = U₁' ⊗ U₂' (CPHASE₁₂)ᵐ |++⟩

The the following constraint is satisfied:
- if U1 ∈ Z_COMMUTATION_SUBGROUP then U1' ∈ Z_COMMUTATION_SUBGROUP. Same for U2, U2'.

This is done by applying stabilizer on the resulting state to change VOPs without changing the underlying quantum state.
See also [`PAULI_STABILIZERS`](@ref)
"""
function apply_cphase_isolated(connected::Bool, U1::SingleQubitOperator, U2::SingleQubitOperator)
    g_init = gen_graph_state(connected, U1, U2)
    stab = Stabilizer(copy(g_init))
    apply!(stab, sCPHASE(1, 2))
    g = GraphState(stab)

    found = false
    for s in PAULI_STABILIZERS[connected]
        satisfied = true
        # Compute the VOPs, using statbilizer, that give us an equivalent state
        U_prime = [vops(g)[i] * (s[i] * one(CliffordOperator, 1)) for i in 1:2]
        for qubit_idx in 1:2
            # Check if constraint is satisfied
            if (CliffordOperator(vops(g_init)[qubit_idx], 1) in Z_COMMUTATION_SUBGROUP) && !(U_prime[qubit_idx] in Z_COMMUTATION_SUBGROUP)
                satisfied = false
                break
            end
        end
        if satisfied
            vops(g)[1], vops(g)[2] = SingleQubitOperator(U_prime[1]), SingleQubitOperator(U_prime[2])
            # check again it's indeed equivalent
            if canonicalize!(stab) == canonicalize!(Stabilizer(g))
                found = true
                break
            else
                throw("Stabilizer doesn't seem to stabilize the state. This is not supposed to happen.")
            end
        end
    end
    if !found
        throw("We cannot find any equivalent state matching the commutation constraint.")
    end
    return g
end

"""
Generate a lookup table for isolated two qubits CPHASE gate operation

Specifically, this creates a mapping

(k, U₁, U₂) -> (m, U₁', U₂')

where k, m ∈{0,1} such that

CPHASE₁₂ U₁ ⊗ U₂ (CPHASE₁₂)ᵏ |++⟩ = U₁' ⊗ U₂' (CPHASE₁₂)ᵐ |++⟩

and we guarantee if U1 ∈ Z_COMMUTATION_SUBGROUP then U1' ∈ Z_COMMUTATION_SUBGROUP. Same for U2, U2'.

See also [`ISOLATED_CPHASE_TABLE`](@ref) and [`gen_isolated_cphase_table`](@ref)
"""
function gen_isolated_cphase_table()
    # Spelling out the full type of GraphState to avoid `convert(T, x)` during `setindex!` which causes memory allocation
    table = Dict{Tuple{Bool,SingleQubitOperator,SingleQubitOperator},GraphState{Graphs.SimpleGraph{Int64},SingleQubitOperator}}()

    # Enumerate all possible states of the form (U1 ⊗ U2) (CPHASE)ᵏ |++>, k∈{0,1}
    # There are 24 * 24 * 2 possibilities in total.
    for (U1, _) in IP_SQRTX_DECOMPOSITION_TABLE
        for (U2, _) in IP_SQRTX_DECOMPOSITION_TABLE
            table[(true, U1, U2)] = apply_cphase_isolated(true, U1, U2)
            table[(false, U1, U2)] = apply_cphase_isolated(false, U1, U2)
        end
    end
    return table
end

"""
A mapping

(k, U₁, U₂) -> (m, U₁', U₂')

where k, m ∈{0,1} such that

CPHASE₁₂ U₁ ⊗ U₂ (CPHASE₁₂)ᵏ |++⟩ = U₁' ⊗ U₂' (CPHASE₁₂)ᵐ |++⟩

and we guarantee if U1 ∈ Z_COMMUTATION_SUBGROUP then U1' ∈ Z_COMMUTATION_SUBGROUP. Same for U2, U2'.

See also [`apply_cphase_isolated`](@ref) and [`gen_isolated_cphase_table`](@ref)
"""
const ISOLATED_CPHASE_TABLE = gen_isolated_cphase_table()

@testitem "ECC - naive syndrome circuits" tags=[:ecc, :ecc_syndrome_measurement_correctness] begin
    using QuantumClifford.ECC
    using QuantumClifford.ECC: AbstractECC

    include("test_ecc_base.jl")

    codes = all_testable_code_instances(; maxn=100)

    function test_naive_syndrome(c::AbstractECC, e::Bool)
        # create a random logical state
        unencoded_qubits = random_stabilizer(code_k(c))
        bufferqubits = one(Stabilizer, code_n(c) - code_k(c))
        logicalqubits = bufferqubits⊗unencoded_qubits
        mctrajectory!(logicalqubits, naive_encoding_circuit(c))
        if e
            #add some noise to logicalqubits
            apply!(logicalqubits, [rand(1:code_n(c))], P"X")
            apply!(logicalqubits, [rand(1:code_n(c))], P"Z")
        end
        # measure using `project!`
        s1 = copy(logicalqubits)
        syndrome1 = [project!(s1, check)[3] for check in parity_checks(c)]
        # measure using `naive_syndrome_circuit`
        naive_circuit, _ = naive_syndrome_circuit(c)
        ancillaryqubits = one(Stabilizer,code_s(c))
        s2 = copy(logicalqubits)
        syndrome2 = Register(s2⊗ancillaryqubits, falses(code_s(c)))
        mctrajectory!(syndrome2, naive_circuit)
        if !e
            @test all(syndrome1 .== 0)
            @test all(bitview(syndrome2) .== 0)
        end
        @test bitview(syndrome2) == syndrome1.÷2
    end

    @testset "naive syndrome circuits - zero syndrome for logical states" begin
        for c in codes, _ in 1:10
            test_naive_syndrome(c, false)
            test_naive_syndrome(c, true)
        end
    end

    ##

    function test_with_pframes(code)
        ecirc = naive_encoding_circuit(code)
        scirc, _ = naive_syndrome_circuit(code)
        nframes = 10
        dataqubits = code_n(code)
        ancqubits = code_s(code)
        regbits = ancqubits
        frames = PauliFrame(nframes, dataqubits+ancqubits, regbits)
        circuit = vcat(ecirc, scirc)
        pftrajectories(frames, circuit)
        @test sum(measurements(frames)) == 0
    end

    @testset "naive syndrome circuits - zero syndrome for logical states" begin
        for c in codes, _ in 1:2
            test_with_pframes(c)
        end
    end
end

using QuantumClifford: getxbit, getzbit, setxbit, setzbit

##############################
# SingleQubitOperator Kernel
##############################

function single_qubit_gpu_kernel(xzs::DeviceMatrix{Tₘₑ},
                                 phases::DeviceVector{Tₚₑ},
                                 op::SingleQubitOperator,
                                 rows::Int,
                                 compute_phases::Bool) where {Tₘₑ <: Unsigned, Tₚₑ <: Unsigned}
    idx = (blockIdx().x - 1) * blockDim().x + threadIdx().x
    if idx > rows
        return nothing
    end
    c = op.q
    r = idx
    sh = QuantumClifford.getshift(Tₘₑ, c)
    xx,zx,xz,zz = Tₘₑ.((op.xx,op.zx,op.xz,op.zz)) .<< sh # maybe putting this in parent function call will improve speed?
    anticom = ~iszero((~zz & xz & ~xx & zx) | ( zz & ~xz & xx & zx) | (zz &  xz & xx & ~zx))

    x = getxbit(xzs, r, c)
    z = getzbit(xzs, r, c)
    setxbit(xzs, r, c, (x&xx)⊻(z&zx))
    setzbit(xzs, r, c, (x&xz)⊻(z&zz))

    if compute_phases
        if op.px && ~iszero(x)
            phases[r] += 0x2
            phases[r] &= 3
        end
        if op.pz && ~iszero(z)
            phases[r] += 0x2
            phases[r] &= 3
        end
        if ~iszero(x&z) && anticom
            phases[r] += 0x2
            phases[r] &= 3
        end
    end
    return nothing
end

##############################
# AbstractSingleQubitOperator Kernel
##############################

function abstract_single_qubit_gpu_kernel(xzs::DeviceMatrix{Tₘₑ},
                                 phases::DeviceVector{Tₚₑ},
                                 gate::QuantumClifford.AbstractSingleQubitOperator,
                                 rows::Int,
                                 compute_phases::Bool) where {Tₘₑ <: Unsigned, Tₚₑ <: Unsigned}
    idx = (blockIdx().x - 1) * blockDim().x + threadIdx().x
    if idx > rows
        return nothing
    end
    c = gate.q
    r = idx

    x::Tₘₑ = getxbit(xzs, r, c)
    z::Tₘₑ = getzbit(xzs, r, c)
    x,z,phase::Bool = QuantumClifford.qubit_kernel(gate,x,z)
    setxbit(xzs, r, c, x)
    setzbit(xzs, r, c, z)
    compute_phases && phase && (phases[r] = (phases[r]+0x2)&3)
    return nothing
end

##############################
# AbstractTwoQubitOperator Kernel
##############################

function two_qubit_gpu_kernel(xzs::DeviceMatrix{Tₘₑ},
                              phases::DeviceVector{Tₚ},
                              gate::QuantumClifford.AbstractTwoQubitOperator,
                              rows::Int,
                              compute_phases::Bool=true) where {Tₘₑ <: Unsigned, Tₚ <: Unsigned}
    idx = (blockIdx().x - 1) * blockDim().x + threadIdx().x
    if idx > rows
        return nothing
    end

    q1 = gate.q1
    q2 = gate.q2
    shift = QuantumClifford.getshift(Tₘₑ, q1) - QuantumClifford.getshift(Tₘₑ, q2)
    r = idx;

    _x1::Tₘₑ = getxbit(xzs, r, q1)
    _z1::Tₘₑ = getzbit(xzs, r, q1)
    _x2::Tₘₑ = getxbit(xzs, r, q2)<<shift
    _z2::Tₘₑ = getzbit(xzs, r, q2)<<shift
    x1::Tₘₑ,z1::Tₘₑ,x2::Tₘₑ,z2::Tₘₑ,phase::Bool = QuantumClifford.qubit_kernel(gate,_x1,_z1,_x2,_z2) # Most `qubit_kernel` functions are defined by a `qubitop2` macro
    setxbit(xzs, r, q1, x1, 0)
    setzbit(xzs, r, q1, z1, 0)
    setxbit(xzs, r, q2, x2, -shift)
    setzbit(xzs, r, q2, z2, -shift)
    if compute_phases && phase
        phases[r] += 0x2
        phases[r] &= 3
    end
    return nothing
end

##############################
# Wrapper _apply! functions
##############################

function _apply!(stab::StabilizerGPU{T},
    op::QuantumClifford.SingleQubitOperator;

    phases::Val{B}=Val(true)) where {B, T <: Unsigned}
    rows = size(stab, 1)
    tab = QuantumClifford.tab(stab)
    (@run_cuda single_qubit_gpu_kernel(tab.xzs, tab.phases, op, rows, B) rows)
    return stab
end

function _apply!(stab::StabilizerGPU{T},
    op::QuantumClifford.AbstractSingleQubitOperator;
    phases::Val{B}=Val(true)) where {B, T <: Unsigned}

    rows = size(stab, 1)
    tab = QuantumClifford.tab(stab)
    (@run_cuda abstract_single_qubit_gpu_kernel(tab.xzs, tab.phases, op, rows, B) rows)
    return stab
end

function _apply!(stab::StabilizerGPU{T},
                 gate::G;
                 phases::Val{B}=Val(true)) where {B, G<:QuantumClifford.AbstractTwoQubitOperator, T <: Unsigned}

    rows = size(stab, 1)
    tab = QuantumClifford.tab(stab)
    (@run_cuda two_qubit_gpu_kernel(tab.xzs, tab.phases, gate, rows, B) rows)
    return stab
end

# TODO split in separate files
@testitem "Noisy" begin
    using Random

    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    import AbstractAlgebra

    @testset "SparseGate" begin
        g = SparseGate(random_clifford(2), randperm(10)[1:2])
        gi = inv(g)
        c = random_stabilizer(10)
        @assert apply!(apply!(copy(c), g), gi) == c
    end

    @testset "Noisy Gates" begin
        g1 = SparseGate(tId1, [1])
        g2 = SparseGate(tCNOT, [2,3])
        g3 = sCNOT(4,5)
        g4 = sHadamard(6)
        n = UnbiasedUncorrelatedNoise(1)
        ng1 = NoisyGate(g1, n)
        ng2 = NoisyGate(g2, n)
        ng3 = NoisyGate(g3, n)
        ng4 = NoisyGate(g4, n)
        ng5 = NoiseOp(n,[7])
        state = ghz(7)
        noisy_circuit = [ng1,ng2,ng3,ng4,ng5]
        res2, _ = mctrajectory!(copy(state), [g1,g2,g3,g4])
        res1s = [mctrajectory!(copy(state), noisy_circuit)[1] for _ in 1:10]
        @test any(res1 -> res1 != res2, res1s) # this weird check is because there is a small chance that res1==res2 because of the randomness of the noise -- this makes the chance much smaller
        resp = petrajectories(copy(state), noisy_circuit)
        @test all(values(resp).==0)
    end

    @testset "Depolarization noise" begin
        p = 0.3
        n = DepolarizationNoise(p)
        single_qubit_state = S"Z"
        single_qubit_branches = QuantumClifford.applynoise_branches(copy(single_qubit_state), n, (1,))
        unbiased_single_qubit_branches = QuantumClifford.applynoise_branches(copy(single_qubit_state), UnbiasedUncorrelatedNoise(3p / 4), (1,))

        @test length(single_qubit_branches) == 4
        @test map(branch -> branch[2:3], single_qubit_branches) == map(branch -> branch[2:3], unbiased_single_qubit_branches)
        @test single_qubit_branches[1][2] ≈ 1 - p + p / 4
        @test single_qubit_branches[1][3] == 0
        @test all(branch[2] ≈ p / 4 for branch in single_qubit_branches[2:end])
        @test all(branch[3] == 1 for branch in single_qubit_branches[2:end])
        @test sum(branch[2] for branch in single_qubit_branches) ≈ 1

        two_qubit_state = ghz(2)
        two_qubit_branches = QuantumClifford.applynoise_branches(copy(two_qubit_state), n, (1, 2), max_order=2)

        @test length(two_qubit_branches) == 16
        @test two_qubit_branches[1][2] ≈ 1 - p + p / 16
        @test two_qubit_branches[1][3] == 0
        @test all(branch[2] ≈ p / 16 for branch in two_qubit_branches[2:end])
        @test count(branch[3] == 1 for branch in two_qubit_branches[2:end]) == 6
        @test count(branch[3] == 2 for branch in two_qubit_branches[2:end]) == 9
        @test sum(branch[2] for branch in two_qubit_branches) ≈ 1

        error_probability = 0.3
        error_parameterized_noise = DepolarizationNoise(; two_qubit_error_probability=error_probability)
        error_parameterized_branches = QuantumClifford.applynoise_branches(copy(two_qubit_state), error_parameterized_noise, (1, 2), max_order=2)

        @test error_parameterized_branches[1][2] ≈ 1 - error_probability
        @test all(branch[2] ≈ error_probability / 15 for branch in error_parameterized_branches[2:end])
        @test sum(branch[2] for branch in error_parameterized_branches) ≈ 1

        state_key(state) = repr(canonicalize!(copy(state)))

        function branch_probabilities(state, noise, indices)
            probabilities = Dict{String, Float64}()
            branches = QuantumClifford.applynoise_branches(
                copy(state), noise, indices, max_order=length(indices))
            for (new_state, probability, _) in branches
                key = state_key(new_state)
                probabilities[key] = get(probabilities, key, 0.0) + probability
            end
            return probabilities
        end

        function sampled_probabilities(state, noise, indices; samples=2000)
            counts = Dict{String, Int}()
            for _ in 1:samples
                key = state_key(applynoise!(copy(state), noise, indices))
                counts[key] = get(counts, key, 0) + 1
            end
            return Dict(key => count / samples for (key, count) in counts)
        end

        function test_applynoise_matches_branches(state, noise, indices)
            Random.seed!(0)
            expected = branch_probabilities(state, noise, indices)
            sampled = sampled_probabilities(state, noise, indices)
            @test keys(sampled) ⊆ keys(expected)
            @test all(
                isapprox(get(sampled, key, 0.0), probability; atol=0.04)
                for (key, probability) in expected
            )
        end

        test_applynoise_matches_branches(single_qubit_state, n, (1,))
        test_applynoise_matches_branches(two_qubit_state, n, (1, 2))
    end

    @testset "Monte Carlo Purification examples" begin
        g1 = SparseGate(tCNOT, [1,3])
        g2 = SparseGate(tCNOT, [2,4])
        m = BellMeasurement([sMX(3),sMX(4)])
        good_bell_state = S"XX
        ZZ"
        canonicalize_rref!(good_bell_state)
        v = VerifyOp(good_bell_state,[1,2])
        n = NoiseOpAll(UnbiasedUncorrelatedNoise(0.03))
        init = Register(MixedDestabilizer(good_bell_state⊗good_bell_state))
        with_purification = mctrajectories(init, [n,g1,g2,m,v], trajectories=500)
        @test with_purification[failure_stat] > 5
        @test with_purification[false_success_stat] > 10
        @test with_purification[true_success_stat] > 420
        without_purification = mctrajectories(init, [n,v], trajectories=500)
        @test get(without_purification,failure_stat,0) == 0
        @test without_purification[false_success_stat] > 10
        @test without_purification[true_success_stat] > 450
        nonoise = mctrajectories(init, [g1,g2,m,v], trajectories=10)
        @test get(nonoise,failure_stat,0) == 0
        @test get(nonoise,false_success_stat,0) == 0
        @test nonoise[true_success_stat] == 10
    end

    @testset "Perturbative expansion Purification examples" begin
        @testset "Comparison to MC" begin
            # `trajectories` controls test stringency vs. flakiness:
            # more trajectories → smaller MC variance → can tighten `threshold`.
            # With failure_stat ≈ 3%, std ≈ sqrt(p(1-p)/n). At n=2000 and
            # threshold=0.4 the allowed deviation is ~3.2σ (flakiness <0.2% per
            # comparison). Reduce `trajectories` or tighten `threshold` for a
            # more stringent but flakier test.
            trajectories = 2000
            threshold = 0.4
            compare(a, b, symbol) = abs(a[symbol]/trajectories - b[symbol]) /
                                    (a[symbol]/trajectories + b[symbol] + 1e-5) < threshold
            g1 = SparseGate(tCNOT, [1,3])
            g2 = SparseGate(tCNOT, [2,4])
            m = BellMeasurement([sMX(3),sMX(4)])
            good_bell_state = S"XX
            ZZ"
            canonicalize_rref!(good_bell_state)
            v = VerifyOp(good_bell_state,[1,2])
            n = NoiseOpAll(UnbiasedUncorrelatedNoise(0.03))
            init = Register(MixedDestabilizer(good_bell_state⊗good_bell_state))
            mc = mctrajectories(init, [n,g1,g2,m,v], trajectories=trajectories)
            pe = petrajectories(init, [n,g1,g2,m,v])
            @test compare(mc,pe,failure_stat)
            @test compare(mc,pe,false_success_stat)
            @test compare(mc,pe,true_success_stat)
            mc = mctrajectories(init, [n,v], trajectories=trajectories)
            pe = petrajectories(init, [n,v])
            @test compare(mc,pe,failure_stat)
            @test compare(mc,pe,false_success_stat)
            @test compare(mc,pe,true_success_stat)
            mc = mctrajectories(init, [g1,g2,m,v], trajectories=trajectories)
            pe = petrajectories(init, [g1,g2,m,v])
            @test compare(mc,pe,failure_stat)
            @test compare(mc,pe,false_success_stat)
            @test compare(mc,pe,true_success_stat)
        end

        @testset "Symbolic" begin
            R, (e,) = AbstractAlgebra.polynomial_ring(AbstractAlgebra.RealField, ["e"])
            unity = R(1);
            good_bell_state = Register(MixedDestabilizer(S"XX ZZ"))
            initial_state = good_bell_state⊗good_bell_state
            g1 = SparseGate(tCNOT, [1,3]) # CNOT between qubit 1 and qubit 3 (both with Alice)
            g2 = SparseGate(tCNOT, [2,4]) # CNOT between qubit 2 and qubit 4 (both with Bob)
            m = BellMeasurement([sMX(3),sMX(4)]) # Bell measurement on qubit 3 and 4
            v = VerifyOp(good_bell_state,[1,2]) # Verify that qubit 1 and 2 indeed form a good Bell pair
            epsilon = e # The X or Y or Z error rate
            n = NoiseOpAll(UnbiasedUncorrelatedNoise(3epsilon))
            circuit = [n,g1,g2,m,v]
            pe_symbolic = petrajectories(initial_state, circuit, branch_weight=unity) # perturbative expansion
            @test pe_symbolic[false_success_stat] == -162.0*e^4 + 162.0*e^3 + -54.0*e^2 + 6.0*e
            @test pe_symbolic[failure_stat]   == -108.0*e^4 + 108.0*e^3 + -36.0*e^2 + 4.0*e
            @test pe_symbolic[true_success_stat]       == 27.0*e^4 + -54.0*e^3 + 36.0*e^2 + -10.0*e + 1.0
        end
    end

    @testset "Measurements" begin
        @testset "BellMeasurements" begin
            stateX = S"X"
            mX = BellMeasurement([sMX(1)])
            vX = VerifyOp(S"X", [1])
            determinate1 = mctrajectories(Register(MixedDestabilizer(stateX)), [mX,vX], trajectories=10)
            @test determinate1[failure_stat] == 0
            @test determinate1[false_success_stat] == 0
            @test determinate1[true_success_stat] == 10
            determinate1_pe = petrajectories(Register(MixedDestabilizer(copy(stateX))), [mX,vX])
            @test determinate1_pe[failure_stat] == 0
            @test determinate1_pe[false_success_stat] == 0
            @test determinate1_pe[true_success_stat] == 1
            stateZ = S"Z"
            random1 = mctrajectories(Register(MixedDestabilizer(stateZ)), [mX,vX], trajectories=500)
            @test random1[failure_stat] > 200
            @test random1[false_success_stat] == 0
            @test random1[true_success_stat] > 200
            random1_pe = petrajectories(Register(MixedDestabilizer(copy(stateZ))), [mX,vX])
            @test random1_pe[failure_stat] > 0.4
            @test random1_pe[false_success_stat] == 0
            @test random1_pe[true_success_stat] > 0.4
            bell_state = S" XX
            ZZ"
            m1 = BellMeasurement([sMX(1),sMX(2)])
            determinate2 = mctrajectories(Register(bell_state), [m1], trajectories=10)
            @test determinate2[failure_stat] == 0
            @test determinate2[false_success_stat] == 0
            @test determinate2[continue_stat] == 10
            determinate2_pe = petrajectories(Register(copy(bell_state)), [m1])
            @test determinate2_pe[failure_stat] == 0
            @test determinate2_pe[false_success_stat] == 0
            m2 = BellMeasurement([sMX(1),sMZ(2)])
            v = VerifyOp(bell_state, [1,2])
            random2 = mctrajectories(Register(bell_state), [m2,v], trajectories=500)
            @test random2[failure_stat]+random2[false_success_stat] == 500
            @test random2[true_success_stat] == 0
            random2_pe = petrajectories(Register(copy(bell_state)), [m2,v])
            @test random2_pe[failure_stat]+random2_pe[false_success_stat] == 1
            @test random2_pe[true_success_stat] == 0
        end

        @testset "PauliMeasurements" begin
            ghzState = S"XXX
            ZZI
            IZZ"
            m1 = PauliMeasurement(P"ZZI", 1)
            v = VerifyOp(ghzState, [1,2,3])
            register1 = Register(ghzState, zeros(Bool, 1))
            determinate1 = mctrajectories(register1, [m1,v], trajectories=10)
            @test determinate1[failure_stat] == 0
            @test determinate1[false_success_stat] == 0
            @test determinate1[true_success_stat] == 10
            determinate1_pe = petrajectories(register1, [m1,v])
            @test determinate1_pe[failure_stat] == 0
            @test determinate1_pe[false_success_stat] == 0
            @test determinate1_pe[true_success_stat] == 1
            m2 = PauliMeasurement(P"ZII", 1)
            register1 = Register(ghzState, zeros(Bool, 1))
            random1 = mctrajectories(register1, [m2,v], trajectories=50)
            @test random1[failure_stat] == 0
            @test random1[false_success_stat] == 50
            @test random1[true_success_stat] == 0
            random1_pe = petrajectories(register1, [m2,v])
            @test random1_pe[failure_stat] == 0
            @test random1_pe[false_success_stat] == 1
            @test random1_pe[true_success_stat] == 0
            m3 = PauliMeasurement(P"XII", 1)
            register1 = Register(ghzState, zeros(Bool, 1))
            random2 = mctrajectories(register1, [m3,v], trajectories=50)
            @test random2[failure_stat] == 0
            @test random2[false_success_stat] == 50
            @test random2[true_success_stat] == 0
            random2_pe = petrajectories(register1, [m3,v])
            @test random2_pe[failure_stat] == 0
            @test random2_pe[false_success_stat] == 1
            @test random2_pe[true_success_stat] == 0
        end

        @testset "Sparse Measurements" begin
            ghzState = S"XXX
            ZZI
            IZZ"
            v = VerifyOp(ghzState, [1,2,3])
            #= TODO reintroduce this type of SparseMeasurement (more than one qubit (so not sMZ), but not all qubits (so not DenseMeasurement))
            m1 = SparseMeasurement(P"ZZ", [1,2], 1)
            register1 = Register(ghzState, zeros(Bool, 1))
            determinate1 = mctrajectories(register1, [m1,v], trajectories=10)
            @test determinate1[failure_stat] == 0
            @test determinate1[false_success_stat] == 0
            @test determinate1[true_success_stat] == 10
            determinate1_pe = petrajectories(register1, [m1,v])
            @test determinate1_pe[failure_stat] == 0
            @test determinate1_pe[false_success_stat] == 0
            @test determinate1_pe[true_success_stat] == 1
            =#
            m2 = sMZ(1, 1)
            register1 = Register(ghzState, zeros(Bool, 1))
            random1 = mctrajectories(register1, [m2,v], trajectories=50)
            @test random1[failure_stat] == 0
            @test random1[false_success_stat] == 50
            @test random1[true_success_stat] == 0
            random1_pe = petrajectories(register1, [m2,v])
            @test random1_pe[failure_stat] == 0
            @test random1_pe[false_success_stat] == 1
            @test random1_pe[true_success_stat] == 0
            m3 = sMX(1, 1)
            register1 = Register(ghzState, zeros(Bool, 1))
            random2 = mctrajectories(register1, [m3,v], trajectories=50)
            @test random2[failure_stat] == 0
            @test random2[false_success_stat] == 50
            @test random2[true_success_stat] == 0
            random2_pe = petrajectories(register1, [m3,v])
            @test random2_pe[failure_stat] == 0
            @test random2_pe[false_success_stat] == 1
            @test random2_pe[true_success_stat] == 0
        end

        @testset "Symbolic Reset Measurements" begin
            using QuantumClifford:tensor
            #test for checking reset capabilities
            state1 = S"-Z"
            register1 = Register(state1, [0])
            reset_measure_z = sMRZ(1,1)
            verify_z_neg = VerifyOp(state1, [1])
            pet1 = petrajectories(register1, [reset_measure_z,verify_z_neg])
            @test pet1[false_success_stat] == 1
            @test pet1[true_success_stat] == 0
            @test pet1[failure_stat] == 0

            state2 = S"-X"
            register2 = Register(state2, [0])
            reset_measure_x = sMRX(1,1)
            verify_x_neg = VerifyOp(state2, [1])
            pet2 = petrajectories(register2, [reset_measure_x,verify_x_neg])
            @test pet2[false_success_stat] == 1
            @test pet2[true_success_stat] == 0
            @test pet2[failure_stat] == 0

            state3 = S"Z"
            register3 = Register(state3, [0])
            reset_measure_z = sMRZ(1,1)
            verify_z = VerifyOp(state3, [1])
            pet3 = petrajectories(register3, [reset_measure_z,verify_z])
            @test pet3[false_success_stat] == 0
            @test pet3[true_success_stat] == 1
            @test pet3[failure_stat] == 0

            state4 = S"X"
            register4 = Register(state4, [0])
            reset_measure_x = sMRX(1,1)
            verify_x = VerifyOp(state4, [1])
            pet4 = petrajectories(register4, [reset_measure_x,verify_x])
            @test pet4[false_success_stat] == 0
            @test pet4[true_success_stat] == 1
            @test pet4[failure_stat] == 0

            state_y = S"Y"
            register_y = Register(state_y, [0])
            reset_measure_y = sMRY(1,1)
            verify_y = VerifyOp(state_y, [1])
            pet_y = petrajectories(register_y, [reset_measure_y,verify_y])
            @test pet_y[false_success_stat] == 0
            @test pet_y[true_success_stat] == 1
            @test pet_y[failure_stat] == 0

            #checks probabilistic case to see if the phase of measurement anticommuting stabilizer is the same in both branches
            ghz_state = S"XXX ZZI IZZ"
            reg = Register(ghz_state, [0])
            branches = applybranches(reg, sMRZ(1,1))
            stab1 = stabilizerview(branches[2][1].stab)
            stab2 = stabilizerview(branches[1][1].stab)
            @test stab1 == S"ZII -ZZI -ZIZ"
            @test stab2 == S"ZII +ZZI +ZIZ"


            #checking if the classical bits record measurements correctly
            reg = Register(one(MixedDestabilizer,1), 1)
            apply!(reg, sX(1))
            branches1 = applybranches(reg, sMRZ(1,1))
            reg_after, _, _, _ = first(branches1)
            @test bitview(reg_after)[1] == true
            # The qubit should have been reset to 0
            branches2 = applybranches(reg_after, sMRZ(1,1))
            r2, _, _, _ = first(branches2)
            @test bitview(r2)[1] == false

            #if the second argument(the bit where the measurement is recorded) isn't provided
            state = S"-Z"
            register5 = Register(state, 1)
            branches = applybranches(register5, sMRZ(1)) #sMRZ(1) is internally sMRZ(1,0)
            @test branches[1][1].bits[1] == false # since there's no bit provided for sMRZ, the bit should remain 0 even though the measurement would result in a 1. 



        end

        @testset "Conforming to the project! interface" begin
            state = Register(MixedDestabilizer(S"ZZ"), zeros(Bool, 1))
            meas = PauliMeasurement(P"ZI", 1)
            state, flag = applywstatus!(state, meas)
            @test rank(state.stab) == 2
            tab(state.stab).phases .= 0
            @test stabilizerview(state.stab) == S"ZZ
            ZI"
        end
    end

    @testset "Classical Bits" begin
        @testset "IndexedDecisionGate" begin
            X_error = CliffordOperator([P"X", P"-Z"])
            # testing single digit return value from decision function
            for s in [S"Z", S"-Z", S"X", S"-X"]
                r = Register(s, [false])
                applywstatus!(r, PauliMeasurement(P"Z", 1))
                correctiveGate = SparseGate(X_error, [1])
                decisionFunction = syndrome -> syndrome[1] ? 1 : nothing
                applywstatus!(r, IndexedDecisionGate([correctiveGate], decisionFunction))
                @test stabilizerview(r) == S"Z"
            end

            # testing an array return from decision function
            expectedFinalState = S"ZI
            IZ"
            s = QuantumClifford.bell()
            r = Register(s, [false])
            applywstatus!(r, PauliMeasurement(P"ZI", 1))
            correctiveGates = [SparseGate(X_error, [1]), SparseGate(X_error, [2])]
            decisionFunction = syndrome -> syndrome[1] ? [1,2] : nothing
            applywstatus!(r, IndexedDecisionGate(correctiveGates, decisionFunction))
            canonicalize!(quantumstate(r))
            @test stabilizerview(r) == expectedFinalState

            s = QuantumClifford.bell((false, true)) # |01>+|10>
            r = Register(s, [false])
            applywstatus!(r, sMZ(1, 1))
            # we use the same corrective gates, with a different decision function
            decisionFunction = syndrome -> syndrome[1] ? [1] : 2 # both [1] and 1 should work
            applywstatus!(r, IndexedDecisionGate(correctiveGates, decisionFunction))
            canonicalize!(quantumstate(r))
            @test stabilizerview(r) == expectedFinalState
        end

        @testset "ConditionalGate" begin
            id_op = CliffordOperator([P"X", P"Z"])
            X_error = CliffordOperator([P"X", P"-Z"])

            for s in [S"Z", S"-Z", S"X", S"-X"]
                r = Register(s, [false])
                applywstatus!(r, PauliMeasurement(P"Z", 1))
                correctiveGate = SparseGate(X_error, [1])
                identityGate = SparseGate(id_op, [1])
                applywstatus!(r, ConditionalGate(correctiveGate, identityGate, 1))
                @test stabilizerview(r) == S"Z"
            end

            expectedFinalState = S"ZI
            IZ"
            s = QuantumClifford.bell((false, true))
            r = Register(s, [false])
            applywstatus!(r, PauliMeasurement(P"ZI", 1))
            correctiveGate1 = SparseGate(X_error, [1])
            correctiveGate2 = SparseGate(X_error, [2])
            applywstatus!(r, ConditionalGate(correctiveGate1, correctiveGate2, 1))
            canonicalize!(quantumstate(r))
            @test stabilizerview(r) == expectedFinalState
        end

        @testset "DecoderCorrectionGate" begin
            using QuantumClifford.ECC: Steane7, parity_checks, naive_encoding_circuit, naive_syndrome_circuit, DecoderCorrectionGate, TableDecoder

            code = parity_checks(Steane7())
            decoder = TableDecoder(code)
            ecirc = naive_encoding_circuit(code)
            scirc,_,_ = naive_syndrome_circuit(code)
            state = one(MixedDestabilizer,7)
            mctrajectory!(state, ecirc)
            verify = VerifyOp(state, 1:7)

            reg = Register(one(MixedDestabilizer,13),6)
            mctrajectory!(reg, ecirc)
            apply!(reg, sX(2))
            mctrajectory!(reg, scirc)
            correction_gate = DecoderCorrectionGate(decoder, 1:7, 1:6)
            apply!(reg, correction_gate)
            _, status = applywstatus!(reg, verify) 
            @test status == true_success_stat

            new_reg = Register(one(MixedDestabilizer,13),6)
            mctrajectory!(new_reg, ecirc)
            apply!(new_reg, sZ(5))
            mctrajectory!(new_reg, scirc)
            correction = DecoderCorrectionGate(decoder, 1:7, 1:6)
            branches = applybranches(new_reg,correction )
            _, status = applywstatus!(branches[1][1], verify)
            @test status == true_success_stat
        end
    end

    @testset "VerifyOp" begin
        using QuantumClifford.ECC: Steane7, parity_checks, naive_encoding_circuit
        using QuantumClifford: tensor
        @testset "Stabilizer passed as good_state is not a logical state" begin
            good_state = parity_checks(Steane7()) #passing in a code instead of a state within codespace
            @test_throws ArgumentError VerifyOp(good_state, 1:7) #should throw an error since good_state isn't a logical state i.e. has only 6 stabilizer generators
            
        end
    
        @testset "Accepts pure good_state argument" begin
            good_state = S"ZZI
                            IZZ 
                            XXX" # passing in GHZ state as good_state argument since it exists within the repetition code's codespace
            verify = VerifyOp(good_state, 1:3)
            reg = Register(one(MixedDestabilizer,3),2) 
            encoding = [sHadamard(1)  ,  sCNOT(1,2)   ,sCNOT(1,3) ] # encoding the register's state into a logical state within the repetition code's codespace
            for i in encoding
                apply!(reg, i)
            end
    
            _, status = applywstatus!(reg, verify)
            @test status == true_success_stat
        end

        @testset "handles sub-tableau with ancillas correctly " begin
            s = S"+ XXX__
            + ZZ___
            + Z_Z__
            - ZZ_Z_
            - _ZZ_Z"
            good_state = S"XXX ZZI IZZ"
            verify = VerifyOp(good_state, 1:3)
            _, status = applywstatus!(s, verify) 
            @test status == true_success_stat #this test would have given a false_success_stat in the previous implementation of applywstatus! for VerifyOp

        end
    
      
    end
    @testset "Petrajectories" begin
        reg = Register(one(MixedDestabilizer,3),2) 
        op = sCNOT(1,4)
        circuit = [op]
        @test_throws ArgumentError petrajectories(reg, circuit) # throws an error because sCNOT attempts to access a qubit that doesn't exist
    end
end

function permutesystems(c::CliffordOperator,p) # TODO this is a slow stupid implementation
    CliffordOperator(Tableau([tab(c)[i][p] for i in 1:2*nqubits(c)][vcat(p,p.+nqubits(c))]))
end

@deprecate permute(c::CliffordOperator,p) permutesystems(c,p)

function permutesystems!(s::Tableau, perm::AbstractVector)
    for r in 1:size(s,1)
        s[r] = s[r][perm] # TODO make a local temporary buffer row instead of constantly allocating new rows
    end
    s
end

function permutesystems!(s::AbstractStabilizer, perm::AbstractVector)
    permutesystems!(tab(s), perm)
    s
end

import Base: permute!
@deprecate permute!(s::Tableau, perm::AbstractVector) permutesystems!(s, perm)
@deprecate permute!(s::AbstractStabilizer, perm::AbstractVector) permutesystems!(s, perm)

# TODO upstream to QuantumInterface for (state::Any, perm)
permutesystems(s::AbstractStabilizer, perm) = permutesystems!(copy(s), perm)

"""
$TYPEDSIGNATURES

Inverse of a `CliffordOperator`

```jldoctest
julia> inv(CliffordOperator(sCNOT))
X₁ ⟼ + XX
X₂ ⟼ + _X
Z₁ ⟼ + Z_
Z₂ ⟼ + ZZ

julia> inv(CliffordOperator(sCNOT(2, 1), 2))
X₁ ⟼ + X_
X₂ ⟼ + XX
Z₁ ⟼ + ZZ
Z₂ ⟼ + _Z

julia> inv(CliffordOperator(tHadamard))
X₁ ⟼ + Z
Z₁ ⟼ + X
```
"""
function LinearAlgebra.inv(c::CliffordOperator; phases=true)
    ci = zero(c)
    n = nqubits(c)
    # TODO this transpose can be much faster with proper SIMDing
    for i in 1:n
        for j in 1:n
            ci.tab[i,j] = c.tab[n+j,i][2], c.tab[j,i][2]
            ci.tab[n+i,j] = c.tab[n+j,i][1], c.tab[j,i][1]
        end
    end
    if phases
        ci*c*ci # TODO perform this inplace as in Stim https://github.com/quantumlib/Stim/blob/e51ea66d213b25920e72c08e53266ec56fd14db4/src/stim/stabilizers/tableau.cc#L383
    else
        ci
    end
end

"""The inner product of two Stabilizers.

Based on [garcia2012efficient](@cite).

```jldoctest
julia> using LinearAlgebra

julia> dot(S"Z", S"Z")
1.0

julia> dot(S"Z", S"Y")
0.7071067811865476
```

See also: [`logdot`](@ref)"""
function LinearAlgebra.dot(s1::AbstractStabilizer, s2::AbstractStabilizer)
    ld = logdot(s1,s2)
    if isnothing(ld)
        return 0.0
    else
        return 2.0^(-ld/2)
    end
end

"""Logarithm of the inner product between to Stabilizer states.

If the result is `nothing`, the dot inner product is zero.
Otherwise the inner product is `2^(-logdot/2)`.

The actual inner product can be computed with `LinearAlgebra.dot`.

Based on [garcia2012efficient](@cite)."""
function logdot(s1::AbstractStabilizer, s2::AbstractStabilizer) # TODO verify rank # TODO this is currently very inefficient as we discard the destabilizers and then recreate them
    logdot(stabilizerview(s1),stabilizerview(s2))
end

function logdot(s1::Stabilizer, s2::Stabilizer)
    if nqubits(s1)!=length(s1) || nqubits(s2)!=length(s2) # TODO implement this
        throw(DomainError("Only pure (not mixed) states are supported when calculating inner product."))
    end
    if nqubits(s1)!=nqubits(s2)
        throw(DimensionMismatch("Inner product can be calculated only between states with the same number of qubits."))
    end
    c1_inv = inv(CliffordOperator(tab(MixedDestabilizer(copy(s1)))))
    s2_prime = canonicalize!(c1_inv*s2)
    canonicalize!(s2_prime)
    k = 0
    for row in eachindex(s2_prime)
        if any(i->s2_prime[row,i][1], 1:nqubits(s2_prime)) # X or Y
            k += 1
        else
            if !iszero(tab(s2_prime).phases[row])
                return nothing
            end
        end
    end
    return k
end

"""
    fidelity(state1::MixedDestabilizer, state2::MixedDestabilizer)

Compute the fidelity between stabilizer states, following the
`QuantumInterface.fidelity` convention,

```math
F(\\rho, \\sigma) =
\\operatorname{Tr}\\sqrt{\\sqrt{\\rho}\\,\\sigma\\sqrt{\\rho}}.
```

For two pure states this returns their overlap by delegating to
`LinearAlgebra.dot`. If exactly one state is pure, the result is the square root
of that pure state's projector expectation in the mixed state. The order of
the arguments does not matter. Inputs have the same rank and representation
requirements as [`expect`](@ref).

General mixed/mixed fidelity is not currently implemented and raises a
`DomainError`. In particular, it is not equal in general to the square root of
the Hilbert--Schmidt expectation returned by [`expect`](@ref).

# Examples

```jldoctest
julia> fidelity(MixedDestabilizer(S"Z"), maximally_mixed(1))
0.7071067811865476

julia> fidelity(MixedDestabilizer(S"Z"), MixedDestabilizer(S"-Z"))
0.0
```

See also: [`expect`](@ref), [`logdot`](@ref).
"""
function fidelity(
    state1::MixedDestabilizer,
    state2::MixedDestabilizer,
)
    state1_qubits = nqubits(state1)
    state2_qubits = nqubits(state2)
    state1_qubits == state2_qubits || throw(DimensionMismatch(
        lazy"Expected equal qubit counts; got $state1_qubits and $state2_qubits.",
    ))
    state1_rank = rank(state1)
    state2_rank = rank(state2)
    state1_is_pure = state1_rank == state1_qubits
    state2_is_pure = state2_rank == state2_qubits

    if state1_is_pure && state2_is_pure
        return dot(state1, state2)
    elseif !state1_is_pure && !state2_is_pure
        throw(DomainError(
            (state1_rank, state2_rank),
            lazy"Fidelity between two rank-deficient stabilizer states is not supported.",
        ))
    end

    pure_state, mixed_state = state1_is_pure ?
        (state1, state2) : (state2, state1)
    exponent = _stabilizer_expect_log2(nothing, pure_state, mixed_state)
    isnothing(exponent) ? 0.0 : exp2(exponent / 2)
end

LinearAlgebra.rank(s::Stabilizer)   = throw(BadDataStructure("Using a `Stabilizer` type does not permit automatic tracking of the rank. Use `length`, `trusted_rank`, the `MixedDestabilizer` type, or track the rank manually.",
                                            :rank, :Stabilizer))
LinearAlgebra.rank(s::Destabilizer) = throw(BadDataStructure("Using a `Destabilizer` type does not permit automatic tracking of the rank. Use `length`, `trusted_rank`, the `MixedDestabilizer` type, or track the rank manually.",
                                            :rank, :Destabilizer))
LinearAlgebra.rank(s::MixedStabilizer) = s.rank
LinearAlgebra.rank(s::MixedDestabilizer) = s.rank

"""A "trusted" `rank` which returns `rank(state)` for `Mixed[De]Stabilizer` and `length(state)` for `[De]Stabilizer`."""
function trusted_rank end
trusted_rank(s::Stabilizer) = length(s)
trusted_rank(s::Destabilizer) = length(s)
trusted_rank(s::MixedStabilizer) = LinearAlgebra.rank(s)
trusted_rank(s::MixedDestabilizer) = LinearAlgebra.rank(s)

"""Tensor product between operators or tableaux.

Tensor product between CiffordOperators:

```jldoctest
julia> tensor(CliffordOperator(sCNOT), CliffordOperator(sCNOT))
X₁ ⟼ + XX__
X₂ ⟼ + _X__
X₃ ⟼ + __XX
X₄ ⟼ + ___X
Z₁ ⟼ + Z___
Z₂ ⟼ + ZZ__
Z₃ ⟼ + __Z_
Z₄ ⟼ + __ZZ
```

Tensor product between PauliOperators:

```jldoctest
julia> tensor(P"-IXYZ", P"iIXYZ")
-i_XYZ_XYZ
```

Tensor product between Tableaux:

```jldoctest
julia> s = S"-XX
             +ZZ";

julia> tensor(s, s, s)
- XX____
+ ZZ____
- __XX__
+ __ZZ__
- ____XX
+ ____ZZ

julia> s = S"+XZI
             -IZI";

julia> tensor(s, s)
+ XZ____
- _Z____
+ ___XZ_
- ____Z_
```

See also [`tensor_pow`](@ref)."""
function tensor end

tensor(p::PauliOperator, ps::PauliOperator...) = foldl(⊗, ps; init=p)

function tensor(ops::AbstractStabilizer...) # TODO optimize by pre-allocating one large tableau instead of the current quadratic fold
    ct = promote_type(map(typeof, ops)...)
    conv_ops = map(x -> convert(ct, x), ops)
    return foldl(⊗, conv_ops)
end

"""Repeated tensor product of an operators or a tableau.

For `CliffordOperator`:

```jldoctest
julia> tensor_pow(CliffordOperator(sHadamard), 3)
X₁ ⟼ + Z__
X₂ ⟼ + _Z_
X₃ ⟼ + __Z
Z₁ ⟼ + X__
Z₂ ⟼ + _X_
Z₃ ⟼ + __X
```

For `PauliOperator`:

```jldoctest
julia> tensor_pow(P"IXYZ", 2)
+ _XYZ_XYZ
```

For `Tableaux`:

```jldoctest
julia> tensor_pow(S"Z", 4)
+ Z___
+ _Z__
+ __Z_
+ ___Z

julia> s = S"+XZI
             +IZI";

julia> tensor_pow(s, 3)
+ XZ_______
+ _Z_______
+ ___XZ____
+ ____Z____
+ ______XZ_
+ _______Z_
```

See also [`tensor`](@ref).
"""
function tensor_pow(op::Union{<:AbstractStabilizer,<:AbstractCliffordOperator},power)
    if power==1
        return op
    else
        return tensor((op for i in 1:power)...)
    end
end

function tensor(ops::Stabilizer...)
    length(ops)==1 && return ops[1]
    ntot = sum(nqubits, ops) # TODO why is this allocating (at least in 1.11)
    rtot = sum(length, ops)  # TODO why is this allocating (at least in 1.11)
    tab = zero(Stabilizer, rtot, ntot)
    last_row = 0
    last_col = 0
    for op in ops
        _, last_row, last_col = puttableau!(tab, op, last_row, last_col)
    end
    tab
end

function tensor(ops::MixedDestabilizer...)
    length(ops)==1 && return ops[1]
    ntot = sum(nqubits, ops)
    rtot = sum(LinearAlgebra.rank, ops)
    tab = zero(Tableau, 2*ntot, ntot)
    last_svrow = ntot
    last_dvrow = 0
    last_lxrow = rtot
    last_lzrow = ntot+rtot
    last_col = 0
    for op in ops
        _, last_svrow, _        = puttableau!(tab,   stabilizerview(op), last_svrow, last_col)
        _, last_dvrow, _        = puttableau!(tab, destabilizerview(op), last_dvrow, last_col)
        _, last_lxrow, _        = puttableau!(tab,     logicalxview(op), last_lxrow, last_col)
        _, last_lzrow, last_col = puttableau!(tab,     logicalzview(op), last_lzrow, last_col)
    end
    MixedDestabilizer(tab, rtot)
end

tensor(ops::AbstractCliffordOperator...) = ⊗(CliffordOperator.(ops)...)

function tensor(ops::CliffordOperator...) # TODO implement \otimes for Destabilizer and use it here
    length(ops)==1 && return ops[1]
    ntot = sum(nqubits, ops)
    tab = zero(Tableau, 2*ntot, ntot)
    last_zrow = ntot
    last_xrow = 0
    for op in ops
        t = QuantumClifford.tab(op)
        _, last_zrow, _ = puttableau!(tab, (@view t[end÷2+1:end]), last_zrow, last_xrow)
        _, last_xrow, _ = puttableau!(tab, (@view t[1:end÷2]), last_xrow, last_xrow)
    end
    CliffordOperator(tab)
end

@testitem "Quantum optics" begin
    using QuantumOpticsBase
    using QuantumClifford: @S_str, random_stabilizer
    using LinearAlgebra
    #using QuantumCliffordQOpticsExt: _l0, _l1, _s₊, _s₋, _i₊, _i₋
    const qo = Base.get_extension(QuantumClifford, :QuantumCliffordQOpticsExt)
    const _l0 = qo._l0
    const _l1 = qo._l1
    const _s₊ = qo._s₊
    const _s₋ = qo._s₋
    const _i₊ = qo._i₊
    const _i₋ = qo._i₋

    @testset "conversion from Stabilizer to Ket" begin
        for n in 1:5
            stabs = [random_stabilizer(1) for _ in 1:n]
            stab = tensor(stabs...)
            translate = Dict(S"X"=>_s₊,S"-X"=>_s₋,S"Z"=>_l0,S"-Z"=>_l1,S"Y"=>_i₊,S"-Y"=>_i₋)
            kets = [translate[s] for s in stabs]
            ket = tensor(kets...)
            @test ket.data ≈ Ket(stab).data

            rstab = random_stabilizer(n)
            lstab = random_stabilizer(n)
            lket = Ket(rstab)
            rket = Ket(lstab)
            dotket = abs(lket'*rket)
            dotstab = abs(dot(lstab,rstab))
            @test (dotket<=1e-10 && dotstab==0) || dotket≈dotstab
        end
    end

    @testset "conversion from CliffordOperator to Operator" begin
        for n in 1:3
            for _c in 1:5
                cliff = random_clifford(n)
                U = Operator(cliff)
                for _c in 1:5
                    stab = random_stabilizer(n)
                    ψ₁ = Ket(stab)
                    ψ₂ = Ket(apply!(stab,cliff))
                    # test they are equal up to a phase
                    @test all(x->isnan(x)||abs(x)≈1 , (U*ψ₁).data ./ ψ₂.data)
                    @test abs(det(U.data))≈1
                end
            end
        end
    end

    @testset "conversion from GeneralizedStabilizer to Operator" begin
        for n in 1:5
            stab = random_stabilizer(n)
            @test dm(Ket(stab)) == Operator(GeneralizedStabilizer(stab))
        end
    end

    @testset "conversion from PauliOperator to Operator" begin
        for n in 1:5
            for _ in 1:10
                p = random_pauli(n)
                q = random_pauli(n)
                p̃ = Operator(p)
                q̃ = Operator(q)
                @test Operator(p*q) == p̃*q̃
                @test Operator(q*p) == q̃*p̃
            end
        end
    end


    tgate = sparse(identityoperator(SpinBasis(1//2)))
    tgate.data[2,2] = exp(im*pi/4)

    @testset "GeneralizedStabilizer/PauliChannel to QuantumOptics - explicit single-qubit Pauli channels" begin
        # manual checks
        @test Operator(pcT)≈tgate

        # single qubit checks
        for single_qubit_explicit_channel in [pcT]
            qo_gate = Operator(single_qubit_explicit_channel)
            for single_qubit_tableau in [S"X", S"Y", S"Z", S"-X", S"-Y", S"-Z"]
                sm = GeneralizedStabilizer(single_qubit_tableau)
                ψ = Ket(single_qubit_tableau)
                for rep in 1:8
                    apply!(sm, single_qubit_explicit_channel)
                    ψ = qo_gate*ψ
                    @test expect(Operator(sm), ψ) ≈ 1
                end
            end
        end

        # embedded checks
        for single_qubit_explicit_channel in [pcT]
            for n in 2:5
                i = rand(1:n)
                channel = embed(n,i,single_qubit_explicit_channel)
                qo_gate1 = Operator(single_qubit_explicit_channel)
                qo_gate = embed(basis(qo_gate1)^n, i, qo_gate1)
                stab = random_stabilizer(n)
                sm = GeneralizedStabilizer(stab)
                ψ = Ket(stab)
                for rep in 1:8
                    apply!(sm, channel)
                    ψ = qo_gate*ψ
                    @test expect(Operator(sm), ψ) ≈ 1
                end
            end
        end
    end
end

@testitem "OpenCL" tags = [:opencl] begin

    include("implementation/test_platform.jl")

    import pocl_jll
    using OpenCL: CLArray, cl.devices, cl.platforms, cl.finish, cl.queue
    const AT = CLArray

    const can_run = any(
        length(devices(platform)) > 0 for platform in platforms()
            )

    @testset "Device availability" begin
        @test can_run
    end

    if can_run
        # TODO: Revisit this once the POCL code generation issues are resolved.
        block_sizes = fill(256, round_count)
        synchronize() = finish(queue())
        test_platform(AT, synchronize)
    end

end

@testitem "Classical" begin
    using Random
    using QuantumClifford: stab_looks_good, destab_looks_good, mixed_stab_looks_good, mixed_destab_looks_good

    n=5
    stab = random_stabilizer(n)
    mdstab = MixedDestabilizer(stab)
    _ = Register(stab)
    reg = Register(stab, [0,0,0,0])
    regmd = Register(mdstab, [0,0,0,0])
    @test reg==regmd
    @test stabilizerview(reg) == stabilizerview(mdstab)
    @test destabilizerview(reg) == destabilizerview(mdstab)
    @test logicalxview(reg) == logicalxview(mdstab)
    @test logicalzview(reg) == logicalzview(mdstab)
    @test bitview(reg) == bitview(regmd)
    @test quantumstate(reg) == mdstab
    @test (reg ⊗ reg).stab == (reg ⊗ stab).stab
    @test (regmd ⊗ regmd).stab == (regmd ⊗ mdstab).stab
    for state in [mdstab,reg,regmd]
        for op in [sMX(1,1),sMY(2,2),sMZ(3,3),PauliMeasurement(P"XYZZZ",4),sCNOT(1,2),sCPHASE(2,3),sCNOT(3,4),NoiseOpAll(UnbiasedUncorrelatedNoise(0.1))]
            apply!(state,op)
        end
        for (i,proj) in enumerate([projectXrand!, projectYrand!, projectZrand!])
            proj(state, i)
        end
    end
    @test tab(canonicalize!(stabilizerview(reg))).xzs == tab(canonicalize!(stabilizerview(mdstab))).xzs
end

@testitem "Graph states" begin
    using Graphs
    using Random
    import QuantumClifford.GraphSim: GraphState

    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    @testset "Graph State conversion (New API)" begin
        for n in test_sizes
            s = random_stabilizer(n)
            @test canonicalize!(s) == canonicalize!(Stabilizer(GraphState(s)))
        end
    end

    @testset "Graph State conversion (Old API)" begin
        for n in test_sizes
            s = random_stabilizer(n)
            g, h_idx, ip_idx, z_idx = graphstate(s)
            gates = graph_gatesequence(h_idx, ip_idx, z_idx)
            gate = graph_gate(h_idx, ip_idx, z_idx, nqubits(s))
            c0 = one(CliffordOperator,nqubits(s))
            for gate in vcat(gates...) apply!(Stabilizer(tab(c0)), gate) end # TODO this wrapping in a Stabilizer hack is ugly; clean it up
            @test c0==gate
            s1 = copy(s)
            for gate in vcat(gates...) apply!(s1, gate) end
            @test canonicalize!(apply!(copy(s),c0)) == canonicalize!(s1) == canonicalize!(Stabilizer(g))
        end
        # one more check, done manually, to ensure we are testing for cases
        # where canonicalize_gott! is causing index permutation
        # (a few of the random cases already cover that)
        s = S"- _XZ
            + _ZX
            + ZXZ"
        g, h_idx, ip_idx, z_idx = graphstate(s)
        gates = graph_gatesequence(h_idx, ip_idx, z_idx)
        gate = graph_gate(h_idx, ip_idx, z_idx, nqubits(s))
        c0 = one(CliffordOperator,nqubits(s))
        for gate in vcat(gates...) apply!(Stabilizer(tab(c0)), gate) end # TODO this wrapping in a Stabilizer hack is ugly; clean it up
        @test c0==gate
        s1 = copy(s)
        for gate in vcat(gates...) apply!(s1, gate) end
        @test canonicalize!(apply!(copy(s),c0)) == canonicalize!(s1) == canonicalize!(Stabilizer(g))
    end
end

"""
$TYPEDEF

Classical codes lifted over a group algebra, used for lifted product code construction ([panteleev2021degenerate](@cite), [panteleev2022asymptotically](@cite))

The parity-check matrix is constructed by applying `repr` to each element of `A`,
which is mathematically a linear map from a group algebra element to a binary matrix.
The size of the parity check matrix will enlarged with each element of `A` being inflated into a matrix.
The procedure is called a lift [panteleev2022asymptotically](@cite).

## Constructors

A lifted code can be constructed via the following approaches:

1. A matrix of group algebra elements.

2. A matrix of group elements, where a group element will be considered as a group algebra element by assigning a unit coefficient.

3. A matrix of integers, where each integer represent the shift of a cyclic permutation. The order of the cyclic permutation should be specified.

The default `GA` is the group algebra of `A[1, 1]`, the default representation `repr` is the permutation representation.

Below is a list of all constructors:

$METHODLIST

## The representation function `repr`

We use the default representation function `Hecke.representation_matrix` to convert a `GF(2)`-group algebra element to a binary matrix.
The default representation, provided by `Hecke`, is the permutation representation.

We also accept a custom representation function (the `repr` field of the constructor).
Whatever the representation, the matrix elements need to be convertible to Integers (e.g. permit `lift(ZZ, ...)`).
Such a customization would be useful to reduce the number of bits required by the code construction.

For example, if we use a D4 group for lifting, our default representation will be `8×8` permutation matrices,
where 8 is the group's order.
However, we can find a `4×4` matrix representation for the group,
e.g. by using the typical [`2×2` representation](https://en.wikipedia.org/wiki/Dihedral_group)
and converting it into binary representation by replacing "1" with the Pauli I, and "-1" with the Pauli X matrix.

See also: [`QuantumClifford.ECC.LPCode`](@ref).

All fields:

$TYPEDFIELDS
"""
struct LiftedCode <: AbstractCECC
    """the base matrix of the code, whose elements are in a group algebra."""
    A::GroupAlgebraElemMatrix
    """the group algebra for which elements in `A` are from."""
    GA::GroupAlgebra
    """
    a function that converts a group algebra element to a binary matrix;
    default to be the permutation representation for GF(2)-algebra."""
    repr::Function

    function LiftedCode(A::GroupAlgebraElemMatrix; GA::GroupAlgebra=parent(A[1, 1]), repr::Function)
        all(elem.parent == GA for elem in A) || error("The base ring of all elements in the code must be the same as the group algebra")
        new(A, GA, repr)
    end
end

#"""
#`LiftedCode` constructor using the default `GF(2)` representation (coefficients converted to a permutation matrix by `representation_matrix` provided by Hecke).
#"""
# TODO doctest example and document the other constructors below
function LiftedCode(A::Matrix{GroupAlgebraElem{FqFieldElem, <: GroupAlgebra}}; GA::GroupAlgebra=parent(A[1,1]))
    !(characteristic(base_ring(A[1, 1])) == 2) && error("The default permutation representation applies only to GF(2) group algebra; otherwise, a custom representation function should be provided")
    LiftedCode(A; GA=GA, repr=representation_matrix)
end

# TODO document and doctest example
function LiftedCode(group_elem_array::Matrix{<: GroupOrAdditiveGroupElem}; GA::GroupAlgebra=group_algebra(GF(2), parent(group_elem_array[1,1])), repr::Union{Function, Nothing}=nothing)
    A = zeros(GA, size(group_elem_array)...)
    for i in axes(group_elem_array, 1), j in axes(group_elem_array, 2)
        A[i, j] = GA[A[i, j]]
    end
    if repr === nothing
        return LiftedCode(A; GA=GA, repr=representation_matrix)
    else
        return LiftedCode(A; GA=GA, repr=repr)
    end
end

# TODO document and doctest example
function LiftedCode(shift_array::Matrix{Int}, l::Int; GA::GroupAlgebra=group_algebra(GF(2), abelian_group(l)))
    A = zeros(GA, size(shift_array)...)
    for i in 1:size(shift_array, 1)
        for j in 1:size(shift_array, 2)
            A[i, j] = GA[shift_array[i, j]%l+1]
        end
    end
    return LiftedCode(A; GA=GA, repr=representation_matrix)
end

lift_to_bool(x) = Bool(Int(lift(ZZ,x)))

function concat_lift_repr(repr, mat)
    x = repr.(mat)
    y = hvcat(size(x,2), transpose(x)...)
    z = Matrix(lift_to_bool.(y))
    return z
end

function parity_checks(c::LiftedCode)
    return lift(c.repr, c.A)
end

code_n(c::LiftedCode) = size(c.A, 2) * size(zero(c.GA), 2)

code_s(c::LiftedCode) = size(c.A, 1) * size(zero(c.GA), 1)

"""
    $TYPEDEF

A quantum CSS code constructed from three trivariate polynomials over a finite field
from [jacob2025singleshotdecodingfaulttolerantgates](@cite).

## Group Algebra Formalism

[jacob2025singleshotdecodingfaulttolerantgates](@cite) first define arbitrary 3-block
group algebra codes (for an *abelian* group G. The group algebra ``\\mathbb{F}_2[G]`` consists of
formal sums of the form ``\\sum_{g \\in G} a_g g``, with ``a_g \\in \\mathbb{F}_2``.

For a 3-block code, [jacob2025singleshotdecodingfaulttolerantgates](@cite) considers the
three length-1 chain complexes:

```math
\\begin{aligned}
A_1 \\xrightarrow{\\quad a \\quad} A_0, \\quad
B_1 \\xrightarrow{\\quad b \\quad} B_0, \\quad
C_1 \\xrightarrow{\\quad c \\quad} C_0,
\\end{aligned}
```

where ``A_i, B_i, C_i = \\mathbb{F}_2[G]`` and the boundary maps ``a, b, c \\in \\mathbb{F}_2[G]``.

The tensor (balanced) product complex is formed from these three complexes using the
*isomorphism* ``\\mathbb{F}_2[G] \\otimes_G \\mathbb{F}_2[G] \\simeq \\mathbb{F}_2[G]``
which is used to simplify the general definition. The resulting tensor product complex is:

```math
\\begin{aligned}
A_1 \\otimes_G B_1 \\otimes_G C_1
\\xrightarrow{\\quad \\partial_3 \\quad}
\\bigoplus_{i+j+k=2} A_i \\otimes_G B_j \\otimes_G C_k
\\xrightarrow{\\quad \\partial_2 \\quad}
\\bigoplus_{i+j+k=1} A_i \\otimes_G B_j \\otimes_G C_k
\\xrightarrow{\\quad \\partial_1 \\quad} A_0 \\otimes_G B_0 \\otimes_G C_0
\\end{aligned}
```

The boundary maps can be written explicitly in terms of a, b, and c as:

```math
\\begin{aligned}
\\partial_3 &= \\begin{bmatrix} a \\\\ b \\\\ c \\end{bmatrix} \\\\
\\partial_2 &= \\begin{bmatrix}
0 & c & b \\\\
c & 0 & a \\\\
b & a & 0
\\end{bmatrix} \\\\
\\partial_1 &= \\begin{bmatrix} a & b & c \\end{bmatrix}
\\end{aligned}
```

The trivariate tricycle codes from this complex are constructed in
[jacob2025singleshotdecodingfaulttolerantgates](@cite) by defining the group
``G = \\Z_\\ell \\times \\Z_m \\times \\Z_p`` for integers ``\\ell``, m, and p,
which is *isomorphic* to the group generated by the following matrices:

```math
\\begin{aligned}
x &= S_\\ell \\otimes I_m \\otimes I_p \\\\
y &= I_\\ell \\otimes S_m \\otimes I_p \\\\
z &= I_\\ell \\otimes I_m \\otimes S_p
\\end{aligned}
```

where ``S_n`` is the ``n \\times n`` cyclic shift matrix with elements
``(S_n)_{i,j} = \\delta_{i, j \\oplus 1}`` and ``\\oplus`` denotes addition
modulo n.

[jacob2025singleshotdecodingfaulttolerantgates](@cite) considers trivariate
polynomials A, B, and C in the non-commuting variables x, y, and z. Their initial,
symmetric choice is:

```math
\\begin{aligned}
A &= A_1 + A_2 + A_3 \\\\
B &= B_1 + B_2 + B_3 \\\\
C &= C_1 + C_2 + C_3
\\end{aligned}
```

though this restriction can be relaxed.

## Parity Checks

The parity-check matrices for the CSS code as:

```math
\\begin{aligned}
H_X \\equiv \\partial_1, \\quad H_Z = \\partial_2^\\top, \\quad M_Z = \\partial_3^\\top,
\\end{aligned}
```

where ``H_X`` and ``H_Z`` are the ``X`` and ``Z`` stabilizer generators, and ``M_Z``
is a matrix of meta-checks encoding the redundancy in the ``Z`` checks. It can be verified that:

```math
\\begin{aligned}
H_XH_Z^\\top = 0 \\quad \\text{and} \\quad M_ZH_Z = 0.
\\end{aligned}
```

This results in the chain complex structure:

```math
\\begin{aligned}
C_M \\xrightarrow{\\quad M_Z \\quad} C_Z \\xrightarrow{\\quad H_Z \\quad} Q \\xrightarrow{\\quad H_X \\quad} C_X
\\end{aligned}
```

where the vector spaces over ``\\mathbb{F}_2[G]``.

The matrices are given by:

```math
\\begin{aligned}
M_Z &= \\begin{bmatrix} A^\\top & B^\\top & C^\\top \\end{bmatrix} \\\\
H_Z &= \\begin{bmatrix}
0 & C^\\top & B^\\top \\\\
C^\\top & 0 & A^\\top \\\\
B^\\top & A^\\top & 0
\\end{bmatrix} \\\\
H_X &= \\begin{bmatrix} A & B & C \\end{bmatrix}
\\end{aligned}
```

## Polynomial Quotient Ring Formalism

!!! note
    We leverage the isomorphism between the group algebra ``\\mathbb{F}_2[\\mathbb{Z}_\\ell \\times \\mathbb{Z}_m \\times \\mathbb{Z}_p]``
    and the multivariate polynomial quotient ring ``\\frac{\\mathbb{F}_2[x, y, z]}{\\langle x^\\ell-1, y^m-1, z^p-1 \\rangle}`` to introduce
    a novel realization of the Trivariate Tricycle codes of [jacob2025singleshotdecodingfaulttolerantgates](@cite).

## Generalization

The generalization of the [`TrivariateTricycle`](@ref) codes to an arbitrary
number of groups (Λ ≥ 3) remains a conjecture; for details, see Section 5.3.2,
*Product of Λ ≥ 3 group algebra codes* of [breuckmann2024cupsgatesicohomology](@cite).
The parity-check and metacheck matrices for the [`TrivariateTricycle`](@ref) codes—which
are equivalent to the boundary maps of the underlying 3-term chain complex, see
equation 2, 3, and 4 of [jacob2025singleshotdecodingfaulttolerantgates](@cite)—are
constructed explicitly in [breuckmann2024cupsgatesicohomology](@cite). These
matrices serve as the fundamental building blocks and provide the key theoretical
insight underlying this family of quantum codes.

#### Examples

Here is the `[[72, 6, 6]]` trivariate tricycle code from Table I from [jacob2025singleshotdecodingfaulttolerantgates](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l, m, p = 4, 3, 2;

julia> R, (x, y, z) = polynomial_ring(GF(2), [:x, :y, :z]);

julia> I = ideal(R, [x^l - 1, y^m - 1, z^p - 1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + y + x*y^2);

julia> B = S(1 + y*z + x^2*y^2);

julia> C = S(1 + x*y^2*z + x^2*y);

julia> c = TrivariateTricycle(l, m, p, A, B, C);

julia> code_n(c), code_k(c)
(72, 6)
```

Here is the `[[432, 12, 12]]` trivariate tricycle code from Table I from [jacob2025singleshotdecodingfaulttolerantgates](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l, m, p = 6, 6, 4;

julia> R, (x, y, z) = polynomial_ring(GF(2), [:x, :y, :z]);

julia> I = ideal(R, [x^l - 1, y^m - 1, z^p - 1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + x*y*z^3 + x^3*y^4*z^2);

julia> B = S(1 + x^3*y*z^2 + x^3*y^2*z^3);

julia> C = S(1 + x^4*y^3*z^3 + x^5*z^2);

julia> c = TrivariateTricycle(l, m, p, A, B, C);

julia> code_n(c), code_k(c)
(432, 12)
```

### Fields
    $TYPEDFIELDS
"""
struct TrivariateTricycle <: AbstractCSSCode
    """Order of the first abelian group in ``\\mathbb{F}_2[\\mathbb{Z}_\\ell \\times \\mathbb{Z}_m \\times \\mathbb{Z}_p]``"""
    l::Int
    """Order of the second abelian group in ``\\mathbb{F}_2[\\mathbb{Z}_\\ell \\times \\mathbb{Z}_m \\times \\mathbb{Z}_p]``"""
    m::Int
    """Order of the third abelian group in ``\\mathbb{F}_2[\\mathbb{Z}_\\ell \\times \\mathbb{Z}_m \\times \\mathbb{Z}_p]``"""
    p::Int
    """First trivariate polynomial in quotient ring ``\\frac{\\mathbb{F}_2[x, y, z]}{\\langle x^\\ell-1, y^m-1, z^p-1 \\rangle}``"""
    A::MPolyQuoRingElem{FqMPolyRingElem}
    """Second trivariate polynomial in quotient ring ``\\frac{\\mathbb{F}_2[x, y, z]}{\\langle x^\\ell-1, y^m-1, z^p-1 \\rangle}``"""
    B::MPolyQuoRingElem{FqMPolyRingElem}
    """Third trivariate polynomial in quotient ring ``\\frac{\\mathbb{F}_2[x, y, z]}{\\langle x^\\ell-1, y^m-1, z^p-1 \\rangle}``"""
    C::MPolyQuoRingElem{FqMPolyRingElem}

    function TrivariateTricycle(l::Int, m::Int, p::Int, A::MPolyQuoRingElem{FqMPolyRingElem}, B::MPolyQuoRingElem{FqMPolyRingElem}, C::MPolyQuoRingElem{FqMPolyRingElem})
        l > 0 || throw(ArgumentError("l must be positive"))
        m > 0 || throw(ArgumentError("m must be positive"))
        p > 0 || throw(ArgumentError("p must be positive"))
        Rₒ = parent(A)
        R, (x,y,z) = polynomial_ring(GF(2), [:x, :y, :z])
        I = ideal(R, [x^l-1, y^m-1, z^p-1])
        Rₑₓₚ, _ = quo(R, I)
        base_ring(Rₒ) != base_ring(Rₑₓₚ) && throw(ArgumentError("A must be in R/⟨x^$l-1, y^$m-1, z^$p-1⟩"))
        modulus(Rₒ) != modulus(Rₑₓₚ) && throw(ArgumentError("A must be in R/⟨x^$l-1, y^$m-1, z^$p-1⟩"))
        parent(B) != Rₒ && throw(ArgumentError("B must be in same ring as A"))
        parent(C) != Rₒ && throw(ArgumentError("C must be in same ring as A"))
        new(l, m, p, A, B, C)
    end
end

"""Convert a matrix over GF(2) to an integer matrix."""
function _gf2_to_int_mat(M_gf2)
    m, n = size(M_gf2)
    Mᵢₙₜ = zeros(Int, m, n)
    for i in 1:m, j in 1:n
        elem = M_gf2[i, j]
        Mᵢₙₜ[i, j] = iszero(elem) ? 0 : 1
    end
    return Mᵢₙₜ
end

"""Construct a 3D circulant matrix from a trivariate polynomial."""
function _circulant_matrix_3d(poly, l, m, p)
    n = l*m*p
    M = zero_matrix(GF(2), n, n)
    for i in 0:l-1, j in 0:m-1, k in 0:p-1
        col_idx = i*(m*p)+j*p+k+1
        for term in terms(poly)
            c = coeff(term, 1)
            i₂ = degree(term, 1)
            j₂ = degree(term, 2)
            k₂ = degree(term, 3)
            i₃ = mod(i₂+i, l)
            j₃ = mod(j₂+j, m)
            k₃ = mod(k₂+k, p)
            row_idx = i₃*(m*p)+j₃*p+k₃+1
            M[row_idx, col_idx] += c
        end
    end
    return M
end

"""Convert a quotient ring polynomial to its circulant matrix representation."""
function _polynomial_to_circulant_matrix(f, l, m, p)
    f_lift = lift(f)
    return _circulant_matrix_3d(f_lift, l, m, p)
end

"""Compute the transpose of a polynomial in the group algebra. For a
polynomial f = ∑ cᵢⱼₖ xⁱyʲzᵏ, the transpose is fᵀ = ∑ cᵢⱼₖ x⁻ⁱy⁻ʲz⁻ᵏ."""
function _polynomial_transpose(f, l, m, p)
    f_lift = lift(f)
    Rₒ = parent(f_lift)
    x, y, z = gens(Rₒ)
    fₜᵣₐₙₛ = zero(Rₒ)
    monoms = monomials(f_lift)
    coeffs = coefficients(f_lift)
    for (mono, c) in zip(monoms, coeffs)
        i = degree(mono, 1)
        j = degree(mono, 2)
        k = degree(mono, 3)
        iᵢₙᵥ = mod(-i, l)
        jᵢₙᵥ = mod(-j, m)
        kᵢₙᵥ = mod(-k, p)
        monoᵢₙᵥ = x^iᵢₙᵥ*y^jᵢₙᵥ*z^kᵢₙᵥ
        fₜᵣₐₙₛ += c*monoᵢₙᵥ
    end
    return Rₒ(fₜᵣₐₙₛ)
end

function boundary_maps(c::TrivariateTricycle)
    l, m, p = c.l, c.m, c.p
    A, B, C = c.A, c.B, c.C
    M_A = _polynomial_to_circulant_matrix(A, l, m, p)
    M_B = _polynomial_to_circulant_matrix(B, l, m, p)
    M_C = _polynomial_to_circulant_matrix(C, l, m, p)
    Aₜᵣₐₙₛ = _polynomial_transpose(A, l, m, p)
    Bₜᵣₐₙₛ = _polynomial_transpose(B, l, m, p)
    Cₜᵣₐₙₛ = _polynomial_transpose(C, l, m, p)
    M_Aₜᵣₐₙₛ = _polynomial_to_circulant_matrix(Aₜᵣₐₙₛ, l, m, p)
    M_Bₜᵣₐₙₛ = _polynomial_to_circulant_matrix(Bₜᵣₐₙₛ, l, m, p)
    M_Cₜᵣₐₙₛ = _polynomial_to_circulant_matrix(Cₜᵣₐₙₛ, l, m, p)
    n_block = l*m*p
    zero_block = zero_matrix(GF(2), n_block, n_block)
    H_X = hcat(M_A, M_B, M_C) # Eq. 14
    H_Z = vcat(
        hcat(zero_block, M_Cₜᵣₐₙₛ, M_Bₜᵣₐₙₛ),
        hcat(M_Cₜᵣₐₙₛ, zero_block, M_Aₜᵣₐₙₛ),
        hcat(M_Bₜᵣₐₙₛ, M_Aₜᵣₐₙₛ, zero_block)
    ) # Eq. 13
    M_Z = hcat(M_Aₜᵣₐₙₛ, M_Bₜᵣₐₙₛ, M_Cₜᵣₐₙₛ) # Eq. 12
    H_X = _gf2_to_int_mat(H_X)
    H_Z = _gf2_to_int_mat(H_Z)
    M_Z = _gf2_to_int_mat(M_Z)
    return H_X, H_Z, M_Z
end

parity_matrix_x(c::TrivariateTricycle) = boundary_maps(c)[1]

parity_matrix_z(c::TrivariateTricycle) = boundary_maps(c)[2]

metacheck_matrix_z(c::TrivariateTricycle) = boundary_maps(c)[3]

hasmetachecks(c::TrivariateTricycle) = (false, true)

@testitem "Enumeration" begin
    @test Set([copy(op) for op in enumerate_cliffords(1)]) == Set((random_clifford(1,phases=false) for i in 1:70))
    @test Set([copy(op) for op in enumerate_phases(enumerate_cliffords(1))]) == Set((random_clifford(1,phases=true) for i in 1:300))
    @test length(collect(enumerate_cliffords(2))) == length(collect(enumerate_phases(enumerate_cliffords(2))))/2^4 == 720
    @test first(enumerate_cliffords(3)) == C"X__ __Z _Z_ Z__ __X _X_"
    @test first(enumerate_cliffords(5)) == C"X____ ____Z ___Z_ __Z__ _Z___ Z____ ____X ___X_ __X__ _X___"
    for n in 1:10
        symplectic_cardinality = clifford_cardinality(n, phases=false)
        @test clifford_cardinality(n) == symplectic_cardinality*(2^(2n))
    end
end

"""Classical codes lifted over a group algebra, used for lifted product code construction ([panteleev2021degenerate](@cite), [panteleev2022asymptotically](@cite))

Implemented as a package extension with Hecke. Check the [QuantumClifford documentation](http://qc.quantumsavory.org/stable/ECC_API/) for more details on that extension."""
function LiftedCode(args...; kwargs...)
    ext = Base.get_extension(QuantumClifford, :QuantumCliffordHeckeExt)
    if isnothing(ext)
        throw("The `LiftedCode` depends on the package `Hecke` but you have not installed or imported it yet. Immediately after you import `Hecke`, the `LiftedCode` will be available.")
    end
    return ext.LiftedCode(args...; kwargs...)
end

# Works even when broadcasting on zero-dimensional arrays.
@inline u32(v) = map(x -> UInt32(x), v)

# By definition, the size of (unsigned) char is set to unity.
@inline bit_count(::Type{T}) where {T} = sizeof(T) * count_zeros(zero(Cuchar))

module QuantumCliffordOscarExt

using DocStringExtensions

import LinearAlgebra
import LinearAlgebra: rank
import QuantumClifford
import QuantumClifford: Stabilizer
import Nemo
import Nemo: FqFieldElem
import Hecke: group_algebra, GF, abelian_group, gens, quo, one, GroupAlgebra,
   GroupAlgebraElem, direct_product, sub, ZZ, lift, polynomial_ring
import Oscar
import Oscar: free_group, small_group_identification, describe, order, FPGroupElem, FPGroup,
    BasicGAPGroupElem, DirectProductGroup, cyclic_group, free_module, hom, tensor_product,
    chain_complex, total_complex, map, summands, MatElem, matrix, nrows, ncols, kernel, dim, image,
    base_ring, ComplexOfMorphisms, coefficients, zero_matrix, circshift,
    kronecker_product, FqMatrix, identity_matrix, FqPolyRingElem, laurent_polynomial_ring,
    hnf_with_transform, ideal, is_coprime, quo, groebner_basis, length, FqMPolyRingElem,
    first, MPolyQuoRingElem, FqMPolyRingElem, modulus, ideal, monomials, terms, coeff, degree, mod,
    monomial, exponent_vector, nvars, koszul_matrix, koszul_complex, IdealGens, LaurentMPolyWrap
import Oscar.Generic: MatSpaceElem, DirectSumModule, exponent_vectors
import Combinatorics: combinations

import QuantumClifford.ECC: two_block_group_algebra_code, twobga_from_direct_product, twobga_from_fp_group,
    boundary_maps, max_xy_exponents

import QECCore: AbstractECC, CSS, RepCode, AbstractCSSCode,
    hgp, code_k, code_n, code_s, distance, parity_matrix_x, parity_matrix_z, parity_matrix_xz, parity_matrix,
    metacheck_matrix_x, metacheck_matrix_z, metacheck_matrix, hasmetachecks

# exported from extension so that Documenter.jl sees them when autogenerating API lists
export twobga_from_direct_product, twobga_from_fp_group, DDimensionalSurface, DDimensionalToric, boundary_maps,
    HomologicalProduct, DoubleHomologicalProduct, GeneralizedToric, TrivariateTricycle, BivariateBicycleViaPoly, MultivariateMulticycle

include("types.jl")
include("direct_product.jl")
include("bivariate_bicycle.jl")
include("generalized_toric.jl")
include("group_presentation.jl")
include("d_dimensional_codes.jl")
include("trivariate_tricycle.jl")
include("multivariate_multicycle.jl")
include("homological_product_codes.jl")

end # module

@testitem "Consistency checks -- Cliffords are unitary" begin
    using Random
    using InteractiveUtils
    @testset "Apply small symbolics/sparse/named gates" begin
        for gate_type in subtypes(QuantumClifford.AbstractTwoQubitOperator)
            @test apply!(S"II II", gate_type(1,2)) == S"II II"
            s1 = random_stabilizer(4)
            s2 = s1[randperm(4)]
            apply!(s1, gate_type(3,2))
            apply!(s2, gate_type(3,2))
            @test canonicalize!(s1) == canonicalize!(s2)
        end
        for gate_type in subtypes(QuantumClifford.AbstractSingleQubitOperator)
            gate_type === SingleQubitOperator && continue
            @test apply!(S"I", gate_type(1)) == S"I"
            s1 = random_stabilizer(4)
            s2 = s1[randperm(4)]
            apply!(s1, gate_type(2))
            apply!(s2, gate_type(2))
            @test canonicalize!(s1) == canonicalize!(s2)
            gate(x) = SingleQubitOperator(gate_type(x))
            @test apply!(S"I", gate(1)) == S"I"
            s1 = random_stabilizer(4)
            s2 = s1[randperm(4)]
            apply!(s1, gate(2))
            apply!(s2, gate(2))
            @test canonicalize!(s1) == canonicalize!(s2)
        end
    end

    @testset "Apply dense Cliffords and Paulis" begin
        for gate_type in (random_pauli, random_clifford)
            @test apply!(S"II II", gate_type(2)) == S"II II"
            s1 = random_stabilizer(4)
            s2 = s1[randperm(4)]
            gate = gate_type(4)
            apply!(s1, gate)
            apply!(s2, gate)
            @test canonicalize!(s1) == canonicalize!(s2)
        end
    end
end

@testitem "ECC D-dimensional Surface Code" tags=[:ecc, :ecc_bespoke_checks, :oscar_required] begin
    using Oscar
    using QECCore
    import HiGHS
    import JuMP
    using Nemo: matrix, GF
    using QuantumClifford: stab_looks_good, stab_to_gf2
    using QuantumClifford.ECC
    import Oscar.Generic.MatSpaceElem

    @testset "Check properties of D-dimensional Surface codes" begin
        @testset "[[L² + (L − 1)², 1, L]] 2D surface code" begin
            for L in 2:5
                D = 2
                c = DDimensionalSurface(D, L)
                code = parity_checks(c)
                n, k = code_n(code), code_k(code)
                H = stab_to_gf2(code)
                mat = matrix(GF(2), H)
                computed_rank = rank(mat)
                @test computed_rank == n - k
                @test stab_looks_good(code, remove_redundant_rows=true)
                @test n == L^2 + (L − 1)^2 == code_n(c) && k == 1 == code_k(c)
                @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == L
                @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:Z)) == L
            end
        end

        @testset "[[L³ + 2L(L − 1)², 1, min(L, L²)]] 3D Surface code" begin
            for L in 2:3
                D = 3
                c = DDimensionalSurface(D, L)
                code = parity_checks(c)
                n, k = code_n(code), code_k(code)
                H = stab_to_gf2(code)
                mat = matrix(GF(2), H)
                computed_rank = rank(mat)
                @test computed_rank == n - k
                @test stab_looks_good(code, remove_redundant_rows=true)
                @test n == L^3 + 2*L*(L − 1)^2 == code_n(c) && k == 1 == code_k(c)
                @test iszero(mod.(metacheck_matrix_z(c)*parity_matrix_z(c), 2))
                @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:X)) == L
                @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:Z)) == L^2
                dx = distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:X))
                dz = distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:Z))
                mindxdz = distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:minXZ))
                @test min(dx, dz) == mindxdz
            end
        end

        @testset "[[6L⁴ − 12L³ + 10L² − 4L + 1, 1, L²]] 4D Surface code" begin
            # Testing only one instance of 4D codes due to longer execution time.
            L = 2
            D = 4
            c = DDimensionalSurface(D, L)
            code = parity_checks(c)
            n, k = code_n(code), code_k(code)
            H = stab_to_gf2(code)
            mat = matrix(GF(2), H)
            computed_rank = rank(mat)
            @test computed_rank == n - k
            @test stab_looks_good(code, remove_redundant_rows=true)
            @test iszero(mod.(metacheck_matrix_z(c)*parity_matrix_z(c), 2))
            @test iszero(mod.(metacheck_matrix_x(c)*parity_matrix_x(c), 2))
            @test n == 6*L^4 − 12*L^3 + 10*L^2 − 4*L + 1 == code_n(c) && k == 1 == code_k(c)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == L^2
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:Z)) == L^2
        end
    end

    @testset "Check properties of D-dimensional Toric codes" begin
        @testset "[[2L², 2, L]] 2D Toric code" begin
            for L in 2:5
                D = 2
                c = DDimensionalToric(D, L)
                code = parity_checks(c)
                n, k = code_n(code), code_k(code)
                H = stab_to_gf2(code)
                mat = matrix(GF(2), H)
                computed_rank = rank(mat)
                @test computed_rank == n - k
                @test code_n(c) == n == 2*L^2 && code_k(c) == k == 2
                @test stab_looks_good(code, remove_redundant_rows=true)
                @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == L
                @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:Z)) == L
            end
        end

        @testset "[[3L³, 3, min(L, L²)]] 3D Toric code" begin
            for L in 2:3
                D = 3
                c = DDimensionalToric(D, L)
                code = parity_checks(c)
                n, k = code_n(code), code_k(code)
                H = stab_to_gf2(code)
                mat = matrix(GF(2), H)
                computed_rank = rank(mat)
                @test computed_rank == n - k
                @test code_n(c) == n == 3*L^3 && code_k(c) == k == 3
                @test stab_looks_good(code, remove_redundant_rows=true)
                @test iszero(mod.(metacheck_matrix_z(c)*parity_matrix_z(c), 2))
                @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:X)) == L
                @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:Z)) == L^2
                dx = distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:X))
                dz = distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:Z))
                mindxdz = distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:minXZ))
                @test min(dx, dz) == mindxdz
            end
        end

        @testset "[[6L⁴, 6, L²]] 4D Toric code" begin
            # Testing only one instance of 4D codes due to longer execution time.
            L = 2
            D = 4
            c = DDimensionalToric(D, L)
            code = parity_checks(c)
            n, k = code_n(code), code_k(code)
            H = stab_to_gf2(code)
            mat = matrix(GF(2), H)
            computed_rank = rank(mat)
            @test computed_rank == n - k
            @test code_n(c) == n == 6*L^4 && code_k(c) == k == 6
            @test stab_looks_good(code, remove_redundant_rows=true)
            @test iszero(mod.(metacheck_matrix_z(c)*parity_matrix_z(c), 2))
            @test iszero(mod.(metacheck_matrix_x(c)*parity_matrix_x(c), 2))
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == L^2
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:Z)) == L^2
        end
    end

    @testset "Homological Product codes of Table III of https://arxiv.org/pdf/2407.18490" begin
        function _circulant_matrix_from_quasi_cyclic_polynomial_matrix(H::MatSpaceElem, l::Int)
            F = GF(2)
            r, n = size(H)
            H_bin = zero_matrix(F, r*l, n*l)
            for i in 1:r, j in 1:n
                cfs = zeros(F, l)
                for (k, c) in enumerate(coefficients(H[i,j]))
                    cfs[k] = c
                end
            circ = hcat([circshift(cfs, s) for s in 0:l-1]...)
            rows = (1:l) .+ (i-1)*l
            cols = (1:l) .+ (j-1)*l
            H_bin[rows, cols] = matrix(F, circ)
            end
            return H_bin
        end
        # [[117, 9, 4]] from Table III
        R, x = polynomial_ring(GF(2), "x")
        l = 3
        H = matrix(R, 2, 3, [x^2 x^2 x^2;
                             x   x^2  0])
        G = matrix(R, 1, 3, [1 x 1+x])
        c = HomologicalProduct([H,transpose(H)], l)
        code = parity_checks(c)
        n, k = code_n(code), code_k(code)
        H = stab_to_gf2(code)
        mat = matrix(GF(2), H)
        computed_rank = rank(mat)
        @test computed_rank == n - k
        @test n == 117 && k == 9
        @test stab_looks_good(code, remove_redundant_rows=true)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
        H = matrix(R, 2, 3, [x^2 x^2 x^2;
                             x   x^2  0])
        G = matrix(R, 1, 3, [1 x 1+x])
        H = _circulant_matrix_from_quasi_cyclic_polynomial_matrix(H, l)
        G = _circulant_matrix_from_quasi_cyclic_polynomial_matrix(G, l)
        @test iszero(H*transpose(G))

        # [[225, 9, 4]] from Table III
        R, x = polynomial_ring(GF(2), "x")
        l = 3
        H = matrix(R, 3, 4, [x^2 x^2 x^2   0;
                             x^2   0 x^2  x^2;
                             x^2 x^2   x  x^2])
        G = matrix(R, 1, 4, [1 (1+x)^2 x^2 (1+x)^2])
        c = HomologicalProduct([H,transpose(H)], l)
        code = parity_checks(c)
        n, k = code_n(code), code_k(code)
        H = stab_to_gf2(code)
        mat = matrix(GF(2), H)
        computed_rank = rank(mat)
        @test computed_rank == n - k
        @test n == 225 && k == 9
        @test stab_looks_good(code, remove_redundant_rows=true)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
        H = matrix(R, 3, 4, [x^2 x^2 x^2   0;
                             x^2   0 x^2  x^2;
                             x^2 x^2   x  x^2])
        G = matrix(R, 1, 4, [1 (1+x)^2 x^2 (1+x)^2])
        H = _circulant_matrix_from_quasi_cyclic_polynomial_matrix(H, l)
        G = _circulant_matrix_from_quasi_cyclic_polynomial_matrix(G, l)
        @test iszero(H*transpose(G))

        # [[400, 18, 8]] from Table III
        R, x = polynomial_ring(GF(2), "x")
        l = 4
        H = matrix(R, 3, 4, [x^3 x^3   0 x^3;
                             x^3 x^2 x^3 x^2;
                             x^3 x^3 x^2  0])
        G = matrix(R, 1, 4, [1 1+x+x^2 1+x x+x^2])
        H = _circulant_matrix_from_quasi_cyclic_polynomial_matrix(H, l)
        G = _circulant_matrix_from_quasi_cyclic_polynomial_matrix(G, l)
        @test iszero(H*transpose(G))

        # [[625, 25, 9]]
        R, x = polynomial_ring(GF(2), "x")
        l = 5
        H = matrix(R, 3, 4, [x^4   0 x^4 x^3;
                             0 x^3 x^3 x^4;
                             x^3 x^4   0 x^3])
        G = matrix(R, 1, 4, [1 x+x^2+x^3 1+x^2+x^3 x+x^2])
        H = _circulant_matrix_from_quasi_cyclic_polynomial_matrix(H, l)
        G = _circulant_matrix_from_quasi_cyclic_polynomial_matrix(G, l)
        @test iszero(H*transpose(G))
    end

    @testset "Double Homological Product codes of Table I of https://arxiv.org/pdf/1805.09271" begin
        # [[241, 1, 9]]
        δ = [1 1 0;
             0 1 1]
        c = DoubleHomologicalProduct(δ)
        code = parity_checks(c)
        n, k = code_n(code), code_k(code)
        H = stab_to_gf2(code)
        mat = matrix(GF(2), H)
        computed_rank = rank(mat)
        @test computed_rank == n - k
        @test n == 241 && k == 1
        @test stab_looks_good(code, remove_redundant_rows=true)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 9
        @test iszero(mod.(metacheck_matrix_z(c)*parity_matrix_z(c), 2))
        @test iszero(mod.(metacheck_matrix_x(c)*parity_matrix_x(c), 2))

        # [[486, 6, 9]]
        δ = [1 1 0;
             0 1 1;
             1 0 1]
        c = DoubleHomologicalProduct(δ)
        code = parity_checks(c)
        n, k = code_n(code), code_k(code)
        H = stab_to_gf2(code)
        mat = matrix(GF(2), H)
        computed_rank = rank(mat)
        @test computed_rank == n - k
        @test n == 486 && k == 6
        @test stab_looks_good(code, remove_redundant_rows=true)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 9
        @test iszero(mod.(metacheck_matrix_z(c)*parity_matrix_z(c), 2))
        @test iszero(mod.(metacheck_matrix_x(c)*parity_matrix_x(c), 2))

        # [[913, 1, 16]]
        δ = [1 1 0 0;
             0 1 1 0;
             0 0 1 1];
        c = DoubleHomologicalProduct(δ)
        code = parity_checks(c)
        n, k = code_n(code), code_k(code)
        H = stab_to_gf2(code)
        mat = matrix(GF(2), H)
        computed_rank = rank(mat)
        @test computed_rank == n - k
        @test n == 913 && k == 1
        @test stab_looks_good(code, remove_redundant_rows=true)
        @test iszero(mod.(metacheck_matrix_z(c)*parity_matrix_z(c), 2))
        @test iszero(mod.(metacheck_matrix_x(c)*parity_matrix_x(c), 2))
    end
end

@testite "Expectation of Pauli strings on stabilizer states" begin
    using QuantumClifford: stab_looks_good, destab_looks_good, mixed_stab_looks_good, mixed_destab_looks_good
    using QuantumClifford: projectremoverand!

    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    function alter_expect(p::PauliOperator, s::Stabilizer)
        nqubits(p) == nqubits(s) || error("The number of qubits does not match")
        n = nqubits(p)
        s_anc = s ⊗ one(Stabilizer, n)
        p_anc = zero(PauliOperator, 2n)
        for i = 1:n
            if p[i] != (false, false)
                if p[i][1]
                    apply!(s_anc, sHadamard(i))
                    p[i][2] && apply!(s_anc, sInvPhase(i))
                end
                apply!(s_anc, sCNOT(i, i+n))
                p_anc[i+n] = (false, true)
            end
        end
        p_anc.phase[] = p.phase[]
        _, _, result = project!(s_anc, p_anc)
        result === nothing && return 0
        result === 0x00 && return 1
        result === 0x01 && return im
        result === 0x02 && return -1
        result === 0x03 && return -im
    end

    st = bell()
    apply!(st, sX(2))
    @test expect(P"XX", st) == alter_expect(P"XX", st) == 1
    @test expect(P"ZZ", st) == alter_expect(P"ZZ", st) == -1
    @test expect(P"XI", st) == alter_expect(P"XI", st) == 0
    @test expect(P"ZI", st) == alter_expect(P"ZI", st) == 0
    @test expect(P"II", st) == alter_expect(P"II", st) == 1
    @test expect(P"-XX", st) == alter_expect(P"-XX", st) == -1
    @test expect(P"-iXX", st) == alter_expect(P"-iXX", st) == -im
end

module QuantumCliffordQuantikzExt

import Quantikz
using QuantumClifford
using QuantumClifford.Experimental.NoisyCircuits
using QuantumClifford: AbstractOperation

function Quantikz.QuantikzOp(op::SparseGate)
    g = op.cliff
    if g==tCNOT
        return Quantikz.CNOT(op.indices...)
    elseif g==tSWAP*tCNOT*tSWAP
        return Quantikz.CNOT(op.indices[end:-1:begin]...)
    elseif g==tCPHASE
        return Quantikz.CPHASE(op.indices...)
    elseif g==tSWAP
        return Quantikz.SWAP(op.indices...)
    else
        return Quantikz.MultiControlU([],[],op.indices) # TODO Permit skipping the string
    end
end
Quantikz.QuantikzOp(op::AbstractOperation) = Quantikz.MultiControlU(collect(affectedqubits(op))) # TODO make Quantikz work with tuples and remove the collect
Quantikz.QuantikzOp(op::PauliOperator) = Quantikz.MultiControlU("\\begin{array}{c}$(lstring(op))\\end{array}", collect(affectedqubits(op))) # TODO make Quantikz work with tuples and remove the collect
Quantikz.QuantikzOp(op::sId1) = Quantikz.Id(affectedqubits(op)...)
function Quantikz.QuantikzOp(op::AbstractSingleQubitOperator)
    T = typeof(op)
    str = if T in (sHadamard, sPhase, sX, sY, sZ)
        string(nameof(T))[2:2]
    elseif T == sInvPhase
        "P^{-1}"
    else
        "U"
    end
    str = "{"*str*"}"
    return Quantikz.U(str,affectedqubits(op)...)
end
Quantikz.QuantikzOp(op::sCNOT) = Quantikz.CNOT(affectedqubits(op)...)
Quantikz.QuantikzOp(op::sZCX) = Quantikz.CNOT(affectedqubits(op)...)
Quantikz.QuantikzOp(op::sXCZ) = Quantikz.CNOT(reverse(affectedqubits(op))...)
Quantikz.QuantikzOp(op::sCPHASE) = Quantikz.CPHASE(affectedqubits(op)...)
Quantikz.QuantikzOp(op::sSWAP) = Quantikz.SWAP(affectedqubits(op)...)
Quantikz.QuantikzOp(op::sZCZ) = Quantikz.CPHASE(affectedqubits(op)...)
Quantikz.QuantikzOp(op::sXCX) = Quantikz.MultiControl([],[],collect(affectedqubits(op)),[]) # TODO make Quantikz work with tuples and remove the collect
Quantikz.QuantikzOp(op::sZCY) = Quantikz.MultiControlU("-iY",affectedqubits(op)...)
Quantikz.QuantikzOp(op::sYCZ) = Quantikz.MultiControlU("Y",reverse(affectedqubits(op))...)
Quantikz.QuantikzOp(op::sXCY) = Quantikz.MultiControlU("-iY",[],[],[affectedqubits(op)[2]],[affectedqubits(op)[1]])
Quantikz.QuantikzOp(op::sYCX) = Quantikz.MultiControlU("Y",[],[],[affectedqubits(op)[1]],[affectedqubits(op)[2]])
function Quantikz.QuantikzOp(op::AbstractTwoQubitOperator)
    return Quantikz.U("{U}",collect(affectedqubits(op))) # TODO make Quantikz work with tuples and remove the collect
end
Quantikz.QuantikzOp(op::BellMeasurement) = Quantikz.ParityMeasurement(["\\mathtt{$(string(nameof(typeof(o)))[3])}" for o in op.measurements], collect(affectedqubits(op))) # TODO make Quantikz work with tuples and remove the collect
Quantikz.QuantikzOp(op::NoisyBellMeasurement) = Quantikz.QuantikzOp(op.meas)
Quantikz.QuantikzOp(op::ConditionalGate) = Quantikz.ClassicalDecision(affectedqubits(op),op.controlbit) # TODO make Quantikz work with tuples and remove the collect
Quantikz.QuantikzOp(op::DecisionGate) = Quantikz.ClassicalDecision(affectedqubits(op),Quantikz.ibegin:Quantikz.iend) # TODO make Quantikz work with tuples and remove the collect
#Quantikz.QuantikzOp(op::DenseGate) = Quantikz.MultiControlU(affectedqubits(op))
Quantikz.QuantikzOp(op::PauliMeasurement) = Quantikz.Measurement("\\begin{array}{c}$(lstring(op.pauli))\\end{array}",collect(affectedqubits(op)),op.bit) # TODO make Quantikz work with tuples and remove the collect
Quantikz.QuantikzOp(op::Union{sMX,sMRX}) = Quantikz.Measurement("\\begin{array}{c}\\mathtt{X}\\end{array}",collect(affectedqubits(op)), iszero(op.bit) ? nothing : op.bit) # TODO make Quantikz work with tuples and remove the collect
Quantikz.QuantikzOp(op::Union{sMY,sMRY}) = Quantikz.Measurement("\\begin{array}{c}\\mathtt{Y}\\end{array}",collect(affectedqubits(op)), iszero(op.bit) ? nothing : op.bit) # TODO make Quantikz work with tuples and remove the collect
Quantikz.QuantikzOp(op::Union{sMZ,sMRZ}) = Quantikz.Measurement("\\begin{array}{c}\\mathtt{Z}\\end{array}",collect(affectedqubits(op)), iszero(op.bit) ? nothing : op.bit) # TODO make Quantikz work with tuples and remove the collect
#Quantikz.QuantikzOp(op::SparseMeasurement) = Quantikz.Measurement("\\begin{array}{c}$(lstring(op.pauli))\\end{array}",affectedqubits(op),op.bit)
Quantikz.QuantikzOp(op::NoisyGate) = Quantikz.QuantikzOp(op.gate)
Quantikz.QuantikzOp(op::VerifyOp) = Quantikz.MultiControlU("\\begin{array}{c}\\mathrm{Verify:}\\\\$(lstring(op.good_state))\\end{array}",collect(affectedqubits(op))) # TODO make Quantikz work with tuples and remove the collect
function Quantikz.QuantikzOp(op::Reset) # TODO This is complicated because quantikz requires $$ for some operators but not all of them... Fix in Quantikz.jl
    m,M = extrema(op.indices)
    indices = sort(op.indices)
    str = "\\begin{array}{c}\\\\$(lstring(op.resetto))\\end{array}"
    if collect(m:M)==indices
        Quantikz.Initialize("\$$str\$",affectedqubits(op)) # TODO make Quantikz work with tuples and remove the collect
    else
        Quantikz.Initialize("$str",affectedqubits(op)) # TODO make Quantikz work with tuples and remove the collect
    end
end
Quantikz.QuantikzOp(op::NoiseOp) = Quantikz.Noise(collect(op.indices))
Quantikz.QuantikzOp(op::NoiseOpAll) = Quantikz.NoiseAll()
Quantikz.QuantikzOp(op::ClassicalXOR) = Quantikz.ClassicalDecision(sort([op.store, op.bits...]))

function lstring(pauli::PauliOperator)
    v = join(("\\mathtt{$(o)}" for o in replace(string(pauli)[3:end],"_"=>"I")),"\\\\")
end

function lstring(stab::Stabilizer)
    v = join(("\\mathtt{$(replace(string(p),"_"=>"I"))}" for p in stab),"\\\\")
end

function Base.show(io::IO, mime::MIME"image/png", circuit::AbstractVector{<:AbstractOperation}; scale=1, kw...)
    if length(circuit)==0
        show(io, mime, [Quantikz.Id(1)]; scale=scale, kw...)
    else
        show(io, mime, [Quantikz.QuantikzOp(c) for c in circuit]; scale=scale, kw...)
    end
end
Base.show(io::IO, mime::MIME"image/png", gate::T; scale=1, kw...) where T<:AbstractOperation =
    show(io, mime, Quantikz.QuantikzOp(gate); scale=scale, kw...)

end

# Required for QuantumCliffordKAExt.
import Atomix, GPUArraysCore, KernelAbstractions

# Assists in reducing resource demands.
using GPUArrays: AllocCache, @cached, unsafe_free!
using QuantumClifford
# This must be done explicitly as they are not exported.
using QuantumClifford: Tableau, AbstractStabilizer

@testitem "throws" begin
    using QuantumClifford: rank, mul_left!, mul_right!
    using InteractiveUtils: subtypes

    @test_throws DimensionMismatch CliffordOperator(T"XXX ZZ_")

    @test_throws DimensionMismatch tCNOT*S"X"

    #@test_throws DomainError bigram(random_stabilizer(50), clip=false)

    @test_throws DomainError logdot(S"XX", S"XX ZZ")
    @test_throws DimensionMismatch logdot(S"X", S"XX ZZ")

    @test_throws BadDataStructure rank(S"X")
    @test_throws BadDataStructure rank(Destabilizer(S"X"))

    @test_throws DimensionMismatch mul_left!(P"X", P"XX")
    @test_throws DimensionMismatch mul_right!(P"X", P"XX")

    @test_throws ArgumentError GeneralizedStabilizer(S"XX")
    @test_throws DimensionMismatch apply!(GeneralizedStabilizer(random_stabilizer(2)), pcT)

    @test_throws ArgumentError UnitaryPauliChannel([P"X"], [1,2])
    @test_throws ArgumentError UnitaryPauliChannel([P"X",P"XX"], [1,2])

    @test_throws ArgumentError embed(10,2,P"XX")
    @test_throws ArgumentError embed(10,[2,3],P"X")

    struct A <: QuantumClifford.AbstractOperation end
    @test_throws ArgumentError applybranches(S"X",A())

    @test_throws BadDataStructure project!(Destabilizer(S"XX"), P"ZZ")

    @test_throws DimensionMismatch reset_qubits!(ghz(4), ghz(3), [1,2])
    @test_throws DimensionMismatch reset_qubits!(ghz(3), ghz(4), [1,2,3,4])
    @test_throws DimensionMismatch reset_qubits!(MixedStabilizer(ghz(4)), MixedStabilizer(ghz(3)), [1,2])
    @test_throws DimensionMismatch reset_qubits!(MixedStabilizer(ghz(3)), MixedStabilizer(ghz(4)), [1,2,3,4])
    @test_throws DimensionMismatch reset_qubits!(MixedDestabilizer(ghz(4)), MixedDestabilizer(ghz(3)), [1,2])
    @test_throws DimensionMismatch reset_qubits!(MixedDestabilizer(ghz(3)), MixedDestabilizer(ghz(4)), [1,2,3,4])

    #TODO broken in other ways @test_throws DomainError MixedDestabilizer(Destabilizer(S"XX"))

    @test_throws DomainError 2*P"X"

    @test_throws DimensionMismatch P"X" * S"XX"

    @test_throws ArgumentError one(typeof(T"X"), 1, basis=:U)

    @test_throws ArgumentError SparseGate(random_clifford(2), [1, 2, 3])
    @test_throws ArgumentError apply!(random_stabilizer(2), SparseGate(random_clifford(3), [1, 2, 3]))

    for gt in subtypes(QuantumClifford.AbstractSingleQubitOperator)
        gt == SingleQubitOperator && continue
        @test_throws ArgumentError gt(0)
        @test_throws ArgumentError gt(-1)
    end

    for gt in subtypes(QuantumClifford.AbstractTwoQubitOperator)
        @test_throws ArgumentError gt(0,1)
        @test_throws ArgumentError gt(-1,1)
        @test_throws ArgumentError gt(2,2)
    end

    for m in [sMX,sMZ,sMY,sMRX,sMRZ,sMRY]
        @test_throws ArgumentError m(0)
        @test_throws ArgumentError m(-1)
        @test_throws ArgumentError m(0,1)
        @test_throws ArgumentError m(-1,0)
    end

    @test_throws DimensionMismatch Stabilizer(fill(0x0, 2), Matrix{Bool}([1 0 1;1 1 1; 1 0 1]), Matrix{Bool}([1 0 0;1 1 1;1 0 1]))
    @test_throws DimensionMismatch Stabilizer(fill(0x0, 2), Matrix{Bool}([1 0 1 1 0 0; 1 1 1 1 1 1; 1 0 1 1 0 1]))

end

##
# Extensions
##

# Quantikz in QuantumCliffordQuantikzExt

# Plots in QuantumCliffordPlotsExt

# Makie in QuantumCliffordMakieExt

"""A Makie.jl recipe for pictorial representation of a tableau.

Requires a Makie.jl backend to be loaded, e.g. `using CairoMakie`.

Alternatively, you can use the Plots.jl plotting ecosystem, e.g.
`using Plots; plot(S"XXX ZZZ")`.

Consult the documentation for more details on visualization options."""
function stabilizerplot end
"""A Makie.jl recipe for pictorial representation of a tableau.

Requires a Makie.jl backend to be loaded, e.g. `using CairoMakie`.

Alternatively, you can use the Plots.jl plotting ecosystem, e.g.
`using Plots; plot(S"XXX ZZZ")`.

Consult the documentation for more details on visualization options."""
function stabilizerplot_axis end

using Random: AbstractRNG, GLOBAL_RNG
using AutoHashEquals

"""Supertype of all symbolic operators. Subtype of `AbstractCliffordOperator`"""
abstract type AbstractSymbolicOperator <: AbstractCliffordOperator end
"""Supertype of all single-qubit symbolic operators."""
abstract type AbstractSingleQubitOperator <: AbstractSymbolicOperator end
"""Supertype of all two-qubit symbolic operators."""
abstract type AbstractTwoQubitOperator <: AbstractSymbolicOperator end
"""Supertype of all symbolic single-qubit measurements."""
abstract type AbstractMeasurement <: AbstractOperation end
"""Supertype of all symbolic single-qubit reset measurements"""
abstract type AbstractResetMeasurement <: AbstractOperation end
# Stim has a good list of specialized single and two qubit operations at https://github.com/quantumlib/Stim/blob/e51ea66d213b25920e72c08e53266ec56fd14db4/src/stim/stabilizers/tableau_specialized_prepend.cc
# Note that their specialized operations are for prepends (right multiplications), while we implement append (left multiplication) operations.

@inline getshift(::Type{Tₘₑ},col::Int) where {Tₘₑ} = _mod(Tₘₑ,col-1)
@inline getmask(::Type{Tₘₑ},col::Int) where {Tₘₑ} = Tₘₑ(0x1)<<getshift(Tₘₑ,col)
@inline getbigindex(::Type{Tₘₑ},col::Int) where {Tₘₑ} = _div(Tₘₑ,col-1)+1

TableauType{Tₚᵥ, Tₘₑ} = Tableau{Tₚᵥ, Tₘ} where {Tₘ <: AbstractMatrix{Tₘₑ}}

Base.@propagate_inbounds function getxbit(s::TableauType{Tₚᵥ, Tₘₑ}, r::Int, c::Int) where {Tₚᵥ, Tₘₑ}
    getxbit(s.xzs, r, c)
end
Base.@propagate_inbounds function getzbit(s::TableauType{Tₚᵥ, Tₘₑ}, r::Int, c::Int) where {Tₚᵥ, Tₘₑ}
    getzbit(s.xzs, r, c)
end
Base.@propagate_inbounds function setxbit(s::TableauType{Tₚᵥ, Tₘₑ}, r::Int, c::Int, x::Tₘₑ) where {Tₚᵥ, Tₘₑ}
    setxbit(s.xzs, r, c, x)
end
Base.@propagate_inbounds function setzbit(s::TableauType{Tₚᵥ, Tₘₑ}, r::Int, c::Int, z::Tₘₑ) where {Tₚᵥ, Tₘₑ}
    setzbit(s.xzs, r, c, z)
end
Base.@propagate_inbounds setxbit(s::TableauType{Tₚᵥ, Tₘₑ}, r::Int, c::Int, x::Tₘₑ, shift::Int) where {Tₚᵥ, Tₘₑ} = setxbit(s, r, c, x<<shift)
Base.@propagate_inbounds setzbit(s::TableauType{Tₚᵥ, Tₘₑ}, r::Int, c::Int, z::Tₘₑ, shift::Int) where {Tₚᵥ, Tₘₑ} = setzbit(s, r, c, z<<shift)


Base.@propagate_inbounds function getxbit(xzs::AbstractMatrix{T}, r::Int, c::Int)::T where {T <: Unsigned}
    xzs[QuantumClifford.getbigindex(T, c),r] & QuantumClifford.getmask(T, c)
end
Base.@propagate_inbounds function getzbit(xzs::AbstractMatrix{T}, r::Int, c::Int)::T where {T <: Unsigned}
    xzs[end÷2+QuantumClifford.getbigindex(T, c),r]& QuantumClifford.getmask(T, c)
end
Base.@propagate_inbounds function setxbit(xzs::AbstractMatrix{T}, r::Int, c::Int, x::T) where {T <: Unsigned}
    cbig = QuantumClifford.getbigindex(T, c)
    xzs[cbig,r] &= ~QuantumClifford.getmask(T, c)
    xzs[cbig,r] |= x
end
Base.@propagate_inbounds function setzbit(xzs::AbstractMatrix{T}, r::Int, c::Int, z::T) where {T <: Unsigned}
    cbig = QuantumClifford.getbigindex(T, c)
    xzs[end÷2+cbig,r] &= ~QuantumClifford.getmask(T, c)
    xzs[end÷2+cbig,r] |= z
end
Base.@propagate_inbounds setxbit(xzs::AbstractMatrix{T}, r::Int, c::Int, x::T, shift::Int) where {T <: Unsigned} = setxbit(xzs, r, c, x<<shift)
Base.@propagate_inbounds setzbit(xzs::AbstractMatrix{T}, r::Int, c::Int, z::T, shift::Int) where {T <: Unsigned} = setzbit(xzs, r, c, z<<shift)

##############################
# Single-qubit gates
##############################

function _apply!(stab::AbstractStabilizer, gate::AbstractSingleQubitOperator; phases::Val{B}=Val(true)) where {B}
    s = tab(stab)
    c = gate.q
    @inbounds @simd for r in eachindex(s)
        x = getxbit(s, r, c)
        z = getzbit(s, r, c)
        x,z,phase = qubit_kernel(gate,x,z)
        setxbit(s, r, c, x)
        setzbit(s, r, c, z)
        B && phase && (s.phases[r] = (s.phases[r]+0x2)&3)
    end
    stab
end

function _apply_inv!(stab::AbstractStabilizer, gate::AbstractSingleQubitOperator; phases::Val{B}=Val(true)) where {B} # code repetition with the corresponding `_apply`
    s = tab(stab)
    c = gate.q
    @inbounds @simd for r in eachindex(s)
        x = getxbit(s, r, c)
        z = getzbit(s, r, c)
        x,z,phase = inv_qubit_kernel(gate,x,z)
        setxbit(s, r, c, x)
        setzbit(s, r, c, z)
        B && phase && (s.phases[r] = (s.phases[r]+0x2)&3)
    end
    stab
end

"""Macro used to define single qubit symbolic gates and their `qubit_kernel` methods."""
macro qubitop1(name, kernel, inv_kernel)
    prefixname = Symbol(:s,name)
    docstring = "A \"symbolic\" single-qubit $name. See also: [`SingleQubitOperator`](@ref), [`AbstractSymbolicOperator`](@ref)"
    quote
        struct $(esc(prefixname)) <: AbstractSingleQubitOperator
            q::Int
            $(esc(prefixname))(q) = if q<=0 throw(NoZeroQubit) else new(q) end
        end
        @doc $docstring $prefixname
        @inline $(esc(:qubit_kernel))(::$prefixname, x, z) = $kernel
        @inline $(esc(:inv_qubit_kernel))(::$prefixname, x, z) = $inv_kernel
    end
end

@qubitop1 Hadamard     (z   ,x   , x!=0 && z!=0) (z   ,x   , x!=0 && z!=0)
@qubitop1 HadamardXY   (x   ,x⊻z , x==0 && z!=0) (x   ,x⊻z , x==0 && z!=0)
@qubitop1 HadamardYZ   (x⊻z ,z   , x!=0 && z==0) (x⊻z ,z   , x!=0 && z==0)
@qubitop1 Phase        (x   ,x⊻z , x!=0 && z!=0) (x   ,x⊻z , x!=0 && z==0)
@qubitop1 InvPhase     (x   ,x⊻z , x!=0 && z==0) (x   ,x⊻z , x!=0 && z!=0)
@qubitop1 X            (x   ,z   , z!=0)         (x   ,z   , z!=0)
@qubitop1 Y            (x   ,z   , (x⊻z)!=0)     (x   ,z   , (x⊻z)!=0)
@qubitop1 Z            (x   ,z   , x!=0)         (x   ,z   , x!=0)
@qubitop1 SQRTX        (x⊻z ,z   , x==0 && z!=0) (x⊻z ,z   , x!=0 && z!=0)
@qubitop1 InvSQRTX     (x⊻z ,z   , x!=0 && z!=0) (x⊻z ,z   , x==0 && z!=0)
@qubitop1 SQRTY        (z   ,x   , x!=0 && z==0) (z   ,x   , z!=0 && x==0)
@qubitop1 InvSQRTY     (z   ,x   , z!=0 && x==0) (z   ,x   , x!=0 && z==0)
@qubitop1 CXYZ         (x⊻z ,x   , false)        (z   ,x⊻z , false)
@qubitop1 CZYX         (z   ,x⊻z , false)        (x⊻z ,x   , false)

"""A "symbolic" single-qubit Identity operation.

See also: [`SingleQubitOperator`](@ref)
"""
struct sId1 <: AbstractSingleQubitOperator
    q::Int
    sId1(q) = if q<=0 throw(NoZeroQubit) else new(q) end
end
function _apply!(stab::AbstractStabilizer, ::sId1; phases::Val{B}=Val(true)) where B
    stab
end
function _apply_inv!(stab::AbstractStabilizer, ::sId1; phases::Val{B}=Val(true)) where B
    stab
end

"""A "symbolic" general single-qubit operator which permits faster multiplication than an operator expressed as an explicit tableau.

```jldoctest
julia> op = SingleQubitOperator(2, true, true, true, false, true, true) # Tableau components and phases
SingleQubitOperator on qubit 2
X₁ ⟼ - Y
Z₁ ⟼ - X

julia> typeof(op)
SingleQubitOperator

julia> t_op = CliffordOperator(op, 3) # Transforming it back into an explicit tableau representation (specifying the size)
X₁ ⟼ + X__
X₂ ⟼ - _Y_
X₃ ⟼ + __X
Z₁ ⟼ + Z__
Z₂ ⟼ - _X_
Z₃ ⟼ + __Z

julia> typeof(t_op)
CliffordOperator{QuantumClifford.Tableau{Vector{UInt8}, Matrix{UInt64}}, PauliOperator{Array{UInt8, 0}, Vector{UInt64}}}

julia> CliffordOperator(op, 1, compact=true) # You can also extract just the non-trivial part of the tableau
X₁ ⟼ - Y
Z₁ ⟼ - X
```

See also: [`sHadamard`](@ref), [`sPhase`](@ref), [`sId1`](@ref), [`sX`](@ref), [`sY`](@ref), [`sZ`](@ref), [`CliffordOperator`](@ref)

Or simply consult `subtypes(QuantumClifford.AbstractSingleQubitOperator)` and
`subtypes(QuantumClifford.AbstractTwoQubitOperator)` for a full list.
You can think of the `s` prefix as "symbolic" or "sparse".
"""
@auto_hash_equals struct SingleQubitOperator <: AbstractSingleQubitOperator
    q::Int
    xx::Bool
    xz::Bool
    zx::Bool
    zz::Bool
    px::Bool
    pz::Bool
    SingleQubitOperator(q,args...) = if q<=0 throw(NoZeroQubit) else new(q,args...) end
end
function _apply!(stab::AbstractStabilizer, op::SingleQubitOperator; phases::Val{B}=Val(true)) where B # TODO Generated functions that simplify the whole `if phases` branch might be a good optimization, but a quick benchmark comparing sHadamard to SingleQubitOperator(sHadamard) did not show a worthwhile difference.
    s = tab(stab)
    c = op.q
    Tₘₑ = eltype(s.xzs)
    sh = getshift(Tₘₑ, c)
    xx,zx,xz,zz = Tₘₑ.((op.xx,op.zx,op.xz,op.zz)) .<< sh
    anticom = ~iszero((~zz & xz & ~xx & zx) | ( zz & ~xz & xx & zx) | (zz &  xz & xx & ~zx))
    @inbounds @simd for r in eachindex(s)
        x = getxbit(s, r, c)
        z = getzbit(s, r, c)
        setxbit(s, r, c, (x&xx)⊻(z&zx))
        setzbit(s, r, c, (x&xz)⊻(z&zz))
        if B
            if op.px && ~iszero(x)
                s.phases[r] += 0x2
                s.phases[r] &= 3
            end
            if op.pz && ~iszero(z)
                s.phases[r] += 0x2
                s.phases[r] &= 3
            end
            if ~iszero(x&z) && anticom
                s.phases[r] += 0x2
                s.phases[r] &= 3
            end
        end
    end
    stab
end

SingleQubitOperator(h::sHadamard)           = SingleQubitOperator(h.q, false, true , true , false, false, false)
SingleQubitOperator(p::sPhase)              = SingleQubitOperator(p.q, true , true , false, true , false, false)
SingleQubitOperator(p::sInvPhase)           = SingleQubitOperator(p.q, true , true , false, true , true , false)
SingleQubitOperator(p::sId1)                = SingleQubitOperator(p.q, true , false, false, true , false, false)
SingleQubitOperator(p::sX)                  = SingleQubitOperator(p.q, true , false, false, true , false, true)
SingleQubitOperator(p::sY)                  = SingleQubitOperator(p.q, true , false, false, true , true , true)
SingleQubitOperator(p::sZ)                  = SingleQubitOperator(p.q, true , false, false, true , true , false)
SingleQubitOperator(p::sCXYZ)               = SingleQubitOperator(p.q, true , true , true , false, false, false)
SingleQubitOperator(p::sCZYX)               = SingleQubitOperator(p.q, false, true , true , true , false, false)
SingleQubitOperator(p::sHadamardXY)         = SingleQubitOperator(p.q, true , true , false, true , false, true)
SingleQubitOperator(p::sHadamardYZ)         = SingleQubitOperator(p.q, true , false, true , true , true , false)
SingleQubitOperator(p::sSQRTX)              = SingleQubitOperator(p.q, true , false, true , true , false, true)
SingleQubitOperator(p::sInvSQRTX)           = SingleQubitOperator(p.q, true , false, true , true , false, false)
SingleQubitOperator(p::sSQRTY)              = SingleQubitOperator(p.q, false, true , true , false, true , false)
SingleQubitOperator(p::sInvSQRTY)           = SingleQubitOperator(p.q, false, true , true , false, false, true)
SingleQubitOperator(o::SingleQubitOperator) = o
function SingleQubitOperator(o::SingleQubitOperator, qubit::Int)
    return SingleQubitOperator(qubit, o.xx, o.xz, o.zx, o.zz, o.px, o.pz)
end
function SingleQubitOperator(op::CliffordOperator, qubit)
    nqubits(op)==1 || throw(DimensionMismatch("You are trying to convert a multiqubit `CliffordOperator` into a symbolic `SingleQubitOperator`."))
    SingleQubitOperator(qubit,tab(op)[1,1]...,tab(op)[2,1]...,(~).(iszero.(tab(op).phases))...)
end
SingleQubitOperator(op::CliffordOperator) = SingleQubitOperator(op, 1)

CliffordOperator(op::AbstractSingleQubitOperator, n; kw...) = CliffordOperator(SingleQubitOperator(op), n; kw...)
function CliffordOperator(op::SingleQubitOperator, n; compact=false)
    if compact
        n==1 || throw(ArgumentError("Set `n=1` as a `SingleQubitOperator` being compacted (`compact=true`) has to result in a 1×1 `CliffordOperator`."))
        return CliffordOperator(Tableau([op.px ? 0x2 : 0x0, op.pz ? 0x2 : 0x0],[op.xx op.xz; op.zx op.zz]))
    else
        n >= op.q || throw(DimensionMismatch("Set a larger `n`, otherwise the `SingleQubitOperator` can not fit in the allocated `CliffordOperator`. Use `compact=true` if you want to discard the target index."))
        c = one(CliffordOperator, n)
        c[op.q,op.q] = op.xx, op.xz # TODO define an `embed` helper function
        c[n+op.q,op.q] = op.zx, op.zz
        c.tab.phases[op.q] = op.px ? 0x2 : 0x0 # TODO define a `phasesview` or `phases` helper function
        c.tab.phases[n+op.q] = op.pz ? 0x2 : 0x0
        return c
    end
end

CliffordOperator(::Type{O}) where {O<:AbstractSingleQubitOperator} = CliffordOperator(apply!(one(Destabilizer,1),O(1)))

function Base.show(io::IO, op::AbstractSingleQubitOperator)
    if get(io, :compact, false) | haskey(io, :typeinfo)
        print(io, "$(string(typeof(op)))($(op.q))")
    else
        print(io, "$(string(typeof(op))) on qubit $(op.q)\n")
        show(io, CliffordOperator(op,1;compact=true))
    end
end

"""Random symbolic single-qubit Clifford applied to qubit at index `qubit`.

See also: [`SingleQubitOperator`](@ref), [`random_clifford`](@ref)
"""
function random_clifford1(rng::AbstractRNG, qubit)
    return enumerate_single_qubit_gates(rand(rng,1:6),qubit=qubit,phases=(rand(rng,Bool),rand(rng,Bool)))
end
random_clifford1(qubit) = random_clifford1(GLOBAL_RNG, qubit)

function LinearAlgebra.inv(op::SingleQubitOperator)
    c = LinearAlgebra.inv(CliffordOperator(SingleQubitOperator(op), 1, compact=true))
    return SingleQubitOperator(c, op.q)
end

LinearAlgebra.inv(h::sHadamard)   = sHadamard(h.q)
LinearAlgebra.inv(p::sPhase)      = sInvPhase(p.q)
LinearAlgebra.inv(p::sInvPhase)   = sPhase(p.q)
LinearAlgebra.inv(p::sId1)        = sId1(p.q)
LinearAlgebra.inv(p::sX)          = sX(p.q)
LinearAlgebra.inv(p::sY)          = sY(p.q)
LinearAlgebra.inv(p::sZ)          = sZ(p.q)
LinearAlgebra.inv(p::sHadamardXY) = sHadamardXY(p.q)
LinearAlgebra.inv(p::sHadamardYZ) = sHadamardYZ(p.q)
LinearAlgebra.inv(p::sSQRTX)      = sInvSQRTX(p.q)
LinearAlgebra.inv(p::sInvSQRTX)   = sSQRTX(p.q)
LinearAlgebra.inv(p::sSQRTY)      = sInvSQRTY(p.q)
LinearAlgebra.inv(p::sInvSQRTY)   = sSQRTY(p.q)
LinearAlgebra.inv(p::sCZYX)       = sCXYZ(p.q)
LinearAlgebra.inv(p::sCXYZ)       = sCZYX(p.q)
##############################
# Two-qubit gates
##############################

function _apply!(stab::AbstractStabilizer, gate::AbstractTwoQubitOperator; phases::Val{B}=Val(true)) where {B}
    s = tab(stab)
    q1 = gate.q1
    q2 = gate.q2
    Tₘₑ = eltype(s.xzs)
    shift = getshift(Tₘₑ, q1) - getshift(Tₘₑ, q2)
    @inbounds @simd for r in eachindex(s)
#    for r in eachindex(s)
        x1 = getxbit(s, r, q1)
        z1 = getzbit(s, r, q1)
        x2 = getxbit(s, r, q2)<<shift
        z2 = getzbit(s, r, q2)<<shift
        x1,z1,x2,z2,phase = qubit_kernel(gate,x1,z1,x2,z2) # Most `qubit_kernel` functions are defined by a `qubitop2` macro
        setxbit(s, r, q1, x1, 0)
        setzbit(s, r, q1, z1, 0)
        setxbit(s, r, q2, x2, -shift)
        setzbit(s, r, q2, z2, -shift)
        if B && phase
            s.phases[r] += 0x2
            s.phases[r] &= 3
        end
    end
    stab
end

function _apply_inv!(stab::AbstractStabilizer, gate::AbstractTwoQubitOperator; phases::Val{B}=Val(true)) where {B} # code repetition with the corresponding `_apply`
    s = tab(stab)
    q1 = gate.q1
    q2 = gate.q2
    Tₘₑ = eltype(s.xzs)
    shift = getshift(Tₘₑ, q1) - getshift(Tₘₑ, q2)
    @inbounds @simd for r in eachindex(s)
#    for r in eachindex(s)
        x1 = getxbit(s, r, q1)
        z1 = getzbit(s, r, q1)
        x2 = getxbit(s, r, q2)<<shift
        z2 = getzbit(s, r, q2)<<shift
        x1,z1,x2,z2,phase = inv_qubit_kernel(gate,x1,z1,x2,z2) # Most `inv_qubit_kernel` functions are defined by a `qubitop2` macro
        setxbit(s, r, q1, x1, 0)
        setzbit(s, r, q1, z1, 0)
        setxbit(s, r, q2, x2, -shift)
        setzbit(s, r, q2, z2, -shift)
        if B && phase
            s.phases[r] += 0x2
            s.phases[r] &= 3
        end
    end
    stab
end

"""Macro used to define 2-qubit symbolic gates and their `qubit_kernel` methods."""
macro qubitop2(name, kernel, inv_kernel)
    prefixname = Symbol(:s,name)
    docstring = "A \"symbolic\" $name. See also: [`AbstractSymbolicOperator`](@ref)"
    quote
        struct $(esc(prefixname)) <: AbstractTwoQubitOperator
            q1::Int
            q2::Int
            $(esc(prefixname))(q1,q2) = if q1<=0 || q2<=0 throw(NoZeroQubit) elseif q1==q2 throw(ArgumentError("Failed to create a two qubit gate because the two qubits it acts on have the same index. The qubit indices have to be different.")) else new(q1,q2) end
        end
        @doc $docstring $prefixname
        @inline $(esc(:qubit_kernel))(::$prefixname, x1, z1, x2, z2) = $kernel
        @inline $(esc(:inv_qubit_kernel))(::$prefixname, x1, z1, x2, z2) = $inv_kernel
    end
end
#                 x1   z1      x2      z2
@qubitop2 SWAP   (x2 , z2    , x1    , z1    , false) (x2 , z2    , x1    , z1    , false)

@qubitop2 SWAPCX    (x2    , z2⊻z1 , x2⊻x1 , z1    , ~iszero((x1 & z1 & x2 & z2) | (~x1 & z1 & x2 & ~z2))) (x2⊻x1 , z2    , x1    , z2⊻z1 , ~iszero((x1 & z1 & x2 & z2) | ( x1 &~z1 &~x2 &  z2)))
@qubitop2 InvSWAPCX (x2⊻x1 , z2    , x1    , z2⊻z1 , ~iszero((x1 & z1 & x2 & z2) | ( x1 &~z1 &~x2 &  z2))) (x2    , z2⊻z1 , x2⊻x1 , z1    , ~iszero((x1 & z1 & x2 & z2) | (~x1 & z1 & x2 & ~z2)))

@qubitop2 ISWAP    (x2       , x1⊻z2⊻x2 , x1       , x1⊻x2⊻z1 , ~iszero((x1 & z1 & ~x2) | (~x1 & x2 & z2))) (x2       , x1⊻z2⊻x2 , x1       , x1⊻x2⊻z1 , ~iszero((x1 &~z1 & ~x2) | (~x1 & x2 &~z2)))
@qubitop2 InvISWAP (x2       , x1⊻z2⊻x2 , x1       , x1⊻x2⊻z1 , ~iszero((x1 &~z1 & ~x2) | (~x1 & x2 &~z2))) (x2       , x1⊻z2⊻x2 , x1       , x1⊻x2⊻z1 , ~iszero((x1 & z1 & ~x2) | (~x1 & x2 & z2)))

@qubitop2 CZSWAP (x2    , z2⊻x1 , x1    , x2⊻z1 , ~iszero((x1 & ~z1 & x2 & z2) | (x1 & z1 & x2 & ~z2))) (x2    , z2⊻x1 , x1    , x2⊻z1 , ~iszero((x1 & ~z1 & x2 & z2) | (x1 & z1 & x2 & ~z2)))
@qubitop2 CXSWAP (x2⊻x1 , z2    , x1    , z2⊻z1 , ~iszero((x1 & ~z1 &~x2 & z2) | (x1 & z1 & x2 &  z2))) (x2 , z2⊻z1    , x2⊻x1    , z1 , ~iszero((x1 &  z1 & x2 & z2) | (~x1 & z1 & x2 & ~z2)))

@qubitop2 CNOT   (x1 , z1⊻z2 , x2⊻x1 , z2    , ~iszero( (x1 & z1 & x2 & z2)  | (x1 & z2 &~(z1|x2)) )) (x1 , z1⊻z2 , x2⊻x1 , z2    , ~iszero( (x1 & z1 & x2 & z2)  | (x1 & z2 &~(z1|x2)) ))
@qubitop2 CPHASE (x1 , z1⊻x2 , x2    , z2⊻x1 , ~iszero( (x1 & z1 & x2 &~z2)  | (x1 &~z1 & x2 & z2) )) (x1 , z1⊻x2 , x2    , z2⊻x1 , ~iszero( (x1 & z1 & x2 &~z2)  | (x1 &~z1 & x2 & z2) ))

@qubitop2 ZCX    (x1      , z1⊻z2    , x2⊻x1 , z2      , ~iszero( ((x1 & z2) &~(z1 ⊻ x2)) )) (x1      , z1⊻z2    , x2⊻x1 , z2      , ~iszero( ((x1 & z2) &~(z1 ⊻ x2)) )) # equiv of CNOT[1, 2]
@qubitop2 ZCY    (x1      , x2⊻z1⊻z2 , x2⊻x1 , z2⊻x1   , ~iszero( (x1 & (x2 ⊻ z1) & (x2 ⊻ z2)) )) (x1      , x2⊻z1⊻z2 , x2⊻x1 , z2⊻x1   , ~iszero( (x1 & (x2 ⊻ z1) & (x2 ⊻ z2)) ))
@qubitop2 ZCZ    (x1      , z1⊻x2    , x2    , z2⊻x1   , ~iszero( ((z1 ⊻ z2) & (x1 & x2)) )) (x1      , z1⊻x2    , x2    , z2⊻x1   , ~iszero( ((z1 ⊻ z2) & (x1 & x2)) ))

@qubitop2 XCX    (z2⊻x1   , z1       , x2⊻z1 , z2      , ~iszero( (z1 & z2) & (x1 ⊻ x2) )) (z2⊻x1   , z1       , x2⊻z1 , z2      , ~iszero( (z1 & z2) & (x1 ⊻ x2) ))
@qubitop2 XCY    (x1⊻x2⊻z2, z1       , z1⊻x2 , z2⊻z1   , ~iszero( (z1 & (x2 ⊻ z2) & ~(x2 ⊻ x1)) )) (x1⊻x2⊻z2, z1       , z1⊻x2 , z2⊻z1   , ~iszero( (z1 & (x2 ⊻ z2) & ~(x2 ⊻ x1)) ))
@qubitop2 XCZ    (x1⊻x2   , z1       , x2    , z2⊻z1   , ~iszero( (x2 & z1) & ~(x1 ⊻ z2) )) (x1⊻x2   , z1       , x2    , z2⊻z1   , ~iszero( (x2 & z1) & ~(x1 ⊻ z2) )) # equiv to CNOT[2, 1]

@qubitop2 YCX    (x1⊻z2   , z2⊻z1    , x1⊻z1⊻x2 , z2      , ~iszero( (z2 & (x1 ⊻ z1) & ~(x2 ⊻ x1)) )) (x1⊻z2   , z2⊻z1    , x1⊻z1⊻x2 , z2      , ~iszero( (z2 & (x1 ⊻ z1) & ~(x2 ⊻ x1)) ))
@qubitop2 YCY    (x1⊻z2⊻x2, z1⊻x2⊻z2 , x1⊻x2⊻z1 , x1⊻z1⊻z2, ~iszero( (x1 & ~z1 & ~x2 & z2) | (~x1 & z1 & x2 & ~z2))) (x1⊻z2⊻x2, z1⊻x2⊻z2 , x1⊻x2⊻z1 , x1⊻z1⊻z2, ~iszero( (x1 & ~z1 & ~x2 & z2) | (~x1 & z1 & x2 & ~z2)))
@qubitop2 YCZ    (x1⊻x2   , x2⊻z1    , x2       , z2⊻x1⊻z1, ~iszero( (x2 & (x1 ⊻ z1) & (z2 ⊻ x1)) )) (x1⊻x2   , x2⊻z1    , x2       , z2⊻x1⊻z1, ~iszero( (x2 & (x1 ⊻ z1) & (z2 ⊻ x1)) ))

@qubitop2 ZCrY    (x1, x1⊻z1⊻x2⊻z2, x1⊻x2, x1⊻z2, ~iszero((x1 &~z1 & x2) | (x1 & ~z1 & ~z2) | (x1 & x2 & ~z2))) (x1, x1⊻z1⊻x2⊻z2, x1⊻x2, x1⊻z2, ~iszero((x1 & z1 &~x2) | (x1 &  z1 &  z2) | (x1 &~x2 &  z2)))
@qubitop2 InvZCrY (x1, x1⊻z1⊻x2⊻z2, x1⊻x2, x1⊻z2, ~iszero((x1 & z1 &~x2) | (x1 &  z1 &  z2) | (x1 &~x2 &  z2))) (x1, x1⊻z1⊻x2⊻z2, x1⊻x2, x1⊻z2, ~iszero((x1 &~z1 & x2) | (x1 & ~z1 & ~z2) | (x1 & x2 & ~z2)))

@qubitop2 SQRTZZ    (x1       , x1⊻x2⊻z1 , x2       , x1⊻z2⊻x2 , ~iszero((x1 & z1 & ~x2) | (~x1 & x2 & z2))) (x1       , x1⊻x2⊻z1 , x2       , x1⊻z2⊻x2 , ~iszero((x1 &~z1 & ~x2) | (~x1 & x2 &~z2)))
@qubitop2 InvSQRTZZ (x1       , x1⊻x2⊻z1 , x2       , x1⊻z2⊻x2 , ~iszero((x1 &~z1 & ~x2) | (~x1 & x2 &~z2))) (x1       , x1⊻x2⊻z1 , x2       , x1⊻z2⊻x2 , ~iszero((x1 & z1 & ~x2) | (~x1 & x2 & z2)))

@qubitop2 SQRTXX    (z1⊻z2⊻x1, z1      , z1⊻x2⊻z2, z2      , ~iszero((~x1 & z1 &~z2) | (~z1 &~x2 & z2))) (z1⊻z2⊻x1, z1      , z1⊻x2⊻z2, z2      , ~iszero(( x1 & z1 &~z2) | (~z1 & x2 & z2)))
@qubitop2 InvSQRTXX (z1⊻z2⊻x1, z1      , z1⊻x2⊻z2, z2      , ~iszero(( x1 & z1 &~z2) | (~z1 & x2 & z2))) (z1⊻z2⊻x1, z1      , z1⊻x2⊻z2, z2      , ~iszero((~x1 & z1 &~z2) | (~z1 &~x2 & z2)))

@qubitop2 SQRTYY    (z1⊻x2⊻z2, x1⊻z2⊻x2, x1⊻z1⊻z2, x1⊻x2⊻z1, ~iszero((~x1 &~z1 & x2 &~z2) | ( x1 &~z1 &~x2 &~z2) | ( x1 &~z1 & x2 & z2) | ( x1 & z1 & x2 &~z2))) (z1⊻x2⊻z2, x1⊻z2⊻x2, x1⊻z1⊻z2, x1⊻x2⊻z1, ~iszero(( x1 & z1 &~x2 & z2) | (~x1 & z1 & x2 & z2) | (~x1 & z1 &~x2 &~z2) | (~x1 &~z1 &~x2 & z2)))
@qubitop2 InvSQRTYY (z1⊻x2⊻z2, x1⊻z2⊻x2, x1⊻z1⊻z2, x1⊻x2⊻z1, ~iszero(( x1 & z1 &~x2 & z2) | (~x1 & z1 & x2 & z2) | (~x1 & z1 &~x2 &~z2) | (~x1 &~z1 &~x2 & z2))) (z1⊻x2⊻z2, x1⊻z2⊻x2, x1⊻z1⊻z2, x1⊻x2⊻z1, ~iszero((~x1 &~z1 & x2 &~z2) | ( x1 &~z1 &~x2 &~z2) | ( x1 &~z1 & x2 & z2) | ( x1 & z1 & x2 &~z2)))

#=
To get the boolean formulas for the phase, it is easiest to first write down the truth table for the phase:
for i in 0:15
    s=S"__"
    d=tuple(Bool.(digits(i,base=2,pad=4))...)
    s[1,1]=d[1:2]
    s[1,2]=d[3:4]
    println("$(Int.(d)) $(phases(explicit_tableaux*s)[1]÷2)")
end
Then we can use a truth-table to boolean formula converter, e.g. https://www.dcode.fr/boolean-expressions-calculator
(by just writing the initial unsimplified formula as the OR of all true rows of the table)
=#

function CliffordOperator(op::AbstractTwoQubitOperator, n; compact=false)
    if compact
        n==2 || throw(ArgumentError("Set `n=2` as a `TwoQubitOperator` being compacted (`compact=true`) has to result in a 2×2 `CliffordOperator`."))
        return CliffordOperator(typeof(op))
    else
        n >= max(op.q1,op.q2) || throw(DimensionMismatch("Set a larger `n`, otherwise the `TwoQubitOperator` can not fit in the allocated `CliffordOperator`. Use `compact=true` if you want to discard the target index."))
        c = one(CliffordOperator, n)
        _c = CliffordOperator(typeof(op))
        for (i,q) in ((1,op.q1),(2,op.q2))
            for (ii,qq) in ((1,op.q1),(2,op.q2))
                c[q,qq] = _c[i,ii] # TODO define an `embed` helper function
                c[n+q,qq] = _c[2+i,ii]
            end
            c.tab.phases[q] = _c.tab.phases[i] # TODO define a `phasesview` or `phases` helper function
            c.tab.phases[n+q] = _c.tab.phases[2+i]
        end
        return c
    end
end

CliffordOperator(::Type{O}) where {O<:AbstractTwoQubitOperator} = CliffordOperator(apply!(one(Destabilizer,2),O(1,2)))

function Base.show(io::IO, op::AbstractTwoQubitOperator)
    if get(io, :compact, false) | haskey(io, :typeinfo)
        print(io, "$(string(typeof(op)))($(op.q1),$(op.q2))")
    else
        print(io, "$(string(typeof(op))) on qubit ($(op.q1),$(op.q2))\n")
        show(io, CliffordOperator(op,2;compact=true))
    end
end

LinearAlgebra.inv(op::sSWAP)      = sSWAP(op.q1, op.q2)
LinearAlgebra.inv(op::sCNOT)      = sCNOT(op.q1, op.q2)
LinearAlgebra.inv(op::sCPHASE)    = sCPHASE(op.q1, op.q2)
LinearAlgebra.inv(op::sZCX)       = sZCX(op.q1, op.q2)
LinearAlgebra.inv(op::sZCY)       = sZCY(op.q1, op.q2)
LinearAlgebra.inv(op::sZCZ)       = sZCZ(op.q1, op.q2)
LinearAlgebra.inv(op::sXCX)       = sXCX(op.q1, op.q2)
LinearAlgebra.inv(op::sXCY)       = sXCY(op.q1, op.q2)
LinearAlgebra.inv(op::sXCZ)       = sXCZ(op.q1, op.q2)
LinearAlgebra.inv(op::sYCX)       = sYCX(op.q1, op.q2)
LinearAlgebra.inv(op::sYCY)       = sYCY(op.q1, op.q2)
LinearAlgebra.inv(op::sYCZ)       = sYCZ(op.q1, op.q2)
LinearAlgebra.inv(op::sZCrY)      = sInvZCrY(op.q1, op.q2)
LinearAlgebra.inv(op::sInvZCrY)   = sZCrY(op.q1, op.q2)
LinearAlgebra.inv(op::sSWAPCX)    = sInvSWAPCX(op.q1, op.q2)
LinearAlgebra.inv(op::sInvSWAPCX) = sSWAPCX(op.q1, op.q2)
LinearAlgebra.inv(op::sCZSWAP)    = sCZSWAP(op.q1, op.q2)
LinearAlgebra.inv(op::sCXSWAP)    = sSWAPCX(op.q1, op.q2)
LinearAlgebra.inv(op::sISWAP)     = sInvISWAP(op.q1, op.q2)
LinearAlgebra.inv(op::sInvISWAP)  = sISWAP(op.q1, op.q2)
LinearAlgebra.inv(op::sSQRTZZ)    = sInvSQRTZZ(op.q1, op.q2)
LinearAlgebra.inv(op::sInvSQRTZZ) = sSQRTZZ(op.q1, op.q2)
LinearAlgebra.inv(op::sSQRTXX)    = sInvSQRTXX(op.q1, op.q2)
LinearAlgebra.inv(op::sInvSQRTXX) = sSQRTXX(op.q1, op.q2)
LinearAlgebra.inv(op::sSQRTYY)    = sInvSQRTYY(op.q1, op.q2)
LinearAlgebra.inv(op::sInvSQRTYY) = sSQRTYY(op.q1, op.q2)

##############################
# Functions that perform direct application of common operators without needing an operator instance
##############################
# TODO is there a reason to keep these given that sZ/sX/sY exist?
# TODO currently these are faster than sZ/sX/sY

"""Apply a Pauli Z to the `i`-th qubit of state `s`. You should use `apply!(stab,sZ(i))` instead of this."""
function apply_single_z!(stab::AbstractStabilizer, i)
    s = tab(stab)
    _, ibig, _, ismallm = get_bitmask_idxs(s.xzs,i)
    @inbounds @simd for row in 1:size(s.xzs,2)
        if !iszero(s.xzs[ibig,row] & ismallm)
            s.phases[row] = (s.phases[row]+0x2)&0x3
        end
    end
    stab
end

"""Apply a Pauli X to the `i`-th qubit of state `s`. You should use `apply!(stab,sX(i))` instead of this."""
function apply_single_x!(stab::AbstractStabilizer, i)
    s = tab(stab)
    _, ibig, _, ismallm = get_bitmask_idxs(s.xzs,i)
    @inbounds @simd for row in 1:size(s.xzs,2)
        if !iszero(s.xzs[end÷2+ibig,row] & ismallm)
            s.phases[row] = (s.phases[row]+0x2)&0x3
        end
    end
    stab
end

"""Apply a Pauli Y to the `i`-th qubit of state `s`. You should use `apply!(stab,sY(i))` instead of this."""
function apply_single_y!(stab::AbstractStabilizer, i)
    s = tab(stab)
    _, ibig, _, ismallm = get_bitmask_idxs(s.xzs,i)
    @inbounds @simd for row in 1:size(s.xzs,2)
        if !iszero((s.xzs[ibig,row] & ismallm) ⊻ (s.xzs[end÷2+ibig,row] & ismallm))
            s.phases[row] = (s.phases[row]+0x2)&0x3
        end
    end
    stab
end

##############################
# Measurements
##############################

"""Symbolic single qubit X measurement. See also [`Register`](@ref), [`projectXrand!`](@ref), [`sMY`](@ref), [`sMZ`](@ref)"""
struct sMX <: AbstractMeasurement
    qubit::Int
    bit::Int
    sMX(q, args...) = if q<=0 throw(NoZeroQubit) else new(q,args...) end
end

"""Symbolic single qubit Y measurement. See also [`Register`](@ref), [`projectYrand!`](@ref), [`sMX`](@ref), [`sMZ`](@ref)"""
struct sMY <: AbstractMeasurement
    qubit::Int
    bit::Int
    sMY(q, args...) = if q<=0 throw(NoZeroQubit) else new(q,args...) end
end

"""Symbolic single qubit Z measurement. See also [`Register`](@ref), [`projectZrand!`](@ref), [`sMX`](@ref), [`sMY`](@ref)"""
struct sMZ <: AbstractMeasurement
    qubit::Int
    bit::Int
    sMZ(q, args...) = if q<=0 throw(NoZeroQubit) else new(q,args...) end
end

sMX(i) = sMX(i,0)
sMY(i) = sMY(i,0)
sMZ(i) = sMZ(i,0)
sMX(i,::Nothing) = sMX(i,0)
sMY(i,::Nothing) = sMY(i,0)
sMZ(i,::Nothing) = sMZ(i,0)

function apply!(state::AbstractStabilizer, m::sMX)
    projectXrand!(state,m.qubit)
    state
end
function apply!(state::AbstractStabilizer, m::sMY)
    projectYrand!(state,m.qubit)
    state
end
function apply!(state::AbstractStabilizer, m::sMZ)
    projectZrand!(state,m.qubit)
    state
end
project!(state::AbstractStabilizer, m::sMX) = projectX!(state, m.qubit)
project!(state::AbstractStabilizer, m::sMY) = projectY!(state, m.qubit)
project!(state::AbstractStabilizer, m::sMZ) = projectZ!(state, m.qubit)
projectrand!(state::AbstractStabilizer, m::sMX) = projectXrand!(state, m.qubit)
projectrand!(state::AbstractStabilizer, m::sMY) = projectYrand!(state, m.qubit)
projectrand!(state::AbstractStabilizer, m::sMZ) = projectZrand!(state, m.qubit)

"""Measure a qubit in the Z basis and reset to the |0⟩ state.

!!! warning "It does not trace out the qubit!"
    As described below there is a difference between measuring the qubit (followed by setting it to a given known state)
    and "tracing out" the qubit. By reset here we mean "measuring and setting to a known state", not "tracing out".

```jldoctest
julia> s = MixedDestabilizer(S"XXX ZZI IZZ") # |000⟩+|111⟩
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z__
+ _X_
+ __X
𝒮𝓉𝒶𝒷━
+ XXX
+ ZZ_
+ Z_Z

julia> traceout!(copy(s), 1) # = I⊗(|00⟩⟨00| + |11⟩⟨11|)
𝒟ℯ𝓈𝓉𝒶𝒷
+ _X_
𝒳ₗ━━━
+ _XX
+ Z__
𝒮𝓉𝒶𝒷━
+ _ZZ
𝒵ₗ━━━
+ Z_Z
+ XXX

julia> projectZ!(traceout!(copy(s), 1), 1)[1] # = |000⟩⟨000|+|011⟩⟨011| or |100⟩⟨100|+|111⟩⟨111| (use projectZrand! to actually get a random result)
𝒟ℯ𝓈𝓉𝒶𝒷
+ _X_
+ XXX
𝒳ₗ━━━
+ _XX
𝒮𝓉𝒶𝒷━
+ _ZZ
+ Z__
𝒵ₗ━━━
+ Z_Z

julia> projectZ!(copy(s), 1)[1] # = |000⟩ or |111⟩ (use projectZrand! to actually get a random result)
𝒟ℯ𝓈𝓉𝒶𝒷
+ XXX
+ _X_
+ __X
𝒮𝓉𝒶𝒷━
+ Z__
+ ZZ_
+ Z_Z
```

```julia-repl
julia> apply!(Register(copy(s)), sMRZ(1)) |> quantumstate # |000⟩ or |011⟩, depending on randomization
𝒟ℯ𝓈𝓉𝒶𝒷
+ XXX
+ _X_
+ __X
𝒮𝓉𝒶𝒷━
+ Z__
- ZZ_
- Z_Z
```

See also: [`Reset`](@ref), [`sMZ`](@ref)"""
struct sMRZ <: AbstractResetMeasurement
    qubit::Int
    bit::Int
    sMRZ(q, args...) = if q<=0 throw(NoZeroQubit) else new(q,args...) end
end

"""Measure a qubit in the X basis and reset to the |+⟩ state.

See also: [`sMRZ`](@ref), [`Reset`](@ref), [`sMZ`](@ref)"""
struct sMRX <: AbstractResetMeasurement
    qubit::Int
    bit::Int
    sMRX(q, args...) = if q<=0 throw(NoZeroQubit) else new(q,args...) end
end

"""Measure a qubit in the Y basis and reset to the |i₊⟩ state.

See also: [`sMRZ`](@ref), [`Reset`](@ref), [`sMZ`](@ref)"""
struct sMRY <: AbstractResetMeasurement
    qubit::Int
    bit::Int
    sMRY(q, args...) = if q<=0 throw(NoZeroQubit) else new(q,args...) end
end

sMRX(i) = sMRX(i,0)
sMRY(i) = sMRY(i,0)
sMRZ(i) = sMRZ(i,0)
sMRX(i,::Nothing) = sMRX(i,0)
sMRY(i,::Nothing) = sMRY(i,0)
sMRZ(i,::Nothing) = sMRZ(i,0)

@testitem "Trace" begin
    using Test
    using Random
    using QuantumClifford: stab_looks_good, destab_looks_good, mixed_stab_looks_good, mixed_destab_looks_good

    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.
    @testset "Partial traces" begin
        @testset "ptrace" begin
            for N in test_sizes[3:end]
                for n in [N,rand(N÷4:N÷2)]
                    #@show n
                    to_delete = randperm(N)[1:rand(N÷4:N÷3)]
                    stab0 = random_stabilizer(n, N)
                    stab1 = MixedStabilizer(stab0)
                    stab2 = MixedDestabilizer(stab0)
                    p0, ra, rb = canonicalize!(ptrace(stab0, to_delete), ranks=true)
                    #@show ra, rb
                    p1 = canonicalize!(stabilizerview(ptrace(stab1, to_delete)))
                    p2 = canonicalize!(stabilizerview(ptrace(stab2, to_delete)))
                    @test p0[1:rb] == p1 == p2
                end
            end
        end
        @testset "RREF canonicalization vs manual traceout" begin
            for N in test_sizes
                for n in [N,rand(N÷4:N÷2)]
                    to_delete = randperm(N)[1:rand(N÷4:N÷2)]
                    stab0 = random_stabilizer(n, N)
                    id_paulis = zero(PauliOperator, N)
                    # Trace out by doing projective measurements
                    naive_stab = copy(stab0)
                    for i in to_delete
                        naive_stab, anticom_index, result = project!(naive_stab, single_x(N,i))
                        if anticom_index!=0 && anticom_index<=length(naive_stab)
                            naive_stab[anticom_index] = id_paulis
                        end
                        naive_stab, anticom_index, result = project!(naive_stab, single_z(N,i))
                        if anticom_index!=0 && anticom_index<=length(naive_stab)
                            naive_stab[anticom_index] = id_paulis
                        end
                    end
                    canonicalize!(naive_stab)
                    # Trace out by using the RREF canonical form
                    stab = copy(stab0)
                    stab, last_row = canonicalize_rref!(stab, to_delete)
                    for i in last_row+1:n
                        stab[i] = id_paulis
                    end
                    canonicalize!(stab)
                    # Confirm the results are the same
                    @test stab == naive_stab
                    @test mixed_stab_looks_good(stab[1:last_row])
                    # Check the built-in traceout! functions for this
                    s = traceout!(copy(stab0), to_delete)
                    canonicalize!(s)
                    @test stab == s
                    # On MixedStabilizer instances
                    s = traceout!(MixedStabilizer(copy(stab0), n), to_delete)
                    canonicalize!(s)
                    @test stab[1:last_row] == stabilizerview(s)
                    @test mixed_stab_looks_good(s)
                    # On MixedDestabilizer instances
                    s = traceout!(MixedDestabilizer(copy(stab0)), to_delete)
                    @test mixed_destab_looks_good(s)
                    s = canonicalize!(stabilizerview(s))
                    @test stab[1:last_row] == s
                end
            end
        end
    end
    @testset "Qubit resets" begin
        @test_throws DimensionMismatch reset_qubits!(S"XX YY",S"X",[1,2])
        @test_throws DimensionMismatch reset_qubits!(S"X",S"XX YY",[1,2])
        @test_throws DimensionMismatch reset_qubits!(MixedStabilizer(S"XX YY"),S"X",[1,2])
        @test_throws DimensionMismatch reset_qubits!(MixedStabilizer(S"X"),S"XX YY",[1,2])
        @test_throws DimensionMismatch reset_qubits!(MixedDestabilizer(S"XX YY"),S"X",[1,2])
        @test_throws DimensionMismatch reset_qubits!(MixedDestabilizer(S"X"),S"XX YY",[1,2])
        for N in test_sizes
            for R in [rand(N÷2:N*2÷3), N]
                R > 0 || continue
                s = random_stabilizer(R,N)
                nnew = rand(N÷4:N*2÷3)
                nnew > 0 || continue
                newstate = random_stabilizer(nnew)
                perm = randperm(N)[1:nqubits(newstate)]
                to_trace = setdiff(1:N,perm)
                resetop = Reset(newstate, perm)
                # Testing MixedDestabilizer
                md = MixedDestabilizer(s)
                mdr1 = reset_qubits!(copy(md), newstate,perm)
                @test mixed_destab_looks_good(mdr1)
                mdr2 = reset_qubits!(copy(mdr1),newstate,perm)
                mdro = apply!(copy(md), resetop)
                @test canonicalize!(copy(stabilizerview(mdr1)))==canonicalize!(copy(stabilizerview(mdr2)))==canonicalize!(copy(stabilizerview(mdro)))
                traceout!(mdr2,to_trace)
                mdr2v = stabilizerview(mdr2)
                @test canonicalize!(copy(mdr2v)[:,perm]) == canonicalize!(copy(newstate))
                # Testing MixedStabilizer
                ms = MixedStabilizer(s)
                msr1 = reset_qubits!(copy(ms), newstate,perm)
                @test mixed_stab_looks_good(msr1)
                msr2 = reset_qubits!(copy(msr1),newstate,perm)
                msro = apply!(copy(ms), resetop)
                @test msr1==msr2==msro
                traceout!(msr2,to_trace)
                msr2v = stabilizerview(msr2)
                @test canonicalize!(copy(msr2v)[:,perm]) == canonicalize!(copy(newstate))
                @test canonicalize!(msr2v) == canonicalize!(mdr2v)
                # Testing Stabilizer
                ss = R==N ? s : Stabilizer(tab(MixedStabilizer(s))) # Ensure the tableau is padded with Is
                ssr1 = reset_qubits!(copy(ss), newstate,perm)
                ssr2 = reset_qubits!(copy(ssr1),newstate,perm)
                ssro = apply!(copy(ss), resetop)
                @test canonicalize!(ssr1)==canonicalize!(ssr2)==canonicalize!(ssro)
                traceout!(ssr2,to_trace)
                ssr2v = stabilizerview(ssr2)
                c, x, z = canonicalize!(ssr2v, ranks=true)
                @test canonicalize!(copy(ssr2v)[:,perm])[1:z] == canonicalize!(copy(newstate))
                @test canonicalize!(msr2v) == c[1:z]
                # Compare different datastractures
                @test canonicalize!(copy(stabilizerview(mdr1)))==canonicalize!(copy(stabilizerview(msr1)))==canonicalize!(ssr1[1:rank(mdr1)])
            end
        end
    end
end

"""
$TYPEDSIGNATURES

Compute the distance of a code using mixed integer programming.
See [`QuantumClifford.ECC.DistanceMIPAlgorithm`](@ref) for configuration options.

Computes the minimum Hamming weight of a binary vector `x` by solving an **mixed
integer program (MIP)** that satisfies the following constraints:

- ``\\text{stab} \\cdot x \\equiv 0 \\pmod{2}``: The binary vector `x` must have an
even overlap with each `X`-check of the stabilizer binary representation `stab`.
- ``\\text{logicOp} \\cdot x \\equiv 1 \\pmod{2}``: The binary vector `x` must have
an odd overlap with logical-`X` operator `logicOp` on the `i`-th logical qubit.

Specifically, it calculates the minimum Hamming weight ``d_{Z}`` for the `Z`-type
logical operator. The minimum distance for `X`-type logical operators is the same.

### Background on Minimum Distance

For *classical* codes, the minimum distance, which measures a code's error-correcting
capability, is equivalent to its minimum weight. This can be computed by generating
all possible codewords from combinations of the generator matrix rows, calculating
their weights, and finding the smallest. While accurate, this method takes exponential
time. Vardy [vardy1997intractability](@cite) demonstrated that computing the minimum
distance is *NP-hard*, and the corresponding decision problem is *NP-complete*,
making polynomial-time algorithms unlikely.

For *quantum* codes, classical intuition does not always apply. The minimum distance
is given by the minimum weight of a non-trivial logical operator. This is generally
unrelated to the minimum distance of the corresponding stabilizer code when viewed as
a classical, additive code. White and Grassl [white2006new](@cite) proposed mapping
quantum codes to higher-dimensional classical linear codes. This mapping allows the
minimum distance of the quantum additive code to be inferred from that of the classical
linear code but increases parameters from `n` to `3n` and `d` to `2d`, adding complexity.
Furthermore, once a minimal weight vector is identified, it is essential to verify
whether it belongs to the Pauli group `𝒫ₙ` over `n` qubits [Sabo:2022smk](@cite).

Additionally, to illustrate how classical intuition can be misleading in this context,
consider that the `[[7, 1, 3]]` Steane code has a minimum distance of three, despite all
its elements having a weight of four. This discrepancy occurs because stabilizer codes
are defined by parity-check matrices, while their minimum distances are determined by
the dual [Sabo:2022smk](@cite).

```jldoctest
julia> using QuantumClifford, QuantumClifford.ECC

julia> c = parity_checks(Steane7());

julia> stab_to_gf2(c)
6×14 Matrix{Bool}:
 0  0  0  1  1  1  1  0  0  0  0  0  0  0
 0  1  1  0  0  1  1  0  0  0  0  0  0  0
 1  0  1  0  1  0  1  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  1  1  1  1
 0  0  0  0  0  0  0  0  1  1  0  0  1  1
 0  0  0  0  0  0  0  1  0  1  0  1  0  1

julia> minimum(sum(stab_to_gf2(c), dims=2))
4

julia> distance(Steane7())
3
```

!!! note
    The minimum distance problem for quantum codes is *NP-hard*, and this hardness extends
    to multiplicative and additive approximations, even when restricted to stabilizer or
    CSS codes, with the result established through a reduction from classical problems in
    the CWS framework using a 4-cycle free graph [kapshikar2023hardness](@cite). Despite
    this, methods that improve on brute-force approaches are actively explored.

For a more in-depth background on minimum distance, see Chapter 3 of [Sabo:2022smk](@cite).

### Mixed Integer Programming

The MIP minimizes the Hamming weight `w(x)`, defined as the number of nonzero
elements in `x`, while satisfying the constraints:

```math
\\begin{aligned}
    \\text{Minimize} \\quad & w(x) = \\sum_{i=1}^n x_i, \\\\
    \\text{subject to} \\quad & \\text{stab} \\cdot x \\equiv 0 \\pmod{2}, \\\\
                            & \\text{logicOp} \\cdot x \\equiv 1 \\pmod{2}, \\\\
                            & x_i \\in \\{0, 1\\} \\quad \\text{for all } i.
\\end{aligned}
```

Here:
- ``\\text{stab}`` is the binary matrix representing the stabilizer group.
- ``\\text{logicOp}`` is the binary vector representing the logical-`X` operator.
- `x` is the binary vector (decision variable) being optimized.

The optimal solution ``w_{i}`` for each logical-`X` operator corresponds to the
minimum weight of a Pauli `Z`-type operator satisfying the above conditions.
The `Z`-type distance is given by:

```math
\\begin{aligned}
    d_Z = \\min(w_1, w_2, \\dots, w_k),
\\end{aligned}
```

where `k` is the number of logical qubits.

# Example

A [[40, 8, 5]] 2BGA code with the minimum distance of 5 from
Table 2 of [lin2024quantum](@cite).

```jldoctest jumpexamples
julia> import Hecke: group_algebra, GF, abelian_group, gens; import HiGHS; import JuMP;

julia> using QuantumClifford, QuantumClifford.ECC

julia> l = 10; m = 2;

julia> GA = group_algebra(GF(2), abelian_group([l,m]));

julia> x, s = gens(GA);

julia> A = 1 + x^6;

julia> B = 1 + x^5 + s + x^6 + x + s*x^2;

julia> c = two_block_group_algebra_codes(A,B);

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(40, 8, 5)
```

A [[48, 6, 8]] GB code with the minimum distance of 8 from (A3)
in Appendix B of [panteleev2021degenerate](@cite).

```jldoctest jumpexamples
julia> l = 24;

julia> c1 = generalized_bicycle_codes([0, 2, 8, 15], [0, 2, 12, 17], l);

julia> code_n(c1), code_k(c1), distance(c1, DistanceMIPAlgorithm(solver=HiGHS))
(48, 6, 8)
```

### Applications

Mixed-integer programming (MIP) is applied in quantum error correction,
notably for decoding and minimum distance computation. Some applications
are as follows:

- The first usecase of the MIP approach was the code capacity Most Likely Error (MLE) decoder for color codes introduced in [landahl2011color](@cite).

- For all quantum LDPC codes presented in [panteleev2021degenerate](@cite), the lower and upper bounds on the minimum distance was obtained by reduction to a mixed integer linear program and using the GNU Linear Programming Kit ([makhorin2008glpk](@cite)).

- For all the Bivariate Bicycle (BB) codes presented in [bravyi2024high](@cite), the code distance was calculated using the mixed integer programming approach.

- [lacroix2024scaling](@cite) developed a MLE decoder that finds the most likely chain of Pauli errors given the observed error syndrome by solving a mixed-integer program using `HiGHS` package ([huangfu2018parallelizing](@cite)).

- [cain2025correlateddecodinglogicalalgorithms](@cite) formulate maximum-likelihood decoding as a mixed-integer program maximizing ``\\prod_{j=1}^M p_j^{E_j}(1-p_j)^{1-E_j}`` (where binary variables ``E_j \\in {0,1}`` indicate error occurrence) subject to syndrome constraints, solved optimally via MIP solvers despite its NP-hard complexity.
"""
function distance(code::AbstractECC, alg::DistanceMIPAlgorithm)
    logical_qubits = isnothing(alg.logical_qubit) ? (1:code_k(code)) : (alg.logical_qubit:alg.logical_qubit)
    isnothing(alg.logical_qubit) || (1 <= alg.logical_qubit <= code_k(code)) || throw(ArgumentError("Logical qubit out of range"))
    # Get the appropriate logical operators and matrices based on operator type
    logical_operator_type = alg.logical_operator_type
    l, H, h = if logical_operator_type == :X
        l_val = SparseMatrixCSC{Int, Int}(stab_to_gf2(logx_ops(code)))
        H_val = SparseMatrixCSC{Int, Int}(stab_to_gf2(parity_checks(code)))
        px = parity_matrix_x(code)
        h_val = cat(px, spzeros(Int, size(px, 1), nqubits(code)); dims=2)
        (l_val, H_val, h_val)
    else
        l_val = SparseMatrixCSC{Int, Int}(stab_to_gf2(logz_ops(code)))
        H_val = SparseMatrixCSC{Int, Int}(stab_to_gf2(parity_checks(code)))
        pz = parity_matrix_z(code)
        h_val = cat(spzeros(Int, size(pz, 1), nqubits(code)), pz; dims=2)
        (l_val, H_val, h_val)
    end
    # Calculate weights for each logical qubit
    if alg.opt_summary
        weights = Dict(
            i => (weight=w, summary=s)
            for (i, (w, s)) in (
                (i, _minimum_distance(h, l[i, :], alg.solver.Optimizer, true, alg.time_limit))
                for i in logical_qubits
            )
        )
    else
        weights = Dict(
            i => first(_minimum_distance(h, l[i, :], alg.solver.Optimizer, false, alg.time_limit))
            for i in logical_qubits
        )
    end
    # Return appropriate result based on configuration
    if alg.opt_summary
        min_entry = argmin(x -> x.weight, values(weights))
        return (min_entry.weight, min_entry.summary)
    else
        return minimum(values(weights))
    end
end

"""Computing minimum distance for quantum LDPC codes is a NP-Hard problem,
but we can solve mixed integer program (MIP) for small instance sizes.
inspired from [bravyi2024high](@cite) and [landahl2011color](@cite)."""
function _minimum_distance(hx, lx, opt, opt_summary, time_limit)
    n = size(hx, 2) # number of qubits
    m = size(hx, 1) # number of stabilizers
    # Maximum stabilizer weight
    whx = maximum(sum(hx[i, :] for i in 1:m)) # Maximum row sum of hx
    # Weight of the logical operator
    wlx = count(!iszero, lx) # Count non-zero elements in lx
    # Number of slack variables needed to express orthogonality constraints modulo two
    num_anc_hx = ilog2(whx, RoundUp)
    num_anc_logical = ilog2(wlx, RoundUp)
    num_var = n + m * num_anc_hx + num_anc_logical
    # Let the user choose which MIP solver to use
    model = Model(opt; add_bridges = false) # model
    set_silent(model)
    set_time_limit_sec(model, time_limit)
    @variable(model, x[1:num_var], Bin) # binary variables
    @objective(model, Min, sum(x[i] for i in 1:n)) # objective function
    # Caching weights for orthogonality constraints
    orthogonality_weights = sparsevec(1:m, [Vector{Int}() for _ in 1:m], m)
    # Orthogonality to rows of hx constraints
    for row in 1:m
        weight = spzeros(Int, num_var)
        supp = findnz(hx[row, :])[1] # Non-zero indices in hx[row, :]
             for q in supp
                 weight[q] = 1
             end
             cnt = 1
             for q in 1:num_anc_hx
                 weight[n + (row - 1) * num_anc_hx + q] = -(1 << cnt)
             cnt += 1
         end
         orthogonality_weights[row] = weight # Cache the weight vector
    end
    # Add orthogonality constraints using cached weights
    for row in 1:m
        @constraint(model, sum(orthogonality_weights[row][i] * x[i] for i in 1:num_var) == 0)
    end
    # Odd overlap with lx constraint
    supp = findnz(lx)[1] # Non-zero indices in lx
    weight = spzeros(Int, num_var)
    for q in supp
        weight[q] = 1
    end
    cnt = 1
    for q in 1:num_anc_logical
        weight[n + m * num_anc_hx + q] = -(1 << cnt)
        cnt += 1
    end
    @constraint(model, sum(weight[i] * x[i] for i in 1:num_var) == 1)
    optimize!(model)
    # Ensure the model is solved and feasible
    if !is_solved_and_feasible(model)
        if termination_status(model) == MOI.MEMORY_LIMIT
            throw(ErrorException("Model exceeded memory limits"))
        elseif termination_status(model) == MOI.TIME_LIMIT
            throw(ErrorException("Model exceeded time limit"))
        else
            throw(ErrorException("Model failed to solve: $(termination_status(model))"))
        end
    end
    opt_val = sum(value(x[i]) for i in 1:n)
    opt_summary ? (round(Int, opt_val), solution_summary(model)) : round(Int, opt_val)
end

@testitem "Stabilizer-state metrics match QuantumOpticsBase" begin
    using QuantumClifford
    import QuantumOpticsBase
    using Test

    function signed_stabilizer_group(state)
        group = [zero(PauliOperator, nqubits(state))]
        for generator in stabilizerview(state)
            products = [generator * element for element in group]
            append!(group, products)
        end
        group
    end

    function quantumoptics_density(state)
        density = exp2(-nqubits(state)) * sum(
            QuantumOpticsBase.Operator(pauli)
            for pauli in signed_stabilizer_group(state)
        )
        QuantumOpticsBase.dense(density)
    end

    function quantumoptics_expect(operator_state, state)
        operator = quantumoptics_density(operator_state)
        density = quantumoptics_density(state)
        QuantumOpticsBase.expect(operator, density)
    end

    function quantumoptics_expect(indices, operator_state, state)
        operator = quantumoptics_density(operator_state)
        density = quantumoptics_density(state)
        embedded = QuantumOpticsBase.embed(
            QuantumOpticsBase.basis(density),
            indices,
            operator,
        )
        QuantumOpticsBase.expect(embedded, density)
    end

    function quantumoptics_fidelity(state1, state2)
        density1 = quantumoptics_density(state1)
        density2 = quantumoptics_density(state2)
        QuantumOpticsBase.fidelity(density1, density2)
    end

    @testset "full-system expectation" begin
        pairs = (
            (MixedDestabilizer(S"Z"), MixedDestabilizer(S"Z")),
            (MixedDestabilizer(S"Z"), MixedDestabilizer(S"-Z")),
            (MixedDestabilizer(S"X"), MixedDestabilizer(S"-Y")),
            (MixedDestabilizer(bell()), MixedDestabilizer(S"Z_ _Z")),
            (MixedDestabilizer(S"-YY ZZ"), MixedDestabilizer(bell())),
            (maximally_mixed(1), maximally_mixed(1)),
            (maximally_mixed(2), maximally_mixed(2)),
            (MixedDestabilizer(S"Z_"), MixedDestabilizer(S"-Z_")),
            (MixedDestabilizer(S"Z_"), MixedDestabilizer(S"X_")),
        )

        for (operator_state, state) in pairs
            @test QuantumClifford.expect(operator_state, state) ≈
                real(quantumoptics_expect(operator_state, state)) atol=1e-12
        end
    end

    @testset "ordered subsystem expectation" begin
        asymmetric_operator = MixedDestabilizer(S"Z_ -_Z")
        asymmetric_state = MixedDestabilizer(S"Z__ _Z_ -__Z")
        cases = (
            (1, MixedDestabilizer(S"Z"), MixedDestabilizer(bell())),
            ([1, 3], MixedDestabilizer(bell()), MixedDestabilizer(ghz(3))),
            ([1, 3], asymmetric_operator, asymmetric_state),
            ([3, 1], asymmetric_operator, asymmetric_state),
            ([2], MixedDestabilizer(S"Z"), MixedDestabilizer(S"_Z_")),
        )

        for (indices, operator_state, state) in cases
            @test QuantumClifford.expect(indices, operator_state, state) ≈
                real(quantumoptics_expect(indices, operator_state, state)) atol=1e-12
        end
    end

    @testset "root fidelity" begin
        maximally_mixed_one = maximally_mixed(1)
        rank_one = MixedDestabilizer(S"Z_")
        pairs = (
            (MixedDestabilizer(S"Z"), MixedDestabilizer(S"Z")),
            (MixedDestabilizer(S"Z"), MixedDestabilizer(S"-Z")),
            (MixedDestabilizer(S"Z"), MixedDestabilizer(S"X")),
            (MixedDestabilizer(bell()), MixedDestabilizer(S"Z_ _Z")),
            (MixedDestabilizer(S"-YY ZZ"), MixedDestabilizer(bell())),
            (MixedDestabilizer(S"YY ZZ"), MixedDestabilizer(bell())),
            (MixedDestabilizer(S"Z"), maximally_mixed_one),
            (MixedDestabilizer(S"Z_ _Z"), rank_one),
            (MixedDestabilizer(S"X_ _X"), rank_one),
            (MixedDestabilizer(S"-Z_ _Z"), rank_one),
        )

        for (state1, state2) in pairs
            # QuantumOpticsBase evaluates this through dense matrix square roots.
            @test QuantumClifford.fidelity(state1, state2) ≈
                real(quantumoptics_fidelity(state1, state2)) atol=1e-7
        end
    end
end

#=============================================================================#
# Reasonable size that is generally ideal for most vendors and usecases.
const default_block_size = 256
# Ameliorate overhead and enhance performance by doing more work per thread.
const default_batch_size = 32

# Most ideal type for shared reductions due to avoiding bank conflicts.
const DeviceUnsigned = UInt32

# Keeps function definitions succinct.
const DevicePauliOperator = PauliOperator{T_P, T_XZ} where {
    T_P <: AbstractGPUArray, T_XZ <: AbstractGPUArray
    }
const DeviceTableau = Tableau{T_P, T_XZ} where {
    T_P <: AbstractGPUArray, T_XZ <: AbstractGPUArray
    }
# This is a bit redundant but it keeps the REPL expansions more readable.
const DeviceUnionStabilizer = Union{
    Stabilizer{T}, MixedStabilizer{T}
    } where {
        T_P <: AbstractGPUArray, T_XZ <: AbstractGPUArray,
        T <: Tableau{T_P, T_XZ}
        }
const DeviceUnionDestabilizer = Union{
    Destabilizer{T}, MixedDestabilizer{T}
    } where {
        T_P <: AbstractGPUArray, T_XZ <: AbstractGPUArray,
        T <: Tableau{T_P, T_XZ}
        }
const DeviceAbstractStabilizer = Union{
    Stabilizer{T}, MixedStabilizer{T}, Destabilizer{T}, MixedDestabilizer{T}
    } where {
        T_P <: AbstractGPUArray, T_XZ <: AbstractGPUArray,
        T <: Tableau{T_P, T_XZ}
        }
#=============================================================================#

@testitem "ECC BCH" tags=[:ecc] begin
    using LinearAlgebra
    using QuantumClifford.ECC
    using QuantumClifford.ECC: AbstractECC, BCH, generator_polynomial
    using Nemo: ZZ, residue_ring, matrix, finite_field, GF, minpoly, coeff, lcm, FqPolyRingElem, FqFieldElem, is_zero, degree, defining_polynomial, is_irreducible
    using QuantumClifford.ECC.QECCore: code_k, code_n, distance, rate

    """
    - To prove that `t`-bit error correcting BCH code indeed has minimum distance of at least `2 * t + 1`, it is shown that no `2 * t` or fewer columns of its binary parity check matrix `H` sum to zero. A formal mathematical proof can be found on pages 168 and 169 of Ch6 of Error Control Coding by Lin, Shu and Costello, Daniel.
    - The parameter `2 * t + 1` is usually called the designed distance of the `t`-bit error correcting BCH code.
    """
    function check_designed_distance(matrix, t)
        n_cols = size(matrix, 2)
        for num_cols in 1:2 * t
            for i in 1:n_cols - num_cols + 1
                combo = matrix[:, i:(i + num_cols - 1)]
                sum_cols = sum(combo, dims = 2)
                if all(sum_cols .== 0)
                    return false  # Minimum distance is not greater than `2 * t`.
                end
            end
        end
        return true  # Minimum distance is at least `2 * t + 1`.
    end

    @testset "Testing properties of BCH codes" begin
        m_cases = [3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15]
        for m in m_cases
            n = 2 ^ m - 1
            for t in rand(1:m, 2)
                H = parity_checks(BCH(m, t))
                @test check_designed_distance(H, t) == true
                # n - k == degree of generator polynomial, `g(x)` == rank of binary parity check matrix, `H`.
                mat = matrix(GF(2), parity_checks(BCH(m, t)))
                computed_rank = rank(mat)
                @test computed_rank == degree(generator_polynomial(BCH(m, t)))
                @test code_k(BCH(m, t)) == n - degree(generator_polynomial(BCH(m, t)))
                # BCH code is cyclic as its generator polynomial, `g(x)` divides `xⁿ - 1`, so `mod (xⁿ - 1, g(x))` = 0.
                gx = generator_polynomial(BCH(m, t))
                GF2x, x = GF(2)["x"]
                @test mod(x ^ n - 1, gx) == 0
            end
        end

        #example taken from Ch6 of Error Control Coding by Lin, Shu and Costello, Daniel
        @test parity_checks(BCH(4, 2))  ==    [1  0  0  0  1  0  0  1  1  0  1  0  1  1  1;
                                               0  1  0  0  1  1  0  1  0  1  1  1  1  0  0;
                                               0  0  1  0  0  1  1  0  1  0  1  1  1  1  0;
                                               0  0  0  1  0  0  1  1  0  1  0  1  1  1  1;
                                               1  0  0  0  1  1  0  0  0  1  1  0  0  0  1;
                                               0  0  0  1  1  0  0  0  1  1  0  0  0  1  1;
                                               0  0  1  0  1  0  0  1  0  1  0  0  1  0  1;
                                               0  1  1  1  1  0  1  1  1  1  0  1  1  1  1]

        # Examples taken from https://web.ntpu.edu.tw/~yshan/BCH_code.pdf.
        GF2x, x = GF(2)["x"]
        GF2⁴, a = finite_field(2, 4, "a")
        GF2⁶, b = finite_field(2, 6, "b")
        @test defining_polynomial(GF2x, GF2⁴) ==  x ^ 4 + x + 1
        @test is_irreducible(defining_polynomial(GF2x, GF2⁴)) == true
        @test generator_polynomial(BCH(4, 2)) == x ^ 8 + x ^ 7 +  x ^ 6 +  x ^ 4 + 1
        @test generator_polynomial(BCH(4, 3)) == x ^ 10 + x ^ 8 +  x ^ 5 +  x ^ 4 +  x ^ 2 + x + 1

        # Nemo.jl uses [Conway polynomial](https://en.wikipedia.org/wiki/Conway_polynomial_(finite_fields)), a standard way to represent the primitive polynomial for finite Galois fields `GF(pᵐ)` of degree `m`, where `p` is a prime number.
        # The `GF(2⁶)`'s Conway polynomial is `p(z) = z⁶ + z⁴ + z³ + z + 1`. In contrast, the polynomial given in https://web.ntpu.edu.tw/~yshan/BCH_code.pdf is `p(z) = z⁶ + z + 1`. Because both polynomials are irreducible, they are also primitive polynomials for `GF(2⁶)`.

        test_cases = [(6, 1), (6, 2), (6, 3), (6, 4), (6, 5), (6, 6), (6, 7), (6, 10), (6, 11), (6, 13), (6, 15)]
        @test defining_polynomial(GF2x, GF2⁶) == x ^ 6 + x ^ 4 + x ^ 3 + x + 1
        @test is_irreducible(defining_polynomial(GF2x, GF2⁶)) == true
        for i in 1:length(test_cases)
            m, t = test_cases[i]
            if t == 1
                @test generator_polynomial(BCH(m, t)) == defining_polynomial(GF2x, GF2⁶)
            else
                prev_t = test_cases[i - 1][2]
                @test generator_polynomial(BCH(m, t)) == generator_polynomial(BCH(m, prev_t)) * minpoly(GF2x, b ^ (t + prev_t - (t - prev_t - 1)))
            end
        end

        results = [57 51 45 39 36 30 24 18 16 10 7]
        for (result, (m, t)) in zip(results, test_cases)
            @test code_k(BCH(m, t)) == result
            @test check_designed_distance(parity_checks(BCH(m, t)), t) == true
        end
    end
end

@testitem "ECC code properties" tags=[:ecc, :ecc_base] begin
    using QuantumClifford.ECC
    using QuantumClifford.ECC: AbstractECC

    include("test_ecc_base.jl")

    function is_css_matrix(H)
        nrows, ncols = size(H)
        for i in 1:nrows
            has_x = false
            has_z = false
            for j in 1:ncols
                has_x |= H[i,j][1]
                has_z |= H[i,j][2]
                has_x && has_z && return false
            end
        end
        return true
    end

    @testset "is CSS" begin
        for code in all_testable_code_instances()
            H = parity_checks(code)
            @test iscss(code) in (is_css_matrix(H), nothing)
        end
    end

    @testset "code tableau consistency" begin
        for code in all_testable_code_instances()
            H = parity_checks(code)
            @test nqubits(code) == size(H, 2) == code_n(code)
            @test size(H, 1) == code_s(code)
            @test code_s(code) + code_k(code) >= code_n(code) # possibly exist redundant checks
            _, _, rank = canonicalize!(copy(H), ranks=true)
            @test rank <= size(H, 1)
            @test QuantumClifford.stab_looks_good(copy(H), remove_redundant_rows=true)
        end
    end

    @testset "is degenerate function - test on popular codes" begin
        @test isdegenerate(Shor9()) == true
        @test isdegenerate(Steane7()) == false
        @test isdegenerate(Steane7(), 2) == true
        @test isdegenerate(Bitflip3()) == true
    end
end

using Random: randperm, AbstractRNG, GLOBAL_RNG, rand!
using ILog2
import Nemo

##############################
# Random Paulis
##############################

"""A random Pauli operator on n qubits.

Use `nophase=false` to randomize the phase.
Use `realphase=false` to get operators with phases including ±i.


Optionally, a "flip" probability `p` can be provided specified,
in which case each bit is set to I with probability `1-p` and to
X or Y or Z with probability `p`. Useful for simulating unbiased Pauli noise.

See also [`random_pauli!`](@ref)"""
function random_pauli end
"""An in-place version of [`random_pauli`](@ref)"""
function random_pauli! end


# Modified from `Base` for `BitArray`
@inline _msk_end(::Type{T}, l::Int) where {T<:Unsigned} = ~T(0) >>> _mod(T, -l)

# A mask for the non-coding bits in the last chunk.
@inline _msk_end(P::PauliOperator) = _msk_end(eltype(P.xz), length(P))

# Unset the leftover bits in the data array that don't code the Pauli operator.
@inline function _unset_noncoding_bits!(P::PauliOperator)
    msk = _msk_end(P)
    P.xz[end] &= msk
    P.xz[end÷2] &= msk
    nothing
end

function random_pauli!(rng::AbstractRNG, P::PauliOperator; nophase=true, realphase=true)
    rand!(rng, P.xz)
    _unset_noncoding_bits!(P)
    P.phase[] = nophase ? 0x0 : (realphase ? rand(rng,(0x0,0x2)) : rand(rng,0x0:0x3))
    P
end
random_pauli!(P::PauliOperator; kwargs...) = random_pauli!(GLOBAL_RNG,P; kwargs...)
function random_pauli!(rng::AbstractRNG,P::PauliOperator,p; nophase=true, realphase=true)
    n = nqubits(P)
    p = p/3
    for i in 1:n
        r = rand(rng)
        P[i] = (r<=2p), (p<r<=3p)
    end
    P.phase[] = nophase ? 0x0 : (realphase ? rand(rng,(0x0,0x2)) : rand(rng,0x0:0x3))
    P
end
random_pauli!(P::PauliOperator, p; kwargs...) = random_pauli!(GLOBAL_RNG,P,p; kwargs...)

random_pauli(rng::AbstractRNG,n::Int; kwargs...) = random_pauli!(rng, zero(PauliOperator, n); kwargs...)
random_pauli(n::Int; kwargs...) = random_pauli(GLOBAL_RNG, n; kwargs...)
random_pauli(rng::AbstractRNG,n::Int,p; kwargs...) = random_pauli!(rng, zero(PauliOperator, n),p; kwargs...)
random_pauli(n::Int, p; kwargs...) = random_pauli(GLOBAL_RNG,n,p; kwargs...)

##############################
# Random Binary Matrices
##############################

function random_invertible_gf2(rng::AbstractRNG, n::Int)
    while true
        mat = rand(rng,Bool,n,n)
        gf2_isinvertible(mat) && return mat
    end
end
random_invertible_gf2(n::Int) = random_invertible_gf2(GLOBAL_RNG, n)

##############################
# Random Tableaux and Clifford
##############################

# function random_cnot_clifford(n) = ... #TODO

"""A random Stabilizer/Destabilizer tableau generated by the Bravyi-Maslov Algorithm 2 from [bravyi2020hadamard](@cite).

`random_destabilizer(n)` gives a n-qubit tableau of rank `n`.
`random_destabilizer(r,n)` gives a n-qubit tableau of rank `r`."""
function random_destabilizer(rng::AbstractRNG, n::Int; phases::Bool=true)
    hadamard, perm = quantum_mallows(rng, n)
    had_idxs = findall(i -> hadamard[i], 1:n)

    # delta, delta', gamma, gamma' appear in the canonical form
    # of a Clifford operator (Eq. 3/Theorem 1)
    # delta is unit lower triangular, gamma is symmetric
    F1 = zeros(Int8, 2n, 2n)
    F2 = zeros(Int8, 2n, 2n)
    delta   = @view F1[1:n, 1:n]
    delta_p = @view F2[1:n, 1:n]
    prod   = @view F1[n+1:2n, 1:n]
    prod_p = @view F2[n+1:2n, 1:n]
    gamma   = @view F1[1:n, n+1:2n]
    gamma_p = @view F2[1:n, n+1:2n]
    inv_delta   = @view F1[n+1:2n, n+1:2n]
    inv_delta_p = @view F2[n+1:2n, n+1:2n]
    for i in 1:n
        delta[i,i] = 1
        delta_p[i,i] = 1
        gamma_p[i,i] = rand(rng, 0x0:0x1)::UInt8
    end

    # gamma_ii is zero if h[i] = 0
    for idx in had_idxs
        gamma[idx, idx] = rand(rng, 0x0:0x1)::UInt8
    end

    # gamma' and delta' are unconstrained on the lower triangular
    fill_tril(rng, gamma_p, n, symmetric = true)
    fill_tril(rng, delta_p, n)

    # off diagonal: gamma, delta must obey conditions C1-C5
    for row in 1:n, col in 1:row-1
        if hadamard[row] && hadamard[col]
            gamma[row, col] = gamma[col, row] = rand(rng, 0x0:0x1)::UInt8
            # otherwise delta[row,col] must be zero by C4
            if perm[row] > perm[col]
                 delta[row, col] = rand(rng, 0x0:0x1)::UInt8
            end
        elseif hadamard[row] && (!hadamard[col]) && perm[row] < perm[col]
            # C5 imposes delta[row, col] = 0 for h[row]=1, h[col]=0
            # if perm[row] > perm[col] then C2 imposes gamma[row,col] = 0
            gamma[row, col] = gamma[col, row] = rand(rng, 0x0:0x1)::UInt8
        elseif (!hadamard[row]) && hadamard[col]
            delta[row, col] = rand(rng, 0x0:0x1)::UInt8
            # not sure what condition imposes this
            if perm[row] > perm[col]
                 gamma[row, col] = gamma[col, row] = rand(rng, 0x0:0x1)::UInt8
            end
        elseif (!hadamard[row]) && (!hadamard[col]) && perm[row] < perm[col]
            # C1 imposes gamma[row, col] = 0 for h[row]=h[col] = 0
            # if perm[row] > perm[col] then C3 imposes delta[row,col] = 0
            delta[row, col] = rand(rng, 0x0:0x1)::UInt8
        end
    end

    # now construct the tableau representation for F(I, Gamma, Delta)
    mul!(prod, gamma, delta)
    mul!(prod_p, gamma_p, delta_p)
    inv_delta .= precise_inv(delta')
    inv_delta_p .= precise_inv(delta_p')

    # block matrix form
    F1 .= mod.(F1, 2)
    F2 .= mod.(F2, 2)
    gamma .= 0
    gamma_p .= 0

    # apply qubit permutation S to F2
    perm_inds = vcat(perm, perm .+ n)
    U = F2[perm_inds,:]

    # apply layer of hadamards
    lhs_inds = vcat(had_idxs, had_idxs .+ n)
    rhs_inds = vcat(had_idxs .+ n, had_idxs)
    U[lhs_inds, :] .= U[rhs_inds, :]

    # apply F1
    xzs = mod.(F1 * U,2) .== 1

    # random Pauli matrix just amounts to phases on the stabilizer tableau
    phasesarray::Vector{UInt8} = if phases rand(rng, [0x0,0x2], 2n) else zeros(UInt8, 2n) end
    return Destabilizer(Tableau(phasesarray, xzs))
end
random_destabilizer(n::Int; phases::Bool=true) = random_destabilizer(GLOBAL_RNG, n; phases)
random_destabilizer(rng::AbstractRNG, r::Int, n::Int; phases::Bool=true) = MixedDestabilizer(random_destabilizer(rng,n;phases),r)
random_destabilizer(r::Int, n::Int; phases::Bool=true) = random_destabilizer(GLOBAL_RNG,r,n; phases)

# Reuse memory for faster generation of many random destabilizers
struct RandDestabMemory{N,T<:Integer}
    F1::Matrix{Int8}
    F2::Matrix{Int8}
    hadamard::BitVector
    perm::Vector{T}
    had_idxs::Vector{T}
    perm_inds::Vector{T}
    U::Matrix{Int8}
    xzs::BitMatrix
    phasesarray::Vector{UInt8}
    phase_options::Vector{UInt8}
    arr::Vector{T}
    n::Int64

    function RandDestabMemory(n::Integer)
        T = typeof(n)
        F1 = zeros(Int8, 2n, 2n)
        F2 = zeros(Int8, 2n, 2n)
        hadamard = falses(n)
        perm = zeros(T, n)
        had_idxs = zeros(T, n)
        perm_inds = zeros(T, 2n)
        U = zeros(Int8, 2n, 2n)
        xzs = falses(2n, 2n)
        phasesarray = zeros(UInt8, 2n)
        phase_options = [0x0, 0x2]
        arr = collect(1:n)
        new{n,T}(F1, F2, hadamard, perm, had_idxs, perm_inds, U, xzs, phasesarray, phase_options, arr, n)
    end
end
function _reset!(memory::RandDestabMemory)
    fill!(memory.F1, 0)
    fill!(memory.F2, 0)
    fill!(memory.hadamard, false)
    fill!(memory.perm, 0)
    fill!(memory.had_idxs, 0)
    fill!(memory.perm_inds, 0)
    fill!(memory.U, 0)
    fill!(memory.xzs, false)
    fill!(memory.phasesarray, 0)
    for i in eachindex(memory.arr)
        @inbounds memory.arr[i] = i
    end
end

# Allocation free inverse of upper trinagular int matrix with 1 on diagonal.
function _inv!(inverse, A)
    for i in 2:size(A, 2)
        for j in 1:i-1
            @inbounds factor = A[j, i] # diagonal always 1 => only integers in inverse matrix
            for k in 1:j
                @inbounds inverse[k, i] -= factor * inverse[k, j]
            end
        end
    end
    nothing
end

function random_destabilizer(rng::AbstractRNG, memory::RandDestabMemory; phases::Bool=true)
    n = memory.n
    # reset the working memory
    _reset!(memory)

    hadamard = memory.hadamard
    perm = memory.perm
    _quantum_mallows!(rng, hadamard, perm, memory.arr)
    had_idxs = memory.had_idxs
    j = 1
    for i in eachindex(hadamard)
        @inbounds if hadamard[i]
            @inbounds had_idxs[j] = i
            j += 1
        end
    end

    # delta, delta', gamma, gamma' appear in the canonical form
    # of a Clifford operator (Eq. 3/Theorem 1)
    # delta is unit lower triangular, gamma is symmetric
    F1 = memory.F1
    F2 = memory.F2
    delta = @view F1[1:n, 1:n]
    delta_p = @view F2[1:n, 1:n]
    prod = @view F1[n+1:2n, 1:n]
    prod_p = @view F2[n+1:2n, 1:n]
    gamma = @view F1[1:n, n+1:2n]
    gamma_p = @view F2[1:n, n+1:2n]
    inv_delta = @view F1[n+1:2n, n+1:2n]
    inv_delta_p = @view F2[n+1:2n, n+1:2n]
    for i in 1:n
        delta[i, i] = 1
        delta_p[i, i] = 1
        gamma_p[i, i] = rand(rng, 0x0:0x1)::UInt8
    end

    # gamma_ii is zero if h[i] = 0
    for idx in had_idxs
        if idx != 0
            gamma[idx, idx] = rand(rng, 0x0:0x1)::UInt8
        end
    end

    # gamma' and delta' are unconstrained on the lower triangular
    fill_tril(rng, gamma_p, n, symmetric=true) # I think this should be fill_tril!
    fill_tril(rng, delta_p, n)

    # off diagonal: gamma, delta must obey conditions C1-C5
    for row in 1:n, col in 1:row-1
        if hadamard[row] && hadamard[col]
            gamma[row, col] = gamma[col, row] = rand(rng, 0x0:0x1)::UInt8
            # otherwise delta[row,col] must be zero by C4
            if perm[row] > perm[col]
                delta[row, col] = rand(rng, 0x0:0x1)::UInt8
            end
        elseif hadamard[row] && (!hadamard[col]) && perm[row] < perm[col]
            # C5 imposes delta[row, col] = 0 for h[row]=1, h[col]=0
            # if perm[row] > perm[col] then C2 imposes gamma[row,col] = 0
            gamma[row, col] = gamma[col, row] = rand(rng, 0x0:0x1)::UInt8
        elseif (!hadamard[row]) && hadamard[col]
            delta[row, col] = rand(rng, 0x0:0x1)::UInt8
            # not sure what condition imposes this
            if perm[row] > perm[col]
                gamma[row, col] = gamma[col, row] = rand(rng, 0x0:0x1)::UInt8
            end
        elseif (!hadamard[row]) && (!hadamard[col]) && perm[row] < perm[col]
            # C1 imposes gamma[row, col] = 0 for h[row]=h[col] = 0
            # if perm[row] > perm[col] then C3 imposes delta[row,col] = 0
            delta[row, col] = rand(rng, 0x0:0x1)::UInt8
        end
    end

    # now construct the tableau representation for F(I, Gamma, Delta)
    mul!(prod, gamma, delta)
    mul!(prod_p, gamma_p, delta_p)
    for i in n+1:2n
        @inbounds F1[i, i] = 1
        @inbounds F2[i, i] = 1
    end
    _inv!(inv_delta, delta')
    _inv!(inv_delta_p, delta_p')

    # block matrix form
    F1 .= mod.(F1, 2)
    F2 .= mod.(F2, 2)
    gamma .= 0
    gamma_p .= 0

    # apply qubit permutation S to F2
    perm_inds = memory.perm_inds
    U = memory.U
    for i in 1:n
        @inbounds perm_inds[i] = perm[i]
        @inbounds perm_inds[i+n] = perm[i] + n
    end
    for (i, e) in enumerate(perm_inds)
        for j in 1:2n
            U[i, j] = F2[e, j]
        end
    end

    # apply layer of hadamards
    for i in 1:n
        if had_idxs[i] != 0
            for j in 1:2n
                @inbounds (U[had_idxs[i], j], U[had_idxs[i]+n, j]) = (U[had_idxs[i]+n, j], U[had_idxs[i], j])
            end
        end
    end

    # apply F1
    xzs = memory.xzs
    fill!(F2, 0)
    mul!(F2, F1, U)

    F2 .= mod.(F2, 2)
    xzs .= F2 .== 1

    # random Pauli matrix just amounts to phases on the stabilizer tableau
    phasesarray = memory.phasesarray
    if phases
        for i in 1:2n
            phasesarray[i] = rand(rng, memory.phase_options)
        end
    end

    return Destabilizer(Tableau(phasesarray, xzs))
end



"""A random Clifford operator generated by the Bravyi-Maslov Algorithm 2 from [bravyi2020hadamard](@cite)."""
random_clifford(rng::AbstractRNG, n::Int; phases::Bool=true) = CliffordOperator(random_destabilizer(rng, n; phases))
random_clifford(rng::AbstractRNG, memory::RandDestabMemory; phases::Bool=true) = CliffordOperator(random_destabilizer(rng, memory; phases))
random_clifford(n::Int; phases::Bool=true) = random_clifford(GLOBAL_RNG, n::Int; phases)

"""A random Stabilizer tableau generated by the Bravyi-Maslov Algorithm 2 from [bravyi2020hadamard](@cite)."""
random_stabilizer(rng::AbstractRNG, n::Int; phases::Bool=true) = copy(stabilizerview(random_destabilizer(rng, n; phases))) # TODO be less wasteful: there is no point in creating the whole destabilizer and then just throwing it away
random_stabilizer(n::Int; phases::Bool=true) = random_stabilizer(GLOBAL_RNG, n; phases)
random_stabilizer(rng::AbstractRNG,r::Int,n::Int; phases::Bool=true) = random_stabilizer(rng,n; phases)[randperm(rng,n)[1:r]]
random_stabilizer(r::Int,n::Int; phases::Bool=true) = random_stabilizer(GLOBAL_RNG,n; phases)[randperm(GLOBAL_RNG,n)[1:r]]

"""Inverting a binary matrix: uses floating point for small matrices and Nemo for large matrices."""
function precise_inv(a)::Matrix{UInt8}
    n = size(a,1)
    if n<200
        return UInt8.(mod.(inv(a),0x2))
    else
	    return nemo_inv(a,n)
    end
end

function nemo_inv(a, n)::Matrix{UInt8}
    inverted = inv(Nemo.matrix(Nemo.GF(2),a))
    return collect(UInt8.(inverted.==1)) # maybe there is a better way to do the conversion
end


"""Sample (h, S) from the distribution P_n(h, S) from Bravyi and Maslov Algorithm 1."""
function quantum_mallows(rng::AbstractRNG, n::Int) # each one is benchmarked in benchmarks/quantum_mallows.jl
    arr = collect(1:n)
    hadamard = falses(n)
    perm = zeros(Int64, n)

    return _quantum_mallows!(rng, hadamard, perm, arr)
end

function _quantum_mallows!(
    rng::AbstractRNG,
    hadamard::BitVector,
    perm::Vector{T},
    arr::Vector{T}) where {T<:Integer} # inplace version

    n = length(perm)
    for idx in 1:n
        m = n - idx + 1
        # sample h_i from given prob distribution
        l = sample_geometric_2(rng, 2 * m)
        weight = 2 * m - l
        hadamard[idx] = (weight < m)
        k = weight < m ? weight : 2 * m - weight - 1
        perm[idx] = _popat!(arr, k + 1)
    end
    return hadamard, perm
end

function _popat!(arr, n)
    m = length(arr)
    at = arr[n]

    for i in n:(m-1)
        arr[i] = arr[i+1]
    end

    arr[end] = 0

    return at
end


""" This function samples a number from 1 to `n` where `n >= 1`
    probability of outputting `i` is proportional to `2^i`"""
function sample_geometric_2(rng::AbstractRNG, n::Integer)
    n < 1 && throw(DomainError(n))
    if n<30
        k = rand(rng, 2:UInt(2)^n)
        return ilog2(k, RoundUp)
    elseif n<500
        k = rand(rng)*(2.0^n-1) + 1
        return Int(ceil(log2(k)))
    else
        k = rand(rng, 2:BIG_INT_TWO[]^n)
        return ilog2(k, RoundUp)
    end
end

"""Assign (symmetric) random ints to off diagonals of matrix."""
function fill_tril(rng::AbstractRNG, matrix, n; symmetric::Bool=false)
    # Add (symmetric) random ints to off diagonals
    @inbounds for row in 1:n, col in 1:row-1
        b = rand(rng, Bool)
        matrix[row, col] = b
        if symmetric
            matrix[col, row] = b
        end
    end
    matrix
end

##############################
# Random circuit
##############################

"""
Random brickwork Clifford circuit.

The connectivity of the random circuit is brickwork in some dimensions. Each gate in the circuit is a random 2-qubit Clifford gate.

The brickwork is defined as follows: The qubits are arranged as a lattice, and `lattice_size` contains side length in each dimension.
For example, a chain of length five will have `lattice_size = (5,)`, and a 5×5 lattice will have `lattice_size = (5, 5)`.

In multi-dimensional cases, gate layers act alternatively along each direction.
The nearest two layers along the same direction are offset by one qubit, forming a so-called brickwork.
The boundary condition is chosen as open.
"""
function random_brickwork_clifford_circuit(rng::AbstractRNG, lattice_size::NTuple{N,Int} where {N}, nlayers::Int)
    circ = QuantumClifford.SparseGate[]
    cartesian = CartesianIndices(lattice_size)
    dim = length(lattice_size)
    nqubits = prod(lattice_size)
    working_memory = RandDestabMemory(2)
    for i in 1:nlayers
        gate_direction = (i - 1) % dim + 1
        l = lattice_size[gate_direction]
        brickwise_parity = dim == 1 ? i % 2 : 1 - (i ÷ dim) % 2
        for j in 1:nqubits
            cardj = collect(cartesian[j].I)
            if cardj[gate_direction] % 2 == brickwise_parity && cardj[gate_direction] != l # open boundary
                cardk = cardj
                cardk[gate_direction] = cardk[gate_direction] + 1
                k = LinearIndices(cartesian)[cardk...]
                push!(circ, SparseGate(random_clifford(rng, working_memory), [j, k]))
            end
        end
    end
    circ
end

random_brickwork_clifford_circuit(lattice_size::NTuple{N,Int} where {N}, nlayers::Int) = random_brickwork_clifford_circuit(GLOBAL_RNG, lattice_size, nlayers)

"""
Random all-to-all Clifford circuit.

The circuit contains `nqubits` qubits and `ngates` gates. The connectivity is all to all. Each gate in the circuit is a random 2-qubit Clifford gate on randomly picked two qubits.
"""
function random_all_to_all_clifford_circuit(rng::AbstractRNG, nqubits::Int, ngates::Int)
    circ = QuantumClifford.SparseGate[]
    for i in 1:ngates
        j = rand(1:nqubits)
        k = rand(1:nqubits-1)
        push!(circ, SparseGate(random_clifford(rng, 2), [j, (j + k - 1) % nqubits + 1]))
    end
    circ
end

random_all_to_all_clifford_circuit(nqubits::Int, ngates::Int) = random_all_to_all_clifford_circuit(GLOBAL_RNG, nqubits, ngates)

@testitem "ECC Multivaraite Bicycle" tags=[:ecc, :ecc_bespoke_checks] begin
    using Hecke
    using HiGHS
    using JuMP
    using Hecke: group_algebra, GF, abelian_group, gens
    using QuantumClifford.ECC: two_block_group_algebra_code, code_k, code_n, distance, DistanceMIPAlgorithm

    # Multivariate Bicycle codes taken from Table 1 of [voss2024multivariatebicyclecodes](@cite)
    @testset "Weight-4 QLDPC Codes" begin
        # [[112, 8, 5]]
        l=7; m=8
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = z^2 + z^6
        B = x + x^6
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 112 && code_k(c) == 8
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5

        # [[64, 2, 8]]
        l=8; m=4
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x + x^2
        B = x^3 + y
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 64 && code_k(c) == 2
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8

        # [[72, 2, 8]]
        l=4; m=9
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x + y^2
        B = x^2 + y^2
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 72 && code_k(c) == 2
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8

        # [[96, 2, 8]]
        l=6; m=8
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x^5 + y^6
        B = z + z^4
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 96 && code_k(c) == 2
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8

        # [[112, 2, 10]]
        l=7; m=8
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = z^6 + x^5
        B = z^2 + y^5
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 112 && code_k(c) == 2
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 10

        # [[144, 2, 12]]
        l=8; m=9
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x^3 + y^7
        B = x + y^5
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 144 && code_k(c) == 2
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 12
    end

    @testset "Weight-5 QLDPC Codes" begin
        # [[30, 4, 5]]
        l=3; m=5
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x + z^4
        B = x + y^2 + z^2
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 30 && code_k(c) == 4
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5

        # [[72, 4, 8]]
        l=4; m=9
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x + y^3
        B = x^2 + y + y^2
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 72 && code_k(c) == 4
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8

        # [96, 4, 8]]
        l=8; m=6
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x^6 + x^3
        B = z^5 + x^5 + y
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 96 && code_k(c) == 4
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8
    end

    @testset "Weight-6 QLDPC codes" begin
        # [[30, 6, 4]]
        l=5; m=3
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x^4 + z^3
        B = x^4 + x + z^4 + y
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 30 && code_k(c) == 6
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4

        # [[48, 6, 6]]
        l=4; m=6
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x^2 + y^4
        B = x^3 + z^3 + y^2 + y
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 48 && code_k(c) == 6
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6

        # [[40, 4, 6]]
        l=4; m=5
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x^2 + y
        B = y^4 + y^2 + x^3 + x
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 40 && code_k(c) == 4
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6

        # [[48, 4, 6]]
        l=4; m=6
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x^3 + y^5
        B = x + z^5 + y^5 + y^2
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 48 && code_k(c) == 4
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
    end

    @testset "Weight-7 QLDPC codes" begin
        # [[30, 4, 5]]
        l=5; m=3
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x^4 + x^2
        B = x + x^2 + y + z^2 + z^3
        c = two_block_group_algebra_code(A, B)
        @test code_n(c) == 30 && code_k(c) == 4
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
    end
end

"""
$TYPEDSIGNATURES

Canonicalize a stabilizer (in place).

Assumes the input is a valid stabilizer (all operators commute and have
real phases). It permits redundant generators and identity generators.

```jldoctest
julia> ghz = S"XXXX
               ZZII
               IZZI
               IIZZ";


julia> canonicalize!(ghz)
+ XXXX
+ Z__Z
+ _Z_Z
+ __ZZ

julia> canonicalize!(S"XXXX
                       IZZI
                       IIZZ")
+ XXXX
+ _Z_Z
+ __ZZ
```

Not all rows in the tableau in the next example are independent:

```jldoctest
julia> canonicalize!(S"XXXX
                       ZZII
                       IZZI
                       IZIZ
                       IIZZ")
+ XXXX
+ Z__Z
+ _Z_Z
+ __ZZ
+ ____
```

In cases of lower rank, more advanced tableau structures might be better.
For instance the [`MixedStabilizer`](@ref) or [`MixedDestabilizer`](@ref)
structures (you can read more about them in the [Data Structures section](@ref Choosing-Appropriate-Data-Structure)
of the documentation).

If `phases=false` is set, the canonicalization does not track the phases
in the tableau, leading to significant (constant factor) speedup.

```jldoctest
julia> s = S"-ZX
              XZ"
- ZX
+ XZ

julia> canonicalize!(copy(s), phases=false)
- XZ
+ ZX

julia> canonicalize!(copy(s))
+ XZ
- ZX
```

If `ranks=true` is set, the last pivot indices for the X and Z stage of
the canonicalization are returned as well.

```jldoctest
julia> s = S"XXXX
             ZZII
             IZIZ
             ZIIZ";


julia> _, ix, iz = canonicalize!(s, ranks=true); ix, iz
(1, 3)

julia> s
+ XXXX
+ Z__Z
+ _Z_Z
+ ____
```

Based on [garcia2012efficient](@cite).

See also: [`canonicalize_rref!`](@ref), [`canonicalize_gott!`](@ref)
"""
function canonicalize!(state::AbstractStabilizer; phases::Bool=true, ranks::Bool=false)
    @valbooldispatch _canonicalize!(state; phases=Val(phases), ranks=Val(ranks)) phases ranks
end
function _canonicalize!(state::AbstractStabilizer; phases::Val{Bphases}=Val(true), ranks::Val{Branks}=Val(false)) where {Bphases,Branks}
    tab = stabilizerview(state)
    rows, columns = size(stabilizerview(state))
    i = 1
    for j in 1:columns
        # find first row with X or Y in col `j`
        k = findfirst(ii->tab[ii,j][1],i:rows)
        if k !== nothing
            k += i-1
            rowswap!(state, k, i; phases)
            for m in 1:rows
                if tab[m,j][1] && m!=i # if X or Y
                    mul_left!(state, m, i; phases)
                end
            end
            i += 1
        end
    end
    rx = i
    for j in 1:columns
        # find first row with Z in col `j`
        k = findfirst(ii->tab[ii,j][2],i:rows)
        if k !== nothing
            k += i-1
            rowswap!(state, k, i; phases)
            for m in 1:rows
                if tab[m,j][2] && m!=i # if Z or Y
                    mul_left!(state, m, i; phases)
                end
            end
            i += 1
        end
    end
    if Branks
        return state, rx-1, i-1
    else
        return state
    end
end

"""
$TYPEDSIGNATURES

Canonicalize a stabilizer (in place) along only some columns.

This uses different canonical form from [`canonicalize!`](@ref). It also indexes in
reverse in order to make its use in [`traceout!`](@ref) more efficient.
Its use in `traceout!` is its main application.

It returns the (in place) modified state and the index of the last pivot.

Based on [audenaert2005entanglement](@cite).

See also: [`canonicalize!`](@ref), [`canonicalize_gott!`](@ref)
"""
function canonicalize_rref!(state::AbstractStabilizer, colindices; phases::Bool=true)
    @valbooldispatch _canonicalize_rref!(state, colindices; phases=Val(phases)) phases
end
function _canonicalize_rref!(state::AbstractStabilizer, colindices; phases::Val{B}=Val(true)) where B
    tab = stabilizerview(state)
    rows, columns = size(stabilizerview(state))
    i = rows
    for j in colindices
        k = findfirst(ii->tab[ii,j][1],1:i)
        if k !== nothing
            rowswap!(state, k, i; phases)
            for m in 1:rows
                if tab[m,j][1] && m!=i # if X or Y
                    mul_left!(state, m, i; phases)
                end
            end
            i -= 1
        end
        k = findfirst(ii->tab[ii,j][2],1:i)
        if k !== nothing
            rowswap!(state, k, i; phases)
            for m in 1:rows
                if tab[m,j][2] && m!=i # if Z or Y
                    mul_left!(state, m, i; phases)
                end
            end
            i -= 1
        end
    end
    state, i
end

"""
$TYPEDSIGNATURES
"""
canonicalize_rref!(state::AbstractStabilizer; phases::Bool=true) = canonicalize_rref!(state, 1:nqubits(state); phases=phases)

function gott_standard_form_indices(chunks2D, rows, cols; skip=0)::Tuple{Vector{Int},Int}
    goodindices = Int[]
    j = 1
    r = 1
    for r in skip+1:rows
        i = unsafe_bitfindnext_(chunks2D[:,r],skip+1)
        isnothing(i) && break
        (i ∈ goodindices)::Bool && continue
        push!(goodindices, i)
    end
    rank = length(goodindices)
    if rank>0
        badindices = [r for r in 1+skip:goodindices[end] if !(r ∈ goodindices)]
        return vcat(1:skip, goodindices, badindices, goodindices[end]+1:cols), rank
    else
        return collect(1:cols), rank # without the collect it is not type stable; TODO is the collect making this slow?
    end
end

"""
Inplace Gottesman canonicalization of a tableau.

This uses different canonical form from [`canonicalize!`](@ref).
It is used in the computation of the logical X and Z operators
of a [`MixedDestabilizer`](@ref).

It returns the (in place) modified state, the indices of the last pivot
of both Gaussian elimination steps, and the permutations that have been used
to put the X and Z tableaux in standard form.

Based on [gottesman1997stabilizer](@cite).

See also: [`canonicalize!`](@ref), [`canonicalize_rref!`](@ref)
"""
function canonicalize_gott!(stabilizer::Stabilizer; phases::Bool=true)
    @valbooldispatch _canonicalize_gott!(stabilizer; phases=Val(phases)) phases
end
function _canonicalize_gott!(stabilizer::Stabilizer; phases::Val{B}=Val(true)) where {B}
    xzs = tab(stabilizer).xzs
    rows, columns = size(stabilizer)
    i = 1
    for j in 1:columns
        # find first row with X or Y in col `j`
        k = findfirst(ii->stabilizer[ii,j][1],i:rows)
        if k !== nothing
            k += i-1
            rowswap!(stabilizer, k, i; phases)
            for m in 1:rows
                if stabilizer[m,j][1] && m!=i # if X or Y
                    mul_left!(stabilizer, m, i; phases)
                end
            end
            i += 1
        end
    end
    xperm, r = gott_standard_form_indices((@view xzs[1:end÷2,:]),rows,columns)
    permutesystems!(stabilizer,xperm)
    i = r+1
    for j in r+1:columns
        # find first row with Z in col `j`
        k = findfirst(ii->stabilizer[ii,j][2],i:rows)
        if k !== nothing
            k += i-1
            rowswap!(stabilizer, k, i; phases)
            for m in 1:rows
                if stabilizer[m,j][2] && m!=i # if Z or Y
                    mul_left!(stabilizer, m, i; phases)
                end
            end
            i += 1
        end
    end
    zperm, s = gott_standard_form_indices((@view xzs[end÷2+1:end,:]),rows,columns,skip=r)
    permutesystems!(stabilizer,zperm)
    # we have r+s==rows (or we have trailing rows that are zeroed)
    stabilizer, r, s, xperm, zperm
end


canonicalize!(ps::Base.AbstractVecOrTuple{PauliOperator}, args...; kwargs...) = canonicalize!(Stabilizer(ps), args...; kwargs...)
canonicalize_rref!(ps::Base.AbstractVecOrTuple{PauliOperator}, args...; kwargs...) = canonicalize_rref!(Stabilizer(ps), args...; kwargs...)
canonicalize_gott!(ps::Base.AbstractVecOrTuple{PauliOperator}, args...; kwargs...) = canonicalize_gott!(Stabilizer(ps), args...; kwargs...)

#=============================================================================#
# TODO: include the unsafe functions once the main package establishes them.
import QuantumClifford: mul_left!, mul_right!

# CAUTION: Keep in mind that mutable = order_right_left ? right : left
# TODO: Make the parameters keyword arguments once support becomes available.
KA.@kernel inbounds = true unsafe_indices = true function kernel_mul!(
    mutable_phases, mutable_xzs, @Const(const_xzs),
    ::Val{order_right_left}, ::Val{phases},
    ::Val{block_size}, ::Val{batch_size}
    ) where {order_right_left, phases, block_size, batch_size}

    # unsafe_indices is required for shared_memory_reduce, do this manually.
    begin_i, j_mutable = global_index(
        KA.@index(Group, NTuple), KA.@groupsize(), KA.@index(Local, NTuple)
        )
    stride_i = KA.@uniform (KA.@ndrange()[1])
    j_const = ifelse(size(const_xzs, 2) > 1, j_mutable, 1)
    end_i = KA.@uniform (size(mutable_xzs, 1) >> 1)
    if phases
        low = KA.@uniform (zero(eltype(mutable_xzs)))
        high = KA.@uniform (zero(eltype(mutable_xzs)))
    end

    for (i, _) in zip(begin_i : stride_i : end_i, one(batch_size) : batch_size)
        if order_right_left
            x_left = const_xzs[i, j_const]
            z_left = const_xzs[i + end_i, j_const]
            x_right = mutable_xzs[i, j_mutable]
            z_right = mutable_xzs[i + end_i, j_mutable]
        else
            x_left = mutable_xzs[i, j_mutable]
            z_left = mutable_xzs[i + end_i, j_mutable]
            x_right = const_xzs[i, j_const]
            z_right = const_xzs[i + end_i, j_const]
        end

        x_new = xor(x_left, x_right)
        z_new = xor(z_left, z_right)
        if phases
            xl_zr = x_left & z_right
            merged = xor(xl_zr, z_left & x_right)
            high =
                xor(high, xor(low, x_new, z_new, xl_zr) & merged)
            low = xor(low, merged)
        end

        mutable_xzs[i, j_mutable] = x_new
        mutable_xzs[i + end_i, j_mutable] = z_new
    end

    if phases
        value::DeviceUnsigned = (count_ones(high) << 1) + count_ones(low)
        buffer = KA.@localmem DeviceUnsigned (block_size,)
        index = KA.@index(Local, Linear)
        value = shared_memory_reduce!(+, buffer, value, index, Val(block_size))
        if index == one(index)
            @atomic mutable_phases[j_mutable] += value
        end
    end

end

# CAUTION: Requires either rows(const) == 1 or rows(const) == rows(mutable)
function device_mul!(
    mutable_phases::AbstractGPUArray{<: Unsigned},
    mutable_xzs::AbstractGPUArray{T},
    const_phases::AbstractGPUArray{<: Unsigned},
    const_xzs::AbstractGPUArray{T};
    order_right_left::Val{right_left}, phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    )::Nothing where {T <: Unsigned, right_left, phase_B, block_SZ, batch_SZ}

    backend = KA.get_backend(mutable_xzs)
    dim_x = cld(size(mutable_xzs, 1) >> 1, batch_SZ)
    dim_y = size(mutable_xzs, 2)
    if phase_B
        transform! = kernel_transform!(backend)
        transform!(
            mod_4_sum!, mutable_phases, const_phases; ndrange = dim_y
            )
    end
    mul! = kernel_mul!(backend, (block_SZ, 1))
    mul!(
        mutable_phases, mutable_xzs, const_xzs,
        order_right_left, phases, block_size, batch_size;
        workgroupsize = (block_SZ, 1),
        ndrange = tessellate((dim_x, dim_y), (block_SZ, 1))
        )
    if phase_B
        transform!(
            mod_4_identity!, mutable_phases, nothing; ndrange = dim_y
            )
    end
    return nothing

end

# CAUTION: Meta-programming is utilised to in order to avoid repetition.
for (safe_f_sym, unsafe_f_sym, right_left) in (
    (:mul_left!, :do_mul_left!, true), (:mul_right!, :do_mul_right!, false)
    )

#==============================================================================
RETURNS PAULI OPERATOR
==============================================================================#

# PauliOperator - PauliOperator
@eval @inline function $safe_f_sym(
    u::DevicePauliOperator, v::DevicePauliOperator;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    u.nqubits == v.nqubits || throw(DimensionMismatch(THROW_NQUBITS))
    return $unsafe_f_sym(
        u, v;
        phases = phases, block_size = block_size, batch_size = batch_size
        )

end

@eval @inline function $unsafe_f_sym(
    u::DevicePauliOperator, v::DevicePauliOperator;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    device_mul!(
        u.phase, u.xz, v.phase, v.xz;
        order_right_left = Val($right_left), phases = phases,
        block_size = block_size, batch_size = batch_size
        )
    return u

end

for (T_v_sym, v_tab_sym) in (
    (:DeviceTableau, :v), (:DeviceAbstractStabilizer, :(v.tab))
    )

# PauliOperator - Tableau/AbstractStabilizer[i]
@eval @inline function $safe_f_sym(
    u::DevicePauliOperator, v::$T_v_sym, i::Integer;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    1 <= i <= length($v_tab_sym.phases) || throw(BoundsError(THROW_BOUNDS))
    u.nqubits == $v_tab_sym.nqubits || throw(DimensionMismatch(THROW_NQUBITS))
    return $unsafe_f_sym(
        u, v, i;
        phases = phases, block_size = block_size, batch_size = batch_size
        )

end

@eval @inline function $unsafe_f_sym(
    u::DevicePauliOperator, v::$T_v_sym, i::Integer;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    @inbounds device_mul!(
        u.phase, u.xz,
        (@view $v_tab_sym.phases[i]), (@view $v_tab_sym.xzs[:, i]);
        order_right_left = Val($right_left), phases = phases,
        block_size = block_size, batch_size = batch_size
        )
    return u

end

# Marks the end for (T_v_sym, v_tab_sym)
end

#==============================================================================
RETURNS TABLEAU / ABSTRACT STABILIZER
==============================================================================#

for (T_u_sym, u_tab_sym) in (
    (:DeviceTableau, :u), (:DeviceAbstractStabilizer, :(u.tab))
    )

# Tableau/AbstractStabilizer - PauliOperator
@eval @inline function $safe_f_sym(
    u::$T_u_sym, v::DevicePauliOperator;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    $u_tab_sym.nqubits == v.nqubits || throw(DimensionMismatch(THROW_NQUBITS))
    return $unsafe_f_sym(
        u, v;
        phases = phases, block_size = block_size, batch_size = batch_size
        )

end

@eval @inline function $unsafe_f_sym(
    u::$T_u_sym, v::DevicePauliOperator;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    device_mul!(
        $u_tab_sym.phases, $u_tab_sym.xzs, v.phase, v.xz;
        order_right_left = Val($right_left), phases = phases,
        block_size = block_size, batch_size = batch_size
        )
    return u

end

# Tableau/AbstractStabilizer[i] - PauliOperator
@eval @inline function $safe_f_sym(
    u::$T_u_sym, i::Integer, v::DevicePauliOperator;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    1 <= i <= length($u_tab_sym.phases) || throw(BoundsError(THROW_BOUNDS))
    $u_tab_sym.nqubits == v.nqubits || throw(DimensionMismatch(THROW_NQUBITS))
    return $unsafe_f_sym(
        u, i, v;
        phases = phases, block_size = block_size, batch_size = batch_size
        )

end

@eval @inline function $unsafe_f_sym(
    u::$T_u_sym, i::Integer, v::DevicePauliOperator;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    @inbounds device_mul!(
        (@view $u_tab_sym.phases[i]), (@view $u_tab_sym.xzs[:, i]),
        v.phase, v.xz;
        order_right_left = Val($right_left), phases = phases,
        block_size = block_size, batch_size = batch_size
        )
    return u

end

# CAUTION: (Mixed)Destabilizer is handled separately.
# Tableau/AbstractStabilizer[i] - Self[j]
@eval @inline function $safe_f_sym(
    u::$T_u_sym, i::Integer, j::Integer;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    len = length($u_tab_sym.phases)
    1 <= i <= len && 1 <= j <= len || throw(BoundsError(THROW_BOUNDS))
    return $unsafe_f_sym(
        u, i, j;
        phases = phases, block_size = block_size, batch_size = batch_size
        )

end

@eval @inline function $unsafe_f_sym(
    u::$T_u_sym, i::Integer, j::Integer;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    @inbounds device_mul!(
        (@view $u_tab_sym.phases[i]), (@view $u_tab_sym.xzs[:, i]),
        (@view $u_tab_sym.phases[j]), (@view $u_tab_sym.xzs[:, j]);
        order_right_left = Val($right_left), phases = phases,
        block_size = block_size, batch_size = batch_size
        )
    return u

end

for (T_v_sym, v_tab_sym) in (
    (:DeviceTableau, :v), (:DeviceAbstractStabilizer, :(v.tab))
    )

# Tableau/AbstractStabilizer - Tableau/AbstractStabilizer
@eval @inline function $safe_f_sym(
    u::$T_u_sym, v::$T_v_sym;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    length($u_tab_sym.phases) == length($v_tab_sym.phases) ||
        throw(DimensionMismatch(THROW_SIZE))
    $u_tab_sym.nqubits == $v_tab_sym.nqubits ||
        throw(DimensionMismatch(THROW_NQUBITS))
    return $unsafe_f_sym(
        u, v;
        phases = phases, block_size = block_size, batch_size = batch_size
        )

end

@eval @inline function $unsafe_f_sym(
    u::$T_u_sym, v::$T_v_sym;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    device_mul!(
        $u_tab_sym.phases, $u_tab_sym.xzs, $v_tab_sym.phases, $v_tab_sym.xzs;
        order_right_left = Val($right_left), phases = phases,
        block_size = block_size, batch_size = batch_size
        )
    return u

end

# Tableau/AbstractStabilizer - Tableau/AbstractStabilizer[i]
@eval @inline function $safe_f_sym(
    u::$T_u_sym, v::$T_v_sym, i::Integer;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    1 <= i <= length($v_tab_sym.phases) || throw(BoundsError(THROW_BOUNDS))
    $u_tab_sym.nqubits == $v_tab_sym.nqubits ||
        throw(DimensionMismatch(THROW_NQUBITS))
    return $unsafe_f_sym(
        u, v, i;
        phases = phases, block_size = block_size, batch_size = batch_size
        )

end

@eval @inline function $unsafe_f_sym(
    u::$T_u_sym, v::$T_v_sym, i::Integer;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    @inbounds device_mul!(
        $u_tab_sym.phases, $u_tab_sym.xzs,
        (@view $v_tab_sym.phases[i]), (@view $v_tab_sym.xzs[:, i]);
        order_right_left = Val($right_left), phases = phases,
        block_size = block_size, batch_size = batch_size
        )
    return u

end

# Tableau/AbstractStabilizer[i] - Tableau/AbstractStabilizer[j]
@eval @inline function $safe_f_sym(
    u::$T_u_sym, i::Integer, v::$T_v_sym, j::Integer;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    1 <= i <= length($u_tab_sym.phases) &&
        1 <= j <= length($v_tab_sym.phases) ||
            throw(BoundsError(THROW_BOUNDS))
    $u_tab_sym.nqubits == $v_tab_sym.nqubits ||
        throw(DimensionMismatch(THROW_NQUBITS))
    return $unsafe_f_sym(
        u, i, v, j;
        phases = phases, block_size = block_size, batch_size = batch_size
        )

end

@eval @inline function $unsafe_f_sym(
    u::$T_u_sym, i::Integer, v::$T_v_sym, j::Integer;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    @inbounds device_mul!(
        (@view $u_tab_sym.phases[i]), (@view $u_tab_sym.xzs[:, i]),
        (@view $v_tab_sym.phases[j]), (@view $v_tab_sym.xzs[:, j]);
        order_right_left = Val($right_left), phases = phases,
        block_size = block_size, batch_size = batch_size
        )
    return u

end

# Marks the end for (T_v_sym, v_tab_sym)
end

# Marks the end for (T_u_sym, u_tab_sym)
end

#==============================================================================
RETURNS (MIXED) DESTABILIZER
==============================================================================#

# CAUTION: Requires special handling.
# (Mixed)Destabilizer[i] - Self[j]
@eval @inline function $safe_f_sym(
    u::DeviceUnionDestabilizer, i::Integer, j::Integer;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    len = length(u.tab.phases)
    n = len >> 1
    all(x -> 1 <= x <= len, (i, j, i + n, j + n)) ||
        throw(BoundsError(THROW_BOUNDS))
    return $unsafe_f_sym(
        u, i, j;
        phases = phases, block_size = block_size, batch_size = batch_size
        )

end

@eval @inline function $unsafe_f_sym(
    u::DeviceUnionDestabilizer, i::Integer, j::Integer;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    p, xzs = u.tab.phases, u.tab.xzs
    n = length(p) >> 1
    # Swapping the order of the indices is intentional.
    @inbounds device_mul!(
        (@view p[j]), (@view xzs[:, j]),
        (@view p[i]), (@view xzs[:, i]);
        order_right_left = Val($right_left), phases = Val(false),
        block_size = block_size, batch_size = batch_size
        )
    @inbounds device_mul!(
        (@view p[i + n]), (@view xzs[:, i + n]),
        (@view p[j + n]), (@view xzs[:, j + n]);
        order_right_left = Val($right_left), phases = phases,
        block_size = block_size, batch_size = batch_size
        )
    return u

end

# Marks the end for (safe_f_sym, unsafe_f_sym, right_left)
end
#=============================================================================#

#=============================================================================#
import KernelAbstractions as KA

using Atomix: @atomic
using GPUArraysCore: AbstractGPUArray
# Resolves issue due to KA comparing against the literal Symbol("@Const").
using KernelAbstractions: @Const
using QuantumClifford
# This must be done explicitly as it is not exported.
using QuantumClifford: Tableau
#=============================================================================#

@testitem "Non-Clifford Quantum Optics" begin
    using QuantumClifford
    using QuantumClifford: GeneralizedStabilizer, rowdecompose, PauliChannel, mul_left!, mul_right!, invsparsity, mixed_destab_looks_good
    using QuantumClifford.PauliChannelNonClifford: _projectrand_notnorm
    using LinearAlgebra: tr    
    using QuantumClifford: @S_str, random_stabilizer
    using QuantumOpticsBase
    using Test
    using InteractiveUtils
    using Random

    qo_basis = SpinBasis(1//2)
    qo_tgate = sparse(identityoperator(qo_basis))
    qo_tgate.data[2,2] = exp(im*pi/4)

    @testset "expect" begin
        for s in [S"X", S"Y", S"Z", S"-X", S"-Y", S"-Z"]
            for p in [P"X", P"Y", P"Z", P"-X", P"-Y", P"-Z"]
                gs = GeneralizedStabilizer(s)
                apply!(gs, pcT)
                ρ = dm(qo_tgate*Ket(s))
                @test Operator(gs) ≈ ρ
                @test isapprox(expect(p, gs), expect(Operator(p),ρ); atol=1e-5)
            end
        end

       for _ in 1:4
           for n in 1:1
               i = rand(1:n)
               stab = random_stabilizer(n)
               genstab = GeneralizedStabilizer(stab)
               ket = Ket(stab)
               @test dm(ket) ≈ Operator(stab)
               @test dm(ket) ≈ Operator(genstab)

               pauli = random_pauli(n; nophase=false, realphase=true)
               qo_pauli = Operator(pauli)

               qo_bigtgate = n==1 ? qo_tgate : embed(qo_basis^n, i, qo_tgate)
               bigtgate = embed(n,i, pcT)
               @test qo_bigtgate ≈ Operator(bigtgate)

               for step in 1:4
                   # apply!(ket, qo_bigtgate) TODO implement this API
                   ket = qo_bigtgate*ket
                   apply!(genstab, bigtgate)
                   @test dm(ket) ≈ Operator(genstab)
                   @test isapprox(expect(qo_pauli, ket), expect(pauli, genstab); atol=1e-5)
               end
           end
       end
    end

    @testset "apply!" begin
        for n in [1,2,3] # exponential cost in this term
            s = random_stabilizer(n)
            sm = GeneralizedStabilizer(s)
            @test dm(Ket(s)) ≈ Operator(sm)
            # test clifford gates
            for _ in 1:4
                c = random_clifford(n)
                uc = Operator(c)
                @test uc * Operator(sm) * uc' ≈ Operator(apply!(sm, c)) # sm is modified in place for the next round
            end
            # and now some (repeated) non-clifford ops
            for _ in 1:3 # exponential cost in this term
                i = rand(1:n)
                nc = embed(n, i, pcT)
                apply!(sm, nc) # in-place
                c = random_clifford(n)
                uc = Operator(c)
                @test uc * Operator(sm) * uc' ≈ Operator(apply!(sm, c)) # sm is modified in place for the next round
            end
        end
    end

    @testset "copy and ==" begin
        for n in 1:6
            s = random_stabilizer(n)
            sm = GeneralizedStabilizer(s)
            i = rand(1:n)
            apply!(sm, embed(n, i, pcT))
            smcopy = copy(sm)
            @test smcopy == sm
            nc = embed(n, rand(1:n), pcT)
            @test copy(nc) == nc
        end
    end

    function _projrand(τ,p)
        qo_state = Operator(τ)
        projectrand!(τ, p)[1] # in-place
        qo_state_after_proj = Operator(τ)
        qo_pauli = Operator(p)
        qo_proj1 = (identityoperator(qo_pauli) - qo_pauli)/2
        qo_proj2 = (identityoperator(qo_pauli) + qo_pauli)/2
        result1 = qo_proj1*qo_state*qo_proj1'
        result2 = qo_proj2*qo_state*qo_proj2'
        # Normalize to ensure consistent comparison of the projected state
        norm_qo_state_after_proj = iszero(qo_state_after_proj) ? qo_state_after_proj : qo_state_after_proj/tr(qo_state_after_proj)
        norm_result1 = iszero(result1) ? result1 : result1/tr(result1)
        norm_result2 = iszero(result2) ? result2 : result2/tr(result2)
        return norm_qo_state_after_proj, norm_result1, norm_result2
    end

    @testset "Single-qubit projections using for stabilizer states" begin
        for s in [S"X", S"Y", S"Z", S"-X", S"-Y", S"-Z"]
            for p in [P"X", P"Y", P"Z", P"-X", P"-Y", P"-Z"]
                genstab = GeneralizedStabilizer(s)
                apply!(genstab, pcT) # in-place
                norm_qo_state_after_proj, norm_result1, norm_result2 = _projrand(genstab,p) # in-place
                !(iszero(norm_qo_state_after_proj)) && @test real(tr(norm_qo_state_after_proj)) ≈ 1
                @test invsparsity(projectrand!(genstab, p)[1]) <= invsparsity(genstab) # Λ(χ′) ≤ Λ(χ)
                @test norm_qo_state_after_proj ≈ norm_result2 || norm_qo_state_after_proj ≈ norm_result1
           end
        end
    end

    @testset "Multi-qubit projections using GeneralizedStabilizer for stabilizer states" begin
        for n in 1:4
            for repetition in 1:2
                for state in [Stabilizer, MixedDestabilizer, GeneralizedStabilizer]
                    s = random_stabilizer(n)
                    p = random_pauli(n)
                    τ = state(s)
                    apply!(τ, random_clifford(n)) # in-place
                    norm_qo_state_after_proj, norm_result1, norm_result2 = _projrand(τ,p) # in-place
                    !(iszero(norm_qo_state_after_proj)) && @test real(tr(norm_qo_state_after_proj)) ≈ 1
                    @test norm_qo_state_after_proj ≈ norm_result2 || norm_qo_state_after_proj ≈ norm_result1
                    isa(τ, GeneralizedStabilizer) && @test invsparsity(projectrand!(τ, p)[1]) <= invsparsity(τ) # Λ(χ′) ≤ Λ(χ)
                end
            end
        end
    end

    @testset "The trace Tr[χ′] is the probability of measuring 0 wrt _projectrand_notnorm." begin
        for s in [S"X", S"Y", S"Z", S"-X", S"-Y", S"-Z"]
            for p in [P"X", P"Y", P"Z", P"-X", P"-Y", P"-Z"]
                genstab = GeneralizedStabilizer(s)
                apply!(genstab, pcT)
                # Calculate theoretical probability
                prob1 = (real(expect(p, genstab)) + 1) / 2
                # Perform unnormalized projection and get the updated state
                genstab_proj, _ = _projectrand_notnorm(genstab, p, 0)
                if !isempty(genstab_proj.destabweights)
                    # Calculate trace of χ′
                    trace_χ′ = tr(genstab_proj)
                    # Verify Tr[χ′] equals measurement probability using _projectrand_notnorm
                    @test isapprox(prob1, real(trace_χ′); atol=1e-5)
                else
                    # Verify zero probability case
                    @test isapprox(prob1, 0.0; atol=1e-5)
                end
            end
        end
        # Test non-trivial states
        for n in 2:4
            for trial in 1:4
                s = random_stabilizer(n)
                genstab = GeneralizedStabilizer(s)
                p = random_pauli(n)
                # Apply non-Clifford operations
                for _ in 1:n
                    apply!(genstab, embed(n, rand(1:n), pcT))
                end
                # Calculate theoretical probability
                prob1 = (real(expect(p, genstab)) + 1) / 2
                # Perform unnormalized projection and get the updated state
                genstab_proj, _ = _projectrand_notnorm(genstab, p, 0)
                if !isempty(genstab_proj.destabweights)
                    # Calculate trace of χ′
                    trace_χ′ = tr(genstab_proj)
                    # Verify Tr[χ′] equals measurement probability using _projectrand_notnorm
                    @test isapprox(prob1, real(trace_χ′); atol=1e-5)
                else
                    # Verify zero probability case
                    @test isapprox(prob1, 0.0; atol=1e-5)
                end
            end
        end
    end

    @testset "Multi-qubit projections using GeneralizedStabilizer with multiple non-Clifford gates" begin
        num_trials = 4
        num_qubits = [2,3,4] # exclusively multi-qubit
        for n in num_qubits  # Exponential cost in this term
            for repetition in 1:num_trials
                test_phases = [π/4, π/8, π/2, π, 2π]
                test_gates = [pcPhase, pcRx]
                for ϕ in test_phases
                    for gates in test_gates
                        stab = random_stabilizer(n)
                        pauli = random_pauli(n)
                        genstab = GeneralizedStabilizer(stab)
                        # Apply some (repeated) non-Clifford operations
                        i = rand(1:n)
                        nc = embed(n, i, gates(ϕ))
                        apply!(genstab, nc) # in-place
                        apply!(genstab, nc) # in-place
                        apply!(genstab, nc) # in-place
                        norm_qo_state_after_proj, norm_result1, norm_result2 = _projrand(genstab, pauli)
                        !(iszero(norm_qo_state_after_proj)) && @test real(tr(norm_qo_state_after_proj)) ≈ 1
                        @test norm_qo_state_after_proj ≈ norm_result2 || norm_qo_state_after_proj ≈ norm_result1
                    end
                end
            end
        end

        for j in 1:4
            num_qubits = [2,3,4] # exclusively multi-qubit
            for n in num_qubits # exponential cost in this term
                test_phases = [π/4, π/8, π/2, π, 2π]
                test_gates = [pcPhase, pcRx]
                    for ϕ in test_phases
                        for gates in test_gates
                            genstab = GeneralizedStabilizer(random_stabilizer(n))
                            p = random_pauli(n)
                            for i in 1:n
                                apply!(genstab, embed(n, rand(1:n), gates(ϕ)))
                            end
                            projectrand!(genstab, p)
                            # Check the trace after normalization
                            trace = tr(genstab)
                            !iszero(trace) && @assert trace ≈ 1
                        end
                    end
                end
            end
        end
    end

    @testset "projectrand! gives random results" begin
        s1 = projectrand!(GeneralizedStabilizer(S"X"), P"Z")[1].stab
        @test any(projectrand!(GeneralizedStabilizer(S"X"), P"Z")[1].stab != s1 for _ in 1:10)
    end

    @testset "Tensor products of generalized stabilizers" begin
        num_trials = 3
        num_qubits = [2,3] # exclusively multi-qubit
        test_phases = [π/4, π/8, π/2]
        function apply_random_nc_ops!(genstab, n)
            for _ in 1:rand(1:5)
                for ϕ in test_phases
                    i = rand(1:n)
                    nc = embed(n, i, pcPhase(ϕ))
                    apply!(genstab, nc)
                end
            end
        end
        for n in num_qubits
            for repetition in 1:num_trials
                stab1 = random_stabilizer(n)
                genstab1 = GeneralizedStabilizer(stab1)
                stab2 = random_stabilizer(n)
                genstab2 = GeneralizedStabilizer(stab2)
                destab1 = random_destabilizer(n)
                destab2 = random_destabilizer(n)
                md1 = MixedDestabilizer(destab1)
                md2 = MixedDestabilizer(destab2)
                ms1 = MixedStabilizer(stab1)
                ms2 = MixedStabilizer(stab1)
                # apply some (repeated) non-Clifford operations to genstab1
                apply_random_nc_ops!(genstab1, n)
                apply_random_nc_ops!(genstab2, n)
                for gs in [genstab1, genstab2]
                    for qcstate in [md1, md2, ms1, ms2, stab1, stab2, destab1, destab2, genstab1, genstab2]
                        @test Operator(gs ⊗ qcstate) ≈ Operator(gs) ⊗ Operator(qcstate)
                        @test Operator(qcstate ⊗ gs) ≈ Operator(qcstate) ⊗ Operator(gs)
                    end
                end
                @test Operator(genstab1 ⊗ genstab2) ≈ Operator(genstab1) ⊗ Operator(genstab2)
                @test Operator(genstab2 ⊗ genstab1) ≈ Operator(genstab2) ⊗ Operator(genstab1)
                @test Operator(genstab1 ⊗ genstab1) ≈ Operator(genstab1) ⊗ Operator(genstab1)
                @test Operator(genstab2 ⊗ genstab2) ≈ Operator(genstab2) ⊗ Operator(genstab2)
            end
        end
    end

    @testset "Tensor products between paulichannels and paulis" begin
        num_trials = 3
        num_qubits = [2,3] # exclusively multi-qubit
        test_phases = [π/4, π/8, π/2]
        for n in num_qubits
            for repetition in 1:num_trials
                p = random_pauli(n)
                i = rand(1:n)
                test_gates = [pcPhase, pcRx]
                for ϕ in test_phases
                    for gates in test_gates
                        nc = embed(n, i, gates(ϕ))
                        @test Operator(nc ⊗ p) ≈ Operator(nc) ⊗ Operator(p)
                        @test Operator(nc ⊗ nc) ≈ Operator(nc) ⊗ Operator(nc)
                        @test Operator(nc ⊗ nc ⊗ p) ≈ Operator(nc) ⊗ Operator(nc) ⊗ Operator(p)
                    end
                end
            end
        end
    end

    @testset "smaller test redundant to the ones above" begin
        for n in 1:4
            for rep in 1:2
            test_phases = [π/4, π/8, π/2, π, 2π]
            test_gates = [pcPhase, pcRx]
                for ϕ in test_phases
                    for gates in test_gates
                        s = random_stabilizer(n)
                        g = GeneralizedStabilizer(s)
                        nc = embed(n, rand(1:n), gates(ϕ))
                        p = random_pauli(n; realphase=true)
                        gm, r = projectrand!(copy(g), p)

                        rho = Operator(g)
                        pqo = Operator(p)
                        id = identityoperator(pqo)
                        projp = (pqo+id)/2
                        projm = (-pqo+id)/2

                        @test projp+projm ≈ id

                        rhom = projm*rho*projm'
                        rhop = projp*rho*projp'

                        # @test rhom + rhop ≈ rho

                        @test (expect(p, g)+1)/2 ≈ tr(rhop)

                        gm_notnorm, _ = _projectrand_notnorm(copy(g), p, 0)
                        @test (expect(p, g)+1)/2 ≈ tr(gm_notnorm)

                        @test tr(rhop) ≈ tr(gm_notnorm)

                        if r == 0x2
                            @test rhom / tr(rhom) ≈ Operator(gm)
                        else
                            @test rhop / tr(rhop) ≈ Operator(gm)
                        end
                    end
                end
            end
        end
    end

    @testset "pcPhase" begin
        ref_ph(ϕ) = [1 0; 0 exp(im*ϕ)]
        qo_basis = SpinBasis(1//2)
        Id = identityoperator(qo_basis)
        function qo_ph(ϕ)
            U = copy(sparse(Id))
            U.data[2, 2] = exp(im*ϕ)
            return U
        end
        for _ in 1:5
            ϕ = 2π*rand()
            @test Operator(pcPhase(ϕ)).data ≈ dense(qo_ph(ϕ)).data ≈ ref_ph(ϕ)
        end
        for n in 2:5
            for _ in 1:5
                ϕ = 2π*rand()
                q = rand(1:n)
                qc = dense(Operator(embed(n, q, pcPhase(ϕ)))).data
                basis = tensor([qo_basis for _ in 1:n]...)
                qo = dense(embed(basis, Dict(q => qo_ph(ϕ)))).data
                @test qc ≈ qo
            end
        end
    end
    
    @testset "pcRx" begin
        # from https://en.wikipedia.org/wiki/List_of_quantum_logic_gates#Rotation_operator_gates
        ref_rx(θ) = [cos(θ/2) -im*sin(θ/2); -im*sin(θ/2) cos(θ/2)]
        qo_basis = SpinBasis(1//2)
        Id = identityoperator(qo_basis)
        function qo_rx(θ)
            U = copy(sparse(Id))
            U.data[1,1] = cos(θ/2)
            U.data[1,2] = -im*sin(θ/2)
            U.data[2,1] = -im*sin(θ/2)
            U.data[2,2] = cos(θ/2)
            return U
        end
        for _ in 1:5
            # This rotations have a period of 4π.
            θ = 4π*rand() 
            @test Operator(pcRx(θ)).data ≈ dense(qo_rx(θ)).data ≈ ref_rx(θ)
        end
        for n in 2:5
            for _ in 1:3
                θ = 4π*rand()
                q = rand(1:n)
                qc = dense(Operator(embed(n, q, pcRx(θ)))).data 
                b = tensor([qo_basis for _ in 1:n]...)
                qo = dense(embed(b, Dict(q => qo_rx(θ)))).data
                @test qc ≈ qo
            end
        end
        θ1, θ2 = 2π*rand(), 2π*rand()
        composed = Operator(pcRx(θ1)) * Operator(pcRx(θ2))
        expected = Operator(pcRx(θ1 + θ2))
        @test composed.data ≈ expected.data rtol=1e-10
    end
end

module QuantumCliffordLDPCDecodersExt

import LDPCDecoders
using SparseArrays
using QuantumClifford
using QuantumClifford.ECC
using QECCore
import QuantumClifford.ECC: AbstractSyndromeDecoder, decode, parity_checks

struct BeliefPropDecoder <: AbstractSyndromeDecoder # TODO all these decoders have the same fields, maybe we can factor out a common type
    H
    faults_matrix
    n
    s
    k
    cx
    cz
    bpdecoderx
    bpdecoderz
end

struct BitFlipDecoder <: AbstractSyndromeDecoder # TODO all these decoders have the same fields, maybe we can factor out a common type
    H
    faults_matrix
    n
    s
    k
    cx
    cz
    bfdecoderx
    bfdecoderz
end

function BeliefPropDecoder(c; errorrate=nothing, maxiter=nothing)
    Hx = parity_matrix_x(c)
    Hz = parity_matrix_z(c)
    H = parity_checks(c)
    s, n = size(H)
    _, _, r = canonicalize!(Base.copy(H), ranks=true)
    k = n - r
    cx = size(Hx, 1)
    cz = size(Hz, 1)
    fm = faults_matrix(H)

    isnothing(errorrate) || 0≤errorrate≤1 || error(lazy"BeliefPropDecoder got an invalid error rate argument. `errorrate` must be in the range [0, 1].")
    errorrate = isnothing(errorrate) ? 0.0 : errorrate
    maxiter = isnothing(maxiter) ? n : maxiter
    bpx = LDPCDecoders.BeliefPropagationDecoder(Hx, errorrate, maxiter)
    bpz = LDPCDecoders.BeliefPropagationDecoder(Hz, errorrate, maxiter)

    return BeliefPropDecoder(H, fm, n, s, k, cx, cz, bpx, bpz)
end

function BitFlipDecoder(c; errorrate=nothing, maxiter=nothing)
    Hx = parity_matrix_x(c)
    Hz = parity_matrix_z(c)
    H = parity_checks(c)
    s, n = size(H)
    _, _, r = canonicalize!(Base.copy(H), ranks=true)
    k = n - r
    cx = size(Hx, 1)
    cz = size(Hz, 1)
    fm = faults_matrix(H)

    isnothing(errorrate) || 0≤errorrate≤1 || error(lazy"BitFlipDecoder got an invalid error rate argument. `errorrate` must be in the range [0, 1].")
    errorrate = isnothing(errorrate) ? 0.0 : errorrate
    maxiter = isnothing(maxiter) ? n : maxiter
    bfx = LDPCDecoders.BitFlipDecoder(Hx, errorrate, maxiter)
    bfz = LDPCDecoders.BitFlipDecoder(Hz, errorrate, maxiter)

    return BitFlipDecoder(H, fm, n, s, k, cx, cz, bfx, bfz)
end

parity_checks(d::BeliefPropDecoder) = d.H
parity_checks(d::BitFlipDecoder) = d.H

function decode(d::BeliefPropDecoder, syndrome_sample)
    row_x = @view syndrome_sample[1:d.cx]
    row_z = @view syndrome_sample[d.cx+1:d.cx+d.cz]
    guess_z, success = LDPCDecoders.decode!(d.bpdecoderx, row_x)
    guess_x, success = LDPCDecoders.decode!(d.bpdecoderz, row_z)
    return vcat(guess_x, guess_z)
end

function decode(d::BitFlipDecoder, syndrome_sample)
    row_x = @view syndrome_sample[1:d.cx]
    row_z = @view syndrome_sample[d.cx+1:d.cx+d.cz]
    guess_z, success = LDPCDecoders.decode!(d.bfdecoderx, row_x)
    guess_x, success = LDPCDecoders.decode!(d.bfdecoderz, row_z)
    return vcat(guess_x, guess_z)
end

end

"""A multiqubit operator corresponding to all identities except for Pauli Z at `i`. See also: [`sY`](@ref), [`sMY`](@ref)"""
function single_z(n,i)
    p = zero(PauliOperator, n)
    p[i] = (false, true)
    p
end

"""A multiqubit operator corresponding to all identities except for Pauli X at `i`. See also: [`sX`](@ref), [`sMX`](@ref)"""
function single_x(n,i)
    p = zero(PauliOperator, n)
    p[i] = (true, false)
    p
end

"""A multiqubit operator corresponding to all identities except for Pauli Y at `i`. See also: [`sY`](@ref), [`sMY`](@ref)"""
function single_y(n,i)
    p = zero(PauliOperator, n)
    p[i] = (true, true)
    p
end

_destabilizing_basis(basis) = basis == :X ? :Z : :X

# TODO make faster by using fewer initializations, like in Base.zero
function Base.one(::Type{T}, n::Integer; basis=:Z) where {T<:Tableau}
    if basis==:X
        T(LinearAlgebra.I(n),falses(n,n))
    elseif basis==:Y
        T(LinearAlgebra.I(n),LinearAlgebra.I(n))
    elseif basis==:Z
        T(falses(n,n),LinearAlgebra.I(n))
    else
        throw(ArgumentError("`basis` should be one of :X, :Y, or :Z"))
    end
end
Base.one(::Type{<:Stabilizer}, n; basis=:Z) = Stabilizer(one(Tableau,n; basis)) # TODO make it type preserving
Base.one(s::Stabilizer; basis=:Z) = one(Stabilizer, nqubits(s); basis)
function Base.one(::Type{<:Destabilizer}, n; basis=:Z)
    s = one(Tableau, n; basis=basis)
    d = one(Tableau, n; basis=_destabilizing_basis(basis))
    Destabilizer(vcat(d, s))
end
Base.one(d::Destabilizer; basis=:Z) = one(Destabilizer, nqubits(d); basis=basis)
function Base.one(::Type{<:MixedStabilizer}, r, n; basis=:Z)
    s = one(Stabilizer, n; basis=basis)
    MixedStabilizer(s,r)
end
Base.one(T::Type{<:MixedStabilizer}, r, n, basis) = one(T, r, n; basis=basis)
Base.one(s::MixedStabilizer; basis=:Z) =
    one(MixedStabilizer, rank(s), nqubits(s); basis=basis)
function Base.one(::Type{<:MixedDestabilizer}, r, n; basis=:Z)
    s = one(Tableau, n; basis=basis)
    d = one(Tableau, n; basis=_destabilizing_basis(basis))
    MixedDestabilizer(vcat(d,s),r)
end
Base.one(T::Type{<:MixedDestabilizer}, n; basis=:Z) = one(T, n, n; basis=basis)
Base.one(d::MixedDestabilizer; basis=:Z) =
    one(MixedDestabilizer, rank(d), nqubits(d); basis=basis)
function Base.one(c::CliffordOperator)
    n = nqubits(c)
    one(typeof(c),n)
end
Base.one(::Type{<:CliffordOperator}, n) = CliffordOperator(one(Destabilizer,n))

"""Prepare one or more Bell pairs (with optional phases).

```jldoctest
julia> bell()
+ XX
+ ZZ

julia> bell(2)
+ XX__
+ ZZ__
+ __XX
+ __ZZ

julia> bell((true, false))
- XX
+ ZZ

julia> bell([true, false, true, true])
- XX__
+ ZZ__
- __XX
- __ZZ
```
"""
function bell end

function bell()
    copy(S"XX
           ZZ")
end

function bell(n::Int; localorder=false)
    if localorder
        return bell_local(n)
    else
        return tensor_pow(bell(), n)
    end
end

function bell_local(n)
    s = zero(Stabilizer, 2n)
    for i in 1:n
        s[i,i] = s[i,i+n] = (true, false)
        s[i+n,i] = s[i+n,i+n] = (false, true)
    end
    s
end

function bell(phase::Tuple{Bool, Bool})
    s = bell()
    phases(s)[1] = phase[1] ? 0x2 : 0x0
    phases(s)[2] = phase[2] ? 0x2 : 0x0
    s
end

function bell(phases::AbstractVector{Tuple{Bool, Bool}})
    ⊗((bell(t) for t in phases)...)
end

function bell(bellphases::AbstractVector{Bool})
    s = bell(length(bellphases)÷2)
    for i in 1:length(s)
        phases(s)[i] = bellphases[i] ? 0x2 : 0x0
    end
    s
end

"""
Prepare a GHZ state of n qubits.

```jldoctest
julia> ghz()
+ XXX
+ ZZ_
+ _ZZ

julia> ghz(2)
+ XX
+ ZZ

julia> ghz(4)
+ XXXX
+ ZZ__
+ _ZZ_
+ __ZZ
```
"""
function ghz end

function ghz()
    copy(S"XXX
           ZZI
           IZZ")
end

function ghz(n::Int)
    s = zero(Stabilizer, n)
    for i in 1:n
        s[1,i] = (true,false)
    end
    for i in 2:n
        s[i,i] = (false,true)
        s[i,i-1] = (false,true)
    end
    s
end

"""
Prepare a maximally mixed state of n qubits.
"""
function maximally_mixed(n)
    tab = vcat(one(Stabilizer,n; basis=:X).tab, one(Stabilizer,n; basis=:Z).tab)
    return MixedDestabilizer(tab, 0)
end

# TODO document these explicitly
# TODO cluster states, toric code, planar code, other codes from python libraries

module NoisyCircuits

#TODO permit the use of alternative RNGs

using QuantumClifford
using QuantumClifford: AbstractQCState, AbstractStabilizer, AbstractOperation, AbstractMeasurement, AbstractCliffordOperator, apply_single_x!, apply_single_y!, apply_single_z!, registered_statuses
import QuantumClifford: applywstatus!, affectedqubits, applybranches, applynoise_branches

using Combinatorics: combinations
using Base.Cartesian

export NoisyBellMeasurement,
       DecisionGate, ConditionalGate

#TODO all these structs should use specified types
#TODO all of the methods should better specified type signatures
#TODO measure allocation in various apply* methods and verify it is not superfluous

"""A Bell measurement in which each of the measured qubits has a chance to have flipped."""
struct NoisyBellMeasurement{T} <: AbstractOperation
    meas::AbstractOperation
    flipprob::T
end
NoisyBellMeasurement(p,i,fp) = NoisyBellMeasurement(BellMeasurement(p,i),fp)

"""A conditional gate that either performs `truegate` or `falsegate`, depending on the value of `controlbit`."""
struct ConditionalGate <: AbstractOperation
    truegate::AbstractOperation
    falsegate::AbstractOperation
    controlbit::Int
end

"""A conditional gate that performs one of the `gates`, depending on the output of `decisionfunction` applied to the entire classical bit register."""
struct DecisionGate <: AbstractOperation
    gates::AbstractVector{AbstractOperation}
    decisionfunction
end

function applywstatus!(s::AbstractQCState, m::NoisyBellMeasurement)
    state, status = applywstatus!(s,m.meas)
    nqubits = length(affectedqubits(m))
    errprob = (1-(1-2*m.flipprob)^nqubits)/2 # probability of odd number of flips
    if rand()<errprob
        return state, status==continue_stat ? failure_stat : continue_stat
    else
        return state, status
    end
end

function applybranches(s::AbstractQCState, m::NoisyBellMeasurement; max_order=1)
    measurement_branches = applybranches(s, m.meas, max_order=max_order)
    if max_order==0
        return measurement_branches
    else
        new_branches = []
        nqubits = length(affectedqubits(m))
        p = (1-2m.flipprob)^nqubits
        errprob = 1//2*(1-p)
        sucprob = 1//2*(1+p)
        for (mstate, success, mprob, morder) in measurement_branches
            push!(new_branches, (mstate, success, mprob*sucprob, morder))
            push!(new_branches, (mstate, success==continue_stat ? failure_stat : continue_stat, mprob*errprob, morder+1))
        end
        return new_branches
    end
end

# TODO tests for this
function QuantumClifford.apply!(state::Register, op::ConditionalGate)
    if state.bits[op.controlbit]
        apply!(state, op.truegate)
    else
        apply!(state, op.falsegate)
    end
    return state
end

function QuantumClifford.apply!(state::Register, op::DecisionGate)
    decision = op.decisionfunction(state.bits)
    if !isnothing(decision)
        for i in 1:length(decision)
            apply!(state, op.gates[decision[i]])
        end
    end
    state
end

applybranches(s::Register, op::ConditionalGate; max_order=1) = [(applywstatus!(copy(s),op)...,1,0)]
applybranches(s::Register, op::DecisionGate; max_order=1) = [(applywstatus!(copy(s),op)...,1,0)]

affectedqubits(m::NoisyBellMeasurement) = affectedqubits(m.meas)
affectedqubits(d::ConditionalGate) = union(affectedqubits(d.truegate), affectedqubits(d.falsegate))
affectedqubits(d::DecisionGate) = [(union(affectedqubits.(d.gates))...)...]

end

"""
the `apply_right!` function is used to right multiply any quantum operation to unitary 
Clifford operation or Pauli product

```jldoctest
julia> apply_right!(C"X Z", sHadamard(1))
X₁ ⟼ + Z
Z₁ ⟼ + X
julia> apply_right!(C"Y Z", C"Z Y")
X₁ ⟼ + Z
Z₁ ⟼ - X
julia> apply_right!(C"Y Z", P"X")
X₁ ⟼ + Y
Z₁ ⟼ - Z
```

Example: Build a bell state decoder
```jldoctest
julia> cliff = one(CliffordOperator, 2)
X₁ ⟼ + X_
X₂ ⟼ + _X
Z₁ ⟼ + Z_
Z₂ ⟼ + _Z
julia> apply_right!(cliff, sHadamard(1))
X₁ ⟼ + Z_
X₂ ⟼ + _X
Z₁ ⟼ + X_
Z₂ ⟼ + _Z
julia> apply_right!(cliff, sCNOT(1, 2))
X₁ ⟼ + ZX
X₂ ⟼ + _X
Z₁ ⟼ + X_
Z₂ ⟼ + XZ
julia> apply!(bell(), cliff)
+ Z_
+ _Z
```

See also: [`apply!`](@ref), [`apply_inv!`](@ref)
"""
function apply_right! end


##############################
# Dense operators
##############################

function apply_right!(l::CliffordOperator, r::PauliOperator)
    nqubits(l)==nqubits(r) || throw(DimensionMismatch("The Clifford and Pauli operators need to act on the same number of qubits."))
    for i in 1:nqubits(l)
        x, z = r[i]
        if x
            phases(l)[nqubits(l)+i] ⊻= 0x02
        end
        if z
            phases(l)[i] ⊻= 0x02
        end
    end
    return l
end

function apply_right!(l::CliffordOperator, r::CliffordOperator)
    nqubits(l)==nqubits(r) || throw(DimensionMismatch("The two Clifford operators need to act on the same number of qubits."))
    l_tab = tab(l)
    l_tab_copy = copy(l_tab)
    r_tab = tab(r)
    threadlocal = l.buffer
    @inbounds for row_r in eachindex(r_tab)
        zero!(threadlocal)
        apply_right_row_kernel!(threadlocal, l_tab, row_r, l_tab_copy, r_tab)
    end
    l
end

"""helper for computing the right multiplication of a row of a Clifford operator with another Clifford operator."""
@inline function apply_right_row_kernel!(new_lrow, l_tab, row, l_tab_copy, r_tab)
    new_lrow.phase[] = r_tab.phases[row]
    n = nqubits(l_tab)
    for qubit in 1:n
        x,z = r_tab[row,qubit]
        if x&&z
            new_lrow.phase[] -= 0x1
        end
        if x
            mul_left!(new_lrow, l_tab_copy, qubit)
        end
        if z
            mul_left!(new_lrow, l_tab_copy, qubit+n)
        end
    end
    l_tab[row] = new_lrow
    new_lrow
end


##############################
# Single-qubit gates
##############################

function apply_right!(l::CliffordOperator, r::sHadamard)
    rowswap!(tab(l), r.q, nqubits(l)+r.q)
    return l
end

function apply_right!(l::CliffordOperator, r::sHadamardXY)
    mul_right_ignore_anticomm!(tab(l), r.q, nqubits(l)+r.q)
    apply_right!(l, sY(r.q))
    return l
end

function apply_right!(l::CliffordOperator, r::sHadamardYZ)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q, r.q)
    apply_right!(l, sZ(r.q))
    return l
end

function apply_right!(l::CliffordOperator, r::sPhase)
    apply_right!(l, sInvPhase(r.q))
    apply_right!(l, sZ(r.q))
    return l
end

function apply_right!(l::CliffordOperator, r::sInvPhase)
    mul_right_ignore_anticomm!(tab(l), r.q, nqubits(l)+r.q)
    return l
end

function apply_right!(l::CliffordOperator, r::sX)
    phases(l)[nqubits(l)+r.q] ⊻= 0x02
    return l
end

function apply_right!(l::CliffordOperator, r::sY)
    phases(l)[r.q] ⊻= 0x02
    phases(l)[nqubits(l)+r.q] ⊻= 0x02
    return l
end

function apply_right!(l::CliffordOperator, r::sZ)
    phases(l)[r.q] ⊻= 0x02
    return l
end

function apply_right!(l::CliffordOperator, r::sSQRTX)
    apply_right!(l, sInvSQRTX(r.q))
    apply_right!(l, sX(r.q))
    return l
end

function apply_right!(l::CliffordOperator, r::sInvSQRTX)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q, r.q)
    return l
end

function apply_right!(l::CliffordOperator, r::sSQRTY)
    phases(l)[nqubits(l)+r.q] ⊻= 0x02
    rowswap!(tab(l), r.q, nqubits(l)+r.q)
    return l
end

function apply_right!(l::CliffordOperator, r::sInvSQRTY)
    rowswap!(tab(l), r.q, nqubits(l)+r.q)
    phases(l)[nqubits(l)+r.q] ⊻= 0x02
    return l
end

function apply_right!(l::CliffordOperator, r::sCXYZ)
    rowswap!(tab(l), r.q, nqubits(l)+r.q)
    mul_right_ignore_anticomm!(tab(l), r.q, nqubits(l)+r.q)
    return l
end

function apply_right!(l::CliffordOperator, r::sCZYX)
    rowswap!(tab(l), r.q, nqubits(l)+r.q)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q, r.q)
    apply_right!(l, sX(r.q))
    return l
end

function apply_right!(l::CliffordOperator, ::sId1)
    return l
end


##############################
# Two-qubit gates
##############################

function apply_right!(l::CliffordOperator, r::sSWAP)
    rowswap!(tab(l), nqubits(l)+r.q1, nqubits(l)+r.q2)
    rowswap!(tab(l), r.q1, r.q2)
    return l
end

function apply_right!(l::CliffordOperator, r::sSWAPCX)
    apply_right!(l, sSWAP(r.q1, r.q2))
    apply_right!(l, sCNOT(r.q2, r.q1))
    return l
end

function apply_right!(l::CliffordOperator, r::sInvSWAPCX)
    apply_right!(l, sCNOT(r.q2, r.q1))
    apply_right!(l, sSWAP(r.q1, r.q2))
    return l
end

function apply_right!(l::CliffordOperator, r::sISWAP)
    apply_right!(l, sSWAP(r.q1, r.q2))
    apply_right!(l, sZCZ(r.q1, r.q2))
    apply_right!(l, sPhase(r.q1))
    apply_right!(l, sPhase(r.q2))
    return l
end

function apply_right!(l::CliffordOperator, r::sInvISWAP)
    apply_right!(l, sSWAP(r.q1, r.q2))
    apply_right!(l, sZCZ(r.q1, r.q2))
    apply_right!(l, sInvPhase(r.q1))
    apply_right!(l, sInvPhase(r.q2))
    return l
end

function apply_right!(l::CliffordOperator, r::sCZSWAP)
    apply_right!(l, sZCZ(r.q2, r.q1))
    apply_right!(l, sSWAP(r.q1, r.q2))
    return l
end

function apply_right!(l::CliffordOperator, r::sCXSWAP)
    apply_right!(l, sCNOT(r.q2, r.q1))
    apply_right!(l, sSWAP(r.q1, r.q2))
    return l
end

function apply_right!(l::CliffordOperator, r::sCNOT)
    return apply_right!(l, sZCX(r.q1, r.q2))
end

function apply_right!(l::CliffordOperator, r::sCPHASE)
    apply_right!(l, sZCZ(r.q1, r.q2))
    return l
end

function apply_right!(l::CliffordOperator, r::sZCX)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q2, nqubits(l)+r.q1)
    mul_right_ignore_anticomm!(tab(l), r.q1, r.q2)
    return l
end

function apply_right!(l::CliffordOperator, r::sZCY)
    apply_right!(l, sHadamardYZ(r.q2))
    apply_right!(l, sZCZ(r.q1, r.q2))
    apply_right!(l, sHadamardYZ(r.q2))
    return l
end

function apply_right!(l::CliffordOperator, r::sZCZ)
    mul_right_ignore_anticomm!(tab(l), r.q2, nqubits(l)+r.q1)
    mul_right_ignore_anticomm!(tab(l), r.q1, nqubits(l)+r.q2)
    return l
end

function apply_right!(l::CliffordOperator, r::sXCX)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q2, r.q1)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q1, r.q2)
    return l
end

function apply_right!(l::CliffordOperator, r::sXCY)
    apply_right!(l, sHadamardXY(r.q2))
    apply_right!(l, sXCX(r.q1, r.q2))
    apply_right!(l, sHadamardXY(r.q2))
    return l
end

function apply_right!(l::CliffordOperator, r::sXCZ)
    return apply_right!(l, sZCX(r.q2, r.q1))
end

function apply_right!(l::CliffordOperator, r::sYCX)
    return apply_right!(l, sXCY(r.q2, r.q1))
end

function apply_right!(l::CliffordOperator, r::sYCY)
    apply_right!(l, sHadamardYZ(r.q1))
    apply_right!(l, sHadamardYZ(r.q2))
    apply_right!(l, sZCZ(r.q1, r.q2))
    apply_right!(l, sHadamardYZ(r.q2))
    apply_right!(l, sHadamardYZ(r.q1))
    return l
end

function apply_right!(l::CliffordOperator, r::sYCZ)
    return apply_right!(l, sZCY(r.q2, r.q1))
end

function apply_right!(l::CliffordOperator, r::sZCrY)
    mul_right_ignore_anticomm!(tab(l), r.q1, r.q2)        
    mul_right_ignore_anticomm!(tab(l), r.q2, nqubits(l)+r.q1)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q2, nqubits(l)+r.q1)
    mul_right_ignore_anticomm!(tab(l), r.q1, nqubits(l)+r.q2)
    return l
end

function apply_right!(l::CliffordOperator, r::sInvZCrY)
    mul_right_ignore_anticomm!(tab(l), r.q1, r.q2)
    mul_right_ignore_anticomm!(tab(l), r.q2, nqubits(l)+r.q1)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q2, nqubits(l)+r.q1)
    mul_right_ignore_anticomm!(tab(l), r.q1, nqubits(l)+r.q2)
    phases(l)[r.q1] ⊻= 0x02
    return l
end

function apply_right!(l::CliffordOperator, r::sSQRTZZ)
    apply_right!(l, sInvSQRTZZ(r.q1, r.q2))
    apply_right!(l, sZ(r.q1))
    apply_right!(l, sZ(r.q2))
    return l
end

function apply_right!(l::CliffordOperator, r::sInvSQRTZZ)
    mul_right_ignore_anticomm!(tab(l), r.q1, nqubits(l)+r.q1)
    mul_right_ignore_anticomm!(tab(l), r.q1, nqubits(l)+r.q2)
    mul_right_ignore_anticomm!(tab(l), r.q2, nqubits(l)+r.q1)
    mul_right_ignore_anticomm!(tab(l), r.q2, nqubits(l)+r.q2)
    return l
end

function apply_right!(l::CliffordOperator, r::sSQRTXX)
    apply_right!(l, sInvSQRTXX(r.q1, r.q2))
    apply_right!(l, sX(r.q1))
    apply_right!(l, sX(r.q2))
    return l
end

function apply_right!(l::CliffordOperator, r::sInvSQRTXX)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q1, r.q1)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q1, r.q2)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q2, r.q1)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q2, r.q2)    
    return l
end

function apply_right!(l::CliffordOperator, r::sSQRTYY)
    apply_right!(l, sInvSQRTYY(r.q1, r.q2))
    apply_right!(l, sY(r.q1))
    apply_right!(l, sY(r.q2))
    return l
end

function apply_right!(l::CliffordOperator, r::sInvSQRTYY)
    mul_right_ignore_anticomm!(tab(l), r.q1, nqubits(l)+r.q1)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q1, nqubits(l)+r.q2)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q1, r.q2)
    mul_right_ignore_anticomm!(tab(l), r.q2, r.q1)
    mul_right_ignore_anticomm!(tab(l), nqubits(l)+r.q2, r.q1)
    mul_right_ignore_anticomm!(tab(l), r.q1, nqubits(l)+r.q1)    
    rowswap!(tab(l), r.q1, nqubits(l)+r.q1)
    rowswap!(tab(l), r.q2, nqubits(l)+r.q2)
    apply_right!(l, sZ(r.q2))
    return l
end


"""Multiply Pauli operators `l * r`, ignoring anticommutation phases (keeping only ±1, not ±i)"""
@inline function mul_right_ignore_anticomm!(s::Tableau, m, t::Tableau, i; phases::Val{B}=Val(true)) where B
    extra_phase = mul_right!((@view s.xzs[:,m]), (@view t.xzs[:,i]); phases=phases)
    B && (s.phases[m] = (extra_phase+s.phases[m]+s.phases[i])&0x2)
    s
end
@inline function mul_right_ignore_anticomm!(s::Tableau, m, i; phases::Val{B}=Val(true)) where B
    extra_phase = mul_right!((@view s.xzs[:,m]), (@view s.xzs[:,i]); phases=phases)
    B && (s.phases[m] = (extra_phase+s.phases[m]+s.phases[i])&0x2)
    s
end

@testitem "isclifford" begin
    using QuantumClifford

    @testset "Single-qubit symbolic Cliffords" begin
        @test isclifford(sHadamard(1)) == true
        @test isclifford(sPhase(1)) == true
        @test isclifford(sInvPhase(1)) == true
        @test isclifford(sX(1)) == true
        @test isclifford(sY(1)) == true
        @test isclifford(sZ(1)) == true
        @test isclifford(sId1(1)) == true
        @test isclifford(sSQRTX(1)) == true
        @test isclifford(sInvSQRTX(1)) == true
        @test isclifford(sSQRTY(1)) == true
        @test isclifford(sInvSQRTY(1)) == true
        @test isclifford(sHadamardXY(1)) == true
        @test isclifford(sHadamardYZ(1)) == true
        @test isclifford(sCXYZ(1)) == true
        @test isclifford(sCZYX(1)) == true
    end

    @testset "Two-qubit symbolic Cliffords" begin
        @test isclifford(sCNOT(1, 2)) == true
        @test isclifford(sCPHASE(1, 2)) == true
        @test isclifford(sSWAP(1, 2)) == true
        @test isclifford(sXCX(1, 2)) == true
        @test isclifford(sXCY(1, 2)) == true
        @test isclifford(sXCZ(1, 2)) == true
        @test isclifford(sYCX(1, 2)) == true
        @test isclifford(sYCY(1, 2)) == true
        @test isclifford(sYCZ(1, 2)) == true
        @test isclifford(sZCX(1, 2)) == true
        @test isclifford(sZCY(1, 2)) == true
        @test isclifford(sZCZ(1, 2)) == true
        @test isclifford(sSWAPCX(1, 2)) == true
        @test isclifford(sInvSWAPCX(1, 2)) == true
        @test isclifford(sCZSWAP(1, 2)) == true
        @test isclifford(sCXSWAP(1, 2)) == true
        @test isclifford(sISWAP(1, 2)) == true
        @test isclifford(sInvISWAP(1, 2)) == true
        @test isclifford(sSQRTZZ(1, 2)) == true
        @test isclifford(sInvSQRTZZ(1, 2)) == true
    end

    @testset "Measurements" begin
        @test isclifford(sMX(1, 1)) == true
        @test isclifford(sMY(1, 1)) == true
        @test isclifford(sMZ(1, 1)) == true
        @test isclifford(sMRX(1, 1)) == true
        @test isclifford(sMRY(1, 1)) == true
        @test isclifford(sMRZ(1, 1)) == true
        @test isclifford(PauliMeasurement(P"X", 1)) == true
    end

    @testset "SparseGate" begin
        sparse_clifford = SparseGate(CliffordOperator(tHadamard), [1])
        @test isclifford(sparse_clifford) == true
    end

    @testset "Dense CliffordOperator" begin
        @test isclifford(CliffordOperator(tHadamard)) == true
    end

    @testset "Non-Clifford gates" begin
        @test isclifford(sT(1)) == false
        @test isclifford(sCCZ(1, 2, 3)) == false
    end
end

@testitem "JET checks" tags=[:jet] begin
    using JET
    using Test
    using QuantumClifford
    using QuantumInterface

    rep = JET.report_package(QuantumClifford, target_modules=[QuantumClifford, QuantumInterface])
    @show rep
    @test length(JET.get_reports(rep)) <= 5
    @test_broken length(JET.get_reports(rep)) == 0
end

"""An abstract type for QECC syndrome decoding algorithms.

All `AbstractSyndromeDecoder` types are expected to:
- have a `parity_checks` method giving the parity checks for the code under study
- have a `decode` method that guesses error which caused the syndrome
- have an `evaluate_decoder` method which runs a full simulation but it supports only a small number of ECC protocols"""
abstract type AbstractSyndromeDecoder end

"""Decode a syndrome using a given decoding algorithm."""
function decode end

"""Decode a batch of syndromes using a given decoding algorithm."""
function batchdecode(d::AbstractSyndromeDecoder, syndrome_samples)
    H = parity_checks(d)
    s, n = size(H)
    samples, _s = size(syndrome_samples)
    s == _s || throw(ArgumentError(lazy"The syndromes given to `batchdecode` have the wrong dimensions. The syndrome length is $(_s) while it should be $(s)"))
    results = falses(samples, 2n)
    for (i,syndrome_sample) in enumerate(eachrow(syndrome_samples))
        guess = decode(d, syndrome_sample)# TODO use `decode!`
        isnothing(guess) || (results[i,:] = guess)
    end
    return results
end


"""An abstract type mostly used by [`evaluate_decoder`](@ref) to specify in what context to evaluate an ECC."""
abstract type AbstractECCSetup end

"""A helper function that takes a parity check tableau and an `AbstractECCSetup` type and provides the circuit that needs to be simulated."""
function physical_ECC_circuit end # XXX Do not export! This might need to be refactored as we add more interesting setups!

"""Configuration for ECC evaluator that does not simulate any ECC circuits, rather it simply checks the commutation of the parity check and the Pauli error.

This is much faster than any other simulation method, but it is incapable of noisy-circuit simulations and thus useless for fault-tolerance studies.

See also: [`NaiveSyndromeECCSetup`](@ref), [`ShorSyndromeECCSetup`](@ref)"""
struct CommutationCheckECCSetup <: AbstractECCSetup
    xz_noise::Float64
    function CommutationCheckECCSetup(xz_noise)
        0<=xz_noise<=1 || throw(DomainError(xz_noise, "The independent X/Z memory noise in `CommutationCheckECCSetup` should be between 0 and 1."))
        new(xz_noise)
    end
end

"""Configuration for ECC evaluator that runs the simplest syndrome measurement circuit.

The circuit is being simulated (as opposed to doing only a quick commutation check).
This circuit would give poor performance if there is non-zero gate noise.

See also: [`CommutationCheckECCSetup`](@ref), [`ShorSyndromeECCSetup`](@ref)"""
struct NaiveSyndromeECCSetup <: AbstractECCSetup
    mem_noise::Float64
    two_qubit_gate_noise::Float64
    function NaiveSyndromeECCSetup(mem_noise, two_qubit_gate_noise)
        0<=mem_noise<=1 || throw(DomainError(mem_noise, "The memory noise in `NaiveSyndromeECCSetup` should be between 0 and 1."))
        0<=two_qubit_gate_noise<=1 || throw(DomainError(two_qubit_gate_noise, "The two-qubit gate noise in `NaiveSyndromeECCSetup` should be between 0 and 1."))
        new(mem_noise, two_qubit_gate_noise)
    end
end

"""Configuration for ECC evaluators that simulate the Shor-style syndrome measurement (without a flag qubit).

The simulated circuit includes:
- perfect noiseless encoding (encoding and its fault tolerance are not being studied here)
- one round of "memory noise" after the encoding but before the syndrome measurement
- perfect preparation of entangled ancillary qubits
- noisy Shor-style syndrome measurement (only two-qubit gate noise)
- noiseless "logical state measurement" (providing the comparison data when evaluating the decoder)

See also: [`CommutationCheckECCSetup`](@ref), [`NaiveSyndromeECCSetup`](@ref)"""
struct ShorSyndromeECCSetup <: AbstractECCSetup
    mem_noise::Float64
    two_qubit_gate_noise::Float64
    function ShorSyndromeECCSetup(mem_noise, two_qubit_gate_noise)
        0<=mem_noise<=1 || throw(DomainError(mem_noise, "The memory noise in `ShorSyndromeECCSetup` should be between 0 and 1."))
        0<=two_qubit_gate_noise<=1 || throw(DomainError(two_qubit_gate_noise, "The two-qubit gate noise in `ShorSyndromeECCSetup` should be between 0 and 1."))
        new(mem_noise, two_qubit_gate_noise)
    end
end

function add_two_qubit_gate_noise(g, gate_error)
    return ()
end

"""Applies gate_error to a given two-qubit gate g."""
function add_two_qubit_gate_noise(g::AbstractTwoQubitOperator, gate_error)
    qubits = affectedqubits(g)
    return (PauliError(qubits, gate_error), )
end

function physical_ECC_circuit(H, setup::NaiveSyndromeECCSetup)
    syndrome_circ, n_anc, syndrome_bits = naive_syndrome_circuit(H)
    noisy_syndrome_circ = []

    for op in syndrome_circ
        push!(noisy_syndrome_circ, op)
        for noise_op in add_two_qubit_gate_noise(op, setup.two_qubit_gate_noise)
            push!(noisy_syndrome_circ, noise_op)
        end
    end

    mem_error_circ = [PauliError(i, setup.mem_noise) for i in 1:nqubits(H)]
    circ = vcat(mem_error_circ, noisy_syndrome_circ)
    return circ, syndrome_bits, n_anc
end


function physical_ECC_circuit(H, setup::ShorSyndromeECCSetup)
    prep_anc, syndrome_circ, n_anc, syndrome_bits = shor_syndrome_circuit(H)

    noisy_syndrome_circ = []
    for op in syndrome_circ
        push!(noisy_syndrome_circ, op)
        for noise_op in add_two_qubit_gate_noise(op, setup.two_qubit_gate_noise)
            push!(noisy_syndrome_circ, noise_op)
        end
    end

    mem_error_circ = [PauliError(i, setup.mem_noise) for i in 1:nqubits(H)]

    circ = vcat(prep_anc, mem_error_circ, noisy_syndrome_circ)
    circ, syndrome_bits, n_anc
end

"""Evaluate the performance of a given decoder (e.g. [`TableDecoder`](@ref)) and a given style of running an ECC code (e.g. [`ShorSyndromeECCSetup`](@ref))"""
function evaluate_decoder(d::AbstractSyndromeDecoder, setup::AbstractECCSetup, nsamples::Int)
    H = parity_checks(d)
    n = code_n(H)
    k = code_k(H)
    O = faults_matrix(H)

    physical_noisy_circ, syndrome_bits, n_anc = physical_ECC_circuit(H, setup)
    encoding_circ = naive_encoding_circuit(H)
    preX = sHadamard[sHadamard(i) for i in n-k+1:n]

    mdH = MixedDestabilizer(H)
    logX_circ, _, logX_bits = naive_syndrome_circuit(logicalxview(mdH), n_anc+1, last(syndrome_bits)+1)
    logZ_circ, _, logZ_bits = naive_syndrome_circuit(logicalzview(mdH), n_anc+1, last(syndrome_bits)+1)

    # Evaluate the probability for X logical error (the Z-observable part of the faults matrix is used)
    X_error = evaluate_decoder(
        d, nsamples,
        vcat(encoding_circ, physical_noisy_circ, logZ_circ),
        syndrome_bits, logZ_bits, O[end÷2+1:end,:])
    # Evaluate the probability for Z logical error (the X-observable part of the faults matrix is used)
    Z_error = evaluate_decoder(
        d, nsamples,
        vcat(preX, encoding_circ, physical_noisy_circ, logX_circ),
        syndrome_bits, logX_bits, O[1:end÷2,:])
    return (X_error, Z_error)
end

"""Evaluate the performance of an error-correcting circuit.

This method requires you give the circuit that performs both syndrome measurements and (probably noiseless) logical state measurements.
The faults matrix that translates an error vector into corresponding logical errors is necessary as well.

This is a relatively barebones method that assumes the user prepares necessary circuits, etc.
It is a method that is used internally by more user-friendly methods providing automatic conversion of codes and noise models
to the necessary noisy circuits.
"""
function evaluate_decoder(d::AbstractSyndromeDecoder, nsamples, circuit, syndrome_bits, logical_bits, faults_submatrix)
    frames = pftrajectories(circuit;trajectories=nsamples,threads=true)

    syndromes = @view measurements(frames)[:, syndrome_bits]
    measured_faults = @view measurements(frames)[:, logical_bits]
    guesses = batchdecode(d, syndromes)
    evaluate_guesses(measured_faults, guesses, faults_submatrix)
end

function evaluate_guesses(measured_faults, guesses, faults_matrix)
    nsamples = size(guesses, 1)
    fails = 0
    for i in 1:nsamples
        for j in 1:size(faults_matrix, 1)
            sum_mod = 0
            @inbounds @simd for k in 1:size(faults_matrix, 2)
                sum_mod += faults_matrix[j, k] * guesses[i, k]
            end
            sum_mod %= 2
            if sum_mod != measured_faults[i, j]
                fails += 1
                break
            end
        end
    end
    return fails / nsamples
end

function evaluate_decoder(d::AbstractSyndromeDecoder, setup::CommutationCheckECCSetup, nsamples::Int)
    H = parity_checks(d)
    fm = faults_matrix(H)
    fmtab = QuantumClifford.Tableau(fm[:,end÷2+1:end],fm[:,1:end÷2]) # TODO there should be a special method for this
    k, s = size(fm)
    n = nqubits(H)
    err = zero(PauliOperator, n)
    syndromes = zeros(Bool, nsamples, length(H)) # TODO will this be better and faster if we use bitmatrices
    measured_faults = zeros(UInt8, nsamples, k)
    for i in 1:nsamples
        err = random_pauli!(err, setup.xz_noise, nophase=true)
        comm!((@view syndromes[i,:]), H,err)
        comm!((@view measured_faults[i,:]), fmtab,err)
    end
    measured_faults .%= 2
    guesses = batchdecode(d, syndromes)
    evaluate_guesses(measured_faults, guesses, fm)
end

"""A simple look-up table decoder for error correcting codes.

The lookup table contains only weight=1 errors, thus it is small,
but at best it provides only for distance=3 decoding.

The size of the lookup table would grow exponentially quickly for higher distances.

See also: [`CSSTableDecoder`](@ref)"""
struct TableDecoder <: AbstractSyndromeDecoder
    """Stabilizer tableau defining the code"""
    H
    """Faults matrix corresponding to the code"""
    faults_matrix
    """The number of qubits in the code"""
    n::Int
    """The depth of the code"""
    s::Int
    """The number of encoded qubits"""
    k::Int
    """The maximum weight of errors in the lookup table"""
    error_weight::Int
    """The lookup table corresponding to the code, slow to create"""
    lookup_table::Dict{Vector{Bool},Vector{Bool}}
    lookup_buffer::Vector{Bool}
    TableDecoder(H, faults_matrix, n, s, k, error_weight, lookup_table) = new(H, faults_matrix, n, s, k, error_weight, lookup_table, fill(false, s))
end

function TableDecoder(c; error_weight=1)
    H = parity_checks(c)
    s, n = size(H)
    _, _, r = canonicalize!(Base.copy(H), ranks=true)
    k = n - r
    lookup_table = create_lookup_table(H; error_weight)
    fm = faults_matrix(H)
    return TableDecoder(H, fm, n, s, k, error_weight, lookup_table)
end

parity_checks(d::TableDecoder) = d.H

function create_lookup_table(code::Stabilizer; error_weight=1)
    lookup_table = Dict{Vector{Bool},Vector{Bool}}()
    constraints, qubits = size(code)
    # Process errors from highest weight to lowest
    # so that lower-weight errors overwrite higher-weight ones
    # (lower-weight errors are more probable)
    for w in error_weight:-1:1
        # Iterate over all combinations of w qubit positions
        for positions in combinations(1:qubits, w)
            # For each position, there are 3 choices: X, Y, Z
            # We iterate over all 3^w combinations using (x_bit, z_bit) tuples
            for pauli_types in Iterators.product(ntuple(_ -> ((true,false), (true,true), (false,true)), w)...)
                error = zero(PauliOperator, qubits)
                for (i, pos) in enumerate(positions)
                    error[pos] = pauli_types[i]
                end
                # Calculate syndrome (check which stabilizer rows do not commute with the error)
                syndrome = comm(error, code)
                # Store s⃗ → e⃗
                lookup_table[syndrome] = stab_to_gf2(error)
            end
        end
    end
    # In the case of no errors
    lookup_table[zeros(UInt8, constraints)] = stab_to_gf2(zero(PauliOperator, qubits))
    lookup_table
end;

function decode(d::TableDecoder, syndrome_sample)
    d.lookup_buffer .= syndrome_sample # TODO have this work without data copying, by supporting the correct types, especially in the batch decode case
    return get(d.lookup_table, d.lookup_buffer, nothing)
end

"""A simple look-up table decoder for classical codes.

Similar to [`TableDecoder`](@ref) but works with a classical parity check matrix
instead of a stabilizer tableau."""
struct ClassicalTableDecoder <: AbstractSyndromeDecoder
    """Parity check matrix defining the code"""
    H::Matrix{Bool}
    """The number of bits in the code"""
    n::Int
    """The number of parity checks"""
    s::Int
    """The maximum weight of errors in the lookup table"""
    error_weight::Int
    """The lookup table corresponding to the code"""
    lookup_table::Dict{Vector{Bool},Vector{Bool}}
    lookup_buffer::Vector{Bool}
    ClassicalTableDecoder(H, n, s, error_weight, lookup_table) = new(H, n, s, error_weight, lookup_table, fill(false, s))
end

function ClassicalTableDecoder(H::Matrix{Bool}; error_weight=1)
    s, n = size(H)
    lookup_table = create_lookup_table(H; error_weight)
    return ClassicalTableDecoder(H, n, s, error_weight, lookup_table)
end

parity_checks(d::ClassicalTableDecoder) = d.H

function create_lookup_table(H::Matrix{Bool}; error_weight=1) # TODO there is inefficient casting between Bool vectors and bitvectors here
    lookup_table = Dict{Vector{Bool},Vector{Bool}}()
    s, n = size(H)
    # Process errors from highest weight to lowest
    # so that lower-weight errors overwrite higher-weight ones
    # (lower-weight errors are more probable)
    for w in error_weight:-1:1
        for positions in combinations(1:n, w)
            error = falses(n)
            for pos in positions
                error[pos] = true
            end
            # Calculate syndrome: s = H * e (mod 2)
            syndrome = Bool[(sum(H[row, pos] for pos in positions) % 2) == 1 for row in 1:s]
            lookup_table[syndrome] = error
        end
    end
    # In the case of no errors
    lookup_table[falses(s)] = falses(n)
    lookup_table
end

function decode(d::ClassicalTableDecoder, syndrome_sample)
    d.lookup_buffer .= syndrome_sample
    return get(d.lookup_table, d.lookup_buffer, nothing)
end

"""A look-up table decoder for CSS codes.

Importantly, this decoder addresses the x and z errors separately, unlike the [`TableDecoder`](@ref).
For a given distance, this decoder will do better on CSS codes than the [`TableDecoder`](@ref).

Uses two `ClassicalTableDecoder` instances internally to decode
the X and Z errors separately."""
struct CSSTableDecoder <: AbstractSyndromeDecoder
    """Stabilizer tableau defining the code"""
    H
    """Faults matrix corresponding to the code"""
    faults_matrix
    """The number of qubits in the code"""
    n::Int
    """The number of parity checks"""
    s::Int
    """The number of encoded qubits"""
    k::Int
    """The number of X checks"""
    cx::Int
    """The number of Z checks"""
    cz::Int
    """The maximum weight of errors in the lookup table"""
    error_weight::Int
    """Classical decoder for X errors (decodes Z syndrome)"""
    tabledecoderx::ClassicalTableDecoder
    """Classical decoder for Z errors (decodes X syndrome)"""
    tabledecoderz::ClassicalTableDecoder
end

function CSSTableDecoder(c; error_weight=1)
    Hx = parity_matrix_x(c)
    Hz = parity_matrix_z(c)
    H = parity_checks(c)
    s, n = size(H)
    _, _, r = canonicalize!(copy(H), ranks=true)
    k = n - r
    cx = size(Hx, 1)
    cz = size(Hz, 1)
    fm = faults_matrix(H)
    tabledecoderx = ClassicalTableDecoder(Matrix{Bool}(Hx); error_weight)
    tabledecoderz = ClassicalTableDecoder(Matrix{Bool}(Hz); error_weight)
    return CSSTableDecoder(H, fm, n, s, k, cx, cz, error_weight, tabledecoderx, tabledecoderz)
end

parity_checks(d::CSSTableDecoder) = d.H

function decode(d::CSSTableDecoder, syndrome_sample)
    row_x = @view syndrome_sample[1:d.cx]
    row_z = @view syndrome_sample[d.cx+1:d.cx+d.cz]
    guess_z = decode(d.tabledecoderx, row_x)
    guess_x = decode(d.tabledecoderz, row_z)
    return isnothing(guess_x) || isnothing(guess_z) ? nothing : vcat(guess_x, guess_z)
end

# From extensions:

using WeakDepHelpers: @declare_struct_is_in_extension

@declare_struct_is_in_extension QuantumClifford BeliefPropDecoder :QuantumCliffordLDPCDecodersExt (:LDPCDecoders,) "A simple Belief Propagation decoder built around tools from `LDPCDecoders.jl`."
@declare_struct_is_in_extension QuantumClifford BitFlipDecoder :QuantumCliffordLDPCDecodersExt (:LDPCDecoders,) "An Iterative Bitflip decoder built around tools from `LDPCDecoders.jl`."
@declare_struct_is_in_extension QuantumClifford PyBeliefPropDecoder :QuantumCliffordPyQDecodersExt (:PyQDecoders,) "A Belief Propagation decoder built around tools from the python package `ldpc` available from the julia package `PyQDecoders.jl`."
@declare_struct_is_in_extension QuantumClifford PyBeliefPropOSDecoder :QuantumCliffordPyQDecodersExt (:PyQDecoders,) "A Belief Propagation decoder with ordered statistics decoding, built around tools from the python package `ldpc` available from the julia package `PyQDecoders.jl`."
@declare_struct_is_in_extension QuantumClifford PyMatchingDecoder :QuantumCliffordPyQDecodersExt (:PyQDecoders,) "A perfect matching decoder built around tools from the python package `pymatching` available from the julia package `PyQDecoders.jl`."
@declare_struct_is_in_extension QuantumClifford TesseractDecoder :QuantumCliffordPyTesseractDecoderExt (:PyTesseractDecoder,) "A syndrome decoder using Google's `tesseract-decoder` available via `PyTesseractDecoder.jl`."

# using LoopVectorization
using HostCPUFeatures: pick_vector_width
import SIMD

"""Nonvectorized version of `mul_left!` used for unit tests."""
function _mul_left_nonvec!(r::AbstractVector{T}, l::AbstractVector{T}; phases::Bool=true) where T<:Unsigned
    rcnt1, rcnt2 = _mul_ordered_nonvec!(r,l; phases)
    rcnt1 ⊻ (rcnt2 << 1)
end

function _mul_ordered_nonvec!(r::AbstractVector{T}, l::AbstractVector{T}; phases::Bool=true) where T<:Unsigned
    if !phases
        r .⊻= l
        return (0, 0)
    end
    cnt1 = zero(T)
    cnt2 = zero(T)
    len = length(l)÷2
    @inbounds @simd for i in 1:len
        x1, x2, z1, z2 = l[i], r[i], l[i+len], r[i+len]
        r[i] = newx1 = x1 ⊻ x2
        r[i+len] = newz1 = z1 ⊻ z2
        x1z2 = x1 & z2
        anti_comm = (x2 & z1) ⊻ x1z2
        cnt2 ⊻= (cnt1 ⊻ newx1 ⊻ newz1 ⊻ x1z2) & anti_comm
        cnt1 ⊻= anti_comm
    end
    rcnt1 = count_ones(cnt1)
    rcnt2 = count_ones(cnt2)
    rcnt1, rcnt2
end

#= # LoopVectorization does not support the necessary bit operations
function mul_ordered_lv!(r::AbstractVector{T}, l::AbstractVector{T}; phases::Val{B}=Val(true)) where {T<:Unsigned, B}
    if !B
        r .⊻= l
        return (0, 0)
    end
    cnt1 = zero(T)
    cnt2 = zero(T)
    len = length(l)÷2
    @turbo for i in 1:len
        x1, x2, z1, z2 = l[i], r[i], l[i+len], r[i+len]
        newx1 = x1 ⊻ x2
        r[i] = newx1
        newz1 = z1 ⊻ z2
        r[i+len] = newz1
        x1z2 = x1 & z2
        anti_comm = (x2 & z1) ⊻ x1z2
        cnt2 ⊻= (newx1 ⊻ newz1 ⊻ x1z2) & anti_comm
        cnt1 ⊻= anti_comm
    end
    rcnt1 = count_ones(cnt1)
    rcnt2 = count_ones(cnt2)
    rcnt1, rcnt2
end
=#

function mul_ordered!(r::SubArray{T,1,P,I2,false}, l::AbstractVector{T}; phases::Val{B}=Val(true)) where {T<:Unsigned, B, I2, P}
    # This method exists because SIMD.jl requires fast linear indexing
    # (which is not the case for Adjoint,
    # e.g. when we use `fastcolumn`).
    # The `false` in the SubArray parameters stands for
    # "does not support fast linear indexing".
    # See the other ::SubArray method below as well.
    _mul_ordered_nonvec!(r,l; phases=B)
end

function mul_ordered!(r::SubArray{T,1,P,Tuple{I1, I2},true}, l::AbstractVector{T}; phases::Val{B}=Val(true)) where {T<:Unsigned, B, P, I1<:Any, I2<:AbstractUnitRange}
    # This method exists because SIMD.jl requires fast linear indexing
    # that is NOT strided. See the other ::SubArray method above as well.
    _mul_ordered_nonvec!(r,l; phases=B)
end

function mul_ordered!(r::AbstractVector{T}, l::AbstractVector{T}; phases::Val{B}=Val(true)) where {T<:Unsigned, B}
    if !B
        r .⊻= l
        return (0, 0)
    end
    len = length(l)÷2
    veclen = Int(pick_vector_width(T)) # TODO remove the Int cast
    rcnt1 = 0
    rcnt2 = 0
    packs = len÷veclen
    VT = SIMD.Vec{veclen,T}
    if packs>0
        cnt1 = zero(VT)
        cnt2 = zero(VT)
        lane = SIMD.VecRange{veclen}(0)
        @inbounds for i in 1:veclen:(len-veclen+1)
            # JET-XXX The ::VT should not be necessary, but they help with inference
            x1::VT, x2::VT, z1::VT, z2::VT = l[i+lane], r[i+lane], l[i+len+lane], r[i+len+lane]
            r[i+lane] = newx1 = x1 ⊻ x2
            r[i+len+lane] = newz1 = z1 ⊻ z2
            x1z2 = x1 & z2
            anti_comm = (x2 & z1) ⊻ x1z2
            cnt2 ⊻= (cnt1 ⊻ newx1 ⊻ newz1 ⊻ x1z2) & anti_comm
            cnt1 ⊻= anti_comm
        end
        for i in 1:length(cnt1)
            rcnt1 += count_ones(cnt1[i])
        end
        for i in 1:length(cnt2)
            rcnt2 += count_ones(cnt2[i])
        end
    end
    scnt1 = zero(T)
    scnt2 = zero(T)
    @inbounds for i in (packs*veclen+1):len # same code for the pieces that do not fit in a vector at the end (TODO padding would simplify the code)
        x1, x2, z1, z2 = l[i], r[i], l[i+len], r[i+len]
        r[i] = newx1 = x1 ⊻ x2
        r[i+len] = newz1 = z1 ⊻ z2
        x1z2 = x1 & z2
        anti_comm = (x2 & z1) ⊻ x1z2
        scnt2 ⊻= (scnt1 ⊻ newx1 ⊻ newz1 ⊻ x1z2) & anti_comm
        scnt1 ⊻= anti_comm
    end
    rcnt1 += count_ones(scnt1) # anti_comm
    rcnt2 += count_ones(scnt2)
    rcnt1, rcnt2
end

function mul_left!(r::AbstractVector{T}, l::AbstractVector{T}; phases::Val{B}=Val(true))::UInt8 where {T<:Unsigned, B}
    rcnt1, rcnt2 = mul_ordered!(r, l; phases=phases)
    return UInt8((rcnt1 ⊻ (rcnt2<<1))&0x3)
end

function mul_right!(l::AbstractVector{T}, r::AbstractVector{T}; phases::Val{B}=Val(true))::UInt8 where {T<:Unsigned, B}
    rcnt1, rcnt2 = mul_ordered!(l, r; phases=phases)
    return UInt8(((rcnt1 ⊻ (rcnt2<<1)) + rcnt1*2)&0x3) # TODO simplify
end

##############################
# On Pauli Operators
##############################

@inline function mul_left!(r::PauliOperator, l::PauliOperator; phases::Val{B}=Val(true)) where B
    nqubits(l)==nqubits(r) || throw(DimensionMismatch("The two Pauli operators should have the same length!")) # TODO skip this when @inbounds is set
    s = mul_left!(r.xz, l.xz, phases=phases)
    B && (r.phase[] = (s+r.phase[]+l.phase[])&0x3)
    r
end

@inline function mul_right!(l::PauliOperator, r::PauliOperator; phases::Val{B}=Val(true)) where B
    nqubits(l)==nqubits(r) || throw(DimensionMismatch("The two Pauli operators should have the same length!")) # TODO skip this when @inbounds is set
    s = mul_right!(l.xz, r.xz, phases=phases)
    B && (l.phase[] = (s+r.phase[]+l.phase[])&0x3)
    l
end

@inline function mul_left!(r::PauliOperator, l::Tableau, i::Int; phases::Val{B}=Val(true)) where B
    s = mul_left!(r.xz, (@view l.xzs[:,i]), phases=phases)
    B && (r.phase[] = (s+r.phase[]+l.phases[i])&0x3)
    r
end

@inline mul_left!(r::PauliOperator, l::Stabilizer, i::Int; phases::Val{B}=Val(true)) where B = mul_left!(r, tab(l), i; phases=phases)

@inline function mul_right!(l::PauliOperator, r::Tableau, i::Int; phases::Val{B}=Val(true)) where B
    s = mul_right!(l.xz, (@view r.xzs[:,i]), phases=phases)
    B && (l.phase[] = (s+l.phase[]+r.phases[i])&0x3)
    l
end

@inline mul_right!(l::PauliOperator, r::Stabilizer, i::Int; phases::Val{B}=Val(true)) where B = mul_right!(l, tab(r), i; phases=phases)

##############################
# On Tableaux
##############################

@inline function mul_left!(s::Tableau, m, t::Tableau, i; phases::Val{B}=Val(true)) where B
    extra_phase = mul_left!((@view s.xzs[:,m]), (@view t.xzs[:,i]); phases=phases)
    B && (s.phases[m] = (extra_phase+s.phases[m]+s.phases[i])&0x3)
    s
end

@inline function mul_left!(s::Tableau, m, i; phases::Val{B}=Val(true)) where B
    extra_phase = mul_left!((@view s.xzs[:,m]), (@view s.xzs[:,i]); phases=phases)
    B && (s.phases[m] = (extra_phase+s.phases[m]+s.phases[i])&0x3)
    s
end

@inline function mul_left!(s::Stabilizer, m, i; phases::Val{B}=Val(true)) where B
    mul_left!(tab(s), m, i; phases)
end

@inline function mul_left!(s::Destabilizer, i, j; phases::Val{B}=Val(true)) where B
    t = tab(s)
    mul_left!(t, j, i; phases=Val(false)) # Indices are flipped to preserve commutation constraints
    n = size(t,1)÷2
    mul_left!(t, i+n, j+n; phases=phases)
end

@inline function mul_left!(s::MixedStabilizer, i, j; phases::Val{B}=Val(true)) where B
    mul_left!(tab(s), i, j; phases=phases)
end

@inline function mul_left!(s::MixedDestabilizer, i, j; phases::Val{B}=Val(true)) where B
    t = tab(s)
    mul_left!(t, j, i; phases=Val(false)) # Indices are flipped to preserve commutation constraints
    n = nqubits(t)
    mul_left!(t, i+n, j+n; phases=phases)
end

@inline function mul_left!(s::Tableau, p::PauliOperator; phases::Val{B}=Val(true)) where B # TODO multithread
    @inbounds @simd for m in eachindex(s)
        extra_phase = mul_left!((@view s.xzs[:,m]), p.xz; phases=phases)
        B && (s.phases[m] = (extra_phase+s.phases[m]+p.phase[])&0x3)
    end
    s
end

@inline function mul_left!(s::AbstractStabilizer, p::PauliOperator; phases::Val{B}=Val(true)) where B
    mul_left!(tab(s), p; phases=phases)
    s
end

@inline function mul_right!(s::Tableau, p::PauliOperator; phases::Val{B}=Val(true)) where B # TODO multithread
    @inbounds @simd for m in eachindex(s)
        extra_phase = mul_right!((@view s.xzs[:,m]), p.xz; phases=phases)
        B && (s.phases[m] = (extra_phase+s.phases[m]+p.phase[])&0x3)
    end
    s
end

@inline function mul_right!(s::AbstractStabilizer, p::PauliOperator; phases::Val{B}=Val(true)) where B
    mul_right!(tab(s), p; phases=phases)
    s
end

const NoZeroQubit = ArgumentError("Qubit indices have to be larger than zero, but you are attempting to create a gate acting on a qubit with a non-positive index. Ensure indexing always starts from 1.")

const THROW_BOUNDS =
"Unable to perform the requested operation due to encountering a mismatch \
between the provided index(indices) and the pertinent size(s) of the other \
argument(s)."

const THROW_SIZE =
"Unable to perform the requested operation due to encountering a mismatch \
between the pertinent size(s) of the provided arguments."

const THROW_NQUBITS =
"Unable to perform the requested operation due to encountering a mismatch \
between the number of qubits in the provided arguments."

@testitem "Allocation checks" begin
    using QuantumClifford: mul_left!, RandDestabMemory, Tableau
    using Random
    n = Threads.nthreads()
    allocated(f::F) where {F} = @allocations f()
    @testset "apply! mul_left! canonicalize!" begin
        p1 = random_pauli(500)
        p2 = random_pauli(500)
        f1() = mul_left!(p1,p2)
        f1()
        allocated(f1)
        @test allocated(f1) == 0
        s = random_stabilizer(500)
        f2() = canonicalize!(s)
        f2()
        allocated(f2)
        @test allocated(f2) <= 1
        f2a() = QuantumClifford._canonicalize!(s)
        f2a()
        allocated(f2a)
        @test allocated(f2a) <= 1
        c = random_clifford(500)
        f3() = apply!(s,c)
        f3()
        allocated(f3)
        #@test allocated(f3) <= 1 # TODO lower it by making apply! more efficient
        @test_broken false # the test above does not always work on julia 1.11+, depending on whether it runs in CI or not
        f4() = apply!(s,tCNOT,[5,20])
        f4()
        allocated(f4)
        #@test allocated(f4) <= 3 # TODO lower it by making apply! more efficient
        @test_broken false # the test above does not always work on julia 1.11+, depending on whether it runs in CI or not
        for phases in [(false,false),(false,true),(true,false),(true,true)], i in 1:6
            g = enumerate_single_qubit_gates(i,qubit=10,phases=phases)
            f5() = apply!(s,g)
            f5()
            allocated(f5)
            @test allocated(f5) <= 2
        end
        for g in [sSWAP(10,200), sCNOT(10,200)]
            f6() = apply!(s,g)
            f6()
            allocated(f6)
            @test allocated(f6) <= 2
        end
    end
    @testset "random_destabilizer" begin
        N = 100
        memory = RandDestabMemory(N)
        f1() = RandDestabMemory(N)
        f1()
        f2() = random_destabilizer(Random.GLOBAL_RNG, memory)
        f2()
        f3() = Destabilizer(Tableau(memory.phasesarray, memory.xzs))
        f3()
        @test allocated(f1) < 12.5 * N^2 + 50 * N + 1000
        if VERSION >= v"1.11"
            @test abs(allocated(f2) - allocated(f3)) / allocated(f3) < 0.05
        end
    end
    @testset "project!" begin
        N = 100
        d = random_destabilizer(N)
        md = MixedDestabilizer(random_destabilizer(N))
        md.rank = 50
        s = copy(stabilizerview(d))
        ms = MixedStabilizer(s)
        ms.rank = 50
        p = s[end];
        f1() = project!(s,p)
        f1()
        f2() = project!(ms,p)
        f2()
        f3() = project!(d,p)
        f3()
        f4() = project!(md,p)
        f4()
        allocated(f1)
        allocated(f2)
        allocated(f3)
        allocated(f4)
        @test allocated(f1) <= 15
        @test allocated(f2) <= 12
        @test allocated(f3) <= 6
        @test allocated(f4) <= 8
        for p! in [projectX!, projectY!, projectZ!]
            md = MixedDestabilizer(random_destabilizer(N))
            md.rank = 50
            f5() = p!(md,40)
            f5()
            allocated(f5)
            @test allocated(f5) <= 7
        end
    end
    @testset "tensor product" begin
        stabs = [s[1:5] for s in [random_stabilizer(n) for n in [63,64,65,127,128,129]]]
        f1() = ⊗(stabs...)
        f1()
        allocated(f1)
        @test allocated(f1) <= 18
    end
end

using CairoMakie
using AlgebraOfGraphics
using QuantumClifford
using PkgBenchmark
using DataFrames
using DataFramesMeta
using Statistics
using Glob

function results_to_dataframe(res)
    recs = []
    bmg = res.benchmarkgroup
    for taxon1 in keys(bmg)
        for taxon2 in keys(bmg[taxon1])
            for taxon3 in keys(bmg[taxon1][taxon2])
                best = minimum(bmg[taxon1][taxon2][taxon3])
                time = best.time
                memory = best.memory
                allocs = best.allocs
                push!(recs, (;taxon1,taxon2,taxon3,time,memory,allocs))
            end
        end
    end
    DataFrame(recs)
end

##
cd("QuantumCliffordBenchmarksLog/logs")
##

files = glob("*.benchmarkresults")
subframes = []
for f in files
    m = match(r"tag=(v[\d\.]*)-nthreads=(\d)-julia=([\d\.\w]*).benchmarkresults", f)
    if isnothing(m)
        @warn "problem with $(f)"
        continue
    end
    sdf = results_to_dataframe(readresults(f))
    #sdf[!,:tag] .= m.captures[1]
    sdf[!,:version] .= VersionNumber(m.captures[1][2:end])
    sdf[!,:threads] .= m.captures[2]
    #sdf[!,:julia] .= m.captures[3]
    sdf[!,:julia] .= m.captures[3]=="nightly" ? v"1.999" : VersionNumber(m.captures[3])
    push!(subframes, sdf)
end

##

df = vcat(subframes...)
maxjversion = maximum(df[df.julia .!= v"1.999",:julia])
df[df.julia .== v"1.999", :julia] .= VersionNumber(maxjversion.major, maxjversion.minor+1, 0)
df[!,:fullname] .= df[:,:taxon1] .* "-" .* df[:,:taxon2] .* "-" .* df[:,:taxon3]
df[!,:groupname] .= df[:,:taxon1] .* "-" .* df[:,:taxon2]
df[!,:logtime] .= log10.(df[:,:time])
df_min = combine(groupby(df, [:taxon3, :taxon2, :taxon1, :julia, :threads]), :logtime=>minimum=>:minlogtime)
df = outerjoin(df, df_min, on=[:taxon3, :taxon2, :taxon1, :julia, :threads])
df[!,:normlogtime] .= df[:,:logtime] .- df[:,:minlogtime]

df2 = combine(groupby(df, [:groupname, :taxon1, :version, :julia, :threads]), :normlogtime=>mean=>:logtime)
df1 = combine(groupby(df2, [:taxon1, :version, :julia, :threads]), :logtime=>mean=>:logtime)
df0 = combine(groupby(df1, [:version, :julia, :threads]), :logtime=>mean=>:logtime)

layers = visual(Stairs, step=:center)
axis = (;width = 500, height = 400, xticklabelrotation=-pi/3)
facet = (;linkyaxes=:minimal)

##

benchmark_data3 = data(df)
mappings3 = mapping(:version, :time, color=:julia, row=:fullname, col=:threads)
f3 = draw(benchmark_data3 * layers * mappings3; facet, axis)
save("../benchmarks3.png",f3)

benchmark_data2 = data(df2)
mappings2 = mapping(:version, :logtime, color=:julia, row=:groupname, col=:threads)
f2 = draw(benchmark_data2 * layers * mappings2; facet, axis)
save("../benchmarks2.png",f2)

benchmark_data1 = data(df1)
mappings1 = mapping(:version, :logtime, color=:julia, row=:taxon1, col=:threads)
f1 = draw(benchmark_data1 * layers * mappings1; facet, axis)
save("../benchmarks1.png",f1)

benchmark_data0 = data(df0)
mappings0 = mapping(:version, :logtime, color=:julia, col=:threads)
f0 = draw(benchmark_data0 * layers * mappings0; facet, axis)
save("../benchmarks0.png",f0)

mappings3a = mapping(:version, :allocs, color=:julia, row=:fullname, col=:threads)
f3a = draw(benchmark_data3 * layers * mappings3a; facet, axis)
save("../benchmarks3_allocs.png",f3a)

# TODO: implement apply!(::GeneralizedStabilizer, ::sT)
"""
$(TYPEDEF)

T gate (π/8 phase rotation). This is a non-Clifford gate with optimal
stabilizer extent ξ(T) = (cos(π/8) + tan(π/8)sin(π/8))² ≈ 1.172.

The T gate is diagonal in the computational basis:
T = diag(1, e^(iπ/4)) = R_z(π/4)

$(TYPEDFIELDS)

# Example
```jldoctest
julia> circuit = [sHadamard(1), sT(1), sHadamard(1)];

julia> result = emtrajectories(circuit, 1; trajectories=100);

julia> size(measurements(result))
(100, 1)
```
"""
struct sT <: AbstractNonCliffordOperator
    "Target qubit index (1-indexed)"
    qubit::Int

    function sT(q::Int)
        q > 0 || throw(ArgumentError("Qubit index must be positive, got $q"))
        new(q)
    end
end

nqubits(::sT) = 1

# TODO: implement apply!(::GeneralizedStabilizer, ::sCCZ)
"""
$(TYPEDEF)

Controlled-Controlled-Z gate. This is a non-Clifford gate with optimal
stabilizer extent ξ(CCZ) = 16/9 ≈ 1.778.

The CCZ gate applies a phase of -1 when all three qubits are in state |1⟩:
CCZ|xyz⟩ = (-1)^(xyz)|xyz⟩

$(TYPEDFIELDS)

# Example
```jldoctest
julia> circuit = [sHadamard(1), sHadamard(2), sHadamard(3), sCCZ(1, 2, 3)];

julia> result = emtrajectories(circuit, 3; trajectories=100);

julia> size(measurements(result))
(100, 3)
```
"""
struct sCCZ <: AbstractNonCliffordOperator
    "Target qubit indices (sorted, 1-indexed)"
    qubits::NTuple{3, Int}

    function sCCZ(q1::Int, q2::Int, q3::Int)
        all(q -> q > 0, (q1, q2, q3)) || throw(ArgumentError("All qubit indices must be positive"))
        length(unique((q1, q2, q3))) == 3 || throw(ArgumentError("CCZ requires 3 distinct qubits, got $q1, $q2, $q3"))
        new(Tuple(sort([q1, q2, q3])))
    end
end

sCCZ(qubits::Vector{Int}) = sCCZ(qubits[1], qubits[2], qubits[3])

nqubits(::sCCZ) = 3

@testitem "ECC GHP Code" tags=[:ecc, :ecc_bespoke_checks] begin
    using Hecke
    using QuantumClifford
    using QuantumClifford: stab_looks_good, gf2_row_echelon_with_pivots!
    using QuantumClifford.ECC
    using Nemo: matrix, GF
    using QECCore
    using QuantumClifford.ECC: random_qc_ghp_code_matrix_A

    @testset "Appendix B of [panteleev2021degenerate](@cite)" begin
        # [[882, 24, 18 ≤ d ≤ 24]]
        F = GF(2)
        R, x = polynomial_ring(F, "x")
        n = 7
        l = 63
        S, _ =  quo(R, x^l - 1)
        A = matrix(S, n, n,
            [x^27  0     0     0     0     1     x^54
             x^54  x^27  0     0     0     0     1
             1     x^54  x^27  0     0     0     0
             0     1     x^54  x^27  0     0     0
             0     0     1     x^54  x^27  0     0
             0     0     0     1     x^54  x^27  0
             0     0     0     0     1     x^54  x^27])
        b = S(1 + x + x^6)
        c = GeneralizedHyperGraphProduct(A, b, l)
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 882 == code_n(stab) && code_k(c) == 24 == code_k(stab)
        @test stab_looks_good(stab, remove_redundant_rows=true)
        @test all(sum(parity_matrix_x(c), dims=1) .== 3)
        @test all(sum(parity_matrix_x(c), dims=2) .== 6)
        @test all(sum(parity_matrix_z(c), dims=1) .== 3)
        @test all(sum(parity_matrix_z(c), dims=2) .== 6)

        # [[882, 48, 16]]
        F = GF(2)
        R, x = polynomial_ring(F, "x")
        n = 7
        l = 63
        S, _ =  quo(R, x^l - 1)
        A = matrix(S, n, n,
            [x^27   0     0     1     x^18  x^27  1
             1      x^27  0     0     1     x^18  x^27
             x^27   1     x^27  0     0     1     x^18
             x^18   x^27  1     x^27  0     0     1
             1      x^18  x^27  1     x^27  0     0
             0      1     x^18  x^27  1     x^27  0
             0      0     1     x^18  x^27  1     x^27])
        b = S(1 + x + x^6)
        c = GeneralizedHyperGraphProduct(A, b, l)
        stab = parity_checks(c);
        mat = matrix(GF(2), stab_to_gf2(stab));
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 882 == code_n(stab) && code_k(c) == 48 == code_k(stab)
        @test stab_looks_good(stab, remove_redundant_rows=true)
        @test all(sum(parity_matrix_x(c), dims=2) .== 8)
        @test all(sum(parity_matrix_z(c), dims=2) .== 8)
        @test count(==(3), vec(sum(parity_matrix_x(c), dims=1))) == size(parity_matrix_x(c), 2) ÷ 2
        @test count(==(5), vec(sum(parity_matrix_x(c), dims=1))) == size(parity_matrix_x(c), 2) ÷ 2
        @test count(==(3), vec(sum(parity_matrix_z(c), dims=1))) == size(parity_matrix_z(c), 2) ÷ 2
        @test count(==(5), vec(sum(parity_matrix_z(c), dims=1))) == size(parity_matrix_z(c), 2) ÷ 2

        # [[1270, 28, 16≤ d ≤ 46]]
        n = 5
        l = 127
        S, _ =  quo(R, x^l - 1)
        A = matrix(S, n, n,
            [1     0     x^51  x^52  0
             0     1     0     x^111 x^20
             1     0     x^98  0     x^122
             1     x^80  0     x^119 0
             0     1     x^5   0     x^106])
        b = S(1 + x + x^7)
        c = GeneralizedHyperGraphProduct(A, b, l)
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 1270 == code_n(stab) && code_k(c) == 28 == code_k(stab)
        @test stab_looks_good(stab, remove_redundant_rows=true)
        @test all(sum(parity_matrix_x(c), dims=1) .== 3)
        @test all(sum(parity_matrix_x(c), dims=2) .== 6)
        @test all(sum(parity_matrix_z(c), dims=1) .== 3)
        @test all(sum(parity_matrix_z(c), dims=2) .== 6)
    end

    @testset "random quasi-cyclic A matrix tests for quasi-cyclic GHP codes" begin
        F = GF(2)
        R, x = polynomial_ring(F, "x")
        l = 63
        n = 7
        w = 3
        S, _ =  quo(R, x^l - 1)
        b = S(1 + x + x^6)
        for _ in 1:5
            for n in 5:7
                b_w = degree(lift(b))
                A = random_qc_ghp_code_matrix_A(S, b,  n, w, l)
                c = GeneralizedHyperGraphProduct(A, b, l)
                stab = parity_checks(c)
                mat = matrix(GF(2), stab_to_gf2(stab))
                computed_rank = rank(mat)
                @test computed_rank == code_n(c) - code_k(c)
                @test stab_looks_good(stab, remove_redundant_rows=true)
                @test all(sum(parity_matrix_x(c), dims=1) .== w)
                @test all(sum(parity_matrix_z(c), dims=2) .== b_w)
                @test all(sum(parity_matrix_x(c), dims=1) .== w)
                @test all(sum(parity_matrix_z(c), dims=2) .== b_w)
            end
        end
    end
end

@testitem "ECC Bivaraite Bicycle as 2BGA" tags=[:ecc] begin
    using Hecke
    using HiGHS
    using JuMP
    using Hecke: group_algebra, GF, abelian_group, gens, one
    using QuantumClifford.ECC: two_block_group_algebra_codes, code_k, code_n, distance, DistanceMIPAlgorithm

    @testset "Reproduce Table 3 bravyi2024high" begin
        # [[72, 12, 6]]
        l=6; m=6
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^3 + y + y^2
        B = y^3 + x + x^2
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 72 && code_k(c) == 12
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6

        # [[90, 8, 10]]
        l=15; m=3
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^9 + y   + y^2
        B = 1   + x^2 + x^7
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 90 && code_k(c) == 8

        # [[108, 8, 10]]
        l=9; m=6
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^3 + y + y^2
        B = y^3 + x + x^2
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 108 && code_k(c) == 8

        # [[144, 12, 12]]
        l=12; m=6
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^3 + y + y^2
        B = y^3 + x + x^2
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 144 && code_k(c) == 12

        # [[288, 12, 12]]
        l=12; m=12
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^3 + y^2 + y^7
        B = y^3 + x   + x^2
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 288 && code_k(c) == 12

        # [[360, 12, ≤ 24]]
        l=30; m=6
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^9 + y    + y^2
        B = y^3 + x^25 + x^26
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 360 && code_k(c) == 12

        # [[756, 16, ≤ 34]]
        l=21; m=18
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^3 + y^10 + y^17
        B = y^5 + x^3  + x^19
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 756 && code_k(c) == 16
    end

    @testset "Reproduce Table 1 berthusen2024toward" begin
        # [[72, 8, 6]]
        l=12; m=3
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^9 + y + y^2
        B = 1   + x + x^11
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 72 && code_k(c) == 8
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6

        # [[90, 8, 6]]
        l=9; m=5
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^8 + y^4 + y
        B = y^5 + x^8 + x^7
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 90 && code_k(c) == 8
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6

        # [[120, 8, 8]]
        l=12; m=5
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^10 + y^4 + y
        B = 1    + x   + x^2
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 120 && code_k(c) == 8

        # [[150, 8, 8]]
        l=15; m=5
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^5 + y^2 + y^3
        B = y^2 + x^7 + x^6
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 150 && code_k(c) == 8

        # [[196, 12, 8]]
        l=14; m=7
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^6 + y^5 + y^6
        B = 1   + x^4 + x^13
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 196 && code_k(c) == 12
    end

    @testset "Reproduce Table 1 wang2024coprime" begin
        # [[54, 8, 6]]
        l=3; m=9
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = 1   + y^2 + y^4
        B = y^3 + x   + x^2
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 54 && code_k(c) == 8
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6

        # [[98, 6, 12]]
        l=7; m=7
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^3 + y^5 + y^6
        B = y^2 + x^3 + x^5
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 98 && code_k(c) == 6

        # [[126, 8, 10]]
        l=3; m=21
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = 1   + y^2 + y^10
        B = y^3 + x  +  x^2
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 126 && code_k(c) == 8

        # [[150, 16, 8]]
        l=5; m=15
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = 1   + y^6 + y^8
        B = y^5 + x   + x^4
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 150 && code_k(c) == 16

        # [[162, 8, 14]]
        l=3; m=27
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = 1    + y^10 + y^14
        B = y^12 + x    + x^2
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 162 && code_k(c) == 8

        # [[180, 8, 16]]
        l=6; m=15
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^3 + y   + y^2
        B = y^6 + x^4 + x^5
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 180 && code_k(c) == 8
    end

    @testset "Reproduce Table 1 eberhardt2024logical" begin
        # [[108, 16, 6]]
        l=6; m=9
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = 1 +   y   + y^2
        B = y^3 + x^2 + x^4
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 108 && code_k(c) == 16

        # [[128, 14, 12]]
        l=8; m=8
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^2 + y + y^3 + y^4
        B = y^2 + x + x^3 + x^4
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 128 && code_k(c) == 14

        # [[162, 4, 16]]
        l=9; m=9
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = 1   + x + y
        B = x^3 + y + y^2
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 162 && code_k(c) == 4

        # [[162, 12, 8]]
        l=9; m=9
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = 1   + x   + y^6
        B = y^3 + x^2 + x^3
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 162 && code_k(c) == 12

        # [[162, 24, 6]]
        l=9; m=9
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = 1   + y   + y^2
        B = y^3 + x^3 + x^6
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 162 && code_k(c) == 24

        # [[270, 8, 18]]
        l=9; m=15
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^3 + y + y^2
        B = y^3 + x + x^2
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 270 && code_k(c) == 8

        # [[98, 6, 12]]
        l=7; m=7
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x + y^3 + y^4
        B = y + x^3 + x^4
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 98 && code_k(c) == 6

        # [[162, 8, 12]]
        l=9; m=9
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        A = x^3 + y + y^2
        B = y^3 + x + x^2
        c = two_block_group_algebra_codes(A,B)
        @test code_n(c) == 162 && code_k(c) == 8
    end
end

"""A convenience struct to represent the status of a circuit simulated by [`mctrajectories`](@ref)"""
struct CircuitStatus
    status::Int
end

"""Returned by [`applywstatus!`](@ref) if the circuit simulation should continue."""
const continue_stat = CircuitStatus(0)

"""Returned by [`applywstatus!`](@ref) if the circuit reports a success and there is no undetected error.

See also: [`VerifyOp`](@ref), [`BellMeasurement`](@ref)."""
const true_success_stat = CircuitStatus(1)

"""Returned by [`applywstatus!`](@ref) if the circuit reports a success, but it is a false positive (i.e., there was an undetected error).

See also: [`VerifyOp`](@ref), [`BellMeasurement`](@ref)."""
const false_success_stat = CircuitStatus(2)

"""Returned by [`applywstatus!`](@ref) if the circuit reports a failure.

See also: [`VerifyOp`](@ref), [`BellMeasurement`](@ref)."""
const failure_stat = CircuitStatus(3)

const registered_statuses = ["continue",
                             "true_success",
                             "false_success",
                             "failure"
                             ]

function Base.show(io::IO, s::CircuitStatus)
    print(io, get(registered_statuses,s.status+1,nothing))
    print(io, ":CircuitStatus($(s.status))")
end

"""Used for [`mctrajectories`](@ref)."""
function applywstatus!(state, op)
    apply!(state,op), continue_stat
end

"""Run a single Monte Carlo sample, starting with (and modifying) `state` by applying the given `circuit`. Uses `apply!` under the hood."""
function mctrajectory!(state,circuit)
    for op in circuit
        state, cont = applywstatus!(state, op)
        if cont!=continue_stat
            return state, cont
        end
    end
    return state, continue_stat
end

function countmap(samples) # A simpler faster version of StatsBase.countmap that only works for CircuitStatus
    counts = zeros(length(registered_statuses))
    for s in samples
        counts[s.status+1] += 1
    end
    Dict(CircuitStatus(i-1)=>counts[i] for i in eachindex(counts))
end

"""Run multiple Monte Carlo trajectories and report the aggregate final statuses of each.

See also: [`pftrajectories`](@ref), [`petrajectories`](@ref)"""
mctrajectories(initialstate,circuit;trajectories=500,keepstates::Bool=false) = _mctrajectories(initialstate,circuit;trajectories,keepstates=Val(keepstates))

function _mctrajectories(initialstate,circuit;trajectories=500,keepstates::Val{B}=Val(false)) where {B}
    if B
        counter = DefaultDict{Tuple{typeof(initialstate),CircuitStatus},Int}
        counts = counter((mctrajectory!(copy(initialstate),circuit)[2] for i in 1:trajectories)) # TODO use threads or at least a generator
        return counts
    else
        counts = countmap((mctrajectory!(copy(initialstate),circuit)[2] for i in 1:trajectories)) # TODO use threads or at least a generator
        return counts
    end
end

@testitem "Row echelon with pivots" begin
    using Random
    using Nemo
    using Nemo: echelon_form, matrix, GF
    using QuantumClifford
    using QuantumClifford: gf2_row_echelon_with_pivots!, gf2_nullspace, gf2_rowspace_basis
    test_sizes = [1,2,10,63,64,65,127,128,129]

    @testset "GF(2) row echelon form with transformation matrix, pivots etc." begin
        for n in test_sizes
            for rep in 1:10
                gf2_matrices = [rand(Bool, size, size) for size in test_sizes]
                for (i, mat) in enumerate(gf2_matrices)
                    naive_echelon_form, _, transformation, _ = gf2_row_echelon_with_pivots!(Matrix{Int}(mat), full=true) # in-place
                    # Check the correctness of the transformation matrix
                    @test (transformation*mat) .%2 == naive_echelon_form
                    # Check the correctness of Gaussian elimination
                    @test naive_echelon_form == gf2_gausselim!(mat)
                    # Consistency check with Nemo.jl's echelon_form
                    nemo_mat =  matrix(GF(2), Matrix{Int}(mat))
                    @test echelon_form(nemo_mat) == matrix(GF(2), naive_echelon_form)
                end
            end
        end
    end

    function is_in_nullspace(A, x)
        # Ensure x is the correct orientation
        if size(x, 1) != size(A, 2)
            x = transpose(x)
        end
        # Perform modulo 2 arithmetic: A * x must be zero mod 2
        if size(x, 2) == 1  # x is a single column vector
            result = A * x
            return all(result .% 2 .== 0)  # Check if A * x = 0 mod 2
        else  # x is a matrix, check each column vector
            for i in 1:size(x, 2)
                result = A * x[:, i] # Multiply A with the i-th column of x
                if !all(result .% 2 .== 0) # Check if A * column = 0 mod 2
                    return false
                end
            end
            return true # All columns are in the null space mod 2
        end
    end

    @testset "GF(2) nullspace of the binary matrix" begin
        for n in test_sizes
            for rep in 1:10
                gf2_matrices = [rand(Bool, size, size) for size in test_sizes]
                for (i, matrix) in enumerate(gf2_matrices)
                    imat = Matrix{Int}(matrix)
                    ns = gf2_nullspace(imat)
                    @test is_in_nullspace(imat, ns)
                end
            end
        end
    end

    @testset "Consistency check with ldpc" begin
        # sanity checks for comparison to https://github.com/quantumgizmos/ldpc
        # results compared with 'from ldpc.mod2 import nullspace, row_basis, row_echelon'
        # Consistency check 1
        H = [1 1 1; 1 1 1; 0 1 0]
        echelon_form, rank, transformation, pivots = gf2_row_echelon_with_pivots!(copy(H)) # in-place
        @test echelon_form == [1 1 1; 0 1 0; 0 0 0]
        @test rank == 2
        @test transformation == [1 0 0; 0 0 1; 1 1 0]
        @test pivots == [1, 2] # in python, it's [0, 1] due to zero-indexing
        @test mod.((transformation*copy(H)), 2) == echelon_form
        @test gf2_nullspace(copy(H)) == [1 0 1]
        @test gf2_rowspace_basis(copy(H)) == [1 1 1; 0 1 0]
        # Consistency check 2
        H = [0 0 0 1 1 1 1;
             0 1 1 0 0 1 1;
             1 0 1 0 1 0 1]
        echelon_form, rank, transformation, pivots = gf2_row_echelon_with_pivots!(copy(H)) # in-place
        @test echelon_form == [1 0 1 0 1 0 1;
                               0 1 1 0 0 1 1;
                               0 0 0 1 1 1 1]
        @test rank == 3
        @test transformation == [0 0 1;
                                 0 1 0;
                                 1 0 0]
        @test pivots == [1, 2, 4] # in python, it's [0, 1, 3] due to zero-indexing
        @test mod.((transformation*copy(H)), 2) == echelon_form
        @test gf2_nullspace(copy(H)) == [1 1 1 0 0 0 0;
                                         0 1 1 1 1 0 0;
                                         0 1 0 1 0 1 0;
                                         0 0 1 1 0 0 1]
        @test gf2_rowspace_basis(copy(H)) == [0 0 0 1 1 1 1;
                                              0 1 1 0 0 1 1;
                                              1 0 1 0 1 0 1]
        # Consistency check 3
        H = [1 1 0; 0 1 1; 1 0 1]
        echelon_form, rank, transformation, pivots = gf2_row_echelon_with_pivots!(copy(H)) # in-place
        @test echelon_form == [1 1 0;
                               0 1 1;
                               0 0 0]
        @test rank == 2
        @test transformation == [1 0 0;
                                 0 1 0;
                                 1 1 1]
        @test pivots == [1,2 ] # in python, it's [0, 1] due to zero-indexing
        @test mod.((transformation*copy(H)), 2) == echelon_form
        @test gf2_nullspace(copy(H)) == [1 1 1]
        @test gf2_rowspace_basis(copy(H)) == [1 1 0;
                                              0 1 1]
        # Consistency check 4
        H = [1 1 0; 0 1 0; 0 0 1]
        echelon_form, rank, transformation, pivots = gf2_row_echelon_with_pivots!(copy(H)) # in-place
        @test echelon_form == [1 1 0;
                               0 1 0;
                               0 0 1]
        @test rank == 3
        @test transformation == [1 0 0;
                                 0 1 0;
                                 0 0 1]
        @test pivots == [1, 2, 3]  # in python, it's [0, 1, 2] due to zero-indexing
        @test mod.((transformation*copy(H)), 2) == echelon_form
        @test gf2_nullspace(copy(H)) == [0 0 0]
        @test gf2_rowspace_basis(copy(H)) == [1 1 0;
                                              0 1 0;
                                              0 0 1]
        # Consistency check 5
        H = [1 1 0; 0 1 0; 0 0 1; 0 1 1]
        echelon_form, rank, transformation, pivots = gf2_row_echelon_with_pivots!(copy(H)) # in-place
        @test echelon_form == [1 1 0;
                               0 1 0;
                               0 0 1;
                               0 0 0]
        @test rank == 3
        @test transformation == [1 0 0 0;
                                 0 1 0 0;
                                 0 0 1 0;
                                 0 1 1 1]
        @test pivots == [1, 2, 3] # in python, it's [0, 1, 2] due to zero-indexing
        @test mod.((transformation*copy(H)), 2) == echelon_form
        @test gf2_nullspace(copy(H)) == [0 0 0]
        @test gf2_rowspace_basis(copy(H)) == [1 1 0;
                                              0 1 0;
                                              0 0 1]
        # Consistency check 6
        H = [0 0 0 1 1 1 1;
             0 1 1 0 0 1 1;
             1 0 1 0 1 0 1]
        echelon_form, rank, transformation, pivots = gf2_row_echelon_with_pivots!(copy(H)) # in-place
        @test echelon_form == [1 0 1 0 1 0 1;
                               0 1 1 0 0 1 1;
                               0 0 0 1 1 1 1]
        @test rank == 3
        @test transformation == [0 0 1;
                                 0 1 0;
                                 1 0 0]
        @test pivots == [1, 2, 4]  # in python, it's [0, 1, 3] due to zero-indexing
        @test mod.((transformation*copy(H)), 2) == echelon_form
        @test gf2_nullspace(copy(H)) == [1 1 1 0 0 0 0;
                                         0 1 1 1 1 0 0;
                                         0 1 0 1 0 1 0;
                                         0 0 1 1 0 0 1]
        @test gf2_rowspace_basis(copy(H)) == [0 0 0 1 1 1 1;
                                              0 1 1 0 0 1 1;
                                              1 0 1 0 1 0 1]
    end
end

# convert from oscar mat to regular mat type
matrix_to_int(m::MatElem) = [Int(lift(ZZ, matrix(m)[i,j])) for i in 1:nrows(matrix(m)), j in 1:ncols(matrix(m))]

function fq_to_int(δ::FqMatrix)
    m, n = size(δ)
    int_δ = Matrix{Int}(undef, m, n)
    @inbounds for j in 1:n, i in 1:m
        int_δ[i,j] = iszero(δ[i,j]) ? 0 : 1
    end
    return int_δ
end

const VectorFPGroupElem = Vector{FPGroupElem}

const VectorDirectProductGroupElem = Vector{GroupAlgebraElem{FqFieldElem, GroupAlgebra{FqFieldElem, DirectProductGroup, BasicGAPGroupElem{DirectProductGroup}}}}

const FqFieldFPGroupAlgebra = GroupAlgebra{FqFieldElem, FPGroup, FPGroupElem}

const DirectProductGroupAlgebra = GroupAlgebra{FqFieldElem, DirectProductGroup, BasicGAPGroupElem{DirectProductGroup}}

@testitem "group theory tools" begin
    using Test
    using Random
    using QuantumClifford

    # Including sizes that would test off-by-one errors in the bit encoding.
    test_sizes = [1, 2, 3, 4, 5, 7, 8, 9]
    # Zero function(in groupify) slows down around 2^30(n=30),eventually breaks
    small_test_sizes = [1, 2, 3, 4, 5, 7] # Pauligroup slows around n = 8

    @testset "group theory tools" begin
        #Test groupify
        for n in [1, test_sizes...]
            s = random_stabilizer(n)
            s_test = copy(s)
            group = groupify(s)
            @test length(group) == 2^n
            for stabilizer in group
                apply!(s, stabilizer)
                @test s == s_test
            end
        end
        #Test minimal_generating_set
        for n in [1, test_sizes...]
            s = random_stabilizer(n)
            group = groupify(s)
            gen_set = minimal_generating_set(Stabilizer(group))
            @test length(group) == 2^(length(gen_set))
            new_group = groupify(gen_set)
            s1, _, r = canonicalize!(Stabilizer(group), ranks = true)
            s2, _, r = canonicalize!(Stabilizer(new_group), ranks=true)
            @test group[1:r, :] == new_group[1:r, :]
        end
        #Test canonicalize_noncomm
        for n in [1, small_test_sizes...]
            t = zero(QuantumClifford.Tableau, rand(1:(2*n)), n)
            for i in eachindex(t) t[i] = random_pauli(n) end
            loc = canonicalize_noncomm(t)
            for i in 1:loc.k
                for j in 1:loc.k
                    if i == j
                        @test comm(logicalxview(loc)[i], logicalzview(loc)[j]) == 0x01
                    else @test comm(logicalxview(loc)[i], logicalzview(loc)[j]) == 0x00 end
                end
            end
            for i in stabilizerview(loc)
                for j in stabilizerview(loc) @test comm(i, j) == 0x00 end
                for j in logicalzview(loc) @test comm(i, j) == 0x00 end
                for j in logicalxview(loc) @test comm(i, j) == 0x00 end
            end
        end
        #Test commutify
        for n in [1, small_test_sizes...]
            t = zero(QuantumClifford.Tableau, rand(1:(2*n)), n)
            for i in eachindex(t) t[i] = random_pauli(n) end
            c, d = commutify(t)
            for i in c
                for j in c
                    @test comm(i, j) == 0x00
                end
            end
            for i in d
                for p in c
                    @test p[i] != (true, true)
                end
            end
            loc1= delete_columns(c, d)
            loc2 = canonicalize_noncomm(t).tab
            for i in eachindex(delete_columns(c, d))
            end
        end
        #Test matroid_parent
        for n in [1,2,3,4,5]
            t = zero(QuantumClifford.Tableau, 2*n, n)
            for i in eachindex(t) t[i] = random_pauli(n) end
            e, d2, d1 = matroid_parent(t)
            s = Stabilizer(groupify(e))
            for i in e for j in e @test comm(i, j)==0x00 end end
            @test 2^(nqubits(s)) == length(s) #assumes commutativise works
            #find original tableau from matroid_parentded state, ignoring phases
            inverted = delete_columns(Stabilizer(normalizer(delete_columns(Stabilizer(e), d2).tab)), d1)
            original = Stabilizer(groupify(Stabilizer(t)))
            canonicalize!(inverted)
            canonicalize!(original)
            @test inverted[1:length(inverted)].tab.xzs == original[1:length(inverted)].tab.xzs
        end
        #Test pauligroup
        for n in [1, small_test_sizes...]
            @test length(QuantumClifford.pauligroup(n, phases=false)) == 4^n
            @test length(QuantumClifford.pauligroup(n, phases=true)) == 4^(n+1)
        end
        #Test normalizer
        for n in [1, small_test_sizes...] # pauligroup is very slow at n=14
            t = zero(QuantumClifford.Tableau, rand(1:(2*n)), n)
            for i in eachindex(t) t[i] = random_pauli(n) end
            normalized = normalizer(t)
            paulis = QuantumClifford.pauligroup(n, phases=false)
            for n_pauli in normalized
                for t_pauli in t
                    @test comm(n_pauli, t_pauli) == 0x0
                end
            end
            for pauli in paulis
                commutes = true
                for t_pauli in t
                    if comm(t_pauli, pauli) == 0x01
                        commutes = false
                    end
                end
            @test (!commutes) || (pauli in normalized)
            end
        end
        #Test centralizer
        for n in [1, test_sizes...]
            t = zero(QuantumClifford.Tableau, rand(1:(2*n)), n)
            for i in eachindex(t) t[i] = random_pauli(n) end
            c = centralizer(t)
            for c_pauli in c
                for t_pauli in t
                    @test comm(c_pauli, t_pauli) == 0x0
                end
            end
            for pauli in t
                commutes = true
                for t_pauli in t
                    if comm(t_pauli, pauli)==0x01 commutes = false end
                end
                @test !commutes || pauli in c
            end

        end
        #Test contractor
        for n in [1, test_sizes...]
            s = random_stabilizer(n)
            subset = []
            for i in 1:nqubits(s) #create a random subset
                if rand(1:2) == 1 push!(subset, i) end
            end
            c = contractor(s, subset)
            count = 0
            for stabilizer in s
                contractable = true
                for i in subset
                    if stabilizer[i] != (false, false) contractable = false end
                end
                if contractable count+=1 end
            end
            if length(c[1]) > 0
            @test count == length(c)
                for contracted in c
                    p = zero(PauliOperator, nqubits(s))
                    index = 0
                    for i in 1:nqubits(s)
                        if !(i in subset)
                            index+=1
                            p[i] = contracted[index]
                        end
                    end
                    @test p in s || -1* p in s || 1im * p in s || -1im * p in s
                end
            else
                @test count ==0
            end
        end
    end
end

@testitem "Pauli Operators" begin
    using QuantumClifford: apply_single_x!, apply_single_y!, apply_single_z!
    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    @testset "Parsing, constructors, and properties" begin
        @test P"-iXYZ" == PauliOperator(0x3, 3, vcat(BitArray([1,1,0]).chunks, BitArray([0,1,1]).chunks))
        @test P"-iXYZ" == PauliOperator(0x3, Bool[1,1,0], Bool[0,1,1])
        @test P"XYZ" == PauliOperator(Bool[1,1,0],Bool[0,1,1])
        @test xbit(P"-iXYZ") == Bool[1,1,0]
        @test zbit(P"-iXYZ") == Bool[0,1,1]
        @test P"-iXYZ".xz == UInt64[0x03, 0x06]
        @test P"-iXYZ".phase[] == 0x03
        @test P"-iXYZ".nqubits == 3
        @test size(P"-iXYZ") == (3,)
    end
    @testset "Indexing" begin
        @test eachindex(P"IXYZ") == 1:4
        @test P"IXYZ"[3] == (true, true)
        p = P"IXYZ"
        @test firstindex(p):lastindex(p) == eachindex(p) == 1:length(p)
        @test p[[3,2]] == P"YX"
        p[4] = (true,false)
        @test p == P"IXYX"
    end
    @testset "Elementary operations" begin
        @test P"X"*P"Z" == P"-iY"
        @test P"X"⊗P"Z" == P"XZ"
        @test -P"X" == P"-X"
        @test +P"X" == P"X"
        @test 1*P"X" == P"X"
        @test 1.0*P"X" == P"X"
        @test -1*P"X" == P"-X"
        @test im*P"X" == P"iX"
        @test -im*P"X" == P"-iX"
        @test_throws DomainError 0.5*P"X"
        @test comm(P"XX",P"YY") == 0x0
        @test comm(P"XZ",P"YZ") == comm(S"II XZ",P"YZ", 2) == comm(P"XZ",S"II YZ", 2) == comm(S"II XZ",P"YZ")[2] == comm(P"XZ",S"II YZ")[2] == 0x1
        @test prodphase(P"XX",P"YY") == 0x2
        @test prodphase(P"ZZZ",P"XXX") == prodphase(S"III ZZZ",P"XXX",2) == prodphase(P"ZZZ",S"III XXX",2) == prodphase(S"III ZZZ",S"III XXX",2,2) == 0x3
    end

    for Pop in [P"X", P"iX", P"-iXYZ", random_pauli(100; nophase=false, realphase=false)]
        @test Pop * inv(Pop) == zero(Pop)
    end

    @testset "Commutation implies real phase" begin
        for i in 1:10
            for n in test_sizes
                p1,p2 = random_pauli(n; nophase=true), random_pauli(n; nophase=true)
                com = comm(p1,p2)==0x0
                p = prodphase(p1,p2)
                rea = p==0x0 || p==0x2
                @test (com && rea) || (!com && !rea)
            end
        end
    end
    @testset "Prodphase" begin
        for i in 1:10
            for n in test_sizes
                p1,p2 = random_pauli(n; nophase=true), random_pauli(n; nophase=true)
                p = prodphase(p1.xz,p2.xz)
                @test p == QuantumClifford._stim_prodphase(p1.xz,p2.xz)&0x3
            end
        end
    end
    @testset "Single qubit Paulis and their action" begin
        for i in 1:3
            for n in test_sizes
                for t in [Stabilizer, Destabilizer, MixedDestabilizer]
                    x, y, z = rand(1:n), rand(1:n), rand(1:n)
                    px = single_x(n,x)
                    py = single_y(n,y)
                    pz = single_z(n,z)
                    rstab = random_stabilizer(n)
                    s1 = t(rstab)
                    s2 = copy(s1)
                    s3 = copy(s1)
                    apply!(s1,px)
                    apply_single_x!(s2,x)
                    apply!(s3,P"X",[x])
                    @test s1==s2==s3
                    apply!(s1,py)
                    apply_single_y!(s2,y)
                    apply!(s3,P"Y",[y])
                    @test s1==s2==s3
                    apply!(s1,pz)
                    apply_single_z!(s2,z)
                    apply!(s3,P"Z",[z])
                    @test s1==s2==s3
                end
            end
        end
    end
end

"""
Clifford Operator specified by the mapping of the basis generators.

```jldoctest
julia> tCNOT
X₁ ⟼ + XX
X₂ ⟼ + _X
Z₁ ⟼ + Z_
Z₂ ⟼ + ZZ

julia> phase_gate = C"Y
                      Z"
X₁ ⟼ + Y
Z₁ ⟼ + Z

julia> stab = S"XI
                IZ";


julia> entangled = tCNOT*stab
+ XX
+ ZZ

julia> CliffordOperator(T"YY")
ERROR: DimensionMismatch: Input tableau should be of size 2n×n (top half is the X mappings and the bottom half are the Z mappings).
[...]
```

[`Destabilizer`](@ref) can also be converted.
```jldoctest
julia> d = Destabilizer(S"Y")
𝒟ℯ𝓈𝓉𝒶𝒷
+ X
𝒮𝓉𝒶𝒷
+ Y

julia> CliffordOperator(d)
X₁ ⟼ + X
Z₁ ⟼ + Y
```
"""
struct CliffordOperator{T<:Tableau,P<:PauliOperator} <: AbstractCliffordOperator
    tab::T
    buffer::P
    function CliffordOperator(tab::Tableau)
        if size(tab,1)==2*size(tab,2)
            p = zero!(tab[1])
            new{typeof(tab),typeof(p)}(tab,p)
        #elseif size(stab,1)==size(stab,2) # TODO be able to work with squara tableaux (by reversing all row operations)
        #    destab = tab(Destabilizer(stab))
        #    new{typeof(destab.phases),typeof(destab.xzs)}(destab) # TODO be smarter about type signatures here... there should be a better way
        else
            throw(DimensionMismatch("Input tableau should be of size 2n×n (top half is the X mappings and the bottom half are the Z mappings)."))
        end
    end
end

macro C_str(a)
    tab = _T_str(a)
    quote CliffordOperator($tab) end
end

CliffordOperator(op::CliffordOperator) = op
CliffordOperator(paulis::AbstractVector{<:PauliOperator}) = CliffordOperator(Tableau(paulis))
CliffordOperator(destab::Destabilizer) = CliffordOperator(tab(destab))
function CliffordOperator(pauli::PauliOperator)
    res = one(CliffordOperator, nqubits(pauli))
    comm!(phases(res), pauli, tab(res))
    tab(res).phases .*= 0x02
    return res
end

Base.:(==)(l::CliffordOperator, r::CliffordOperator) = tab(l) == tab(r)
Base.hash(c::T, h::UInt) where {T<:CliffordOperator} = hash(T, hash(tab(c), h))

Base.getindex(c::CliffordOperator, args...) = getindex(tab(c), args...)
Base.setindex!(c::CliffordOperator, args...) = setindex!(tab(c), args...)

tab(c::CliffordOperator) = c.tab

Base.size(c::CliffordOperator,args...) = size(tab(c),args...)

function row_limit(str, limit=50)
    n = length(str)
    if (n <= limit || limit==-1)
        return str
    end
    padding = Int64(floor(limit/2))
    return SubString(str, 1, padding) * " ... " * SubString(str, n - padding, n - 1)
end

digits_subchars = collect("₀₁₂₃₄₅₆₇₈₉")
digits_substr(n::Int,nwidth::Int) = join(([digits_subchars[d+1] for d in reverse(digits(n, pad=nwidth))]))

function Base.copy(c::CliffordOperator)
    CliffordOperator(copy(tab(c)))
end

@inline nqubits(c::CliffordOperator) = nqubits(tab(c))
@inline phases(c::CliffordOperator) = phases(tab(c))

Base.zero(c::CliffordOperator) = CliffordOperator(zero(tab(c)))
Base.zero(::Type{<:CliffordOperator}, n) = CliffordOperator(zero(Tableau, 2n, n))

function Base.:(*)(l::AbstractCliffordOperator, r::CliffordOperator)
    tab = copy(QuantumClifford.tab(r))
    apply!(Stabilizer(tab),l) # TODO maybe not the most elegant way to perform apply!(::Tableau, gate)
    CliffordOperator(tab)
end

function apply!(r::CliffordOperator, l::AbstractCliffordOperator; phases=false)
    @valbooldispatch _apply!(Stabilizer(tab(r)),l;phases=Val(phases)) phases # TODO maybe not the most elegant way to perform apply!(::Tableau, gate)
    r
end

function apply_inv!(r::CliffordOperator, l::AbstractCliffordOperator; phases=false)
    @valbooldispatch _apply_inv!(Stabilizer(tab(r)),l,phases=Val(phases)) phases
    r
end

"""Nonvectorized version of `apply!` used for unit tests."""
function _apply_nonthread!(stab::AbstractStabilizer, c::CliffordOperator; phases::Bool=true)
    nqubits(stab)==nqubits(c) || throw(DimensionMismatch("The tableau and the Clifford operator need to act on the same number of qubits. Consider specifying an array of indices as a third argument to the `apply!` function to avoid this error."))
    s_tab = tab(stab)
    c_tab = tab(c)
    new_stabrow = c.buffer
    for row_stab in eachindex(s_tab)
        zero!(new_stabrow)
        apply_row_kernel!(new_stabrow, row_stab, s_tab, c_tab, phases=Val(phases))
    end
    stab
end

# TODO no need to track phases outside of stabview
function _apply!(stab::AbstractStabilizer, c::CliffordOperator; phases::Val{B}=Val(true)) where B
    nqubits(stab)==nqubits(c) || throw(DimensionMismatch("The tableau and the Clifford operator need to act on the same number of qubits. Consider specifying an array of indices as a third argument to the `apply!` function to avoid this error."))
    s_tab = tab(stab)
    c_tab = tab(c)
    threadlocal = c.buffer
    @inbounds for row_stab in eachindex(s_tab)
        zero!(threadlocal) # a new stabrow for temporary storage
        apply_row_kernel!(threadlocal, row_stab, s_tab, c_tab, phases=phases)
    end
    stab
end

function _apply_inv!(stab::AbstractStabilizer, c::CliffordOperator; phases::Val{B}=Val(true)) where B
    _apply!(stab, inv(c); phases=phases)
end

# TODO Added a lot of type assertions to help Julia infer types, but they are much too strict for cases where bitpacking varies (check tests)
@inline function apply_row_kernel!(new_stabrow, row, s_tab, c_tab; phases::Val{B}=Val(true)) where B
    B && (new_stabrow.phase[] = s_tab.phases[row])
    n = nqubits(c_tab)
    for qubit in 1:n
        x,z = s_tab[row,qubit]
        if B&&x&&z
            new_stabrow.phase[] -= 0x1
        end
        if x
            mul_left!(new_stabrow, c_tab, qubit, phases=phases)
        end
        if z
            mul_left!(new_stabrow, c_tab, qubit+n, phases=phases)
        end
    end
    s_tab[row] = new_stabrow
    new_stabrow
end

"""Nonvectorized version of `apply!` used for unit tests."""
function _apply_nonthread!(stab::AbstractStabilizer, c::CliffordOperator, indices_of_application::AbstractArray{Int,1}; phases::Bool=true)
    s_tab = tab(stab)
    c_tab = tab(c)
    new_stabrow = c.buffer
    for row in eachindex(s_tab)
        zero!(new_stabrow)
        apply_row_kernel!(new_stabrow, row, s_tab, c_tab, indices_of_application; phases=Val(phases))
    end
    stab
end

#TODO a lot of code repetition with apply!(stab::AbstractStabilizer, c::CliffordOperator; phases::Bool=true) and apply_row_kernel!
function _apply!(stab::AbstractStabilizer, c::CliffordOperator, indices_of_application::AbstractArray{Int,1}; phases::Val{B}=Val(true)) where B
    #max(indices_of_application)<=nqubits(s) || throw(DimensionMismatch("")) # Too expensive to check every time
    s_tab = tab(stab)
    c_tab = tab(c)
    threadlocal= c.buffer
    @inbounds for row_stab in eachindex(s_tab)
        zero!(threadlocal) # a new stabrow for temporary storage
        apply_row_kernel!(threadlocal, row_stab, s_tab, c_tab, indices_of_application, phases=phases)
    end
    stab
end

function _apply_inv!(stab::AbstractStabilizer, c::CliffordOperator, indices_of_application::AbstractArray{Int,1}; phases::Val{B}=Val(true)) where B
    _apply!(stab, inv(c), indices_of_application; phases=phases)
end

@inline function apply_row_kernel!(new_stabrow, row, s_tab, c_tab, indices_of_application; phases::Val{B}=Val(true)) where B
    B && (new_stabrow.phase[] = s_tab.phases[row])
    n = nqubits(c_tab)
    for (qubit_i, qubit) in enumerate(indices_of_application)
        x,z = s_tab[row,qubit]
        if B&&x&&z
            new_stabrow.phase[] -= 0x1
        end
        if x
            mul_left!(new_stabrow, c_tab, qubit_i, phases=phases)
        end
        if z
            mul_left!(new_stabrow, c_tab, qubit_i+n, phases=phases)
        end
    end
    for (qubit_i, qubit) in enumerate(indices_of_application)
        s_tab[row,qubit] = new_stabrow[qubit_i]
    end
    B && (s_tab.phases[row] = new_stabrow.phase[])
    new_stabrow
end

const tCNOT = C"XX
                IX
                ZI
                ZZ"

const tCPHASE = C"XZ
                  ZX
                  ZI
                  IZ"

const tSWAP = C"IX
                XI
                IZ
                ZI"

const tHadamard = C"Z
                    X"

const tPhase = C"Y
                 Z"

const tId1 = C"X
               Z"

@testitem "Hashing" begin
    @test hash(P"X") == hash(P"X")
    @test hash(S"X") == hash(S"X")
    @test hash(C"X Z") == hash(C"X Z")
    r = random_destabilizer(2)
    @test hash(r) == hash(copy(r))
end

@testitem "Stabilizers" begin
    using QuantumClifford
    using LinearAlgebra
    using Random: randperm
    using QuantumClifford: stab_looks_good, destab_looks_good, mixed_stab_looks_good, mixed_destab_looks_good
    test_sizes = [1,2,10,63,64,65] # Including sizes that would test off-by-one errors in the bit encoding.
    @testset "Pure and Mixed state initialization" begin

        @testset "Destabilizer initialization" begin
            for n in test_sizes
                s = random_stabilizer(n)
                d = Destabilizer(s)
                @test destab_looks_good(d)
                canonicalize!(s)
                s1 = copy(stabilizerview(d))
                canonicalize!(s1)
                @test s1 == s
            end
        end
        @testset "Mixed destabilizer initialization" begin
            for n in test_sizes
                n<10 && continue
                s = random_stabilizer(rand(n÷2+1:n-4),n)
                md = MixedDestabilizer(s)
                ms = MixedStabilizer(s)
                @test mixed_stab_looks_good(ms)
                @test mixed_destab_looks_good(md)
                canonicalize!(s)
                s1 = copy(stabilizerview(md))
                canonicalize!(s1)
                @test s1 == s == stabilizerview(canonicalize!(ms))
            end
            # Test initialization out of overdetermined stabs
            stabs = [S"XX
                     II",
                     S"XX
                     XX",
                     S"ZZ
                     ZZ"]
            for s in stabs
                md = MixedDestabilizer(s[1:1])
                @test MixedDestabilizer(s) == md
            end
        end
        @testset "one basis keyword" begin
            for basis in (:X, :Y, :Z)
                expected = one(Stabilizer, 3; basis=basis)

                destab = one(Destabilizer, 3; basis=basis)
                @test stabilizerview(destab) == expected
                @test stabilizerview(one(destab; basis=basis)) == expected
                @test destab_looks_good(destab)

                mixed_stab = one(MixedStabilizer, 2, 3; basis=basis)
                @test stabilizerview(mixed_stab) == expected[1:2]
                @test mixed_stab_looks_good(mixed_stab)
                @test one(MixedStabilizer, 2, 3, basis) == mixed_stab
                @test one(mixed_stab; basis=basis) == mixed_stab

                mixed_destab = one(MixedDestabilizer, 2, 3; basis=basis)
                @test stabilizerview(mixed_destab) == expected[1:2]
                @test mixed_destab_looks_good(mixed_destab)
                @test stabilizerview(one(MixedDestabilizer, 3; basis=basis)) == expected
                @test one(mixed_destab; basis=basis) == mixed_destab

                register = one(Register, 3, 2; basis=basis)
                @test quantumstate(register) == one(MixedDestabilizer, 3; basis=basis)
                @test bitview(register) == falses(2)
                @test bitview(one(Register, 3; basis=basis)) == Bool[]
                @test one(register; basis=basis) == register
            end
        end
    end

    @testset "Tensor products over stabilizers" begin
        for n in test_sizes
            n<10 && continue
            l = random_stabilizer(rand(n÷2+1:n-2),n)
            r = random_stabilizer(rand(n÷3:n÷2),rand(n÷2:n))
            s = l⊗r
            ds = MixedDestabilizer(l)⊗MixedDestabilizer(r)
            @test mixed_destab_looks_good(ds)
            canonicalize!(s)
            dss = canonicalize!(copy(stabilizerview(ds)))
            @test s == dss
            stabs = [s[1:i] for s in [random_stabilizer(n) for n in [32,16,16,64,63,65]] for i in rand(1:10)];
            mdstabs = MixedDestabilizer.(stabs);
            @test canonicalize!(⊗(stabs...)) == canonicalize!(stabilizerview(⊗(mdstabs...)))
            md = MixedDestabilizer(random_destabilizer(n))
            s = random_stabilizer(n)
            mds = md⊗s
            @test mixed_destab_looks_good(mds)
            estab = stabilizerview(md)⊗s
            @test canonicalize!(copy(stabilizerview(mds))) == canonicalize!(estab)
        end
    end

    @testset "Stabilizer indexing" begin
        s = random_stabilizer(9,10)
        @test s[1,1] == s[[1,3,4],[1,3,5]][1,1]
        @test s[1,1] == s[:,[1,3,5]][1,1]
        @test s[1,1] == s[1,[1,3,5]][1]
        @test s[1,1] == s[[1,3,5],:][1,1]
        @test s[1,1] == s[[1,3,5],1][1,1]
        @test s[1,1] == s[:,1][1,1]
        @test s[1,1] == s[1,:][1]
        @test s[1,1] == s[:,:][1,1]
        @test isa(s[1], PauliOperator)
        @test isa(s[1,:], PauliOperator)
        @test isa(s[1,[1,2,3]], PauliOperator)
        @test axes(s) == (axes(s,1), axes(s,2)) == (Base.OneTo(9),Base.OneTo(10))
        ms = MixedStabilizer(s)
        mds = MixedStabilizer(s)
        @test length(mds) == length(ms) == 10
        @test length(s) == 9
        for n in test_sizes
            s = random_stabilizer(n)
            r1 = rand(1:n)
            ri1 = deleteat!(collect(1:n),r1)
            s1a = QuantumClifford.remove_column!(copy(s),r1)
            s1b = copy(s)[:,ri1]
            r2 = min(n,rand([63,64,65]))
            ri2 = deleteat!(collect(1:n),r2)
            s2a = QuantumClifford.remove_column!(copy(s),r2)
            s2b = copy(s)[:,ri2]
            @test stab_to_gf2(s1a) == stab_to_gf2(s1b)
            @test stab_to_gf2(s2a) == stab_to_gf2(s2b)
        end
    end

    @testset "horizontal concatenation" begin
        @test hcat(ghz(2), ghz(2)) == S"XXXX ZZZZ"
        s1 = S"YZ -XX"
        s2 = S"-ZY -YX"
        @test hcat(copy(s1), copy(s2)) == S"-YZZY XXYX"
        @test hcat(copy(s1), copy(s2), copy(s1), copy(s2)) == S"YZZYYZZY XXYXXXYX"
        @test_throws ArgumentError hcat(copy(s1), random_stabilizer(3))
        @test hcat(copy(tab(s1)), copy(tab(s2))) == T"-YZZY XXYX"
        @test hcat(copy(tab(s1)), copy(tab(s2)), copy(tab(s1)), copy(tab(s2))) == T"YZZYYZZY XXYXXXYX"
    end

    @testset "MixedDestabilizer over subarrays (#191)" begin
        # Case 1: QuantumClifford.Tableau{Vector{UInt8}, Matrix{UInt64}}
        n = 6
        stab = random_stabilizer(n)
        regular_arr = MixedDestabilizer(stab; undoperm=true)
        @test isa(regular_arr, MixedDestabilizer)
        # Case 2: Tableau{SubArray{...}, SubArray{...}, Tuple{Base.Slice{...}}}
        stab = random_stabilizer(n)
        substab = @view stab[3:n]
        md_via_subarr = MixedDestabilizer(substab; undoperm=true)
        @test isa(md_via_subarr, MixedDestabilizer)
    end

    @testset "Consistency between Destabilizer and MixedDestabilizer" begin # They have different construction algorithms so a consistency check is in order
        for n in test_sizes
            s = random_stabilizer(n)
            @test stabilizerview(Destabilizer(s))==s # Destabilizer is supposed to guarantee same stabilizer generators
            @test canonicalize!(stabilizerview(MixedDestabilizer(s)))==canonicalize!(stabilizerview(Destabilizer(s)))
        end
    end

    @testset "permutesystems does not modify original" begin
        for n in [2, 5, 10]
            perm = randperm(n)
            for s in [random_stabilizer(n), random_destabilizer(n), MixedDestabilizer(random_stabilizer(n))]
                original = copy(stabilizerview(s))
                permuted = permutesystems(s, perm)
                @test stabilizerview(s) == original
                @test permuted !== s
                @test stabilizerview(permutesystems(s, perm)) == stabilizerview(permutesystems!(copy(s), perm))
            end
        end
    end

    @testset "Construct out of Paulis" begin
        paulis1 = [P"-XXX", P"ZZI"]
        paulis2 = (P"-XXX", P"ZZI")
        stab = canonicalize!(S"-XXX ZZI")
        for T in [MixedDestabilizer, Stabilizer, Destabilizer, MixedDestabilizer]
            for paulis in [paulis1, paulis2]
                @test canonicalize!(stabilizerview(T(paulis))) == stab
            end
        end
    end
end

module QuantumCliffordQOpticsExt

using QuantumClifford
using QuantumClifford.PureNonClifford: PureGeneralizedStabilizer
import QuantumClifford: mul_left!, mul_right!
using QuantumOpticsBase
using Graphs
using DocStringExtensions
import QuantumOpticsBase: Ket, Operator

const _b2 = SpinBasis(1//2)
const _l0 = spinup(_b2)
const _l1 = spindown(_b2)
const _s₊ = (_l0+_l1)/√2
const _s₋ = (_l0-_l1)/√2
const _i₊ = (_l0+im*_l1)/√2
const _i₋ = (_l0-im*_l1)/√2
const _σ₊ = sigmap(_b2)
const _σ₋ = sigmam(_b2)
const _l00 = projector(_l0)
const _l11 = projector(_l1)
const _id = identityoperator(_b2)
const _z = sigmaz(_b2)
const _x = sigmax(_b2)
const _y = sigmay(_b2)
const _Id = identityoperator(_b2)
const _hadamard = (sigmaz(_b2)+sigmax(_b2))/√2
const _cnot = _l00⊗_Id + _l11⊗_x
const _cphase = _l00⊗_Id + _l11⊗_z
const _phase = _l00 + im*_l11
const _iphase = _l00 - im*_l11

function stab_to_ket(s)
    r,c = size(stabilizerview(s))
    r==c || throw(ArgumentError("""
        There was an attempt to convert a non-square tableaux into a `QuantumOptics.Ket`.
        The Stabilizer tableau has to be square (i.e. pure), otherwise the conversion is impossible.
    """))
    graph, hadamard_idx, iphase_idx, flips_idx = graphstate(s)
    ket = tensor(fill(copy(_s₊),c)...) # TODO fix this is UGLY
    for (;src,dst) in edges(graph)
        apply!(ket, [src,dst], _cphase)
    end
    for i in flips_idx
        apply!(ket, [i], _z)
    end
    for i in iphase_idx
        apply!(ket, [i], _phase)
    end
    for i in hadamard_idx
        apply!(ket, [i], _hadamard)
    end
    ket
end

"""
$TYPEDSIGNATURES

Convert a stabilizer state to a ket representation.

Requires that `QuantumOptics` is loaded.

```jldoctest
julia> using QuantumClifford, QuantumOpticsBase

julia> Ket(S"XX ZZ")
Ket(dim=4)
  basis: [Spin(1/2) ⊗ Spin(1/2)]
 0.7071067811865474 + 0.0im
                0.0 + 0.0im
                0.0 + 0.0im
 0.7071067811865474 + 0.0im
```
"""
Ket(s::QuantumClifford.AbstractStabilizer) = stab_to_ket(s)

"""
$TYPEDSIGNATURES

Convert a PureGeneralizedStabilizer state to a ket representation.

The state |ψ⟩ = Σₐ cₐ|φₐ⟩ is converted by summing the ket representations
of each stabilizer state weighted by their coefficients.

TODO: Each stabilizer state is converted independently with potentially different
global phases, which can cause incorrect interference for multi-term superpositions.
A proper implementation would need to track relative phases between stabilizer states.
"""
function Ket(state::PureGeneralizedStabilizer)
    return sum(c * Ket(Stabilizer(stabilizerview(s))) for (c, s) in zip(state.coefficients, state.states))
end

"""
$TYPEDSIGNATURES

Convert a stabilizer tableau to a density matrix corresponding to the given state.
"""
Operator(s::QuantumClifford.AbstractStabilizer) = dm(Ket(s)) # TODO support mixed stabilizer states

function genstab_to_densityop(s::GeneralizedStabilizer)
    ρ₀ = zero(dm(Ket(s.stab)))
    for ((Pₗᵇⁱᵗˢ,Pᵣᵇⁱᵗˢ), χ) in s.destabweights
        ρ̃ = dm(Ket(s.stab))
        destab = destabilizerview(s.stab)
        p = zero(destab[1])
        for (i,b) in enumerate(Pₗᵇⁱᵗˢ)
            b && mul_left!(p, destab, i)
        end
        ρ̃ = Operator(p)*ρ̃
        p = zero(destab[1])
        for (i,b) in enumerate(Pᵣᵇⁱᵗˢ)
            b && mul_left!(p, destab, i)
        end
        ρ̃ = ρ̃*Operator(p)
        ρ₀ += χ*ρ̃
    end
    return ρ₀
end

"""
$TYPEDSIGNATURES

"""
Operator(s::GeneralizedStabilizer) = genstab_to_densityop(s)


"""
$TYPEDSIGNATURES

Convert a `QuantumClifford.PauliOperator` to `QuantumOptics.Operator`.

```jldoctest
julia> Operator(P"Y") |> dense
Operator(dim=2x2)
  basis: Spin(1/2)
 0.0+0.0im  0.0-1.0im
 0.0+1.0im  0.0+0.0im

julia> Operator(P"-I") |> dense
Operator(dim=2x2)
  basis: Spin(1/2)
 -1.0+0.0im   0.0+0.0im
  0.0+0.0im  -1.0+0.0im
```
"""
function Operator(p::PauliOperator)
    toop = Dict((false,false)=>_Id,(true,false)=>_x,(false,true)=>_z,(true,true)=>_y)
    return (im)^p.phase[] * ⊗((toop[p[i]] for i in eachindex(p))...)
end

"""
$TYPEDSIGNATURES

Convert a `QuantumClifford.UnitaryPauliChannel` to `QuantumOptics.Operator`.

```jldoctest
julia> pcT
A unitary Pauli channel P = ∑ ϕᵢ Pᵢ with the following branches:
with ϕᵢ | Pᵢ
 0.853553+0.353553im | + _
 0.146447-0.353553im | + Z

julia> Operator(pcT) |> dense
Operator(dim=2x2)
  basis: Spin(1/2)
 1.0+0.0im       0.0+0.0im
 0.0+0.0im  0.707107+0.707107im
```
"""
function Operator(p::UnitaryPauliChannel)
    return sum(w*Operator(p) for (p,w) in zip(p.paulis,p.weights))
end

function cliff_to_unitary(cliff)
    n = nqubits(cliff)
    b = bell(n, localorder=true)
    apply!(b, 1:n, cliff)
    ψ = Ket(b)
    Operator(SpinBasis(1//2)^n,reshape(ψ.data * sqrt(2)^n, (2^n,2^n)))
end

"""
$TYPEDSIGNATURES

Convert a `QuantumClifford.CliffordOperator` to `QuantumOptics.Operator`.

```jldoctest
julia> Operator(tHadamard)
Operator(dim=2x2)
  basis: Spin(1/2)
 0.707107+0.0im   0.707107+0.0im
 0.707107+0.0im  -0.707107+0.0im

julia> Operator(tId1⊗tHadamard)
Operator(dim=4x4)
  basis: [Spin(1/2) ⊗ Spin(1/2)]
 0.707107+0.0im       0.0+0.0im   0.707107+0.0im        0.0+0.0im
      0.0+0.0im  0.707107+0.0im        0.0+0.0im   0.707107+0.0im
 0.707107+0.0im       0.0+0.0im  -0.707107+0.0im        0.0+0.0im
      0.0+0.0im  0.707107+0.0im        0.0+0.0im  -0.707107+0.0im

julia> Operator(tCNOT)
Operator(dim=4x4)
  basis: [Spin(1/2) ⊗ Spin(1/2)]
 1.0+0.0im  0.0+0.0im  0.0+0.0im  0.0+0.0im
 0.0+0.0im  0.0+0.0im  0.0+0.0im  1.0+0.0im
 0.0+0.0im  0.0+0.0im  1.0+0.0im  0.0+0.0im
 0.0+0.0im  1.0+0.0im  0.0+0.0im  0.0+0.0im
```

This conversion expects a dense tableau of type [`CliffordOperator`](@ref) as input.
If you are working with some of the implicit (a.k.a. small/sparse/symbolic) types of gates
(e.g. [`sCNOT`](@ref)), you need to first convert them to `CliffordOperator`.

```jldoctest
julia> Operator(CliffordOperator(sHadamard))
Operator(dim=2x2)
  basis: Spin(1/2)
 0.707107+0.0im   0.707107+0.0im
 0.707107+0.0im  -0.707107+0.0im

julia> Operator(CliffordOperator(sHadamard(1), 1))
Operator(dim=2x2)
  basis: Spin(1/2)
 0.707107+0.0im   0.707107+0.0im
 0.707107+0.0im  -0.707107+0.0im

julia> Operator(CliffordOperator(sHadamard(1), 2))
Operator(dim=4x4)
  basis: [Spin(1/2) ⊗ Spin(1/2)]
 0.707107+0.0im   0.707107+0.0im       0.0+0.0im        0.0+0.0im
 0.707107+0.0im  -0.707107+0.0im       0.0+0.0im        0.0+0.0im
      0.0+0.0im        0.0+0.0im  0.707107+0.0im   0.707107+0.0im
      0.0+0.0im        0.0+0.0im  0.707107+0.0im  -0.707107+0.0im

julia> Operator(CliffordOperator(sHadamard(2), 2))
Operator(dim=4x4)
  basis: [Spin(1/2) ⊗ Spin(1/2)]
 0.707107+0.0im       0.0+0.0im   0.707107+0.0im        0.0+0.0im
      0.0+0.0im  0.707107+0.0im        0.0+0.0im   0.707107+0.0im
 0.707107+0.0im       0.0+0.0im  -0.707107+0.0im        0.0+0.0im
      0.0+0.0im  0.707107+0.0im        0.0+0.0im  -0.707107+0.0im

julia> Operator(CliffordOperator(sHadamard(2), 1, compact=true))
Operator(dim=2x2)
  basis: Spin(1/2)
 0.707107+0.0im   0.707107+0.0im
 0.707107+0.0im  -0.707107+0.0im
```
"""
function Operator(c::CliffordOperator)
    cliff_to_unitary(c)
end

end

##

@testitem "Graph states single qubit gates" begin
    using Random
    import QuantumClifford.GraphSim: GraphState

    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    @testset "Single qubit gate application" begin
        for n in test_sizes
            for i in 1:6
                op = enumerate_single_qubit_gates(i, qubit=rand(1:n), phases=(rand(Bool),rand(Bool)))
                s = random_stabilizer(n)
                gs = GraphState(s)
                @test canonicalize!(apply!(copy(s),op))==canonicalize!(Stabilizer(apply!(copy(gs),op)))
            end
        end
    end
end

module QuantumCliffordJuMPExt

using DocStringExtensions

import JuMP
import JuMP: @variable, @objective, @constraint, optimize!, Model, set_silent,
    sum, value, optimize!, is_solved_and_feasible, set_time_limit_sec, solution_summary,
    termination_status, MOI.MEMORY_LIMIT, MOI.TIME_LIMIT, MOI
import QuantumClifford
import QuantumClifford: stab_to_gf2, logicalxview, logicalzview, canonicalize!,
    MixedDestabilizer, Stabilizer
import QuantumClifford.ECC
import QuantumClifford.ECC: distance, AbstractECC, code_n, code_k, parity_checks,
    logx_ops, logz_ops, parity_matrix_x, parity_matrix_z, AbstractECC, nqubits,
    DistanceMIPAlgorithm

import SparseArrays
import SparseArrays: SparseMatrixCSC, sparse, spzeros, findnz, sparsevec

import ILog2
import ILog2: ilog2, RoundUp

# exported from extension so that Documenter.jl sees them when autogenerating API lists
export distance

include("min_distance_mixed_integer_programming.jl")

end

@testitem "GPU" tags=[:gpu] begin
    using QuantumClifford: to_cpu, to_gpu
    using CUDA

    function apply_single_qubit_and_compare(n, s, s_gpu)
        qbitidx = (((rand(Int) % n) + n) %n) + 1
        op = random_clifford1(qbitidx)
        apply!(s_gpu, op)
        apply!(s, op)
        if to_cpu(s_gpu) != s
            throw("result of cpu and gpu differ in single qubit operation. n=$n iteration=$iteration operation=$op")
        end
    end

    function apply_single_or_double_qubit_and_compare(n, s, s_gpu)
        op = if rand(Int) % 2 == 0
            qbitidx = (((rand(Int) % n) + n) %n) + 1
            random_clifford1(qbitidx)
        else
            # todo what other gates can we use? how to randomly generate two qubit operation?
            # can we use random_clifford(2) with this function?
            qbitidx1 = (((rand(Int) % n) + n) %n) + 1
            qbitidx2 = (((rand(Int) % n) + n) %n) + 1
            if qbitidx1 == qbitidx2
                qbitidx2 = (qbitidx1 % n) + 1
            end
            sCNOT(qbitidx1, qbitidx2)
        end
        apply!(s_gpu, op)
        apply!(s, op)
        if to_cpu(s_gpu) != s
            throw("result of cpu and gpu differ in single qubit operation. n=$n iteration=$iteration operation=$op")
        end
    end

    function approx(a, b, threshold)
        maximum(abs.(a - b)) <= threshold
    end


    @testset "GPU" begin
        CUDA.allowscalar(false) # make sure we are using GPU kernels and not iterating on indices

        @test begin
            p = random_pauli(3)
            p_gpu = to_gpu(p)
            typeof(p_gpu.xz) <: CUDA.CuArray # todo this is a bad test because it depends on representation of data in QuantumClifford. Change later...
        end
        @test begin
            s = random_stabilizer(3)
            s_gpu = to_gpu(s)
            typeof(tab(s_gpu).xzs) <: CUDA.CuArray # todo this is a bad test because it depends on representation of data in QuantumClifford. Change later...
        end

        @test begin
            for n in [2, 4, 8, 100, 500]
                s = random_stabilizer(n)
                s_gpu = to_gpu(s)
                for iteration in 1:100
                    apply_single_qubit_and_compare(n, s, s_gpu)
                end
            end
            true
        end

        @test begin
            for n in [2, 4, 8, 100, 500]
                s = random_stabilizer(n)
                s_gpu = to_gpu(s)
                for iteration in 1:100
                    apply_single_or_double_qubit_and_compare(n, s, s_gpu)
                end
            end
            true
        end

        @test begin
            # todo test MRZ and other random gates statistically
            circuit = [sHadamard(2), sHadamard(5), sCNOT(1, 2), sCNOT(2, 5), sMZ(1), sMZ(2), sMZ(4), sMZ(5)]
            ccircuit = if eltype(circuit) <: QuantumClifford.CompactifiedGate
                circuit
            else
                compactify_circuit(circuit)
            end

            for func in [identity, fastcolumn, fastrow]
                frames = QuantumClifford._create_pauliframe(ccircuit; trajectories=10)
                cpu_frames = func(to_cpu(frames))
                gpu_frames = func(to_gpu(frames))
                cpu_result = pftrajectories(cpu_frames, ccircuit)
                gpu_result = pftrajectories(gpu_frames, ccircuit)
                check = (cpu_result.frame == to_cpu(gpu_result.frame)) && (cpu_result.measurements == to_cpu(gpu_result.measurements))
                if !check
                    throw("pftrajectories produce wrong result after applying $func")
                end
            end
            true
        end

        @test begin
            # test fastrow
            for n in [2, 4, 8, 100, 500]
                s = fastrow(random_stabilizer(n))
                s_gpu = fastrow(to_gpu(s))
                for iteration in 1:100
                    # how to check if after each iteration we are still fastrow
                    apply_single_or_double_qubit_and_compare(n, s, s_gpu)
                end
            end
            true
        end

        @test begin
            # test fastcolumn
            for n in [2, 4, 8, 100, 500]
                s = fastcolumn(random_stabilizer(n))
                s_gpu = fastcolumn(to_gpu(s))
                for iteration in 1:100
                    # how to check if after each iteration we are still fastrow
                    apply_single_or_double_qubit_and_compare(n, s, s_gpu)
                end
            end
            true
        end

        @test begin
            # test applynoise
            N = 4
            trajectories = 10000
            f = PauliFrame(trajectories, N, N);
            f = to_gpu(f)
            p = 0.1
            measurements = pftrajectories(f, [
                                              sMZ(1, 1),
                                              sHadamard(2),
                                              sMZ(2, 2),
                                              NoiseOp(UnbiasedUncorrelatedNoise(p), [3, 4]),
                                              sMZ(3, 3),
                                              sHadamard(4),
                                              sMZ(4, 4)
                                             ]).measurements
            avg_result = to_cpu(sum(measurements, dims=1) / trajectories)
            error_threshold = 0.02
            approx(vec(avg_result), [0, .5, 2p/3, .5], error_threshold)
        end
    end
end

"""A conditional gate that either performs `truegate` or `falsegate`, depending on the value of `controlbit`."""
struct ConditionalGate <: AbstractOperation
    truegate::AbstractOperation
    falsegate::AbstractOperation
    controlbit::Int
end

"""A conditional gate that performs one of the `gates`, depending on the output of `decisionfunction` applied to the entire classical bit register."""
struct IndexedDecisionGate <: AbstractOperation
    gates::AbstractVector{AbstractOperation}
    decisionfunction
end

# TODO tests for this
function QuantumClifford.apply!(state::Register, op::ConditionalGate)
    if state.bits[op.controlbit]
        apply!(state, op.truegate)
    else
        apply!(state, op.falsegate)
    end
    return state
end

function QuantumClifford.apply!(state::Register, op::IndexedDecisionGate)
    decision = op.decisionfunction(state.bits)
    if !isnothing(decision)
        for i in 1:length(decision)
            apply!(state, op.gates[decision[i]])
        end
    end
    state
end

applybranches(s::Register, op::ConditionalGate; max_order=1) = [(applywstatus!(copy(s),op)...,1,0)]
applybranches(s::Register, op::IndexedDecisionGate; max_order=1) = [(applywstatus!(copy(s),op)...,1,0)]

affectedqubits(d::ConditionalGate) = union(affectedqubits(d.truegate), affectedqubits(d.falsegate))
affectedqubits(d::IndexedDecisionGate) = [(union(affectedqubits.(d.gates))...)...]

using WeakDepHelpers: @declare_method_is_in_extension, @declare_struct_is_in_extension

const heckeext_struct_docstring = "Implemented as a package extension with Hecke. Check the docs for the [Hecke extension](http://qc.quantumsavory.org/stable/ECC_API/#Implemented-in-an-extension-requiring-Hecke.jl)"
const heckeext_function_docstring = heckeext_struct_docstring
const oscarext_struct_docstring = "Implemented as a package extension with Oscar. Check the docs for the [Oscar extension](http://qc.quantumsavory.org/stable/ECC_API/#Implemented-in-an-extension-requiring-Oscar.jl)"
const oscarext_function_docstring = oscarext_struct_docstring

@declare_struct_is_in_extension QuantumClifford LPCode :QuantumCliffordHeckeExt (:Hecke,) heckeext_struct_docstring
@declare_struct_is_in_extension QuantumClifford LaCross :QuantumCliffordHeckeExt (:Hecke,) heckeext_struct_docstring
@declare_struct_is_in_extension QuantumClifford GeneralizedHyperGraphProduct :QuantumCliffordHeckeExt (:Hecke,) heckeext_struct_docstring
@declare_struct_is_in_extension QuantumClifford GeneralizedBicycle :QuantumCliffordHeckeExt (:Hecke,) heckeext_struct_docstring
@declare_struct_is_in_extension QuantumClifford ExtendedGeneralizedBicycle :QuantumCliffordHeckeExt (:Hecke,) heckeext_struct_docstring
@declare_struct_is_in_extension QuantumClifford DDimensionalSurface :QuantumCliffordOscarExt (:Oscar,) oscarext_struct_docstring
@declare_struct_is_in_extension QuantumClifford DDimensionalToric :QuantumCliffordOscarExt (:Oscar,) oscarext_struct_docstring
@declare_struct_is_in_extension QuantumClifford HomologicalProduct :QuantumCliffordOscarExt (:Oscar,) oscarext_struct_docstring
@declare_struct_is_in_extension QuantumClifford DoubleHomologicalProduct :QuantumCliffordOscarExt (:Oscar,) oscarext_struct_docstring
@declare_struct_is_in_extension QuantumClifford GeneralizedToric :QuantumCliffordOscarExt (:Oscar,) oscarext_struct_docstring
@declare_struct_is_in_extension QuantumClifford TrivariateTricycle :QuantumCliffordOscarExt (:Oscar,) oscarext_struct_docstring
@declare_struct_is_in_extension QuantumClifford BivariateBicycleViaPoly :QuantumCliffordOscarExt (:Oscar,) oscarext_struct_docstring
@declare_struct_is_in_extension QuantumClifford MultivariateMulticycle :QuantumCliffordOscarExt (:Oscar,) oscarext_struct_docstring

@declare_method_is_in_extension QuantumClifford.WEAKDEP_METHOD_ERROR_HINTS two_block_group_algebra_code (:Hecke,) heckeext_function_docstring
@declare_method_is_in_extension QuantumClifford.WEAKDEP_METHOD_ERROR_HINTS generalized_bicycle_code_as_2bga (:Hecke,) heckeext_function_docstring
@declare_method_is_in_extension QuantumClifford.WEAKDEP_METHOD_ERROR_HINTS bicycle_code_as_2bga (:Hecke,) heckeext_function_docstring
@declare_method_is_in_extension QuantumClifford.WEAKDEP_METHOD_ERROR_HINTS Haah_cubic_code_as_2bga (:Hecke,) heckeext_function_docstring
@declare_method_is_in_extension QuantumClifford.WEAKDEP_METHOD_ERROR_HINTS honeycomb_color_code_as_2bga (:Hecke,) heckeext_function_docstring
@declare_method_is_in_extension QuantumClifford.WEAKDEP_METHOD_ERROR_HINTS boundary_maps (:Oscar,) oscarext_function_docstring
@declare_method_is_in_extension QuantumClifford.WEAKDEP_METHOD_ERROR_HINTS max_xy_exponents (:Oscar,) oscarext_function_docstring
@declare_method_is_in_extension QuantumClifford.WEAKDEP_METHOD_ERROR_HINTS twobga_from_direct_product (:Oscar,) oscarext_function_docstring
@declare_method_is_in_extension QuantumClifford.WEAKDEP_METHOD_ERROR_HINTS twobga_from_fp_group (:Oscar,) oscarext_function_docstring

@testitem "Syndrome Measurements with mctrajectory!" begin # TODO this is a rather old test that is now done in a few other places, e.g. the ECC module -- double check and consider deleting
    using QuantumClifford: AbstractOperation
    codeˢᵗᵉᵃⁿᵉ = S"Z__Z_ZZ
                   _Z_ZZ_Z
                   __Z_ZZZ
                   X__X_XX
                   _X_XX_X
                   __X_XXX";
    function get_check(code,index) # TODO a fairly ugly piece of code that should just be part of the library
        s,n = size(code)
        @assert index<=s
        op = code[index]
        anc = n+1
        circuit = AbstractOperation[]
        measurement = nothing
        resetgate = nothing
        for qubit in 1:n
            if op[qubit] == (false, true) # it is a Z
                if isnothing(measurement) || measurement==sMZ
                    resetgate = Reset(S"Z",[anc])
                    measurement = sMZ
                else
                    error("can not do mixed syndromes")
                end
                push!(circuit, sCNOT(qubit, anc))
            elseif op[qubit] == (true, false) # it is a X
                if isnothing(measurement) || measurement==sMX
                    resetgate = Reset(S"X",[anc])
                    measurement = sMX
                else
                    error("can not do mixed syndromes")
                end
                push!(circuit, sCNOT(anc, qubit))
            elseif op[qubit] == (true, true) # it is a Y
                error("can not do Y syndromes")
            end
        end
        push!(circuit,measurement(anc,index))
        circuit = AbstractOperation[resetgate,circuit...]
    end
    function get_all_checks(code)
        s,n = size(code)
        vcat([get_check(code,i) for i in 1:s]...)
    end
    # test the code is correct
    state = Register(MixedDestabilizer(codeˢᵗᵉᵃⁿᵉ ⊗ S"Z"),zeros(Bool,6))
    full_circuit = get_all_checks(codeˢᵗᵉᵃⁿᵉ)
    for _ in 1:100
        err = random_pauli(7;realphase=true)
        @test mctrajectory!(apply!(copy(state),(err ⊗ P"I")),full_circuit)[1].bits == comm(err*codeˢᵗᵉᵃⁿᵉ, err)
    end
end

@testitem "Random" begin
    using Random
    using QuantumClifford
    using QuantumClifford: stab_looks_good, destab_looks_good, mixed_stab_looks_good, mixed_destab_looks_good

    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    @testset "Random sampling of operators" begin
        for n in [1, test_sizes..., 200,500]
            p = random_pauli(n)
            s = random_stabilizer(n)
            ss = random_stabilizer(rand(1:n),n)
            ms = MixedDestabilizer(ss)
            d = random_destabilizer(n)
            c = random_clifford(n)
            sq = random_clifford1(n÷2+1)
            @test stab_looks_good(s)
            @test stab_looks_good(ss)
            @test destab_looks_good(d)
            @test mixed_destab_looks_good(ms)
            @test stab_looks_good(c*s)
            @test stab_looks_good(c*ss)
            @test destab_looks_good(c*d)
            @test mixed_destab_looks_good(c*ms)
            @test stab_looks_good(p*s)
            @test stab_looks_good(p*ss)
            @test destab_looks_good(p*d)
            @test mixed_destab_looks_good(p*ms)
            @test stab_looks_good(apply!(s,sq,phases=false))
            @test stab_looks_good(apply!(ss,sq,phases=false))
            @test destab_looks_good(apply!(d,sq,phases=false))
            @test mixed_destab_looks_good(apply!(ms,sq,phases=false))
        end
    end

    @testset "Random sampling of operators memory reuse" begin
        for n in [1, test_sizes..., 200, 500]
            workingmemory = QuantumClifford.RandDestabMemory(n)
            for _ in 1:2
                seed = rand(1:100000)
                rng = Random.GLOBAL_RNG
                Random.seed!(rng, seed)
                non_reuse_version = random_destabilizer(rng, n)
                Random.seed!(rng, seed)
                reuse_version = random_destabilizer(rng, workingmemory)
                @test non_reuse_version == reuse_version
            end
        end
    end

    @testset "Random Paulis" begin
        for n in [1, test_sizes..., 200,500]
            @test all((random_pauli(n).phase[] == 0  for _ in 1:100))
            @test all((random_pauli(n, 0.1).phase[] == 0  for _ in 1:100))
            @test any((random_pauli(n; nophase=false, realphase=false).phase[] == 1  for _ in 1:100))
            @test any((random_pauli(n, 0.1; nophase=false, realphase=false).phase[] == 1  for _ in 1:100))
            @test any((random_pauli(n; nophase=false).phase[] ∈ [0,2]  for _ in 1:100))
            @test any((random_pauli(n, 0.1; nophase=false).phase[] ∈ [0,2]  for _ in 1:100))
        end
        for i in 1:10
            e = 0.2
            n = 10000
            expected = 2/3*e * 2 * n
            bound = 1/sqrt(n)
            @test expected * (1-10bound) <= sum(count_ones.(random_pauli(10000,0.2).xz)) <= expected * (1+10bound)
            e = 0.75
            n = 10000
            expected = 2/3*e * 2 * n
            bound = 1/sqrt(n)
            @test expected * (1-10bound) <= sum(count_ones.(random_pauli(10000).xz)) <= expected * (1+10bound)

        end
    end
end

@testitem "Pauli frame" begin
    @testset "syndrome measurement of 3 qubit repetition code" begin
        circuit = [
                   sX(1),
                   sCNOT(1,2), sCNOT(1,3), # encode
                   PauliError(2,0.75), # error
                   sCNOT(1,4), sCNOT(2,4), sCNOT(2,5), sCNOT(3,5), sMZ(4,1), sMZ(5,2) # syndrome measurement
                  ]
        frame = PauliFrame(100, 5, 2)
        frame = pftrajectories(frame, circuit)
        frame1 = pftrajectories(circuit; trajectories=100, threads=false)
        frame2 = pftrajectories(circuit; trajectories=100, threads=true)
        # If the x component is set on the second qubit, then the fourth and fifth qubits should also have it set
        for f in [frame, frame1, frame2]
            m = pfmeasurements(f)
            for (i, row) in enumerate(f.frame)
                if row[2] == (true, false)
                    @test row[4][1] && row[5][1] && m[i,1] && m[i,2]
                end
            end
        end
    end

    @testset "GHZ correlations" begin
        ghz_circuit = [
                       sHadamard(1), sCNOT(1,2), sCNOT(1,3), # prepare a GHZ state
                       sMZ(1,1), sMZ(2,2), sMZ(3,3) # measure each qubit
                      ]
        n = 10^6
        frame = PauliFrame(n, 3, 3)
        f = pftrajectories(frame, ghz_circuit)
        m = pfmeasurements(f)
        frame1 = pftrajectories(ghz_circuit; trajectories=n, threads=false)
        m1 = pfmeasurements(frame1)
        frame2 = pftrajectories(ghz_circuit; trajectories=n, threads=true)
        m2 = pfmeasurements(frame2)
        for _m in [m, m1, m2]
            rowtotal_1s = sum(m, dims=2)[:,1]
            @test all(rowtotal_1s .% 3 .== 0)
            fractotal_1s = sum(rowtotal_1s)/3 / n
            @test (fractotal_1s > 0.49) && (fractotal_1s < 0.51)
        end
    end

    @testset "sMZ vs sMRZ - mctrajectories vs pftrajectories" begin
        n = 2000
        state = Register(one(MixedDestabilizer, 3), 6)
        frame = PauliFrame(n, 3, 6)

        ghz_circuit1 = [
                        sHadamard(1), sCNOT(1,2), sCNOT(1,3), # prepare a GHZ state
                        sMZ(1,1), sMZ(2,2), sMZ(3,3), # measure each qubit
                        sMZ(1,4), sMZ(2,5), sMZ(3,6)  # measure each qubit again
                       ]
        for m in [
                  stack([bitview(mctrajectory!(copy(state), ghz_circuit1)[1]) for i in 1:n], dims=1),
                  pfmeasurements(pftrajectories(copy(frame), ghz_circuit1)),
                  pfmeasurements(pftrajectories(ghz_circuit1;trajectories=n,threads=false)),
                  pfmeasurements(pftrajectories(ghz_circuit1;trajectories=n,threads=true)),
                 ]
            @test all(0.25 .< sum(m, dims=1)./n .< 0.75)
        end

        ghz_circuit2 = [
                        sHadamard(1), sCNOT(1,2), sCNOT(1,3), # prepare a GHZ state
                        sMRZ(1,1), sMZ(2,2), sMZ(3,3), # measure and reset each qubit
                        sMZ(1,4), sMZ(2,5), sMZ(3,6)  # measure each qubit again
                       ]
        for m in [
                  stack([bitview(mctrajectory!(copy(state), ghz_circuit2)[1]) for i in 1:n], dims=1),
                  pfmeasurements(pftrajectories(copy(frame), ghz_circuit2)),
                  pfmeasurements(pftrajectories(ghz_circuit2;trajectories=n,threads=false)),
                  pfmeasurements(pftrajectories(ghz_circuit2;trajectories=n,threads=true)),
                 ]
            @test all(0.25.*[1 1 1 0 1 1] .<= sum(m, dims=1)./n .<= 0.75.*[1 1 1 0 1 1])
        end

        noncom_circuit = [
                          sHadamard(1), sMRZ(1,1), sX(1), sMZ(1,2), sMRZ(1,3), sMRZ(1,4), sHadamard(1), sMZ(1,5)
                         ]
        ms3 = stack([bitview(mctrajectory!(copy(state), noncom_circuit)[1]) for i in 1:n], dims=1)
        @test all(0.25.*[1 4 4 0 1 0] .<= sum(ms3, dims=1)./n .<= 0.75.*[1 2 2 0 1 0])
        for m in [
                  pfmeasurements(pftrajectories(copy(frame), noncom_circuit)),
                  pfmeasurements(pftrajectories(noncom_circuit;trajectories=n,threads=false)),
                  pfmeasurements(pftrajectories(noncom_circuit;trajectories=n,threads=true)),
                 ]
            @test all(0.25.*[1 0 0 0 1] .<= (sum(m, dims=1)[:,1:5])./n .<= 0.75.*[1 0 0 0 1])
        end
    end

    @testset "PauliMeasurements" begin
        n = 2000
        state = Register(one(MixedDestabilizer, 3), 5)
        frame = PauliFrame(n, 3, 5)

        glassy_ghz_circuit = [
            sHadamard(1), sHadamard(2), sHadamard(3),
            PauliMeasurement(P"ZZ_", 1), PauliMeasurement(P"_ZZ", 2),
            sMZ(1, 3), sMZ(2, 4), sMZ(3, 5)
        ]
        for m in [pfmeasurements(pftrajectories(copy(frame), glassy_ghz_circuit)),
            pfmeasurements(pftrajectories(glassy_ghz_circuit; trajectories=n, threads=false)),
            pfmeasurements(pftrajectories(glassy_ghz_circuit; trajectories=n, threads=true))]

            # decode based on measurement outcomes
            for r in eachrow(m)
                r[4] ⊻= r[1]
                r[5] ⊻= r[1] ⊻ r[2]
            end

            # check that the correct correlations are present
            @test all(m[:, 3] .== m[:, 4] .== m[:, 5])
        end
    end
end

"""
    $TYPEDEF

A Generalized Hypergraph Product (GHP) CSS code introduced in [panteleev2021degenerate](@cite).

The GHP code is constructed from a matrix ``A \\in M_{m \\times n}(R)``, where
``R \\subseteq M_\\ell(\\mathbb{F}_2)`` is a ring of binary circulant matrices,
and a binary matrix ``b \\in M_\\ell(\\mathbb{F}_2)`` such that every element of
``R`` commutes with ``b``. The code is defined by the block parity-check matrices:

```math
\\begin{aligned}
    H_X = \\begin{bmatrix} A & b \\cdot I_m \\end{bmatrix}, \\quad
    H_Z = \\begin{bmatrix} b^T \\cdot I_n & A^* \\end{bmatrix}
\\end{aligned}
```

where ``A^*`` is the transpose of ``A`` with each entry polynomial-reversed modulo
``x^\\ell - 1``, and ``I_m, I_n`` are identity matrices over ``R``.

Here is an example of `[[882, 24, 18 ≤ d ≤ 24]]` code from Appendix B of [panteleev2021degenerate](@cite).

```jldoctest
julia> import Hecke: polynomial_ring, GF, quo, matrix; using QuantumClifford.ECC;

julia> R, x = polynomial_ring(GF(2), :x);

julia> l = 63; n = 7;

julia> S, _ =  quo(R, x^l - 1);

julia> A = matrix(S, n, n,
           [x^27  0     0     0     0     1     x^54
            x^54  x^27  0     0     0     0     1
            1     x^54  x^27  0     0     0     0
            0     1     x^54  x^27  0     0     0
            0     0     1     x^54  x^27  0     0
            0     0     0     1     x^54  x^27  0
            0     0     0     0     1     x^54  x^27]);

julia> b = S(1 + x + x^6);

julia> c = GeneralizedHyperGraphProduct(A, b, l);

julia> code_n(c), code_k(c)
(882, 24)
```

Here is an example of `[[1270, 28, 16 ≤ d ≤ 46]]` code from Appendix B of [panteleev2021degenerate](@cite).

```jldoctest
julia> import Hecke: polynomial_ring, GF, quo, matrix; using QuantumClifford.ECC;

julia> R, x = polynomial_ring(GF(2), :x);

julia> l = 127; n = 5;

julia> S, _ =  quo(R, x^l - 1);

julia> A = matrix(S, n, n,
           [1     0     x^51  x^52  0
            0     1     0     x^111 x^20
            1     0     x^98  0     x^122
            1     x^80  0     x^119 0
            0     1     x^5   0     x^106]);

julia> b = S(1 + x + x^7);

julia> c = GeneralizedHyperGraphProduct(A, b, l);

julia> code_n(c), code_k(c)
(1270, 28)
```

### Fields
    $TYPEDFIELDS
"""
struct GeneralizedHyperGraphProduct <: AbstractCSSCode
    """The matrix ``A \\in M_{n \\times n}(R)``, where ``R = \\mathbb{F}_2[x]/(x^\\ell - 1)``. Each entry in `A` represents a polynomial modulo ``x^\\ell - 1``, defining a circulant block."""
    A::MatSpaceElem{EuclideanRingResidueRingElem{FqPolyRingElem}}
    """The polynomial ``b(x) \\in R``, generating a binary circulant matrix that commutes with all elements of `R`. """
    b::EuclideanRingResidueRingElem{FqPolyRingElem}
    """The number of rows and columns in each binary circulant block."""
    l::Int

    function GeneralizedHyperGraphProduct(A, b, l)
        size(A, 1) == size(A, 2) || throw(ArgumentError("A must be square"))
        parent(A[1,1]) == parent(b) || throw(ArgumentError("A and b must be over the same ring"))
        new(A, b, l)
    end
end

function _poly_transpose(p, l)
    plift = lift(p)
    deg_p = degree(plift)
    rev = zero(base_ring(parent(p)))
    x = gen(parent(p))
    for i in 0:deg_p
        rev += coeff(plift, i)*x^(mod(-i, l))
    end
    return parent(p)(rev)
end

_bᵢ(b, n) = matrix(parent(b), n, n, [i == j ? b : zero(parent(b)) for i in 1:n, j in 1:n])

function _circulant_matrix(poly, l)
    coeffs = [coeff(poly, i) for i in 0:l-1]
    return matrix(GF(2), l, l, [coeffs[mod1(j-i+1, l)] for i in 1:l, j in 1:l])
end

function _polynomial_matrix_to_circulant_matrix(H_poly, l)
    m, n = size(H_poly)
    H = zero_matrix(GF(2), m*l, n*l)
    for i in 1:m, j in 1:n
        poly = lift(H_poly[i, j])
        H_block = _circulant_matrix(poly, l)
        H[(i-1)*l+1:i*l, (j-1)*l+1:j*l] = H_block
    end
    H = [Int(lift(ZZ, H[i,j])) for i in 1:nrows(H), j in 1:ncols(H)]
    return H
end

function parity_matrix_xz(c::GeneralizedHyperGraphProduct)
    n = size(c.A, 1)
    Aᵗʳ = matrix(parent(c.b), n, n, [_poly_transpose(c.A[j, i], c.l) for i in 1:n, j in 1:n])
    bᵢ = _bᵢ(c.b, n)
    bᵢᵀ = _bᵢ(_poly_transpose(c.b, c.l), n)
    hx = hcat(c.A, bᵢ)
    hz = hcat(bᵢᵀ, Aᵗʳ)
    hx = _polynomial_matrix_to_circulant_matrix(hx, c.l)
    hz = _polynomial_matrix_to_circulant_matrix(hz, c.l)
    return hx, hz
end

parity_matrix_x(c::GeneralizedHyperGraphProduct) = parity_matrix_xz(c)[1]

parity_matrix_z(c::GeneralizedHyperGraphProduct) = parity_matrix_xz(c)[2]

@testitem "ECC 2BGA Reproduce Table 3 of arXiv:2306.16400" tags=[:ecc, :ecc_bespoke_checks, :oscar_required] begin
    using Nemo
    using Nemo: FqFieldElem
    using Hecke: group_algebra, GF, abelian_group, gens, quo, one, GroupAlgebra
    using QuantumClifford
    using QuantumClifford.ECC
    using QuantumClifford.ECC: code_k, code_n, two_block_group_algebra_code, DistanceMIPAlgorithm
    using Oscar
    using Oscar: free_group, small_group_identification, describe, order, FPGroupElem, FPGroup, FPGroupElem
    using HiGHS
    using JuMP

    @testset "Reproduce Table 3 of arXiv:2306.16400" begin
        # [[24, 8, 3]]
        m = 6
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^4]
        b_elts = [one(G), s*r^4, r^3, r^4, s*r^2, r]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 24 && code_k(c) == 8
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        @test small_group_identification(G) == (order(G), 4)

        # [[24, 12, 2]]
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^3]
        b_elts = [one(G), s*r, r^3, r^4, s*r^4, r]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 24 && code_k(c) == 12
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test small_group_identification(G) == (order(G), 4)

        # [[32, 8, 4]]
        m = 8
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^2]
        b_elts = [one(G), s*r^5, s*r^4, r^2, s*r^7, s*r^6]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 32 && code_k(c) == 8
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
        @test small_group_identification(G) == (order(G), 7)

        # [[32, 16, 2]]
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^4]
        b_elts = [one(G), s*r^3, s*r^6, r^4, s*r^7, s*r^2]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 32 && code_k(c) == 16
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test small_group_identification(G) == (order(G), 7)

        # [[36, 12, 3]]
        m = 9
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^3]
        b_elts = [one(G), s, r, r^3, s*r^3, r^4]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 36 && code_k(c) == 12
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        @test small_group_identification(G) == (order(G), 1)

        # [[40, 8, 5]]
        m = 10
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^2]
        b_elts = [one(G), s*r^4, r^5, r^2, s*r^6, r]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 40 && code_k(c) == 8
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
        @test small_group_identification(G) == (order(G), 4)

        # [[40, 20, 2]]
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^5]
        b_elts = [one(G), s*r^2, r^5, r^6, s*r^7, r]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 40 && code_k(c) == 20
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test small_group_identification(G) == (order(G), 4)

        # [[48, 8, 6]]
        m = 12
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^10]
        b_elts = [one(G), s*r^8, r^9, r^4, s*r^2, r^5]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 48 && code_k(c) == 8
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
        @test small_group_identification(G) == (order(G), 6)

        # [[48, 12, 4]]
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^3]
        b_elts = [one(G), s*r^7, r^3, r^4, s*r^10, r^7]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 48 && code_k(c) == 12
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
        @test small_group_identification(G) == (order(G), 6)

        # [[48, 16, 3]]
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^8]
        b_elts = [one(G), s*r^8, r^9, r^8, s*r^4, r^5]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 48 && code_k(c) == 16
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        @test small_group_identification(G) == (order(G), 6)

        # [[48, 24, 2]]
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^6]
        b_elts = [one(G), s*r^11, r^6, s*r^5, r, r^7]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 48 && code_k(c) == 24
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test small_group_identification(G) == (order(G), 6)

        # [[56, 8, 7]]
        m = 14
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^4]
        b_elts = [one(G), s*r^11, r^7, s*r^5, r^12, r^9]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 56 && code_k(c) == 8
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 7
        @test small_group_identification(G) == (order(G), 3)

        # [[56, 28, 2]]
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^7]
        b_elts = [one(G), s*r^2, r^7, r^8, s*r^9, r]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 56 && code_k(c) == 28
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test small_group_identification(G) == (order(G), 3)

        # [[60, 12, 5]]
        m = 15
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^12]
        b_elts = [one(G), s*r^14, r^5, r^12, s*r^11, r^14]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 60 && code_k(c) == 12
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
        @test small_group_identification(G) == (order(G), 3)

        # [[60, 20, 3]]
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^5]
        b_elts = [one(G), s*r^13, r^5, r^12, s*r^3, r^2]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 60 && code_k(c) == 20
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        @test small_group_identification(G) == (order(G), 3)

        # [[64, 8, 8]]
        m = 16
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^6]
        b_elts = [one(G), s*r^12, s*r^9, r^6, s, s*r]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 64 && code_k(c) == 8
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8
        @test small_group_identification(G) == (order(G), 18)

        # [[64, 16, 4]]
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^4]
        b_elts = [one(G), s*r^10, s*r^3, r^4, s*r^14, s*r^7]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 64 && code_k(c) == 16
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
        @test small_group_identification(G) == (order(G), 18)

        # [[64, 32, 2]]
        F = free_group(["r", "s"])
        r, s = gens(F)
        G, = quo(F, [r^m, s^2, (r*s)^2])
        F2G = group_algebra(GF(2), G)
        r, s = gens(G)
        a_elts = [one(G), r^8]
        b_elts = [one(G), s*r^11, s*r^12, r^8, s*r^3, s*r^4]
        c = twobga_from_fp_group(a_elts, b_elts, F2G)
        @test order(G) == 2*m
        @test describe(G) == "D$(m*2)"
        @test code_n(c) == 64 && code_k(c) == 32
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test small_group_identification(G) == (order(G), 18)
    end
end

@testitem "Quantum Reed-Muller" tags=[:ecc] begin
    using Test
    using Nemo: echelon_form, matrix, GF
    using LinearAlgebra
    using QuantumClifford
    using QuantumClifford: canonicalize!, Stabilizer, stab_to_gf2
    using QuantumClifford.ECC
    using QuantumClifford.ECC: AbstractECC, QuantumReedMuller, Steane7, CSS
    using QuantumClifford.ECC.QECCore: code_k, code_n, distance, rate, parity_matrix_x, parity_matrix_z

    function designed_distance(mat)
        dist = 3
        for row in eachrow(mat)
            count = sum(row)
            if count < dist
                return false
            end
        end
        return true
    end

    @testset "Test QuantumReedMuller(r,m) properties" begin
        for m in 3:10
            stab = parity_checks(QuantumReedMuller(m))
            H = stab_to_gf2(stab)
            @test designed_distance(H) == true
            # QuantumReedMuller(3) is the Steane7 code.
            @test canonicalize!(parity_checks(Steane7())) == parity_checks(QuantumReedMuller(3))
            @test code_n(QuantumReedMuller(m)) == 2^m - 1
            @test code_k(QuantumReedMuller(m)) == 1
            @test distance(QuantumReedMuller(m)) == 3
            @test H == stab_to_gf2(parity_checks(CSS(parity_matrix_x(QuantumReedMuller(m)), parity_matrix_z(QuantumReedMuller(m)))))
            # [[15,1,3]] qrm code from table 1 of https://arxiv.org/pdf/1705.0010
            qrm₁₅₁₃ = S"ZIZIZIZIZIZIZIZ
                        IZZIIZZIIZZIIZZ
                        IIIZZZZIIIIZZZZ
                        IIIIIIIZZZZZZZZ
                        IIZIIIZIIIZIIIZ
                        IIIIZIZIIIIIZIZ
                        IIIIIZZIIIIIIZZ
                        IIIIIIIIIZZIIZZ
                        IIIIIIIIIIIZZZZ
                        IIIIIIIIZIZIZIZ
                        XIXIXIXIXIXIXIX
                        IXXIIXXIIXXIIXX
                        IIIXXXXIIIIXXXX
                        IIIIIIIXXXXXXXX"
            @test canonicalize!(parity_checks(qrm₁₅₁₃)) == canonicalize!(parity_checks(QuantumReedMuller(4)))
        end
    end
end

"""
Checks the commutation relation between the left and right representation matrices
for two randomly-sampled elements `a` and `b` in the group algebra `ℱ[G]` with a general group `G`.
It verifies the commutation relation that states, `L(a)·R(b) = R(b)·L(a)`. This
property shows that matrices from the left and right representation sets commute
with each other, which is an important property related to the CSS orthogonality
condition. By default, we use `Hecke`’s `representation_matrix`, though a *custom*
`repr` function is also supported.

"""
function check_repr_commutation_relation(GA::GroupAlgebra; repr::Function=representation_matrix)
    a, b = rand(GA), rand(GA)
    # Check commutation relation: L(a)R(b) = R(b)L(a)
    L_a = repr(a)
    R_b = repr(b, :right)
    return L_a * R_b == R_b * L_a
end

"""
Verifies that the specified group elements constitute a regular *F-linear* representation
of the group `G` by checking the properties `L(a)L(b) = L(ab)` and `R(a)R(b) = R(ba)` for any
elements `a`, `b` in the group algebra `F[G]`. By default, we use `Hecke`’s `representation_matrix`,
though a *custom* `repr` function is also supported.
"""
function check_repr_regular_linear(GA::GroupAlgebra; repr::Function=representation_matrix)
    a, b = rand(GA), rand(GA)
    # L(a)L(b) = L(ab)
    L_a = repr(a)
    L_b = repr(b)
    L_ab = repr(a*b)
    # R(a)R(b) = R(ba)
    R_a = repr(a, :right)
    R_b = repr(b, :right)
    R_ba = repr(b*a, :right)
    return L_a*L_b == L_ab && R_a*R_b == R_ba
end

"""
The quotient ring ``\\mathbb{F}_2[x]/(x^\\ell - 1)``, consisting of binary polynomials
modulo ``x^\\ell - 1``, is isomorphic to the algebra of ``\\ell \\times \\ell`` circulant
matrices over ``\\mathbb{F}_2``. Thus, a polynomial ``p(x) = \\sum_{i=0}^{\\ell-1} p_i x^i``
can be mapped to a circulant matrix ``P`` whose first row is ``(p_0, p_{\\ell-1}, ..., p_1)``, with
each subsequent row being a cyclic right shift of the previous row [koukoulekidis2024smallquantumcodesalgebraic](@cite).
"""
function circulant_matrix_from_polynomial_ring(l::Int, h::FqPolyRingElem)
    R = parent(h)
    x = gen(R)
    _, proj = residue_ring(R, R(x)^l-1)
    h = proj(h)
    lifted_h = lift(h)
    coeffs = Int[lift(ZZ, coeff(lifted_h, i)) for i in 0:l-1]
    H = zero_matrix(GF(2), l, l)
    for i in 1:l
        for j in 1:l
            H[i, j] = coeffs[mod1(j-i+1, l)]
        end
    end
    H = [Int(lift(ZZ, H[i,j])) for i in 1:nrows(H), j in 1:ncols(H)]
    return H
end

"""
    $TYPEDEF

Generate a sparse *quasi-cyclic* polynomial matrix A where each entry is either 0 or a monomial
``x^i (0 \\leq i < \\ell)``. The matrix is constructed such that each row and column
has at most w non-zero entries. This ensures the resulting parity-check matrices ``H_X``
and ``H_Z`` are ``(w + deg b(x))``-limited. Thus, the Tanner graphs 𝒯_X and 𝒯_Z have girth 6
(no 4-cycles), improving belief propagation decoder performance [panteleev2021degenerate](@cite).
"""
function random_qc_ghp_code_matrix_A(S, b, n::Int, w::Int, l::Int; min_k::Int=10, max_attempts=1000, rng::AbstractRNG=default_rng())
    R = base_ring(S)
    x = gen(R)
    b_lifted = lift(b)
    xₗ₋₁ = R(x)^l - 1
    g = gcd(b_lifted, xₗ₋₁)
    k_b = degree(g)
    k_b == 0 && min_k > 0 && error("The chosen polynomial b(x) yields k_b=0. It cannot generate a code with min_k=$min_k. Choose a different b(x).")
    F, _ = residue_ring(R, g)
    for attempt in 1:max_attempts
        A = _matrix_A(S, n, w, l, rng)
        _meets_ghp_constraints(A, w) || continue
        A_proj = matrix(F, n, n, [F(lift((A[i,j]))) for i in 1:n, j in 1:n])
        rk_A_proj = rank(A_proj)
        k_A = n - rk_A_proj
        k = 2*k_A*k_b
        k >= min_k && return A
    end
    error("Failed to generate a valid QC matrix with k >= $min_k after $max_attempts attempts. Try increasing max_attempts, decreasing min_k, or choosing a different b(x) with higher k_b.")
end

function _matrix_A(S, n, w, l, rng)
    R = base_ring(S)
    x = gen(R)
    temp = [S(0) for _ in 1:n]
    positions = randperm(rng, n)[1:w]
    for pos in positions
        exp = rand(rng, 0:l-1)
        temp[pos] = S(x^exp)
    end
    A = zero_matrix(S, n, n)
    for i in 1:n
        for j in 1:n
            shift_idx = mod(j - i, n) + 1
            A[i, j] = temp[shift_idx]
        end
    end
    return A
end

function _meets_ghp_constraints(A, w::Int)
    n = size(A, 1)
    # Each row has exactly w non-zero entries.
    for i in 1:n
        row_cnt = count(j -> !iszero(A[i, j]), 1:n)
        row_cnt ≠ w && return false
    end
    # Each column has exactly w non-zero entries.
    for j in 1:n
        col_cnt = count(i -> !iszero(A[i, j]), 1:n)
        col_cnt ≠ w && return false
    end
    # All non-zero entries are monomials x^i.
    for i in 1:n, j in 1:n
        if !iszero(A[i, j])
            p = lift(A[i, j])
            if count(!iszero, coefficients(p)) ≠ 1
                return false
            end
        end
    end
    return true
end

@testitem "ECC QLDPC minimum distance" tags=[:ecc] begin
    using Hecke
    using JuMP
    using HiGHS
    using Hecke: group_algebra, GF, abelian_group, gens
    using QuantumClifford.ECC: two_block_group_algebra_codes, generalized_bicycle_codes, code_k, code_n, distance, DistanceMIPAlgorithm

    @testset "minimum distance properties: GB" begin
        # [48, 6, 8]] GB code, # minimum distance is exact, d = 8
        l = 24
        c = generalized_bicycle_codes([0, 2, 8, 15], [0, 2, 12, 17], l)
        # minimum distance is exact, d = 8
        i = rand(1:code_k(c))
        # By default, the minimum distance for the Z-type logical operator is computed.
        # The minimum distance for X-type logical operators is the same.
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == distance(c, DistanceMIPAlgorithm(logical_operator_type=:Z; solver=HiGHS)) == 8
    end
    @testset "minimum distance properties: Weight-7 MB" begin
        # [[30, 4, 5]] MB code from Table 1 of [voss2024multivariatebicyclecodes](@cite)
        l=5; m=3
        GA = group_algebra(GF(2), abelian_group([l, m]))
        x, y = gens(GA)
        z = x*y
        A = x^4 + x^2
        B = x + x^2 + y + z^2 + z^3
        c = two_block_group_algebra_codes(A, B)
        # minimum distance is exact, d = 5
        i = rand(1:code_k(c))
        @test code_n(c) == 30 && code_k(c) == 4
        # By default, the minimum distance for the Z-type logical operator is computed.
        # The minimum distance for X-type logical operators is the same.
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == distance(c, DistanceMIPAlgorithm(logical_operator_type=:Z; solver=HiGHS)) == 5
    end
end

# Works even when broadcasting on zero-dimensional arrays.
@inline u32(v) = map(x -> UInt32(x), v)

# Surprisingly, these do not already exist.
@inline get_pauli(t::Tableau, i::Integer) =
    PauliOperator((@view t.phases[i]), t.nqubits, (@view t.xzs[:, i]))
@inline get_pauli(s::AbstractStabilizer, i::Integer) =
    PauliOperator(
        (@view s.tab.phases[i]),
        s.tab.nqubits,
        (@view s.tab.xzs[:, i])
        )

@inline phases(t::Tableau) = t.phases
@inline phases(t::Tableau, i::Integer) = (@view t.phases[i])
@inline phases(s::AbstractStabilizer) = s.tab.phases
@inline phases(s::AbstractStabilizer, i::Integer) = (@view s.tab.phases[i])
@inline xzs(t::Tableau) = t.xzs
@inline xzs(t::Tableau, i::Integer) = (@view t.xzs[:, i])
@inline xzs(s::AbstractStabilizer) = s.tab.xzs
@inline xzs(s::AbstractStabilizer, i::Integer) = (@view s.tab.xzs[:, i])

"""
    $TYPEDEF

Constructs a D-dimensional CSS quantum code (D ≥ 2) from D classical parity-check
matrices via iterated *homological* products.

Several interpretations of the homological product exist. For example,
[bravyi2013homologicalproductcodes](@cite) employ a simplified version known
as the *single-sector* homological product. In contrast, the `HomologicalProduct`
adopts a more conventional definition, which [bravyi2013homologicalproductcodes](@cite)
would refer to as the *multi-sector* homological product.

The term "homological product codes" can broadly encompass various constructions
involving the product of quantum codes ([bravyi2013homologicalproductcodes](@cite),
[Campbell_2019](@cite)). However, `HomologicalProduct` focuses specifically on a
particular subset—namely, the product of classical codes, which can also be described
as length-`1` chain complexes (sometimes called high-dimensional hypergraph product codes
[Zeng_2019](@cite)).

# Product Complex

Given ``D`` chain complexes ``\\{\\mathcal{B}^i\\}_{i\\in[D]}``, where
``\\mathcal{B}^i = \\{\\{B^i_{x_i}\\}_{x_i}, \\{\\partial^i_{x_i}\\}_{x_i}\\}``,
the ``D``-dimensional product complex is defined as:

```math
\\begin{aligned}
\\mathcal{D} = \\{\\{D_{\\vec{x}}\\}_{\\vec{x}=(x_1,\\dots,x_D)^T \\in \\mathbb{Z}^D}, \\{\\partial^i_{\\vec{x}}: D_{\\vec{x}} \\to D_{\\vec{x}-\\vec{e}_i}\\}_{i\\in[D],\\vec{x}\\in\\mathbb{Z}^D}\\} := \\text{Prod}(\\{\\mathcal{B}^i\\}_{i\\in[D]})
\\end{aligned}
```

the tensor product of these chain complexes, where:

```math
\\begin{aligned}
D_{\\vec{x}} := \\bigotimes_{i=1}^D B^i_{x_i}, \\\\
\\partial^i_{\\vec{x}} := \\bigotimes_{j=1}^D (\\partial^j_{x_j})^{\\delta_{i,j}}
\\end{aligned}
```

where ``\\delta_{i,j}`` is the Kronecker delta function and ``(\\partial^j_{x_j})^0``
is defined as the identity map [xu2024fastparallelizablelogicalcomputation](@cite).

A product complex is a high-dimensional generalization of the chain complex.

# Total Complex

The ``\\mathcal{D}``-product complex is constructed from ``D`` base chain complexes
with vector spaces ``\\{D_{\\vec{x}}\\}_{\\vec{x}}`` and boundary maps
``\\{\\partial^i_{\\vec{x}}\\}_{i\\in[D],\\vec{x}}``. It's total chain complex
``\\mathcal{T} = \\{\\{T_k\\}_k, \\{\\delta_k\\}_k\\} := \\text{Tot}(\\mathcal{D})``
as follows:

```math
\\begin{aligned}
T_k := \\bigoplus_{|\\vec{x}|=k} D_{\\vec{x}}
\\end{aligned}
```

and the boundary maps:

```math
\\begin{aligned}
\\delta_k\\left(\\bigoplus_{|\\vec{x}|=k} a_{\\vec{x}}\\right) = \\sum_{|\\vec{x}|=k} \\left(\\bigoplus_{|\\vec{y}|=k-1} \\partial_{\\vec{y},\\vec{x}} a_{\\vec{x}}\\right)
\\end{aligned}
```

for any ``a_{\\vec{x}} \\in D_{\\vec{x}}``, and

```math
\\begin{aligned}
\\partial_{\\vec{y},\\vec{x}} :=
\\begin{cases}
\\partial^i_{\\vec{x}} & \\text{if } \\vec{x} - \\vec{y} = \\vec{e}_i \\text{ for some } i \\in [D], \\\\
0 & \\text{otherwise.}
\\end{cases}
\\end{aligned}
```

!!! note
    The total complex is obtained by projecting the ``D``-dimensional complex along
    the "diagonal" direction. Once a total chain complex is derived from a product complex
    (with length greater than 2), a quantum code can be defined from a length-2
    subcomplex [xu2024fastparallelizablelogicalcomputation](@cite).

[xu2024fastparallelizablelogicalcomputation](@cite) focuses on product complexes with
length-1 base complexes ``\\{\\mathcal{C}^i\\}_{i\\in[D]}}`` (classical codes). In this
case, the total complex ``\\mathcal{T} = \\text{Tot}(\\text{Prod}(\\{\\mathcal{C}^i\\}_{i\\in[D]}))``
has length ``D``:

```math
\\begin{aligned}
T_D \\xrightarrow{\\delta_D} T_{D-1} \\xrightarrow{\\delta_{D-1}} \\cdots \\xrightarrow{\\delta_1} T_0
\\end{aligned}
```

[xu2024fastparallelizablelogicalcomputation](@cite) considers dimensions ``D = 2, 3, 4``.
- For ``D = 2``, the standard hypergraph product code is obtained, with planar surface codes as a special case [xu2024fastparallelizablelogicalcomputation](@cite).
- For ``D = 3`` and ``D = 4``, the construction yields 3D and 4D homological product codes, with 3D surface/toric codes serving as specific instances [xu2024fastparallelizablelogicalcomputation](@cite).

# Examples

Here is a 3D Homological product code from [Quintavalle_2021](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC; using QECCore;

julia> δ = matrix(GF(2), parity_matrix(RepCode(3)));

julia> c = HomologicalProduct([δ,δ,δ]);

julia> import HiGHS; import JuMP;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(81, 3, 3)
```

Here is the `[[117, 9, 4]]` Homological product code construct from classical
quasi-cyclic code from Table III of [xu2024fastparallelizablelogicalcomputation](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC; using QECCore;

julia> R, x = polynomial_ring(GF(2), "x");

julia> l = 3;

julia> H = matrix(R, 2, 3, [x^2 x^2 x^2;
                            x   x^2  0]);

julia> c = HomologicalProduct([H,transpose(H)], l);

julia> import HiGHS; import JuMP;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(117, 9, 4)
```

Here is a Homological product of `(3,4)`-classical LDPC codes.

```jldoctest
julia> using Oscar, QuantumClifford, QuantumClifford.ECC, QECCore;

julia> μ = 2; wc = 3; wr = 4;

julia> c = random_Gallager_ldpc(μ, wc, wr);

julia> H = matrix(GF(2), c);

julia> c = HomologicalProduct([H,transpose(H)]);
```

### Fields
    $TYPEDFIELDS
"""
struct HomologicalProduct{T<:MatElem} <: AbstractCSSCode
    """A length-`D` vector of parity-check matrices of classical error-correcting codes."""
    boundary_maps::Vector{T}
    function HomologicalProduct(boundary_maps::Vector{T}) where {T <: MatElem}
        length(boundary_maps) >= 2 || throw(ArgumentError("At least `2` boundary maps must be provided."))
        all(base_ring(δ) == base_ring(boundary_maps[1]) for δ in boundary_maps) || throw(ArgumentError("All boundary maps must have the same base ring."))
        new{T}(boundary_maps)
    end
end

"""Convert a polynomial parity-check matrix or generator check matrix to binary quasi-cyclic form."""
function _circulant_matrix_from_quasi_cyclic_polynomial_matrix(H::MatSpaceElem, l::Int)
    F = GF(2)
    r, n = size(H)
    H_bin = zero_matrix(F, r*l, n*l)
    for i in 1:r, j in 1:n
        cfs = fill(zero(F), l)
        for (k, c) in enumerate(coefficients(H[i,j]))
            cfs[k] = c
        end
        circ = hcat([circshift(cfs, s) for s in 0:l-1]...)
        rows = (1:l) .+ (i-1)*l
        cols = (1:l) .+ (j-1)*l
        H_bin[rows, cols] = matrix(F, circ)
    end
    return H_bin
end

function HomologicalProduct(boundary_maps::Vector{MatSpaceElem{FqPolyRingElem}}, l::Int)
    δₛ = [_circulant_matrix_from_quasi_cyclic_polynomial_matrix(δ, l) for δ in boundary_maps]
    HomologicalProduct(δₛ)
end

HomologicalProduct(boundary_maps::Vector{MatSpaceElem{FqPolyRingElem}}; l::Int) = HomologicalProduct(boundary_maps, l)

function boundary_maps(hp::HomologicalProduct)
    length(hp.boundary_maps) < 2 && throw(ArgumentError("`HomologicalProduct` requires at least `2` boundary maps."))
    typeof(hp.boundary_maps) == Vector{MatSpaceElem{FqPolyRingElem}} ? [_circulant_matrix_from_quasi_cyclic_polynomial_matrix(δ, c.l) for δ in hp.boundary_maps] : hp.boundary_maps
    R = base_ring(hp.boundary_maps[1])
    C = chain_complex([hom(free_module(R, size(hp.boundary_maps[1],1)), free_module(R, size(hp.boundary_maps[1],2)), hp.boundary_maps[1])], seed=0)
    for i in 2:length(hp.boundary_maps)
        δ = hp.boundary_maps[i]
        C_next = chain_complex([hom(free_module(R, size(δ,1)), free_module(R, size(δ,2)), δ)], seed=0)
        C = tensor_product(C, C_next)
        C = total_complex(C)
    end
    δs = [matrix(map(C, d)) for d in 1:length(hp.boundary_maps)]
    return matrix_to_int.(δs)
end

function metacheck_matrix_x(c::HomologicalProduct)
    length(c.boundary_maps) ≥ 3 || throw(ArgumentError("`X`-metachecks (`Mx`) require three classical seed codes (D=$(length(c.boundary_maps))"))
    return boundary_maps(c)[3] # Mx = δ₂
end

parity_matrix_x(hp::HomologicalProduct) = boundary_maps(hp)[2]

parity_matrix_z(hp::HomologicalProduct) = boundary_maps(hp)[1]'

hasmetachecks(c::HomologicalProduct) = length(c.boundary_maps) >= 4 ? (true, true) : length(c.boundary_maps) == 3 ? (true, false) : (false, false)

"""
Constructs the *Double Homological Product code* from [Campbell_2019](@cite).

# 4-term Chain Complex

To construct a quantum error-correcting code with *metachecks*, we require a length-4 chain
complex. This can be built by taking the *homological product* of two length-2 chain complexes.

The length-4 chain complex, structured as:

```math
\\begin{aligned}
\\breve{C}_{-2} \\xrightarrow{\\breve{\\delta}_{-2}} \\breve{C}_{-1} \\xrightarrow{\\breve{\\delta}_{-1}} \\breve{C}_0 \\xrightarrow{\\breve{\\delta}_0} \\breve{C}_1 \\xrightarrow{\\breve{\\delta}_1} \\breve{C}_2
\\end{aligned}
```

The homological product of two 2D chain complexes produces this length-4 complex, following the general rule:

```math
\\begin{aligned}
\\breve{C}_m = \\bigoplus_{i - j = m} \\tilde{C}_i \\otimes \\tilde{C}_j
\\end{aligned}
```

The boundary maps are represented as block matrices and are defined as:

```math
\\begin{align}
\\breve{\\delta}_{-2} &= \\begin{pmatrix}
I \\otimes \\tilde{\\delta}_0^T \\\\
\\tilde{\\delta}_{-1} \\otimes I
\\end{pmatrix} \\\\
\\breve{\\delta}_{-1} &= \\begin{pmatrix}
I \\otimes \\tilde{\\delta}_{-1}^T & 0 \\\\
\\tilde{\\delta}_{-1} \\otimes I & I \\otimes \\tilde{\\delta}_0^T \\\\
0 & \\tilde{\\delta}_0 \\otimes I
\\end{pmatrix} \\\\
\\breve{\\delta}_0 &= \\begin{pmatrix}
\\tilde{\\delta}_{-1} \\otimes I & I \\otimes \\tilde{\\delta}_{-1}^T & 0 \\\\
0 & \\tilde{\\delta}_0 \\otimes I & I \\otimes \\tilde{\\delta}_0^T
\\end{pmatrix} \\\\
\\breve{\\delta}_1 &= \\begin{pmatrix}
\\tilde{\\delta}_0 \\otimes I & I \\otimes \\tilde{\\delta}_{-1}^T
\\end{pmatrix}
\\end{align}
```

The condition ``\\breve{\\delta}_{j+1} \\breve{\\delta}_j = 0`` holds for all j,
which follows from the corresponding property of the ``\\tilde{\\delta}`` matrices.

#### Example

Here is `[[241, 1, 9]]` double homological product code from Table I of [Campbell_2019](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC; using QECCore;

julia> δ = [1 1 0;
            0 1 1];

julia> c = DoubleHomologicalProduct(δ);

julia> import HiGHS; import JuMP;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(241, 1, 9)
```

### Fields
    $TYPEDFIELDS
"""
struct DoubleHomologicalProduct <: AbstractCSSCode
    """The parity-check matrix of a classical error-correcting code."""
    H::AbstractMatrix
end

function boundary_maps(c::DoubleHomologicalProduct)
    R = GF(2)
    n = size(c.H, 2)
    m = size(c.H, 1)
    δ₀ = matrix(R, c.H)
    # see Eq. 43 of [Campbell_2019](@cite).
    # δ̃₋₁ = (I ⊗ δ₀ᵀ) ⊕ (δ₀ ⊗ I)
    δ̃₋₁ = vcat(
        kronecker_product(identity_matrix(R, n), transpose(δ₀)),
        kronecker_product(δ₀, identity_matrix(R, m))
    )
    # see Eq. 43 of [Campbell_2019](@cite).
    # δ̃₀ = [δ₀ ⊗ I | I ⊗ δ₀ᵀ]
    δ̃₀ = hcat(
        kronecker_product(δ₀, identity_matrix(R, n)),
        kronecker_product(identity_matrix(R, m), transpose(δ₀))
    )
    ñ₋₁ = n*m # Eq. 44
    ñ₀ = n^2 + m^2 # Eq. 44
    ñ₁ = n*m # Eq. 44

    # see Eq. 58 of [Campbell_2019](@cite).
    # δ̌₋₂  = (I ⊗ δ̃₀ᵀ) ⊕ (δ̃₋₁ ⊗ I)
    δ̌₋₂ = vcat(
        kronecker_product(identity_matrix(R, ñ₋₁), transpose(δ̃₀)),
        kronecker_product(δ̃₋₁, identity_matrix(R, ñ₁))
    )
    # see Eq. 59 of [Campbell_2019](@cite).
    # δ̌₋₁ = [I ⊗ δ̃₋₁ᵀ |    0
    #        δ̃₋₁ ⊗ I  | I ⊗ δ̃₀ᵀ
    #           0      | δ̃₀ ⊗ I]

    # I ⊗ δ̃₋₁ᵀ  0
    tb = hcat(
        kronecker_product(identity_matrix(R, ñ₁), transpose(δ̃₋₁)),
        zero_matrix(R, ñ₋₁ * ñ₋₁, ñ₁ * ñ₀)
    )

    # δ̃₋₁ ⊗ I  I ⊗ δ̃₀ᵀ
    mb = hcat(
        kronecker_product(δ̃₋₁, identity_matrix(R, ñ₀)),
        kronecker_product(identity_matrix(R, ñ₀), transpose(δ̃₀))
    )

    # 0 δ̃₀ ⊗ I
    bb = hcat(
        zero_matrix(R, ñ₁ * ñ₁, ñ₋₁ * ñ₀),
        kronecker_product(δ̃₀, identity_matrix(R, ñ₁))
    )

    δ̌₋₁ = vcat(tb, mb, bb)
    @assert iszero(δ̌₋₁*δ̌₋₂)

    # see Eq. 60 of [Campbell_2019](@cite).
    # δ̌0 = [δ̃₋₁ ⊗ I | I ⊗ δ̃₋₁ᵀ | 0
    #       0        | δ̃₀ ⊗ I   | I ⊗ δ̃₀ᵀ]
    tb = vcat(
        kronecker_product(δ̃₋₁, identity_matrix(R, ñ₋₁)),
        zero_matrix(R, ñ₀ * ñ₋₁, ñ₁ * ñ₁)
    )
    mb = vcat(
        kronecker_product(identity_matrix(R, ñ₀), transpose(δ̃₋₁)),
        kronecker_product(δ̃₀, identity_matrix(R, ñ₀))
    )
    bb = vcat(
        zero_matrix(R, ñ₀ * ñ₋₁, ñ₁ * ñ₁),
        kronecker_product(identity_matrix(R, ñ₁), transpose(δ̃₀)),
    )
    δ̌₀ = hcat(tb, mb, bb)

    # see Eq. 61 of [Campbell_2019](@cite).
    # δ̌1 = [δ̃₀ ⊗ I | I ⊗ δ̃₋₁ᵀ]
    δ̌₁ = hcat(
        kronecker_product(δ̃₀, identity_matrix(R, ñ₋₁)),
        kronecker_product(identity_matrix(R, ñ₋₁), transpose(δ̃₋₁))
    )
    @assert iszero(δ̌₁*δ̌₀)
    return fq_to_int(δ̌₋₂), fq_to_int(δ̌₋₁), fq_to_int(δ̌₀), fq_to_int(δ̌₁)
end

parity_matrix_x(c::DoubleHomologicalProduct) = boundary_maps(c)[3] # δ̌₀

parity_matrix_z(c::DoubleHomologicalProduct) = boundary_maps(c)[2]' # δ̌₋₁'

metacheck_matrix_x(c::DoubleHomologicalProduct) = boundary_maps(c)[4] # δ̌₁

metacheck_matrix_z(c::DoubleHomologicalProduct) = boundary_maps(c)[1]' # δ̌₋₂'

hasmetachecks(c::DoubleHomologicalProduct) = (true, true)

@testitem "Apply Inv" begin
    using InteractiveUtils

    @testset "Apply Inv" begin
        stabilizers = [S" I", S" X", S" Y", S" Z",
                       S"-I", S"-X", S"-Y", S"-Z",]
        for gate in subtypes(AbstractSingleQubitOperator)
            gate == SingleQubitOperator && continue
            for stab in stabilizers
                @test apply_inv!(stab, gate(1)) == apply!(stab, inv(CliffordOperator(gate(1), 1)))
            end
        end
    end

    @testset "Apply Inv two-qubit" begin
        stabilizers = [S" II", S" IX", S" IY", S" IZ",
                       S"-II", S"-IX", S"-IY", S"-IZ",
                       S" XI", S" XX", S" XY", S" XZ",
                       S"-XI", S"-XX", S"-XY", S"-XZ",
                       S" YI", S" YX", S" YY", S" YZ",
                       S"-YI", S"-YX", S"-YY", S"-YZ",
                       S" ZI", S" ZX", S" ZY", S" ZZ",
                       S"-ZI", S"-ZX", S"-ZY", S"-ZZ",]                        
        for gate in subtypes(AbstractTwoQubitOperator)
            for stab in stabilizers
                @test apply_inv!(stab, gate(1, 2)) == apply!(stab, inv(CliffordOperator(gate(1, 2), 2)))
            end
        end
    end

    @testset "Apply Inv subsystem order" begin
        state = S"X_Z"
        operation = tCNOT
        indices = [3, 1]

        expected = apply!(copy(state), indices, inv(operation))
        @test apply_inv!(copy(state), indices, operation) == expected
        @test apply_inv!(copy(state), Tuple(indices), operation) == expected

        legacy_state = copy(state)
        @test_deprecated apply_inv!(legacy_state, operation, indices)
        @test legacy_state == expected

        @test hasmethod(apply_inv!, Tuple{typeof(state), typeof(operation), Int})
        @test_deprecated begin
            @test_throws MethodError apply_inv!(copy(state), operation, 1)
        end

        @test_throws MethodError apply!(copy(state), operation, indices)
        @test_throws MethodError apply!(Register(copy(state)), operation, indices)
    end

    @testset "Apply Inv Pauli phases" begin
        for phases in (true, false)
            operation = P"Z"

            state = S"X"
            @test apply_inv!(copy(state), operation; phases) ==
                  apply!(copy(state), operation; phases)

            subsystem_state = S"X_"
            indices = [1]
            @test apply_inv!(copy(subsystem_state), indices, operation; phases) ==
                  apply!(copy(subsystem_state), indices, operation; phases)
        end
    end

end

@testitem "GF(2) representations" begin
    using Random
    using QuantumClifford: stab_looks_good, destab_looks_good, mixed_stab_looks_good, mixed_destab_looks_good
    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    @testset "Equivalence of GF(2) Gaussian elimination and Stabilizer canonicalization" begin
        for n in test_sizes
            for rep in 1:5
                s = random_stabilizer(n)[randperm(n)[1:rand(n÷2+1:n)]]
                cs = canonicalize!(copy(s));
                H = stab_to_gf2(cs);
                cH = gf2_gausselim!(stab_to_gf2(s));
                @test H==cH
            end
        end
    end
    @testset "GF(2) H and G matrices" begin
        for n in test_sizes
            for rep in 1:5
                H = random_invertible_gf2(n)[randperm(n)[1:rand(n÷2+1:n)],:]
                H = gf2_gausselim!(H)
                G = gf2_H_to_G(H)
                @test sum(G*H' .%2)==0;
            end
        end
    end
end

#=============================================================================#
# CAUTION: Requires an integral ratio between the sizes of the data types.
@inline function change_type(
    ::Type{T}, source::AbstractArray{S}; interpret::Bool = false
    ) where {T <: Unsigned, S <: Unsigned}

    if T == S
        output = copy(source)
    elseif !interpret || size(source) == ()
        output = map(x -> T(x), source)
    elseif sizeof(S) >= sizeof(T)
        output = copy(reinterpret(T, source))
    else
        len, dims... = size(source)
        new_len = cld(len, div(sizeof(T), sizeof(S)))
        output = similar(source, T, new_len, dims...)
        @inbounds fill!(
            (@view output[new_len, Base.OneTo.(dims)...]),
            zero(T)
            )
        temp = reinterpret(S, output)
        @inbounds (
            @view temp[Base.OneTo(len), Base.OneTo.(dims)...]
            ) .= source
    end
    return output

end
#=============================================================================#

@testitem "Mul leftright" begin
  @testset "Pauli string multiplication" begin
    using QuantumClifford: mul_left!, mul_right!
    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.


    for n in test_sizes
      for _ in 1:20
        p1 = random_pauli(n)
        p2 = random_pauli(n)
        s = random_stabilizer(n)
        i = rand(1:n)
        @test p1*p2 == mul_left!(copy(p2), p1)
        @test p1*p2 == mul_right!(copy(p1), p2)
        @test mul_left!(copy(p2), p1) == (-1)^comm(p1,p2) * mul_right!(copy(p2), p1)
        @test mul_left!(copy(p2), s[i]) == mul_left!(copy(p2), s, i) == s[i]*p2
        @test mul_right!(copy(p2), s[i]) == mul_right!(copy(p2), s, i) == p2*s[i]
        @test mul_left!(copy(s), p2)[i] == p2*s[i]
        @test mul_right!(copy(s), p2)[i] == s[i]*p2
      end
    end
  end

  # test for #320
  @testset "verify SIMD implementation" begin
    for i in 1:10,
      n in 1:30,
      T in [UInt8, UInt16, UInt32, UInt64]
      a = rand(T, n)
      b = rand(T, n)
      c1,c2 = QuantumClifford.mul_ordered!(copy(a),copy(b))
      n1,n2 = QuantumClifford._mul_ordered_nonvec!(copy(a),copy(b))
      np = ((n1 ⊻ (n2<<1))&0x3)
      cp = ((c1 ⊻ (c2<<1))&0x3)
      @test np==cp
    end
  end
end

using QuantumClifford: get_bitmask_idxs

##############################
# sMZ
##############################

function apply_sMZ_kernel!(xzs::DeviceMatrix{Tₘₑ},
                          measurements::DeviceMatrix{Bool},
                          op::sMZ,
                          ibig::Int,
                          ismallm::Tₘₑ,
                          rows::Int) where {Tₘₑ <: Unsigned}
    f = (blockIdx().x - 1) * blockDim().x + threadIdx().x;
    if f > rows
        return nothing
    end
    should_flip = !iszero(xzs[ibig,f] & ismallm)
    measurements[f,op.bit] = should_flip
    return nothing
end

function apply!(frame::PauliFrameGPU{T}, op::QuantumClifford.sMZ) where {T <: Unsigned}
    op.bit == 0 && return frame
    i = op.qubit
    xzs = frame.frame.tab.xzs
    lowbit, ibig, ismall, ismallm = get_bitmask_idxs(xzs,i)
    (@run_cuda apply_sMZ_kernel!(xzs, frame.measurements, op, ibig, ismallm, length(frame)) length(frame))
    return frame
end

##############################
# sMRZ
##############################

function apply_sMRZ_kernel!(xzs::DeviceMatrix{Tₘₑ},
                          measurements::DeviceMatrix{Bool},
                          op::QuantumClifford.sMRZ,
                          ibig::Int, # todo change to Int
                          ismallm::Tₘₑ,
                          rows::Int) where {Tₘₑ <: Unsigned}
    f = (blockIdx().x - 1) * blockDim().x + threadIdx().x;
    if f > rows
        return nothing
    end
    if op.bit != 0 # not good practice. how to replace 0?
        should_flip = !iszero(xzs[ibig,f] & ismallm)
        measurements[f,op.bit] = should_flip
    end
    xzs[ibig,f] &= ~ismallm
    rand(Bool) && (xzs[end÷2+ibig,f] ⊻= ismallm)
    return nothing
end

function apply!(frame::PauliFrameGPU{T}, op::QuantumClifford.sMRZ) where {T <: Unsigned} # TODO sMRX, sMRY
    i = op.qubit
    xzs = frame.frame.tab.xzs
    lowbit, ibig, ismall, ismallm = get_bitmask_idxs(xzs,i)
    (@run_cuda apply_sMRZ_kernel!(xzs, frame.measurements, op, ibig, ismallm, length(frame)) length(frame))
    return frame
end

using CairoMakie
using AlgebraOfGraphics
using QuantumClifford
using PkgBenchmark
using DataFrames
using DataFramesMeta
using Statistics
using Glob

##
cd("QuantumCliffordBenchmarksLog/ttfxlogs")
##
files = glob("using_*.ttfxresults")
records = []
for f in files
    m = match(r"using_tag=(v[\d\.]*)-nthreads=(\d)-julia=([\d\.\w]*).ttfxresults", f)
    if isnothing(m)
        @warn "problem with $(f)"
        continue
    end
    tag = m.captures[1]
    version = VersionNumber(tag[2:end])
    threads = m.captures[2]
    juliastr = m.captures[3]
    julia = juliastr=="nightly" ? v"1.999" : VersionNumber(m.captures[3])
    pkgimportsamples = parse.(Float64, readlines(f))
    pkgimport = isempty(pkgimportsamples) ? missing : minimum(parse.(Float64, readlines(f)))
    tasksamples = parse.(Float64, readlines("task_tag=$(tag)-nthreads=$(threads)-julia=$(juliastr).ttfxresults"))
    task = isempty(tasksamples) ? missing : minimum(tasksamples)
    push!(records, (;version, threads, julia, pkgimport, task))
end

##

df = DataFrame(records)
maxjversion = maximum(df[df.julia .!= v"1.999",:julia])
df[df.julia .== v"1.999", :julia] .= VersionNumber(maxjversion.major, maxjversion.minor+1, 0)
df[!,:total] .= df[:,:task] .+ df[:,:pkgimport]
df = DataFrames.stack(df, [:total, :task, :pkgimport], variable_name=:x, value_name=:time)
sort!(df) # by first column (version)

df = df[df.time .!== missing,:] # otherwise the ticks are messed up, probably a bug

layers = visual(Stairs, step=:center)
maxy = ceil(maximum(skipmissing(df.time)))
axis = (;width = 800, height = 400, xticklabelrotation=-pi/2, yticks=(0:0.5:maxy))
facet = (;
    linkyaxes=:minimal,
    )

##

benchmark_data = data(df)
mappings = mapping(:version, :time, color=:julia, row=:x, col=:threads)
f = draw(benchmark_data * layers * mappings; facet, axis)
save("../benchmarks_ttfx.png",f)

@testitem "ECC Syndromes" tags=[:ecc, :ecc_syndrome_circuit_equivalence] begin
    using QuantumClifford: mul_left!, embed
    using QuantumClifford.ECC
    using QuantumClifford.ECC: AbstractECC

    include("test_ecc_base.jl")

    using QuantumClifford: Tableau
    reinterpret_frame(frame) = PauliFrame(reinterpret_stab(frame.frame), copy(frame.measurements))
    reinterpret_stab(s) = Stabilizer(Tableau(copy(phases(s)), nqubits(s), collect(reinterpret(UInt8, collect(s.tab.xzs)))[[1:1+(nqubits(s)-1)÷8;end÷2+1:end÷2+1+(nqubits(s)-1)÷8],:]))
    reinterpret_p(p) = PauliOperator(p.phase, nqubits(p), collect(reinterpret(UInt8, p.xz))[[1:1+(nqubits(p)-1)÷8;end÷2+1:end÷2+1+(nqubits(p)-1)÷8]])

    function pframe_naive_vs_shor_syndrome(code)
        ecirc = naive_encoding_circuit(code)
        naive_scirc, naive_ancillaries = naive_syndrome_circuit(code)
        shor_cat_scirc, shor_scirc, shor_ancillaries, shor_bits = shor_syndrome_circuit(code)
        nframes = 10
        dataqubits = code_n(code)
        syndromebits = code_s(code)
        naive_qubits = dataqubits + syndromebits
        shor_qubits = dataqubits + shor_ancillaries
        # no noise
        naive_frames = PauliFrame(nframes, naive_qubits, syndromebits)
        shor_frames = PauliFrame(nframes, shor_qubits, last(shor_bits))
        naive_circuit = vcat(ecirc, naive_scirc)
        shor_circuit = vcat(ecirc, shor_cat_scirc, shor_scirc)
        pftrajectories(naive_frames, naive_circuit)
        pftrajectories(shor_frames, shor_circuit)
        @test measurements(naive_frames) == measurements(shor_frames)[:,shor_bits]
        # with errors
        for _ in 1:10
            naive_frames = PauliFrame(nframes, naive_qubits, syndromebits)
            shor_frames = PauliFrame(nframes, shor_qubits, last(shor_bits))
            pftrajectories(naive_frames, ecirc)
            pftrajectories(shor_frames, vcat(ecirc, shor_cat_scirc))
            # manually injecting the same type of noise in the frames -- not really a user accessible API
            p = random_pauli(dataqubits, realphase=true)
            pₙ = embed(naive_qubits+1, 1:dataqubits, p) # +1 to account for the buffer qubit hidden in pauli frames
            pₛ = embed(shor_qubits+1, 1:dataqubits, p)  # +1 to account for the buffer qubit hidden in pauli frames
            mul_left!(naive_frames.frame, pₙ)
            mul_left!(shor_frames.frame, pₛ)
            # run the syndrome circuits using the public API
            pftrajectories(naive_frames, naive_scirc)
            pftrajectories(shor_frames, shor_scirc)
            @test measurements(naive_frames) == measurements(shor_frames)[:,shor_bits]

            # just for completeness, let's also try bitpacking in UInt8 instead of the default UInt
            _naive_frames = PauliFrame(nframes, naive_qubits, syndromebits)
            _shor_frames = PauliFrame(nframes, shor_qubits, last(shor_bits))
            naive_uint8 = reinterpret_frame(_naive_frames)
            shor_uint8 = reinterpret_frame(_shor_frames)
            pftrajectories(naive_uint8, ecirc)
            pftrajectories(shor_uint8, vcat(ecirc, shor_cat_scirc))
            p_uint8 = reinterpret_p(p)
            pₙ_uint8 = embed(naive_qubits+1, 1:dataqubits, p_uint8)
            pₛ_uint8 = embed(shor_qubits+1, 1:dataqubits, p_uint8)
            mul_left!(naive_uint8.frame, pₙ_uint8)
            mul_left!(shor_uint8.frame, pₛ_uint8)
            pftrajectories(naive_uint8, naive_scirc)
            pftrajectories(shor_uint8, shor_scirc)
            @test measurements(shor_uint8)[:,shor_bits] == measurements(shor_frames)[:,shor_bits] == measurements(naive_frames) == measurements(naive_uint8)
        end
    end

    @testset "naive and shor measurement circuits" begin
        for (i,c) in enumerate(all_testable_code_instances())
            pframe_naive_vs_shor_syndrome(c)
        end
    end
end

import QuantumInterface: nsubsystems

"""A Stabilizer measurement on the entirety of the quantum register.

`projectrand!(state, pauli)` and `apply!(state, PauliMeasurement(pauli))` give the same (possibly non-deterministic) result.
Particularly useful when acting on [`Register`](@ref).

See also: [`apply!`](@ref), [`projectrand!`](@ref)."""
struct PauliMeasurement{
    P <: AbstractArray{<: Unsigned, 0}, XZ <: AbstractVector{<: Unsigned}
} <: AbstractMeasurement
    pauli::PauliOperator{P,XZ}
    bit::Int
end

PauliMeasurement(pauli) = PauliMeasurement(pauli,0)
PauliMeasurement(pauli,::Nothing) = PauliMeasurement(pauli,0)

function apply!(state::AbstractStabilizer, m::PauliMeasurement)
    projectrand!(state,m.pauli)
    state
end

function apply!(state::MixedDestabilizer, indices::Base.AbstractVecOrTuple, operation::Type{<:AbstractSymbolicOperator})
    apply!(state, operation(indices...))
end

"""A Clifford gate, applying the given `cliff` operator to the qubits at the selected `indices`.

`apply!(state, indices, cliff)` and `apply!(state, SparseGate(cliff, indices))` give the same result."""
struct SparseGate{T<:Tableau} <: AbstractCliffordOperator # TODO simplify type parameters (remove nesting)
    cliff::CliffordOperator{T}
    indices::Vector{Int}
    function SparseGate(cliff::CliffordOperator{T}, indices::Vector{Int}) where T<:Tableau
        if length(indices) != nqubits(cliff)
            throw(ArgumentError("The number of target qubits (indices) must match the qubit count in the CliffordOperator."))
        end
        new{T}(cliff, indices)
    end
end

SparseGate(c,t::Tuple) = SparseGate(c,collect(t))

function apply!(state::AbstractStabilizer, g::SparseGate; kwargs...)
    m = maximum(g.indices)
    if m > nqubits(state)
        throw(ArgumentError(lazy"SparseGate was attempted on invalid qubit index $(m) when the state contains only $(nqubits(state)) qubits."))
    end
    apply!(state, g.indices, g.cliff; kwargs...)
end

function LinearAlgebra.inv(g::SparseGate; phases=true)
  return SparseGate(inv(g.cliff;phases=phases), g.indices)
end

"""Reset the specified qubits to the given state.

Be careful, this operation implies first tracing out the qubits, which can lead to mixed states
if these qubits were entangled with the rest of the system.

See also: [`sMRZ`](@ref)"""
struct Reset{T<:Tableau} <: AbstractOperation # TODO simplify type parameters (remove nesting)
    resetto::Stabilizer{T}
    indices::Vector{Int}
end

function apply!(state::AbstractStabilizer, reset::Reset)
    reset_qubits!(state, reset.resetto, reset.indices)
    return state
end

"""A Bell measurement performing the correlation measurement corresponding to the given `pauli` projections on the qubits at the selected indices."""
struct BellMeasurement <: AbstractOperation
    measurements::Vector{Union{sMX,sMY,sMZ}}
    parity::Bool
end
BellMeasurement(meas) = BellMeasurement(meas,false)

# TODO this seems unnecessarily complicated
function applywstatus!(s::AbstractQCState, m::BellMeasurement)
    res = 0x00
    for meas in m.measurements
        s,r = projectrand!(s,meas)
        res ⊻= r
    end
    if iseven(res>>1+m.parity)
        return s, continue_stat
    else
        return s, failure_stat
    end
end

"""A Bell measurement in which each of the measured qubits has a chance to have flipped."""
struct NoisyBellMeasurement{T} <: AbstractOperation
    meas::AbstractOperation
    flipprob::T
end
NoisyBellMeasurement(p,i,fp) = NoisyBellMeasurement(BellMeasurement(p,i),fp)

function applywstatus!(s::AbstractQCState, m::NoisyBellMeasurement)
    state, status = applywstatus!(s,m.meas)
    nqubits = length(affectedqubits(m))
    errprob = (1-(1-2*m.flipprob)^nqubits)/2 # probability of odd number of flips
    if rand()<errprob
        return state, status==continue_stat ? failure_stat : continue_stat
    else
        return state, status
    end
end

function applybranches(s::AbstractQCState, m::BellMeasurement; max_order=1)
    n = nqubits(s)
    [(ns,iseven(r>>1 + m.parity) ? continue_stat : failure_stat, p,0)
     for (ns,r,p) in _applybranches_measurement([(s,0x0,1.0)],m.measurements,n)]
end

function applybranches(s::AbstractQCState, m::NoisyBellMeasurement; max_order=1)
    measurement_branches = applybranches(s, m.meas, max_order=max_order)
    if max_order==0
        return measurement_branches
    else
        new_branches = []
        nqubits = length(affectedqubits(m))
        p = (1-2m.flipprob)^nqubits
        errprob = 1//2*(1-p)
        sucprob = 1//2*(1+p)
        for (mstate, success, mprob, morder) in measurement_branches
            push!(new_branches, (mstate, success, mprob*sucprob, morder))
            push!(new_branches, (mstate, success==continue_stat ? failure_stat : continue_stat, mprob*errprob, morder+1))
        end
        return new_branches
    end
end

# TODO XXX THIS IS PARTICULARLY INEFFICIENT recurrent implementation
function _applybranches_measurement(branches, measurements, n)
    if length(measurements) == 0
        return branches
    end

    new_branches = []
    pauli = measurements[1]
    otherpaulis = measurements[2:end]

    for (s,r0,p) in branches
        _,anticom,r = project!(quantumstate(s),pauli)
        if isnothing(r) # TODO anticom could be zero if there was a rank change
            s1 = s
            s2 = copy(s)
            r1 = phases(stabilizerview(s1))[anticom] = 0x00
            r2 = phases(stabilizerview(s2))[anticom] = 0x02
            push!(new_branches, (s1,r0+r1,p/2))
            push!(new_branches, (s2,r0+r2,p/2))
        else
            push!(new_branches, (s,r0+r,p))
        end
    end

    return _applybranches_measurement(new_branches, otherpaulis, n)
end


"""A "probe" to verify that the state of the qubits corresponds to a desired `good_state`, e.g. at the end of the execution of a circuit."""
struct VerifyOp <: AbstractOperation
    good_state::Stabilizer
    indices::AbstractVector{Int}
    function VerifyOp(s, indices)
        gs = canonicalize_rref!(copy(stabilizerview(s)))[1]
        r,n = size(gs)
        if(r!=n)
            throw(ArgumentError(lazy"""The argument you have provided for good_state is not a logical state within the codespace. Expected a pure $n - qubit stabilizer state (i.e. $n independent stabilizer generators on $n qubits), but good_state has only $r independent stabilizer generators."""))
        end
        return new(gs, indices)
    end
end

# TODO this one needs more testing
function applywstatus!(s::AbstractQCState, v::VerifyOp) # XXX It assumes the other qubits are measured or traced out
    # TODO QuantumClifford should implement some submatrix comparison
    sv = traceout!(copy(quantumstate(s)), setdiff(1:nqubits(s),v.indices))
    sv = stabilizerview(sv)
    canonicalize_rref!(sv, v.indices)
    sv = tab(sv)
    good_state = tab(v.good_state)

    for i in eachindex(good_state)
        (sv.phases[end-i+1]==good_state.phases[end-i+1]) || return s, false_success_stat
        for (j,q) in zip(eachindex(good_state),v.indices)
            (sv[end-i+1,q]==good_state[end-i+1,j]) || return s, false_success_stat
        end
    end
    return s, true_success_stat
end

operatordeterminism(::Type{VerifyOp}) = DeterministicOperatorTrait()

"""Applies an XOR gate to classical bits. Currently only implemented for functionality with pauli frames."""
struct ClassicalXOR{N} <: AbstractOperation
    "The indices of the classical bits to be xor-ed"
    bits::NTuple{N,Int}
    "The index of the classical bit that will store the results"
    store::Int
end

ClassicalXOR(bits,store) = ClassicalXOR{length(bits)}(tuple(bits...),store)

nsubsystems(state::MixedDestabilizer) = nqubits(state)

"""
Generate a table mapping group members to the minimal representation in terms of the generators provided.

The first argument is the identity element of the group. The second argument is a list of generators.

For example,
`decompose_into_generators(sId1(1), [sInvPhase(1), sSQRTX(1)])`
generates a table in which the `sY` entry is
`sY(1) -> [sSQRTX(1), sSQRTX(1), sInvPhase(1), sInvPhase(1)]`
which means
Y = sInvPhase * sInvPhase * sSQRTX * sSQRTX

The function uses a brute-force, dynamic programming based approach on
finding minimal representation (decomposition) of any group elements in terms of the generators provided.
"""
function decompose_into_generators(e::AbstractSingleQubitOperator, generators::Vector{<:AbstractSingleQubitOperator})
    e = CliffordOperator(e, 1)

    # Initialize the table with generators. Table shouldn't include identity `e`
    # because composing with identity gives nothing new.
    table = Dict{CliffordOperator,Vector{AbstractSingleQubitOperator}}()
    for g in generators
        push!(table, CliffordOperator(g, 1) => [g])
    end

    updated = true
    while updated
        updated = false
        k = copy(keys(table))
        for a in k
            for b in k
                # compose a new element and see if it's already in the table
                if (a * b) in k
                    if length(table[a]) + length(table[b]) < length(table[a*b])
                        # store the sequence in reverse, so entry A -> [a1, a2, a3] means A = a3 * a2 * a1
                        table[a*b] = append!(copy(table[b]), table[a])
                        updated = true
                    end
                else
                    # Don't store identity in the table
                    if a * b != e
                        table[a*b] = append!(copy(table[b]), table[a])
                        updated = true
                    end
                end
            end
        end
    end

    # transform the key to SingleQubitOperator so it's easier to lookup
    table_prime = Dict{SingleQubitOperator,Vector{AbstractSingleQubitOperator}}()
    for (k, v) in table
        table_prime[SingleQubitOperator(k)] = v
    end
    # store identity in the table now as the table keys are used as a set of all single qubit clifford operators
    table_prime[SingleQubitOperator(sId1(1))] = [sId1(1)]
    return table_prime
end

"""
A table mapping group members to the minimal representation in terms of the generators provided.
"""
const IP_SQRTX_DECOMPOSITION_TABLE = decompose_into_generators(sId1(1), [sInvPhase(1), sSQRTX(1)])

"""Generate a single qubit operator multiplication table"""
function gen_single_qubit_multiplication_table()
    table = Dict{Tuple{SingleQubitOperator, SingleQubitOperator}, SingleQubitOperator}()
    for (a, _) in IP_SQRTX_DECOMPOSITION_TABLE
        for (b, _) in IP_SQRTX_DECOMPOSITION_TABLE
            table[(a, b)] = SingleQubitOperator(a * (b * one(CliffordOperator, 1)))
        end
    end
    return table
end

"""
Single qubit operator multiplication table to speed up the `_apply_vop!`

The table consists of entries of the form
(sX(1), sY(1)) -> sZ(1)
"""
const SINGLE_QUBIT_MULTIPLICATION_TABLE = gen_single_qubit_multiplication_table()

@testitem "ECC Bivaraite Bicycle" tags=[:ecc, :ecc_bespoke_checks] begin
    using Hecke
    using HiGHS
    using JuMP
    using Hecke: group_algebra, GF, abelian_group, gens, one
    using QuantumClifford.ECC: two_block_group_algebra_code, code_k, code_n, distance, DistanceMIPAlgorithm

    @testset "Reproduce Table 3 bravyi2024high" begin
        # [[72, 12, 6]]
        l=6; m=6
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^3 + y + y^2)
        B = S(y^3 + x + x^2)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 72 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^3 + y + y^2)
        B = S(y^3 + x + x^2)
        c = MultivariateMulticycle([l,m], [A,B]);
        @test code_n(c) == 72 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[90, 8, 10]]
        l=15; m=3
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^9 + y   + y^2)
        B = S(1   + x^2 + x^7)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 90 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^9 + y   + y^2)
        B = S(1   + x^2 + x^7)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 90 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[108, 8, 10]]
        l=9; m=6
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^3 + y + y^2)
        B = S(y^3 + x + x^2)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 108 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^3 + y + y^2)
        B = S(y^3 + x + x^2)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 108 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[144, 12, 12]]
        l=12; m=6
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^3 + y + y^2)
        B = S(y^3 + x + x^2)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 144 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^3 + y + y^2)
        B = S(y^3 + x + x^2)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 144 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[288, 12, 12]]
        l=12; m=12
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^3 + y^2 + y^7)
        B = S(y^3 + x   + x^2)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 288 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^3 + y^2 + y^7)
        B = S(y^3 + x   + x^2)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 288 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[360, 12, ≤ 24]]
        l=30; m=6
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^9 + y    + y^2)
        B = S(y^3 + x^25 + x^26)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 360 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^9 + y    + y^2)
        B = S(y^3 + x^25 + x^26)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 360 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[756, 16, ≤ 34]]
        l=21; m=18
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^3 + y^10 + y^17)
        B = S(y^5 + x^3  + x^19)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 756 && code_k(c) == 16
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^3 + y^10 + y^17)
        B = S(y^5 + x^3  + x^19)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 756 && code_k(c) == 16
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
    end

    @testset "Reproduce Table 1 berthusen2024toward" begin
        # [[72, 8, 6]]
        l=12; m=3
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^9 + y + y^2)
        B = S(1   + x + x^11)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 72 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^9 + y + y^2)
        B = S(1   + x + x^11)
        c = MultivariateMulticycle([l,m], [A,B]);
        @test code_n(c) == 72 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[90, 8, 6]]
        l=9; m=5
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^8 + y^4 + y)
        B = S(y^5 + x^8 + x^7)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 90 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^8 + y^4 + y)
        B = S(y^5 + x^8 + x^7)
        c = MultivariateMulticycle([l,m], [A,B]);
        @test code_n(c) == 90 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[120, 8, 8]]
        l=12; m=5
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^10 + y^4 + y)
        B = S(1    + x   + x^2)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 120 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^10 + y^4 + y)
        B = S(1    + x   + x^2)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 120 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[150, 8, 8]]
        l=15; m=5
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^5 + y^2 + y^3)
        B = S(y^2 + x^7 + x^6)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 150 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^5 + y^2 + y^3)
        B = S(y^2 + x^7 + x^6)
        c = MultivariateMulticycle([l,m], [A,B]);
        @test code_n(c) == 150 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[196, 12, 8]]
        l=14; m=7
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^6 + y^5 + y^6)
        B = S(1   + x^4 + x^13)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 196 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^6 + y^5 + y^6)
        B = S(1   + x^4 + x^13)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 196 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
    end

    @testset "Reproduce Table 1 wang2024coprime" begin
        # [[54, 8, 6]]
        l=3; m=9
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(1   + y^2 + y^4)
        B = S(y^3 + x   + x^2)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 54 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(1   + y^2 + y^4)
        B = S(y^3 + x   + x^2)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 54 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[98, 6, 12]]
        l=7; m=7
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^3 + y^5 + y^6)
        B = S(y^2 + x^3 + x^5)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 98 && code_k(c) == 6
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^3 + y^5 + y^6)
        B = S(y^2 + x^3 + x^5)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 98 && code_k(c) == 6
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[126, 8, 10]]
        l=3; m=21
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(1   + y^2 + y^10)
        B = S(y^3 + x  +  x^2)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 126 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(1   + y^2 + y^10)
        B = S(y^3 + x  +  x^2)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 126 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[150, 16, 8]]
        l=5; m=15
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(1   + y^6 + y^8)
        B = S(y^5 + x   + x^4)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 150 && code_k(c) == 16
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(1   + y^6 + y^8)
        B = S(y^5 + x   + x^4)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 150 && code_k(c) == 16
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[162, 8, 14]]
        l=3; m=27
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(1    + y^10 + y^14)
        B = S(y^12 + x    + x^2)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 162 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(1    + y^10 + y^14)
        B = S(y^12 + x    + x^2)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 162 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[180, 8, 16]]
        l=6; m=15
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^3 + y   + y^2)
        B = S(y^6 + x^4 + x^5)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 180 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^3 + y   + y^2)
        B = S(y^6 + x^4 + x^5)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 180 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
    end

    @testset "Reproduce Table 1 eberhardt2024logical" begin
        # [[108, 16, 6]]
        l=6; m=9
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(1 +   y   + y^2)
        B = S(y^3 + x^2 + x^4)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 108 && code_k(c) == 16
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(1 +   y   + y^2)
        B = S(y^3 + x^2 + x^4)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 108 && code_k(c) == 16
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[128, 14, 12]]
        l=8; m=8
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^2 + y + y^3 + y^4)
        B = S(y^2 + x + x^3 + x^4)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 128 && code_k(c) == 14
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 4)
        @test all(sum(B, dims=2) .== 4)
        @test all(sum(A, dims=1) .== 4)
        @test all(sum(B, dims=1) .== 4)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^2 + y + y^3 + y^4)
        B = S(y^2 + x + x^3 + x^4)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 128 && code_k(c) == 14
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 4)
        @test all(sum(B, dims=2) .== 4)
        @test all(sum(A, dims=1) .== 4)
        @test all(sum(B, dims=1) .== 4)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[162, 4, 16]]
        l=9; m=9
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(1   + x + y)
        B = S(x^3 + y + y^2)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 162 && code_k(c) == 4
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(1   + x + y)
        B = S(x^3 + y + y^2)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 162 && code_k(c) == 4
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[162, 12, 8]]
        l=9; m=9
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(1   + x   + y^6)
        B = S(y^3 + x^2 + x^3)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 162 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(1   + x   + y^6)
        B = S(y^3 + x^2 + x^3)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 162 && code_k(c) == 12
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[162, 24, 6]]
        l=9; m=9
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(1   + y   + y^2)
        B = S(y^3 + x^3 + x^6)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 162 && code_k(c) == 24
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(1   + y   + y^2)
        B = S(y^3 + x^3 + x^6)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 162 && code_k(c) == 24
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[270, 8, 18]]
        l=9; m=15
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^3 + y + y^2)
        B = S(y^3 + x + x^2)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 270 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^3 + y + y^2)
        B = S(y^3 + x + x^2)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 270 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[98, 6, 12]]
        l=7; m=7
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x + y^3 + y^4)
        B = S(y + x^3 + x^4)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 98 && code_k(c) == 6
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x + y^3 + y^4)
        B = S(y + x^3 + x^4)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 98 && code_k(c) == 6
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)

        # [[162, 8, 12]]
        l=9; m=9
        R, (x, y) = polynomial_ring(GF(2), [:x, :y])
        I = ideal(R, [x^l-1, y^m-1])
        S, _ = quo(R, I)
        A = S(x^3 + y + y^2)
        B = S(y^3 + x + x^2)
        c = BivariateBicycleViaPoly(l, m, A, B)
        @test code_n(c) == 162 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
        A = S(x^3 + y + y^2)
        B = S(y^3 + x + x^2)
        c = MultivariateMulticycle([l,m], [A,B])
        @test code_n(c) == 162 && code_k(c) == 8
        Hx = parity_matrix_x(c)
        n = size(Hx,2)÷2
        A = Hx[:,1:n]
        B = Hx[:,n+1:end]
        @test all(sum(A, dims=2) .== 3)
        @test all(sum(B, dims=2) .== 3)
        @test all(sum(A, dims=1) .== 3)
        @test all(sum(B, dims=1) .== 3)
        @test A*B == B*A
        @test iszero(A*B+B*A) == iszero(2*A*B)
    end
end

"""
$(TYPEDEF)

This is a wrapper around a tableau. This "frame" tableau is not to be viewed as a normal stabilizer tableau,
although it does conjugate the same under Clifford operations.
Each row in the tableau refers to a single frame.
The row represents the Pauli operation by which the frame and the reference differ.
"""
struct PauliFrame{T,S} <: AbstractQCState
    frame::T # TODO this should really be a Tableau, but now most of the code seems to be assuming a Stabilizer
    measurements::S # TODO check if when looping over this we are actually looping over the fast axis
end

nqubits(f::PauliFrame) = nqubits(f.frame) - 1 # dont count the ancilla qubit
Base.length(f::PauliFrame) = size(f.measurements, 1)
Base.eachindex(f::PauliFrame) = 1:length(f)
Base.copy(f::PauliFrame) = PauliFrame(copy(f.frame), copy(f.measurements))
Base.view(frame::PauliFrame, r) = PauliFrame(view(frame.frame, r), view(frame.measurements, r, :))

tab(f::PauliFrame) = Tableau(f.frame.tab.phases, nqubits(f), f.frame.tab.xzs)

fastrow(s::PauliFrame) = PauliFrame(fastrow(s.frame), s.measurements)
fastcolumn(s::PauliFrame) = PauliFrame(fastcolumn(s.frame), s.measurements)

"""
$(TYPEDSIGNATURES)

Prepare an empty set of Pauli frames with the given number of `frames` and `qubits`. Preallocates spaces for `measurement` number of measurements.
"""
function PauliFrame(frames, qubits, measurements)
    # one extra qubit for ancilla measurements
    stab = fastcolumn(zero(Stabilizer, frames, qubits + 1)) # TODO this should really be a Tableau
    bits = zeros(Bool, frames, measurements)
    frame = PauliFrame(stab, bits)
    initZ!(frame)
    return frame
end

"""
$(TYPEDSIGNATURES)

Inject random Z errors over all frames and qubits for the supplied PauliFrame with probability 0.5.

Calling this after initialization is essential for simulating any non-deterministic circuit.
It is done automatically by most [`PauliFrame`](@ref) constructors.
"""
function initZ!(frame::PauliFrame)
    T = eltype(frame.frame.tab.xzs)

    @inbounds @simd for f in eachindex(frame)
        @simd for row in 1:size(frame.frame.tab.xzs,1)÷2
            frame.frame.tab.xzs[end÷2+row,f] = rand(T)
        end
    end
    return frame
end

function apply!(f::PauliFrame, op::AbstractCliffordOperator)
    _apply!(f.frame, op; phases=Val(false))
    return f
end

function apply!(frame::PauliFrame, xor::ClassicalXOR)
    for f in eachindex(frame)
        value = frame.measurements[f,xor.bits[1]]
        for i in xor.bits[2:end]
            value ⊻= frame.measurements[f,i]
        end
        frame.measurements[f, xor.store] = value
    end
    return frame
end

function apply!(frame::PauliFrame, op::sMX) # TODO implement a faster direct version
    op.bit == 0 && return frame
    apply!(frame, sHadamard(op.qubit))
    apply!(frame, sMZ(op.qubit, op.bit))
end

function apply!(frame::PauliFrame, op::sMRX) # TODO implement a faster direct version
    apply!(frame, sHadamard(op.qubit))
    apply!(frame, sMRZ(op.qubit, op.bit))
end

function apply!(frame::PauliFrame, op::sMZ) # TODO sMY, and faster sMX
    op.bit == 0 && return frame
    i = op.qubit
    xzs = tab(frame.frame).xzs
    lowbit, ibig, ismall, ismallm = get_bitmask_idxs(xzs,i)

    @inbounds @simd for f in eachindex(frame)
        should_flip = !iszero(xzs[ibig,f] & ismallm)
        frame.measurements[f,op.bit] = should_flip
    end

    return frame
end

function apply!(frame::PauliFrame, op::sMRZ) # TODO sMRY, and faster sMRX
    i = op.qubit
    xzs = tab(frame.frame).xzs
    lowbit, ibig, ismall, ismallm = get_bitmask_idxs(xzs,i)

    if op.bit != 0
        @inbounds @simd for f in eachindex(frame)
            should_flip = !iszero(xzs[ibig,f] & ismallm)
            frame.measurements[f,op.bit] = should_flip
        end
    end
    @inbounds @simd for f in eachindex(frame)
        xzs[ibig,f] &= ~ismallm
        rand(Bool) && (xzs[end÷2+ibig,f] ⊻= ismallm)
    end

    return frame
end

function apply!(frame::PauliFrame, op::PauliMeasurement)
    # this is inspired by ECC.naive_syndrome_circuit
    n = nqubits(op.pauli)
    for qubit in 1:n
        if op.pauli[qubit] == (1, 0)
            apply!(frame, sXCZ(qubit, n + 1))
        elseif op.pauli[qubit] == (0, 1)
            apply!(frame, sCNOT(qubit, n + 1))
        elseif op.pauli[qubit] == (1, 1)
            apply!(frame, sYCX(qubit, n + 1))
        end
    end
    op.pauli.phase[] == 0 || apply!(frame, sX(n + 1))
    apply!(frame, sMRZ(n + 1, op.bit))

    return frame
end

function applynoise!(frame::PauliFrame,noise::UnbiasedUncorrelatedNoise,i::Int)
    p = noise.p
    xzs = tab(frame.frame).xzs

    lowbit, ibig, ismall, ismallm = get_bitmask_idxs(xzs,i)
    p = p/3

    @inbounds @simd for f in eachindex(frame)
        r = rand()
        if  r < p # X error
            xzs[ibig,f] ⊻= ismallm
        elseif r < 2p # Z error
            xzs[end÷2+ibig,f] ⊻= ismallm
        elseif r < 3p # Y error
            xzs[ibig,f] ⊻= ismallm
            xzs[end÷2+ibig,f] ⊻= ismallm
        end
    end
    return frame
end

function applynoise!(frame::PauliFrame,noise::PauliNoise,i::Int)
    xzs = tab(frame.frame).xzs

    lowbit, ibig, ismall, ismallm = get_bitmask_idxs(xzs,i)

    @inbounds @simd for f in eachindex(frame)
        r = rand()
        if  r < noise.px # X error
            xzs[ibig,f] ⊻= ismallm
        elseif r < noise.px+noise.pz # Z error
            xzs[end÷2+ibig,f] ⊻= ismallm
        elseif r < noise.px+noise.pz+noise.py # Y error
            xzs[ibig,f] ⊻= ismallm
            xzs[end÷2+ibig,f] ⊻= ismallm
        end
    end
    return frame
end

"""
Perform a "Pauli frame" style simulation of a quantum circuit.
"""
function pftrajectories end

"""
$(TYPEDSIGNATURES)

The main method for running Pauli frame simulations of circuits.
See the other methods for lower level access.

Multithreading is enabled by default, but can be disabled by setting `threads=false`.
Do not forget to launch Julia with multiple threads enabled, e.g. `julia -t4`, if you want
to use multithreading.

See also: [`mctrajectories`](@ref), [`petrajectories`](@ref)
"""
function pftrajectories(circuit;trajectories=5000,threads=true)
    _pftrajectories(circuit;trajectories,threads)
end

function _create_pauliframe(ccircuit; trajectories=5000)
    qmax=maximum((maximum(affectedqubits(g),init=1) for g in ccircuit))
    bmax=maximum((maximum(affectedbits(g),init=1) for g in ccircuit))
    return PauliFrame(trajectories, qmax, bmax)
end

function _pftrajectories(circuit;trajectories=5000,threads=true)
    ccircuit = if eltype(circuit) <: CompactifiedGate
        circuit
    else
        try
            compactify_circuit(circuit)
        catch err
            @warn "Could not compactify the circuit, falling back to a slower version of the simulation. Consider reporting this issue to the package maintainers to improve performance. The offending gate was `$(err.args[2])`."
            circuit
        end
    end
    frames = _create_pauliframe(ccircuit; trajectories)
    nthr = min(Threads.nthreads(),trajectories÷(100))
    if threads && nthr>1
        batchsize = trajectories÷nthr
        Threads.@threads for i in 1:nthr
            b = (i-1)*batchsize+1
            e = i==nthr ? trajectories : i*batchsize
            pftrajectories((@view frames[b:e]), ccircuit)
        end
    else
        pftrajectories(frames, ccircuit)
    end
    return frames
end

"""
$(TYPEDSIGNATURES)

Evolve each frame stored in [`PauliFrame`](@ref) by the given circuit.
"""
function pftrajectories(state::PauliFrame, circuit)
    for op in circuit
        apply!(state, op)
    end
    return state
end

"""
$(TYPEDSIGNATURES)

For a given [`Register`](@ref) and circuit, simulates the reference circuit acting on the
register and then also simulate numerous [`PauliFrame`](@ref) trajectories.
Returns the register and the [`PauliFrame`](@ref) instance.

Use [`measurements`](@ref) to get the measurement results.
"""
function pftrajectories(register::Register, circuit; trajectories=500)
    for op in circuit
        apply!(register, op)
    end
    frame = PauliFrame(trajectories, nqubits(register), length(bitview(register)))
    pftrajectories(frame, circuit)
    register, frame
end

"""
For a given simulated state, e.g. a [`PauliFrame`](@ref) instance, returns the measurement results.
"""
function pfmeasurement end

"""
$(TYPEDSIGNATURES)

Returns the measurements stored in the bits of the given [`Register`](@ref).
"""
measurements(register::Register) = bitview(register)

"""
$(TYPEDSIGNATURES)

Returns the measurement results for each frame in the [`PauliFrame`](@ref) instance.

!!! warning "Relative measurements"
    The return measurements are relative to the reference measurements, i.e. they only say
    whether the reference measurements have been flipped in the given frame.
"""
measurements(frame::PauliFrame) = frame.measurements

"""
$(TYPEDSIGNATURES)

Takes the references measurements from the given [`Register`](@ref) and applies the flips
as prescribed by the [`PauliFrame`](@ref) relative measurements. The result is the actual
(non-relative) measurement results for each frame.
"""
measurements(register::Register, frame::PauliFrame) = measurements(register) .⊻ measurements(frame)

Base.@deprecate pfmeasurements(register::Register) measurements(register)
Base.@deprecate pfmeasurements(frame::PauliFrame) measurements(frame)
Base.@deprecate pfmeasurements(register::Register, frame::PauliFrame) measurements(register, frame)

@testitem "SumTypes compactification" begin
    @test_warn "Could not compactify the circuit" QuantumClifford.pftrajectories([ClassicalXOR{17}((65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81), 282)])
    QuantumClifford.compactify_circuit([ClassicalXOR{3}((65, 66, 67), 282)])
end

"""
A module for using the Stabilizer formalism and simulating Clifford circuits.
"""
module QuantumClifford

# TODO document phases=false

# TODO Significant performance improvements: many operations do not need phase=true if the Pauli operations commute

using LinearAlgebra: LinearAlgebra, inv, mul!, rank, Adjoint, dot, tr
using DataStructures: DataStructures, DefaultDict, Accumulator
using Combinatorics: combinations
using Base.Cartesian

using DocStringExtensions

import QuantumInterface: tensor, ⊗, tensor_pow,
    nqubits, expect, project!, reset_qubits!, traceout!, ptrace,
    apply!, projectX!, projectY!, projectZ!,
    embed, permutesystems,
    entanglement_entropy

export
    @P_str, PauliOperator, ⊗, I, X, Y, Z,
    @T_str, xbit, zbit, xview, zview,
    @S_str, Stabilizer,
    Destabilizer, MixedStabilizer, MixedDestabilizer,
    prodphase, comm, comm!,
    nqubits,
    stabilizerview, destabilizerview, logicalxview, logicalzview, phases,
    fastcolumn, fastrow,
    bitview, quantumstate, tab, rank,
    BadDataStructure,
    affectedqubits, #TODO move to QuantumInterface?
    # GF2
    stab_to_gf2, gf2_gausselim!, gf2_isinvertible, gf2_invert, gf2_H_to_G,
    # Canonicalization
    canonicalize!, canonicalize_rref!, canonicalize_gott!,
    # Linear Algebra
    tensor, tensor_pow,
    logdot, expect,
    apply!, apply_inv!, apply_right!,
    permutesystems, permutesystems!,
    # Low Level Function Interface
    generate!, project!, reset_qubits!, traceout!, ptrace,
    projectX!, projectY!, projectZ!,
    projectrand!, projectXrand!, projectYrand!, projectZrand!,
    puttableau!, embed,
    # Clifford Ops
    CliffordOperator, @C_str,
    tCNOT, tCPHASE, tSWAP, tHadamard, tPhase, tId1,
    # Symbolic Clifford Ops
    AbstractSymbolicOperator, AbstractSingleQubitOperator, AbstractTwoQubitOperator,
    sHadamard, sPhase, sInvPhase, SingleQubitOperator, sId1, sX, sY, sZ,
    sHadamardXY, sHadamardYZ, sSQRTX, sInvSQRTX, sSQRTY, sInvSQRTY, sCXYZ, sCZYX,
    sCNOT, sCPHASE, sSWAP,
    sXCX, sXCY, sXCZ, sYCX, sYCY, sYCZ, sZCX, sZCY, sZCZ,
    sZCrY, sInvZCrY, sSWAPCX, sInvSWAPCX, sCZSWAP, sCXSWAP, sISWAP, sInvISWAP,
    sSQRTZZ, sInvSQRTZZ, sSQRTXX, sInvSQRTXX, sSQRTYY, sInvSQRTYY,
    # Misc Ops
    SparseGate,
    sMX, sMY, sMZ, PauliMeasurement, Reset, sMRX, sMRY, sMRZ,
    BellMeasurement, NoisyBellMeasurement, ClassicalXOR,
    VerifyOp,
    Register,
    # Misc gates
    IndexedDecisionGate, ConditionalGate,
    # Enumeration and Randoms
    enumerate_single_qubit_gates, random_clifford1,
    enumerate_cliffords, symplecticGS, clifford_cardinality, enumerate_phases,
    random_invertible_gf2,
    random_pauli, random_pauli!,
    random_stabilizer, random_destabilizer, random_clifford,
    random_brickwork_clifford_circuit, random_all_to_all_clifford_circuit,
    # Noise
    applynoise!, UnbiasedUncorrelatedNoise, DepolarizationNoise, NoiseOp, NoiseOpAll, NoisyGate,
    PauliNoise, PauliError,
    # Pauli frames
    PauliFrame, pftrajectories, pfmeasurements,
    measurements,
    # Useful States
    bell, ghz, maximally_mixed,
    single_z, single_x, single_y,
    # Graphs
    graphstate, graphstate!, graph_gatesequence, graph_gate,
    # Group theory tools
    groupify, minimal_generating_set, pauligroup, normalizer, centralizer, contractor, delete_columns,
    canonicalize_noncomm, commutify, matroid_parent, SubsystemCodeTableau,
    # Clipped Gauge
    canonicalize_clip!, bigram, entanglement_entropy,
    # mctrajectories
    CircuitStatus, continue_stat, true_success_stat, false_success_stat, failure_stat,
    mctrajectory!, mctrajectories, applywstatus!,
    # petrajectories
    petrajectories, applybranches,
    # nonclifford ops
    pcT, pcPhase, pcRx,
    sT, sCCZ,
    isclifford,
    # nonclifford density matrix and Pauli Channels
    GeneralizedStabilizer, UnitaryPauliChannel, PauliChannel,
    # nonclifford pure states
    PureGeneralizedStabilizer,
    emtrajectories,
    # makie plotting -- defined only when extension is loaded
    stabilizerplot, stabilizerplot_axis,
    # sum types
    compactify_circuit
    # gpu support
    # to_cpu, to_gpu


include("init.jl")
include("throws.jl")

# Predefined constants representing the permitted phases encoded
# in the low bits of UInt8.
const _p  = 0x00
const _pi = 0x01
const _m  = 0x02
const _mi = 0x03

const phasedict = Dict(""=>_p,"+"=>_p,"i"=>_pi,"+i"=>_pi,"-"=>_m,"-i"=>_mi)
const toletter = Dict((false,false)=>"_",(true,false)=>"X",(false,true)=>"Z",(true,true)=>"Y")

include("macrotools.jl")

##############################
# Pauli Operators
##############################

abstract type AbstractOperation end
abstract type AbstractCliffordOperator <: AbstractOperation end
abstract type AbstractNonCliffordOperator <: AbstractOperation end

include("pauli_operator.jl")

##############################
# Generic Tableaux
##############################

"""Internal Tableau type for storing a list of Pauli operators in a compact form.
No special semantic meaning is attached to this type, it is just a convenient way to store a list of Pauli operators.
E.g. it is not used to represent a stabilizer state, or a stabilizer group, or a Clifford circuit."""
struct Tableau{
    P <: AbstractVector{<: Unsigned}, XZ <: AbstractMatrix{<: Unsigned}
}
    phases::P
    nqubits::Int
    xzs::XZ
end

function Tableau(paulis::Base.AbstractVecOrTuple{PauliOperator})
    r = length(paulis)
    if r == 0
        return Tableau(zeros(UInt8, 0), 0, zeros(UInt8, 0, 0))
    end
    n = nqubits(paulis[1])
    P = eltype(paulis[1].phase)
    XZ = eltype(paulis[1].xz)
    tab = zero(Tableau{Vector{P},Matrix{XZ}},r,n)
    for i in eachindex(paulis)
        tab[i] = paulis[i]
    end
    tab
end

function Tableau(phases::AbstractVector{<: Unsigned}, xs::AbstractMatrix{Bool}, zs::AbstractMatrix{Bool})
    r_xs = size(xs, 1)
    r_zs = size(zs, 1)
    if length(phases) != r_xs || r_xs != r_zs
        throw(DimensionMismatch(lazy"The length of phases ($(length(phases))), rows of xs ($r_xs), rows of zs ($r_zs) must all be equal."))
    end
    Tableau(
        phases,size(xs, 2),
        vcat(
            hcat((BitArray(xs[i, :]).chunks for i in 1:r_xs)...)::Matrix{UInt},
            hcat((BitArray(zs[i, :]).chunks for i in 1:r_zs)...)::Matrix{UInt} # type assertions to help Julia infer types
        )
    )
end

Tableau(phases::AbstractVector{<: Unsigned}, xzs::AbstractMatrix{Bool}) = Tableau(phases, xzs[:,1:end÷2], xzs[:,end÷2+1:end])

Tableau(xs::AbstractMatrix{Bool}, zs::AbstractMatrix{Bool}) = Tableau(zeros(UInt8, size(xs,1)), xs, zs)

Tableau(xzs::AbstractMatrix{Bool}) = Tableau(zeros(UInt8, size(xzs,1)), xzs[:,1:end÷2], xzs[:,end÷2+1:end])

Tableau(t::Tableau) = t

function _T_str(a::Union{String,SubString{String}}) # TODO this can be optimized by not creating intermediary PauliOperator objects
    paulis = [_P_str(strip(s.match)) for s in eachmatch(r"[+-]?\h*[i]?\h*[XYZI_]+", a)]
    Tableau(paulis)
end

macro T_str(a)
    quote _T_str($a) end
end

Base.getindex(tab::Tableau, i::Int) = PauliOperator(tab.phases[i], nqubits(tab), tab.xzs[:,i])
@inline function Base.getindex(tab::Tableau, r::Int, c::Int)
     # TODO this has code repetition with the Pauli getindex
     Tₘₑ = eltype(tab.xzs)
     x = (tab.xzs[_div(Tₘₑ,c-1)+1,r] & Tₘₑ(0x1)<<_mod(Tₘₑ,c-1))!=0x0
     z = (tab.xzs[end÷2+_div(Tₘₑ,c-1)+1,r] & Tₘₑ(0x1)<<_mod(Tₘₑ,c-1))!=0x0
     return (x,z)
end
Base.getindex(tab::Tableau, r) = Tableau(tab.phases[r], nqubits(tab), tab.xzs[:,r])
Base.getindex(tab::Tableau, r::Union{Colon,AbstractVector}, c::Union{Colon,AbstractVector}) = Tableau([s[c] for s in tab[r]])
Base.getindex(tab::Tableau, r::Union{Colon,AbstractVector}, c::Int) = tab[r,[c]]
Base.getindex(tab::Tableau, r::Int, c::Union{Colon,AbstractVector}) = tab[r][c]
Base.view(tab::Tableau, r) = Tableau(view(tab.phases, r), nqubits(tab), view(tab.xzs, :, r))

Base.iterate(tab::Tableau, state::Int=1) = state>length(tab) ? nothing : (tab[state], state+1)

function Base.setindex!(tab::Tableau, pauli::PauliOperator, i)
    tab.phases[i] = pauli.phase[]
    #tab.xzs[:,i] = pauli.xz # TODO why is this assignment causing allocations
    for j in 1:length(pauli.xz)
        tab.xzs[j,i] = pauli.xz[j]
    end
    tab
end

function Base.setindex!(tab::Tableau, t::Tableau, i)
    tab.phases[i] = t.phases
    tab.xzs[:,i] = t.xzs
    tab
end

function Base.setindex!(tab::Tableau{Tₚᵥ,Tₘ}, (x,z)::Tuple{Bool,Bool}, i, j) where {Tₚᵥ, Tₘₑ<:Unsigned, Tₘ<:AbstractMatrix{Tₘₑ}} # TODO this has code repetitions with the Pauli setindex
    if x
        tab.xzs[_div(Tₘₑ,j-1)+1,        i] |= Tₘₑ(0x1)<<_mod(Tₘₑ,j-1)
    else
        tab.xzs[_div(Tₘₑ,j-1)+1,        i] &= ~(Tₘₑ(0x1)<<_mod(Tₘₑ,j-1))
    end
    if z
        tab.xzs[end÷2+_div(Tₘₑ,j-1)+1, i] |= Tₘₑ(0x1)<<_mod(Tₘₑ,j-1)
    else
        tab.xzs[end÷2+_div(Tₘₑ,j-1)+1, i] &= ~(Tₘₑ(0x1)<<_mod(Tₘₑ,j-1))
    end
    tab
end

Base.firstindex(tab::Tableau) = 1

Base.lastindex(tab::Tableau) = length(tab.phases)::Int
Base.lastindex(tab::Tableau, i) = size(tab)[i]

Base.eachindex(tab::Tableau) = Base.OneTo(lastindex(tab.phases)::Int)

Base.axes(tab::Tableau) = (Base.OneTo(lastindex(tab)), Base.OneTo(nqubits(tab)))
Base.axes(tab::Tableau,i) = axes(tab)[i]

Base.size(tab::Tableau) = (length(tab.phases)::Int, nqubits(tab))
Base.size(tab::Tableau,i) = size(tab)[i]

Base.length(tab::Tableau) = length(tab.phases)::Int

Base.:(==)(l::Tableau, r::Tableau) = r.nqubits==l.nqubits && r.phases==l.phases && r.xzs==l.xzs

Base.hash(t::Tableau, h::UInt) = hash(t.nqubits, hash(t.phases, hash(t.xzs, h)))

Base.copy(t::Tableau) = Tableau(copy(t.phases), t.nqubits, copy(t.xzs))

function Base.zero(::Type{Tableau{PV, XZM}}, r, q) where {
    P <: Unsigned, PV <: AbstractVector{P},
    XZ <: Unsigned, XZM <: AbstractMatrix{XZ}
}
    return Tableau(zeros(P, r), q, zeros(XZ, _nchunks(q, XZ), r))
end
Base.zero(::Type{Tableau}, r, q) = zero(Tableau{Vector{UInt8},Matrix{UInt}}, r, q)
Base.zero(::Type{T}, q) where {T<:Tableau}= zero(T, q, q)
Base.zero(s::T) where {T<:Tableau} = zero(T, length(s), nqubits(s))

"""Zero-out a given row of a [`Tableau`](@ref)"""
@inline function zero!(t::Tableau{P, XZ}, i) where {P, XZ}
    fill!((@view t.phases[i]), zero(eltype(P)))
    fill!((@view t.xzs[:, i]), zero(eltype(XZ)))
    return t
end

##############################
# Stabilizer States
##############################

abstract type AbstractQCState end # This could include classical bits

abstract type AbstractStabilizer <: AbstractQCState end # This includes only qubits in stabilizer states

"""
Stabilizer, i.e. a list of commuting multi-qubit Hermitian Pauli operators.

Instances can be created with the `S` custom string macro or
as direct sum of other stabilizers.

!!! tip "Stabilizers and Destabilizers"
    In many cases you probably would prefer to use the [`MixedDestabilizer`](@ref)
    data structure, as it caries a lot of useful additional information, like tracking
    rank and destabilizer operators. `Stabilizer` has mostly a pedagogical value, and it
    is also used for slightly faster simulation of a particular subset of Clifford
    operations.

```jldoctest stabilizer
julia> s = S"XXX
             ZZI
             IZZ"
+ XXX
+ ZZ_
+ _ZZ

julia> s⊗s
+ XXX___
+ ZZ____
+ _ZZ___
+ ___XXX
+ ___ZZ_
+ ____ZZ
```

It has an indexing API, looking like a list of `PauliOperator`s.

```jldoctest stabilizer
julia> s[2]
+ ZZ_
```

Pauli operators can act directly on the a stabilizer.

```jldoctest stabilizer
julia> P"YYY" * s
- XXX
+ ZZ_
+ _ZZ
```

There are a number of ways to create a Stabilizer, including:

- generate Stabilizers from a list of Pauli operators

```jldoctest stabilizer
julia> Stabilizer([P"XX", P"ZZ"])
+ XX
+ ZZ
```

- generate Stabilizers from boolean matrices

```jldoctest stabilizer
julia> a = [true true; false false]; b = [false true; true true];

julia> Stabilizer(a, b)
+ XY
+ ZZ

julia> Stabilizer([0x0, 0x2], a, b)
+ XY
- ZZ
```

- initialize an empty Stabilizer and fill it through indexing

```jldoctest stabilizer
julia> s = zero(Stabilizer, 2)
+ __
+ __

julia> s[1,1] = (true, false); s
+ X_
+ __
```

There are no automatic checks for correctness (i.e. independence of all rows,
commutativity of all rows, hermiticity of all rows). The rank (number of rows)
is permitted to be less than the number of qubits (number of columns):
canonilization, projection, etc. continue working in that case. To great extent
this library uses the `Stabilizer` data structure simply as a tableau. This
might be properly abstracted away in future versions.

See also: [`PauliOperator`](@ref), [`canonicalize!`](@ref)
"""
struct Stabilizer{T<:Tableau} <: AbstractStabilizer
    tab::T
end

Stabilizer(phases::Tₚᵥ, nqubits::Int, xzs::Tₘ) where {Tₚᵥ<:AbstractVector{<: Unsigned}, Tₘ<:AbstractMatrix{<:Unsigned}} = Stabilizer(Tableau(phases, nqubits, xzs))
Stabilizer(paulis::Base.AbstractVecOrTuple{PauliOperator}) = Stabilizer(Tableau(paulis))
Stabilizer(phases::AbstractVector{<: Unsigned}, xs::AbstractMatrix{Bool}, zs::AbstractMatrix{Bool}) = Stabilizer(Tableau(phases, xs, zs))
Stabilizer(phases::AbstractVector{<: Unsigned}, xzs::AbstractMatrix{Bool}) = Stabilizer(Tableau(phases, xzs))
Stabilizer(xs::AbstractMatrix{Bool}, zs::AbstractMatrix{Bool}) = Stabilizer(Tableau(xs,zs))
Stabilizer(xzs::AbstractMatrix{Bool}) = Stabilizer(Tableau(xzs))
Stabilizer(s::Stabilizer) = s
macro S_str(a)
    quote Stabilizer(_T_str($a)) end
end
Base.getindex(stab::Stabilizer, i::Int) = tab(stab)[i]
Base.getindex(stab::Stabilizer, i) = Stabilizer(tab(stab)[i]::Tableau)
@inline Base.getindex(stab::Stabilizer, r::Int, c) = tab(stab)[r,c]
Base.getindex(stab::Stabilizer, r, c) = Stabilizer(tab(stab)[r,c])
Base.view(stab::Stabilizer, r) = Stabilizer(view(tab(stab),r))
Base.iterate(stab::Stabilizer, state=1) = iterate(tab(stab), state)
Base.setindex!(stab::Stabilizer, pauli::PauliOperator, i) = setindex!(tab(stab), pauli, i)
Base.setindex!(stab::Stabilizer, s::Stabilizer, i) = setindex!(tab(stab), tab(s), i)
Base.setindex!(stab::Stabilizer, (x,z)::Tuple{Bool,Bool}, i, j) = setindex!(tab(stab), (x,z), i, j)
Base.firstindex(stab::Stabilizer) = firstindex(tab(stab))
Base.lastindex(stab::Stabilizer) = lastindex(tab(stab))
Base.lastindex(stab::Stabilizer, i) = lastindex(tab(stab),i)
Base.eachindex(stab::Stabilizer) = eachindex(tab(stab))
Base.axes(stab::Stabilizer) = axes(tab(stab))
Base.axes(stab::Stabilizer, i) = axes(tab(stab), i)
Base.size(stab::Stabilizer) = size(tab(stab))
Base.size(stab::Stabilizer,i) = size(tab(stab),i)
Base.length(stab::Stabilizer) = length(tab(stab))

Base.:(==)(l::Stabilizer, r::Stabilizer) = tab(l) == tab(r)
Base.hash(s::Stabilizer, h::UInt) = hash(tab(s), h)
Base.copy(s::Stabilizer) = Stabilizer(copy(tab(s)))
Base.zero(::Type{S}, q) where {S<:Stabilizer} = zero(S, q, q)
Base.zero(::Type{Stabilizer{T}}, r, q) where {T<:Tableau} = Stabilizer(zero(T, r, q))
Base.zero(::Type{Stabilizer}, r, q) = zero(Stabilizer{Tableau{Vector{UInt8},Matrix{UInt}}}, r, q)
Base.zero(s::S) where {S<:Stabilizer} = zero(S, length(s), nqubits(s))
@inline zero!(s::Stabilizer,i) = zero!(tab(s),i)

##############################
# Helpers for subclasses of AbstractStabilizer that use Stabilizer as a tableau internally.
##############################

function Base.:(==)(l::T, r::S; phases=true) where {T<:AbstractStabilizer, S<:AbstractStabilizer}
    if phases
        return T==S && tab(l)==tab(r)
    else
        return T==S && tab(l).xzs==tab(r).xzs
    end
end

Base.hash(s::T, h::UInt) where {T<:AbstractStabilizer} = hash(T, hash(tab(s), h))

"""Extract the underlying tableau structure.

```jldoctest
julia> s = S"X"
+ X

julia> tab(s)
+ X

julia> tab(Destabilizer(s))
+ Z
+ X

julia> tab(MixedDestabilizer(s))
+ Z
+ X

julia> tab(tHadamard)
+ Z
+ X

julia> typeof(tab(tHadamard))
QuantumClifford.Tableau{Vector{UInt8}, Matrix{UInt64}}
```

See also: [`stabilizerview`](@ref), [`destabilizerview`](@ref), [`logicalxview`](@ref), [`logicalzview`](@ref)
"""
tab(s::AbstractStabilizer) = s.tab
tab(t::Tableau) = t

##############################
# Destabilizer formalism
##############################

"""
A tableau representation of a pure stabilizer state. The tableau tracks the
destabilizers as well, for efficient projections.

For full-rank tableaux, the stabilizer part of the tableau is guaranteed to be kept the same as the input stabilizer tableau given to the constructor (a guarantee not kept by [`MixedDestabilizer`](@ref)).

On initialization there are
no checks that the provided state is indeed pure. This enables the use of this
data structure for mixed stabilizer state, but usually a better choice would be
[`MixedDestabilizer`](@ref).

```
julia> Destabilizer(S"ZZI XXX")
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z__
+ _X_
𝒮𝓉𝒶𝒷━
+ XXX
+ ZZ_

julia> Destabilizer(S"ZZI XXX IZZ")
𝒟ℯ𝓈𝓉𝒶𝒷
+ X__
+ _Z_
+ __X
𝒮𝓉𝒶𝒷━
+ ZZ_
+ XXX
+ _ZZ
```
"""
struct Destabilizer{T<:Tableau} <: AbstractStabilizer
    tab::T
end

function Destabilizer(s::Stabilizer)
    row, col = size(s)
    if row<col
        mixed_destab = MixedDestabilizer(s)
        t = vcat(tab(destabilizerview(mixed_destab)),tab(stabilizerview(mixed_destab)))
        return Destabilizer(t)
    elseif row==col
        maxmix = maximally_mixed(col)
        for row in s
            project!(maxmix, row)
        end
        return Destabilizer(maxmix.tab)
    else
        error(DomainError("The input stabilizer has more rows than columns, making it inconsistent or overdetermined."))
    end
end

Destabilizer(paulis::Base.AbstractVecOrTuple{PauliOperator}) = Destabilizer(Stabilizer(Tableau(paulis)))

Base.length(d::Destabilizer) = length(tab(d))÷2

Base.copy(d::Destabilizer) = Destabilizer(copy(tab(d)))

##############################
# Mixed Stabilizer states
##############################

"""
A slight improvement of the [`Stabilizer`](@ref) data structure that enables
more naturally and completely the treatment of mixed states, in particular when
the [`project!`](@ref) function is used.
"""
mutable struct MixedStabilizer{T<:Tableau} <: AbstractStabilizer
    tab::T # TODO assert size on construction
    rank::Int
end

function MixedStabilizer(s::Stabilizer{T}) where {T}
    s, xr, zr = canonicalize!(s,ranks=true)
    spadded = zero(Stabilizer, nqubits(s))
    spadded[1:zr] = s[1:zr]
    MixedStabilizer(spadded,zr)
end

MixedStabilizer(s::Stabilizer,rank::Int) = MixedStabilizer(tab(s), rank)
MixedStabilizer(paulis::Base.AbstractVecOrTuple{PauliOperator}) = MixedStabilizer(Stabilizer(Tableau(paulis)))

Base.length(d::MixedStabilizer) = length(tab(d))

Base.copy(ms::MixedStabilizer) = MixedStabilizer(copy(tab(ms)), rank(ms))

##############################
# Mixed Destabilizer states
##############################

"""
A tableau representation for mixed stabilizer states that keeps track of the
destabilizers in order to provide efficient projection operations.

The rank `r` of the `n`-qubit tableau is tracked, either so that it can be
used to represent a mixed stabilizer state, or so that it can be used to
represent an `n-r` logical-qubit code over `n` physical qubits. The "logical"
operators are tracked as well.

When the constructor is called on an incomplete [`Stabilizer`](@ref) it
automatically calculates the destabilizers and logical operators, following
chapter 4 of [gottesman1997stabilizer](@cite).
Under the hood the conversion uses the [`canonicalize_gott!`](@ref) canonicalization.
That canonicalization permutes the columns of the tableau, but we automatically undo the
column permutation in the preparation of a `MixedDestabilizer` so that qubits are not reindexed.
The boolean keyword arguments `undoperm` and `reportperm` can be used to control this behavior
and to report the permutations explicitly.

Occasionally one might want specific destabilizer operators for a given tableau, **without** canonicalizing the tableau.
E.g. if a Pauli frame correction is to be applied after purification or teleportation,
the correction has to be done by applying the destabilizer corresponding to a specific stabilizer operator of a given tableau.
Directly using `MixedDestabilizer` will first canonicalize the tableau, which would change the rows of the tableau,
leading to a consistent set of destabilizer operators, but not the specific ones corresponding to the original pre-canonicalization tableau.
The `backtrack=true` keyword argument can be undo canonicalization and restore the original rows, but this time also with the corresponding destabilizers.

See also: [`stabilizerview`](@ref), [`destabilizerview`](@ref), [`logicalxview`](@ref), [`logicalzview`](@ref)
"""
mutable struct MixedDestabilizer{T<:Tableau} <: AbstractStabilizer
    tab::T # TODO assert size on construction
    rank::Int
end

# Added a lot of type assertions to help Julia infer types
function MixedDestabilizer(stab::Stabilizer{T}; undoperm=true, reportperm=false, backtrack=false) where {T}
    rows,n = size(stab)
    canonops = CanonOp[]
    if backtrack
        stab, r, s, permx, permz, canonops = canonicalize_gott!(copy(stab), backtrack=true)
    else
        stab, r, s, permx, permz = canonicalize_gott!(copy(stab))
    end
    t = zero(T, n*2, n)
    vstab = @view tab(stab)[1:r+s] # this view is necessary for cases of tableaux with redundant rows
    t[n+1:n+r+s] = vstab # The Stabilizer part of the tableau
    for i in 1:r # The Destabilizer part
        t[i,i] = (false,true)
    end
    for i in r+1:r+s
        t[i,i] = (true,false)
    end
    if r+s!=n
        H = stab_to_gf2(vstab)            # n-k × 2n
        k = n - r - s
        E = H[r+1:end,end÷2+r+s+1:end]    # n-k-r × n-r-s
        C1 = H[1:r,end÷2+r+1:end÷2+r+s]   #     r ×     s
        C2 = H[1:r,end÷2+r+s+1:end]       #     r × n-r-s
        U2 = E'                           # n-r-s × n-k-r
        V1 = (E' * C1' + C2').%2 .!= 0x0  # n-r-s ×     r
        #X = hcat(zeros(Bool,k,r),U2,I,V1,zeros(Bool,k,s+k))
        X = zeros(Bool, k, 2n)
        X[:,r+1:n-k] .= U2
        X[:,n+1:n+r] .= V1
        @inbounds @simd for i in 1:k X[i,n-k+i] = true end
        sX = Tableau(X)
        t[r+s+1:n] = sX # One of the logical sets in the tableau
        A2 = H[1:r,r+s+1:end÷2]           #     r × n-r-s
        #Z = hcat(zeros(Bool,k,n),A2',zeros(Bool,k,s),I)
        Z = zeros(Bool, k, 2n)
        Z[:,n+1:n+r] .= A2'
        @inbounds @simd for i in 1:k Z[i,2n-k+i] = true end
        sZ = Tableau(Z)
        t[n+r+s+1:end] = sZ # The other logical set in the tableau
    end
    if undoperm
        t = t[:,invperm(permx[permz])]
    end
    returnstate = MixedDestabilizer(t, r+s)
    if backtrack
        for canonop in reverse(canonops)
            canonop(returnstate)
        end
    end
    if reportperm
        return returnstate, r, permx, permz
    else
        return returnstate
    end
end

function MixedDestabilizer(d::Destabilizer, r::Int)
    l,n = size(tab(d))
    if l==2n
        MixedDestabilizer(tab(d), r)
    else
        throw(DomainError("Only full-rank `Destabilizer` can be converted to `MixedDestabilizer` with specific rank. Try not specifying `r`."))
    end
end
function MixedDestabilizer(d::Destabilizer)
    l,n = size(tab(d))
    if l==2n
        MixedDestabilizer(d, nqubits(d))
    else
        MixedDestabilizer(stabilizerview(d))
    end
end

MixedDestabilizer(d::MixedStabilizer) = MixedDestabilizer(stabilizerview(d))
MixedDestabilizer(d::MixedDestabilizer) = d
MixedDestabilizer(paulis::Base.AbstractVecOrTuple{PauliOperator}) = MixedDestabilizer(Stabilizer(Tableau(paulis)))

Base.length(d::MixedDestabilizer) = length(tab(d))÷2

Base.copy(d::MixedDestabilizer) = MixedDestabilizer(copy(tab(d)),rank(d))

##############################
# Subtableau views
##############################

"""A view of the subtableau corresponding to the stabilizer. See also [`tab`](@ref), [`destabilizerview`](@ref), [`logicalxview`](@ref), [`logicalzview`](@ref)"""
@inline stabilizerview(s::Stabilizer) = s
@inline stabilizerview(s::Destabilizer) = Stabilizer(@view tab(s)[end÷2+1:end])
@inline stabilizerview(s::MixedStabilizer) = Stabilizer(@view tab(s)[1:rank(s)])
@inline stabilizerview(s::MixedDestabilizer) = Stabilizer(@view tab(s)[end÷2+1:end÷2+rank(s)])

"""A view of the subtableau corresponding to the destabilizer. See also [`tab`](@ref), [`stabilizerview`](@ref), [`logicalxview`](@ref), [`logicalzview`](@ref)"""
@inline destabilizerview(s::Destabilizer) = Stabilizer(@view tab(s)[1:end÷2])
@inline destabilizerview(s::MixedDestabilizer) = Stabilizer(@view tab(s)[1:rank(s)])

"""A view of the subtableau corresponding to the logical X operators. See also [`tab`](@ref), [`stabilizerview`](@ref), [`destabilizerview`](@ref), [`logicalzview`](@ref)"""
@inline logicalxview(s::MixedDestabilizer) = Stabilizer(@view tab(s)[rank(s)+1:end÷2])
"""A view of the subtableau corresponding to the logical Z operators. See also [`tab`](@ref), [`stabilizerview`](@ref), [`destabilizerview`](@ref), [`logicalxview`](@ref)"""
@inline logicalzview(s::MixedDestabilizer) = Stabilizer(@view tab(s)[end÷2+rank(s)+1:end])

"""The number of qubits of a given state."""
@inline nqubits(s::AbstractStabilizer) = nqubits(tab(s))
@inline nqubits(t::Tableau) = t.nqubits

"""The phases of a given tableau. It is a view, i.e. if you modify this array, the original tableau caries these changes."""
@inline phases(t::Tableau) = t.phases
@inline phases(s::AbstractStabilizer) = phases(tab(stabilizerview(s)))

##############################
# Pauli Operator Helpers
##############################

"""
Get the phase of the product of two Pauli operators.

Phase is encoded as F(4) in the low qubits of an UInt8.

```jldoctest
julia> P"ZZZ"*P"XXX"
-iYYY

julia> prodphase(P"ZZZ", P"XXX")
0x03

julia> prodphase(P"XXX", P"ZZZ")
0x01
```
"""
@inline function prodphase(l::AbstractVector{T}, r::AbstractVector{T})::UInt8 where T<:Unsigned
    res = 0
    len = length(l)÷2
    @inbounds @simd for i in 1:len
        x1, x2, z1, z2 = l[i], r[i], l[i+len], r[i+len]
        res += count_ones((~z2 & x2 & ~x1 & z1) | ( z2 & ~x2 & x1 & z1) | (z2 &  x2 & x1 & ~z1))
        res -= count_ones(( z2 & x2 & ~x1 & z1) | (~z2 &  x2 & x1 & z1) | (z2 & ~x2 & x1 & ~z1))
    end
    unsigned(res)&0x3
end

"""The quantumlib/Stim implementation, which performs the prodphase and mul_left! together. Used for unit tests."""
function _stim_prodphase(l::AbstractVector{T}, r::AbstractVector{T}) where T<: Unsigned
    cnt1 = zero(T)
    cnt2 = zero(T)
    len = length(l)÷2
    @inbounds @simd for i in 1:len
        x1, x2, z1, z2 = l[i], r[i], l[i+len], r[i+len]
        newx1 = x1 ⊻ x2 # Here l or r would be updated in an actual multiplication
        newz1 = z1 ⊻ z2 # Here l or r would be updated in an actual multiplication
        x1z2 = x1 & z2
        anti_comm = (x2 & z1) ⊻ x1z2
        cnt2 ⊻= (cnt1 ⊻ newx1 ⊻ newz1 ⊻ x1z2) & anti_comm
        cnt1 ⊻= anti_comm
    end
    s = count_ones(cnt1)
    s ⊻= count_ones(cnt2) << 1
    s & 0x3
end

@inline function prodphase(l::PauliOperator, r::PauliOperator)::UInt8
    (l.phase[]+r.phase[]+prodphase(l.xz,r.xz))&0x3
end

@inline function prodphase(l::PauliOperator, r::Tableau, i)::UInt8
    (l.phase[]+r.phases[i]+prodphase(l.xz, (@view r.xzs[:,i])))&0x3
end

@inline function prodphase(l::Tableau, r::PauliOperator, i)::UInt8
    (l.phases[i]+r.phase[]+prodphase((@view l.xzs[:,i]), r.xz))&0x3
end

@inline function prodphase(l::Tableau, r::Tableau, i, j)::UInt8
    (l.phases[i]+r.phases[j]+prodphase((@view l.xzs[:,i]), (@view r.xzs[:,j])))&0x3
end

@inline prodphase(l::PauliOperator,r::Stabilizer,i) = prodphase(l,tab(r),i)
@inline prodphase(l::Stabilizer,r::PauliOperator,i) = prodphase(tab(l),r,i)
@inline prodphase(l::Stabilizer,r::Stabilizer,i,j) = prodphase(tab(l),tab(r),i,j)

"""
Check whether two operators commute.

`0x0` if they commute, `0x1` if they anticommute.

```jldoctest
julia> P"XX"*P"ZZ", P"ZZ"*P"XX"
(- YY, - YY)

julia> comm(P"ZZ", P"XX")
0x00

julia> comm(P"IZ", P"XX")
0x01
```

See also: [`comm!`](@ref)
"""
function comm end

@inline function comm(l::AbstractVector{T}, r::AbstractVector{T})::UInt8 where T<:Unsigned
    res = T(0)
    len = length(l)÷2
    @inbounds @simd for i in 1:len
        res ⊻= (l[i+len] & r[i]) ⊻ (l[i] & r[i+len])
    end
    count_ones(res)&0x1
end

@inline function comm(l::PauliOperator, r::PauliOperator)::UInt8
    comm(l.xz,r.xz)
end

@inline function comm(l::PauliOperator, r::Tableau, i::Int)::UInt8
    # Guard against xzs word-count mismatches: when the tableau's physical word
    # count per row exceeds what nqubits requires (e.g. after _remove_rowcol!
    # without compaction), the Z-half offset in the generic comm() would be wrong.
    @boundscheck length(l.xz) == size(r.xzs, 1) || throw(DimensionMismatch(
        lazy"comm(PauliOperator, Tableau, i): operator xz length $(length(l.xz)) ≠ tableau xzs row count $(size(r.xzs, 1))"))
    comm(l.xz,(@view r.xzs[:,i]))
end

@inline function comm(l::Tableau, r::PauliOperator, i::Int)::UInt8
    comm(r, l, i)
end

@inline function comm(s::Tableau, l::Int, r::Int)::UInt8
    comm((@view s.xzs[:,l]),(@view s.xzs[:,r]))
end

function comm(l::PauliOperator, r::Tableau)::Vector{UInt8}
    [comm(l,r,i) for i in 1:size(r,1)]
end

comm(l::Tableau, r::PauliOperator) = comm(r, l)

@inline comm(l::PauliOperator, r::Stabilizer, i::Int) = comm(l, tab(r), i)
@inline comm(l::Stabilizer, r::PauliOperator, i::Int) = comm(tab(l), r, i)
@inline comm(l::PauliOperator, r::Stabilizer) = comm(l, tab(r))
@inline comm(l::Stabilizer, r::PauliOperator) = comm(tab(l), r)
@inline comm(s::Stabilizer, l::Int, r::Int) = comm(tab(s), l, r)

"""An in-place version of [`comm`](@ref), storing its output in the given buffer."""
function comm! end
function comm!(v, l::PauliOperator, r::Tableau)
    length(v) == length(r) || throw(DimensionMismatch(lazy"The dimensions of the output buffer and the input tableau have to match in `comm!`"))
    nqubits(l) == nqubits(r) || throw(DimensionMismatch(lazy"The number of qubits of the input Pauli operator and the input tableau have to match in `comm!`"))
    for i in 1:length(r)
        v[i] = comm(l,r,i)
    end
    v
end
comm!(v, l::Tableau, r::PauliOperator) = comm!(v, r, l)
@inline comm!(v, l::PauliOperator, r::Stabilizer) = comm!(v, l, tab(r))
@inline comm!(v, l::Stabilizer, r::PauliOperator) = comm!(v, tab(l), r)
function comm!(v, l::PauliOperator, r::Tableau, i)
    v[i] = comm(l,r,i)
    v
end
comm!(v, l::Tableau, r::PauliOperator, i) = comm!(v, r, l, i)
@inline comm!(v, l::PauliOperator, r::Stabilizer, i::Int) = comm!(v, l, tab(r), i)
@inline comm!(v, l::Stabilizer, r::PauliOperator, i::Int) = comm!(v, tab(l), r, i)
function comm!(v, s::Tableau, l::Int, r::Int)
    v[l] = comm(s, l, r)
    v
end
@inline comm!(v, s::Stabilizer, l::Int, r::Int) = comm!(v, tab(s), l, r)


Base.:(*)(l::PauliOperator, r::PauliOperator) = mul_left!(copy(r),l)

(⊗)(l::PauliOperator, r::PauliOperator) = PauliOperator((l.phase[]+r.phase[])&0x3, vcat(xbit(l),xbit(r)), vcat(zbit(l),zbit(r)))

function Base.:(*)(l::Number, r::PauliOperator)
    p = copy(r)
    if l==1
        nothing
    elseif l==1im
        p.phase[] = (p.phase[] + 1)&0x3
    elseif l==-1
        p.phase[] = (p.phase[] + 2)&0x3
    elseif l==-1im
        p.phase[] = (p.phase[] + 3)&0x3
    else
        throw(DomainError(l,"Only {±1,±i} are permitted as phases."))
    end
    p
end

Base.:(+)(p::PauliOperator) = p

function Base.:(-)(p::PauliOperator)
    p = copy(p)
    p.phase[] = (p.phase[]+2)&0x3
    p
end

const I = P"I"
const Z = P"Z"
const X = P"X"
const Y = P"Y"

##############################
# Stabilizer helpers
##############################

@inline function rowswap!(s::Tableau, i, j; phases::Val{B}=Val(true)) where B # Written only so we can avoid copying in `canonicalize!`
    (i == j) && return
    B && begin s.phases[i], s.phases[j] = s.phases[j], s.phases[i] end
    @inbounds @simd for k in 1:size(s.xzs,1)
        s.xzs[k,i], s.xzs[k,j] = s.xzs[k,j], s.xzs[k,i]
    end
end

@inline function rowswap!(s::Stabilizer, i, j; phases::Val{B}=Val(true)) where B
    rowswap!(tab(s), i, j; phases)
end

@inline function rowswap!(s::Destabilizer, i, j; phases::Val{B}=Val(true)) where B
    t = tab(s)
    rowswap!(t, i, j; phases)
    n = size(t,1)÷2
    rowswap!(t, i+n, j+n; phases)
end

@inline function rowswap!(s::MixedStabilizer, i, j; phases::Val{B}=Val(true)) where B
    rowswap!(tab(s), i, j; phases)
end

@inline function rowswap!(s::MixedDestabilizer, i, j; phases::Val{B}=Val(true)) where B
    t = tab(s)
    rowswap!(t, i, j; phases)
    n = nqubits(s)
    rowswap!(t, i+n, j+n; phases)
end

# TODO is this used anywhere?
"""Swap two columns of a stabilizer in place."""
@inline function colswap!(s::Tableau, i, j)
    Tₘₑ = eltype(s.xzs)
    lowbit = Tₘₑ(1)
    ibig = _div(Tₘₑ,i-1)+1
    ismall = _mod(Tₘₑ,i-1)
    ismallm = lowbit<<(ismall)
    jbig = _div(Tₘₑ,j-1)+1
    jsmall = _mod(Tₘₑ,j-1)
    jsmallm = lowbit<<(jsmall)
    for off in [0,size(s.xzs,2)÷2]
        ibig += off
        jbig += off
        @inbounds for k in 1:size(s.xzs,2)
            ival = s.xzs[ibig,k] & ismallm
            jval = s.xzs[jbig,k] & jsmallm
            s.xzs[ibig,k] &= ~ismallm
            s.xzs[jbig,k] &= ~jsmallm
            s.xzs[ibig,k] |= jval>>>(jsmall-ismall)
            s.xzs[jbig,k] |= ival>>>(ismall-jsmall)
        end
    end
end

@inline _logsizeof(::Union{T, Type{T}}) where {T <: Unsigned} = trailing_zeros(count_zeros(zero(T)))
@inline _mask(::T) where T<:Unsigned = sizeof(T)*8-1
@inline _mask(arg::T) where T<:Type = sizeof(arg)*8-1
@inline _div(T,l) = l >> _logsizeof(T)
@inline _mod(T,l) = l & _mask(T)

function unsafe_bitfindnext_(chunks::AbstractVector{T}, start::Int) where T<:Unsigned
    chunk_start = _div(T,start-1)+1
    within_chunk_start = _mod(T,start-1)
    mask = ~T(0) << within_chunk_start

    @inbounds begin
        if chunks[chunk_start] & mask != 0
            return (chunk_start-1) << _logsizeof(T) + trailing_zeros(chunks[chunk_start] & mask) + 1
        end

        for i = chunk_start+1:length(chunks)
            if chunks[i] != 0
                return (i-1) << _logsizeof(T) + trailing_zeros(chunks[i]) + 1
            end
        end
    end
    return nothing
end

"""
$(TYPEDSIGNATURES)

Computes bitmask indices for an unsigned integer at index `i`
within the binary structure of a `Tableau` or `PauliOperator`.

For `Tableau`, the method operates on the `.xzs` field, while
for `PauliOperator`, it uses the `.xz` field. It calculates
the following values based on the index `i`:

- `lowbit`, the lowest bit.
- `ibig`, the index of the word containing the bit.
- `ismall`, the position of the bit within the word.
- `ismallm`, a bitmask isolating the specified bit.
"""
@inline function get_bitmask_idxs(xzs::AbstractArray{<:Unsigned}, i::Int)
    T = eltype(xzs)
    lowbit = T(1)
    ibig = _div(T, i-1) + 1
    ismall = _mod(T, i-1)
    ismallm = lowbit << ismall
    return lowbit, ibig, ismall, ismallm
end

function check_allrowscommute(stabilizer::Tableau)
    for i in eachindex(stabilizer)
        for j in eachindex(stabilizer)
            i==j && continue
            comm(stabilizer[i],stabilizer[j])==0x0 || return false
        end
    end
    return true
end
check_allrowscommute(stabilizer::Stabilizer)=check_allrowscommute(tab(stabilizer))

"""
Vertically concatenates tableaux.

```jldoctest
julia> vcat(ghz(2), ghz(2))
+ XX
+ ZZ
+ XX
+ ZZ
```

See also: [`hcat`](@ref)
"""
function Base.vcat(tabs::Tableau...)
    Tableau(
        vcat((s.phases for s in tabs)...),
        tabs[1].nqubits,
        hcat((s.xzs for s in tabs)...))
end

Base.vcat(stabs::Stabilizer{T}...) where {T} = Stabilizer(vcat((tab(s) for s in stabs)...))

"""
Horizontally concatenates tableaux.

```jldoctest
julia> hcat(ghz(2), ghz(2))
+ XXXX
+ ZZZZ
```

See also: [`vcat`](@ref)
"""
function Base.hcat(tabs::Tableau...) # TODO this implementation is slow as it unpacks each bitvector into bits and repacks them -- reuse the various tableau inset functionality we have to speed this up
    rows = size(tabs[1], 1)
    cols = sum(map(nqubits, tabs))
    newtab = zero(Tableau, rows, cols)
    cols_idx = 1
    for tab in tabs
        rows_tab, cols_tab = size(tab)
        if rows_tab != rows
            throw(ArgumentError("All input Tableaux/Stabilizers must have the same number of rows."))
        end
        for i in 1:rows
            for j in 1:cols_tab
                newtab[i, cols_idx+j-1]::Tuple{Bool,Bool} = tab[i, j]::Tuple{Bool,Bool}
            end
            newtab.phases[i] = (newtab.phases[i]+tab.phases[i])%4
        end
        cols_idx += cols_tab
    end
    return newtab
end

Base.hcat(stabs::Stabilizer{T}...) where {T} = Stabilizer(hcat((tab(s) for s in stabs)...))

##############################
# Unitary Clifford Operations
##############################

"""
    apply!

Apply any quantum operation to a stabilizer state, including unitary Clifford
operations, Pauli measurements, and noise.
May result in a random/stochastic result (e.g. with measurements or noise)."""
function apply! end

function Base.:(*)(p::AbstractCliffordOperator, s::AbstractStabilizer; phases::Bool=true)
    s = copy(s)
    @valbooldispatch _apply!(s,p; phases=Val(phases)) phases
end
function apply!(stab::AbstractStabilizer, op::AbstractCliffordOperator; phases::Bool=true)
    @valbooldispatch _apply!(stab,op; phases=Val(phases)) phases
end
function apply!(stab::AbstractStabilizer, indices::Base.AbstractVecOrTuple{Int}, op::AbstractCliffordOperator; phases::Bool=true)
    @valbooldispatch _apply!(stab,op,indices; phases=Val(phases)) phases
end
@deprecate apply!(stab::AbstractStabilizer, op::AbstractCliffordOperator, indices::Base.AbstractVecOrTuple{Int}; phases::Bool=true) apply!(stab, indices, op; phases=phases)

# TODO no need to track phases outside of stabview
function _apply!(stab::AbstractStabilizer, p::PauliOperator; phases::Val{B}=Val(true)) where B
    nqubits(stab)==nqubits(p) || throw(DimensionMismatch("The tableau and the Pauli operator need to act on the same number of qubits. Consider specifying an array of indices as a third argument to the `apply!` function to avoid this error."))
    s = tab(stab)
    B || return stab
    for i in eachindex(s)
        s.phases[i] = (s.phases[i]+comm(p,s,i)<<1)&0x3
    end
    stab
end

function _apply!(stab::AbstractStabilizer, p::PauliOperator, indices; phases::Val{B}=Val(true)) where B
    s = tab(stab)
    B || return stab
    newp = zero(typeof(p),nqubits(s)) # TODO this is an unnecessarily slow operation for something that can be sparse
    for (ii,i) in enumerate(indices)
        newp[i] = p[ii]
    end
    newp.phase .= p.phase
    for i in eachindex(s)
        s.phases[i] = (s.phases[i]+comm(newp,s,i)<<1)&0x3
    end
    stab
end


"""
    apply_inv!

Apply the inverse of any quantum operation to a stabilizer state.
"""
function apply_inv! end

function apply_inv!(stab::AbstractStabilizer, op::AbstractCliffordOperator; phases::Bool=true)
    @valbooldispatch _apply_inv!(stab,op; phases=Val(phases)) phases
end
function apply_inv!(stab::AbstractStabilizer, op::AbstractCliffordOperator, indices; phases::Bool=true)
    @valbooldispatch _apply_inv!(stab,op,indices; phases=Val(phases)) phases
end

function _apply_inv!(stab::AbstractStabilizer, p::PauliOperator; phases::Val{B}=Val(true)) where B
    apply!(stab,p; phases=phases)
end
function _apply_inv!(stab::AbstractStabilizer, p::PauliOperator, indices; phases::Val{B}=Val(true)) where B
    apply!(stab,p,indices; phases=phases)
end

##############################
# Conversion and promotion
##############################

Base.promote_rule(::Type{<:Destabilizer{T}}   , ::Type{<:MixedDestabilizer{T}}) where {T<:Tableau} = MixedDestabilizer{T}
Base.promote_rule(::Type{<:MixedStabilizer{T}}, ::Type{<:MixedDestabilizer{T}}) where {T<:Tableau} = MixedDestabilizer{T}
Base.promote_rule(::Type{<:Stabilizer{T}}     , ::Type{<:S}                   ) where {T<:Tableau, S<:Union{MixedStabilizer{T}, Destabilizer{T}, MixedDestabilizer{T}}} = S

Base.convert(::Type{<:MixedDestabilizer{T}}, x::Union{Destabilizer{T}, MixedStabilizer{T}, Stabilizer{T}}) where {T <: Tableau} = MixedDestabilizer(x)

##############################
# Helpers for binary codes
##############################

"""The F(2,2) matrix of a given tableau, represented as the concatenation of two binary matrices, one for X and one for Z."""
function stab_to_gf2(s::Tableau)
    r, n = size(s)
    H = zeros(Bool,r,2n)
    for iᵣ in 1:r
        @inbounds @simd for iₙ in 1:n
            H[iᵣ,iₙ], H[iᵣ,iₙ+n] = s[iᵣ,iₙ]
        end
    end
    H
end
function stab_to_gf2(p::PauliOperator)
    n = nqubits(p)
    H = zeros(Bool,2n)
    @inbounds @simd for i in 1:n
        H[i], H[i+n] = p[i]
    end
    H
end
stab_to_gf2(s::Stabilizer) = stab_to_gf2(tab(s))

"""Gaussian elimination over the binary field."""
function gf2_gausselim!(H)
    rows, cols = size(H)
    j = 1
    for c in 1:cols
        j>rows && break
        goodrow = findfirst(H[j:end,c])
        goodrow===nothing && continue
        goodrow += j-1
        @inbounds for d in 1:cols
            H[goodrow,d], H[j,d] = H[j,d], H[goodrow,d]
        end
        for r in 1:rows
            r==j && continue
            if H[r,c]
                H[r,:] .⊻= H[j,:]
            end
        end
        j += 1
    end
    H
end

# TODO check whether Nemo is faster in doing this and other gf2 methods.
"""Check whether a binary matrix is invertible."""
function gf2_isinvertible(H) # TODO can be smarter and exit earlier. And should check for squareness.
    ut = gf2_gausselim!(copy(H))
    all((ut[i, i] for i in 1:size(ut,1)))::Bool
end

"""Invert a binary matrix."""
function gf2_invert(H)
    id = zero(H)
    s = size(H,1)
    for i in 1:s id[i,i]=true end
    M = hcat(H,id)
    gf2_gausselim!(M)
    M[:,s+1:end]
end

"""The permutation of columns which turns a binary matrix into standard form. It is assumed the matrix has already undergone Gaussian elimination."""
function gf2_H_standard_form_indices(H)
    rows, cols = size(H)
    goodindices = Int[]
    j = 1
    r = 1
    for r in 1:rows
        i = findfirst(H[r,:])
        (i ∈ goodindices)::Bool && continue
        push!(goodindices, i)
    end
    badindices = [r for r in 1:goodindices[end] if !(r ∈ goodindices)]
    return vcat(goodindices, badindices, goodindices[end]+1:cols)
end

"""For a given F(2,2) parity check matrix, return the generator matrix."""
function gf2_H_to_G(H)
    # XXX it assumes that H is upper triangular (Gauss elimination, canonicalized, etc)
    # XXX careful, this is the binary code matrix - for the F(2,2) code you need to swap the x and z parts
    rows, cols = size(H)
    sindx = gf2_H_standard_form_indices(H)
    H = H[:,sindx]
    P = H[:,rows+1:end]'
    I = falses(cols-rows,cols-rows)
    for i in 1:size(I,1)
        I[i,i]=true
    end
    G = hcat(P,I)
    G[:,invperm(sindx)]
end

"""Performs in-place Gaussian elimination on a binary matrix and returns
its *row echelon form*,*rank*, the *transformation matrix*, and the *pivot
columns*. The transformation matrix that converts the original matrix into
the row echelon form. The `full` parameter controls the extent of elimination:
if `true`, only rows below the pivot are affected; if `false`, both above and
below the pivot are eliminated."""
function gf2_row_echelon_with_pivots!(M::AbstractMatrix{Int}; full=false)
    r, c = size(M)
    N = Matrix{Int}(LinearAlgebra.I, r, r)
    p = 1
    pivots = Int[]
    for col in 1:c
        @inbounds for row in p:r
            if M[row, col] == 1
                if row != p
                    M[[row, p], :] .= M[[p, row], :]
                    N[[row, p], :] .= N[[p, row], :]
                end
                break
            end
        end
        if M[p, col] == 1
            if !full
                elim_range = p+1:r
            else
                elim_range = 1:r
            end
            @simd for j in elim_range
                @inbounds if j != p && M[j, col] == 1
                    M[j, :] .= (M[j, :] .+ M[p, :]) .% 2
                    N[j, :] .= (N[j, :] .+ N[p, :]) .% 2
                end
            end
            p += 1
            push!(pivots, col)
        end
        if p > r
            break
        end
    end
    rank = p - 1
    return M, rank, N, pivots
end

"""The nullspace of a binary matrix."""
function gf2_nullspace(H::AbstractMatrix{Int})
    m = size(H',1)
    _, matrix_rank, transformation_matrix, _ = gf2_row_echelon_with_pivots!(copy(H)')
    if m == matrix_rank
        # By the rank-nullity theorem, if rank(M) = m, then nullity(M) = 0
        return zeros(Bool, 1, m)
    end
    # Extract the nullspace from the transformation matrix
    return transformation_matrix[matrix_rank+1:end, :]
end

"""The basis for the row space of the binary matrix."""
function gf2_rowspace_basis(H::AbstractMatrix{Int})
    pivots = gf2_row_echelon_with_pivots!(copy(H)')[4]
    # Extract the rows corresponding to the pivot columns
    H[pivots,:]
end

##############################
# Error classes
##############################
struct BadDataStructure <: Exception
    message::String
    whichop::Symbol
    whichstructure::Symbol
end

##############################
# Consistency checks
##############################

"""
Check basic consistency requirements of a stabilizer. Used in tests.
"""
function stab_looks_good(s; remove_redundant_rows=false)
    # first remove redundant rows
    c = if remove_redundant_rows
        s1, _, rank = canonicalize!(copy(s), ranks=true)
        tab(s1[1:rank])
    else
        tab(canonicalize!(copy(s)))
    end
    nrows, ncols = size(c)
    all((c.phases .== 0x0) .| (c.phases .== 0x2)) || return false
    H = stab_to_gf2(c)
    good_indices = reduce(|,H,dims=(1,))
    good_indices = good_indices[1:end÷2] .| good_indices[end÷2+1:end]
    colsok = ncols>nrows || all(good_indices) # TODO, this can be stricter
    colsok || return false
    good_indices = reduce(|,H,dims=(2,))
    rowsok = nrows>ncols || all(good_indices) # TODO, this can be stricter
    rowsok || return false
    check_allrowscommute(c) || return false
    return true
end

"""
Check basic consistency requirements of a mixed stabilizer. Used in tests.
"""
function mixed_stab_looks_good(s)
    s = stabilizerview(s)
    c = tab(canonicalize!(copy(s)))
    all((c.phases .== 0x0) .| (c.phases .== 0x2)) || return false
    H = stab_to_gf2(c)
    # Unlike for stabilizers, we do not expect all columns to have non-identity ops
    non_trivial_rows = reduce(|,H,dims=(2,))
    all(non_trivial_rows) || return false
    check_allrowscommute(c) || return false
    return true
end

"""
Check basic consistency requirements of a destabilizer. Used in tests.
"""
function destab_looks_good(destabilizer)
    s = stabilizerview(destabilizer)
    d = destabilizerview(destabilizer)
    stab_looks_good(s) || return false
    stab_looks_good(d) || return false
    for i in eachindex(s)
        comm(s[i],d[i])==0x1 || return false
        for j in eachindex(s)
            j==i && continue
            comm(s[i],d[j])==0x0 || return false
        end
    end
    return true
end

"""
Check basic consistency requirements of a mixed destabilizer. Used in tests.
"""
function mixed_destab_looks_good(destabilizer)
    s = stabilizerview(destabilizer)
    d = destabilizerview(destabilizer)
    x = logicalxview(destabilizer)
    z = logicalzview(destabilizer)
    check_allrowscommute(s) || return false
    mixed_stab_looks_good(s) || return false
    mixed_stab_looks_good(d) || return false
    mixed_stab_looks_good(x) || return false
    mixed_stab_looks_good(z) || return false
    for i in eachindex(s)
        comm(s[i],d[i])==0x1 || return false
        for j in eachindex(s)
            j==i && continue
            comm(s[i],d[j])==0x0 || return false
        end
        for j in eachindex(x)
            comm(s[i],x[j])==0x0 || return false
            comm(s[i],z[j])==0x0 || return false
        end
    end
    for i in eachindex(x)
        for j in eachindex(x)
            comm(x[i],x[j])==0x0 || return false
            comm(z[i],z[j])==0x0 || return false
            if i==j
                comm(x[i],z[j])==0x1 || return false
            else
                comm(x[i],z[j])==0x0 || return false
            end
        end
    end
    return true
end

# base tableaux handling
include("mul_leftright.jl")
include("canonicalization.jl")
include("project_trace_reset.jl")
include("fastmemlayout.jl")
# dense clifford operator tableaux
include("dense_cliffords.jl")
# special one- and two- qubit operators
include("symbolic_cliffords.jl")
# apply right operations
include("apply_right.jl")
# linear algebra and array-like operations
include("linalg.jl")
# circuits
include("operator_traits.jl")
include("mctrajectory.jl")
include("petrajectory.jl")
include("misc_ops.jl")
include("classical_register.jl")
include("misc_gates.jl")
include("noise.jl")
include("affectedqubits.jl")
include("pauli_frames.jl")
# common states and operators
include("enumeration.jl")
include("randoms.jl")
include("useful_states.jl")
#
include("graphs/graphs.jl")
using .GraphSim
#
include("entanglement.jl")
#
include("isclifford.jl")
include("symbolic_noncliffords.jl")
#
include("tableau_show.jl")
include("sumtypes.jl")
include("precompiles.jl")
#
include("ecc/ECC.jl")
#
include("lowrank/PauliChannelNonClifford.jl")
include("lowrank/PureNonClifford.jl")
using .PauliChannelNonClifford
using .PureNonClifford
#
include("grouptableaux.jl")
include("plotting_extensions.jl")
#
include("gpu_adapters.jl")
end #module

# TODO: Revisit should the base package support more multiplication signatures.
# This must be done explicitly as they are not exported.
using QuantumClifford: mul_left!, mul_right!

@inline function test_KA_mul_leftright(AT, synchronize)
    cache = AllocCache()
    for n in test_sizes
    # Keep the memory usage sane.
    rows = min(n, max_rows)
    for r in one(round_count) : round_count
    block = block_sizes[r]
    batch = batch_sizes[r]
    for mul! in (mul_left!, mul_right!)
    @cached cache begin

        # PauliOperator
        h_p1 = random_pauli(n)
        d_p1 = PauliOperator(AT(u32(h_p1.phase)), h_p1.nqubits, AT(h_p1.xz))
        h_p2 = random_pauli(n)
        d_p2 = PauliOperator(AT(u32(h_p2.phase)), h_p2.nqubits, AT(h_p2.xz))

        # Stabilizer
        h_s = Stabilizer(
            Tableau(
                rand(eltype(h_p1.phase), rows) .& 0x3,
                n,
                rand(eltype(h_p1.xz), length(h_p1.xz), rows)
                )
            )
        d_s = Stabilizer(
            Tableau(
                AT(u32(h_s.tab.phases)),
                h_s.tab.nqubits,
                AT(h_s.tab.xzs)
                )
            )

        # Destabilizer
        h_d = Destabilizer(
            Tableau(
                rand(eltype(h_p1.phase), rows << 1) .& 0x3,
                n,
                rand(eltype(h_p1.xz), length(h_p1.xz), rows << 1)
                )
            )
        d_d = Destabilizer(
            Tableau(
                AT(u32(h_d.tab.phases)),
                h_d.tab.nqubits,
                AT(h_d.tab.xzs)
                )
            )
        i = rand(one(rows) : rows)
        j = rand(one(rows) : rows)

        # Independent of phases.
        d_o_true = mul!(
            copy(d_p1), d_p2;
            phases = Val(true),
            block_size = Val(block), batch_size = Val(batch)
            )
        d_o_false = mul!(
            copy(d_p1), d_p2;
            phases = Val(false),
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        @test Array(d_o_true.xz) == Array(d_o_false.xz)

        # Left/Right order.
        d_L = mul_left!(
            copy(d_p1), d_p2;
            block_size = Val(block), batch_size = Val(batch)
            )
        d_R = mul_right!(
            copy(d_p1), d_p2;
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        # Either commutes or anti-commutes.
        @test begin
            (Array(d_L.phase)[1] - Array(d_R.phase)[1]) & 0x3 ==
                (comm(h_p1, h_p2) << 1) &&
            Array(d_L.xz) == Array(d_R.xz)
        end

        # Potential aliasing problem.
        h_o = mul!(copy(get_pauli(h_s, i)), h_s, i)
        d_o = mul!(
            copy(d_s), i, i;
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        @test begin
            h_o.phase == Array(phases(d_o, i)) &&
            h_o.xz == Array(xzs(d_o, i))
        end

        # PauliOperator - PauliOperator
        h_o = mul!(copy(h_p1), h_p2)
        d_o = mul!(
            copy(d_p1), d_p2;
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        @test begin
            h_o.phase == Array(d_o.phase) &&
            h_o.xz == Array(d_o.xz)
        end

        for (h_v, d_v) in ((h_s.tab, d_s.tab), (h_s, d_s))

        # PauliOperator - Tableau/AbstractStabilizer[i]
        h_o = mul!(copy(h_p1), h_v, i)
        d_o = mul!(
            copy(d_p1), d_v, i;
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        @test begin
            h_o.phase == Array(d_o.phase) &&
            h_o.xz == Array(d_o.xz)
        end

        # Marks the end for (h_v, d_v)
        end

        for (h_u, d_u) in ((h_s.tab, d_s.tab), (h_s, d_s))

        # Tableau/AbstractStabilizer - PauliOperator
        h_o = mul!(copy(h_u), h_p1)
        d_o = mul!(
            copy(d_u), d_p1;
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        @test begin
            phases(h_o, i) == Array(phases(d_o, i)) &&
            xzs(h_o, i) == Array(xzs(d_o, i))
        end

        # Tableau/AbstractStabilizer[i] - PauliOperator
        h_o = mul!(copy(get_pauli(h_u, i)), h_p1)
        d_o = mul!(
            copy(d_u), i, d_p1;
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        @test begin
            h_o.phase == Array(phases(d_o, i)) &&
            h_o.xz == Array(xzs(d_o, i))
        end

        # Tableau/AbstractStabilizer[i] - Self[j]
        h_o = mul!(copy(get_pauli(h_u, i)), h_u, j)
        d_o = mul!(
            copy(d_u), i, j;
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        @test begin
            h_o.phase == Array(phases(d_o, i)) &&
            h_o.xz == Array(xzs(d_o, i))
        end

        for (h_v, d_v) in ((h_s.tab, d_s.tab), (h_s, d_s))

        # Tableau/AbstractStabilizer - Tableau/AbstractStabilizer
        d_o = mul!(
            copy(d_u), d_v;
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        # Rows become {+/-} x Identity since it is multiplied by itself.
        @test begin
            reduce(|, phases(d_o)) & 0x1 == 0 &&
            reduce(|, xzs(d_o, i)) == 0
        end

        # Tableau/AbstractStabilizer - Tableau/AbstractStabilizer[i]
        h_o = mul!(copy(h_u), get_pauli(h_v, i))
        d_o = mul!(
            copy(d_u), d_v, i;
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        @test begin
            phases(h_o, j) == Array(phases(d_o, j)) &&
            xzs(h_o, j) == Array(xzs(d_o, j))
        end

        # Tableau/AbstractStabilizer[i] - Tableau/AbstractStabilizer[j]
        h_o = mul!(copy(get_pauli(h_u, i)), h_v, j)
        d_o = mul!(
            copy(d_u), i, d_v, j;
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        @test begin
            h_o.phase == Array(phases(d_o, i)) &&
            h_o.xz == Array(xzs(d_o, i))
        end

        # Marks the end for (h_v, d_v)
        end

        # Marks the end for (h_u, d_u)
        end

        # (Mixed)Destabilizer[i] - Self[j]
        h_o1 = mul!(
            copy(get_pauli(h_d, j)), get_pauli(h_d, i);
            phases = Val(false)
            )
        m = length(h_d.tab.phases) >> 1
        h_o2 = mul!(copy(get_pauli(h_d, i + m)), get_pauli(h_d, j + m))
        d_o = mul!(
            d_d, i, j;
            block_size = Val(block), batch_size = Val(batch)
            )
        synchronize()
        @test begin
            h_o1.phase == Array(phases(d_o, j)) &&
            h_o1.xz == Array(xzs(d_o, j)) &&
            h_o2.phase == Array(phases(d_o, i + m)) &&
            h_o2.xz == Array(xzs(d_o, i + m))
        end

    # Marks the end for @cached
    end
    # Marks the end for mul!
    end
    # Marks the end for r in one(round_count) : round_count
    end
    # Marks the end for n in test_sizes
    end
    unsafe_free!(cache)
end

using Revise
using QuantumClifford
using QuantumClifford: to_cpu, to_gpu
using CUDA
using BenchmarkTools
using Plots
using ProgressBars
using DataFrames
using CSV

include("surface-code-circuit.jl")

ints = [UInt8, UInt16, UInt32, UInt64, UInt128]
names = [:UInt8, :UInt16, :UInt32, :UInt64, :UInt128]

function get_stats()
    println("Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...")

    # Powers of 2 to benchmark
    powers = reverse(3:18) # start from the hardest one first! (fail fast)
    n_values = 2 .^ powers

    times = Dict([
        sm=>[]
        for (sm, tp) in zip(names, ints)
    ])

    ccircuit = if eltype(circ) <: QuantumClifford.CompactifiedGate
        circ
    else
        compactify_circuit(circ)
    end

    CUDA.allowscalar(false)


    for n in ProgressBar(n_values)    
        for (sm, T) in zip(names, ints)
            gpu_frames() = to_gpu(QuantumClifford._create_pauliframe(ccircuit; trajectories=n), T)
            gpu_column() = pftrajectories(fastcolumn(gpu_frames()), ccircuit), synchronize()
            @show n, T
            @elapsed gpu_column() # to eliminate compile time
            push!(times[sm], @belapsed $gpu_column())
        end
        # note. this is also measuring the time it takes to move data to gpu
    end
    df = DataFrame(times)
    df.n_values=n_values
    return df
end

function load_stats()
    if isfile("gpu_innertype_comparison.csv")
        DataFrame(CSV.File("gpu_innertype_comparison.csv"))
    else
        get_stats()
    end
end

function save_stats(df)
    CSV.write("gpu_innertype_comparison.csv", df)
end

function plot_result(df)
    my_y_axis(arrs) = begin
        arr = []
        for a in arrs
            append!(arr, a)
        end
        logarr = log.(arr)
        exp.(range(min(logarr...), stop=max(logarr...), length=8))
    end
    plot(df.n_values, [df[!, col] for col in names], marker=:circle, label=reshape(["times $col" for col in names], (1, length(names))), xlabel="n", ylabel="Execution Time (s)", title="gpu inner type comparison (fast column)", xticks=df.n_values[1:2:end], xscale=:log2, yticks=my_y_axis([df[!, col] for col in names]), yscale=:log10, legend=:topleft, size=(1200, 800))
end

function main()
    df = load_stats()
    save_stats(df)
    plot_result(df)
    savefig("benchmark_gpu_innertype.png")
end

"""
    $TYPEDEF

The extended generalized bicycle code ([koukoulekidis2024smallquantumcodesalgebraic](@cite)) is a family of quantum LDPC codes generated
through *algebraic extension* of a base [`GeneralizedBicycle`](@ref). Starting
with initial generating polynomials ``a(x), b(x) \\in \\mathbb{F}_2^{\\langle\\ell\\rangle}``,
the extended GB codes are constructed by polynomial multiplication, where for each extension
step ``m``, an extension polynomial

```math
\\begin{aligned}
p^{(m)}(x) \\in \\mathbb{F}_2^{\\langle\\kappa_m\\ell\\rangle}
\\end{aligned}
```

is selected to produce extended polynomials:

```math
\\begin{aligned}
a^{(m)}(x) &= p^{(m)}(x)a(x), \\\\
b^{(m)}(x) &= p^{(m)}(x)b(x)
\\end{aligned}
```

These extended polynomials are then used to form ``\\kappa_m\\ell \\times \\kappa_m\\ell`` circulant
matrices ``A_m`` and ``B_m``, which are combined into a parity-check matrix ``H_m`` with block structure:

```math
\\begin{aligned}
H_m = \\begin{pmatrix}
A_m \\mid B_m & 0 \\\\
0 & B_m^\\top \\mid A_m^\\top
\\end{pmatrix}
\\end{aligned}
```

while maintaining logical dimension:

```math
\\begin{aligned}
k_m = 2\\deg\\left(\\gcd\\left(a^{(m)}, b^{(m)}, x^{\\kappa_m\\ell}-1\\right)\\right)
\\end{aligned}
```

that are always bounded below by the base code dimension `k`.

#### Example

```jldoctest
julia> import Hecke: polynomial_ring, GF, one, gen; using QuantumClifford.ECC;

julia> R, x = polynomial_ring(GF(2), "x");

julia> l = 5;

julia> a = 1 + x^4;

julia> b = 1 + x + x^2 + x^4;

julia> c = GeneralizedBicycle(a, b, l);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(10, 2, 3)

julia> m, p = 4, one(R);

julia> new_code = ExtendedGeneralizedBicycle(c, m, p);

julia> code_n(new_code), code_k(new_code), distance(new_code, DistanceMIPAlgorithm(solver=HiGHS))
(40, 2, 5)

julia> m, p = 4, 1 + x;

julia> new_code = ExtendedGeneralizedBicycle(c, m, p);

julia> code_n(new_code), code_k(new_code), distance(new_code, DistanceMIPAlgorithm(solver=HiGHS))
(40, 4, 5)
```

!!! note
    [koukoulekidis2024smallquantumcodesalgebraic](@cite) establishes that `l = 5` is the
    minimal lift size required to achieve quantum error-correcting codes with a minimum
    distance of `d ≥ 3`.

### Fields
    $TYPEDFIELDS
"""
struct ExtendedGeneralizedBicycle <: AbstractCSSCode
    """The base generalized bicycle code to extend."""
    base_code::AbstractCSSCode
    """The extension index (m ≥ 1)"""
    m::Int
    """The extension polynomial ∈ 𝔽₂[((m-1)l +1)]."""
    p::FqPolyRingElem

    function ExtendedGeneralizedBicycle(base_code::GeneralizedBicycle, m::Int, p::FqPolyRingElem)
        m ≥ 1 || throw(ArgumentError("Extension index m must be ≥ 1"))
        if m == 1
            isone(p) || throw(ArgumentError("For m=1, p must be 1"))
        else
            max_deg = (m-1)*base_code.l+1
            degree(p) < max_deg || throw(ArgumentError("For m=$m, polynomial degree must be < $max_deg"))
        end
        new(base_code, m, p)
    end
end

function parity_matrix_xz(c::ExtendedGeneralizedBicycle)
    l = c.base_code.l
    R = parent(c.base_code.a)
    x = gen(R)
    # a⁽ᵐ⁾(x) = p(x)a(x) ∈ 𝔽₂[x]/(x^(ml) - 1)
    a⁽ᵐ⁾ = mod(c.p*c.base_code.a, x^(c.m*l)-1)
    # b⁽ᵐ⁾(x) = p(x)b(x) ∈ 𝔽₂[x]/(x^(ml) - 1)
    b⁽ᵐ⁾ = mod(c.p*c.base_code.b, x^(c.m*l)-1)
    ext_gb = GeneralizedBicycle(a⁽ᵐ⁾, b⁽ᵐ⁾, c.m*l)
    hx, hz = parity_matrix_xz(ext_gb)
    return hx, hz
end

parity_matrix_x(c::ExtendedGeneralizedBicycle) = parity_matrix_xz(c)[1]

parity_matrix_z(c::ExtendedGeneralizedBicycle) = parity_matrix_xz(c)[2]

@testitem "Symbolic Measurements" begin
    using Random
    using QuantumClifford
    using Test
    test_sizes = [10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    @testset "Symbolic Measurements" begin
        for n in test_sizes
            for i in [rand(1:n), 1, n, n÷2+1, n÷2-1, n÷2]
                for T in [sMRZ,sMZ,sMRX,sMX] # TODO sMY sMRY
                    for _ in 1:10
                        apply!(PauliFrame(n,n,n), T(i,1))
                    end
                end
            end
            for i in [rand(1:n), 1, n, n÷2+1, n÷2-1, n÷2]
                for T in [sMRZ,sMZ,sMRX,sMX,sMY] # TODO sMRY
                    for _ in 1:10
                        s = random_stabilizer(n)
                        apply!(Register(copy(s),1), T(i,1))
                    end
                end
            end
        end
        @test_throws DimensionMismatch SingleQubitOperator(tCNOT,1)
        @test_throws DimensionMismatch CliffordOperator(sHadamard(5),2)
        @test_throws ArgumentError CliffordOperator(sHadamard(5),6,compact=true)
        for T in [sMRZ,sMZ,sMRX,sMX,sMRY,sMY]
            @test_throws ArgumentError T(-1)
            @test_throws ArgumentError T(-1,0)
            @test_throws ArgumentError T(-1,1)
            @test T(1,0) == T(1)
        end
    end
end

"""
    $TYPEDEF

The generalized toric code is specified by two [Laurent polynomials](https://en.wikipedia.org/wiki/Laurent_polynomial)
``f(x,y)`` and ``g(x,y)`` over ``\\mathbb{F}_2``. These polynomials encode the local
stabilizers of the X and Z-type operators. The parameters (α, β, γ) define
the geometry of the underlying twisted torus:

- ``\\alpha``: vertical period from lattice vector ``a_1 = (0, \\alpha)``
- ``\\beta``: horizontal extent from lattice vector ``a_2 = (\\beta, \\gamma)``
- ``\\gamma``: vertical shift applied when wrapping horizontally

### Laurent Polynomial Formalism

Any two-dimensional translation-invariant Pauli stabilizer code over ``\\mathbb{Z}_2`` qubits
that satisfies the topological order condition can be transformed via a finite-depth quantum
circuit into a direct sum of Kitaev toric codes ([liang2025generalizedtoriccodestwisted](@cite),
[Liang_2024](@cite)).

[liang2025generalizedtoriccodestwisted](@cite) employ a ring-theoretic approach within the
framework of topological order to study two-dimensional topological CSS codes using [Laurent
polynomial](https://en.wikipedia.org/wiki/Laurent_polynomial) formalism. This technique allows
for efficient construction of new quantum LDPC codes.

!!! note
    The use of *twisted tori* enables stabilizers with more *localized* support compared to prior methods.

By leveraging Laurent polynomial rings, [liang2025generalizedtoriccodestwisted](@cite) derive the
topological order associated with Pauli stabilizer codes. Extending this framework, it introduces a
*ring-theoretic* method that simplifies computations for CSS codes. Specifically, *Gröbner basis* techniques
are utilized to classify [anyons](https://en.wikipedia.org/wiki/Anyon) in these topological orders
[liang2025generalizedtoriccodestwisted](@cite).

For simplicity, [liang2025generalizedtoriccodestwisted](@cite) focus on the *square lattice*. On the
square lattice, a unit cell consisting of two edges, representing their Pauli operators as 4-dimensional vectors:

```math
\\begin{aligned}
X_1 = \\begin{bmatrix} 1 \\\\ 0 \\\\ 0 \\\\ 0 \\end{bmatrix}, \\quad
X_2 = \\begin{bmatrix} 0 \\\\ 1 \\\\ 0 \\\\ 0 \\end{bmatrix}, \\quad
Z_1 = \\begin{bmatrix} 0 \\\\ 0 \\\\ 1 \\\\ 0 \\end{bmatrix}, \\quad
Z_2 = \\begin{bmatrix} 0 \\\\ 0 \\\\ 0 \\\\ 1 \\end{bmatrix}
\\end{aligned}
```

Translated Pauli operators are obtained by multiplying these basis vectors by the monomial
``x^n y^m`` (where n, m may be negative), implementing a shift of n steps in the x-direction
and m steps in the y-direction. In this formalism, the product of two Pauli operators corresponds to
the sum of their 4-dimensional vectors.

The Pauli operator vectors form a [module](https://en.wikipedia.org/wiki/Module_(mathematics)) over the
Laurent polynomial ring ``R = \\mathbb{Z}_2[x, y, x^{-1}, y^{-1}]``.

The translation-invariant ``\\mathbb{Z}_2`` CSS code with stabilizers expressed as:

```math
\\begin{aligned}
A_v = \\begin{bmatrix} f(x, y) \\\\ g(x, y) \\\\ \\hline 0 \\\\ 0 \\end{bmatrix}, \\quad
B_p = \\begin{bmatrix} 0 \\\\ 0 \\\\ \\hline \\overline{g}(x, y) \\\\ \\overline{f}(x, y) \\end{bmatrix}
\\end{aligned}
```

where ``\\overline{x^n y^m} := x^{-n} y^{-m}``. ``A_v`` and ``B_p`` denote the X and Z stabilizer
generators, respectively, forming the stabilizer group ``S``. Specifically, ``S`` is generated by all lattice
translations of ``A_v`` and ``B_p``, i.e., the set of operators ``{x^n y^m A_v, x^n y^m B_p \\mid n, m \\in \\mathbb{Z}}`` [liang2025generalizedtoriccodestwisted](@cite).

Utilizing Laurent polynomial formalism, [liang2025generalizedtoriccodestwisted](@cite) introduces the
**generalized toric code**, a subclass of bivariate bicycle codes, defined by:

```math
\\begin{aligned}
f(x, y) = 1 + x + x^a y^b, \\quad
g(x, y) = 1 + y + x^c y^d
\\end{aligned}
```

### Topological Order Condition

A key condition [liang2025generalizedtoriccodestwisted](@cite) for these polynomials is:

```math
\\begin{aligned}
\\langle f(x, y) \\rangle \\cap \\langle g(x, y) \\rangle = \\langle f(x, y) g(x, y) \\rangle
\\end{aligned}
```

where ``\\langle p(x, y) \\rangle`` denotes the [ideal](https://en.wikipedia.org/wiki/Ideal_(ring_theory))
in R generated by ``p(x, y)``. This implies that ``f(x, y)`` and ``g(x, y)`` are coprime.

Consider the `[[396, 8, ≤ 26]]` Generalized Toric Code from Table IV of [liang2025generalizedtoriccodestwisted](@cite). The
TO condition is proved using ``Oscar.jl`` as follows:

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> R, (x, y, x⁻¹, y⁻¹) = polynomial_ring(GF(2), [:x, :y, :x⁻¹, :y⁻¹]);

julia> rels = [x*x⁻¹ - 1, y*y⁻¹ - 1];

julia> R_q = quo(R, rels)[1];

julia> f = 1 + x + x⁻¹*y⁻¹^3;

julia> g = 1 + y + x^3*y⁻¹;

julia> I = ideal(R_q, [f]);

julia> J = ideal(R_q, [g]);

julia> I_cap_J = intersect(I, J);

julia> I_times_J = ideal(R_q, [f*g]);

julia> I_cap_J == I_times_J
true

julia> is_coprime(f, g)
true
```

### Gröbner basis Computation

A useful computational technique involves computing the Gröbner basis for the
polynomials ``f'(x, y) = xf(x, y)`` and ``g'(x, y) = yg(x, y)`` to ensure non-negative
exponents. Alternatively, one may introduce auxiliary variables ``\\overline{x}, \\overline{y}``
to represent ``x^{-1}, y^{-1}`` and include the relations ``\\overline{x}x - 1`` and
``\\overline{y}y - 1`` in the Gröbner basis computation [liang2025generalizedtoriccodestwisted](@cite).

#### Example

Here is an example of computing the maximum logical dimension of Example 5
(−1, −4, 4, −1)-generalized toric code from [liang2025generalizedtoriccodestwisted](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford.ECC: max_xy_exponents;

julia> R, (x, y) = polynomial_ring(GF(2), ["x", "y"]);

julia> f = x*y^4 + x^2*y^4 + 1;

julia> g = y + y^2 + x^4;

julia> I = ideal(R, [f, g]);

julia> G = groebner_basis(I, ordering=lex([x,y])) # Eq. 51
Gröbner basis with elements
  1: y^20 + y^17 + 1
  2: x + y^16 + y^13 + y^12 + y^9 + y^2 + y
with respect to the ordering
  lex([x, y])

julia> H = groebner_basis(I, ordering=lex([y,x])) # Eq. 54
Gröbner basis with elements
  1: x^20 + x^18 + x^2 + x + 1
  2: y + x^18 + x^17 + x^8 + x^4 + 1
with respect to the ordering
  lex([y, x])

julia> a, b = max_xy_exponents(G);

julia> all_monomials = [x^i * y^j for i in 0:a-1 for j in 0:b-1] # Eq. 52
20-element Vector{FqMPolyRingElem}:
 1
 y
 y^2
 y^3
 y^4
 y^5
 y^6
 y^7
 y^8
 y^9
 y^10
 y^11
 y^12
 y^13
 y^14
 y^15
 y^16
 y^17
 y^18
 y^19

julia> k_max = 2*length(all_monomials)
40
```

### Parity Checks

The total number of physical qubits is ``n = 2*\\alpha\\beta``, corresponding to horizontal and
vertical edges in each unit cell. The parity-check matrices ``H_X`` and ``H_Z`` are constructed
following approach in Appendix B of [liang2025generalizedtoriccodestwisted](@cite). Qubits are
indexed row-by-row: for each `y`-coordinate, horizontal edges are listed first, then vertical edges.
Stabilizers are generated by translating the *origin* stabilizer, defined by the monomial supports of
`f` and `g`, across all ``(l_x, l_y)`` in ``0 ≤ l_x < \\beta``, ``0 ≤ l_y < \\alpha``. Translations
obey twisted boundary conditions determined by ``(\\alpha, \\beta, \\gamma)``, ensuring the matrices
retain a generalized cyclic structure.

The notable cases of Generalized toric codes include:

### Kitaev Toric Code

The Kitaev Toric code is defined by the Laurent polynomials ``f(x, y) = 1 + x`` and ``g(x, y) = 1 + y``. The
only independent monomial is 1, as all other monomials ``x^a y^b`` can be expressed as:

```math
\\begin{aligned}
    x^a y^b = a_1 + p(x, y)f(x, y) + q(x, y)g(x, y)
\\end{aligned}
```

where ``a_1 \\in \\mathbb{Z}_2`` and ``p(x, y), q(x, y) \\in R``. For instance: ``x^2 = 1 + (1 + x)(1 + x)``.

#### Example

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> R, (x,y) = laurent_polynomial_ring(GF(2), [:x, :y]);

julia> f = 1 + x;

julia> g = 1 + y;

julia> α1 = (0, 6);

julia> α2 = (3, 3);

julia> c = GeneralizedToric(f, g, α1, α2);

julia> code_n(c), code_k(c)
(36, 2)
```

### Color Code

The Color code is defined by the Laurent polynomials ``f(x, y) = 1 + x + xy`` and ``g(x, y) = 1 + y + xy``. The
independent monomials are 1 and x. Other monomials follow:

```math
\\begin{aligned}
    x^a y^b = a_1 + a_x x + p(x, y)f(x, y) + q(x, y)g(x, y)
\\end{aligned}
```

The code has ``k_{\\text{max}} = 4``, reflecting its structure as a direct sum of two Kitaev codes.

!!! note
    For simple polynomials, independent monomials can be identified manually. However, a systematic
    approach using **Gröbner basis** is necessary for general cases.

#### Example

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> R, (x, y) = laurent_polynomial_ring(GF(2), [:x, :y]);

julia> f = 1 + x + x*y;

julia> g = 1 + y + x*y;

julia> α1 = (0, 6);

julia> α2 = (3, 3);

julia> c = GeneralizedToric(f, g, α1, α2);

julia> code_n(c), code_k(c)
(36, 4)
```

### ``(-1, 3, 3, -1)``-Generalized Toric Code

The ``(-1, 3, 3, -1)``-Generalized Toric code corresponds to stabilizers in the Gross code
and ``(3, 3)``-BB code. The Laurent polynomials are:

```math
\\begin{aligned}
    f(x, y) = 1 + x + x^{-1}y^3, \\quad g(x, y) = 1 + y + x^3 y^{-1},
\\end{aligned}
```

#### Example

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> R, (x, y) = laurent_polynomial_ring(GF(2), [:x, :y]);

julia> f = 1 + x + x^-1*y^3;

julia> g = 1 + y + x^3*y^-1;

julia> α1 = (0, 12);

julia> α2 = (6, 0);

julia> c = GeneralizedToric(f, g, α1, α2);

julia> code_n(c), code_k(c)
(144, 12)
```

### ``(-1, -3, 3, -1)``-Generalized Toric Code

The ``(-1, -3, 3, -1)``-Generalized Toric code corresponds to the (3, -3)-BB code. The
Laurent polynomials are:

```math
\\begin{aligned}
    f(x, y) = 1 + x + x^{-1}y^{-3}, \\quad g(x, y) = 1 + y + x^3 y^{-1}.
\\end{aligned}
```

#### Example

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> R, (x, y) = laurent_polynomial_ring(GF(2), [:x, :y]);

julia> f = 1 + x + x^-1*y^-3;

julia> g = 1 + y + x^3*y^-1;

julia> α1 = (0, 12);

julia> α2 = (6, 0);

julia> c = GeneralizedToric(f, g, α1, α2);

julia> code_n(c), code_k(c)
(144, 12)
```

#### Example from Tables I-IV of [liang2025generalizedtoriccodestwisted](@cite)

Here is an example of `[[396, 8, ≤ 26]]` Generalized Toric Code from Table IV of [liang2025generalizedtoriccodestwisted](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> R, (x,y) = laurent_polynomial_ring(GF(2), [:x, :y]);

julia> f = 1 + x + x^-1*y^-3;

julia> g = 1 + y + x^3*y^-1;

julia> α1 = (0, 66);

julia> α2 = (3, 18);

julia> c = GeneralizedToric(f, g, α1, α2);

julia> code_n(c), code_k(c)
(396, 8)
```

Here is an example of `[[292, 18, 8]]` Generalized Toric Code from Appendix B of [liang2025generalizedtoriccodestwisted](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> R, (x,y) = laurent_polynomial_ring(GF(2), [:x, :y]);

julia> f = 1 + x + y^2;

julia> g = 1 + y + x^-4*y;

julia> α1 = (0, 73);

julia> α2 = (2, 32);

julia> c = GeneralizedToric(f, g, α1, α2);

julia> code_n(c), code_k(c)
(292, 18)
```

### Fields
    $TYPEDFIELDS
"""
struct GeneralizedToric <: AbstractCSSCode
    """Laurent polynomial over ``\\mathbb{F}_2`` defining horizontal–edge action of the X-type stabilizer"""
    f::LaurentMPolyWrap
    """Laurent polynomial over ``\\mathbb{F}_2`` defining vertical–edge action of the X-type stabilizer"""
    g::LaurentMPolyWrap
    """First lattice vector ``\\mathbf{a}_1 = (p_1, q_1)``, from which ``(\\alpha, \\beta, \\gamma)`` can
    be computed so that ``a_1 = (0, \\alpha)`` represents the same *generic* twisted torus under a unimodular transformation."""
    a1::Tuple{Int,Int}
    """Second lattice vector ``\\mathbf{a}_2 = (p_2, q_2)``, from which ``(\\alpha, \\beta, \\gamma)`` can
    be computed so that ``a_2 = (\\beta, \\gamma)`` represents the same *generic* twisted torus under a unimodular transformation."""
    a2::Tuple{Int,Int}

    function GeneralizedToric(f::LaurentMPolyWrap, g::LaurentMPolyWrap, a1::Tuple{Int,Int}, a2::Tuple{Int,Int})
        if a1[1] != 0
            α, β, γ, _, _ = _twisted_params(a1, a2)
            a1 = (0, α)
            a2 = (β, γ)
            return new(f, g, a1, a2)
        else
            return new(f, g, a1, a2)
        end
    end
end

function _twisted_params(a1::Tuple{Int,Int}, a2::Tuple{Int,Int})
    M = matrix(ZZ, 2, 2, [a1[1], a1[2], a2[1], a2[2]])
    H, U = hnf_with_transform(M)
    @assert(H == U*M)
    α = H[2,2]
    β = H[1,1]
    γ = H[1,2]
    return α, β, γ, H, U
end

function _monomial_terms(poly)
    coeffs = coefficients(poly)
    exps   = exponent_vectors(poly)
    terms = Tuple{Int,Int}[]
    for (c,e) in zip(coeffs, exps)
        if c != 0
            push!(terms, (Int(e[1]), Int(e[2])))
        end
    end
    return terms
end

function _move_index(i::Int, dx::Int, dy::Int, β::Int, γ::Int, n::Int, α::Int)
    dy_mod = mod(dy, α)
    i = mod(i + 2*β*dy_mod, n)
    if dx > 0
        for _ = 1:dx
            if mod(i,β) == (β-1)
                i = mod(i+1-(2*γ+1)*β, n)
            else
                i = mod(i+1,n)
            end
        end
    elseif dx < 0
        for _ = 1:(-dx)
            if mod(i,β) == 0
                i = mod(i-1+(2*γ+1)*β, n)
            else
                i = mod(i-1, n)
            end
        end
    end
    return i
end

function parity_matrix_xz(c::GeneralizedToric)
    α = c.a1[2]
    β = c.a2[1]
    γ = c.a2[2]
    f_terms = _monomial_terms(c.f)
    g_terms = _monomial_terms(c.g)
    n = 2*α*β
    cols = α*β
    base_horiz = 0
    base_vert  = β
    origin_av = Int[]
    for (ex,ey) in f_terms
        idx = _move_index(base_horiz, ex, ey, β, γ, n, α)
        push!(origin_av, idx)
    end
    for (ex,ey) in g_terms
        idx = _move_index(base_vert, ex, ey, β, γ, n, α)
        push!(origin_av, idx)
    end
    origin_av = unique(origin_av)
    origin_bp = Int[]
    for (ex,ey) in g_terms
        idx = _move_index(base_horiz, -ex, -ey, β, γ, n, α)
        push!(origin_bp, idx)
    end
    for (ex,ey) in f_terms
        idx = _move_index(base_vert, -ex, -ey, β, γ, n, α)
        push!(origin_bp, idx)
    end
    origin_bp = unique(origin_bp)
    HX = zeros(Int, n, cols)
    HZ = zeros(Int, n, cols)
    col = 1
    for lᵧ in 0:(α-1)
        for lₓ in 0:(β-1)
            for q in origin_av
                newq = _move_index(q, lₓ, lᵧ, β, γ, n, α)
                @assert 0 <= newq < n
                HX[newq+1, col] = 1
            end
            for q in origin_bp
                newq = _move_index(q, lₓ, lᵧ, β, γ, n, α)
                @assert 0 <= newq < n
                HZ[newq+1, col] = 1
            end
            col += 1
        end
    end
    return HX', HZ'
end

parity_matrix_x(c::GeneralizedToric) = parity_matrix_xz(c)[1]

parity_matrix_z(c::GeneralizedToric) = parity_matrix_xz(c)[2]

"""
    $TYPEDEF

Given a Gröbner basis `G` of polynomials over a finite field multivariate polynomial ring in variables
including `x` and `y`. It computes the maximum exponents of `x` and `y` appearing in any polynomial in
`G`. It assumes `G` is a vector of polynomials and that variables `x` and `y` exist in the parent ring.

#### Example

```jldoctest
julia> using Oscar; using QuantumClifford.ECC: max_xy_exponents;

julia> R, (x, y) = polynomial_ring(GF(2), [:x, :y]);

julia> f = x + x^2 + y^3;

julia> g = y + y^2 + x^3;

julia> I = ideal(R, [f, g]);

julia> W = groebner_basis(I, ordering=lex([x, y]), complete_reduction=true)
Gröbner basis with elements
  1: y^7 + y^6 + y^4 + y^2 + y
  2: x*y^2 + x*y + x + y^6 + y^3
  3: x^2 + x + y^3
with respect to the ordering
  lex([x, y])

julia> a, b = max_xy_exponents(W)
(2, 7)
```
"""
function max_xy_exponents(G::IdealGens{FqMPolyRingElem})
    vs = gens(parent(first(G)))
    xpos = findfirst(==(vs[1]), vs)
    ypos = findfirst(==(vs[2]), vs)
    nvs = length(vs)
    exps = []
    for p in G
        for e in exponent_vectors(p)
            evec = collect(e)
            while length(evec) < nvs
                push!(evec, 0)
            end
            push!(exps, (evec[xpos], evec[ypos]))
        end
    end
    max_x_exp = maximum(t[1] for t in exps)
    max_y_exp = maximum(t[2] for t in exps)
    return max_x_exp, max_y_exp
end

"""
$TYPEDSIGNATURES

Constructing two block group algebra codes by specifying the direct product to be used.
See also the more general [`two_block_group_algebra_codes`](@ref).

Two block group algebra codes are constructed by choosing a group (and specific generators),
then choosing two polynomials made out of these generators,
then piping these two polynomials as the elements of `1×1` matrices to the
lifted product code constructors.

The Hecke library, for which we already have an extension, provides for a fairly easy way
to construct such polynomials for many abelian and small groups.
See [`two_block_group_algebra_codes`](@ref) for those capabilities.

However, more esoteric groups can be specified as the direct product of other groups.
To support arbitrary direct products we use Oscar, which builds upon Hecke.
Oscar supports the **direct product** operation between two or more arbitrary **general** groups,
including non-abelian groups such as `alternating_group`, `dihedral_group`, `symmetric_group`,
and even arbitrary finitely presented groups (e.g., `free_group`). This capability is not
available in `Hecke.jl`. The 2BGA codes discovered in [lin2024quantum](@cite) rely on direct
products of two or more *general* groups, which necessitate the use of `Oscar.direct_product`.

This particular function is nothing more than a simple wrapper that takes care of argument conversions.
Of note, the polynomials here are given as lists of monomials.

Of course, if you are comfortable with Oscar, you can use [`two_block_group_algebra_codes`](@ref) directly.

See also: [`two_block_group_algebra_codes`](@ref), [`twobga_from_fp_group`](@ref)

## Examples

The [[56, 28, 2]] abelian 2BGA code from Appendix C, Table II in [lin2024quantum](@cite)
can be constructed using the direct product of two cyclic groups. Specifically, the group
`C₂₈` of order `l = 28` can be represented as `C₁₄ × C₂`, where the first group has order
`m = 14` and the second group has order `n = 2`.

```jldoctest directprod
julia> import Oscar: cyclic_group, small_group_identification, describe, order

julia> import Hecke: gens, quo, group_algebra, GF, one, direct_product, sub

julia> using QuantumClifford, QuantumClifford.ECC

julia> m = 14; n = 2;

julia> C₁₄ = cyclic_group(m);

julia> C₂ = cyclic_group(n);

julia> G = direct_product(C₁₄, C₂);

julia> GA = group_algebra(GF(2), G);

julia> x, s = gens(GA)[1], gens(GA)[3];

julia> a = [one(GA), x^7];

julia> b = [one(GA), x^7, s, x^8, s * x^7, x];

julia> c = twobga_from_direct_product(a, b, GA);

julia> order(G)
28

julia> code_n(c), code_k(c)
(56, 28)

julia> describe(G), small_group_identification(G)
("C14 x C2", (28, 4))
```

!!! danger
    When using the direct product, there isn't necessarily a unique set of generators.
    It is essential to verify that Oscar is providing you with the generators you expect,
    e.g. for a cycling group that you have the presentation `Cₘ = ⟨x, s | xᵐ = s² = xsx⁻¹s⁻¹ = 1⟩`.
    For situations where the generators provided by Oscar are not the ones you want,
    you can also use [`twobga_from_fp_group`](@ref) where you specify the group presentation directly.

As a verification that you have the correct generators,
`Oscar.sub` can be used to determine if `H` is a subgroup of `G` and to
confirm that both `C₁₄` and `C₂` are subgroups of `C₂₈`.

```jldoctest directprod
julia> order(gens(G)[1])
14

julia> order(gens(G)[3])
2

julia> x^14 == s^2 == x * s * x^-1 * s^-1
true

julia> H, _  = sub(G, [gens(G)[1], gens(G)[3]]);

julia> H == G
true
```
"""
function twobga_from_direct_product(a_elts::VectorDirectProductGroupElem, b_elts::VectorDirectProductGroupElem, F2G::DirectProductGroupAlgebra)
    a = sum(F2G(x) for x in a_elts)
    b = sum(F2G(x) for x in b_elts)
    c = two_block_group_algebra_codes(a,b)
    return c
end

#=============================================================================#
# Assists in cleanly translating into the grid-block model.
@inline tessellate(space, tile) = tile .* cld.(space, tile)

# For use whenever KA.@index(Global, NTuple) is unavailable.
# At the moment, JET always complains unless unsafe_indices = true is set.
@inline global_index(block_index, block_dim, thread_index) =
    (block_index .- one(eltype(block_index))) .* block_dim .+ thread_index

# This would have been called "map" but that name is already reserved.
KA.@kernel inbounds = true unsafe_indices = true function kernel_transform!(
    f!, target, @Const(auxiliary)
    )

    global_position = global_index(
        KA.@index(Group, NTuple), KA.@groupsize(), KA.@index(Local, NTuple)
        )
    f!(target, auxiliary, global_position)

end

# CAUTION: Requires block_size == length(buffer) == prod(KA.@groupsize())
# CAUTION: Requires unsafe_indices = true if num_active_threads < block_size
# TODO: Overhaul once __ctx__ is no longer necessary for runtime queries.
# TODO: Revisit once warp level primitives are supported.
@inline function shared_memory_reduce!(
    f, buffer::AbstractArray{T}, value::T, index::Integer, ::Val{block_size}
    ) where {T, block_size}

    @inbounds buffer[index] = value

    # This branch is a power of 2, take the quick route.
    if count_ones(block_size) == one(block_size)

    # This is messy but only for-loop unrolling is supported.
    KA.Extras.@unroll for bit = one(block_size) : trailing_zeros(block_size)
        stride = KA.@uniform ((2)^(trailing_zeros(block_size) - bit))
        # The call to KA.@synchronize is ALL or NOTHING.
        KA.@synchronize()
        if index <= stride
            @inbounds value = f(value, buffer[index + stride])
            @inbounds buffer[index] = value
        end
    end

    else

    current = KA.@uniform (block_size)
    # TODO: Unroll this branch should it become possible.
    while current > one(current)
        # The call to KA.@synchronize is ALL or NOTHING.
        KA.@synchronize()
        # This splits into even/odd steps. Should target SALU.
        if iseven(current)
            current = KA.@uniform (current >> one(current))
            if index <= current
                @inbounds value = f(value, buffer[index + current])
                @inbounds buffer[index] = value
            end
        else
            current = KA.@uniform ((current >> one(current)) + one(current))
            # The strict inequality is intentional.
            if index < current
                @inbounds value = f(value, buffer[index + current])
                @inbounds buffer[index] = value
            end
        end
    end

    end
    return value

end

#==============================================================================
COMMON TRANSFORMATIONS
==============================================================================#
# Anonymous functions trigger recompilation. Hence, Separate them out.

@inline function mod_4_sum!(target, auxiliary, global_position)
    @inbounds i = global_position[1]
    if i <= length(target)
        j = ifelse(length(auxiliary) > 1, i, 1)
        @inbounds target[i] = (target[i] + auxiliary[j]) & 0x3
    end
end

@inline function mod_4_identity!(target, auxiliary, global_position)
    @inbounds i = global_position[1]
    if i <= length(target)
        @inbounds target[i] &= 0x3
    end
end
#=============================================================================#

xz2str(x,z) = join(toletter[e] for e in zip(x,z))

function xz2str_limited(x,z, limit=50)
    tupl = collect(zip(x,z))
    n = length(tupl)
    if (ismissing(limit) || limit >= n)
        return xz2str(x, z)
    end
    padding = limit÷2
    return join(toletter[tupl[i]] for i in 1:padding) * "⋯" * join(toletter[tupl[i]] for i in (n-padding):n)
end

_show(io::IO, p::PauliOperator, limit=50) = print(io, ["+ ","+i","- ","-i"][p.phase[]+1]*xz2str_limited(xbit(p),zbit(p), limit))

function Base.show(io::IO, p::PauliOperator)
    if get(io, :compact, false) | haskey(io, :typeinfo)
        _show(io, p, 10)
    elseif get(io, :limit, false)
        sz = displaysize(io)
        _show(io, p, max(2, sz[2]-7))
    else
        _show(io, p, missing)
    end
end

function _show(io::IO, t::Tableau, limit=50, limit_vertical=20)
    padding = max(1,limit_vertical÷2-3)
    n = size(t,1)
    range = 1:n
    if (!ismissing(limit_vertical) && limit_vertical < n+3)
        range = [1:padding; missing; (n-padding+2):n]
    end
    for i in range
        if ismissing(i)
            print(io," ⋮\n")
        else
            _show(io, t[i], max(1,limit-7))
            i!=n && println(io)
        end
    end
end

function Base.show(io::IO, t::Tableau)
    if get(io, :compact, false) | haskey(io, :typeinfo)
        r,q = size(t)
        print(io, "Tableaux $r×$q")
    elseif get(io, :limit, false)
        sz = displaysize(io)
        _show(io, t, sz[2], sz[1])
    else
        _show(io, t, missing, missing)
    end
end

function Base.show(io::IO, s::Stabilizer)
    if get(io, :compact, false) | haskey(io, :typeinfo)
        r,q = size(s)
        print(io, "Stabilizer $r×$q")
    else
        show(io, tab(s))
    end
end

function Base.show(io::IO, s::MixedStabilizer)
    if get(io, :compact, false) | haskey(io, :typeinfo)
        r,q = size(stabilizerview(s))
        print(io, "MixedStabilizer $r×$q")
    else
        show(io, stabilizerview(s))
    end
end

function Base.show(io::IO, d::Destabilizer)
    if get(io, :compact, false) | haskey(io, :typeinfo)
        r,q = size(stabilizerview(d))
        print(io, "Destablizer $r×$q")
    elseif get(io, :limit, false)
        h,w = displaysize(io)
        println(io, "𝒟ℯ𝓈𝓉𝒶𝒷" * "━"^max(min(w-9,size(tab(d),2)-4),0))
        _show(io, tab(destabilizerview(d)), w, h÷2)
        println(io, "\n𝒮𝓉𝒶𝒷" * "━"^max(min(w-7,size(tab(d),2)-2),0))
        _show(io, tab(stabilizerview(d)), w, h÷2)
    else
        println(io, "𝒟ℯ𝓈𝓉𝒶𝒷" * "━"^max(size(tab(d),2)-4,0))
        _show(io, tab(destabilizerview(d)), missing, missing)
        println(io, "\n𝒮𝓉𝒶𝒷" * "━"^max(size(tab(d),2)-2,0))
        _show(io, tab(stabilizerview(d)), missing, missing)
    end
end

function Base.show(io::IO, d::MixedDestabilizer)
    r = rank(d)
    q = nqubits(d)
    if get(io, :compact, false) | haskey(io, :typeinfo)
        print(io, "MixedDestablizer $r×$q")
    elseif get(io, :limit, false)
        h,w = displaysize(io)
        println(io, "𝒟ℯ𝓈𝓉𝒶𝒷" * "━"^max(min(w-9,size(tab(d),2)-4),0))
        _show(io, tab(destabilizerview(d)), w, h÷4)
        if r != q
            println(io)
            println(io, "𝒳ₗ" * "━"^max(min(w-5,size(tab(d),2)),0))
            _show(io, tab(logicalxview(d)), w, h÷4)
        end
        println(io)
        println(io, "𝒮𝓉𝒶𝒷" * "━"^max(min(w-7,size(tab(d),2)-2),0))
        _show(io, tab(stabilizerview(d)), w, h÷4)
        if r != q
            println(io)
            println(io, "𝒵ₗ" * "━"^max(min(w-5,size(tab(d),2)),0))
            _show(io, tab(logicalzview(d)), w, h÷4)
        end
    else
        println(io, "𝒟ℯ𝓈𝓉𝒶𝒷" * "━"^max(size(tab(d),2)-4,0))
        _show(io, tab(destabilizerview(d)), missing, missing)
        if r != q
            println(io)
            println(io, "𝒳ₗ" * "━"^max(size(tab(d),2),0))
            _show(io, tab(logicalxview(d)), missing, missing)
        end
        println(io)
        println(io, "𝒮𝓉𝒶𝒷" * "━"^max(size(tab(d),2)-2,0))
        _show(io, tab(stabilizerview(d)), missing, missing)
        if r != q
            println(io)
            println(io, "𝒵ₗ" * "━"^max(size(tab(d),2)),0)
            _show(io, tab(logicalzview(d)), missing, missing)
        end
    end
end

function _show(io::IO, c::CliffordOperator, limit=50, limit_vertical=20)
    n = nqubits(c)
    nwidth = Int(ceil(log10(n+1)))
    _limit = limit-nwidth-10
    range = 1:n
    if (!ismissing(limit_vertical) && limit_vertical < n)
        padding = limit_vertical÷4
        range = [1:padding-1; missing; (n-padding+2):n]
    end
    for i in range
        if ismissing(i)
            print(" ⋮\n")
            continue
        end
        print(io, "X"*digits_substr(i,nwidth)*" ⟼ ")
        _show(io, tab(c)[i], _limit)
        println(io)
    end
    for i in range
        if ismissing(i)
            print(" ⋮\n")
            continue
        end
        print(io, "Z"*digits_substr(i,nwidth)*" ⟼ ")
        _show(io, tab(c)[i+n], _limit)
        i!=n && println(io)
    end
end

function Base.show(io::IO, c::CliffordOperator)
    if get(io, :compact, false) | haskey(io, :typeinfo)
        q = nqubits(c)
        print(io, "CliffordOperator on $q qubits")
    elseif get(io, :limit, false)
        sz = displaysize(io)
        _show(io, c, sz[2], sz[1])
    else
        _show(io, c, missing, missing)
    end
end

"""Compute all possible new states after the application of the given operator. Reports the probability of each one of them. Deterministic (as it reports all branches of potentially random processes), part of the Perturbative Expansion interface."""
function applybranches end

"""Compute all possible new states after the application of the given noise model. Reports the probability of each one of them. Deterministic (as it reports all branches of potentially random processes), part of the Noise interface."""
function applynoise_branches end

#TODO is the use of copy here necessary?
#TODO `copy` does not preserve the `fastcolumn` vs `fastrow` effect
applybranches(state, op; max_order=1) = applybranches(operatordeterminism(typeof(op)), state, op; max_order=max_order)

function applybranches(::DeterministicOperatorTrait, state, op; max_order=1)
    [(applywstatus!(copy(state),op)...,1,0)]
end

function applybranches(::NondeterministicOperatorTrait, state, op; max_order=1)
    throw(ArgumentError(lazy"""
        You are trying to apply a non-deterministic operator $(typeof(op)) in a perturbative expansion, but this particular operator does not have a `applybranches` method defined for it.
        If this is an operator type that you have defined yourself, please either implement an `applybranches` method for it.
        If you know for a fact that this method is deterministic, then you can opt into the default by giving it a `DeterministicOperatorTrait` trait, e.g. `operatordeterminism(::Type{YourType}) = DeterministicOperatorTrait()`.
        If you were not working with custom operators, please report this as a bug in QuantumClifford.jl -- we probably have not gotten around to expanding this functionality to that particular operator.
    """))
end

function petrajectory(state, circuit; branch_weight=1.0, current_order=0, max_order=1)
    if size(circuit)[1] == 0
        return fill(zero(branch_weight), length(registered_statuses)-1)
    end
    next_op = circuit[1]
    rest_of_circuit = circuit[2:end]

    status_probs = fill(zero(branch_weight), length(registered_statuses)-1)

    for (i,(newstate, status, prob, order)) in enumerate(applybranches(state, next_op, max_order=max_order-current_order))
        if status==continue_stat # TODO is the copy below necessary?
            out_probs = petrajectory(copy(newstate), rest_of_circuit,
                branch_weight=branch_weight*prob, current_order=current_order+order, max_order=max_order)
            status_probs .+= out_probs
        else
            status_probs[status.status] += prob*branch_weight
        end
    end

    return status_probs
end

function petrajectory_keep(state, circuit; branch_weight=1.0, current_order=0, max_order=1) # TODO a lot of repetition with petrajectory - dry out
    A = Accumulator{Tuple{typeof(state),CircuitStatus},typeof(branch_weight)}
    if size(circuit)[1] == 0
        return A()
    end
    next_op = circuit[1]
    rest_of_circuit = circuit[2:end]

    dict = A()

    for (i,(newstate, status, prob, order)) in enumerate(applybranches(state, next_op, max_order=max_order-current_order))
        if status==continue_stat # TODO is the copy below necessary?
            out_dict = petrajectory_keep(copy(newstate), rest_of_circuit,
                branch_weight=branch_weight*prob, current_order=current_order+order, max_order=max_order)
            DataStructures.merge!(dict, out_dict)
        else
            DataStructures.inc!(dict, (newstate,status), prob*branch_weight)
        end
    end

    return dict
end

"""Run a perturbative expansion to a given order. This is the main public function for the perturbative expansion approach.

See also: [`pftrajectories`](@ref), [`mctrajectories`](@ref)"""
function petrajectories(initialstate, circuit; branch_weight=1.0, max_order=1, keepstates::Bool=false)
    for circuit_op in circuit
        if(_sentinel_maximum(_sentinel_affectedqubits(circuit_op)) > nqubits(initialstate))
            throw(ArgumentError(lazy"""Qubit out of bounds for $circuit_op. Attempting to access a $(nqubits(initialstate)) qubit state at index $(_sentinel_maximum(_sentinel_affectedqubits(circuit_op)))"""))
        end
    end
    if keepstates
        return petrajectory_keep(initialstate, circuit; branch_weight=branch_weight, current_order=0, max_order=max_order)
    else
        status_probs = petrajectory(initialstate, circuit; branch_weight=branch_weight, current_order=0, max_order=max_order)
        return Dict([CircuitStatus(i)=>status_probs[i] for i in eachindex(status_probs)])
    end
end

# Here be dragons...

using SumTypes
using InteractiveUtils: subtypes

"""An intermediary when we want to create a new concrete type in a macro."""
struct SymbolicDataType
    name::Symbol
    types#::Core.SimpleVector
    fieldnames
    originaltype
    originaltype_parameterized
end
_header(s) = s
_header(s::SymbolicDataType) = s.name
_symbol(s) = Symbol(s)
_symbol(s::SymbolicDataType) = s.name
_types(s) = s.types
_fieldnames(s) = fieldnames(s)
_fieldnames(s::SymbolicDataType) = s.fieldnames
_originaltype(s) = s
_originaltype(s::SymbolicDataType) = s.originaltype
_originaltype_parameterized(s) = s
_originaltype_parameterized(s::SymbolicDataType) = s.originaltype_parameterized

"""
```
julia> make_variant(sCNOT)
:(sCNOT(::Int64, ::Int64))
```
"""
function make_variant(type::Union{DataType,SymbolicDataType})
    Expr(:call, _symbol(type), [:(::$t) for t in _types(type)]...)
end

"""
```
julia> make_variant_deconstruct(sCNOT, :apply!, (:s,))
:(sCNOT(q1, q2) => apply!(s, sCNOT(q1, q2)))
```
"""
function make_variant_deconstruct(type::Union{DataType,SymbolicDataType}, call, preargs=(), postargs=())
    variant = Expr(:call, _symbol(type), _fieldnames(type)...)
    original = :(($(_originaltype_parameterized(type)))($(_fieldnames(type)...)))
    #:($variant => begin $(Expr(:call, call, preargs..., original, postargs...)); nothing end) # useful when you are searching for type instabilities due to inconsistent output types for a method (usually also pointing to a method not following the conventions of the API)
    :($variant => $(Expr(:call, call, preargs..., original, postargs...)))
end

"""
```
julia> make_sumtype([sCNOT])
quote
    @sum_type CompactifiedGate :hidden begin
        sCNOT(::Int64, ::Int64)
    end
end
```
"""
function make_sumtype(concrete_types)
    return quote
        @sum_type CompactifiedGate :hidden begin
            $([make_variant(t) for t in concrete_types if isa(t, DataType) || isa(t, SymbolicDataType)]...)
        end
    end
end

"""
```
julia> make_sumtype_method([sCNOT], :apply!, (:s,))
quote
    function QuantumClifford.apply!(s, g::CompactifiedGate)
        @cases g begin
            sCNOT(q1, q2) => apply!(s, sCNOT(q1, q2))
        end
    end
end
"""
function make_sumtype_method(concrete_types, call, preargs=(), postargs=())
    return quote
        function QuantumClifford.$call($(preargs...), g::CompactifiedGate, $(postargs...))
            @cases g begin
                $([make_variant_deconstruct(t, call, preargs, postargs) for t in concrete_types if isa(t, DataType) || isa(t, SymbolicDataType)]...)
                #_ => @error "something wrong is happening when working with $(g) -- you are probably getting wrong results, please report this as a bug" # this being present ruins some safety guarantees, but it is useful for debugging
            end
        end
    end
end

"""
```
julia> make_sumtype_variant_constructor(sCNOT)
:(CompactifiedGate(g::sCNOT) = begin
    (CompactifiedGate').sCNOT(g.q1, g.q2)
end)
```
"""
function make_sumtype_variant_constructor(type)
    if isa(type, DataType) || isa(type, SymbolicDataType)
        return :( CompactifiedGate(g::$(_header(type))) = CompactifiedGate'.$(_symbol(type))($([:(g.$n) for n in _fieldnames(type)]...)) )
    else
        return :() # this is taken care of by a default constructor that also warns about the failure to compactify
    end
end

genericsupertypeparams(t) = :body ∈ propertynames(t) ? genericsupertypeparams(t.body) : t

"""Returns a tuple of all concrete subtypes and all UnionAll non-abstract subtypes of a given type."""
function get_all_subtypes(type)
    if !isabstracttype(type)
        if isa(type, DataType)
            isbitstype(type) || @debug "$type will be problematic during compactification"
            return [type], []
        elseif isa(type, UnionAll)
            return [], [type]
        else
            @error "The gate compiler has encountered a type that it can not handle: $type. The QuantumClifford library should continue functioning, but potentially at degraded performance. Please report this as a performance bug."
        end
    else
        return Iterators.flatten.(zip(get_all_subtypes.(subtypes(type))...))
    end
end

module_of_type(t::UnionAll) = genericsupertypeparams(t).name.module
module_of_type(t::DataType) = t.name.module

function make_all_sumtype_infrastructure_expr(t::DataType, callsigs)
    concrete_types, unionall_types = get_all_subtypes(t)
    concrete_types = collect(Any, concrete_types)
    concrete_types = Any[t for t in concrete_types if module_of_type(t)==QuantumClifford]
    unionall_types = Any[t for t in unionall_types if module_of_type(t)==QuantumClifford]
    concretifier_workarounds_types = [] # e.g. var"ClassicalXOR_{2}" generated as a workaround for providing a concrete type for ClassicalXOR{N}
    concretifier_additional_constructors = [] # e.g. CompactifiedGate(g::ClassicalXOR{2}) = CompactifiedGate'.var"ClassicalXOR_{2}"(g.bits, g.store)
    for ut in unionall_types
        names, generated_concretetypes, generated_variant_constructors = concretifier(ut)
        append!(concretifier_workarounds_types, generated_concretetypes)
        append!(concrete_types, names)
        append!(concretifier_additional_constructors, generated_variant_constructors)
        push!(concrete_types, ut) # fallback
    end
    sumtype = make_sumtype(concrete_types)
    @debug "compiling a total of $(length(concrete_types)) concrete types"
    constructors = make_sumtype_variant_constructor.(concrete_types)
    methods = [make_sumtype_method(concrete_types, call, preargs, postargs) for (call, preargs, postargs) in callsigs]
    modulename = gensym(:CompactifiedGate)
    return quote
        #module $(modulename)
        #using QuantumClifford
        #import QuantumClifford: CompactifiedGate, # todo
        $(concretifier_workarounds_types...)
        $(sumtype.args...) # defining the sum type
        $(constructors...) # creating constructors for the sumtype which turn our concrete types into instance of the sum type
        $(concretifier_additional_constructors...) # creating constructors for the newly generated "workaround" concrete types
        :(CompactifiedGate(g::AbstractOperation) = (@warn "The operation is of a type that can not be unified, defaulting to slower runtime dispatch" typeof(g); return g) )
        $(methods...)
        #end
    end
end

function concrete_typeparams(t)
    @debug "The gate compiler is not able to concretify the type $t. Define a `concrete_typeparams` method for this type to improve performance."
    return ()
end

function concretifier(t)
    names = []
    generated_concretetypes = []
    generated_variant_constructors = []
    for typeparams in concrete_typeparams(t)
        name = Symbol(t,"{",typeparams,"}")
        parameterized_type = t{typeparams...}
        ftypes = parameterized_type.types
        fnames = fieldnames(t)
        push!(names, SymbolicDataType(name, ftypes, fnames, t, parameterized_type))
        push!(generated_concretetypes, :(
            struct $(name)
                $([:($n::$t) for (n,t) in zip(fnames,ftypes)]...)
            end
        ))
        push!(generated_variant_constructors, make_concretifier_sumtype_variant_constructor(parameterized_type, name))
    end
    return names, generated_concretetypes, generated_variant_constructors
end

function make_concretifier_sumtype_variant_constructor(parameterized_type, variant_name)
    return :( CompactifiedGate(g::$(parameterized_type)) = CompactifiedGate'.$(variant_name)($([:(g.$n) for n in _fieldnames(parameterized_type)]...)) )
end

function make_all_sumtype_infrastructure()
    make_all_sumtype_infrastructure_expr(AbstractOperation,
        [
            (:apply!, (:(s::Register),), ()),
            (:applywstatus!, (:(s::Register),), ()),
            (:apply!, (:(s::PauliFrame),), ()),
            (:applywstatus!, (:(s::PauliFrame),), ()),
            (:affectedqubits, (), ()),
            (:affectedbits, (), ()),
        ]
    ) |> eval
end

"""
Convert a list of gates to a more optimized "sum type" format which permits faster dispatch.

Generally, this should be called on a circuit before it is used in a simulation.
"""
function compactify_circuit(circuit)
    return CompactifiedGate.(circuit)
end


##
# `concrete_typeparams` annotations for the parameteric types we care about
##

function concrete_typeparams(t::Type{ClassicalXOR})
    return 2:16
end

function concrete_typeparams(t::Type{NoiseOp})
    return [
        [(UnbiasedUncorrelatedNoise{Float64}, i) for i in 1:8];
        [(PauliNoise{Float64}, i) for i in 1:8];
    ]
end

function concrete_typeparams(::Type{PauliMeasurement})
    return [
        (Array{UInt8,0}, Vector{UInt64}),
    ]
end


# XXX This has to happen after defining all the `concrete_typeparams` methods

make_all_sumtype_infrastructure()

using Graphs: inneighbors, has_edge, rem_edge!, add_edge!

"""
Toggle the edge of a graph between vertices v1 and v2.

Uses `rem_edge!` and `add_edge!`
"""
function toggle_edge!(g, v1::Int, v2::Int)
    if has_edge(g, v1, v2)
        rem_edge!(g, v1, v2)
    else
        add_edge!(g, v1, v2)
    end
    return g
end

"""
Perform Local Complementation repeatedly to transfer the VOP of src to the target.

See also [`local_comp!`](@ref)
"""
function remove_vop!(gs::GraphState, src::Int, target::Int)
    src_seq = IP_SQRTX_DECOMPOSITION_TABLE[vops(gs)[src]]

    if !has_edge(graph(gs), src, target)
        throw("Target qubit must be a neighbor of the source qubit")
    end

    # Perform the local complementation operation to remove generators in the decomposition one-by-one
    for v in src_seq
        if v isa sInvPhase
            # perform local_comp on the target qubit to remove sInvPhase
            local_comp!(gs, target)
        elseif v isa sSQRTX
            # perform local_comp on the source qubit to remove sSQRTX
            local_comp!(gs, src)
        end
    end

    return gs
end

"""
Perform local complementation on pure graph
"""
function local_comp!(g, id::Int)
    # inneighbors or outneighbors shouldn't really matter because the graph is undirected
    nghbr = inneighbors(g, id)
    for i1 in eachindex(nghbr)
        for i2 in i1+1:length(nghbr)
            toggle_edge!(g, nghbr[i1], nghbr[i2])
        end
    end
    return g
end

"""
Perform local complementation about index id while maintaining the represented quantum state unchanged.
"""
function local_comp!(gs::GraphState{G, SingleQubitOperator} where G, id::Int)
    local_comp!(graph(gs), id)
    # Tweak the VOPs to make the resulting quantum state equivalent
    # See Theorem 3 and Corollary 1 in the paper
    nghbr = inneighbors(graph(gs), id)
    for n in nghbr
        _apply_vop_right!(vops(gs), sPhase(n))
    end
    _apply_vop_right!(vops(gs), sInvSQRTX(id))
    return gs
end

"""
A helper function that applies `ISOLATED_CPHASE_TABLE`.

You should make sure it's suitable to directly copy the result from lookup table. This is the case if either
- vertices are completely isolated
- VOPs of vertices which have non-operand neighbors are all in Z_COMMUTATION_SUBGROUP

An example of the second case is

U₁ = sHadamard, U₂ = sInvPhase

and q2 is connected to some other vertex while q1 has no neighbors except potentially q2.
"""
function apply_isolated_cphase_lookup_table!(gs::GraphState, q1::Int, q2::Int)
    g = graph(gs)

    vs = vops(gs)
    r = ISOLATED_CPHASE_TABLE[(has_edge(g, q1, q2), vs[q1], vs[q2])]
    vs[q1], vs[q2] = vops(r)[1], vops(r)[2]
    # set the edge according to lookup table r
    if has_edge(graph(r), 1, 2) & !has_edge(g, q1, q2)
        add_edge!(g, q1, q2)
    end
    if !has_edge(graph(r), 1, 2) & has_edge(g, q1, q2)
        rem_edge!(g, q1, q2)
    end
end

function apply!(gs::GraphState, gate::sCPHASE)
    # as a convention, we call U₁, U₂ the VOPs of q1, q2 respectively
    q1, q2 = affectedqubits(gate)
    g = graph(gs)

    # The algorithm wants to end up in either of the two cases
    # 1. Fast path: both U₁, U₂ ∈ Z_COMMUTATION_SUBGROUP. In that case we can just toggle the edge between q1, q2.
    # 2. Fallback: for each of the U₁, U₂, it is either
    #    - ∈ Z_COMMUTATION_SUBGROUP
    #    - or, its neighbor is ∈ {q1, q2}
    #    then we can apply the ISOLATED_CPHASE_TABLE directly (see the paper for details on why)


    # In theory we can always apply the lookup table as case 2 includes case 1.
    # However, case 1 is retianed for performance consideration (1.5x performance penalty)
    # To always use fallback route, one can simply write:
    #
    # for q in [q1, q2, q1]
    #     targets = filter(x-> x ∉ [q1, q2], inneighbors(g, q))
    #     if !isempty(targets)
    #         remove_vop!(gs, q, targets[1])
    #     end
    # end
    #
    # apply_isolated_cphase_lookup_table!(gs, q1, q2)
    #
    # We can investigate the performance difference in the future

    if has_edge(g, q1, q2)
        # If q1 and q2 are connected, use q2 as a swapping partner of q1 to transfer VOPs of q1 to q2
        remove_vop!(gs, q1, q2)

        # now try remove the VOP of q2 as well

        # find, after the removal of q1's VOP, if q2 has any non-operand neighbors
        nghbr = inneighbors(g, q2)
        target_id = findfirst(x -> x != q1, nghbr)

        if !isnothing(target_id)
            # If there is at least one non-operand neighbor, remove q2's VOP as well.

            # It's guaranteed that after this step, U₁ ∈ Z_COMMUTATION_SUBGROUP.
            # Because `local_comp!` will only introduce sInvPhase ∈ Z_COMMUTATION_SUBGROUP to non-src and non-target neighbors.
            remove_vop!(gs, q2, nghbr[target_id])

            # in which case we are sure both U₁, U₂ ∈ Z_COMMUTATION_SUBGROUP,
            # and we could just toggle the edge between them (fast path)
            toggle_edge!(g, q1, q2)
        else
            # If we don't have a non-operand swapping partner for q2, the VOP of q1 is identity, and q2 is not connected to other qubits,
            # so we could use the lookup table (fallback path)
            apply_isolated_cphase_lookup_table!(gs, q1, q2)
        end
   else
        # try reduce both U₁, U₂ to identity
        for q in (q1,q2)
            # non-operand neighbors
            nghbr = inneighbors(g, q)
            target_id = findfirst(x-> (x != q1) && (x != q2), nghbr)
            # since q1 and q2 are disconnected, when non-operand neighbor is empty, it means the qubit is truly isolated
            # and any later local complementation won't change this. Therefore, we are safe to do a one-pass [q1, q2] removal above
            # instead of a general [q1, q2, q1] if we are dealing with the general case.
            if !isnothing(target_id)
                remove_vop!(gs, q, nghbr[target_id])
            end
        end

        # in the fallback path, apply the lookup table
        apply_isolated_cphase_lookup_table!(gs, q1, q2)
   end

   return gs
end

@testitem "PureNonClifford Circuit Simulation" tags=[:non_clifford] begin
    using QuantumClifford
    using QuantumClifford.PureNonClifford
    import QuantumClifford.PureNonClifford:
        get_gate_decomposition,
        CliffordGateDecompositionCache,
        lrcost, stabilizer_extent

    @testset "Pure Clifford Circuit" begin
        circuit_clifford = [sHadamard(1), sCNOT(1,2), sZ(1)]

        result = emtrajectories(circuit_clifford, 2; trajectories=50, delta=0.1, verbose=false)
        @test result.simulation_cost == 1
        @test result.approximation_error == 0.0
        @test size(measurements(result), 1) == 50
    end

    @testset "Mixed Circuit" begin
        circuit_mixed = [sHadamard(1), sPhase(1), sCNOT(1,2)]

        result = emtrajectories(circuit_mixed, 2; trajectories=30, delta=0.2, verbose=false)
        @test result.simulation_cost >= 1
        @test size(measurements(result), 1) == 30
    end

    @testset "T-Gate Simulation" begin
        circuit_T = [sHadamard(1), sT(1), sHadamard(1)]
        result_T = emtrajectories(circuit_T, 1; trajectories=100, delta=0.1, verbose=false)

        expected_xi_T = (cos(π/8) + tan(π/8)*sin(π/8))^2
        expected_cost_T = ceil(Int, 1 + expected_xi_T / 0.1^2)

        @test result_T.simulation_cost > 1
        @test result_T.simulation_cost <= expected_cost_T
        @test result_T.approximation_error ≈ 0.1 atol=0.01
    end

    @testset "Multiple T-Gates" begin
        circuit_3T = [sT(1), sT(1), sT(1)]
        result_3T = emtrajectories(circuit_3T, 1; trajectories=50, delta=0.1, verbose=false)

        expected_xi_T = (cos(π/8) + tan(π/8)*sin(π/8))^2
        expected_xi_3T = expected_xi_T^3
        expected_cost_3T = ceil(Int, 1 + expected_xi_3T / 0.1^2)

        @test result_3T.simulation_cost <= expected_cost_3T
    end

    @testset "CCZ Gate Simulation" begin
        circuit_CCZ = [
            sHadamard(1), sHadamard(2), sHadamard(3),
            sCCZ(1, 2, 3),
            sHadamard(1), sHadamard(2), sHadamard(3)
        ]
        result_CCZ = emtrajectories(circuit_CCZ, 3; trajectories=50, delta=0.1, verbose=false)

        expected_xi_CCZ = 16.0/9.0
        expected_cost_CCZ = ceil(Int, 1 + expected_xi_CCZ / 0.1^2)

        @test result_CCZ.simulation_cost > 1
        @test result_CCZ.simulation_cost <= expected_cost_CCZ
    end

    @testset "Error Handling" begin
        @test_throws ArgumentError emtrajectories([], 1)
        @test_throws ArgumentError emtrajectories([sHadamard(1)], 0)
        @test_throws ArgumentError emtrajectories([sHadamard(1)], 1; trajectories=-1)
        @test_throws ArgumentError emtrajectories([sHadamard(1)], 1; delta=1.5)

        circuit_invalid = [sHadamard(5)]
        @test_throws ArgumentError emtrajectories(circuit_invalid, 2)
    end

    @testset "Cost Estimation" begin
        circuit = [sHadamard(1), sT(1)]
        deltas = [0.5, 0.2, 0.1, 0.05]

        for delta in deltas
            result = emtrajectories(circuit, 1; trajectories=30, delta=delta, verbose=false)
            xi_T = (cos(π/8) + tan(π/8)*sin(π/8))^2
            bound = ceil(Int, 1 + xi_T / delta^2)

            @test result.simulation_cost <= bound
            @test result.approximation_error ≈ delta atol=0.02
        end
    end

    @testset "nqubits Interface" begin
        t = sT(1)
        @test nqubits(t) == 1

        ccz = sCCZ(1, 2, 3)
        @test nqubits(ccz) == 3
    end

    @testset "isclifford for non-Clifford gates" begin
        @test isclifford(sT(1)) == false
        @test isclifford(sCCZ(1, 2, 3)) == false
    end

    @testset "AbstractNonCliffordOperator" begin
        @test sT(1) isa QuantumClifford.AbstractNonCliffordOperator
        @test sCCZ(1, 2, 3) isa QuantumClifford.AbstractNonCliffordOperator
        @test sT(1) isa QuantumClifford.AbstractOperation
        @test !(sHadamard(1) isa QuantumClifford.AbstractNonCliffordOperator)
    end

    @testset "stabilizer_extent Trait" begin
        @test stabilizer_extent(sHadamard(1)) == 1.0
        @test stabilizer_extent(sCNOT(1, 2)) == 1.0

        expected_xi_T = (cos(π/8) + tan(π/8)*sin(π/8))^2
        @test stabilizer_extent(sT(1)) ≈ expected_xi_T rtol=0.001

        expected_xi_CCZ = 16.0/9.0
        @test stabilizer_extent(sCCZ(1, 2, 3)) ≈ expected_xi_CCZ rtol=0.001
    end

    @testset "T Gate Decomposition" begin
        decomp = get_gate_decomposition(sT(1))
        @test decomp.gate_type == :T
        @test length(decomp.coefficients) == 2
        @test decomp.target_qubits == [1]
    end

    @testset "CCZ Gate Decomposition" begin
        decomp = get_gate_decomposition(sCCZ(1, 2, 3))
        @test decomp.gate_type == :CCZ
        @test length(decomp.coefficients) == 8
        @test decomp.target_qubits == [1, 2, 3]
    end

    @testset "Pure Clifford Circuit Cost" begin
        circuit = [sHadamard(1), sCNOT(1, 2), sZ(1)]
        cost_info = lrcost(circuit; delta=0.1)

        @test cost_info.estimated_k == 1
        @test cost_info.total_extent == 1.0
        @test cost_info.non_clifford_count == 0
        @test isempty(cost_info.gate_extents)
        @test cost_info.scaling_factor == 1.0
    end

    @testset "T Gate Cost Estimation" begin
        circuit = [sHadamard(1), sT(1), sT(1)]
        cost_info = lrcost(circuit; delta=0.1)

        expected_xi_T = (cos(π/8) + tan(π/8) * sin(π/8))^2
        @test cost_info.non_clifford_count == 2
        @test cost_info.total_extent ≈ expected_xi_T^2
        @test length(cost_info.gate_extents) == 2
        @test all(xi -> xi ≈ expected_xi_T, cost_info.gate_extents)
    end

    @testset "CCZ Gate Cost Estimation" begin
        circuit = [sCCZ(1, 2, 3)]
        cost_info = lrcost(circuit; delta=0.1)

        expected_xi_CCZ = 16.0/9.0
        @test cost_info.non_clifford_count == 1
        @test cost_info.total_extent ≈ expected_xi_CCZ
        @test cost_info.gate_extents[1] ≈ expected_xi_CCZ
    end

    @testset "Mixed Circuit Cost Estimation" begin
        circuit = [
            sHadamard(1), sHadamard(2),
            sT(1),
            sCNOT(1, 2),
            sCCZ(1, 2, 3),
            sZ(3)
        ]
        cost_info = lrcost(circuit; delta=0.1)

        expected_xi_T = (cos(π/8) + tan(π/8) * sin(π/8))^2
        expected_xi_CCZ = 16.0/9.0
        @test cost_info.non_clifford_count == 2
        @test cost_info.total_extent ≈ expected_xi_T * expected_xi_CCZ
        @test length(cost_info.gate_extents) == 2
    end

    @testset "Cost Scales with Delta" begin
        circuit = [sT(1)]

        cost_small_delta = lrcost(circuit; delta=0.01)
        cost_large_delta = lrcost(circuit; delta=0.5)

        @test cost_small_delta.estimated_k > cost_large_delta.estimated_k
    end

    @testset "PureGeneralizedStabilizer construction and apply!" begin
        state = PureGeneralizedStabilizer(2, 0.1)
        @test nqubits(state) == 2
        @test length(state.states) == 1
        @test length(state.coefficients) == 1
        @test state.total_extent == 1.0

        apply!(state, sHadamard(1))
        @test length(state.states) == 1

        apply!(state, sT(1))
        @test length(state.states) == 2
        @test state.total_extent > 1.0
    end
end

@testitem "PureNonClifford Sampling" tags=[:non_clifford] begin
    using QuantumClifford
    using QuantumClifford.PureNonClifford
    import QuantumClifford: AbstractOperation
    import QuantumClifford.PureNonClifford:
        sample_measurement_outcomes,
        compute_outcome_frequencies,
        lrcost, stabilizer_extent

    @testset "Measurement Sampling Tests" begin
        state = PureGeneralizedStabilizer(2, 0.2)
        apply!(state, sHadamard(1))
        apply!(state, sCNOT(1, 2))

        n_samples = 100
        meas = sample_measurement_outcomes(state, n_samples; verbose=false)

        @test size(meas, 1) == n_samples
        @test size(meas, 2) == 2
        @test all(m -> m ∈ [false, true], meas)

        unique_rows = size(unique(meas, dims=1), 1)
        @test unique_rows > 0
    end

    @testset "Computational Correctness - Single Qubit" begin
        circuit = [sHadamard(1), sT(1)]

        result = emtrajectories(circuit, 1; trajectories=1000, delta=0.05, verbose=false)

        meas = measurements(result)
        p0 = sum(meas[:, 1] .== false) / size(meas, 1)
        p1 = sum(meas[:, 1] .== true) / size(meas, 1)

        @test p0 ≈ 0.5 atol=0.05
        @test p1 ≈ 0.5 atol=0.05
    end

    @testset "Computational Correctness - Entanglement" begin
        circuit = [
            sHadamard(1),
            sCNOT(1,2),
            sT(1)
        ]

        result = emtrajectories(circuit, 2; trajectories=1000, delta=0.1, verbose=false)

        meas = measurements(result)
        freq = compute_outcome_frequencies(meas)

        p00 = get(freq, BitVector([false, false]), 0.0)
        p11 = get(freq, BitVector([true, true]), 0.0)
        correlation = p00 + p11

        @test correlation > 0.85
    end

    @testset "Scalability" begin
        qubit_counts = [3, 5, 8]

        for n in qubit_counts
            circuit = AbstractOperation[]
            append!(circuit, [sHadamard(i) for i in 1:n])
            push!(circuit, sT(1))
            append!(circuit, [sHadamard(i) for i in 1:n])

            start = time()
            result = emtrajectories(circuit, n; trajectories=30, delta=0.2, verbose=false)
            elapsed = time() - start

            @test elapsed < 30.0
            @test result.simulation_cost > 1
        end
    end

    @testset "Complete Pipeline" begin
        n_qubits = 5
        circuit = AbstractOperation[
            [sHadamard(i) for i in 1:n_qubits]...,
            sCNOT(1,2), sCNOT(2,3), sCNOT(3,4), sCNOT(4,5),
            sT(1), sT(3), sT(5),
            sCNOT(2,3), sCNOT(4,5),
            sT(2), sT(4)
        ]

        result = emtrajectories(
            circuit, n_qubits;
            trajectories=200,
            delta=0.1,
            verbose=false
        )

        xi_T = (cos(π/8) + tan(π/8)*sin(π/8))^2
        expected_extent = xi_T^5
        expected_cost_bound = ceil(Int, 1 + expected_extent / 0.1^2)

        @test result.simulation_cost > 1
        @test result.simulation_cost <= expected_cost_bound
        @test result.approximation_error ≈ 0.1 atol=0.02
        @test size(measurements(result), 1) == 200
    end
end

@testitem "PureNonClifford Magic States" tags=[:non_clifford] begin
    using QuantumClifford
    using QuantumClifford.PureNonClifford
    using Random
    import QuantumClifford.PureNonClifford:
        get_gate_decomposition,
        decompose_rotation_magic_state,
        MagicStateDecompositionCache,
        sparsify_mixed_destabilizer_decomposition,
        lrcost, stabilizer_extent

    @testset "Sparsification (MixedDestabilizer)" begin
        state1 = MixedDestabilizer(S"Z")
        state2 = MixedDestabilizer(S"X")
        state3 = MixedDestabilizer(S"-Z")
        states = [state1, state2, state3]
        coeffs = ComplexF64[0.5, 0.3, 0.24]
        delta = 0.1

        sparse = sparsify_mixed_destabilizer_decomposition(coeffs, states, delta)

        l1_norm = sum(abs.(coeffs))
        theoretical_k_bound = ceil(Int, l1_norm^2 / delta^2)

        @test sparse.k > 0
        @test sparse.k <= theoretical_k_bound
        @test sparse.l1_norm ≈ l1_norm
        @test length(sparse.states) == sparse.k
        @test length(sparse.coefficients) == sparse.k
    end

    @testset "T-Gate Decomposition" begin
        t_decomp = get_gate_decomposition(sT(1))
        expected_xi_T = (cos(π/8) + tan(π/8)*sin(π/8))^2

        @test t_decomp.gate_type == :T
        @test length(t_decomp.coefficients) == 2
        @test length(t_decomp.clifford_operations) == 2
        @test t_decomp.stabilizer_extent ≈ expected_xi_T rtol=0.01
    end

    @testset "Rotation Magic State" begin
        theta = π/3
        magic_decomp = decompose_rotation_magic_state(theta)
        expected_xi_R = (cos(theta/2) + tan(π/8)*sin(theta/2))^2

        @test magic_decomp.gate_type == :R_theta
        @test length(magic_decomp.coefficients) == 2
        @test magic_decomp.stabilizer_extent ≈ expected_xi_R rtol=0.01
    end

    @testset "CCZ Gate Decomposition" begin
        ccz_decomp = get_gate_decomposition(sCCZ(1,2,3))
        expected_xi_CCZ = 16.0/9.0

        @test ccz_decomp.gate_type == :CCZ
        @test length(ccz_decomp.coefficients) == 8
        @test length(ccz_decomp.clifford_operations) == 8
        @test ccz_decomp.stabilizer_extent ≈ expected_xi_CCZ rtol=0.01
    end

    @testset "Sparsification with Different Deltas" begin
        states = [MixedDestabilizer(S"X"), MixedDestabilizer(S"Z"),
                  MixedDestabilizer(S"Y"), MixedDestabilizer(S"-X")]
        coeffs = ComplexF64[0.4, 0.3, 0.2, 0.1]

        deltas = [0.5, 0.2, 0.1, 0.05]
        k_values = Int[]

        for delta in deltas
            sparse = sparsify_mixed_destabilizer_decomposition(coeffs, states, delta)
            push!(k_values, sparse.k)
        end

        @test issorted(k_values)
    end

    @testset "Magic State Decomposition Cache Properties" begin
        t_magic = decompose_rotation_magic_state(π/4)
        @test t_magic.stabilizer_fidelity ≈ 1.0 / t_magic.stabilizer_extent rtol=0.01

        ccz_magic = MagicStateDecompositionCache(:CCZ,
            fill(ComplexF64(1/6), 8),
            fill(S"XII IXI IIX", 8))
        @test ccz_magic.stabilizer_extent ≈ 16/9 rtol=0.01
        @test ccz_magic.stabilizer_fidelity ≈ 9/16 rtol=0.01
    end
end

@testitem "PureNonClifford T-Gate Probability Distribution" tags=[:non_clifford] begin
    using QuantumClifford
    using QuantumClifford.PureNonClifford
    using QuantumClifford.PureNonClifford: lrcost, stabilizer_extent

    @testset "H-T-H Circuit Probability" begin
        circuit = [sHadamard(1), sT(1), sHadamard(1)]

        result = emtrajectories(circuit, 1; trajectories=10000, delta=0.05, verbose=false)
        meas = measurements(result)

        p0 = sum(meas[:, 1] .== false) / size(meas, 1)
        expected_p0 = cos(π/8)^2

        @test p0 ≈ expected_p0 atol=0.07

        @test p0 > 0.75
        @test p0 < 0.95
    end

    @testset "T|+⟩ State Distribution" begin
        circuit = [sHadamard(1), sT(1)]

        result = emtrajectories(circuit, 1; trajectories=5000, delta=0.05, verbose=false)
        meas = measurements(result)

        p0 = sum(meas[:, 1] .== false) / size(meas, 1)
        p1 = sum(meas[:, 1] .== true) / size(meas, 1)

        @test p0 ≈ 0.5 atol=0.08
        @test p1 ≈ 0.5 atol=0.08

        @test p0 > 0.35 && p0 < 0.65
    end

    @testset "Multiple T Gates" begin
        circuit_2T = [sHadamard(1), sT(1), sT(1), sHadamard(1)]

        result = emtrajectories(circuit_2T, 1; trajectories=5000, delta=0.05, verbose=false)
        meas = measurements(result)

        p0 = sum(meas[:, 1] .== false) / size(meas, 1)
        expected_p0 = 0.5

        @test p0 ≈ expected_p0 atol=0.08

        @test p0 > 0.35 && p0 < 0.65
    end
end

@testitem "PureNonClifford Bell State with T" tags=[:non_clifford] begin
    using QuantumClifford
    using QuantumClifford.PureNonClifford
    import QuantumClifford.PureNonClifford: compute_outcome_frequencies, lrcost, stabilizer_extent

    @testset "Bell State Correlations" begin
        circuit = [
            sHadamard(1),
            sCNOT(1, 2),
            sT(1)
        ]

        result = emtrajectories(circuit, 2; trajectories=5000, delta=0.1, verbose=false)
        meas = measurements(result)
        freq = compute_outcome_frequencies(meas)

        p00 = get(freq, BitVector([false, false]), 0.0)
        p11 = get(freq, BitVector([true, true]), 0.0)
        p01 = get(freq, BitVector([false, true]), 0.0)
        p10 = get(freq, BitVector([true, false]), 0.0)

        correlation = p00 + p11
        anticorrelation = p01 + p10

        @test correlation > 0.9
        @test anticorrelation < 0.1
    end

    @testset "GHZ State with CCZ" begin
        circuit = [
            sHadamard(1), sHadamard(2), sHadamard(3),
            sCCZ(1, 2, 3),
            sHadamard(1), sHadamard(2), sHadamard(3)
        ]

        result = emtrajectories(circuit, 3; trajectories=2000, delta=0.1, verbose=false)

        @test result.simulation_cost > 1
        @test result.total_extent ≈ 16/9 atol=0.01
        @test size(measurements(result)) == (2000, 3)
    end
end

@testitem "PureNonClifford Result Display" tags=[:non_clifford] begin
    using QuantumClifford
    using QuantumClifford.PureNonClifford

    @testset "Show Method" begin
        circuit = [sHadamard(1), sT(1)]
        result = emtrajectories(circuit, 1; trajectories=100, delta=0.1, verbose=false)

        io = IOBuffer()
        show(io, result)
        output = String(take!(io))

        @test occursin("End Measurement Sample Results", output)
        @test occursin("Qubits: 1", output)
        @test occursin("Trajectories: 100", output)
        @test occursin("stabilizer terms", output)
    end

    @testset "measurements Accessor" begin
        circuit = [sHadamard(1), sT(1)]
        result = emtrajectories(circuit, 1; trajectories=50, delta=0.1, verbose=false)

        m = measurements(result)

        @test m isa Matrix{Bool}
        @test size(m) == (50, 1)
    end
end

@testitem "PureNonClifford Edge Cases" tags=[:non_clifford] begin
    using QuantumClifford
    using QuantumClifford.PureNonClifford

    @testset "Single Gate Circuits" begin
        result = emtrajectories([sT(1)], 1; trajectories=50, delta=0.1, verbose=false)
        @test result.simulation_cost > 1

        result = emtrajectories([sHadamard(1)], 1; trajectories=50, delta=0.1, verbose=false)
        @test result.simulation_cost == 1
    end

    @testset "Large Delta" begin
        circuit = [sHadamard(1), sT(1)]
        result = emtrajectories(circuit, 1; trajectories=50, delta=0.9, verbose=false)

        @test result.simulation_cost >= 1
        @test result.simulation_cost <= 10
    end

    @testset "Qubit Index Validation" begin
        @test_throws ArgumentError sT(0)
        @test_throws ArgumentError sT(-1)
        @test_throws ArgumentError sCCZ(1, 1, 2)
        @test_throws ArgumentError sCCZ(0, 1, 2)
    end

    @testset "CCZ Gate Constructor" begin
        ccz = sCCZ(3, 1, 2)
        @test ccz.qubits == (1, 2, 3)
    end

    @testset "Auto Qubit Inference" begin
        circuit = [sHadamard(1), sT(3), sCNOT(2, 4)]
        result = emtrajectories(circuit; trajectories=20, delta=0.2, verbose=false)
        @test result.n_qubits == 4
    end

    @testset "Tuple circuit (untyped iterator)" begin
        circuit = (sHadamard(1), sT(1), sHadamard(1))
        result = emtrajectories(circuit, 1; trajectories=20, delta=0.2)
        @test size(measurements(result)) == (20, 1)
    end
end

@testitem "PureNonClifford Incremental Sparsification" tags=[:non_clifford] begin
    using QuantumClifford
    using QuantumClifford.PureNonClifford
    using Random

    import QuantumClifford: AbstractOperation
    import QuantumClifford.PureNonClifford:
        sparsify_mixed_destabilizer_decomposition,
        lrcost, stabilizer_extent

    @testset "sparsify_mixed_destabilizer_decomposition" begin
        state1 = MixedDestabilizer(S"Z")
        state2 = MixedDestabilizer(S"X")
        state3 = MixedDestabilizer(S"-Z")
        state4 = MixedDestabilizer(S"-X")

        states = [state1, state2, state3, state4]
        coeffs = ComplexF64[0.5, 0.3, 0.15, 0.05]
        l1_norm = sum(abs, coeffs)

        result_large_delta = sparsify_mixed_destabilizer_decomposition(coeffs, states, 10.0)
        expected_k_large = ceil(Int, l1_norm^2 / 10.0^2)
        @test result_large_delta.k == expected_k_large
        @test result_large_delta.k < length(states)

        result_small_delta = sparsify_mixed_destabilizer_decomposition(coeffs, states, 0.1)
        @test result_small_delta.k == 4
        @test length(result_small_delta.states) == 4
        @test length(result_small_delta.coefficients) == 4

        result_medium_delta = sparsify_mixed_destabilizer_decomposition(coeffs, states, 0.6)
        expected_k_medium = ceil(Int, l1_norm^2 / 0.6^2)
        @test result_medium_delta.k == expected_k_medium
        @test length(result_medium_delta.states) == expected_k_medium
    end

    @testset "Incremental Sparsification Triggers" begin
        n_gates = 20
        circuit = vcat(
            [sHadamard(1)],
            [sT(1) for _ in 1:n_gates],
            [sHadamard(1)]
        )

        delta = 0.7
        result = emtrajectories(circuit, 1; trajectories=100, delta=delta, verbose=false)

        @test result.simulation_cost < 2^n_gates
        @test result.simulation_cost < 100000

        xi_T = (cos(π/8) + tan(π/8)*sin(π/8))^2
        @test result.total_extent ≈ xi_T^n_gates rtol=0.01
    end

    @testset "Large Circuit Scalability" begin
        n_gates = 24
        circuit = AbstractOperation[sT(1) for _ in 1:n_gates]

        start_time = time()
        result = emtrajectories(circuit, 1; trajectories=50, delta=0.8, verbose=false)
        elapsed = time() - start_time

        @test elapsed < 120.0
        @test result.simulation_cost < 2^n_gates
        @test result.simulation_cost < 500000

        xi_T = (cos(π/8) + tan(π/8)*sin(π/8))^2
        @test result.total_extent ≈ xi_T^n_gates rtol=0.01
    end

    @testset "Small Circuit No Sparsification" begin
        circuit = AbstractOperation[sT(1), sT(1), sT(1)]

        result = emtrajectories(circuit, 1; trajectories=50, delta=0.1, verbose=false)

        @test result.simulation_cost == 8
    end

    @testset "Error Budget Distribution" begin
        circuit = AbstractOperation[
            sHadamard(1),
            sT(1), sT(1), sT(1), sT(1),
            sHadamard(1)
        ]

        delta = 0.1
        n_runs = 5
        for _ in 1:n_runs
            result = emtrajectories(circuit, 1; trajectories=2000, delta=delta, verbose=false)
            meas = measurements(result)

            p0 = sum(meas[:, 1] .== false) / size(meas, 1)

            @test 0.0 < p0 < 1.0
            @test !isnan(p0)
        end
    end

    @testset "Per-Gate Delta Calculation" begin
        circuit_1T = AbstractOperation[sT(1)]
        circuit_4T = AbstractOperation[sT(1), sT(1), sT(1), sT(1)]

        delta = 0.2

        result_1T = emtrajectories(circuit_1T, 1; trajectories=50, delta=delta, verbose=false)
        result_4T = emtrajectories(circuit_4T, 1; trajectories=50, delta=delta, verbose=false)

        @test result_1T.simulation_cost >= 1
        @test result_4T.simulation_cost >= 1

        @test result_1T.approximation_error ≈ delta
        @test result_4T.approximation_error ≈ delta
    end

    @testset "L1 Norm Consistency Check" begin
        circuit = AbstractOperation[sT(1) for _ in 1:10]

        delta = 0.5
        non_clifford_count = count(op -> !isclifford(op), circuit)
        state = PureGeneralizedStabilizer(1, delta / non_clifford_count)
        mctrajectory!(state, circuit)
        l1_final = sum(abs, state.coefficients)

        xi_T = (cos(π/8) + tan(π/8)*sin(π/8))^2
        expected_l1 = sqrt(xi_T^10)

        @test l1_final > 0.5 * expected_l1
        @test l1_final < 2.0 * expected_l1
    end
end

@testitem "PureNonClifford QuantumOptics Comparison" tags=[:non_clifford] begin
    using QuantumClifford
    using QuantumClifford.PureNonClifford
    using QuantumOpticsBase
    using LinearAlgebra

    b = SpinBasis(1//2)
    T_matrix = Operator(b, ComplexF64[1 0; 0 exp(im*π/4)])
    H_matrix = Operator(b, ComplexF64[1 1; 1 -1]/√2)

    @testset "Single qubit H-T-H circuit" begin
        circuit = [sHadamard(1), sT(1), sHadamard(1)]
        state = PureGeneralizedStabilizer(1, 0.01)
        mctrajectory!(state, circuit)
        ket_qc = Ket(state)

        ket_qo = spinup(b)
        ket_qo = H_matrix * ket_qo
        ket_qo = T_matrix * ket_qo
        ket_qo = H_matrix * ket_qo

        overlap = abs(dagger(ket_qc) * ket_qo)
        @test overlap > 0.85
    end

    @testset "Multiple T gates" begin
        circuit = [sHadamard(1), sT(1), sT(1), sT(1), sHadamard(1)]
        state = PureGeneralizedStabilizer(1, 0.01/3)
        mctrajectory!(state, circuit)
        ket_qc = Ket(state)

        ket_qo = spinup(b)
        ket_qo = H_matrix * ket_qo
        ket_qo = T_matrix * ket_qo
        ket_qo = T_matrix * ket_qo
        ket_qo = T_matrix * ket_qo
        ket_qo = H_matrix * ket_qo

        overlap = abs(dagger(ket_qc) * ket_qo)
        @test overlap > 0.85
    end
end

@testitem "PureNonClifford Probability Accuracy with Incremental Sparsification" tags=[:non_clifford] begin
    using QuantumClifford
    using QuantumClifford.PureNonClifford

    @testset "H-T^4-H Distribution" begin
        circuit = [sHadamard(1), sT(1), sT(1), sT(1), sT(1), sHadamard(1)]

        result = emtrajectories(circuit, 1; trajectories=5000, delta=0.05, verbose=false)
        meas = measurements(result)

        p1 = sum(meas[:, 1] .== true) / size(meas, 1)

        @test p1 > 0.85
    end

    @testset "Multiple T-Gates Accuracy" begin
        circuit = vcat(
            [sHadamard(1)],
            [sT(1) for _ in 1:8],
            [sHadamard(1)]
        )

        result = emtrajectories(circuit, 1; trajectories=5000, delta=0.1, verbose=false)
        meas = measurements(result)

        p0 = sum(meas[:, 1] .== false) / size(meas, 1)

        @test p0 > 0.80
    end
end

@testitem "PureNonClifford Incremental Sparsification Correctness" tags=[:non_clifford] begin
    using QuantumClifford
    using QuantumClifford.PureNonClifford
    using Random

    import QuantumClifford: AbstractOperation
    import QuantumClifford.PureNonClifford:
        compute_outcome_frequencies

    @testset "Probability Accuracy With Sparsification Active" begin
        circuit = AbstractOperation[
            sHadamard(1),
            [sT(1) for _ in 1:16]...,
            sHadamard(1)
        ]

        result = emtrajectories(circuit, 1; trajectories=3000, delta=0.8, verbose=false)

        @test result.simulation_cost < 65536

        meas = measurements(result)
        p0 = sum(meas[:, 1] .== false) / size(meas, 1)

        @test p0 > 0.70
    end

    @testset "Multi-Qubit Bell State With Sparsification" begin
        n_T_gates = 16
        circuit = AbstractOperation[
            sHadamard(1),
            sCNOT(1, 2),
            [sT(1) for _ in 1:n_T_gates]...,
        ]

        result = emtrajectories(circuit, 2; trajectories=2000, delta=0.7, verbose=false)

        @test result.simulation_cost < 2^n_T_gates

        meas = measurements(result)
        freq = compute_outcome_frequencies(meas)

        p00 = get(freq, BitVector([false, false]), 0.0)
        p11 = get(freq, BitVector([true, true]), 0.0)
        p01 = get(freq, BitVector([false, true]), 0.0)
        p10 = get(freq, BitVector([true, false]), 0.0)

        correlation = p00 + p11
        anticorrelation = p01 + p10

        @test correlation > 0.75
        @test anticorrelation < 0.25
    end

    @testset "CCZ With Incremental Sparsification" begin
        circuit = AbstractOperation[
            sHadamard(1), sHadamard(2), sHadamard(3),
            sCCZ(1, 2, 3),
            sCCZ(1, 2, 3),
            sCCZ(1, 2, 3),
            sHadamard(1), sHadamard(2), sHadamard(3)
        ]

        result = emtrajectories(circuit, 3; trajectories=500, delta=0.9, verbose=false)

        xi_CCZ = 16.0/9.0
        @test result.total_extent ≈ xi_CCZ^3 rtol=0.01

        @test result.simulation_cost >= 1
        @test size(measurements(result)) == (500, 3)
    end

    @testset "Mixed T and CCZ Gates" begin
        circuit = AbstractOperation[
            sHadamard(1), sHadamard(2), sHadamard(3),
            sT(1),
            sT(2),
            sCCZ(1, 2, 3),
            sT(3),
            sHadamard(1), sHadamard(2), sHadamard(3)
        ]

        result = emtrajectories(circuit, 3; trajectories=200, delta=0.5, verbose=false)

        xi_T = (cos(π/8) + tan(π/8)*sin(π/8))^2
        xi_CCZ = 16.0/9.0
        expected_extent = xi_T^3 * xi_CCZ
        @test result.total_extent ≈ expected_extent rtol=0.01

        @test result.simulation_cost >= 1
    end

    @testset "Stress Test - Very Large Circuit" begin
        n_gates = 32
        circuit = AbstractOperation[sT(1) for _ in 1:n_gates]

        start_time = time()
        result = emtrajectories(circuit, 1; trajectories=20, delta=0.95, verbose=false)
        elapsed = time() - start_time

        @test elapsed < 180.0

        @test result.simulation_cost < 1_000_000

        xi_T = (cos(π/8) + tan(π/8)*sin(π/8))^2
        @test result.total_extent ≈ xi_T^n_gates rtol=0.01
    end
end

@testitem "PureGeneralizedStabilizer public constructor" tags=[:non_clifford] begin
    using QuantumClifford

    @testset "Single-argument constructor" begin
        state = PureGeneralizedStabilizer(3)
        @test nqubits(state) == 3
        @test length(state.states) == 1
        @test length(state.coefficients) == 1
    end

    @testset "Two-argument constructor" begin
        state = PureGeneralizedStabilizer(2, 0.05)
        @test nqubits(state) == 2
        @test state.delta_per_gate == 0.05
    end

    @testset "Apply gates to constructed state" begin
        state = PureGeneralizedStabilizer(2)
        apply!(state, sHadamard(1))
        apply!(state, sCNOT(1, 2))
        @test nqubits(state) == 2
        @test length(state.states) == 1  # still 1 term, Clifford only
    end

    @testset "Error on invalid nqubits" begin
        @test_throws ArgumentError PureGeneralizedStabilizer(0)
        @test_throws ArgumentError PureGeneralizedStabilizer(-1)
    end
end

using QuantumClifford: get_bitmask_idxs

#according to https://github.com/JuliaGPU/CUDA.jl/blob/ac1bc29a118e7be56d9edb084a4dea4224c1d707/test/core/device/random.jl#L33
#CUDA.jl supports calling rand() inside kernel
function applynoise!(frame::PauliFrameGPU{T},noise::UnbiasedUncorrelatedNoise,i::Int) where {T <: Unsigned}
    p = noise.p
    xzs = tab(frame.frame).xzs
    lowbit, ibig, ismall, ismallm = get_bitmask_idxs(xzs,i)
    rows = size(frame.frame, 1)

    @run_cuda applynoise_kernel(xzs, p, ibig, ismallm, rows) rows
    return frame
end


function applynoise_kernel(xzs::DeviceMatrix{Tₘₑ},
    p::Real,
    ibig::Int,
    ismallm::Tₘₑ,
    rows::Int) where {Tₘₑ <: Unsigned}

    f = (blockIdx().x - 1) * blockDim().x + threadIdx().x;
    if f > rows
        return nothing
    end

    r = rand()
    p = p/3
    if  r < p # X error
        xzs[ibig,f] ⊻= ismallm
    elseif r < 2p # Z error
        xzs[end÷2+ibig,f] ⊻= ismallm
    elseif r < 3p # Y error
        xzs[ibig,f] ⊻= ismallm
        xzs[end÷2+ibig,f] ⊻= ismallm
    end
    return nothing
end

module GraphSim

export graphstate, graphstate!, graph_gatesequence, graph_gate

import Graphs: Graphs, nv, AbstractGraph
using QuantumClifford: AbstractStabilizer, AbstractSingleQubitOperator,
        sId1, sInvPhase, sSQRTX, CliffordOperator, SingleQubitOperator,
        Stabilizer, sZ, sPhase, sX, sY, sHadamard, sInvSQRTX, @S_str, stabilizerview,
        canonicalize_gott!, phases, sCPHASE, affectedqubits, canonicalize!, tab
import QuantumClifford: nqubits, apply!, Stabilizer

include("single_qubit_tables.jl")

# elided as it's a non-public API and might introduce unexpected behavior for downstream users
# we didn't wrap it inside a new struct as that introduces boiler plate for show etc.
function _apply_vop!(vops::Vector{SingleQubitOperator}, op::AbstractSingleQubitOperator; phases::Bool=true)
    q = affectedqubits(op)[1]
    # Convert into a single qubit operator acting on index 1
    op_prime = SingleQubitOperator(SingleQubitOperator(op), 1)
    vops[q] = SINGLE_QUBIT_MULTIPLICATION_TABLE[(op_prime, vops[q])]
    return vops
end

function _apply_vop_right!(vops::Vector{SingleQubitOperator}, op::AbstractSingleQubitOperator; phases::Bool=true)
    q = affectedqubits(op)[1]
    # Convert into a single qubit operator acting on index 1
    op_prime = SingleQubitOperator(SingleQubitOperator(op), 1)
    vops[q] = SINGLE_QUBIT_MULTIPLICATION_TABLE[(vops[q], op_prime)]
end

# TODO: Implement sanity_check like the one in Stim
struct GraphState{G, S}
    # Graph representing the graph state
    graph::G
    # Vertex Operators that need to be applied to convert from a "pure" graph state
    # to general a stabilizer state
    vops::Vector{S}
end

Base.copy(g::GraphState) = GraphState(copy(g.graph), copy(g.vops))

# Applying a single qubit gate
function apply!(gs::GraphState, op::AbstractSingleQubitOperator; phases::Bool = true)
    _apply_vop!(gs.vops, op; phases)
    return gs
end

nqubits(g::GraphState) = nv(g.graph)

"""Return the underlying graph of the graph state"""
graph(g::GraphState) = g.graph

"""Return the VOPs (Vertex Operators) of the graph state"""
vops(g::GraphState) = g.vops

function GraphState(graph::G, h_idx::Vector{Int}, ip_idx::Vector{Int}, z_idx::Vector{Int}) where G
    vops = [SingleQubitOperator(sId1(1)) for _ in 1:nv(graph)]
    # Apply the inverse of Z, InvPhase, H in this order to construct VOPs
    # Remember our definition of VOPs is the operator that converts "pure" graph states
    # to the wanted stabilizer state
    for id in z_idx
        _apply_vop!(vops, sZ(id))
    end
    for id in ip_idx
        _apply_vop!(vops, sPhase(id))
    end
    for id in h_idx
        _apply_vop!(vops, sHadamard(id))
    end
    GraphState{G, SingleQubitOperator}(graph, vops)
end

function GraphState(stab::Stabilizer)
    GraphState(graphstate(stab)...)
end

function Stabilizer(self::GraphState{<:AbstractGraph})
    s_raw = Stabilizer(self.graph)
    # Apply VOPs to convert to the stabilizer state
    for id in eachindex(self.vops)
        apply!(s_raw, SingleQubitOperator(self.vops[id], id))
    end
    s_raw
end

"""An in-place version of [`graphstate`](@ref)."""
function graphstate!(stab::Stabilizer)
    n = nqubits(stab)
    # canonicalization is in-place
    _, r, _, permx, permz = canonicalize_gott!(stab)
    # This is equivalent to saying perm(i) = (permz ∘ permx)(i)
    # No typo above. permz ∘ permx because in Gottesman canonicalization
    # we first do Gaussian elimination on the X half and then on the Z half
    # when writing tableau in the matrix format.
    perm = permx[permz]

    # Swap X ↔ Z in the (r+1):n columns so we have only X,Y,I diagonal and only Z off-diagonal
    h_idx = [perm[i] for i in (r+1):n]
    # Swap Y → X on the diagonal so we have only X, I on the diagonal
    ip_idx = [perm[i] for i in 1:n if stab[i,i]==(true,true)]
    # Since ZXZ = -X, apply Z on rows with negative phase to make all phases positive.
    phase_flips = [perm[i] for i in 1:n if phases(stab)[i]!=0x0]

    # canonicalized stabilizer tableau serves as an adjacency matrix
    graph = Graphs.SimpleGraphFromIterator((
        Graphs.SimpleEdge(perm[i],perm[j])
        for i in 1:n, j in 1:n
        if i!=j && stab[i,j]!=(false,false)
    ))
    Graphs.add_vertices!(graph, n-Graphs.nv(graph))
    graph, h_idx, ip_idx, phase_flips
end

""" Convert any stabilizer state to a graph state

[Graph states](https://en.wikipedia.org/wiki/Graph_state) are a special type
of entangled stabilizer states that can be represented by a graph.
For a graph ``G=(V,E)`` the corresponding stabilizers are ``S_v = X_v \\prod_{u ∈ N(v)} Z_u``.
Notice that such tableau rows contain only a single X operator.
There is a set of single qubit gates that converts any stabilizer state to a graph state.

This function returns the graph state corresponding to a stabilizer and the gates that
might be necessary to convert the stabilizer into a state representable as a graph.

For a tableau `stab` you can convert it with:
```julia
graph, hadamard_idx, iphase_idx, flips_idx = graphstate()
```
where `graph` is the graph representation of `stab`,
and the rest specifies the single-qubit gates converting `stab` to `graph`:
`hadamard_idx` are the qubits that require a Hadamard gate (mapping X ↔ Z),
`iphase_idx` are (different) qubits that require an inverse Phase gate (Y → X),
and `flips_idx` are the qubits that require a phase flip (Pauli Z gate),
after the previous two sets of gates.

```jldoctest graph
julia> using Graphs

julia> s = S" XXX
              ZZ_
             -_ZZ";


julia> g, h_idx, ip_idx, z_idx = graphstate(s);


julia> collect(edges(g))
2-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 3

julia> h_idx
2-element Vector{Int64}:
 2
 3

julia> ip_idx
Int64[]

julia> z_idx
1-element Vector{Int64}:
 3
```

The `Graphs.jl` library provides many graph-theory tools and the
`MakieGraphs.jl` library provides plotting utilities for graphs.

You can directly call the graph constructor on a stabilizer,
if you just want the graph and do not care about the Clifford
operation necessary to convert an arbitrary state to a state
representable as a graph:

```jldoctest graph
julia> collect(edges( Graph(bell()) ))
1-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
```

For a version that does not copy the stabilizer, but rather
performs transformations in-place, use `graphstate!`. It would
perform `canonicalize_gott!` on its argument as it finds a way
to convert it to a graph state.
"""
graphstate(s::AbstractStabilizer) = graphstate!(copy(stabilizerview(s)))

Graphs.Graph(s::AbstractStabilizer) = graphstate(s)[1]

"""Convert a graph representing a stabilizer state to an explicit Stabilizer.

See also: [`graphstate`](@ref)"""
function Stabilizer(g::Graphs.Graph)
    s = zero(Stabilizer, Graphs.nv(g)) # number of vertices
    for v in Graphs.vertices(g)
        s[v,v]=(true,false)
        for n in Graphs.neighbors(g,v)
            s[v,n]=(false,true)
        end
    end
    return s
end

"""A helper function converting the gate indices from [`graphstate`](@ref) into a sequence of gates.

```jldoctest
julia> s = S" XXX
              YZ_
             -_ZZ";


julia> graph, h_idx, ip_idx, z_idx = graphstate(s);


julia> gates = graph_gatesequence(h_idx, ip_idx, z_idx);


julia> for gate in vcat(gates...) apply!(s, gate) end


julia> s # This is now a graph state (notice you need to multiply row 1 by row 2)
+ YYZ
+ XZ_
+ _ZX

julia> canonicalize!(s) == canonicalize!(Stabilizer(graph))
true
```

See also: [`graph_gatesequence`](@ref)
"""
function graph_gatesequence(h_idx::Vector{Int}, ip_idx::Vector{Int}, z_idx::Vector{Int})
    ([sHadamard(i) for i in h_idx], [sInvPhase(i) for i in ip_idx], [sZ(i) for i in z_idx])
end

"""A helper function converting the gate indices from [`graphstate`](@ref) into a Clifford operator.

```jldoctest
julia> s = S" XXX
              YZ_
             -_ZZ";


julia> graph, h_idx, ip_idx, z_idx = graphstate(s);


julia> gate = graph_gate(h_idx, ip_idx, z_idx, nqubits(s));


julia> apply!(s, gate) # This is now a graph state (notice you need to multiply row 1 by row 2)
+ YYZ
+ XZ_
+ _ZX

julia> canonicalize!(s) == canonicalize!(Stabilizer(graph))
true
```

See also: [`graph_gatesequence`](@ref)
"""
function graph_gate(h_idx, ip_idx, z_idx, n)
    c = one(CliffordOperator,n)
    t = tab(c)
    x = @view t[1:n]
    z = @view t[n+1:end]
    for i in h_idx
        x[i,i] = (false,true)
        z[i,i] = (true,false)
    end
    for i in ip_idx
        x[i,i] = (true,true)
        x.phases[i] = 0x2
    end
    for i in z_idx
        if x[i,i][1]
            x.phases[i] = (x.phases[i]+0x2)&0x3
        end
        if z[i,i][1]
            z.phases[i] = (z.phases[i]+0x2)&0x3
        end
    end
    c
end

include("./two_qubits_table.jl")
include("./cphase.jl")

end #module

"""
$TYPEDEF

Generalized bicycle codes ([koukoulekidis2024smallquantumcodesalgebraic](@cite))

A generalized bicycle quantum LDPC code constructed from two polynomials in ``\\mathbb{F}_2[x]/(x^l - 1)``.

Here is an example of a [[10, 2, 3]] GB code from the Appendix B of
[koukoulekidis2024smallquantumcodesalgebraic](@cite) with lift size of 5
build out of two polymonials in ``\\mathbb{F}_2[x]/(x^l - 1)``.

```jldoctest
julia> import Hecke: polynomial_ring, GF; using QuantumClifford.ECC;

julia> R, x = polynomial_ring(GF(2), "x");

julia> l = 5;

julia> a = 1 + x^4;

julia> b = 1 + x + x^2 + x^4;

julia> c = GeneralizedBicycle(a, b, l);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(10, 2, 3)
```

Here is an example of a [[12, 2, 3]] GB code from the Appendix B of
[koukoulekidis2024smallquantumcodesalgebraic](@cite) with lift size of 6
build out of two polymonials in ``\\mathbb{F}_2[x]/(x^l - 1)``.

```jldoctest
julia> import Hecke: polynomial_ring, GF; using QuantumClifford.ECC;

julia> R, x = polynomial_ring(GF(2), "x");

julia> l = 6;

julia> a = 1 + x + x^2 + x^5;

julia> b = 1 + x + x^3 + x^5;

julia> c = GeneralizedBicycle(a, b, l);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(12, 2, 3)
```

See also: [`generalized_bicycle_code_as_2bga`](@ref)

### Fields
    $TYPEDFIELDS
"""
struct GeneralizedBicycle <: AbstractCSSCode
    """First generator polynomial in 𝔽₂[x]/(xˡ - 1)."""
    a::FqPolyRingElem
    """Second generator polynomial in 𝔽₂[x]/(xˡ - 1)."""
    b::FqPolyRingElem
    """The lift size which corresponds to dimension of circulant matrices."""
    l::Int
    function GeneralizedBicycle(a::FqPolyRingElem, b::FqPolyRingElem, l::Int)
        l <= 0 && throw(ArgumentError("Block length must be positive."))
        (base_ring(a) != base_ring(b)) && throw(ArgumentError("Polynomials must be from the same ring."))
        (characteristic(base_ring(a)) != 2) && throw(ArgumentError("Polynomials must be over 𝔽₂"))
        (degree(a) >= l || degree(b) >= l) && throw(ArgumentError("Polynomial degrees must be < l."))
        new(a, b, l)
    end
end

function parity_matrix_xz(c::GeneralizedBicycle)
    A = circulant_matrix_from_polynomial_ring(c.l, c.a)
    B = circulant_matrix_from_polynomial_ring(c.l, c.b)
    hx = hcat(A, B)
    hz = hcat(B', A')
    return hx, hz
end

parity_matrix_x(c::GeneralizedBicycle) = parity_matrix_xz(c)[1]

parity_matrix_z(c::GeneralizedBicycle) = parity_matrix_xz(c)[2]

code_n(c::GeneralizedBicycle) = 2*c.l

code_k(c::GeneralizedBicycle) = 2*degree(gcd(c.a, c.b, gen(parent(c.a))^c.l - 1))

@testitem "ECC code metachecks" tags=[:ecc, :ecc_base] begin
    using QECCore
    using QECCore: hasmetachecks
    using QuantumClifford
    using QuantumClifford
    using QuantumClifford.ECC

    include("test_ecc_base.jl")

    all_codes = all_testable_code_instances()

    function test_all_codes_metachecks(all_codes)
        for c in all_codes
            has_mx, has_mz = hasmetachecks(c)
            if has_mz && hasmethod(metacheck_matrix_z, Tuple{typeof(c)})
                Mz = metacheck_matrix_z(c)
                @test iszero(mod.(Mz*parity_matrix_z(c), 2))
            end
            if has_mx && hasmethod(metacheck_matrix_x, Tuple{typeof(c)})
                Mx = metacheck_matrix_x(c)
                @test iszero(mod.(Mx*parity_matrix_x(c), 2))
            end
        end
    end
end

module QuantumCliffordMakieExt

using Makie
using QuantumClifford
import QuantumClifford: stabilizerplot, stabilizerplot_axis

# If you want to directly use heatmap
function Makie.convert_arguments(P::Type{<:Makie.Heatmap}, s::Stabilizer)
    h = stab_to_gf2(s)
    r = h[:,1:end÷2] + h[:,end÷2+1:end]*2
    r = r[end:-1:1,:]'
    Makie.convert_arguments(P, r)
end

# A complete Makie recipe
Makie.@recipe(
function (scene)
    Makie.Theme(;
        xzcomponents = :together,
        colormap = Makie.cgrad([
            :lightgray,
            Makie.RGB(27/255, 158/255, 119/255),
            Makie.RGB(217/255, 95/255, 2/255),
            Makie.RGB(117/255, 112/255, 179/255)
        ], 4, categorical = true),
        colorrange = (-0.5, 3.5)
    )
end,
StabilizerPlot,
stabilizer
)

function Makie.plot!(myplot::StabilizerPlot)
    s = myplot[:stabilizer][]
    r = if myplot[:xzcomponents][]==:split
        QuantumClifford.stab_to_gf2(s)
    elseif myplot[:xzcomponents][]==:together
        h = QuantumClifford.stab_to_gf2(s)
        h[:,1:end÷2] + h[:,end÷2+1:end]*2
    else
        throw(ErrorException("`xzcomponents` should be `:split` or `:together`"))
    end
    r = r[end:-1:1,:]'
    hm = Makie.heatmap!(myplot, r;
        colorrange = (0, 3),
        colormap=myplot.colormap
    )
    for k in [:colorscale, :highclip, :lowclip]
        myplot[k] = hm[k]
    end
    myplot
end

"""Create a complete Makie figure of the tableaux.

This function is a temporary fix for Makie limitations. It lets you make a complete figure.

See [Makie#379](https://github.com/JuliaPlots/Makie.jl/issues/379)."""
function stabilizerplot_axis(subfig, s; colorbar=true, args...)
    ax = Makie.Axis(subfig[1,1])
    p = stabilizerplot!(ax,s; args...)
    Makie.hidedecorations!(ax)
    Makie.hidespines!(ax)
    ax.aspect = Makie.DataAspect()
    colorbar && Makie.Colorbar(subfig[1, 2], p, ticks = ((0.5:3.51)*3/4, ["I", "X", "Z", "Y"]), vertical = true, flipaxis = true)
    #Makie.colsize!(subfig.layout, 1, Makie.Aspect(1, min(1,size(s,2)/size(s,1))))
    subfig,ax,p
end

end

"""
Generate a Pauli operator by using operators from a given the Stabilizer.

**It assumes the stabilizer is already canonicalized.** It modifies
the Pauli operator in place, generating it in reverse, up to a phase.
That phase is left in the modified operator, which should be the identity up to a phase.
Returns the new operator and the list of indices denoting the elements of
`stabilizer` that were used for the generation.

```jldoctest
julia> ghz = S"XXXX
               ZZII
               IZZI
               IIZZ";


julia> canonicalize!(ghz)
+ XXXX
+ Z__Z
+ _Z_Z
+ __ZZ

julia> generate!(P"-ZIZI", ghz)
(- ____, [2, 4])
```

When the Pauli operator can not be generated by the given tableau, `nothing` is returned.

```jldoctest
julia> generate!(P"XII",canonicalize!(S"ZII")) === nothing
true

julia> generate!(P"XII",canonicalize!(S"XII")) === nothing
false
```
"""
function generate!(pauli::PauliOperator, stabilizer::Stabilizer; phases::Bool=true, saveindices::Bool=true)
    @valbooldispatch _generate!(pauli, stabilizer; phases=Val(phases), saveindices=Val(saveindices)) phases saveindices
end

function _generate!(pauli::PauliOperator{Tₚ,Tᵥ}, stabilizer::Stabilizer{Tableau{Tₚᵥ,Tₘ}}; phases::Val{PHASES}=Val(true), saveindices::Val{SAVEIDX}=Val(true)) where {Tₚ, Tₚᵥ, Tₘₑ<:Unsigned, Tᵥ<:AbstractVector{Tₘₑ}, Tₘ<:AbstractMatrix{Tₘₑ}, PHASES, SAVEIDX} # TODO there is stuff that can be abstracted away here and in canonicalize!
    xzs = tab(stabilizer).xzs
    xs = @view xzs[1:end÷2,:]
    zs = @view xzs[end÷2+1:end,:]
    zerobit = Tₘₑ(0x0)
    px,pz = xview(pauli), zview(pauli)
    used_indices = Int[]
    used = 0
    # remove Xs
    while (i=unsafe_bitfindnext_(px,1); i !== nothing) # TODO awkward notation due to https://github.com/JuliaLang/julia/issues/45499
        _, ibig, _, ismallm = get_bitmask_idxs(xzs,i)
        candidate = findfirst(e->e&ismallm!=zerobit, # TODO some form of reinterpret might be faster than equality check
                              xs[ibig,used+1:end])
        if isnothing(candidate)
            return nothing
        else
            used += candidate
        end
        mul_left!(pauli, stabilizer, used, phases=phases)
        SAVEIDX && push!(used_indices, used)
    end
    # remove Zs
    while (i=unsafe_bitfindnext_(pz,1); i !== nothing) # TODO awkward notation due to https://github.com/JuliaLang/julia/issues/45499
        _, ibig, _, ismallm = get_bitmask_idxs(xzs,i)
        candidate = findfirst(e->e&ismallm!=zerobit, # TODO some form of reinterpret might be faster than equality check
                              zs[ibig,used+1:end])
        if isnothing(candidate)
            return nothing
        else
            used += candidate
        end
        mul_left!(pauli, stabilizer, used, phases=phases)
        SAVEIDX && push!(used_indices, used)
    end
    all(iszero, pauli.xz) || return nothing # Need to check due to cases like generate!(P"_Z", S"XZ") that bypass the X checks # TODO do this better, without this extra loop through p.xz
    if SAVEIDX
        return pauli, used_indices
    else
        return pauli
    end
end

"""
$TYPEDSIGNATURES

Project the state of a Stabilizer on the two eigenspaces of a Pauli operator.

Assumes the input is a valid stabilizer. The projection is done inplace on
that stabilizer and it does not modify the projection operator.

It returns

 - a stabilizer that might not be in canonical form
 - the index of the row where the non-commuting operator was (that row is now equal to `pauli`; its phase is not updated and for a faithful measurement simulation it needs to be randomized by the user)
 - and the result of the projection if there was no non-commuting operator (`nothing` otherwise)

If `keep_result==false` that result of the projection in case of
anticommutation is not computed, sparing a canonicalization operation. This
canonicalization operation is the only one potentially of cubic complexity.
The rest of the calculations are of quadratic complexity.

If you need to measure a single qubit instead of a multiqubit Pauli operator,
the faster [`projectX!`](@ref), [`projectY!`](@ref), and [`projectZ!`](@ref)
are available.

For less boilerplate and automatic randomization of the phase use [`projectrand!`](@ref).

Here is an example of a projection destroying entanglement:

```jldoctest
julia> ghz = S"XXXX
               ZZII
               IZZI
               IIZZ";


julia> canonicalize!(ghz)
+ XXXX
+ Z__Z
+ _Z_Z
+ __ZZ

julia> state, anticom_index, result = project!(ghz, P"ZIII");


julia> state
+ Z___
+ Z__Z
+ _Z_Z
+ __ZZ

julia> canonicalize!(state)
+ Z___
+ _Z__
+ __Z_
+ ___Z

julia> anticom_index, result
(1, nothing)
```

And an example of projection consistent with the stabilizer state.

```jldoctest
julia> s = S"ZII
             IXI
             IIY";


julia> canonicalize!(s)
+ _X_
+ __Y
+ Z__

julia> state, anticom_index, result = project!(s, P"-ZII");


julia> state
+ _X_
+ __Y
+ Z__

julia> anticom_index, result
(0, 0x02)
```

While not the best choice, `Stabilizer` can be used for mixed states,
simply by providing an incomplete tableau. In that case it is possible
to attempt to project on an operator that can not be generated by the
provided stabilizer operators. In that case we have `anticom_index==rank`
and `result===nothing`, where `rank` is the the new rank of the tableau,
one more than the number of rows in the initial tableau. However, if
`keep_result` was set to `false`, then `anticom_index` would stay at zero.

```jldoctest
julia> s = S"XZI
             IZI";


julia> project!(s, P"IIX")[1]
+ X__
+ _Z_
```

If we had used [`MixedStabilizer`](@ref) we would have added the projector
to the list of stabilizers.

```jldoctest
julia> s = one(MixedStabilizer, 2, 3)
+ Z__
+ _Z_

julia> project!(s, P"IIX")[1]
+ Z__
+ _Z_
+ __X
```

However, [`MixedDestabilizer`](@ref) would
be an even better choice as it has \$\\mathcal{O}(n^2)\$ complexity
instead of the \$\\mathcal{O}(n^3)\$ complexity of `*Stabilizer`.

```jldoctest
julia> s = one(MixedDestabilizer, 2, 3)
𝒟ℯ𝓈𝓉𝒶𝒷
+ X__
+ _X_
𝒳ₗ━━━
+ __X
𝒮𝓉𝒶𝒷━
+ Z__
+ _Z_
𝒵ₗ━━━
+ __Z

julia> project!(s, P"IIX")[1]
𝒟ℯ𝓈𝓉𝒶𝒷
+ X__
+ _X_
+ __Z
𝒮𝓉𝒶𝒷━
+ Z__
+ _Z_
+ __X
```

See the "Datastructure Choice" section in the documentation for more details.

See also: [`projectX!`](@ref), [`projectY!`](@ref), [`projectZ!`](@ref), [`projectrand!`](@ref)
"""
function project!(state,pauli::PauliOperator;keep_result::Bool=true,phases::Bool=true)
    @valbooldispatch _project!(state,pauli;keep_result=Val(keep_result),phases=Val(phases)) keep_result phases
end

# TODO maybe just add keep_result to it, for consistency
"""
$TYPEDSIGNATURES

When using [`project!`](@ref) on [`MixedStabilizer`](@ref) it automates some of the extra
steps we encounter when implicitly using the `Stabilizer` datastructure to
represent mixed states. Namely, it helps when the projector is not among the
list of stabilizers:

```jldoctest
julia> s = S"XZI
             IZI";


julia> ms = MixedStabilizer(s)
+ X__
+ _Z_

julia> project!(ms, P"IIY")[1]
+ X__
+ _Z_
+ __Y
```

Similarly to [`project!`](@ref) on [`Stabilizer`](@ref), this function has cubic
complexity when the Pauli operator commutes with all rows of the tableau.
Most of the time it is better to simply use [`MixedDestabilizer`](@ref) representation.

Unlike other `project!` methods, this one does not allow for
`keep_result=false`, as the correct rank or anticommutation index can not be
calculated without the expensive (cubic) canonicalization operation required
by `keep_result=true`.

See the "Datastructure Choice" section in the documentation for more details.

See also: [`projectX!`](@ref), [`projectY!`](@ref), [`projectZ!`](@ref).
"""
function project!(state::MixedStabilizer,pauli::PauliOperator;phases::Bool=true)
    @valbooldispatch _project!(state,pauli;phases=Val(phases)) phases
end

function _project!(stabilizer::Stabilizer,pauli::PauliOperator;keep_result::Val{Bkr}=Val(true),phases::Val{Bp}=Val(true)) where {Bkr,Bp}
    anticommutes = 0
    n = size(stabilizer,1)
    for i in 1:n  # The explicit loop is faster than anticommutes = findfirst(row->comm(pauli,stabilizer,row)!=0x0, 1:n); both do not allocate.
        if comm(pauli,stabilizer,i)!=0x0
            anticommutes = i
            break
        end
    end
    if anticommutes == 0
        if Bkr
            _,_,r = _canonicalize!(stabilizer; phases, ranks=Val(true)) # O(n^3)
            gen = _generate!(copy(pauli), stabilizer; phases) # O(n^2)
            if isnothing(gen)
                result = nothing
                anticommutes = r+1
            else
                result = gen[1].phase[]
            end
        else
            result = nothing
        end
    else
        for i in anticommutes+1:n
            if comm(pauli,stabilizer,i)!=0
                mul_left!(stabilizer, i, anticommutes; phases)
            end
        end
        stabilizer[anticommutes] = pauli
        result = nothing
    end
    stabilizer, anticommutes, result
end

function _project!(ms::MixedStabilizer,pauli::PauliOperator;phases::Val{B}=Val(true)) where B
    _, anticom_index, res = _project!(stabilizerview(ms), pauli; keep_result=Val(true), phases=phases)
    if anticom_index==ms.rank+1 && isnothing(res)
        ms.tab[ms.rank+1] = pauli
        ms.rank += 1
    end
    ms, anticom_index, res
end

@inline function anticomm_update_rows(tab,pauli,r,n,anticommutes,phases::Val{B}=Val(true)) where {B} # TODO Ensure there are no redundant `comm` checks that can be skipped
    for i in r+1:n
        if comm(pauli,tab,i)!=0
            mul_left!(tab, i, n+anticommutes; phases=phases)
        end
    end
    for i in n+anticommutes+1:2n
        if comm(pauli,tab,i)!=0
            mul_left!(tab, i, n+anticommutes; phases=phases)
        end
    end
    for i in 1:r
        if i!=anticommutes && comm(pauli,tab,i)!=0
            mul_left!(tab, i, n+anticommutes; phases=Val(false))
        end
    end
end

function _project!(d::Destabilizer,pauli::PauliOperator;keep_result::Val{Bkr}=Val(true),phases::Val{Bp}=Val(true)) where {Bkr, Bp} # repetition between Destabilizer and MixedDestabilizer, but the redundancy makes the two codes slightly simpler and easier to infer
    anticommutes = 0
    tab = QuantumClifford.tab(d)
    stabilizer = stabilizerview(d)
    destabilizer = destabilizerview(d)
    r = trusted_rank(d)
    n = length(d) # not `nqubits(d)` in case we have an incomplete tableau    # Check whether we anticommute with any of the stabilizer rows
    for i in 1:r # The explicit loop is faster than anticommutes = findfirst(row->comm(pauli,stabilizer,row)!=0x0, 1:r); both do not allocate.
        if comm(pauli,stabilizer,i)!=0x0
            anticommutes = i
            break
        end
    end
    if anticommutes == 0
        if n != nqubits(stabilizer)
            throw(BadDataStructure("`Destabilizer` can not efficiently (faster than n^3) detect whether you are projecting on a stabilized or a logical operator. Switch to one of the `Mixed*` data structures.",
                                   :project!,
                                   :Destabilizer))
        end
        if Bkr
            new_pauli = zero(pauli)::PauliOperator # typeassert for JET
            new_pauli.phase[] = pauli.phase[]
            for i in 1:r
                comm(pauli,destabilizer,i)!=0 && mul_left!(new_pauli, stabilizer, i, phases=phases)
            end
            result = new_pauli.phase[]
        else
            result = nothing
        end
    else
        anticomm_update_rows(tab,pauli,r,n,anticommutes,phases)
        destabilizer[anticommutes] = stabilizer[anticommutes]
        stabilizer[anticommutes] = pauli
        result = nothing
    end
    d, anticommutes, result
end

function _project!(d::MixedDestabilizer,pauli::PauliOperator;keep_result::Val{Bkr}=Val(true),phases::Val{Bp}=Val(true)) where {Bkr, Bp} # repetition between Destabilizer and MixedDestabilizer, but the redundancy makes the two codes slightly simpler and easier to infer
    anticommutes = 0
    tab = QuantumClifford.tab(d)
    stabilizer = stabilizerview(d)
    destabilizer = destabilizerview(d)
    r = trusted_rank(d)
    n = length(d) # not `nqubits(d)` in case we have an incomplete tableau    # Check whether we anticommute with any of the stabilizer rows
    for i in 1:r # The explicit loop is faster than anticommutes = findfirst(row->comm(pauli,stabilizer,row)!=0x0, 1:r); both do not allocate.
        if comm(pauli,stabilizer,i)!=0x0
            anticommutes = i
            break
        end
    end
    if anticommutes == 0
        anticomlog = 0
        # Check whether we anticommute with any of the logical X rows
        for i in r+1:n # The explicit loop is faster than findfirst.
            if comm(pauli,tab,i)!=0x0
                anticomlog = i
                break
            end
        end
        if anticomlog==0
            # Check whether we anticommute with any of the logical Z rows
            for i in n+r+1:2*n # The explicit loop is faster than findfirst.
                if comm(pauli,tab,i)!=0x0
                    anticomlog = i
                    break
                end
            end
        end
        if anticomlog!=0
            if anticomlog<=n
                rowswap!(tab, r+1+n, anticomlog)
                n!=r+1 && anticomlog!=r+1 && rowswap!(tab, r+1, anticomlog+n)
            else
                rowswap!(tab, r+1, anticomlog-n)
                rowswap!(tab, r+1+n, anticomlog)
            end
            anticomm_update_rows(tab,pauli,r+1,n,r+1,phases)
            d.rank+=1
            anticommutes = d.rank
            tab[r+1] = tab[n+r+1]
            tab[n+r+1] = pauli
            result = nothing
        else
            if Bkr
                new_pauli = zero(pauli)::PauliOperator # typeassert for JET
                new_pauli.phase[] = pauli.phase[]
                for i in 1:r
                    comm(pauli,destabilizer,i)!=0 && mul_left!(new_pauli, stabilizer, i, phases=phases)
                end
                result = new_pauli.phase[]
            else
                result = nothing
            end
        end
    else
        anticomm_update_rows(tab,pauli,r,n,anticommutes,phases)
        destabilizer[anticommutes] = stabilizer[anticommutes]
        stabilizer[anticommutes] = pauli
        result = nothing
    end
    d, anticommutes, result
end

"""
Measure a given qubit in the X basis.
A faster special-case version of [`project!`](@ref).

See also: [`project!`](@ref), [`projectXrand!`](@ref), [`projectY!`](@ref), [`projectZ!`](@ref).
"""
function projectX!(d::MixedDestabilizer,qubit::Int;keep_result::Bool=true,phases::Bool=true)
    @valbooldispatch project_cond!(d,qubit,Val(isZ),Val((true,false));keep_result,phases=Val(phases)) phases
end

function projectX!(s::AbstractStabilizer,qubit::Int;keep_result::Bool=true,phases::Bool=true)
    project!(s, single_x(nqubits(s), qubit) ; keep_result, phases)
end

"""
Measure a given qubit in the Z basis.
A faster special-case version of [`project!`](@ref).

See also: [`project!`](@ref), [`projectZrand!`](@ref), [`projectY!`](@ref), [`projectX!`](@ref).
"""
function projectZ!(d::MixedDestabilizer,qubit::Int;keep_result::Bool=true,phases::Bool=true)
    @valbooldispatch project_cond!(d,qubit,Val(isX),Val((false,true));keep_result,phases=Val(phases))
end

function projectZ!(s::AbstractStabilizer,qubit::Int;keep_result::Bool=true,phases::Bool=true)
    project!(s, single_z(nqubits(s), qubit) ; keep_result, phases)
end

"""
Measure a given qubit in the Y basis.
A faster special-case version of [`project!`](@ref).

See also: [`project!`](@ref), [`projectYrand!`](@ref), [`projectX!`](@ref), [`projectZ!`](@ref).
"""
function projectY!(d::MixedDestabilizer,qubit::Int;keep_result::Bool=true,phases::Bool=true)
    @valbooldispatch project_cond!(d,qubit,Val(isXorZ),Val((true,true));keep_result,phases=Val(phases))
end

function projectY!(s::AbstractStabilizer,qubit::Int;keep_result::Bool=true,phases::Bool=true)
    project!(s, single_y(nqubits(s), qubit) ; keep_result, phases)
end

@inline isX(tab,row,col) = tab[row,col][1]
@inline isZ(tab,row,col) = tab[row,col][2]
@inline isY(tab,row,col) = (&)(tab[row,col]...)
@inline isXorZ(tab,row,col) = ⊻(tab[row,col]...)

@inline function anticomm_update_rows_cond(tab,qubit,r,n,anticommutes,phases::Val{B},cond::Val{IS}) where {B,IS} # TODO Ensure there are no redundant `comm` checks that can be skipped
    for i in r+1:n
        if IS(tab,i,qubit)
            mul_left!(tab, i, n+anticommutes; phases=phases)
        end
    end
    for i in n+anticommutes+1:2n
        if IS(tab,i,qubit)
            mul_left!(tab, i, n+anticommutes; phases=phases)
        end
    end
    for i in 1:r
        if i!=anticommutes && IS(tab,i,qubit)
            mul_left!(tab, i, n+anticommutes; phases=Val(false))
        end
    end
end

"""Internal method used to implement [`projectX!`](@ref), [`projectZ!`](@ref), and [`projectY!`](@ref)."""
function project_cond!(d::MixedDestabilizer,qubit::Int,cond::Val{IS},reset::Val{RESET};keep_result::Bool=true,phases::Val{PHASES}=Val(true)) where {IS,RESET,PHASES}
    anticommutes = 0
    tab = QuantumClifford.tab(d)
    stabilizer = stabilizerview(d)
    destabilizer = destabilizerview(d)
    r = d.rank
    n = nqubits(d)
    # Check whether we anticommute with any of the stabilizer rows
    for i in 1:r # The explicit loop is faster than anticommutes = findfirst(row->comm(pauli,stabilizer,row)!=0x0, 1:r); both do not allocate.
        if IS(stabilizer,i,qubit)
            anticommutes = i
            break
        end
    end
    if anticommutes == 0
        anticomlog = 0
        # Check whether we anticommute with any of the logical X rows
        for i in r+1:n # The explicit loop is faster than findfirst.
            if IS(tab,i,qubit)
                anticomlog = i
                break
            end
        end
        if anticomlog==0
            # Check whether we anticommute with any of the logical Z rows
            for i in n+r+1:2*n # The explicit loop is faster than findfirst.
                if IS(tab,i,qubit)
                    anticomlog = i
                    break
                end
            end
        end
        if anticomlog!=0
            if anticomlog<=n
                rowswap!(tab, r+1+n, anticomlog)
                n!=r+1 && anticomlog!=r+1 && rowswap!(tab, r+1, anticomlog+n)
            else
                rowswap!(tab, r+1, anticomlog-n)
                rowswap!(tab, r+1+n, anticomlog)
            end
            anticomm_update_rows_cond(tab,qubit,r+1,n,r+1,phases,cond)
            d.rank += 1
            anticommutes = d.rank
            tab[r+1] = tab[n+r+1]
            zero!(tab,n+r+1) # set to projector
            tab[n+r+1,qubit] = RESET
            result = nothing
        else
            if keep_result
                new_pauli = zero(PauliOperator,n)
                for i in 1:r # comm check bellow
                    IS(destabilizer,i,qubit) && mul_left!(new_pauli, stabilizer, i, phases=phases)
                end
                result = new_pauli.phase[]
            else
                result = nothing
            end
        end
    else
        anticomm_update_rows_cond(tab,qubit,r,n,anticommutes,phases,cond)
        destabilizer[anticommutes] = stabilizer[anticommutes]
        zero!(stabilizer, anticommutes) # set to projector
        stabilizer[anticommutes,qubit] = RESET
        result = nothing
    end
    d, anticommutes, result
end

"""
$TYPEDSIGNATURES

Project `qubit` of `state` along the X axis and randomize the phase if necessary.

Lower boilerplate version of [`project!`](@ref).

See also: [`project!`](@ref), [`projectX!`](@ref), [`projectZrand!`](@ref), [`projectYrand!`](@ref)
"""
function projectXrand!(state, qubit)
    _, anticom, res = projectX!(state, qubit)
    isnothing(res) && (res = tab(stabilizerview(state)).phases[anticom] = rand((0x0, 0x2)))
    return state, res
end

"""
$TYPEDSIGNATURES

Project `qubit` of `state` along the Z axis and randomize the phase if necessary.

Lower boilerplate version of [`project!`](@ref).

See also: [`project!`](@ref), [`projectZ!`](@ref), [`projectXrand!`](@ref), [`projectYrand!`](@ref)
"""
function projectZrand!(state, qubit)
    _, anticom, res = projectZ!(state, qubit)
    isnothing(res) && (res = tab(stabilizerview(state)).phases[anticom] = rand((0x0, 0x2)))
    return state, res
end

"""
$TYPEDSIGNATURES

Project `qubit` of `state` along the Y axis and randomize the phase if necessary.

Lower boilerplate version of [`project!`](@ref).

See also: [`project!`](@ref), [`projectY!`](@ref), [`projectXrand!`](@ref), [`projectZrand!`](@ref)
"""
function projectYrand!(state, qubit)
    _, anticom, res = projectY!(state, qubit)
    isnothing(res) && (res = tab(stabilizerview(state)).phases[anticom] = rand((0x0, 0x2)))
    return state, res
end

"""
$TYPEDSIGNATURES

Measure `pauli` operator on `state` and randomize the phase if necessary.

Lower boilerplate version of [`project!`](@ref).

See also: [`project!`](@ref), [`projectXrand!`](@ref), [`projectZrand!`](@ref), [`projectYrand!`](@ref)
"""
function projectrand!(state, pauli)
    _, anticom, res = project!(state, pauli)
    isnothing(res) && (res = tab(stabilizerview(state)).phases[anticom] = rand((0x0, 0x2)))
    return state, res
end

"""
$TYPEDSIGNATURES

Trace out a qubit.

See also: [`delete_columns`](@ref)
""" # TODO all of these should raise an error if length(qubits)>rank
function traceout!(s::Stabilizer, qubits; phases=true, rank=false)
    _,i = canonicalize_rref!(s,qubits;phases=phases)
    for j in i+1:size(s,1)
        zero!(s,j)
    end
    if rank return (s, i) else return s end
end

"""
$TYPEDSIGNATURES
"""
function traceout!(s::Union{MixedStabilizer, MixedDestabilizer}, qubits; phases=true, rank=false)
    _,i = canonicalize_rref!(s,qubits;phases=phases)
    s.rank = i
    if rank return (s, i) else return s end
end

function _expand_pauli(pauli::PauliOperator,qubits,n) # TODO rename and make public
    expanded = zero(PauliOperator,n)
    for (ii, i) in enumerate(qubits)
        expanded[i] = pauli[ii]
    end
    expanded.phase[] = pauli.phase[]
    expanded
end

"""
$TYPEDSIGNATURES

Reset a given set of qubits to be in the state `newstate`.
These qubits are traced out first, which could lead to "nonlocal" changes in
the tableau.
"""
function reset_qubits!(s::Stabilizer, newstate, qubits; phases=true)
    nqubits(newstate)==length(qubits) || throw(DimensionMismatch("`qubits` and `newstate` have to be of consistent size"))
    length(qubits) <= nqubits(s) || throw(DimensionMismatch("the stabilizer is not big enough to contain the new state"))
    n = nqubits(s)
    s, x, z = canonicalize!(s,ranks=true) # TODO this is unnecessary, but it provides for nicely formatted tableaux; consider removing it for speed reasons
    _, rref_i = canonicalize_rref!((@view s[1:z]),qubits,phases=phases)
    for row in 1:length(newstate)
        s[row+rref_i] = _expand_pauli(newstate[row], qubits, n) # TODO do something that does not allocate temporary arrays
    end
    for row in rref_i+length(newstate)+1:z
        zero!(s,row)
    end
    s
end

"""
$TYPEDSIGNATURES
"""
function reset_qubits!(s::MixedStabilizer, newstate, qubits; phases=true) # TODO create the necessary interfaces so that Stabilizer and MixedStabilizer share this code
    nqubits(newstate)==length(qubits) || throw(DimensionMismatch("`qubits` and `newstate` have to be of consistent size"))
    length(qubits) <= nqubits(s) || throw(DimensionMismatch("the stabilizer is not big enough to contain the new state"))
    n = nqubits(s)
    sv = stabilizerview(s)
    sv, rref_i = canonicalize_rref!(sv,qubits,phases=phases)
    for row in 1:length(newstate)
        s.tab[row+rref_i] = _expand_pauli(newstate[row], qubits, n) # TODO do something that does not allocate temporary arrays
    end
    s.rank = rref_i+length(newstate)
    s
end

"""
$TYPEDSIGNATURES
"""
function reset_qubits!(s::MixedDestabilizer, newstate::AbstractStabilizer, qubits; phases=true) # TODO this is really inefficient
    _phases = Val(phases)
    nqubits(newstate)==length(qubits) || throw(DimensionMismatch("`qubits` and `newstate` have to be of consistent size"))
    length(qubits) <= nqubits(s) || throw(DimensionMismatch("the stabilizer is not big enough to contain the new state"))
    newstatestab = stabilizerview(newstate)
    traceout!(s,qubits)
    for pauli in newstatestab
        expanded = _expand_pauli(pauli, qubits, nqubits(s)) # TODO, use a sparse project that does not require this expand
        _, anticomm, res = project!(s,expanded, phases=phases) # TODO make an `apply_measurement_phase!(project!(...), phase)`
        sv =  stabilizerview(s)
        if anticomm!=0 # Does not commute with the stabilizer or logical ops
            tab(sv).phases[anticomm] = pauli.phase[]
        else # Commutes with everyone
            if res!=0 && phases # TODO many of the checks below were already done by project!; find a way to not repeat them
                destab = destabilizerview(s)
                r = LinearAlgebra.rank(s)
                loc = findfirst(i->comm(pauli,destab,i)!=0, 1:r)::Int # `nothing` should not be a possible answer
                for i in loc+1:r
                    if comm(pauli, destab, i)!=0
                        mul_left!(s, i, loc; phases=_phases)
                    end
                end
                sv[loc] = pauli
            end
        end
    end
    s
end

"""
    expect(p::PauliOperator, st::AbstractStabilizer)

Compute the expectation value of a Pauli operator `p` on a stabilizer state `st`.
This function will allocate a temporary copy of the stabilizer state `st`.
"""
function expect(p::PauliOperator, s::AbstractStabilizer)
    nqubits(p) == nqubits(s) || error("The number of qubits does not match")
    _, _, result = project!(copy(s), p)
    result === nothing && return 0
    result === 0x00 && return 1
    result === 0x01 && return im
    result === 0x02 && return -1
    result === 0x03 && return -im
end

"""Put source tableau in target tableau at given row and column. Assumes target location is zeroed out.""" # TODO implement a getindex setindex interface to this
@inline function puttableau!(target::Tableau{V1,M1}, source::Tableau{V2,M2}, row::Int, col::Int; phases::Val{B}=Val(true)) where {B,V1,V2,T<:Unsigned,M1<:AbstractMatrix{T},M2<:AbstractMatrix{T}}
    xzs = target.xzs
    ph = target.phases
    sxzs = source.xzs
    sph = source.phases
    r,n = size(source)
    bₗ = _div(T,col) + 1
    bᵣ = bₗ + 1
    eₗ = bₗ + _div(T,n-1)
    eᵣ = _div(T,col+n-1) + 1
    shiftₗ = _mod(T,col)
    shiftᵣ = 8*sizeof(T)-shiftₗ
    for i in 1:r
    @inbounds @simd for j in 0:eₗ-bₗ # TODO more simdification
        xzs[bₗ+j,row+i] |= sxzs[j+1,i] >>> -shiftₗ
        xzs[end÷2+bₗ+j,row+i] |= sxzs[end÷2+j+1,i] >>> -shiftₗ
    end
    @inbounds @simd for j in 0:eᵣ-bᵣ
        xzs[bᵣ+j,row+i] |= sxzs[j+1,i] >>> shiftᵣ
        xzs[end÷2+bᵣ+j,row+i] |= sxzs[end÷2+j+1,i] >>> shiftᵣ
    end
    end
    B && (ph[row+1:row+r] .= sph)
    target, row+r, col+n
end

function puttableau!(target::Stabilizer{T1}, source::Stabilizer{T2}, row::Int, col::Int; phases::Val{B}=Val(true)) where {B,T1,T2}
    puttableau!(tab(target), tab(source), row, col; phases)
end
function puttableau!(target::Tableau, source::Stabilizer{T2}, row::Int, col::Int; phases::Val{B}=Val(true)) where {B,T2}
    puttableau!(target, tab(source), row, col; phases)
end
function puttableau!(target::Stabilizer{T1}, source::Tableau, row::Int, col::Int; phases::Val{B}=Val(true)) where {B,T1}
    puttableau!(tab(target), source, row, col; phases)
end

"""
    _compact_xzs_words(xzs, nqubits)

Return `xzs` with only the packed word rows needed for `nqubits`.

Packed tableau data stores all X words followed by all Z words. After removing a
qubit across a word boundary, the old backing array can still contain too many
word rows. Leaving that oversized layout in place breaks the split point used by
low-level operations such as `comm`, which can then read stale X words as Z
words. This helper preserves the no-allocation path when the word count is
unchanged and allocates a compact matrix only when the word count shrinks.
"""
function _compact_xzs_words(xzs::AbstractMatrix{T}, nqubits::Int) where {T<:Unsigned}
    old_nwords = size(xzs, 1) ÷ 2
    new_nwords = cld(nqubits, 8 * sizeof(T))
    new_nwords < old_nwords || return xzs

    compact_xzs = similar(xzs, 2 * new_nwords, size(xzs, 2))
    if new_nwords > 0
        @views begin
            compact_xzs[1:new_nwords, :] .= xzs[1:new_nwords, :]
            compact_xzs[(new_nwords + 1):(2 * new_nwords), :] .=
                xzs[(old_nwords + 1):(old_nwords + new_nwords), :]
        end
    end
    compact_xzs
end

"""Unexported low-level function that removes a column.

Columns to the right of the target are shifted one step left. Because Tableau is
not mutable we return a new Tableau. The backing xzs array is reused unless the
removal crosses a packed-word boundary.
"""
function remove_column!(s::Tableau{V,M}, col::Int) where {V,T<:Unsigned,M<:AbstractMatrix{T}}
    rows,cols=size(s)
    xzs = s.xzs
    big = _div(T,col-1) + 1
    nbig = size(s.xzs,1)÷2
    shiftᵣ = 8*sizeof(T)-1
    zero_span = ~zero(T) << _mod(T,col-1)
    zero_first = ~zero(T) >> 1
    for i in 1:rows # TODO more simdification
        xzs[big,i]        = (xzs[big,i]       & ~zero_span) | ( zero_span & (xzs[big,i]       >>> 1))
        xzs[end÷2+big,i]  = (xzs[end÷2+big,i] & ~zero_span) | ( zero_span & (xzs[end÷2+big,i] >>> 1))
        for j in big+1:nbig
            xzs[j-1,i]        = (xzs[j-1,i]       & zero_first) | (xzs[j,i]       << shiftᵣ)
            xzs[end÷2+j-1,i]  = (xzs[end÷2+j-1,i] & zero_first) | (xzs[end÷2+j,i] << shiftᵣ)
            xzs[j,i] = xzs[j,i] >> 1
            xzs[end÷2+j,i] = xzs[end÷2+j,i] >> 1
        end
    end
    new_nqubits = nqubits(s) - 1
    Tableau(s.phases, new_nqubits, _compact_xzs_words(s.xzs, new_nqubits))
end
remove_column!(s::Stabilizer, col::Int) = Stabilizer(remove_column!(tab(s),col))

"""Unexported low-level function that moves row i to row j.

Used on its own, this function will break invariants. Meant to be used in `_remove_rowcol!`.
"""
@inline function _rowmove!(s::Tableau, i, j; phases::Val{B}=Val(true)) where B
    (i == j) && return
    B && begin s.phases[j] = s.phases[i] end
    @inbounds @simd for k in 1:size(s.xzs,1)
        s.xzs[k,j] = s.xzs[k,i]
    end
end
@inline _rowmove!(s::Stabilizer, i, j; phases::Val{B}=Val(true)) where B = _rowmove!(tab(s), i, j; phases)

"""Unexported low-level function that removes a row (by shifting all rows up as necessary)

Because MixedDestabilizer is not mutable we return a new MixedDestabilizer.

Used on its own, this function will break invariants. Meant to be used with `projectremove!`.
"""
function _remove_rowcol!(s::MixedDestabilizer, r,c)
    t = tab(s)
    rows, cols = size(t)
    t = remove_column!(t,c) # TODO col and row removal should be done in the same loop, not two separate loops
    for i in r+1:cols+r-1
        _rowmove!(t, i, i-1)
    end
    for i in cols+r+1:rows
        _rowmove!(t, i, i-2)
    end
    oldrank = rank(s)
    newrank = r<=oldrank ? oldrank-1 : oldrank
    MixedDestabilizer(Tableau((@view t.phases[1:end-2]),cols-1,(@view t.xzs[:,1:end-2])), newrank)
end

#=
"""Unexported low-level function that projects a qubit and returns the result while making the tableau smaller by a qubit.

Because MixedDestabilizer is not mutable we return a new MixedDestabilizer with the same (modified) xzs array.
"""
function projectremove!(s::MixedDestabilizer, projfunc::F, qubit) where {F<:Union{typeof(projectX!),typeof(projectY!),typeof(projectZ!)}}
    error("can not be implemented in the style of project!, because one can not change `res` after the row has been removed")
end
=#

"""Unexported low-level function that projects a qubit and returns the result while making the tableau smaller by a qubit.

Because MixedDestabilizer is not mutable we return a new MixedDestabilizer with the same (modified) xzs array.
"""
function projectremoverand!(s::MixedDestabilizer, projfunc::F, qubit) where {F<:Union{typeof(projectX!),typeof(projectY!),typeof(projectZ!)}}
    _, anticom, res = projfunc(s, qubit)
    if anticom!=0
        res = rand((0x0,0x2))
        phases(stabilizerview(s))[anticom] = res
    end
    r = rank(s)
    traceout!(s,[qubit]) # TODO this can be optimized thanks to the information already known from projfunc
    s = _remove_rowcol!(s, r, qubit)
    s, res
end

function traceoutremove!(s::MixedDestabilizer, qubit)
    traceout!(s,[qubit]) # TODO this can be optimized thanks to the information already known from projfunc
    s = _remove_rowcol!(s, nqubits(s), qubit)
end


"""
Return the given stabilizer without all the qubits in the given iterable.

The resulting tableaux is not guaranteed to be valid (to retain its commutation relationships).

```jldoctest
julia> delete_columns(S"XYZ YZX ZXY", [1,3])
+ Y
+ Z
+ X
```

See also: [`traceout!`](@ref)
"""
function delete_columns(𝒮::Stabilizer, subset)
    if length(𝒮) == 0 return 𝒮 end
    return 𝒮[:, setdiff(1:nqubits(𝒮), subset)]
end

function ptrace(s::Stabilizer, to_traceout::Base.AbstractVecOrTuple{Int})
    n = nqubits(s)
    to_keep = setdiff(1:n, to_traceout)
    s = traceout!(copy(s), to_traceout)
    s[:,to_keep]
end

function ptrace(s::MixedStabilizer, to_traceout::Base.AbstractVecOrTuple{Int})
    n = nqubits(s)
    to_keep = setdiff(1:n, to_traceout)
    s = traceout!(copy(s), to_traceout)
    MixedStabilizer(tab(s)[:,to_keep], rank(s))
end

function ptrace(s::MixedDestabilizer, to_traceout::Base.AbstractVecOrTuple{Int})
    n = nqubits(s)
    to_keep = setdiff(1:n, to_traceout)
    s = traceout!(copy(s), to_traceout)
    if rank(s) == 0
        return one(typeof(s), 0, length(to_keep))
    else
        return MixedDestabilizer(stabilizerview(s)[:,to_keep]) # TODO this can be faster by avoiding the repeated canonicalization
    end
end

const all_single_qubit_patterns = (
    (true, false, false, true), # X, Z ↦ X, Z
    (false, true, true, true),  # X, Z ↦ Z, Y
    (true, true, true, false),  # X, Z ↦ Y, X
    (false, true, true, false), # X, Z ↦ Z, X - Hadamard
    (true, false, true, true),  # X, Z ↦ X, Y
    (true, true, false, true)   # X, Z ↦ Y, Z - Phase
)

"""Generate a symbolic single-qubit gate given its index. Optionally, set non-trivial phases.

```jldoctest
julia> enumerate_single_qubit_gates(6)
sPhase on qubit 1
X₁ ⟼ + Y
Z₁ ⟼ + Z

julia> enumerate_single_qubit_gates(6, qubit=2, phases=(true, true))
SingleQubitOperator on qubit 2
X₁ ⟼ - Y
Z₁ ⟼ - Z
```

See also: [`enumerate_cliffords`](@ref)."""
function enumerate_single_qubit_gates(index; qubit=1, phases::Tuple{Bool,Bool}=(false,false))
    @assert index<=6 "Only 6 single-qubit gates exit, up to the choice of phases"
    if phases==(false,false)
        if index==4
            return sHadamard(qubit)
        elseif index==6
            return sPhase(qubit)
        else
            return SingleQubitOperator(qubit, all_single_qubit_patterns[index]..., false, false)
        end
    else
        if index==1
            if     (phases[1], phases[2]) == (false, false)
                return sId1(qubit)
            elseif (phases[1], phases[2]) == (false,  true)
                return sX(qubit)
            elseif (phases[1], phases[2]) == (true,  false)
                return sZ(qubit)
            else
                return sY(qubit)
            end
        else
            return SingleQubitOperator(qubit, all_single_qubit_patterns[index]..., phases...)
        end
    end
end

"""The size of the Clifford group `𝒞` over a given number of qubits, possibly modulo the phases.

For n qubits, not accounting for phases is `2ⁿⁿΠⱼ₌₁ⁿ(4ʲ-1)`. There are `4ⁿ` different phase configurations.

```jldoctest
julia> clifford_cardinality(7)
457620995529680351512370381586432000
```

When not accounting for phases (`phases = false`) the result is the same as the size of the Symplectic group `Sp(2n) ≡ 𝒞ₙ/𝒫ₙ`, where `𝒫ₙ` is the Pauli group over `n` qubits.

```jldoctest
julia> clifford_cardinality(7, phases=false)
27930968965434591767112450048000
```

See also: [`enumerate_cliffords`](@ref).
"""
function clifford_cardinality(n::Int; phases=true)
    base = BigInt(2)^(n^2) * prod(1:n) do j; BigInt(4)^j-1 end
    if phases
        base*BigInt(2)^(2n)
    else
        base
    end
end

@inline function _findanticommGS(basis, start, n, padded_n, δn)
    for i in δn+start+1:padded_n
        comm(basis, δn+start, i)==0x1 && return i
    end
    for i in padded_n+δn+start:2padded_n+1
        comm(basis, δn+start, i)==0x1 && return i
    end
    # the following happens only if the input is P"X___..."
    rowswap!(basis, δn+start, 2padded_n+1; phases=Val(false))
    _findanticommGS(basis, start, n, padded_n, δn)
end

@inline function _eliminateGS(basis, start, n, padded_n, δn)
    for i in δn+start+1:padded_n
        x = comm(basis, δn+start, i)==0x1
        z = comm(basis, padded_n+δn+start, i)==0x1
        z && mul_left!(basis, i, δn+start; phases=Val(false))
        x && mul_left!(basis, i, padded_n+δn+start; phases=Val(false))
    end
    for i in padded_n+δn+start+1:2padded_n+1
        x = comm(basis, δn+start, i)==0x1
        z = comm(basis, padded_n+δn+start, i)==0x1
        z && mul_left!(basis, i, δn+start; phases=Val(false))
        x && mul_left!(basis, i, padded_n+δn+start; phases=Val(false))
    end
end

"""Perform the Symplectic Gram-Schmidt procedure that gives a Clifford operator canonically related to a given Pauli operator.

The algorithm is detailed in [koenig2014efficiently](@cite).

```jldoctest
julia> symplecticGS(P"X", padded_n=3)
X₁ ⟼ + X__
X₂ ⟼ + _X_
X₃ ⟼ + __X
Z₁ ⟼ + Z__
Z₂ ⟼ + _Z_
Z₃ ⟼ + __Z

julia> symplecticGS(P"Z")
X₁ ⟼ + Z
Z₁ ⟼ + X
```

See also: [`enumerate_cliffords`](@ref), [`clifford_cardinality`](@ref)."""
function symplecticGS(pauli::PauliOperator; padded_n=nqubits(pauli))
    n = nqubits(pauli)
    basis = zero(Tableau, 2padded_n+1, padded_n)
    δn = padded_n-n
    # fillup the padded tableau
    for i in 1:δn
        basis[i,i] = (true,false)
        basis[padded_n+i,i] = (false,true)
    end
    for i in δn+1:padded_n-1
        basis[i+1,i] = (true,false)
        basis[padded_n+i+1,i] = (false,true)
    end
    for i in 1:n basis[δn+1,δn+i] = pauli[i] end
    basis[padded_n+δn+1,padded_n] = (true,false)
    basis[2padded_n+1,padded_n] = (false,true)
    # end fillup
    doneupto = 1
    while doneupto <= n
        i = _findanticommGS(basis, doneupto, n, padded_n, δn)
        rowswap!(basis, padded_n+δn+doneupto, i; phases=Val(false))
        _eliminateGS(basis, doneupto, n, padded_n, δn)
        doneupto += 1
    end
    CliffordOperator((@view basis[1:2padded_n]))
end

@inline function int_to_bits(n,i)
    Bool[i>>d&0x1 for d in 0:n-1]
end

"""Give the i-th n-qubit Clifford operation, where i∈{1..2ⁿⁿΠⱼ₌₁ⁿ(4ʲ-1)}

The algorithm is detailed in [koenig2014efficiently](@cite).

See also: [`symplecticGS`](@ref), [`clifford_cardinality`](@ref)."""
function enumerate_cliffords(n,i;padded_n=n,onlycoset=false)
    enumerate_cliffords_slow(n,i;padded_n,onlycoset)
end

"""The O(n^4) implementation from [koenig2014efficiently](@cite) -- their algorithm seems wrong as ⟨w'₁|wₗ⟩=bₗ which is not always zero."""
function enumerate_cliffords_slow(n,i;padded_n=n,onlycoset=false) # TODO implement the faster n^3 algorithm
    @assert n<32 # Assuming 64 bit system
    s = 2^(2n)-1
    k = (i-1)%s+1
    pauli = PauliOperator(int_to_bits(2n,k))
    op = symplecticGS(pauli;padded_n)
    basis = tab(op)
    δn = padded_n-n
    idivs = (i-1)÷s
    for j in 0:n-1 # first n bits # w₁ ← w₁+vⱼ
        iszero(idivs>>j&0x1) || mul_left!(basis, padded_n+δn+1, δn+j+1; phases=Val(false))
    end
    for j in n:2n-2 # following n-1 bits # w₁ ← w₁+wⱼ
        iszero(idivs>>j&0x1) || mul_left!(basis, padded_n+δn+1, 2δn+j+2; phases=Val(false))
    end
    for j in 1:n-1 # first n-1 bits after first bit # wⱼ ← wⱼ+v₁ # missing from koenig2014efficiently
        iszero(idivs>>j&0x1) || mul_left!(basis, padded_n+δn+j+1, δn+1; phases=Val(false)) # δn+j+1+n
    end
    for j in n:2n-2 # following n-1 bits # vⱼ ← vⱼ+v₁ # missing from koenig2014efficiently
        iszero(idivs>>j&0x1) || mul_left!(basis, δn+j+2-n, δn+1; phases=Val(false))
    end
    if n==1 || onlycoset
        return op
    else
        subop = enumerate_cliffords(n-1,idivs÷2^(2n-1)+1;padded_n)
        return apply!(subop, op; phases=false)
    end
end

"""Give all n-qubit Clifford operations.

The algorithm is detailed in [koenig2014efficiently](@cite).

See also: [`symplecticGS`](@ref), [`clifford_cardinality`](@ref)."""
function enumerate_cliffords(n;padded_n=n,onlycoset=false) # TODO make an enumerator that does not compute the cosets from scratch each time
    if onlycoset
        cosetsize = (2^(2n)-1)*2^(2n-1)
        (enumerate_cliffords(n,i;padded_n,onlycoset=true) for i in 1:cosetsize)
    else
        (enumerate_cliffords(n,i;padded_n,onlycoset=false) for i in 1:clifford_cardinality(n;phases=false))
    end
end

@inline function _change_phases!(op, phases)
    tab(op).phases .= 0x2 .* phases
    op
end

"""Given an operator, return all operators that have the same tableau but different phases.

```jldoctest
julia> length(collect(enumerate_phases(tCNOT)))
16
```

See also: [`enumerate_cliffords`](@ref), [`clifford_cardinality`](@ref)."""
function enumerate_phases(op::CliffordOperator)
    n = nqubits(op)
    (_change_phases!(copy(op), int_to_bits(2n,i)) for i in 0:2^(2n)-1)
end

"""Given a set of operators, return all operators that have the same tableaux but different phases.

```jldoctest
julia> length(collect(enumerate_phases(enumerate_cliffords(2))))
11520
```

See also: [`enumerate_cliffords`](@ref), [`clifford_cardinality`](@ref)."""
function enumerate_phases(ops::Union{AbstractVector,Base.Generator})
    Iterators.flatten(Iterators.map(enumerate_phases, ops))
end

"""
A multi-qubit Pauli operator (``±\\{1,i\\}\\{I,Z,X,Y\\}^{\\otimes n}``).

A Pauli can be constructed with the `P` custom string macro or by building
up one through products and tensor products of smaller operators.

```jldoctest
julia> pauli3 = P"-iXYZ"
-iXYZ

julia> pauli4 = 1im * pauli3 ⊗ X
+ XYZX

julia> Z*X
+iY
```

We use a typical F(2,2) encoding internally. The X and Z bits are stored
in a single concatenated padded array of UInt chunks of a bit array.

```jldoctest
julia> p = P"-IZXY";


julia> p.xz
2-element Vector{UInt64}:
 0x000000000000000c
 0x000000000000000a
```

You can access the X and Z bits through getters and setters or through the
`xview`, `zview`, `xbit`, and `zbit` functions.

```jldoctest
julia> p = P"XYZ"; p[1]
(true, false)

julia> p[1] = (true, true); p
+ YYZ
```
"""
struct PauliOperator{
    P <: AbstractArray{<: Unsigned, 0}, XZ <: AbstractVector{<: Unsigned}
} <: AbstractCliffordOperator
    phase::P
    nqubits::Int
    xz::XZ
end

function PauliOperator(
    phase::Unsigned, nqubits::Int, xz::AbstractVector{<: Unsigned}
)
    p = similar(xz, typeof(phase), ())
    fill!(p, phase)
    return PauliOperator(p, nqubits, xz)
end

function PauliOperator(phase::Unsigned, x::BitVector, z::BitVector)
    xs = reinterpret(UInt, x.chunks)
    zs = reinterpret(UInt, z.chunks)
    xz = cat(xs, zs; dims = 1)
    p = similar(xz, typeof(phase), ())
    fill!(p, phase)
    return PauliOperator(p, length(x), xz)
end

function PauliOperator(
    phase::Unsigned, x::AbstractVector{Bool}, z::AbstractVector{Bool}
)
    return PauliOperator(phase, BitVector(x), BitVector(z))
end

PauliOperator(x::AbstractVector{Bool}, z::AbstractVector{Bool}) = PauliOperator(0x0, x, z)
PauliOperator(xz::AbstractVector{Bool}) = PauliOperator(0x0, (@view xz[1:end÷2]), (@view xz[end÷2+1:end]))

"""Get a view of the X part of the `UInt` array of packed qubits of a given Pauli operator."""
function xview(p::PauliOperator)
    @view p.xz[1:end÷2]
end
"""Get a view of the Y part of the `UInt` array of packed qubits of a given Pauli operator."""
function zview(p::PauliOperator)
    @view p.xz[end÷2+1:end]
end
"""Extract as a new bit array the X part of the `UInt` array of packed qubits of a given Pauli operator."""
function xbit(p::PauliOperator)
    one = eltype(p.xz)(1)
    size = sizeof(eltype(p.xz))*8
    [(word>>s)&one==one for word in xview(p) for s in 0:size-1][begin:p.nqubits]
end
"""Extract as a new bit array the Z part of the `UInt` array of packed qubits of a given Pauli operator."""
function zbit(p::PauliOperator)
    one = eltype(p.xz)(1)
    size = sizeof(eltype(p.xz))*8
    [(word>>s)&one==one for word in zview(p) for s in 0:size-1][begin:p.nqubits]
end

function _P_str(a::Union{String,SubString{String}})
    letters = filter(x->occursin(x,"_IZXY"),a)
    phase = phasedict[strip(filter(x->!occursin(x,"_IZXY"),a))]
    PauliOperator(phase, [l=='X'||l=='Y' for l in letters], [l=='Z'||l=='Y' for l in letters])
end

macro P_str(a)
    quote _P_str($a) end
end

function Base.getindex(p::PauliOperator{Tₚ,Tᵥ}, i::Int) where {Tₚ, Tᵥₑ<:Unsigned, Tᵥ<:AbstractVector{Tᵥₑ}}
    _, ibig, _, ismallm = get_bitmask_idxs(p.xz,i)
    ((p.xz[ibig] & ismallm) != 0x0)::Bool, ((p.xz[end÷2+ibig] & ismallm) != 0x0)::Bool
end
function Base.getindex(p::PauliOperator{Tₚ,Tᵥ}, r::AbstractVector{Int}) where {Tₚ, Tᵥₑ<:Unsigned, Tᵥ<:AbstractVector{Tᵥₑ}}
    xs = BitArray(undef, length(r))
    zs = BitArray(undef, length(r))

    for (i, pos) in enumerate(r)
        xs[i], zs[i] = getindex(p, pos)
    end
    PauliOperator(p.phase[], xs, zs)
end
Base.getindex(p::PauliOperator{Tₚ,Tᵥ}, r) where {Tₚ, Tᵥₑ<:Unsigned, Tᵥ<:AbstractVector{Tᵥₑ}} = PauliOperator(p.phase[], xbit(p)[r], zbit(p)[r])


function Base.setindex!(p::PauliOperator{Tₚ,Tᵥ}, (x,z)::Tuple{Bool,Bool}, i) where {Tₚ, Tᵥₑ, Tᵥ<:AbstractVector{Tᵥₑ}}
    _, ibig, _, ismallm = get_bitmask_idxs(p.xz,i)
    if x
        p.xz[ibig] |= ismallm
    else
        p.xz[ibig] &= ~(ismallm)
    end
    if z
        p.xz[end÷2+ibig] |= ismallm
    else
        p.xz[end÷2+ibig] &= ~(ismallm)
    end
    p
end

Base.firstindex(p::PauliOperator) = 1

Base.lastindex(p::PauliOperator) = p.nqubits

Base.eachindex(p::PauliOperator) = 1:p.nqubits

Base.size(pauli::PauliOperator) = (pauli.nqubits,)

Base.length(pauli::PauliOperator) = pauli.nqubits

nqubits(pauli::PauliOperator) = pauli.nqubits

Base.:(==)(l::PauliOperator, r::PauliOperator) = r.phase==l.phase && r.nqubits==l.nqubits && r.xz==l.xz

Base.hash(p::PauliOperator, h::UInt) = hash(p.phase,hash(p.nqubits,hash(p.xz, h)))

Base.copy(p::PauliOperator) = PauliOperator(copy(p.phase),p.nqubits,copy(p.xz))

function LinearAlgebra.inv(p::PauliOperator)
    return PauliOperator(map(x -> -x & 0x3, p.phase), p.nqubits, copy(p.xz))
end

function Base.deleteat!(p::PauliOperator, subset)
    p =p[setdiff(1:length(p), subset)]
    return p
end

_nchunks(i::Int, ::Type{T}) where {T <: Unsigned} = 2 * ((i - 1) ÷ count_zeros(zero(T))) + 2

function Base.zero(::Type{PauliOperator{PS, XZV}}, q) where {
    P <: Unsigned, PS <: AbstractArray{P, 0},
    XZ <: Unsigned, XZV <: AbstractVector{XZ}
}
    return PauliOperator(zeros(P), q, zeros(XZ, _nchunks(q, XZ)))
end

Base.zero(::Type{PauliOperator}, q) = zero(PauliOperator{Array{UInt8, 0}, Vector{UInt}}, q)
Base.zero(p::P) where {P<:PauliOperator} = zero(P, nqubits(p))

"""Zero-out the phases and single-qubit operators in a [`PauliOperator`](@ref)"""
@inline function zero!(p::PauliOperator{P, XZ}) where {P, XZ}
    fill!(p.phase, zero(eltype(P)))
    fill!(p.xz, zero(eltype(XZ)))
    return p
end

"""
Embed a Pauli operator in a larger Pauli operator.

```jldoctest
julia> embed(5, 3, P"-Y")
- __Y__

julia> embed(5, (3,5), P"-YX")
- __Y_X
```
"""
function embed(n::Int, i::Int, p::PauliOperator)
    if nqubits(p) == 1
        pout = zero(typeof(p), n)
        pout[i] = p[1]
        pout.phase[] = p.phase[]
        return pout
    else
        throw(ArgumentError("""
        You are trying to embed a small Pauli operator into a larger Pauli operator.
        However, you have not given all the positions at which the operator needs to be embedded.
        If you are directly calling `embed`, use the form `embed(nqubits, indices::Tuple, p::PauliOperator)`.
        If you are not using `embed` directly, then `embed` must have been incorrectly called
        by one of the functions you have called.
        """))
    end
end

function embed(n::Int, indices, p::PauliOperator)
    if nqubits(p) == length(indices)
        pout = zero(typeof(p), n)
        @inbounds @simd for i_ in eachindex(indices)
            i = i_::Int
            pout[indices[i]] = p[i]
        end
        pout.phase[] = p.phase[]
        return pout
    else
        throw(ArgumentError(lazy"""
        You are trying to embed a small Pauli operator into a larger Pauli operator.
        However, you have not given all the positions at which the operator needs to be embedded.
        The operator you are embedding is of length $(length(p)), but you have specified $(length(indices)) indices.
        If you are not using `embed` directly, then `embed` must have been incorrectly called
        by one of the functions you have called.
        """))
    end
end

@testitem "Stabilizer canonicalization" begin
  using QuantumClifford: stab_looks_good, destab_looks_good, mixed_stab_looks_good, mixed_destab_looks_good
  test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.
    @testset "Default canonicalization" begin
        s = S"- XZZZZ_____
            - _YZY___YX_
            - __XXZ__YX_
            + Z_Z_Y__YXZ
            + _____Z____
            + __________
            + __________
            + ______YYX_
            + __________
            + __________"
        canonicalize!(s)
        t = S"- XZZZZ_____
            - _YZY___YX_
            - __XXZ__YX_
            + Z_Z_Y__YXZ
            + ______YYX_
            + _____Z____
            + __________
            + __________
            + __________
            + __________"
        @test s == t
        for n in test_sizes
            @test stab_looks_good(random_stabilizer(n))
        end
    end
    @testset "Gottesman canonicalization" begin
        for n in test_sizes
            for nrows in [n, rand(n÷3:n*2÷3)]
                rs = random_stabilizer(nrows,n)
                c = canonicalize!(copy(rs))
                g, _, _, perm1, perm2 = canonicalize_gott!(copy(rs))
                c1 = canonicalize!(permutesystems!(permutesystems!(copy(rs),perm1),perm2))
                cg = canonicalize!(copy(g))
                @test cg == c1
                @test stab_looks_good(g)
            end
        end
    end
    @testset "Canonicalization of complex tableaus" begin
        for n in test_sizes
            for nrows in [n, rand(n÷3:n*2÷3)]
                rs = random_stabilizer(nrows,n)
                rs_m = MixedStabilizer(copy(rs))
                rs_d = Destabilizer(copy(rs))
                rs_md = MixedDestabilizer(copy(rs))
                c  = canonicalize!(copy(rs))
                mc  = canonicalize!(copy(rs_m))
                dc = canonicalize!(copy(rs_d))
                mdc = canonicalize!(copy(rs_md))
                @test stabilizerview(mdc) == stabilizerview(mc) == stabilizerview(dc) == c
                @test stab_looks_good(c)
                @test mixed_stab_looks_good(mc)
                @test destab_looks_good(dc)
                @test mixed_destab_looks_good(mdc)
                c  = canonicalize_rref!(copy(rs),1:n)[1]
                mc  = canonicalize_rref!(copy(rs_m),1:n)[1]
                dc = canonicalize_rref!(copy(rs_d),1:n)[1]
                mdc = canonicalize_rref!(copy(rs_md),1:n)[1]
                @test stabilizerview(mdc) == stabilizerview(mc) == stabilizerview(dc) == c
                @test stab_looks_good(c)
                @test mixed_stab_looks_good(mc)
                @test destab_looks_good(dc)
                @test mixed_destab_looks_good(mdc)
            end
        end
    end
end

@testitem "canonicalization invariants" begin
    s = random_stabilizer(40,100)
    ss = tensor_pow(s,20)
    sa1 = canonicalize!(canonicalize_rref!(copy(ss))[1])
    sa2 = canonicalize!(copy(ss))
    @test sa1 == sa2
    ms = MixedDestabilizer(s)
    mss = tensor_pow(ms, 20)
    msa1 = canonicalize!(canonicalize_rref!(copy(mss))[1])
    msa2 = canonicalize!(copy(mss))
    @test stabilizerview(msa1) == stabilizerview(msa2) == sa1
end

@testitem "canonicalization of vectors of Paulis" begin
    using QuantumClifford
    p1 = [P"+XXX", P"-ZZI"]
    p2 = (P"+XXX", P"-ZZI")
    t = T"+XXX -ZZI"
    s = S"+XXX -ZZI"
    @test canonicalize!(p1) == canonicalize!(p2) == canonicalize!(copy(s))
    @test canonicalize_gott!(p1) == canonicalize_gott!(p2) == canonicalize_gott!(copy(s))
    @test canonicalize_rref!(p1) == canonicalize_rref!(p2) == canonicalize_rref!(copy(s))
    @test canonicalize_clip!(p1) == canonicalize_clip!(p2) == canonicalize_clip!(copy(s))
    @test canonicalize_noncomm(p1) == canonicalize_noncomm(p2) == canonicalize_noncomm(t)
end

@testitem "ECC throws" tags=[:ecc, :ecc_base] begin

    using QuantumClifford.ECC: ReedMuller, BCH, RecursiveReedMuller, Golay, Triangular488, Triangular666, Hamming

    @test_throws ArgumentError ReedMuller(-1, 3)
    @test_throws ArgumentError ReedMuller(1, 0)
    @test_throws ArgumentError ReedMuller(4, 2)

    @test_throws ArgumentError BCH(2, 2)
    @test_throws ArgumentError BCH(-2, 2)
    @test_throws ArgumentError BCH(2, -3)
    @test_throws ArgumentError BCH(3, 3)
    @test_throws ArgumentError BCH(3, 4)
    @test_throws ArgumentError BCH(4, 4)
    @test_throws ArgumentError BCH(4, 100)

    @test_throws ArgumentError RecursiveReedMuller(-1, 3)
    @test_throws ArgumentError RecursiveReedMuller(1, 0)
    @test_throws ArgumentError RecursiveReedMuller(4, 2)

    @test_throws ArgumentError Golay(21)

    @test_throws ArgumentError Hamming(1)

    @test_throws ArgumentError Triangular488(8)
    @test_throws ArgumentError Triangular488(1)
    @test_throws ArgumentError Triangular666(8)
    @test_throws ArgumentError Triangular666(1)
end

@testitem "ECC GB" tags=[:ecc, :ecc_bespoke_checks] begin
    using Hecke
    using HiGHS
    using JuMP
    using QuantumClifford: stab_looks_good, stab_to_gf2
    using QuantumClifford.ECC.QECCore: code_k, code_n, distance, rate
    using QuantumClifford.ECC: generalized_bicycle_code_as_2bga, code_k, code_n, DistanceMIPAlgorithm, parity_checks, GeneralizedBicycle, ExtendedGeneralizedBicycle

    # codes taken from Table 1 of [lin2024quantum](@cite)
    # Abelian 2BGA codes can be viewed as GB codes.
    @testset "GB codes" begin
        # [[70, 8, 10]]
        c = generalized_bicycle_code_as_2bga([0, 15, 16, 18], [0, 1, 24, 27], 35)
        @test code_n(c) == 70 && code_k(c) == 8
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_qubit=1)) == 10
        # [[54, 6, 9]]
        c = generalized_bicycle_code_as_2bga([0, 1, 3, 7], [0, 1, 12, 19], 27)
        @test code_n(c) == 54 && code_k(c) == 6
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_qubit=1)) == 9
        # [[60, 6, 10]]
        c = generalized_bicycle_code_as_2bga([0 , 10, 6, 13], [0, 25, 16, 12], 30)
        @test code_n(c) == 60 && code_k(c) == 6
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_qubit=1)) == 10
        # [[72, 8, 10]]
        c = generalized_bicycle_code_as_2bga([0, 9, 28, 31], [0, 1, 21, 34], 36)
        @test code_n(c) == 72 && code_k(c) == 8
        # [[72, 10, 9]]
        c = generalized_bicycle_code_as_2bga([0, 9, 28, 13], [0, 1, 3, 22], 36)
        @test code_n(c) == 72 && code_k(c) == 10
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_qubit=1)) == 9
    end

    @testset "Codes from Appendix B of [koukoulekidis2024smallquantumcodesalgebraic](@cite))" begin
        # [[10, 2, 3]]
        R, x = polynomial_ring(GF(2), "x")
        l = 5
        a = 1 + x^4
        b = 1 + x + x^2 + x^4
        c = GeneralizedBicycle(a, b, l)
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 10 == code_n(stab) && code_k(c) == 2 == code_k(stab)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        @test stab_looks_good(stab, remove_redundant_rows=true) == true
        for m in 2:10
            R, x = polynomial_ring(GF(2), :x)
            ext_code = ExtendedGeneralizedBicycle(c, m, one(R))
            stab = parity_checks(ext_code)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(ext_code) - code_k(ext_code)
            @test code_n(ext_code) == m*10 == code_n(stab) && code_k(ext_code) == 2 == code_k(stab)
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
        end

        # [[12, 2, 3]]
        R, x = polynomial_ring(GF(2), "x")
        l = 6
        a = 1 + x + x^2 + x^5
        b = 1 + x + x^3 + x^5
        c = GeneralizedBicycle(a, b, l)
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 12 == code_n(stab) && code_k(c) == 2 == code_k(stab)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        @test stab_looks_good(stab, remove_redundant_rows=true) == true
        for m in 2:10
            R, x = polynomial_ring(GF(2), :x)
            ext_code = ExtendedGeneralizedBicycle(c, m, one(R))
            stab = parity_checks(ext_code)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(ext_code) - code_k(ext_code)
            @test code_n(ext_code) == m*12 == code_n(stab) && code_k(ext_code) == 2 == code_k(stab)
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
        end

        # [[14, 2, 3]]
        R, x = polynomial_ring(GF(2), "x")
        l = 7
        a = 1 + x^3
        b = 1 + x + x^3 + x^6
        c = GeneralizedBicycle(a, b, l)
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 14 == code_n(stab) && code_k(c) == 2 == code_k(stab)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        @test stab_looks_good(stab, remove_redundant_rows=true) == true
        for m in 2:10
            R, x = polynomial_ring(GF(2), :x)
            ext_code = ExtendedGeneralizedBicycle(c, m, one(R))
            stab = parity_checks(ext_code)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(ext_code) - code_k(ext_code)
            @test code_n(ext_code) == m*14 == code_n(stab) && code_k(ext_code) == 2 == code_k(stab)
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
        end

        # [[16, 2, 3]]
        R, x = polynomial_ring(GF(2), "x")
        l = 8
        a = x + x^3
        b = 1 + x^5
        c = GeneralizedBicycle(a, b, l)
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 16 == code_n(stab) && code_k(c) == 2 == code_k(stab)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        @test stab_looks_good(stab, remove_redundant_rows=true) == true
        for m in 2:10
            R, x = polynomial_ring(GF(2), :x)
            ext_code = ExtendedGeneralizedBicycle(c, m, one(R))
            stab = parity_checks(ext_code)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(ext_code) - code_k(ext_code)
            @test code_n(ext_code) == m*16 == code_n(stab) && code_k(ext_code) == 2 == code_k(stab)
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
        end

        # [[18, 2, 3]]
        R, x = polynomial_ring(GF(2), "x")
        l = 9
        a = 1 + x^2
        b = 1 + x^5
        c = GeneralizedBicycle(a, b, l)
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 18 == code_n(stab) && code_k(c) == 2 == code_k(stab)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        @test stab_looks_good(stab, remove_redundant_rows=true) == true
        for m in 2:10
            R, x = polynomial_ring(GF(2), :x)
            ext_code = ExtendedGeneralizedBicycle(c, m, one(R))
            stab = parity_checks(ext_code)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(ext_code) - code_k(ext_code)
            @test code_n(ext_code) == m*18 == code_n(stab) && code_k(ext_code) == 2 == code_k(stab)
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
        end

        # [[20, 2, 4]]
        R, x = polynomial_ring(GF(2), "x")
        l = 10
        a = 1 + x
        b = 1 + x^6
        c = GeneralizedBicycle(a, b, l)
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 20 == code_n(stab) && code_k(c) == 2 == code_k(stab)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
        @test stab_looks_good(stab, remove_redundant_rows=true) == true
        for m in 2:10
            R, x = polynomial_ring(GF(2), :x)
            ext_code = ExtendedGeneralizedBicycle(c, m, one(R))
            stab = parity_checks(ext_code)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(ext_code) - code_k(ext_code)
            @test code_n(ext_code) == m*20 == code_n(stab) && code_k(ext_code) == 2 == code_k(stab)
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
        end
    end

    @testset "Codes from Table I of https://arxiv.org/pdf/2502.19406" begin
        R, t = polynomial_ring(GF(2), :t)
        # [[30, 8, 4]]
        l = 15
        a = 1 + t^6 + t^13
        b = 1 + t + t^4
        c = GeneralizedBicycle(a, b, l)
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 30 == code_n(stab) && code_k(c) == 8 == code_k(stab)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
        @test stab_looks_good(stab, remove_redundant_rows=true) == true

        # [[62, 10, 6]]
        l = 31
        a = 1 + t + t^12
        b = 1 + t^3 + t^8
        c = GeneralizedBicycle(a, b, l)
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 62 == code_n(stab) && code_k(c) == 10 == code_k(stab)
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
        @test stab_looks_good(stab, remove_redundant_rows=true) == true

        # [[126, 12, 10]]
        l = 63
        a = 1 + t^7 + t^8
        b = 1 + t^37 + t^43
        c = GeneralizedBicycle(a, b, l)
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == 126 == code_n(stab) && code_k(c) == 12 == code_k(stab)
        @test stab_looks_good(stab, remove_redundant_rows=true) == true
    end

    @testset "Generalized Bicycle Codes from Tables V-VIII of https://arxiv.org/abs/2503.03827" begin
        R, y = polynomial_ring(GF(2), :y)
        table_v = [
            (12 , 4 , 1 + y    + y^2 , 1 + y + y^2 , 6),
            (14 , 6 , 1 + y    + y^3 , 1 + y + y^3 , 7),
            (18 , 4 , 1 + y^2  + y^4 , 1 + y + y^2 , 9),
            (24 , 4 , 1 + y^2  + y^4 , 1 + y + y^2 , 12),
            (28 , 6 , 1 + y^2  + y^3 , 1 + y + y^5 , 14),
            (30 , 8 , 1 + y^2  + y^8 , 1 + y + y^4 , 15),
            (36 , 4 , 1 + y^2  + y^4 , 1 + y + y^5 , 18),
            (42 , 10, 1 + y^2  + y^10, 1 + y + y^5 , 21),
            (48 , 4 , 1 + y^5  + y^7 , 1 + y + y^5 , 24),
            (54 , 4 , 1 + y^5  + y^7 , 1 + y + y^5 , 27),
            (56 , 6 , 1 + y^3  + y^9 , 1 + y + y^5 , 28),
            (60 , 8 , 1 + y^7  + y^9 , 1 + y + y^4 , 30),
            (62 , 10, 1 + y^3  + y^8 , 1 + y + y^12, 31),
            (66 , 4 , 1 + y^2  + y^7 , 1 + y + y^11, 33),
            (70 , 6 , 1 + y^3  + y^9 , 1 + y + y^5 , 35),
            (72 , 4 , 1 + y^2  + y^7 , 1 + y + y^11, 36),
            (78 , 4 , 1 + y^5  + y^7 , 1 + y + y^8 , 39),
            (84 , 10, 1 + y^11 + y^13, 1 + y + y^5 , 42),
            (90 , 8 , 1 + y^2  + y^9 , 1 + y + y^12, 45),
            (96 , 4 , 1 + y^5  + y^7 , 1 + y + y^11, 48),
            (98 , 6 , 1 + y^4  + y^12, 1 + y + y^10, 49),
            (102, 4 , 1 + y^4  + y^8 , 1 + y + y^11, 51),
            (108, 4 , 1 + y^8  + y^10, 1 + y + y^8 , 54)
        ]

        table_vi = [
            (112, 6 , 1 + y^3  + y^15, 1 + y + y^10, 56),
            (114, 4 , 1 + y^8  + y^13, 1 + y + y^11, 57),
            (120, 8 , 1 + y^8  + y^21, 1 + y + y^12, 60),
            (124, 10, 1 + y^8  + y^11, 1 + y + y^13, 62),
            (126, 12, 1 + y^12 + y^23, 1 + y + y^8 , 63),
            (132, 4 , 1 + y^4  + y^14, 1 + y + y^14, 66),
            (138, 4 , 1 + y^8  + y^13, 1 + y + y^8 , 69),
            (140, 6 , 1 + y^10 + y^16, 1 + y + y^12, 70),
            (144, 4 , 1 + y^23 + y^28, 1 + y + y^20, 72),
            (146, 18, 1 + y^2  + y^18, 1 + y + y^9 , 73),
            (150, 8 , 1 + y^2  + y^8 , 1 + y + y^19, 75),
            (154, 6 , 1 + y^4  + y^34, 1 + y + y^19, 77),
            (156, 4 , 1 + y^11 + y^16, 1 + y + y^14, 78),
            (162, 4 , 1 + y^7  + y^11, 1 + y + y^14, 81),
            (168, 10, 1 + y^11 + y^19, 1 + y + y^17, 84),
            (170, 16, 1 + y^21 + y^25, 1 + y + y^16, 85),
            (174, 4 , 1 + y^7  + y^11, 1 + y + y^17, 87),
            (180, 8 , 1 + y^8  + y^47, 1 + y + y^34, 90),
            (182, 6 , 1 + y^9  + y^13, 1 + y + y^38, 91),
            (186, 14, 1 + y^8  + y^19, 1 + y + y^14, 93),
            (192, 4 , 1 + y^11 + y^16, 1 + y + y^14, 96),
            (196, 6 , 1 + y^12 + y^22, 1 + y + y^19, 98)
        ]

        table_vii = [
            (198, 4 , 1 + y^11 + y^16, 1 + y + y^14,  99),
            (204, 4 , 1 + y^16 + y^35, 1 + y + y^11, 102),
            (210, 14, 1 + y^11 + y^27, 1 + y + y^19, 105),
            (216, 4 , 1 + y^14 + y^22, 1 + y + y^20, 108),
            (222, 4 , 1 + y^10 + y^14, 1 + y + y^20, 111),
            (224, 6 , 1 + y^3  + y^22, 1 + y + y^31, 112),
            (228, 4 , 1 + y^7  + y^17, 1 + y + y^20, 114),
            (234, 4 , 1 + y^13 + y^29, 1 + y + y^20, 117),
            (238, 6 , 1 + y^9  + y^20, 1 + y + y^24, 119),
            (240, 8 , 1 + y^13 + y^21, 1 + y + y^19, 120),
            (246, 4 , 1 + y^13 + y^20, 1 + y + y^23, 123),
            (248, 10, 1 + y^17 + y^27, 1 + y + y^13, 124),
            (252, 12, 1 + y^25 + y^30, 1 + y + y^8 , 126),
            (254, 14, 1 + y^10 + y^37, 1 + y + y^31, 127),
            (258, 4 , 1 + y^14 + y^19, 1 + y + y^14, 129),
            (264, 4 , 1 + y^13 + y^20, 1 + y + y^17, 132),
            (266, 6 , 1 + y^12 + y^25, 1 + y + y^17, 133),
            (270, 8 , 1 + y^6  + y^23, 1 + y + y^27, 135),
            (276, 4 , 1 + y^8  + y^31, 1 + y + y^20, 138),
            (280, 6 , 1 + y^20 + y^23, 1 + y + y^17, 140),
            (282, 4 , 1 + y^10 + y^17, 1 + y + y^23, 141),
            (288, 4 , 1 + y^20 + y^25, 1 + y + y^14, 144),
            (292, 18, 1 + y^4  + y^36, 1 + y + y^9 , 146),
        ]

        table_viii = [
            (294, 10, 1 + y^19 + y^29, 1 + y + y^26, 147),
            (300, 8 , 1 + y^43 + y^52, 1 + y + y^57, 150),
            (306, 4 , 1 + y^8  + y^22, 1 + y + y^20, 153),
            (308, 6 , 1 + y^12 + y^22, 1 + y + y^26, 154),
            (310, 10, 1 + y^20 + y^43, 1 + y + y^14, 155),
            (312, 4 , 1 + y^10 + y^17, 1 + y + y^23, 156),
            (318, 4 , 1 + y^14 + y^34, 1 + y + y^38, 159),
            (322, 6 , 1 +  y^5 + y^25, 1 + y + y^24, 161),
            (324, 4 , 1 + y^11 + y^16, 1 + y + y^26, 162),
            (330, 8 , 1 + y^32 + y^38, 1 + y + y^49, 165),
            (336, 10, 1 + y^19 + y^50, 1 + y + y^5 , 168),
            (340, 16, 1 + y^4  + y^25, 1 + y + y^70, 170),
            (342, 4 , 1 + y^16 + y^23, 1 + y + y^20, 171),
            (348, 4 , 1 + y^16 + y^23, 1 + y + y^20, 174),
            (350, 6 , 1 + y^4  + y^33, 1 + y + y^24, 175),
            (354, 4 , 1 + y^19 + y^29, 1 + y + y^23, 177),
            (360, 8 , 1 + y^5  + y^25, 1 + y + y^27, 180),
            (364, 6 , 1 + y^17 + y^22, 1 + y + y^24, 182),
            (366, 4 , 1 + y^8  + y^28, 1 + y + y^26, 183),
            (372, 14, 1 + y^26 + y^34, 1 + y + y^20, 186),
            (378, 12, 1 + y^4  + y^37, 1 + y + y^25, 189),
            (384, 4 , 1 + y^16 + y^23, 1 + y + y^26, 192),
            (390, 8 , 1 + y^13 + y^37, 1 + y + y^42, 195),
            (392, 6 , 1 + y^6  + y^37, 1 + y + y^24, 196),
            (396, 4 , 1 + y^14 + y^22, 1 + y + y^32, 198)
        ]

        for (n, k, f, g, l) in vcat(table_v, table_vi, table_vii, table_viii)
            c = GeneralizedBicycle(f, g, l)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == n == code_n(stab)
            @test code_k(c) == k == code_k(stab)
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
        end
    end
end

"""A method giving the qubits acted upon by a given operation. Part of the Noise interface."""
function affectedqubits end
affectedqubits(g::AbstractSingleQubitOperator) = (g.q,)
affectedqubits(g::AbstractTwoQubitOperator) = (g.q1, g.q2)
affectedqubits(g::NoisyGate) = affectedqubits(g.gate,)
affectedqubits(g::SparseGate) = g.indices
affectedqubits(b::BellMeasurement) = map(m->m.qubit, b.measurements)
affectedqubits(r::Reset) = r.indices
affectedqubits(n::NoiseOp) = n.indices
affectedqubits(g::PauliMeasurement) = 1:length(g.pauli)
affectedqubits(p::PauliOperator) = 1:length(p)
affectedqubits(m::Union{AbstractMeasurement,sMRX,sMRY,sMRZ}) = (m.qubit,)
affectedqubits(v::VerifyOp) = v.indices
affectedqubits(c::CliffordOperator) = 1:nqubits(c)
affectedqubits(c::ClassicalXOR) = ()

affectedbits(o) = ()
affectedbits(m::Union{sMRZ,sMZ,sMRX,sMX,sMRY,sMY}) = m.bit==0 ? () : (m.bit,)
affectedbits(c::ClassicalXOR) = (c.bits..., c.store)

"""Lifted product codes ([panteleev2021degenerate](@cite), [panteleev2022asymptotically](@cite))

Implemented as a package extension with Hecke. Check the [QuantumClifford documentation](http://qc.quantumsavory.org/stable/ECC_API/) for more details on that extension."""
function LPCode(args...; kwargs...)
    ext = Base.get_extension(QuantumClifford, :QuantumCliffordHeckeExt)
    if isnothing(ext)
        throw("The `LPCode` depends on the package `Hecke` but you have not installed or imported it yet. Immediately after you import `Hecke`, the `LPCode` will be available.")
    end
    return ext.LPCode(args...; kwargs...)
end

"""Implemented in a package extension with Hecke. Check the docs for the [Hecke extension](http://qc.quantumsavory.org/stable/ECC_API/#Implemented-in-an-extension-requiring-Hecke.jl)"""
function two_block_group_algebra_codes end

"""Implemented in a package extension with Hecke. Check the docs for the [Hecke extension](http://qc.quantumsavory.org/stable/ECC_API/#Implemented-in-an-extension-requiring-Hecke.jl)"""
function generalized_bicycle_codes end

"""Implemented in a package extension with Hecke. Check the docs for the [Hecke extension](http://qc.quantumsavory.org/stable/ECC_API/#Implemented-in-an-extension-requiring-Hecke.jl)"""
function bicycle_codes end

"""Implemented in a package extension with Hecke. Check the docs for the [Hecke extension](http://qc.quantumsavory.org/stable/ECC_API/#Implemented-in-an-extension-requiring-Hecke.jl)"""
function haah_cubic_codes end

"""Implemented in a package extension with Oscar. Check the docs for the [Oscar extension](http://qc.quantumsavory.org/stable/ECC_API/#Implemented-in-an-extension-requiring-Oscar.jl)"""
function twobga_from_direct_product end

"""Implemented in a package extension with Oscar. Check the docs for the [Oscar extension](http://qc.quantumsavory.org/stable/ECC_API/#Implemented-in-an-extension-requiring-Oscar.jl)"""
function twobga_from_fp_group end

import Graphs

"""
$TYPEDSIGNATURES

Fix the clipped gauge of a stabilizer (in place).

Assumes the input is a valid full-rank stabilizer (all operators
commute and have real phases).

```jldoctest
julia> s = S"- X_ZX_X
             + XXYZ__
             - YZ_Z_X
             - XZX__Y
             + _Z_Y_Y
             - ____Z_";


julia> canonicalize_clip!(s)
- X_XY__
+ YZY___
+ _XZX__
- _ZYX_Z
- __YZ_X
- ____Z_
```

If `phases=false` is set, the canonicalization does not track the phases
in the tableau, leading to a significant speedup.

Introduced in [nahum2017quantum](@cite), with a more detailed explanation of the algorithm in Appendix A of [li2019measurement](@cite)

See also: [`canonicalize!`](@ref), [`canonicalize_rref!`](@ref), [`canonicalize_gott!`](@ref).
"""
function canonicalize_clip!(state::AbstractStabilizer; phases::Bool=true)
    @valbooldispatch _canonicalize_clip!(state; phases=Val(phases)) phases
end
function _canonicalize_clip!(state::AbstractStabilizer; phases::Val{B}=Val(true)) where B
    tab = stabilizerview(state)
    rows, columns = size(stabilizerview(state))
    # step 1: pregauge
    i = 1 # index to place used stab
    for j in 1:columns
        # find first row that is not I in col j
        k1 = findfirst(let j=j; k->|(tab[k,j]...) end, i:rows)
        # find second row that is not I and not same as k1
        if !isnothing(k1)
            k1 += i-1
            k2 = findfirst(let j=j, k1=k1; k->
                           (|(tab[k,j]...) & # not identity
                           (tab[k,j]!=tab[k1,j])) end, # not same as k1
                           k1+1:rows)
            if !isnothing(k2)
                k2 += k1
                # move k1 and k2 up to i and i+1
                rowswap!(state, k1, i; phases=phases)
                rowswap!(state, k2, i+1; phases=phases)
                # use them to eliminate others
                for m in i+2:rows
                    if !(tab[m,j][1]⊻tab[i,j][1]) && !(tab[m,j][2]⊻tab[i,j][2])
                        mul_left!(state, m, i; phases=phases)
                    elseif !(tab[m,j][1]⊻tab[i+1,j][1]) && !(tab[m,j][2]⊻tab[i+1,j][2])
                        mul_left!(state, m, i+1; phases=phases)
                    elseif !(tab[m,j][1]⊻tab[i,j][1]⊻tab[i+1,j][1]) && !(tab[m,j][2]⊻tab[i,j][2]⊻tab[i+1,j][2])
                        mul_left!(state, m, i; phases=phases)
                        mul_left!(state, m, i+1; phases=phases)
                    end
                end
                i += 2
            else # can only find k1
                # move k1 up to i
                rowswap!(state, k1, i; phases=phases)
                # use it to eliminate others
                for m in i+1:rows
                    if !(tab[m,j][1]⊻tab[i,j][1]) && !(tab[m,j][2]⊻tab[i,j][2])
                        mul_left!(state, m, i; phases=phases)
                    end
                end
                i += 1
            end
        end
    end
    # step 2: gauge
    unfrozen_rows = Array(rows:-1:1)
    for j in columns:-1:1 # in reversed order to keep left ends
        # find first row that is not I in col j
        k1 = findfirst(let j=j; k->|(tab[k,j]...) end, unfrozen_rows)
        # find second row that is not I and not same as k1
        if k1!==nothing
            k1_row = unfrozen_rows[k1]
            k2 = findfirst(let j=j, k1_row=k1_row; k->
                           (|(tab[k,j]...) & # not identity
                           (tab[k,j]!=tab[k1_row,j])) end, # not same as k1
                           @view unfrozen_rows[k1+1:end])

            if k2!==nothing
                k2 += k1
                k2_row = unfrozen_rows[k2]
                # use them to eliminate others
                # for rows between k1 and k2, use k1
                for m in @view unfrozen_rows[k1+1:k2-1]
                    if !(tab[m,j][1]⊻tab[k1_row,j][1]) && !(tab[m,j][2]⊻tab[k1_row,j][2])
                        mul_left!(state, m, k1_row; phases=phases)
                    end
                end
                # for other rows, use both
                for m in @view unfrozen_rows[k2+1:end]
                    if !(tab[m,j][1]⊻tab[k1_row,j][1]) && !(tab[m,j][2]⊻tab[k1_row,j][2])
                        mul_left!(state, m, k1_row; phases=phases)
                    elseif !(tab[m,j][1]⊻tab[k2_row,j][1]) && !(tab[m,j][2]⊻tab[k2_row,j][2])
                        mul_left!(state, m, k2_row; phases=phases)
                    elseif !(tab[m,j][1]⊻tab[k1_row,j][1]⊻tab[k2_row,j][1]) && !(tab[m,j][2]⊻tab[k1_row,j][2]⊻tab[k2_row,j][2])
                        mul_left!(state, m, k1_row; phases=phases)
                        mul_left!(state, m, k2_row; phases=phases)
                    end
                end
                deleteat!(unfrozen_rows, (k1, k2))
            else # can only find k1
                # use it to eliminate others
                for m in @view unfrozen_rows[k1+1:end]
                    if !(tab[m,j][1]⊻tab[k1_row,j][1]) && !(tab[m,j][2]⊻tab[k1_row,j][2])
                        mul_left!(state, m, k1_row; phases=phases)
                    end
                end
                deleteat!(unfrozen_rows, k1)
            end
        end
    end
    state
end

canonicalize_clip!(ps::Base.AbstractVecOrTuple{PauliOperator}, args...; kwargs...) = canonicalize_clip!(Stabilizer(ps), args...; kwargs...)

"""
$TYPEDSIGNATURES

Get the bigram of a tableau.

It is the list of endpoints of a tableau in the clipped gauge.

If `clip=true` (the default) the tableau is converted to the clipped gauge in-place before calculating the bigram.
Otherwise, the clip gauge conversion is skipped (for cases where the input is already known to be in the correct gauge).

Introduced in [nahum2017quantum](@cite), with a more detailed explanation of the algorithm in [li2019measurement](@cite) and [gullans2021quantum](@cite).

See also: [`canonicalize_clip!`](@ref)
"""
function bigram(state::AbstractStabilizer; clip::Bool=true)::Matrix{Int} # JET-XXX The ::Matrix{Int} should not be necessary, but they help with inference
    clip && canonicalize_clip!(state)
    tab = stabilizerview(state)
    rows, columns = size(tab)
    bg = zeros(Int, rows, 2)
    for i in 1:rows
        l = findfirst(j->|(tab[i,j]...), 1:columns)
        r = findlast(j->|(tab[i,j]...), 1:columns)
        (isnothing(l) || isnothing(r)) && throw(DomainError("the tableau is inconsistent (check if it is clip-canonicalized and Hermitian)"))
        bg[i, 1] = l
        bg[i, 2] = r
    end
    bg
end


"""
$TYPEDSIGNATURES

Get bipartite entanglement entropy of a subsystem

Defined as entropy of the reduced density matrix.

It can be calculated with multiple different algorithms,
the most performant one depending on the particular case.

Currently implemented are the `:clip` (clipped gauge), `:graph` (graph state), and `:rref` (Gaussian elimination) algorithms.
Benchmark your particular case to choose the best one.
"""
function entanglement_entropy end


"""
Get bipartite entanglement entropy of a contiguous subsystem by passing through the clipped gauge.

If `clip=false` is set the canonicalization step is skipped, useful if the input state is already in the clipped gauge.

See also: [`bigram`](@ref), [`canonicalize_clip!`](@ref)
"""
function entanglement_entropy(state::AbstractStabilizer, subsystem_range::UnitRange, algorithm::Val{:clip}; clip::Bool=true)
    # JET-XXX The ::Matrix{Int} should not be necessary, but they help with inference
    bg = bigram(state; clip=clip)::Matrix{Int}
    # If the state is mixed, this formula is valid only for contiguous regions that don't wrap around.
    # See Eq. E7 of gullans2021quantum.
    # As subsystem_range is UnitRange, we know the formula will be valid.
    length(subsystem_range) - count(r->(r[1] in subsystem_range && r[2] in subsystem_range), eachrow(bg))
end


"""
Get bipartite entanglement entropy by first converting the state to a graph and computing the rank of the adjacency matrix.

Based on "Entanglement in graph states and its applications".
""" # TODO you should use [hein2006entanglement](@cite) instead of "Entanglement in graph states and its applications", but Documenter is giving the weirdest error if you do so...
function entanglement_entropy(state::AbstractStabilizer, subsystem::AbstractVector, algorithm::Val{:graph})
    graph = Graphs.Graph(state)
    adjmat = Graphs.adjacency_matrix(graph)
    other_subsystem = filter(i->!(i in collect(subsystem)), 1:Graphs.nv(graph))
    subadjmat = Nemo.matrix(Nemo.GF(2), collect(adjmat[subsystem,other_subsystem]))
    LinearAlgebra.rank(subadjmat)
end


"""
Get bipartite entanglement entropy by converting to RREF form (i.e., partial trace form).

The state will be partially canonicalized in an RREF form.

See also: [`canonicalize_rref!`](@ref), [`traceout!`](@ref).
"""
function entanglement_entropy(state::AbstractStabilizer, subsystem::AbstractVector, algorithm::Val{:rref}; pure::Bool=false)
    nb_of_qubits = nqubits(state)
    # if state is pure, then S(A) = S(A_complement), so trace out whichever is shorter
    if pure && length(subsystem) < nb_of_qubits/2
        state, rank_after_deletion = canonicalize_rref!(state, subsystem)
        nb_of_deletions = length(subsystem)
    else
	# trace out the complement to get S(A)
        state, rank_after_deletion = canonicalize_rref!(state, setdiff(1:nb_of_qubits, subsystem))
        nb_of_deletions = nb_of_qubits - length(subsystem)
    end
    return nb_of_qubits - rank_after_deletion - nb_of_deletions
end

entanglement_entropy(state::MixedDestabilizer, subsystem::AbstractVector, a::Val{:rref}) = entanglement_entropy(state, subsystem, a; pure=nqubits(state)==rank(state))

@testitem "ECC Decoder" tags=[:ecc, :ecc_decoding] begin
    using Test
    using QuantumClifford
    using QuantumClifford.ECC

    import PyQDecoders
    import LDPCDecoders
    import Sys

    if !Sys.iswindows()
        import PyTesseractDecoder
    else
        @test_broken false # TODO tesseract-decoder is not available on Windows
    end

    include("test_ecc_base.jl")

    @testset "table decoder, good for small codes" begin
        codes = [
                 all_testable_code_instances(;maxn=10)...
                ]

        noise = 0.001

        setups = [
                  CommutationCheckECCSetup(noise),
                  NaiveSyndromeECCSetup(noise, 0),
                  ShorSyndromeECCSetup(noise, 0),
                 ]

        for c in codes
            for s in setups
                for d in [TableDecoder, CSSTableDecoder]
                    d === CSSTableDecoder && !iscss(c) && continue
                    e = evaluate_decoder(d(c), s, 100000)
                    #@show c
                    #@show s
                    #@show e
                    @test max(e...) < noise/4
                end
            end
        end
    end

    ##

    @testset "belief prop decoders, good for sparse codes" begin
        codes = vcat(LP04, LP118, test_gb_codes, other_lifted_product_codes)

        noise = 0.001

        setups = [
            CommutationCheckECCSetup(noise),
            NaiveSyndromeECCSetup(noise, 0),
            ShorSyndromeECCSetup(noise, 0),
        ]

        for c in codes
            for s in setups
                for d in [c -> PyBeliefPropOSDecoder(c, maxiter=2)]
                    nsamples = 10000
                    if true
                        @test_broken false # TODO these are too slow to test in CI
                        continue
                    end
                    e = evaluate_decoder(d(c), s, nsamples)
                    # @show c
                    # @show s
                    # @show e
                    @test max(e...) <= noise
                end
            end
        end
    end


    @testset "BitFlipDecoder decoder, good for sparse codes" begin
        codes = [
                 QuantumReedMuller(3),
                 QuantumReedMuller(4)
                ]

        noise = 0.001

        setups = [
                  CommutationCheckECCSetup(noise),
                  NaiveSyndromeECCSetup(noise, 0),
                  ShorSyndromeECCSetup(noise, 0),
                 ]

        for c in codes
            for s in setups
                for d in [c->BitFlipDecoder(c, maxiter=10)]
                    e = evaluate_decoder(d(c), s, 100000)
                    #@show c
                    #@show s
                    #@show e
                    @test max(e...) < noise/4
                end
            end
        end
    end

    ##

    @testset "matching decoder, good as long as column weight of the code is limited" begin
        codes = [
                 Toric(8,8),
                 Toric(9,9),
                 Surface(8,8),
                 Surface(9,9)
                ]

        noise = 0.01

        setups = [
                  CommutationCheckECCSetup(noise),
                  NaiveSyndromeECCSetup(noise, 0),
                  ShorSyndromeECCSetup(noise, 0),
                 ]

        for c in codes
            for s in setups
                e = evaluate_decoder(PyMatchingDecoder(c), s, 10000)
                #@show c
                #@show s
                #@show e
                @test max(e...) < noise/5
            end
        end
    end


    if !Sys.iswindows()
    @testset "tesseract decoder (tesseract-decoder via PyTesseractDecoder)" begin
        codes = [
            Surface(8, 8),
            Toric(8, 8),
        ]

        noise = 0.02
        setups = [
            CommutationCheckECCSetup(noise),
        ]

        for c in codes
            Hstab = parity_checks(c)
            stab = QuantumClifford.stab_to_gf2(Hstab) # [X | Z]
            s, n2 = size(stab)
            n = n2 ÷ 2
            check_dense = hcat(@view(stab[:, n+1:end]), @view(stab[:, 1:n])) # [Z | X]

            d = TesseractDecoder(c; errorrate=noise, det_beam=50)

            # Basic consistency: the returned error guess matches the input syndrome.
            for col in 1:min(20, 2n)
                syndrome = @view check_dense[:, col]
                guess = QuantumClifford.ECC.decode(d, syndrome)
                predicted_syndrome = falses(s)
                for j in findall(guess)
                    predicted_syndrome .⊻= @view check_dense[:, j]
                end
                @test predicted_syndrome == syndrome
            end

            for setup in setups
                e = evaluate_decoder(d, setup, 2000)
                @test max(e...) <= 0.2/20
            end
        end
    end
    end

    end
end

"""
A tableau representation of the non-commutative canonical form of a set of Paulis,
which is used in [`commutify`](@ref).

They are organized in the same form as [`MixedDestabilizer`](@ref)
with a stabilizer, destabilizer, logical X, and logical Z components.
"""
mutable struct SubsystemCodeTableau{T <: Tableau} <: AbstractStabilizer
    tab::T
    index::Int
    r::Int
    m::Int
    k::Int
end

function SubsystemCodeTableau(t::Tableau)
    index = 1
    for i in range(1, stop=length(t), step=2)
        if i + 1 > length(t)
            break
        end
        if comm(t[i], t[i+1]) == 0x01
            index = i+2 # index to split t into non-commuting pairs and commuting operators
        end
    end
    s = Stabilizer(t[index:length(t)])
    ind = 1
    if length(s)>nqubits(s)#if stabilizer is overdetermined, Destabilizer constructor throws error
        m = length(s)
        tab = zero(Tableau, length(t)+length(s), nqubits(t))
        for i in s
            tab[ind] = zero(PauliOperator, nqubits(s))
            ind+=1
        end
    else
        d = Destabilizer(s)
        m = length(d)
        tab = zero(Tableau, length(t)+length(d), nqubits(t))
        for p in destabilizerview(d)
            tab[ind] = p
            ind+=1
        end
    end
    for i in range(1, stop=index-1, step=2)
        tab[ind] = t[i]
        ind+=1
    end
    for p in s
        tab[ind] = p
        ind+=1
    end
    for i in range(2, stop=index, step=2)
        tab[ind] = t[i]
        ind+=1
    end
    return SubsystemCodeTableau(tab, index, length(s), m, Int((index-1)/2))
end


Base.copy(t::SubsystemCodeTableau) = SubsystemCodeTableau(copy(t.tab), t.index, t.r, t.m, t.k)

function Base.show(io::IO, t::SubsystemCodeTableau)
    r = t.r+t.m+2*t.k
    q = nqubits(t)
    if get(io, :compact, false) | haskey(io, :typeinfo)
        print(io, "MixedDestablizer $r×$q")
    elseif get(io, :limit, false)
        h,w = displaysize(io)
        println(io, "𝒟ℯ𝓈𝓉𝒶𝒷" * "━"^max(min(w-9,size(t.tab,2)-4),0))
        _show(io, destabilizerview(t).tab, w, h÷4)
        if r != q
            println(io)
            println(io, "𝒳" * "━"^max(min(w-5,size(t.tab,2)),0))
            _show(io, logicalxview(t).tab, w, h÷4)
        end
        println(io)
        println(io, "𝒮𝓉𝒶𝒷" * "━"^max(min(w-7,size(t.tab,2)-2),0))
        _show(io, stabilizerview(t).tab, w, h÷4)
        if r != q
            println(io)
            println(io, "𝒵" * "━"^max(min(w-5,size(t.tab,2)),0))
            _show(io, logicalzview(t).tab, w, h÷4)
        end
    else
        println(io, "𝒟ℯ𝓈𝓉𝒶𝒷" * "━"^max(size(t.tab,2)-4,0))
        _show(io, destabilizerview(t).tab, missing, missing)
        if r != q
            println(io)
            println(io, "𝒳ₗ" * "━"^max(size(t.tab,2),0))
            _show(io, logicalxview(t).tab, missing, missing)
        end
        println(io)
        println(io, "𝒮𝓉𝒶𝒷" * "━"^max(size(t.tab,2)-2,0))
        _show(io, stabilizerview(t).tab, missing, missing)
        if r != q
            println(io)
            println(io, "𝒵ₗ" * "━"^max(size(t.tab,2)))
            _show(io, logicalzview(t).tab, missing, missing)
        end
    end
end

@inline stabilizerview(s::SubsystemCodeTableau) = Stabilizer(@view tab(s)[s.m+s.k+1:s.m+s.k+s.r])
@inline destabilizerview(s::SubsystemCodeTableau) = Stabilizer(@view tab(s)[1:s.r])
@inline logicalxview(s::SubsystemCodeTableau) = Stabilizer(tab(s)[s.m+1:s.m+s.k])
@inline logicalzview(s::SubsystemCodeTableau) = Stabilizer(tab(s)[length(s.tab)-s.k+1:length(s.tab)])

"""
Return the full stabilizer group represented by the input generating set (a [`Stabilizer`](@ref)).

The returned object is exponentially long.

```jldoctest
julia> groupify(S"XZ ZX")
+ __
+ XZ
+ ZX
+ YY
```
"""
function groupify(s::Stabilizer; phases=false)
    # Create a `Tableau` of 2ⁿ n-qubit identity Pauli operators(where n is the size of
    # `Stabilizer` s), then multiply each one by a different subset of the elements in s to
    # create all 2ⁿ unique elements in the group generated by s, then return the `Tableau`.
    if phases == true
        throw(ArgumentError("in groupify phases=true functionality not yet implemented"))
    end
    gen_set = minimal_generating_set(s)
    n = length(gen_set)::Int
    group = zero(Tableau, 2^n, nqubits(gen_set))
    for i in 0:2^n-1
        for (digit_order, j) in enumerate(digits(i, base=2, pad=n))
            if j == 1
                mul_left!(group, i+1, tab(gen_set), digit_order, phases=Val(false))
            end
        end
    end
    return group
end


"""
For a not-necessarily-minimal generating set,
return the minimal generating set.

The input has to have only real phases.

```jldoctest
julia> minimal_generating_set(S"__ XZ ZX YY")
+ XZ
+ ZX
```
"""
function minimal_generating_set(s::Stabilizer)
    # Canonicalize `Stabilizer` s, then return a `Stabilizer` with all non-identity Pauli operators
    # in the result. If s consists of only identity operators, return the negative
    # identity operator if one is contained in s, and the positive identity operator otherwise.
    s, _, r = canonicalize!(copy(s), ranks=true)
    if r == 0
        gs = zero(Stabilizer, 1, nqubits(s))
        if 0x02 in phases(s)
            phases(gs)[1] = 0x2
        end
        return gs
    else
        return s[1:r, :]
    end
end

"""
For a not-necessarily commutative set of Paulis, return a generating set of the form
⟨A₁, A₂, ... Aₖ, Aₖ₊₁, ... Aₘ, B₁, B₂, ... Bₖ⟩ where pairs Aₖ, Bₖ anticommute and all other pairings commute. Based on [RevModPhys.87.307](@cite)

Returns the generating set as a data structure of type [`SubsystemCodeTableau`](@ref). The
`logicalxview` function returns the ⟨A₁, A₂,... Aₖ⟩, and the `logicalzview`
function returns ⟨B₁, B₂, ... Bₖ⟩. `stabilizerview` returns ⟨Aₖ₊₁, ... Aₘ⟩
as a Stabilizer, and `destabilizerview` returns the Destabilizer of that Stabilizer.

Phases are zeroed-out in this canonicalization.

```jldoctest
julia> canonicalize_noncomm(T"XX XZ XY")
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z_
𝒳━━
+ XX
𝒮𝓉𝒶𝒷
+ X_
𝒵━━
+ XZ
```
"""
function canonicalize_noncomm(t::Tableau)
    for i in eachindex(t) phases(t)[i] = 0x00 end
    loc = zero(Tableau, 2*length(t), nqubits(t))
    x_index = 0
    z_index = length(loc)
    for i in eachindex(t)
        for j in eachindex(t)
            if comm(t[i], t[j]) == 0x01
                for k in eachindex(t)
                    if k !=i && k != j
                        if comm(t[k], t[i]) == 0x01
                            mul_left!(t, k, j, phases=Val(false))
                        end
                        if comm(t[k], t[j]) == 0x01
                            mul_left!(t, k, i, phases=Val(false))
                        end
                    end
                end
                if !(t[i] in loc)
                    x_index+=1
                    loc[x_index]= t[i]
                end
                if !(t[j] in loc)
                    loc[z_index]= t[j]
                    z_index-=1
                end
            end
        end
    end
    ind = 2*x_index+1 #format tableau for SubsystemCodeTableau
    k = x_index
    m = length(t)-2*k
    for i in range(k, stop =1, step=-1)
        loc[i+m]= loc[i]
    end
    i = m+1
    j = m+k
    while i < j #ensure anticommutative pairs are lined up correctly
        loc[i], loc[j], = loc[j], loc[i]
        i+=1
        j-=1
    end
    s_index = m+k+1
    for i in eachindex(t)
        if !(t[i] in loc)
            loc[s_index]= t[i]
            s_index+=1
        end
    end
    r = s_index-m-k-1
    if r <= nqubits(t)
        d = destabilizerview(Destabilizer(Stabilizer(loc[m+k+1:s_index-1])))
        for i in eachindex(d)
            loc[i] =d[i]
        end
    else for i in 1:m zero!(loc, i) end end
    return SubsystemCodeTableau(loc, ind, r, m, k)
end

canonicalize_noncomm(ps::Base.AbstractVecOrTuple{PauliOperator}) = canonicalize_noncomm(Tableau(ps))

"""
For a not-necessarily commutative set of Paulis S,
computed S', the [non-commutative canonical form](@ref canonicalize_noncomm) of of S.
For each pair Aₖ, Bₖ of anticommutative Paulis in S', add a qubit to each Pauli in the set:
X to Aₖ, Z to Bₖ, and I to each other operator to produce S'', a fully commutative set. Return
S'' as well as a list of the indices of the added qubits.

The returned object is a Stabilizer that is also useful for the [`matroid_parent`](@ref) function.

```jldoctest
julia> commutify(T"XX XZ XY")[1]
+ XXX
+ X__
+ XZZ

julia> commutify(T"XX XZ XY")[2]
3:3
```
"""
function commutify(t)
    loc = canonicalize_noncomm(t)
    commutative = zero(Stabilizer, 2*loc.k+loc.r, nqubits(loc)+loc.k)
    puttableau!(commutative, logicalxview(loc), 0,0)
    puttableau!(commutative, stabilizerview(loc), loc.k,0)
    puttableau!(commutative, logicalzview(loc), loc.k+loc.r,0)
    x= T"X"
    z=T"Z"
    for i in 0:(loc.k-1)
        puttableau!(commutative, x, i, nqubits(loc)+i)
        puttableau!(commutative, z, i+loc.r+loc.k, nqubits(loc)+i)
    end
    to_delete = nqubits(loc)+1:nqubits(loc)+loc.k
    return commutative, to_delete
end

"""
For a given set S of Paulis that does not necessarily represent a state,
return a set of Paulis S' that represents a state.
S' is a superset of [commutified](@ref commutify) S.
Additionally returns two arrays representing deletions needed to produce S.
Based on [goodenough2024bipartiteentanglementnoisystabilizer](@cite)

By deleting the qubits in the first output array from S', taking the [`normalizer`](@ref) of S', then
deleting the qubits in the second returned array from the [`normalizer`](@ref) of S', S is reproduced.

```jldoctest
julia> matroid_parent(T"XX")[1]
+ X_X
+ XX_
+ ZZZ

julia> matroid_parent(T"XX")[2]
3:3

julia> matroid_parent(T"XX")[3]
3:2
```
"""
function matroid_parent(t::Tableau)
    com, d1= commutify(t)
    norm = normalizer(com.tab)
    state, d2 = commutify(norm)
    return state, d2, d1
end

"""
Return the full Pauli group of a given length. Phases are ignored by default,
but can be included by setting `phases=true`.

```jldoctest
julia> pauligroup(1)
+ _
+ X
+ Z
+ Y

julia> pauligroup(1, phases=true)
+ _
+ X
+ Z
+ Y
- _
- X
- Z
- Y
+i_
+iX
+iZ
+iY
-i_
-iX
-iZ
-iY
```
"""
function pauligroup(n::Int; phases=false)
    if phases
        s = zero(Tableau, 4^(n + 1), n)
        paulis = ((false, false), (true, false), (false, true), (true, true))
        for (i, P) in enumerate(Iterators.product(Iterators.repeated(paulis, n)...))
            for (j, p) in enumerate(P)
                s[i, j] = p
            end
        end
        for i in 1:4^n
            s[i+4^n] = -1 * s[i]
        end
        for i in 4^n+1:2*4^n
            s[i+4^n] = -1im * s[i]
        end
        for i in 2*4^n+1:3*4^n
            s[i+4^n] = -1 * s[i]
        end
    end
    if !phases
        s = zero(Tableau, 4^n, n)
        paulis = ((false, false), (true, false), (false, true), (true, true))
        for (i, P) in enumerate(Iterators.product(Iterators.repeated(paulis, n)...))
            for (j, p) in enumerate(P)
                s[i, j] = p
            end
        end
    end
    return s
end

"""
Return all Pauli operators with the same number of qubits as the given `Tableau` `t`
that commute with all operators in `t`.

```jldoctest
julia> normalizer(T"X")
+ _
+ X
```
"""
function normalizer(t::Tableau; phases=false)
    # For each `PauliOperator` p in the with same number of qubits as the `Stabilizer` s, iterate through s and check each
    # operator's commutivity with p. If they all commute, add p a vector of `PauliOperators`. Return the vector
    # converted to `Tableau`.
    n = nqubits(t)
    ptype =typeof(P"I")
    norm = ptype[]

    p = zero(PauliOperator, n)
    paulis = ((false, false), (true, false), (false, true), (true, true))
    for i in Iterators.product(Iterators.repeated(paulis, n)...)
        zero!(p)
        for (j, k) in enumerate(i)
            p[j] = k
        end
        commutes = true
        for q in t
            if comm(p, q) == 0x01
                commutes = false
            end
        end
        if commutes
            push!(norm, copy(p))
        end
        if phases
            for phase in [-1, 1im, -1im]
                push!(norm, phase *p)
            end
        end
    end
    return Tableau(norm)
end

"""
For a given set of Paulis (in the form of a `Tableau`), return the subset of Paulis that commute with all Paulis in set.

```jldoctest
julia> centralizer(T"XX ZZ _Z")
+ ZZ
```
"""
function centralizer(t::Tableau)
    center = typeof(t[1])[]
    for P in t
        commutes = 0
        for Q in t
            if comm(P, Q) == 0x01
                commutes = 1
                break
            end
        end
        if commutes == 0
            push!(center, P)
        end
    end
    if length(center) == 0
        return Tableau(zeros(Bool, 1,1))
    end
    c = Tableau(center)
    return c
end

"""
Return the subset of Paulis in a Stabilizer that have identity operators on all qubits corresponding to
the given subset, without the entries corresponding to subset. Based on [goodenough2024bipartiteentanglementnoisystabilizer](@cite)

```jldoctest
julia> contractor(S"_X X_", [1])
+ X
```
"""
function contractor(s::Stabilizer, subset)
    result = typeof(s[1])[]
    for p in s
        contractable = true
        for i in subset
            if p[i] != (false, false)
                contractable = false
                break
            end
        end
        if contractable push!(result, p[setdiff(1:length(p), subset)]) end
    end
    if length(result) > 0
        return Tableau(result)
    else
        return Tableau(zeros(Bool, 1,1))
    end
end

"""A register, representing the state of a computer including both a tableaux and an array of classical bits (e.g. for storing measurement results)"""
struct Register{T<:Tableau} <: AbstractQCState # TODO simplify type parameters (remove nesting)
    stab::MixedDestabilizer{T}
    bits::Vector{Bool}
    Register(s::MixedDestabilizer{T}, bits) where {T} = new{T}(s,bits)
end

Register(s::Register) = s
Register(s,bits) = Register(MixedDestabilizer(s), bits)
Register(s) = Register(s, Bool[])
Register(s::MixedDestabilizer,nbits::Int) = Register(s, falses(nbits))

Base.one(::Type{<:Register}, n::Integer; basis=:Z) =
    Register(one(MixedDestabilizer, n; basis=basis))
Base.one(::Type{<:Register}, n::Integer, nbits::Integer; basis=:Z) =
    Register(one(MixedDestabilizer, n; basis=basis), nbits)
Base.one(r::Register; basis=:Z) =
    one(Register, nqubits(r), length(bitview(r)); basis=basis)

Base.copy(r::Register) = Register(copy(r.stab),copy(r.bits))
Base.:(==)(l::Register,r::Register) = l.stab==r.stab && l.bits==r.bits

stabilizerview(r::Register) = stabilizerview(quantumstate(r))
destabilizerview(r::Register) = destabilizerview(quantumstate(r))
logicalxview(r::Register) = logicalxview(quantumstate(r))
logicalzview(r::Register) = logicalzview(quantumstate(r))

nqubits(r::Register) = nqubits(r.stab)

"""A view of the classical bits stored with the state"""
function bitview end
bitview(s::AbstractStabilizer) = ()
bitview(r::Register) = r.bits

"""Only the quantum part of the state (excluding classical bits)"""
function quantumstate end
quantumstate(s::AbstractStabilizer) = s
quantumstate(r::Register) = r.stab

tab(r::Register) = tab(quantumstate(r))

tensor(regs::Register...) = Register(tensor(quantumstate.(regs)...), [bit for r in regs for bit in r.bits])
tensor(args::Union{Register, AbstractStabilizer}...) = tensor(Register.(args)...)

function apply!(r::Register, operation; kwargs...)
    apply!(quantumstate(r), operation; kwargs...)
    r
end

function apply!(r::Register, indices::Base.AbstractVecOrTuple{Int}, operation; kwargs...)
    apply!(quantumstate(r), indices, operation; kwargs...)
    r
end

function apply!(r::Register, m::sMX)
    _, res = projectXrand!(r,m.qubit)
    m.bit!=0 && (bitview(r)[m.bit] = !iszero(res))
    r
end
function apply!(r::Register, m::sMY)
    _, res = projectYrand!(r,m.qubit)
    m.bit!=0 && (bitview(r)[m.bit] = !iszero(res))
    r
end
function apply!(r::Register, m::sMZ)
    _, res = projectZrand!(r,m.qubit)
    m.bit!=0 && (bitview(r)[m.bit] = !iszero(res))
    r
end
function apply!(r::Register, m::sMRX) # TODO sMRY
    _, anticom, res = projectX!(quantumstate(r),m.qubit)
    mres = if isnothing(res)
        mres = rand((0x0, 0x2))
        phases(stabilizerview(r))[anticom] = mres
        mres
    else
        res
    end
    m.bit!=0 && (bitview(r)[m.bit] = !iszero(mres))
    if mres==0x2
        apply!(r, sZ(m.qubit))
    end
    r
end
function apply!(r::Register, m::sMRZ) # TODO sMRY
    _, anticom, res = projectZ!(quantumstate(r),m.qubit)
    mres = if isnothing(res)
        mres = rand(Bool)
        phases(stabilizerview(r))[anticom] = 0x2*mres
        mres
    else
        !iszero(res)
    end
    m.bit!=0 && (bitview(r)[m.bit] = mres)
    if mres
        apply!(r, sX(m.qubit))
    end
    r
end
function apply!(r::Register, m::PauliMeasurement{A,B}) where {A,B}
    _, res = projectrand!(r,m.pauli)
    m.bit!=0 && (bitview(r)[m.bit] = !iszero(res))
    r
end
function projectXrand!(r::Register, m)
    q = quantumstate(r)
    _, res = projectXrand!(q,m)
    r, res
end
function projectYrand!(r::Register, m)
    q = quantumstate(r)
    _, res = projectYrand!(q,m)
    r, res
end
function projectZrand!(r::Register, m)
    q = quantumstate(r)
    _, res = projectZrand!(q,m)
    r, res
end
function projectrand!(r::Register, m)
    q = quantumstate(r)
    _, res = projectrand!(q,m)
    r, res
end

function traceout!(r::Register, arg)
    q = quantumstate(r)
    traceout!(q,arg)
    q
end

##
# petrajectories, applynoise_branches
##

function applynoise_branches(state::Register, noise, indices; max_order=1)
    [(Register(newstate,copy(state.bits)), prob, order)
     for (newstate, prob, order) in applynoise_branches(quantumstate(state), noise, indices; max_order=max_order)]
end

function applybranches(s::Register, op::PauliMeasurement; max_order=1) # TODO this is almost the same as `applybranches(s::Register, op::AbstractMeasurement; max_order=1)` defined below
    stab = s.stab
    stab, anticom, r = project!(stab, op.pauli)
    new_branches = []
    if isnothing(r)
        s1 = s
        phases(stabilizerview(s1.stab))[anticom] = 0x00
        _setregbit(s1.bits, op.bit, false)
        s2 = copy(s)
        phases(stabilizerview(s2.stab))[anticom] = 0x02
        _setregbit(s2.bits, op.bit, true)
        push!(new_branches, (s1,continue_stat,1/2,0))
        push!(new_branches, (s2,continue_stat,1/2,0))
    else
        _setregbit(s.bits, op.bit, r==0x02)
        push!(new_branches, (s,continue_stat,1,0))
    end
    new_branches
end

function applybranches(s::Register, op::AbstractMeasurement; max_order=1)
    stab = s.stab
    stab, anticom, r = project!(stab, op)
    new_branches = []
    if isnothing(r)
        s1 = s
        phases(stabilizerview(s1.stab))[anticom] = 0x00
        _setregbit(s1.bits, op.bit, false)
        s2 = copy(s)
        phases(stabilizerview(s2.stab))[anticom] = 0x02
        _setregbit(s2.bits, op.bit, true)
        push!(new_branches, (s1,continue_stat,1/2,0))
        push!(new_branches, (s2,continue_stat,1/2,0))
    else
        _setregbit(s.bits, op.bit, r==0x02)
        push!(new_branches, (s,continue_stat,1,0))
    end
    new_branches
end



#helper dispatch functions for the AbstractResetMeasurement applybranches
_reset_mappings(::Type{sMRZ}) = (sX, projectZ!)
_reset_mappings(::Type{sMRX}) = (sZ, projectX!)
_reset_mappings(::Type{sMRY}) = (sZ, projectY!)

#helper function to only set a bit if the given index is non-zero, since internally 'nothing' is defined to be 0
function _setregbit(bit_register::Vector{Bool},bit::Int64,value::Bool)
    if(bit==0)
        nothing
    else
        bit_register[bit] = value
    end
end

function applybranches(s::Register, op::AbstractResetMeasurement;max_order=1)
    flipOp, projectFunc = _reset_mappings(typeof(op))
    _, anticom, res = projectFunc(quantumstate(s), op.qubit)
    new_branches = []
    if isnothing(res)
        s1 = s
        phases(stabilizerview(s1.stab))[anticom] = 0x00
        _setregbit(s1.bits, op.bit, false)
        s2 = copy(s)
        phases(stabilizerview(s2.stab))[anticom] = 0x02
        _setregbit(s2.bits, op.bit, true)
        apply!(s2, flipOp(op.qubit))
        push!(new_branches, (s1,continue_stat,1/2,0))
        push!(new_branches, (s2,continue_stat,1/2,0))
    else
        _setregbit(s.bits, op.bit, res==0x02)
        if(res==0x02)
            apply!(s, flipOp(op.qubit))
        end
        push!(new_branches, (s,continue_stat,1,0))
    end
    new_branches
end
#=
function applybranches(state::Register, op::SparseMeasurement; max_order=1)
    n = nqubits(state.stab) # TODO implement actual sparse measurements
    p = zero(typeof(op.pauli), n)
    for (ii,i) in enumerate(op.indices)
        p[i] = op.pauli[ii]
    end
    dm = PauliMeasurement(p,op.bit)
    applybranches(state,dm, max_order=max_order)
end
=#

@testitem "ECC La-cross" tags=[:ecc, :ecc_bespoke_checks] begin
    using JuMP
    using HiGHS
    using Hecke
    using QuantumClifford
    using QuantumClifford: stab_looks_good, gf2_row_echelon_with_pivots!
    using QuantumClifford.ECC
    using Nemo: matrix, GF
    using QECCore

    function _scratch_matrix(n, k, coeffs)
        first_row = zeros(Int, n)
        first_row[1] = 1 # constant term (x⁰)
        for i in 1:k
            first_row[i+1] = coeffs[i] # coefficients for x¹, x², ..., xᵏ
        end
        H = zeros(Int, n, n)
        H[1, :] = first_row
        for i in 2:n
            H[i, :] = circshift(H[i-1, :], 1)
        end
        return H
    end

    function _hecke_circulant_matrix(n, h)
        R = parent(h)
        x = gen(R)
        _, proj = residue_ring(R, R(x)^n-1)
        h = proj(h)
        lifted_h = lift(h)
        coeffs = Int[lift(ZZ, coeff(lifted_h, i)) for i in 0:n-1]
        H = zero_matrix(GF(2), n, n)
        for i in 1:n
            for j in 1:n
                H[i, j] = coeffs[mod1(j-i+1, n)]
            end
        end
        H = [Int(lift(ZZ, H[i,j])) for i in 1:nrows(H), j in 1:ncols(H)]
        return H
    end

    @testset "circulant matrix consistency check" begin
        for _ in 1:20
            n = rand(1:20)
            k = rand(0:n-1)
            coeffs = rand([0, 1], k)
            @testset "(n=$n, k=$k)" begin
                H = _scratch_matrix(n, k, coeffs)
                R, x = polynomial_ring(GF(2), "x")
                h = isempty(coeffs) ? x^0 : sum(coeffs[i]*x^i for i in 1:k) + x^0
                Hₕ = _hecke_circulant_matrix(n, h)
                @test H == Hₕ
            end
        end
    end

    @testset "Reproduce Figure 3 of [pecorari2025high](@cite)" begin
        @testset "Reproduce Figure 3(a) of [pecorari2025high](@cite)" begin
            k = 2
            F = GF(2)
            R, x = polynomial_ring(F, "x")
            h = 1 + x + x^k

            # [[34, 4, 3]]
            n = 5
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 34 == code_n(stab) && code_k(c) == 4 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[52, 4, 4]]
            n = 6
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 52 == code_n(stab) && code_k(c) == 4 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[100, 4, 5]]
            n = 8
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 100 == code_n(stab) && code_k(c) == 4 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[130, 4, 6]]
            n = 9
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 130 == code_n(stab) && code_k(c) == 4 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[164, 4, 6]]
            n = 10
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 164 == code_n(stab) && code_k(c) == 4 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[244, 4, 8]]
            n = 12
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 244 == code_n(stab) && code_k(c) == 4 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
        end

        @testset "Reproduce Figure 3(b) of [pecorari2025high](@cite)" begin
            k = 3
            F = GF(2)
            R, x = polynomial_ring(F, "x")
            h = 1 + x + x^k

            # [[65, 9, 4]]
            n = 7
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 65 == code_n(stab) && code_k(c) == 9 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[98, 18, 4]]
            full_rank = false
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 98 == code_n(stab) && code_k(c) == 18 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[117, 9, 4]]
            n = 9
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 117 == code_n(stab) && code_k(c) == 9 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[149, 9, 5]]
            n = 10
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 149 == code_n(stab) && code_k(c) == 9 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[225, 9, 6]]
            n = 12
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 225 == code_n(stab) && code_k(c) == 9 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[317, 9, 8]]
            n = 14
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 317 == code_n(stab) && code_k(c) == 9 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[369, 9, 8]]
            n = 15
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 369 == code_n(stab) && code_k(c) == 9 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
        end

        @testset "Reproduce Figure 3(c) of [pecorari2025high](@cite)" begin
            k = 4
            F = GF(2)
            R, x = polynomial_ring(F, "x")
            h = 1 + x + x^k

            # [[106, 16, 4]]
            n = 9
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 106 == code_n(stab) && code_k(c) == 16 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3 # distance approximate
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[136, 16, 5]]
            n = 10
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 136 == code_n(stab) && code_k(c) == 16 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4 # distance approximate
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[208, 16, 6]]
            n = 12
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 208 == code_n(stab) && code_k(c) == 16 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5 # distance approximate
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[296, 16, 7]]
            n = 14
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 296 == code_n(stab) && code_k(c) == 16 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 7
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[400, 16, 8]]
            n = 16
            full_rank = true
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 400 == code_n(stab) && code_k(c) == 16 == code_k(stab)
            @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
        end

        @testset "cross-checks from pg.4 of https://arxiv.org/pdf/2404.13010" begin
            # [[117, 9, d]]
            n = 9
            F = GF(2)
            R, x = polynomial_ring(F, "x")
            h = 1 + x^3;
            full_rank = true # corresponds to code with open boundary conditions
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 117 == code_n(stab) && code_k(c) == 9 == code_k(stab)
            @test stab_looks_good(stab, remove_redundant_rows=true) == true

            # [[162, 18, d]]
            full_rank = false # corresponds to code with periodic boundary conditions
            c = LaCross(n, h, full_rank)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            @test code_n(c) == 162 == code_n(stab) && code_k(c) == 18 == code_k(stab)
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
        end
    end
end

const InnerGPUType = UInt32;
const InnerCPUType = UInt64;

# TODO make the conversion types consistent with this...
# also define a cpu default type?!

to_gpu(array::AbstractArray) = CuArray(array)
to_cpu(array::AbstractArray) = Array(array);

# changes the type to InnerGPUType or InnerCPUType as well as copying to cpu/gpu
to_gpu(array::AbstractArray, tp::Type{T}) where {T <: Unsigned} =
    CuArray(reinterpret(T, collect(array)))
to_cpu(array::AbstractArray, tp::Type{T}) where {T <: Unsigned} =
    Array(reinterpret(T, collect(array)))

# maybe change the format of storing the data in gpu array
# so that it is more convenient to work with them on gpu?
# todo later add some type checking to avoid copying (or throw error) if the data is already on gpu/cpu
to_gpu(tab::QuantumClifford.Tableau, tp::Type{T}=InnerGPUType) where {T <: Unsigned} =
    QuantumClifford.Tableau(to_gpu(tab.phases), tab.nqubits, to_gpu(tab.xzs, tp))

to_cpu(tab::QuantumClifford.Tableau, tp::Type{T}=InnerCPUType) where {T <: Unsigned} =
    QuantumClifford.Tableau(to_cpu(tab.phases), tab.nqubits, to_cpu(tab.xzs, tp))

to_gpu(pauli::QuantumClifford.PauliOperator, tp::Type{T}=InnerGPUType) where {T <: Unsigned} =
    QuantumClifford.PauliOperator(to_gpu(pauli.phase), pauli.nqubits, to_gpu(pauli.xz, tp))

to_cpu(pauli::QuantumClifford.PauliOperator, tp::Type{T}=InnerCPUType) where {T <: Unsigned} =
    QuantumClifford.PauliOperator(to_cpu(pauli.phase), pauli.nqubits, to_cpu(pauli.xz, tp))

to_gpu(stabilizer::QuantumClifford.Stabilizer, tp::Type{T}=InnerGPUType) where {T <: Unsigned} =
    Stabilizer(to_gpu(tab(stabilizer), tp))

to_cpu(stabilizer::QuantumClifford.Stabilizer, tp::Type{T}=InnerCPUType) where {T <: Unsigned} =
    Stabilizer(to_cpu(tab(stabilizer), tp))

to_gpu(pauli_frame::QuantumClifford.PauliFrame, tp::Type{T}=InnerGPUType) where {T <: Unsigned} =
    QuantumClifford.PauliFrame(to_gpu(pauli_frame.frame, tp), to_gpu(pauli_frame.measurements))

to_cpu(pauli_frame::QuantumClifford.PauliFrame, tp::Type{T}=InnerCPUType) where {T <: Unsigned} =
    QuantumClifford.PauliFrame(to_cpu(pauli_frame.frame, tp), to_cpu(pauli_frame.measurements))

"""We introduce a novel class of quantum CSS codes — *Multivariate Multicycle* codes — constructed
using new framework of Koszul complex over the multivariate polynomial quotient ring. For details on the construction,
please refer to our paper ([mian2026multivariatemulticyclecodescomplete](@cite))
 
Here is an example of `[[96, 44, 4]]` Multivariate Multicycle Code from Table II of [mian2026multivariatemulticyclecodescomplete](@cite).

These novel codes are made in QuantumClifford.jl backend of QuantumSavory.

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l, m, p, r = 2, 2, 2, 2;

julia> R, (w, x, y, z) = polynomial_ring(GF(2), [:w, :x, :y, :z]);

julia> I = ideal(R, [w^l - 1, x^m - 1, y^p - 1, z^r - 1]);

julia> S, _ = quo(R, I);

julia> A = S((1 + x)*(1 + y*z));

julia> B = S((1 + y)*(1 + z*w));

julia> C = S((1 + z)*(1 + w*x));

julia> D = S((1 + w)*(1 + x*y));

julia> c = MultivariateMulticycle([l, m, p, r], [A, B, C, D]);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS, time_limit=900))
(96, 44, 4)
```

The Multivariate Multicycle code generalizes the several families of quantum-error correcting codes, namely:

- ## Bivariate bicycle codes ([bravyi2024high](@cite))

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l=21; m=18;

julia> R, (x, y) = polynomial_ring(GF(2), [:x, :y]);

julia> I = ideal(R, [x^l-1, y^m-1]);

julia> S, _ = quo(R, I);

julia> A = S(x^3 + y^10 + y^17);

julia> B = S(y^5 + x^3  + x^19);

julia> c = MultivariateMulticycle([l,m], [A,B]);

julia> code_n(c), code_k(c)
(756, 16)
```

- ## Trivariate tricycle codes ([jacob2025singleshotdecodingfaulttolerantgates](@cite))

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l, m, p = 6, 6, 4;

julia> R, (x, y, z) = polynomial_ring(GF(2), [:x, :y, :z]);

julia> I = ideal(R, [x^l - 1, y^m - 1, z^p - 1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + x*y*z^3 + x^3*y^4*z^2);

julia> B = S(1 + x^3*y*z^2 + x^3*y^2*z^3);

julia> C = S(1 + x^4*y^3*z^3 + x^5*z^2);

julia> c = MultivariateMulticycle([l,m, p], [A, B, C]);

julia> code_n(c), code_k(c)
(432, 12)
```

- ## Abelian Multicycle codes ([lin2025abelianmulticyclecodessingleshot](@cite))

Here is an example of `[[84, 6, 7]]` AMC code from Table I of [lin2025abelianmulticyclecodessingleshot](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l, m, p, r = 14, 1, 1, 1;

julia> R, (w, x, y, z) = polynomial_ring(GF(2), [:w, :x, :y, :z]);

julia> I = ideal(R, [w^l - 1, x^m - 1, y^p - 1, z^r - 1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + w);

julia> B = S(1 + w^2);

julia> C = S(1 + w^5);

julia> D = S(1 + w^6);

julia> c = MultivariateMulticycle([l, m, p, r], [A, B, C, D]);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(84, 6, 7)
```

All the AMC codes from Table I are subfamilies of MM codes. Notably, this family of codes have weight-6 stabilizer checks.

- ## Cyclic Hypergraph product codes ([aydin2025cyclichypergraphproductcode](@cite))

Here is an example of `[[450, 32, 8]]` **C2** code from Table I of [aydin2025cyclichypergraphproductcode](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l=15; m=15;

julia> R, (x, y) = polynomial_ring(GF(2), [:x, :y]);

julia> I = ideal(R, [x^l-1, y^m-1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + x + x^4);

julia> B = S(1 + y + y^4);

julia> c = MultivariateMulticycle([l,m], [A,B]);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS, time_limit=900))
(450, 32, 8)
```

Here is an example of `[[240, 8, 8]]` **CxR** code from Table I of [aydin2025cyclichypergraphproductcode](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l=15; m=8;

julia> R, (x, y) = polynomial_ring(GF(2), [:x, :y]);

julia> I = ideal(R, [x^l-1, y^m-1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + x + x^4);

julia> B = S(1 + y);

julia> c = MultivariateMulticycle([l,m], [A,B]);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS, time_limit=900))
(240, 8, 8)
```

- ## Abelian two-block group algebra codes ([lin2024quantum](@cite))

Here is an example of `[[16, 2, 4]]` abelian 2BGA code from Table II of [lin2024quantum](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l=2; m=4;

julia> R, (s, x) = polynomial_ring(GF(2), [:s, :x]);

julia> I = ideal(R, [s^l-1, x^m-1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + x);

julia> B = S(1 + x + s + x^2 + s*x + s*x^3);

julia> c = MultivariateMulticycle([l,m], [A,B]);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS, time_limit=900))
(16, 2, 4)
```

- ## Generalized bicycle codes ([pryadko2013quantum](@cite))

Here is an example of `[[30, 8, 4]]` generalized bicycle code from [pryadko2013quantum](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l=15; m=1;

julia> R, (x, y) = polynomial_ring(GF(2), [:x, :y]);

julia> I = ideal(R, [x^l-1, y^m-1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + x^2 + x^8);

julia> B = S(1 + x + x^4);

julia> c = MultivariateMulticycle([l,m], [A,B]);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS, time_limit=900))
(30, 8, 4)
```

- ## Multivariate bicycle codes ([voss2024multivariatebicyclecodes](@cite))

Here is an example of `[[48, 4, 6]]` Weight-6 TB-QLDPC code from Appendix A Table 2 of [voss2024multivariatebicyclecodes](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l=4; m=6;

julia> R, (x, y) = polynomial_ring(GF(2), [:x, :y]);

julia> I = ideal(R, [x^l-1, y^m-1]);

julia> S, _ = quo(R, I);

julia> z = x*y;

julia> A = S(x^3 + y^5);

julia> B = S(x + z^5 + y^5 + y^2);

julia> c = MultivariateMulticycle([l,m], [A,B]);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS, time_limit=900))
(48, 4, 6)
```

- ## La-Cross codes ([pecorari2025high](@cite))

Here is an example of `[[98, 18, 4]]` "square" La-Cross from [pecorari2025high](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> n = 7;

julia> R, (x, y) = polynomial_ring(GF(2), [:x, :y]);

julia> I = ideal(R, [x^n-1, y^n-1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + x + x^3);

julia> B = S(1 + y + y^3);

julia> c = MultivariateMulticycle([n,n], [A,B]);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS, time_limit=900))
(98, 18, 4)
```

- ## 4D Toric codes ([dennis2002topological](@cite))

Here is an example of `[[96, 6, 4]]` 4D Toric code from [dennis2002topological](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l, m, p, r = 2, 2, 2, 2;

julia> R, (w, x, y, z) = polynomial_ring(GF(2), [:w, :x, :y, :z]);

julia> I = ideal(R, [w^l - 1, x^m - 1, y^p - 1, z^r - 1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + w);

julia> B = S(1 + x);

julia> C = S(1 + y);

julia> D = S(1 + z);

julia> c = MultivariateMulticycle([l, m, p, r], [A, B, C, D]);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(96, 6, 4)
```

- ## Haah's Cubic codes ([haah2011local](@cite))

Here is an example of a `[[1024, 30, 13 ≤ d ≤ 32]]` Haah's cubic code from Appendix B,
code D of [panteleev2021degenerate](@cite) on the `8 × 8 × 8` Lattice.

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> L = 8;

julia> R, (x,y,z) = polynomial_ring(GF(2), [:x,:y,:z]);

julia> I = ideal(R, [x^L-1, y^L-1, z^L-1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + x + y + z);

julia> B = S(1 + x*y + x*z + y*z);

julia> c = MultivariateMulticycle([L,L,L], [A,B]);

julia> code_n(c), code_k(c)
(1024, 30)
```

See also: [`TrivariateTricycle`](@ref), [`BivariateBicycleViaPoly`](@ref)
"""
struct MultivariateMulticycle <: AbstractCSSCode
    orders::Vector{Int}
    polynomials::Vector{MPolyQuoRingElem{FqMPolyRingElem}}
    function MultivariateMulticycle(orders::Vector{Int}, polys::Vector{<:MPolyQuoRingElem})
        all(x->x>0, orders) || throw(ArgumentError("All orders must be positive"))
        length(polys) ≥ 2 || throw(ArgumentError("Need at least 2 variables to define a CSS code"))
        new(orders, collect(polys))
    end
end

_gf2_to_int(M) = [iszero(M[i,j]) ? 0 : 1 for i in 1:size(M,1), j in 1:size(M,2)]

function _polynomial_to_circulant_matrix(f::MPolyQuoRingElem, orders::Vector{Int})
    t = length(orders)
    N = prod(orders)
    M = zero_matrix(GF(2), N, N)
    f_lift = lift(f)
    for col_idx in 0:(N-1)
        tmp = col_idx
        idxs = Vector{Int}(undef, t)
        for k in t:-1:1
            idxs[k] = tmp % orders[k]
            tmp ÷= orders[k]
        end
        for term in terms(f_lift)
            c = coeff(term, 1)
            iszero(c) && continue
            exps = [degree(term, k) for k in 1:t]
            row_idx = 0
            for k in 1:t
                row_idx = row_idx*orders[k]+mod(idxs[k]+exps[k], orders[k])
            end
            M[row_idx+1, col_idx+1] += c
        end
    end
    return M
end

function boundary_maps(code::MultivariateMulticycle)
    t = length(code.polynomials)
    N = prod(code.orders)
    @debug "Constructing boundary maps for MultivariateMulticycle"
    @debug "Number of variables t = $t"
    for k in 0:t
        dim = binomial(t, k)*N
        @debug "C_$k dimension: $dim == binom($t, $k)*$N"
    end
    circs = [_gf2_to_int(_polynomial_to_circulant_matrix(p, code.orders)) for p in code.polynomials]
    # From Wikipedia: A set of matrices A_1, ... , A_k is said to commute if they commute pairwise,
    # meaning that every pair of matrices in the set commutes. https://en.wikipedia.org/wiki/Commuting_matrices.
    # Circulant matrices commute. They form a commutative ring since the sum of two circulant matrices is circulant.
    for i in 1:t
        for j in i+1:t
            A, B = circs[i], circs[j]
            @assert mod.(A*B, 2) == mod.(B*A, 2)
        end
    end
    maps = Vector{Matrix{Int}}(undef, t)
    R, x = polynomial_ring(GF(2), ["x$i" for i in 1:t])
    K = koszul_complex(x)
    @debug "Koszul complex: $K"
    for k in 1:t
        boundary_map = map(K, k)
        KoszulMatrix = matrix(boundary_map)
        nr, nc = size(KoszulMatrix)
        for i in 1:nr, j in 1:nc
            e = KoszulMatrix[i,j]
            @assert iszero(e) || e in x "Unexpected entry in Koszul matrix at ($i,$j): $e"
        end
        M = zeros(Int, nr*N, nc*N)
        for i in 1:nr, j in 1:nc
            e = KoszulMatrix[i,j]
            !iszero(e) || continue
            found = false
            for idx in 1:t
                if e == x[idx]
                    row_range = ((i-1)*N+1):(i*N)
                    col_range = ((j-1)*N+1):(j*N)
                    M[row_range, col_range] .= circs[idx]
                    found = true
                    break
                end
            end
        end
        maps[k] = M
        @debug "Differential for degree $k: $(size(M))"
    end
    for k in 2:t
        if !isempty(maps[k]) && !isempty(maps[k-1])
            @debug "Checking exactness condition for degree $k: ∂$(k-1)∘∂$k"
            prod_check = mod.(maps[k]*maps[k-1], 2)
            @assert iszero(prod_check) "Exactness failed: ∂$(k-1)∘∂$k ≠ 0 mod 2"
        end
    end
    return maps
end

function parity_matrix_xz(code::MultivariateMulticycle)
    maps = boundary_maps(code)
    t = length(code.polynomials)
    if t == 2
        hx = transpose(maps[1])
        hz = maps[2]
    else
        qd = t ÷ 2
        hx = transpose(maps[qd])
        hz = maps[qd+1]
    end
    return hx, hz
end

parity_matrix_x(c::MultivariateMulticycle) = parity_matrix_xz(c)[1]

parity_matrix_z(c::MultivariateMulticycle) = parity_matrix_xz(c)[2]

"""For t ≥ 4, provides metachecks for X-stabilizers enabling single-shot decoding."""
function metacheck_matrix_x(code::MultivariateMulticycle)
    maps = boundary_maps(code)
    t = length(code.polynomials)
    t ≥ 4 || throw(ArgumentError("X-metachecks require t ≥ 4 variables"))
    qd = t÷2
    return transpose(maps[qd-1])
end

"""For t ≥ 3, provides metachecks for Z-stabilizers enabling single-shot decoding."""
function metacheck_matrix_z(code::MultivariateMulticycle)
    maps = boundary_maps(code)
    t = length(code.polynomials)
    t ≥ 3 || throw(ArgumentError("Z-metachecks require t ≥ 3 variables"))
    qd = t÷2
    return maps[qd+2]
end

hasmetachecks(c::MultivariateMulticycle) = length(c.polynomials) >= 4 ? (true, true) : length(c.polynomials) == 3 ? (false, true) : (false, false)

@testitem "Projective measurements" begin
    using QuantumClifford: stab_looks_good, destab_looks_good, mixed_stab_looks_good, mixed_destab_looks_good
    using QuantumClifford: projectremoverand!

    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.


    @testset "Stabilizer representation" begin
        s = S"XXX
        ZZI
        IZZ"
        ps, anticom, res = project!(copy(s), P"ZII")
        ps = canonicalize!(ps)
        @test anticom==1 && isnothing(res) && ps == S"ZII
        IZI
        IIZ"
        @test stab_looks_good(ps)

        ps, anticom, res = project!(copy(s), P"-XXX")
        @test anticom==0 && res[]==0x2 && ps == canonicalize!(copy(s))
        @test stab_looks_good(ps)

        ps, anticom, res = project!(copy(s), P"-XXX"; keep_result=false)
        @test anticom==0 && isnothing(res) && ps == s
        @test stab_looks_good(ps)

        for n in test_sizes
            s = random_stabilizer(n)
            m = random_pauli(n;nophase=true)
            mop = PauliMeasurement(m)
            ps, anticom, res = project!(copy(s),m)
            @test anticom==0x0 || ps[anticom]==m
            @test tab(ps).xzs == tab(apply!(copy(s),mop)).xzs
            @test stab_looks_good(ps)
            m = single_z(n,1)
            ps, anticom, res = project!(copy(s),m)
            @test anticom==0x0 || ps[anticom]==m
            @test stab_looks_good(ps)
            m = single_x(n,1)
            ps, anticom, res = project!(copy(s),m)
            @test anticom==0x0 || ps[anticom]==m
            @test stab_looks_good(ps)
        end
    end
    @testset "Destabilizer representation" begin
        for n in test_sizes
            s = canonicalize!(random_stabilizer(n))
            m = random_pauli(n;nophase=true)
            ps, anticom, res = project!(copy(s),m)
            dps, danticom, dres = project!(Destabilizer(copy(s)),m)
            @test destab_looks_good(dps)
            @test res==dres && canonicalize!(ps)==canonicalize!(stabilizerview(dps))
            m = single_z(n,1)
            ps, anticom, res = project!(copy(s),m)
            dps, danticom, dres = project!(Destabilizer(copy(s)),m)
            @test destab_looks_good(dps)
            @test res==dres && canonicalize!(ps)==canonicalize!(stabilizerview(dps))
            m = single_x(n,1)
            ps, anticom, res = project!(copy(s),m)
            dps, danticom, dres = project!(Destabilizer(copy(s)),m)
            @test destab_looks_good(dps)
            @test res==dres && canonicalize!(ps)==canonicalize!(stabilizerview(dps))
        end
    end
    @testset "Anticommutation indices and NA results" begin
        s = S" XXX
        -ZZI"
        ds = Destabilizer(copy(s))
        ms = MixedStabilizer(copy(s))
        mds = MixedDestabilizer(copy(s))

        p = P"IZZ"
        ps, a, r = project!(copy(s),p)
        @test stab_looks_good(ps)
        @test a==3 && isnothing(r)
        @test_throws BadDataStructure pds, a, r = project!(copy(ds),p)
        pms, a, r = project!(copy(ms),p)
        @test mixed_stab_looks_good(pms)
        @test rank(pms)==3
        @test a==rank(pms) && isnothing(r)
        pmds, a, r = project!(copy(mds),p)
        @test mixed_destab_looks_good(pmds)
        @test rank(pmds)==3
        @test a==rank(pmds) && isnothing(r)

        p = P"ZZI"
        ps, a, r = project!(copy(s),p)
        @test stab_looks_good(ps)
        @test a==0 && r==0x2
        @test_throws BadDataStructure pds, a, r = project!(copy(ds),p)
        pms, a, r = project!(copy(ms),p)
        @test mixed_stab_looks_good(pms)
        @test rank(pms)==2
        @test a==0 && r==0x2
        pmds, a, r = project!(copy(mds),p)
        @test mixed_destab_looks_good(pmds)
        @test rank(pmds)==2
        @test a==0 && r==0x2
        @test canonicalize!(ps)==canonicalize!(stabilizerview(pms))==canonicalize!(stabilizerview(pmds))

        p = P"XZZ"
        ps, a, r = project!(copy(s),p)
        @test stab_looks_good(ps)
        @test a==2 && isnothing(r)
        pds, a, r = project!(copy(ds),p)
        @test destab_looks_good(pds)
        @test a==2 && isnothing(r)
        pms, a, r = project!(copy(ms),p)
        @test mixed_stab_looks_good(pms)
        @test rank(pms)==2
        @test a==2 && isnothing(r)
        pmds, a, r = project!(copy(mds),p)
        @test mixed_destab_looks_good(pmds)
        @test rank(pmds)==2
        @test a==2 && isnothing(r)
        @test canonicalize!(ps)==canonicalize!(stabilizerview(pms))==canonicalize!(stabilizerview(pds))==canonicalize!(stabilizerview(pmds))
    end
    @testset "Mixed Destabilizer projection on logical operator" begin
        stab = one(MixedDestabilizer, 2,4)
        projzl = single_z(4,1)
        projzr = single_z(4,4)
        projxl = single_x(4,1)
        projxr = single_x(4,4)
        s, a, r = project!(copy(stab), projzl)
        @test mixed_destab_looks_good(s)
        @test a==0 && r==0x0       && stabilizerview(s)==S"Z___
        _Z__"
        s, a, r = project!(copy(stab), projxl)
        @test mixed_destab_looks_good(s)
        @test a==1 && isnothing(r) && stabilizerview(s)==S"X___
        _Z__"
        s, a, r = project!(copy(stab), projzr)
        @test mixed_destab_looks_good(s)
        @test a==3 && isnothing(r) && stabilizerview(s)==S"Z___
        _Z__
        ___Z"
        s, a, r = project!(copy(stab), projxr)
        @test mixed_destab_looks_good(s)
        @test a==3 && isnothing(r) && stabilizerview(s)==S"Z___
        _Z__
        ___X"
    end
    @testset "Interface Particularities" begin
        s = S"ZII IZI"
        _, a, r = project!(copy(s), P"IZI"; keep_result=true)
        @test (a, r) == (0, 0x0) # on commuting operator in the stabilizer
        _, a, r = project!(copy(s), P"IIZ"; keep_result=true)
        @test (a, r) == (3, nothing) # on commuting operator out of the stabilizer
        _, a, r = project!(copy(s), P"IZI"; keep_result=false)
        @test (a, r) == (0, nothing) # on commuting operator in the stabilizer
        _, a, r = project!(copy(s), P"IIZ"; keep_result=false)
        @test (a, r) == (0, nothing) # on commuting operator out of the stabilizer
        s = S"ZII IZI III"
        _, a, r = project!(copy(s), P"IZI"; keep_result=true)
        @test (a, r) == (0, 0x0) # on commuting operator in the stabilizer
        _, a, r = project!(copy(s), P"IIZ"; keep_result=true)
        @test (a, r) == (3, nothing) # on commuting operator out of the stabilizer
        _, a, r = project!(copy(s), P"IZI"; keep_result=false)
        @test (a, r) == (0, nothing) # on commuting operator in the stabilizer
        _, a, r = project!(copy(s), P"IIZ"; keep_result=false)
        @test (a, r) == (0, nothing) # on commuting operator out of the stabilizer
        s = MixedStabilizer(s, 2)
        ms, a, r = project!(copy(s), P"IZI")
        @test (a, r) == (0, 0x0) # on commuting operator in the stabilizer
        @test rank(ms) == 2
        ms, a, r = project!(copy(s), P"IIZ")
        @test (a, r) == (3, nothing) # on commuting operator out of the stabilizer
        @test rank(ms) == 3
        s = S"ZII IZI"
        s = Destabilizer(s)
        @test_throws BadDataStructure project!(copy(s), P"IZI"; keep_result=true)  # on comm
        @test_throws BadDataStructure project!(copy(s), P"IIZ"; keep_result=true)  # operators
        @test_throws BadDataStructure project!(copy(s), P"IZI"; keep_result=false) # in or out of
        @test_throws BadDataStructure project!(copy(s), P"IIZ"; keep_result=false) # the stabilizer
        s = S"ZII IZI IIZ"
        s = Destabilizer(s)
        _, a, r = project!(copy(s), P"IIZ"; keep_result=true)
        @test (a, r) == (0, 0x0)
        _, a, r = project!(copy(s), P"IIZ"; keep_result=false)
        @test (a, r) == (0, nothing)
        s = S"ZII IZI"
        s = MixedDestabilizer(s)
        mds, a, r = project!(copy(s), P"IZI"; keep_result=true)
        @test (a, r) == (0, 0x0) # on commuting operator in the stabilizer
        @test rank(mds) == 2
        mds, a, r = project!(copy(s), P"IIZ"; keep_result=true)
        @test (a, r) == (3, nothing) # on commuting operator out of the stabilizer
        @test rank(mds) == 3
        mds, a, r = project!(copy(s), P"IZI"; keep_result=false)
        @test (a, r) == (0, nothing) # on commuting operator in the stabilizer
        @test rank(mds) == 2
        mds, a, r = project!(copy(s), P"IIZ"; keep_result=false)
        @test (a, r) == (3, nothing) # on commuting operator out of the stabilizer
        @test rank(mds) == 3
    end
    @testset "Results from canonicalization vs from destabilizer" begin
        @test generate!(P"_Z", S"XZ") === nothing # for bug fixed in 4b536231c3ee4e6446262fcc61ba8da669415bc8
        for n in test_sizes
            for r in [n, rand(n÷3:n*2÷3)]
                s = random_stabilizer(r,n)
                ms = MixedStabilizer(copy(s))
                d = Destabilizer(copy(s))
                md = MixedDestabilizer(copy(s))
                p = random_pauli(n,realphase=true)
                _, as, rs = project!(s,p)
                _, ams, rms = project!(ms,p)
                _, amd, rmd = project!(md,p)
                @test rs == rms == rmd
                @test (rank(md)!=r) || (canonicalize!(s) == canonicalize!(stabilizerview(ms)))
                @test canonicalize!(stabilizerview(ms)) == canonicalize!(stabilizerview(md))
                if as == 0
                    @test ams == amd == 0
                end
                if r == n
                    _, ad, rd = project!(d,p)
                    @test s == canonicalize!(stabilizerview(d))
                    @test rd == rs
                    if as == 0
                        @test ad == 0
                    end
                end
            end
        end
    end
    @testset "Reported phase" begin
        s = S"ZII IZI"
        _, a, r = project!(copy(s), P"IZI"; keep_result=true)
        @test (a, r) == (0, 0x0) # on commuting operator in the stabilizer
        _, a, r = project!(copy(s), P"-IZI"; keep_result=true)
        @test (a, r) == (0, 0x2) # on commuting operator in the stabilizer
        _, a, r = project!(copy(s), P"IIZ"; keep_result=true)
        @test (a, r) == (3, nothing) # on commuting operator out of the stabilizer
        _, a, r = project!(copy(s), P"-IIZ"; keep_result=true)
        @test (a, r) == (3, nothing) # on commuting operator out of the stabilizer
        _, a, r = project!(copy(s), P"-IIZ"; keep_result=false)
        @test (a, r) == (0, nothing) # on commuting operator out of the stabilizer

        s = S"ZII -IZI"
        _, a, r = project!(copy(s), P"IZI"; keep_result=true)
        @test (a, r) == (0, 0x2) # on commuting operator in the stabilizer
        _, a, r = project!(copy(s), P"-IZI"; keep_result=true)
        @test (a, r) == (0, 0x0) # on commuting operator in the stabilizer

        s = S"ZII IZI III"
        s = MixedStabilizer(s, 2)
        _, a, r = project!(copy(s), P"IZI")
        @test (a, r) == (0, 0x0) # on commuting operator in the stabilizer
        _, a, r = project!(copy(s), P"-IZI")
        @test (a, r) == (0, 0x2) # on commuting operator in the stabilizer
        _, a, r = project!(copy(s), P"IIZ")
        @test (a, r) == (3, nothing) # on commuting operator out of the stabilizer
        _, a, r = project!(copy(s), P"-IIZ")
        @test (a, r) == (3, nothing) # on commuting operator out of the stabilizer
        s = S"ZII -IZI III"
        s = MixedStabilizer(s, 2)
        _, a, r = project!(copy(s), P"IZI")
        @test (a, r) == (0, 0x2) # on commuting operator in the stabilizer
        _, a, r = project!(copy(s), P"-IZI")
        @test (a, r) == (0, 0x0) # on commuting operator in the stabilizer

        s = S"ZII IZI IIZ"
        s = Destabilizer(s)
        _, a, r = project!(copy(s), P"IIZ"; keep_result=true)
        @test (a, r) == (0, 0x0)
        _, a, r = project!(copy(s), P"-IIZ"; keep_result=true)
        @test (a, r) == (0, 0x2)
        s = S"ZII IZI -IIZ"
        s = Destabilizer(s)
        _, a, r = project!(copy(s), P"IIZ"; keep_result=true)
        @test (a, r) == (0, 0x2)
        _, a, r = project!(copy(s), P"-IIZ"; keep_result=true)
        @test (a, r) == (0, 0x0)

        s = S"ZII IZI"
        s = MixedDestabilizer(s)
        mds, a, r = project!(copy(s), P"IZI"; keep_result=true)
        @test (a, r) == (0, 0x0) # on commuting operator in the stabilizer
        mds, a, r = project!(copy(s), P"-IZI"; keep_result=true)
        @test (a, r) == (0, 0x2) # on commuting operator in the stabilizer
        mds, a, r = project!(copy(s), P"IIZ"; keep_result=true)
        @test (a, r) == (3, nothing) # on commuting operator out of the stabilizer
        mds, a, r = project!(copy(s), P"-IIZ"; keep_result=true)
        @test (a, r) == (3, nothing) # on commuting operator out of the stabilizer
        s = S" ZII -IZI"
        s = MixedDestabilizer(s)
        mds, a, r = project!(copy(s), P"IZI"; keep_result=true)
        @test (a, r) == (0, 0x2) # on commuting operator in the stabilizer
        mds, a, r = project!(copy(s), P"-IZI"; keep_result=true)
        @test (a, r) == (0, 0x0) # on commuting operator in the stabilizer
    end
    @testset "Single Qubit Projections" begin
        for n in test_sizes
            s = MixedDestabilizer(random_destabilizer(n),n÷2);
            r = rand(1:n)
            px = single_x(n,r);
            py = single_y(n,r);
            pz = single_z(n,r);
            @test project!(copy(s),px) == projectX!(copy(s),r)
            @test project!(copy(s),py) == projectY!(copy(s),r)
            @test project!(copy(s),pz) == projectZ!(copy(s),r)
            sx = project!(copy(s),px)[1]
            sy = project!(copy(s),py)[1]
            sz = project!(copy(s),pz)[1]
            ssx = project!(copy(s),sMX(r))[1]
            ssy = project!(copy(s),sMY(r))[1]
            ssz = project!(copy(s),sMZ(r))[1]
            rssx = projectrand!(copy(s),sMX(r))[1]
            rssy = projectrand!(copy(s),sMY(r))[1]
            rssz = projectrand!(copy(s),sMZ(r))[1]
            @test project!(copy(sx),px) == projectX!(copy(sx),r)
            @test project!(copy(sy),py) == projectY!(copy(sy),r)
            @test project!(copy(sz),pz) == projectZ!(copy(sz),r)
            @test tab(apply!(copy(s),sMX(r))).xzs == tab(sx).xzs == tab(ssx).xzs == tab(rssx).xzs
            @test tab(apply!(copy(s),sMY(r))).xzs == tab(sy).xzs == tab(ssy).xzs == tab(rssy).xzs
            @test tab(apply!(copy(s),sMZ(r))).xzs == tab(sz).xzs == tab(ssz).xzs == tab(rssz).xzs
        end
    end

    # project*! should accept AbstractStabilizer, or Stabilizer in particular
    # This testset is not merged with the previous one as "measuring commuting operator out of the stabilizer"
    # is not well supported for pure stabilizer state datastructure. See also "Datastructure Choice"
    @testset "Single Qubit Pure State Projections" begin
        for n in test_sizes
            s = random_stabilizer(n);
            r = rand(1:n)
            px = single_x(n,r);
            py = single_y(n,r);
            pz = single_z(n,r);
            @test project!(copy(s),px) == projectX!(copy(s),r)
            @test project!(copy(s),py) == projectY!(copy(s),r)
            @test project!(copy(s),pz) == projectZ!(copy(s),r)
            sx = project!(copy(s),px)[1]
            sy = project!(copy(s),py)[1]
            sz = project!(copy(s),pz)[1]
            ssx = project!(copy(s),sMX(r))[1]
            ssy = project!(copy(s),sMY(r))[1]
            ssz = project!(copy(s),sMZ(r))[1]
            rssx = projectrand!(copy(s),sMX(r))[1]
            rssy = projectrand!(copy(s),sMY(r))[1]
            rssz = projectrand!(copy(s),sMZ(r))[1]
            @test project!(copy(sx),px) == projectX!(copy(sx),r)
            @test project!(copy(sy),py) == projectY!(copy(sy),r)
            @test project!(copy(sz),pz) == projectZ!(copy(sz),r)
            @test tab(apply!(copy(s),sMX(r))).xzs == tab(sx).xzs == tab(ssx).xzs == tab(rssx).xzs
            @test tab(apply!(copy(s),sMY(r))).xzs == tab(sy).xzs == tab(ssy).xzs == tab(rssy).xzs
            @test tab(apply!(copy(s),sMZ(r))).xzs == tab(sz).xzs == tab(ssz).xzs == tab(rssz).xzs
        end
    end
    @testset "project! projectrand! project*! project*rand! apply!(...,sM*) consistency" begin
        s = S"XII -IZI IIY"
        _,_, r1 = project!(MixedDestabilizer(copy(s)), sMX(1))
        _,_, r2 = project!(copy(s), P"XII")
        _, r3 = projectrand!(copy(s), P"XII")
        r4 = bitview(apply!(Register(copy(s), [0]),sMX(1)))[1]
        _, _, r5 = projectX!(copy(s), 1)
        _, r6 = projectXrand!(copy(s), 1)
        @test r1 == r2 == r3 == r4 == r5 == r6
        _,_, r1 = project!(MixedDestabilizer(copy(s)), sMZ(2))
        _,_, r2 = project!(copy(s), P"IZI")
        _, r3 = projectrand!(copy(s), P"IZI")
        r4 = bitview(apply!(Register(copy(s), [0]),sMZ(2)))[1]
        _, _, r5 = projectZ!(copy(s), 2)
        _, r6 = projectZrand!(copy(s), 2)
        @test r1%2 == r2%2 == r3%2 == r4 == r5%2 == r6%2
        _,_, r1 = project!(MixedDestabilizer(copy(s)), sMY(3))
        _,_, r2 = project!(copy(s), P"IIY")
        _, r3 = projectrand!(copy(s), P"IIY")
        r4 = bitview(apply!(Register(copy(s), [0]),sMY(3)))[1]
        _, _, r5 = projectY!(copy(s), 3)
        _, r6 = projectYrand!(copy(s), 3)
        @test r1 == r2 == r3 == r4 == r5 == r6
    end
    @testset "projectremoverand!" begin
        for n in test_sizes
            n > 3 || continue
            state = MixedDestabilizer(random_destabilizer(n),n÷2)
            state_a = projectremoverand!(copy(state),projectX!,n)[1]
            state_b = traceout!(projectX!(state,n)[1],n)
            @test stab_to_gf2(canonicalize!(stabilizerview(state_a))) == stab_to_gf2(canonicalize!(stabilizerview(state_b)[:,1:end-1]))
        end
    end
    @testset "Redundant row permutations in `project!(::MixedDestabilizer)`" begin
        # Fixed in 41ed1d3c
        destab =  T"+ ZX_Y_YXZ
        + XY_Y____
        + _Z_XXY__
        + _ZYXXY__
        + X__Y_ZXZ
        + X__YXZXZ
        + ___YXXZZ
        + _______Z"
        stab =    T"+ X_______
        + _X_Y____
        + __ZY____
        + __Z_____
        + ___YZY__
        + X__YZYZZ
        + X____YZZ
        + ______YX"
        t = MixedDestabilizer(vcat(destab,stab), 8)
        @test mixed_destab_looks_good(t)
        c = copy(stabilizerview(t)[[1,3,5,7]])
        traceout!(t,[1,4,3,6])
        @test mixed_destab_looks_good(t)
        project!(t,c[1])
        @test mixed_destab_looks_good(t)
        project!(t,c[2])
        @test mixed_destab_looks_good(t) # This used to fail because anticomlog==rank+1 leading to a repeated row permutation
    end
end

@testitem "CUDA" tags = [:cuda] begin

    include("implementation/test_platform.jl")

    using CUDA: CuArray, devices, synchronize
    const AT = CuArray

    const can_run = length(devices()) > 0

    @testset "Device availability" begin
        @test can_run
    end

    if can_run
        test_platform(AT, synchronize)
    end

end

"""
`Concat(c₁, c₂)` is a code concatenation of two quantum codes [knill1996concatenated](@cite).

The inner code c₁ and the outer code c₂.
The construction is the following: replace each qubit in code c₂ with logical qubits encoded by code c₁.
The resulting code will have `n = n₁ × n₂` qubits and `k = k₁ × k₂` logical qubits.
"""
struct Concat <: AbstractECC
    c₁::AbstractECC
    c₂::AbstractECC
end

function parity_checks(c::Concat)
    c₁ = c.c₁
    c₂ = c.c₂
    k₁ = code_k(c₁)
    n₁ = code_n(c₁)
    n₂ = code_n(c₂)
    s₁ = code_s(c₁)
    s₂ = code_s(c₂)
    inner_checks = Stabilizer(vcat([embed(n₁ * n₂, 1+(i-1)*n₁:i*n₁, parity_checks(c₁)[j]) for i in 1:n₂ for j in 1:s₁])) # parity checks of c₁ on each qubit of c₂
    h₂ = parity_matrix(c₂)
    phases₂ = phases(parity_checks(c₂))
    h_logx₁ = stab_to_gf2(logx_ops(c₁))
    phases_logx₁ = phases(logx_ops(c₁))
    h_logz₁ = stab_to_gf2(logz_ops(c₁))
    phases_logz₁ = phases(logz_ops(c₁))
    # parity checks of c₂ with qubits repalced with logical qubits of c₁
    outer_check_h = transpose(hcat([vcat(
        kron(h₂[i, 1:end÷2], h_logx₁[j, 1:end÷2]) .⊻ kron(h₂[i, end÷2+1:end], h_logz₁[j, 1:end÷2]), # X part
        kron(h₂[i, 1:end÷2], h_logx₁[j, end÷2+1:end]) .⊻ kron(h₂[i, end÷2+1:end], h_logz₁[j, end÷2+1:end]) # Z part
    ) for i in 1:s₂ for j in 1:k₁]...))
    outer_check_phase = [UInt8(sum(h₂[i, 1:end÷2] * phases_logx₁[j]) + sum(h₂[i, end÷2+1:end] * phases_logz₁[j]) + phases₂[i]) & 0x3 for i in 1:s₂ for j in 1:k₁]
    outer_checks = Stabilizer(outer_check_phase, outer_check_h)
    vcat(inner_checks, outer_checks)
end

code_n(c::Concat) = code_n(c.c₁) * code_n(c.c₂)

code_k(c::Concat) = code_k(c.c₁) * code_k(c.c₂)

function iscss(c::Concat)
    if iscss(c.c₁) && iscss(c.c₂)
        true
    end
    return nothing # if c.c₁ or c.c₂ are non-CSS; in this case, `Concat(c₁, c₂)` can still be CSS
end

"""
    $TYPEDEF

Bivariate Bicycle codes are CSS codes constructed using the *quotient ring*
``R = \\mathbb{F}_2[x, y] / \\langle x^\\ell - 1, y^m - 1 \\rangle``.

# Quotient Ring Formalism

We begin with the polynomial ring ``\\mathbb{F}_2[x, y]``, which is the ring of polynomials in two variables, x and y,
with coefficients in the field ``\\mathbb{F}_2``. The operations are standard polynomial addition and multiplication.

An [ideal](https://en.wikipedia.org/wiki/Ideal_(ring_theory)) is the ring-theoretic analogue of a [normal subgroup](https://en.wikipedia.org/wiki/Normal_subgroup)
from group theory. Just as normal subgroups enable the construction of quotient groups, ideals allow us to form quotient rings.

For a subset I of a ring R to be an ideal, it must satisfy the following properties:
- ``(I, +) \\leq (R, +)``
- ``y \\in R, i \\in I: i \\cdot y \\in I``
- ``x \\in R, i \\in I: x \\cdot i \\in I``

Once we have an ideal, we can construct the quotient ring R/I, whose elements are the cosets themselves. The operations
are defined by adding or multiplying these cosets together. It is important to note that an ideal is not a subring because
it typically does not contain the multiplicative identity. If an ideal contains 1, it must be the entire ring.

We consider the specific ideal generated by two polynomials enforcing periodic boundary conditions:

```math
\\begin{aligned}
J = \\langle x^\\ell - 1, y^m - 1 \\rangle = { p(x,y)(x^\\ell - 1) + q(x,y)(y^m - 1) \\mid p, q \\in \\mathbb{F}_2[x,y]}
\\end{aligned}
```

is a subset of a ring that is closed under addition and under multiplication by any element of the ring (see Definition
10.28 and 10.39) from [ernst2016inquiry](@cite). The set I is the ideal generated by the two polynomials ``x^\\ell - 1``
and ``y^m - 1`` (see Definition 10.45) from [ernst2016inquiry](@cite). This ideal enforces *wrapping around* in both spatial
dimensions: ``x^\\ell - 1`` creates periodic boundary conditions in the x-direction and ``y^m - 1`` creates periodic boundary
conditions in the y-direction.

Formally, to verify that ``J`` satisfies the *ideal* requirements, the properties of J are as follows:

- ``(J, +) \\leq \\mathbb{F}_2[x, y], +)``

For any ``f(x,y) \\in \\mathbb{F}_2[x, y]`` and any ``j(x,y) \\in J``:
- ``f(x,y) \\cdot j(x,y) \\in J``
- ``j(x,y) \\cdot f(x,y) \\in J``

```jldoctest idealsandquotientrings
julia> using Oscar; using QuantumClifford.ECC;

julia> F₂ = GF(2);

julia> R, (x, y) = polynomial_ring(F₂, [:x, :y]);

julia> l, m = 4, 3
(4, 3)

julia> J = ideal(R, [x^l - 1, y^m - 1])
Ideal generated by
  x^4 + 1
  y^3 + 1

julia> x*(x^l - 1) + y*(y^m - 1) ∈ J
true

julia> (x^2 + y)*(x^l - 1) + (x*y + 1)*(y^m - 1) ∈ J
true

julia> 0*(x^l - 1) + 0*(y^m - 1) ∈ J
true
```

The quotient ring ``R = \\mathbb{F}_2[x, y] / I`` is formed by taking the set of [cosets](https://en.wikipedia.org/wiki/Coset)
``f + I``. In this ring, two polynomials are considered the same if their difference is in I. The operations are defined by:

```math
\\begin{aligned}
(f + I) + (g + I) = (f + g) + I, \\quad (f + I)(g + I) = (fg) + I
\\end{aligned}
```

This imposes the relations ``x^\\ell = 1`` and ``y^m = 1``. The operations of addition and multiplication
are performed modulo the ideal I. See Theorem 10.44 of [ernst2016inquiry](@cite) for more details.

```jldoctest idealsandquotientrings
julia> Q, proj = quo(R, J);

julia> x_Q, y_Q = proj(x), proj(y);

julia> zero_Q, one_Q = Q(0), Q(1);

julia> x_Q^l == one_Q
true

julia> y_Q^m == one_Q
true

julia> x_Q^l - one_Q == zero_Q
true

julia> y_Q^m - one_Q == zero_Q
true
```

As a vector space over ``\\mathbb{F}_2``, R has dimension ``\\ell m`` with basis

```math
\\begin{aligned}
{ x^i y^j : 0 \\le i < \\ell, 0 \\le j < m}
\\end{aligned}
```

```jldoctest idealsandquotientrings
julia> basis_elems = [x_Q^i*y_Q^j for i in 0:l-1, j in 0:m-1]
4×3 Matrix{MPolyQuoRingElem{FqMPolyRingElem}}:
 1    y      y^2
 x    x*y    x*y^2
 x^2  x^2*y  x^2*y^2
 x^3  x^3*y  x^3*y^2

julia> length(unique(basis_elems)) == l*m
true
```

There is an injective ring homomorphism from ``R`` to ``\\mathbb{F}_2^{\\ell m \\times \\ell m}``
given by ``x \\mapsto S_\\ell \\otimes I_m`` and ``y \\mapsto I_k \\otimes S_m``, where ``S_k`` is
the cyclic shift matrix of size ``k \\times k`` [eberhardt2024logical](@cite). This homomorphism
allows us to work with either the polynomial quotient ring or explicit circulant matrix formulation.
We implement the polynomial quotient ring formalism.

#### Examples

Here is the `[[54, 8, 6]]` from Table 1 [wang2024coprime](@cite)

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l=3; m=9;

julia> R, (x, y) = polynomial_ring(GF(2), [:x, :y]);

julia> I = ideal(R, [x^l-1, y^m-1]);

julia> S, _ = quo(R, I);

julia> A = S(1 + y^2 + y^4);

julia> B = S(y^3 + x + x^2);

julia> c = BivariateBicycleViaPoly(l, m, A, B);

julia> code_n(c), code_k(c)
(54, 8)
```

Here is the `[[72, 12, 6]]` from Table 3 of [bravyi2024high](@cite)

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l=6; m=6;

julia> R, (x, y) = polynomial_ring(GF(2), [:x, :y]);

julia> I = ideal(R, [x^l-1, y^m-1]);

julia> S, _ = quo(R, I);

julia> A = S(x^3 + y + y^2);

julia> B = S(y^3 + x + x^2);

julia> c = BivariateBicycleViaPoly(l, m, A, B);

julia> code_n(c), code_k(c)
(72, 12)
```

Here is the `[[756, 16, ≤ 34]]` from Table 3 of [bravyi2024high](@cite)

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l=21; m=18;

julia> R, (x, y) = polynomial_ring(GF(2), [:x, :y]);

julia> I = ideal(R, [x^l-1, y^m-1]);

julia> S, _ = quo(R, I);

julia> A = S(x^3 + y^10 + y^17);

julia> B = S(y^5 + x^3 + x^19);

julia> c = BivariateBicycleViaPoly(l, m, A, B);

julia> code_n(c), code_k(c)
(756, 16)
```

Here is the `[[128, 14, 12]]` from Table 1 [eberhardt2024logical](@cite)

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l=8; m=8;

julia> R, (x, y) = polynomial_ring(GF(2), [:x, :y]);

julia> I = ideal(R, [x^l-1, y^m-1]);

julia> S, _ = quo(R, I);

julia> A = S(x^2 + y + y^3 + y^4);

julia> B = S(y^2 + x + x^3 + x^4);

julia> c = BivariateBicycleViaPoly(l, m, A, B);

julia> code_n(c), code_k(c)
(128, 14)
```

# Relationships to other QECCs

This implementation uses the polynomial quotient ring formalism. The same codes can be constructed
using various other approaches:

!!! note
    In the discussion below, we consider the `[[72, 12, 6]]` Bivariate bicycle code as introduced in [bravyi2024high](@cite). For a detailed
    explanation of the *isomorphisms* connecting group algebra of cyclic groups, multivariate quotient rings, and circulant matrix representations,
    see `BivariateBicycleViaCirculantMat`.

- `BivariateBicycleViaCirculantMat`: A generalization of the circulant bivariate bicycle code introduced in [bravyi2024high](@cite),
extending the original three-term polynomial representation up to `l` terms (for `x`-powers) and
`m` terms (for `y`-powers). Instead of polynomials, we provide the *monomial* terms as lists of tuples:

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l = 6;

julia> m = 6;

julia> A = [(:x, 3), (:y, 1), (:y, 2)];

julia> B = [(:y, 3), (:x, 1), (:x, 2)];

julia> c = BivariateBicycleViaCirculantMat(l, m, A, B);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(72, 12, 6)
```

- `LPCode`: Bivariate Bicycle codes are children of *abelian* [Lifted Product](https://errorcorrectionzoo.org/c/abelian_lifted_product) codes. We provide the ``1 x 1`` matrix of group algebra elements:

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l = 6;

julia> m = 6;

julia> GA = group_algebra(GF(2), abelian_group([l, m]));

julia> x, y = gens(GA);

julia> A = reshape([x^3 + y + y^2], (1, 1));

julia> B = reshape([y^3 + x + x^2], (1, 1));

julia> c = LPCode(A, B);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(72, 12, 6)
```

- `two_block_group_algebra_code`:  Bivaraite Bicycle codes are a subfamily of *abelian* [2BGA](https://errorcorrectionzoo.org/c/2bga) codes, which themselves are instances of [Lifted Product](https://errorcorrectionzoo.org/c/abelian_lifted_product) codes.

```jldoctest
julia> using Oscar; using QuantumClifford.ECC;

julia> l=6; m=6;

julia> GA = group_algebra(GF(2), abelian_group([l, m]));

julia> x, y = gens(GA);

julia> A = x^3 + y + y^2;

julia> B = y^3 + x + x^2;

julia> c = two_block_group_algebra_code(A,B);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(72, 12, 6)
```

- `generalized_bicycle_code_as_2bga` and `GeneralizedBicycle`: Bivariate Bicycle codes are siblings of [generalized bicycle](https://errorcorrectionzoo.org/c/generalized_bicycle) codes - both are children of [2BGA](https://errorcorrectionzoo.org/c/2bga) codes.

- `bicycle_code_as_2bga`: The [bicycle](https://errorcorrectionzoo.org/c/bicycle) codes are children of (https://errorcorrectionzoo.org/c/generalized_bicycle) codes.

- `ExtendedGeneralizedBicycle`: These codes are constructed through *algebraic extension* of [generalized bicycle](https://errorcorrectionzoo.org/c/generalized_bicycle) codes.

### Fields
    $TYPEDFIELDS
"""
struct BivariateBicycleViaPoly <: AbstractCSSCode
    """Order of the first abelian group in ``\\mathbb{F}_2[\\mathbb{Z}_\\ell \\times \\mathbb{Z}_m]``"""
    l::Int
    """Order of the second abelian group in ``\\mathbb{F}_2[\\mathbb{Z}_\\ell \\times \\mathbb{Z}_m]``"""
    m::Int
    """First bivariate polynomial in quotient ring ``\\frac{\\mathbb{F}_2[x, y]}{\\langle x^\\ell-1, y^m-1 \\rangle}``"""
    c::MPolyQuoRingElem
    """Second bivariate polynomial in quotient ring ``\\frac{\\mathbb{F}_2[x, y]}{\\langle x^\\ell-1, y^m-1 \\rangle}``"""
    d::MPolyQuoRingElem

    function BivariateBicycleViaPoly(l::Int, m::Int, c::MPolyQuoRingElem, d::MPolyQuoRingElem)
        l > 0 || throw(ArgumentError("l must be positive"))
        m > 0 || throw(ArgumentError("m must be positive"))
        parent(c) == parent(d) || throw(ArgumentError("Polynomials must be in the same quotient ring"))
        Q = parent(c)
        R = base_ring(Q)
        base_ring(R) == GF(2) || throw(ArgumentError("Base ring must be GF(2)"))
        nvars(R) == 2 || throw(ArgumentError("Must be bivariate polynomials"))
        new(l, m, c, d)
    end
end

function _poly_to_coeff_mat(poly::MPolyQuoRingElem, l::Int, m::Int)
    mat = zeros(Int, l, m)
    for term in terms(lift(poly))
        coeffᵥₐₗ = coeff(term, 1)
        coeffᵢₙₜ = iszero(coeffᵥₐₗ) ? 0 : 1
        monom = monomial(term, 1)
        exps = exponent_vector(monom, 1)
        i = length(exps) >= 1 ? exps[1] : 0
        j = length(exps) >= 2 ? exps[2] : 0
        i = mod(i, l)
        j = mod(j, m)
        if i < l && j < m
            mat[i+1, j+1] = coeffᵢₙₜ
        end
    end
    return mat
end

function _bivariate_circulant(coeff_mat::Matrix{Int})
    l, m = size(coeff_mat)
    n = l*m
    circ_mat = zeros(Int, n, n)
    for i₁ in 0:l-1, j₁ in 0:m-1
        row_idx = i₁*m+j₁+1
        for i₂ in 0:l-1, j₂ in 0:m-1
            i_mod = mod(i₁+i₂, l)
            j_mod = mod(j₁+j₂, m)
            col_idx = i_mod*m+j_mod+1
            circ_mat[row_idx, col_idx] += coeff_mat[i₂+1, j₂+1]
        end
    end
    return circ_mat
end

function parity_matrix_xz(c::BivariateBicycleViaPoly)
    A_coeff = _poly_to_coeff_mat(c.c, c.l, c.m)
    B_coeff = _poly_to_coeff_mat(c.d, c.l, c.m)
    A = _bivariate_circulant(A_coeff)
    B = _bivariate_circulant(B_coeff)
    hx, hz = hcat(A, B), hcat(transpose(B), transpose(A))
    return hx, hz
end

parity_matrix_x(c::BivariateBicycleViaPoly) = parity_matrix_xz(c)[1]

parity_matrix_z(c::BivariateBicycleViaPoly) = parity_matrix_xz(c)[2]

code_n(c::BivariateBicycleViaPoly) = 2*c.l*c.m

module ECC

using QECCore
import QECCore: code_n, code_s, code_k, rate, distance, parity_matrix_x, parity_matrix_z, parity_matrix,
metacheck_matrix_x, metacheck_matrix_z, metacheck_matrix, hgp, generator_polynomial, hasmetachecks
using QuantumClifford: QuantumClifford, AbstractOperation, AbstractStabilizer,
    AbstractTwoQubitOperator, Stabilizer, PauliOperator,
    random_brickwork_clifford_circuit, random_all_to_all_clifford_circuit,
    canonicalize!, canonicalize_gott!,
    logicalxview, logicalzview, stabilizerview, destabilizerview, tab, phases,
    sCNOT, sSWAP, sHadamard, sPhase, sInvPhase,
    sZCX, sZCY, sZCZ, sXCX, sXCY, sXCZ, sYCX, sYCY, sYCZ, sZ, sX, sY, sMRZ, sMRX,
    single_x, single_y, single_z, random_pauli!, PauliError,
    apply!, comm, comm!, stab_to_gf2, embed, @S_str, affectedqubits, affectedbits,
    pftrajectories, measurements, mctrajectories
import QuantumClifford: Stabilizer, MixedDestabilizer, nqubits

using Combinatorics: combinations
using LinearAlgebra: LinearAlgebra, I, rank, tr
using Nemo: ZZ, residue_ring, matrix, finite_field, GF, minpoly, coeff, lcm, FqPolyRingElem, FqFieldElem, is_zero, degree, defining_polynomial, is_irreducible, echelon_form
using SparseArrays: sparse
using Statistics: std

using DocStringExtensions

export parity_checks, parity_matrix_x, parity_matrix_z, iscss,
    code_n, code_s, code_k, rate, distance, DistanceMIPAlgorithm,
    metacheck_matrix_x, metacheck_matrix_z, metacheck_matrix,
    isdegenerate, faults_matrix,
    naive_syndrome_circuit, shor_syndrome_circuit, naive_encoding_circuit,
    RepCode, LiftedCode,
    CSS,
    Shor9, Steane7, Cleve8, Perfect5, Bitflip3,
    Toric, Gottesman, Surface, Concat, CircuitCode,
    LPCode, two_block_group_algebra_code, generalized_bicycle_code_as_2bga, bicycle_code_as_2bga,
    Haah_cubic_code_as_2bga, twobga_from_fp_group, twobga_from_direct_product,
    TillichZemor, random_TillichZemor_code,
    random_brickwork_circuit_code, random_all_to_all_circuit_code,
    Triangular488, Triangular666, honeycomb_color_code_as_2bga, DelfosseReichardt,
    DelfosseReichardtRep, DelfosseReichardt823, LaCross,
    QuantumTannerGraphProduct, CyclicQuantumTannerGraphProduct,
    DDimensionalSurface, DDimensionalToric, boundary_maps,
    BivariateBicycleViaCirculantMat, GeneralizedHyperGraphProduct,
    GeneralizedBicycle, ExtendedGeneralizedBicycle,
    HomologicalProduct, DoubleHomologicalProduct,
    GeneralizedToric, TrivariateTricycle, BivariateBicycleViaPoly,
    MultivariateMulticycle,
    evaluate_decoder,
    CommutationCheckECCSetup, NaiveSyndromeECCSetup, ShorSyndromeECCSetup,
    TableDecoder, CSSTableDecoder,
    BeliefPropDecoder, BitFlipDecoder,
    PyBeliefPropDecoder, PyBeliefPropOSDecoder, PyMatchingDecoder, TesseractDecoder, DecoderCorrectionGate

"""Parity check tableau of a code.

See also: [`parity_matrix_x`](@ref) and [`parity_matrix_z`](@ref)"""
function parity_checks end

"""Parity check boolean matrix of a code (only the X entries in the tableau, i.e. the checks for Z errors).

Only CSS codes have this method.

See also: [`parity_checks`](@ref)"""
function parity_matrix_x(code::AbstractECC)
    throw(lazy"Codes of type $(typeof(code)) do not have separate X and Z parity checks, either because they are not a CSS code and thus inherently do not have separate checks, or because its separate checks are not yet implemented in this library.")
end

"""Parity check boolean matrix of a code (only the Z entries in the tableau, i.e. the checks for X errors).

Only CSS codes have this method.

See also: [`parity_checks`](@ref)"""
function parity_matrix_z(code::AbstractECC)
    throw(lazy"Codes of type $(typeof(code)) do not have separate X and Z parity checks, either because they are not a CSS code and thus inherently do not have separate checks, or because its separate checks are not yet implemented in this library.")
end

"""Check if the code is CSS.

Return `nothing` if unknown from the type.
"""
function iscss(::Type{T}) where T<:AbstractECC
    return false
end

function iscss(::Type{T}) where T <: AbstractCSSCode
    return true
end

function iscss(c::AbstractECC)
    return iscss(typeof(c))
end

"""The generator matrix of a code."""
function generator end

parity_checks(s::Stabilizer) = s
parity_checks(c::AbstractECC) = Stabilizer(parity_matrix(c))
Stabilizer(c::AbstractECC) = parity_checks(c)
MixedDestabilizer(c::AbstractECC; kwarg...) = MixedDestabilizer(Stabilizer(c); kwarg...)

nqubits(c::AbstractECC) = code_n(c::AbstractECC)

code_n(c::AbstractECC) = code_n(parity_checks(c))

code_n(s::Stabilizer) = nqubits(s)

code_s(s::Stabilizer) = length(s)
code_s(c::AbstractECC) = code_s(parity_checks(c))

"""
The number of logical qubits in a code.

Note that when redundant rows exist in the parity check matrix, the number of logical qubits `code_k(c)` will be greater than `code_n(c) - code_s(c)`, where the difference equals the redundancy.
"""
function code_k(s::Stabilizer)
    _, _, r = canonicalize!(Base.copy(s), ranks=true)
    return code_n(s) - r
end

code_k(c::AbstractECC) = code_k(parity_checks(c))

"""
$TYPEDEF

A Mixed Integer Programming (MIP) method for computing the code distance of CSS stabilizer codes
by finding the minimum-weight non-trivial logical [`PauliOperator`](@ref) (either `X`-type or `Z`-type).
Used with [`distance`](@ref) to select MIP as the method of finding the distance of a code.

!!! note
    - Requires a `JuMP`-compatible MIP solver (e.g., `HiGHS`, `SCIP`).
    - For some stabilizer CSS codes, the `X`-distance and `Z`-distance are equal.

$FIELDS
"""
@kwdef struct DistanceMIPAlgorithm <: AbstractDistanceAlg
    """index of the logical qubit to compute code distance for (nothing means compute for all logical qubits)"""
    logical_qubit::Union{Int, Nothing}=nothing
    """type of logical operator to consider (:X or :Z, defaults to :minXZ)."""
    logical_operator_type::Symbol=:minXZ
    """`JuMP`-compatible MIP solver (e.g., `HiGHS`, `SCIP`)"""
    solver::Module
    """when `true` (default=`false`), prints the MIP solver's solution summary"""
    opt_summary::Bool=false
    """time limit (in seconds) for the MIP solver's execution (default=60.0)"""
    time_limit::Float64=60.0

    function DistanceMIPAlgorithm(logical_qubit, logical_operator_type, solver, opt_summary, time_limit)
        logical_operator_type ∈ (:X, :Z, :minXZ) || throw(ArgumentError("`logical_operator_type` must be :X or :Z or :minXZ"))
        new(logical_qubit, logical_operator_type, solver, opt_summary, time_limit)
    end
end

"""Parity matrix of a code, given as a stabilizer tableau.""" # TODO this should not exist when the transition to QECCore is finished -- currently this is used only for "old" codes, still defined in QuantumClifford
function parity_matrix(c::AbstractECC)
    paritym = stab_to_gf2(parity_checks(c::AbstractECC))
    return paritym
end

"""Logical X operations of a code."""
function logx_ops(c)
    md = MixedDestabilizer(parity_checks(c))
    logicalxview(md)
end

"""Logical Z operations of a code."""
function logz_ops(c)
    md = MixedDestabilizer(parity_checks(c))
    logicalzview(md)
end

"""Error-to-logical-observable map (a.k.a. fault matrix) of a code.

For a code with n physical qubits and k logical qubits this function returns
a 2k × 2n binary matrix O such that
`O[i,j]` is true if the logical observable of index `i`
is flipped by the single physical qubit error of index `j`.
Indexing is such that:

- `O[1:k,:]` is the error-to-logical-X-observable map (logical X observable, i.e. triggered by logical Z errors)
- `O[k+1:2k,:]` is the error-to-logical-Z-observable map
- `O[:,1:n]` is the X-physical-error-to-logical-observable map
- `O[n+1:2n,:]` is the Z-physical-error-to-logical-observable map

E.g. for `k=1`, `n=10`, then
if `O[2,5]` is true, then the logical Z observable is flipped by a X₅ error;
and if `O[1,12]` is true, then the logical X observable is flipped by a Z₂ error.

Of note is that there is a lot of freedom in choosing the logical operations!
A logical operator multiplied by a stabilizer operator is still a logical operator.
Similarly there is a different fault matrix for each choice of logical operators.
But once the logical operators are picked, the fault matrix is fixed.

Below we show an example that uses the Shor code. While it is not the smallest code,
it is a convenient choice to showcase the importance of the fault matrix when dealing
with degenerate codes where a correction operation and an error do not need to be the same.

First, consider a single-qubit error, potential correction operations, and their effect on the Shor code:

```jldoctest faults_matrix
julia> using QuantumClifford.ECC: faults_matrix, Shor9

julia> state = MixedDestabilizer(Shor9())
𝒟ℯ𝓈𝓉𝒶𝒷━━━━━
+ Z________
+ ___Z_____
+ _X_______
+ __X______
+ ____X____
+ _____X___
+ ______X__
+ _______X_
𝒳ₗ━━━━━━━━━
+ ______XXX
𝒮𝓉𝒶𝒷━━━━━━━
+ XXX___XXX
+ ___XXXXXX
+ ZZ_______
+ Z_Z______
+ ___ZZ____
+ ___Z_Z___
+ ______Z_Z
+ _______ZZ
𝒵ₗ━━━━━━━━━
+ Z__Z____Z

julia> err_Z₁ = single_z(9,1) # the error we will simulate
+ Z________

julia> cor_Z₂ = single_z(9,2) # the correction operation we will perform
+ _Z_______

julia> err_Z₁ * state # observe that one of the syndrome bits is now flipped
𝒟ℯ𝓈𝓉𝒶𝒷━━━━━
+ Z________
+ ___Z_____
+ _X_______
+ __X______
+ ____X____
+ _____X___
+ ______X__
+ _______X_
𝒳ₗ━━━━━━━━━
+ ______XXX
𝒮𝓉𝒶𝒷━━━━━━━
- XXX___XXX
+ ___XXXXXX
+ ZZ_______
+ Z_Z______
+ ___ZZ____
+ ___Z_Z___
+ ______Z_Z
+ _______ZZ
𝒵ₗ━━━━━━━━━
+ Z__Z____Z

julia> cor_Z₂ * err_Z₁ * state # we are back to a good code state
𝒟ℯ𝓈𝓉𝒶𝒷━━━━━
+ Z________
+ ___Z_____
- _X_______
+ __X______
+ ____X____
+ _____X___
+ ______X__
+ _______X_
𝒳ₗ━━━━━━━━━
+ ______XXX
𝒮𝓉𝒶𝒷━━━━━━━
+ XXX___XXX
+ ___XXXXXX
+ ZZ_______
+ Z_Z______
+ ___ZZ____
+ ___Z_Z___
+ ______Z_Z
+ _______ZZ
𝒵ₗ━━━━━━━━━
+ Z__Z____Z

julia> bad_Z₆Z₉ = single_z(9,6) * single_z(9,9) # a different "correction" operation
+ _____Z__Z

julia> bad_Z₆Z₉ * err_Z₁ * state # the syndrome is trivial, but now we have a logical error
𝒟ℯ𝓈𝓉𝒶𝒷━━━━━
+ Z________
+ ___Z_____
+ _X_______
+ __X______
+ ____X____
- _____X___
+ ______X__
+ _______X_
𝒳ₗ━━━━━━━━━
- ______XXX
𝒮𝓉𝒶𝒷━━━━━━━
+ XXX___XXX
+ ___XXXXXX
+ ZZ_______
+ Z_Z______
+ ___ZZ____
+ ___Z_Z___
+ ______Z_Z
+ _______ZZ
𝒵ₗ━━━━━━━━━
+ Z__Z____Z
```

The success of `cor_Z₂` and the failure of `bad_Z₆Z₉` can be immediately seen through the fault matrix,
as the wrong "correction" does not result in the same logical flips ad the error:

```jldoctest faults_matrix
julia> O = faults_matrix(Shor9())
2×18 BitMatrix:
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  1  1  1
 1  0  0  1  0  0  0  0  1  0  0  0  0  0  0  0  0  0

julia> O * stab_to_gf2(err_Z₁)
2-element Vector{Int64}:
 0
 0

julia> O * stab_to_gf2(cor_Z₂)
2-element Vector{Int64}:
 0
 0

julia> O * stab_to_gf2(bad_Z₆Z₉)
2-element Vector{Int64}:
 1
 0
```

While its use in this situation is rather contrived, the fault matrix is incredibly useful
when running large scale simulations in which we want a separate fast error sampling process,
(e.g. with Pauli frames) and a syndrome decoding process, without coupling between them.
We just gather all our syndrome measurement **and logical observables** from the Pauli frame simulations,
and then use them with the fault matrix in the syndrome decoding simulation.
"""
function faults_matrix(c::Stabilizer)
    md = MixedDestabilizer(c)
    s, n = size(c)
    r = rank(md)
    k = n - r
    k == n-s || @warn "`faults_matrix` was called on an ECC that has redundant rows (is rank-deficient). `faults_matrix` corrected for that, however this is a frequent source of mistakes and inefficiencies. We advise you remove redundant rows from your ECC." maxlog=1
    O = falses(2k, 2n)
    logviews = [logicalxview(md); logicalzview(md)]
    errors = [one(Stabilizer,n; basis=:X);one(Stabilizer,n)]
    for i in 1:2k
        O[i, :] = comm(logviews[i]::PauliOperator, errors) # typeassert for JET
    end
    return O
end

function faults_matrix(c::AbstractECC)
    return faults_matrix(parity_checks(c))
end

"""
$TYPEDSIGNATURES

Check if the code is degenerate with respect to a given set of error or with respect to all
"up to d physical-qubit" errors (defaulting to d=1).

```jldoctest
julia> using QuantumClifford.ECC

julia> isdegenerate(Shor9(), [single_z(9,1), single_z(9,2)])
true

julia> isdegenerate(Shor9(), [single_z(9,1), single_x(9,1)])
false

julia> isdegenerate(Steane7(), 1)
false

julia> isdegenerate(Steane7(), 2)
true
```
"""
function isdegenerate end

isdegenerate(c::AbstractECC, args...) = isdegenerate(parity_checks(c), args...)
isdegenerate(c::AbstractStabilizer, args...) = isdegenerate(stabilizerview(c), args...)

function isdegenerate(H::Stabilizer, errors) # Described in https://quantumcomputing.stackexchange.com/questions/27279
    syndromes = map(e -> comm(H,e), errors) # TODO This can be optimized by having something that always returns bitvectors
    syndrome_set = Set(syndromes)
    return length(syndrome_set) != length(errors)
end

function isdegenerate(H::Stabilizer, d::Int=1)
    n = nqubits(H)
    errors = [begin p=zero(PauliOperator,n); for i in bits; p[i]=op; end; p end for bits in combinations(1:n, d) for op in ((true,false), (false,true))]
    return isdegenerate(H, errors)
end

include("circuits.jl")
include("decoder_pipeline.jl")

include("codes/util.jl")

include("codes/concat.jl")
include("codes/random_circuit.jl")
include("codes/classical/bch.jl")

# qLDPC
include("codes/classical/lifted.jl")
include("codes/qeccs_from_extensions.jl")

include("decoder_correction_gate.jl")
end #module

"""
$TYPEDSIGNATURES

Constructing two block group algebra codes by specifying the group presentation.

Two block group algebra codes are constructed by choosing a group (and specific generators),
then choosing two polynomials made out of these generators,
then piping these two polynomials as the elements of `1×1` matrices to the
lifted product code constructors.

The Hecke library, for which we already have an extension, provides for a fairly easy way
to construct such polynomials for many abelian and small groups.
See [`two_block_group_algebra_code`](@ref) for those capabilities.

However, more esoteric groups are usually specified by a group presentation `⟨S | R⟩`,
where `S` is a set of generators and `R` is the relations those generators obey.
To support arbitrary group presentations we use Oscar, which builds upon Hecke.
We use `Oscar.free_group` and `quo` in order to first prepare the free group generated by `S`,
and then the group obeying also the relations `R`, i.e. the `⟨S | R⟩` [presentation](https://en.wikipedia.org/wiki/Presentation_of_a_group).

After that point we proceed as usual, creating two polynomials of generators and piping them
to [`two_block_group_algebra_code`](@ref).

This particular function is nothing more than a simple wrapper that takes care of argument conversions.
Of note, the polynomials here are given as lists of monomials.

Of course, if you are comfortable with Oscar, you can use [`two_block_group_algebra_code`](@ref) directly.

See also: [`two_block_group_algebra_code`](@ref), [`twobga_from_direct_product`](@ref)

## Examples

The [[96, 12, 10]] 2BGA code from Table I in [lin2024quantum](@cite) has the group presentation
`⟨r, s | s⁶ = r⁸ = r⁻¹srs = 1⟩` (the group `C₂ × (C₃ ⋉ C₈)`).

```jldoctest finitegrp
julia> import Oscar: free_group, small_group_identification, describe, order

julia> import Hecke: gens, quo, group_algebra, GF, one

julia> using QuantumClifford, QuantumClifford.ECC

julia> F = free_group(["r", "s"]);

julia> r, s = gens(F); # generators

julia> G, = quo(F, [s^6, r^8, r^(-1) * s * r * s]);  # relations

julia> GA = group_algebra(GF(2), G);

julia> r, s = gens(G);

julia> a = [one(G), r, s^3 * r^2, s^2 * r^3];

julia> b = [one(G), r, s^4 * r^6, s^5 * r^3];

julia> c = twobga_from_fp_group(a, b, GA);

julia> order(G)
48

julia> code_n(c), code_k(c)
(96, 12)

julia> describe(G), small_group_identification(G)
("C2 x (C3 : C8)", (48, 9))
```

### Cyclic Groups

Cyclic groups with specific group presentations, given by `Cₘ = ⟨x, s | xᵐ = s² = xsx⁻¹s⁻¹ = 1⟩`,
where the order is `2m` as seen in Table II of [lin2024quantum](@cite).

The [[56, 28, 2]] abelian 2BGA code from Appendix C, Table II in [lin2024quantum](@cite) is constructed using
the group presentation `⟨x, s | xs = sx, xᵐ = s² = 1⟩` (the cyclic group `C₂₈ = C₁₄ × C₂`).

```jldoctest finitegrp
julia> m = 14;

julia> F = free_group(["x", "s"]);

julia> x, s = gens(F); # generators

julia> G, = quo(F, [x^m, s^2, x * s * x^-1 * s^-1]); # relations

julia> GA = group_algebra(GF(2), G);

julia> x, s = gens(G);

julia> a = [one(G), x^7];

julia> b = [one(G), x^7, s, x^8, s * x^7, x];

julia> c = twobga_from_fp_group(a, b, GA);

julia> order(G)
28

julia> code_n(c), code_k(c)
(56, 28)

julia> describe(G), small_group_identification(G)
("C14 x C2", (28, 4))
```

### Dihedral Groups

Dihedral (non-abelian) groups with group presentations given by `Dₘ = ⟨r, s | rᵐ = s² = (rs)² = 1⟩`,
where the order is `2m`.

The [[24, 8, 3]] 2BGA code from Appendix C, Table III in [lin2024quantum](@cite) is constructed
by specifying a group presentation below (giving the group `D₆ = C₆ ⋉ C₂`).


```jldoctest finitegrp
julia> m = 6;

julia> F = free_group(["r", "s"]);

julia> r, s = gens(F); # generators

julia> G, = quo(F, [r^m, s^2, (r*s)^2]); # relations

julia> GA = group_algebra(GF(2), G);

julia> r, s = gens(G);

julia> a = [one(G), r^4];

julia> b = [one(G), s*r^4, r^3, r^4, s*r^2, r];

julia> c = twobga_from_fp_group(a, b, GA);

julia> order(G)
12

julia> code_n(c), code_k(c)
(24, 8)

julia> describe(G), small_group_identification(G)
("D12", (12, 4))
```

!!! note
    Notice how in all of these construction we are specifying a group presentation.
    We are explicitly **not** picking a group by name and getting its "canonical" generators,
    as we do not a priori know whether Oscar would give us the generating set we need (generating sets are not unique).
"""
function twobga_from_fp_group(a_elts::VectorFPGroupElem, b_elts::VectorFPGroupElem, F2G::FqFieldFPGroupAlgebra)
    a = sum(F2G(x) for x in a_elts)
    b = sum(F2G(x) for x in b_elts)
    c = two_block_group_algebra_code(a,b)
    return c
end

"""
copies the memory content of the object to CPU

You can only use this function if CUDA.jl is imported

For more advanced users `to_cpu(data, element_type)` will reinterpret elements of data and converts them to `element_type`.
For example based on your CPU architecture, if working with matrices of UInt32 is faster than UInt64, you can use `to_cpu(data, UInt32)`




```julia-repl
julia> using QuantumClifford: to_cpu, to_gpu

julia> using CUDA # without this import, to_cpu, to_gpu are just function

julia> stab = S"- X_Z\\n+ _ZZ\\n+ __Z"
- X_Z
+ _ZZ
+ __Z

julia> stab_gpu = to_gpu(stab);

julia> apply!(stab_gpu, sHadamard(1));

julia> stab_result_cpu = to_cpu(stab_gpu)
- Z_Z
+ _ZZ
+ __Z
```

```julia-repl
julia> using QuantumClifford: to_cpu, to_gpu

julia> using CUDA # without this import, to_cpu, to_gpu are just function

julia> pf_gpu = to_gpu(PauliFrame(1000, 2, 2));
julia> circuit = [sMZ(1, 1), sHadamard(2), sMZ(2, 2)];
julia> pftrajectories(pf_gpu, circuit);
julia> measurements = to_cpu(pf_gpu.measurements);
```

See also: [`to_gpu`](@ref)
"""
function to_cpu end


"""
copies the memory content of the object to GPU

You can only use this function if CUDA.jl is imported

For more advanced users `to_gpu(data, element_type)` will reinterpret elements of data and converts them to `element_type`.
For example based on your GPU architecture, if working with matrices of UInt64 is faster than UInt32, you can use `to_gpu(data, UInt64)`




```julia-repl
julia> using QuantumClifford: to_cpu, to_gpu

julia> using CUDA # without this import, to_cpu, to_gpu are just function

julia> stab = S"- X_Z\\n+ _ZZ\\n+ __Z"
- X_Z
+ _ZZ
+ __Z

julia> stab_gpu = to_gpu(stab);

julia> apply!(stab_gpu, sHadamard(1));

julia> stab_result_cpu = to_cpu(stab_gpu)
- Z_Z
+ _ZZ
+ __Z
```

```julia-repl
julia> using QuantumClifford: to_cpu, to_gpu

julia> using CUDA # without this import, to_cpu, to_gpu are just function

julia> pf_gpu = to_gpu(PauliFrame(1000, 2, 2));
julia> circuit = [sMZ(1, 1), sHadamard(2), sMZ(2, 2)];
julia> pftrajectories(pf_gpu, circuit);
julia> measurements = to_cpu(pf_gpu.measurements);
```

See also: [`to_cpu`](@ref)
"""
function to_gpu end

module QuantumCliffordGPUExt

using CUDA
using QuantumClifford
import QuantumClifford: to_cpu, to_gpu, _apply!, apply!, pftrajectories, fastcolumn, fastrow, applynoise!, canonicalize!

include("utils.jl")
include("types.jl")
include("adapters.jl")
include("apply.jl")
include("pauli_frames.jl")
include("fastmemlayout.jl")
include("apply_noise.jl")
include("canonicalization.jl")
end

using LinearAlgebra: Adjoint


const PhaseInnerType = UInt8
const MeasurementInnerType = Bool

CUDAValue{T} = CuArray{T, 0, CUDA.Mem.DeviceBuffer} where {T}
CUDAVector{T} = CuArray{T, 1, CUDA.Mem.DeviceBuffer} where {T}
CUDAMatrix{T} = CuArray{T, 2, CUDA.Mem.DeviceBuffer} where {T}
CUDAParams = [CUDAValue, CUDAVector, CUDAMatrix]

AdjCUDAValue{T} = CuArray{T, 0, CUDA.Mem.DeviceBuffer} where {T} # do not adjoint value
AdjCUDAVector{T} = CuArray{T, 1, CUDA.Mem.DeviceBuffer} where {T} # do not adjoint vector
AdjCUDAMatrix{T} = Adjoint{T, CuArray{T, 2, CUDA.Mem.DeviceBuffer}} where {T}
AdjCUDAParams = [AdjCUDAValue, AdjCUDAVector, AdjCUDAMatrix]

DeviceValue{T} = Union{CuDeviceArray{T, 0, 1}, Adjoint{T, CuDeviceArray{T, 0, 1}}} where {T}
DeviceVector{T} = Union{CuDeviceArray{T, 1, 1}, Adjoint{T, CuDeviceArray{T, 1, 1}}} where {T}
DeviceMatrix{T} = Union{CuDeviceArray{T, 2, 1}, Adjoint{T, CuDeviceArray{T, 2, 1}}} where {T}


function getTableauGPU(GPUValue, GPUVector, GPUMatrix)
    TableauGPU{T} = QuantumClifford.Tableau{Tₚᵥ, Tₘ} where {T <: Unsigned, Tₚᵥ <: GPUVector{PhaseInnerType}, Tₘ <: GPUMatrix{T}}
end
function getStabilizerGPU(GPUValue, GPUVector, GPUMatrix, GPUTableau)
    StabilizerGPU{T} = QuantumClifford.Stabilizer{<:GPUTableau{T}} where {T <: Unsigned}
end
function getPauliOperatorGPU(GPUValue, GPUVector, GPUMatrix, GPUTableau)
    PauliOperatorGPU{T} = QuantumClifford.PauliOperator{Tₚ, Tᵥ} where {T <: Unsigned, Tₚ<:GPUValue{PhaseInnerType}, Tᵥ<:GPUVector{T}}
end

# todo. type definition here is stronger than the code in pauliframes.jl  this will cause serious problems
# especially because its not obvious whether TFrame is Tableau or Stabilizer in pauliframes.jl
# and we are assuming that TMeasurement is made of booleans
function getPauliFrameGPU(GPUValue, GPUVector, GPUMatrix, GPUTableau)
    StabilizerGPU{T} = getStabilizerGPU(GPUValue, GPUVector, GPUMatrix, GPUTableau){T} where {T <: Unsigned}
    PauliFrameGPU{T} = QuantumClifford.PauliFrame{TFrame, TMeasurement} where {T <: Unsigned, TFrame <: StabilizerGPU{T}, TMeasurement <: GPUMatrix{MeasurementInnerType}}
end

const TableauCUDA{T} = getTableauGPU(CUDAParams...){T} where {T <: Unsigned}
const StabilizerCUDA{T} = getStabilizerGPU(CUDAParams..., TableauCUDA){T} where {T <: Unsigned}
const PauliOperatorCUDA{T} = getPauliOperatorGPU(CUDAParams..., TableauCUDA){T} where {T <: Unsigned}
const PauliFrameCUDA{T} = getPauliFrameGPU(CUDAParams..., TableauCUDA){T} where {T <: Unsigned}

const TableauAdj{T} = getTableauGPU(AdjCUDAParams...){T} where {T <: Unsigned}
const StabilizerAdj{T} = getStabilizerGPU(CUDAParams..., TableauAdj){T} where {T <: Unsigned}
const PauliOperatorAdj{T} = getPauliOperatorGPU(CUDAParams..., TableauAdj){T} where {T <: Unsigned}
const PauliFrameAdj{T} = getPauliFrameGPU(CUDAParams..., TableauAdj){T} where {T <: Unsigned}

const TableauGPU{T} = Union{TableauCUDA{T}, TableauAdj{T}} where {T <: Unsigned}
const StabilizerGPU{T} = Union{StabilizerCUDA{T}, StabilizerAdj{T}} where {T <: Unsigned}
const PauliOperatorGPU{T} = Union{PauliOperatorCUDA{T}, PauliOperatorAdj{T}} where {T <: Unsigned}
const PauliFrameGPU{T} = Union{PauliFrameCUDA{T}, PauliFrameAdj{T}} where {T <: Unsigned}

"""Encoding physical qubits into a larger logical code.

The initial physical qubits to be encoded have to be at indices `n-k+1:n`.

!!! info "Encoding circuits are not fault-tolerant"
    Encoding circuits are not fault-tolerant, and thus should not be used in practice.
    Instead, you should measure the stabilizers of the code and the logical observables,
    thus projecting into the code space (which can be fault-tolerant).

The canonicalization operation performed on the code may permute the qubits (see [`canonicalize_gott!`](@ref)).
That permutation is corrected for with SWAP gates by default (controlled by the `undoperm` keyword argument).

Based on [cleve1997efficient](@cite) and [gottesman1997stabilizer](@cite),
however it seems the published algorithm has some errors.
Consult the erratum, as well as the more recent [grassl2002algorithmic](@cite) and [grassl2011variations](@cite),
and be aware that this implementation also uses H instead of Z gates.
"""
function naive_encoding_circuit(code; undoperm=true)
    n = code_n(code)
    k = code_k(code)
    md, r, permx, permz = MixedDestabilizer(code, undoperm=false, reportperm=true);
    circ = QuantumClifford.AbstractOperation[]
    X = logicalxview(md)
    Z = logicalzview(md)
    S = stabilizerview(md)
    for i in 1:k
        for t in 1:n-k
            if X[i,t][1] == true
                push!(circ, sCNOT(n-k+i, t))
            end
        end
    end
    for i in 1:r
        push!(circ, sHadamard(i))
        if S[i,i][2] == true
            push!(circ, sPhase(i))
        end
        for t in 1:n
            if i!=t
                xz = S[i,t]
                g = if xz == (true, true)  # Y
                    sZCY
                elseif xz == (true, false) # X
                    sZCX
                elseif xz == (false, true) && !(i<t<n-k+1) # Z
                    sZCZ
                end
                isnothing(g) || push!(circ, g(i,t))
            end
        end
    end
    for i in 1:n-k # Correct for negative phases in the tableau
        if phases(S)[i]!=0
            if i<=r
                push!(circ, sZ(i))
            else
                push!(circ, sX(i))
            end
        end
    end
    if undoperm
        perm = permx[permz]
        transpositions = perm_to_transpositions(perm)
        for (i,j) in transpositions
            push!(circ, sSWAP(i,j))
        end
    end
    circ
end

function perm_to_transpositions(perm)
    n = length(perm)
    transpositions = Tuple{Int, Int}[]
    for i in n:-1:1
        if perm[i]!=i
            j = findfirst(==(i), perm)
            @assert !isnothing(j)
            push!(transpositions, (i, j))
            perm[j] = perm[i]
        end
    end
    return transpositions
end

"""Generate the non-fault-tolerant stabilizer measurement cicuit for a given code instance or parity check tableau.

Use the `ancillary_index` and `bit_index` arguments to offset where the corresponding part the circuit starts.

Returns the circuit, the number of ancillary qubits that were added, and a list of bit indices that will store the measurement results.

See also: [`shor_syndrome_circuit`](@ref)
"""
function naive_syndrome_circuit end

function naive_syndrome_circuit(code_type::AbstractECC, ancillary_index=1, bit_index=1)
    naive_syndrome_circuit(parity_checks(code_type), ancillary_index, bit_index)
end

"""Naive Pauli measurement circuit using a single ancillary qubit.

Not a fault-tolerant circuit, but useful for testing purposes.

Measures the corresponding `PauliOperator` by using conditional gates into an ancillary
qubit at index `nqubits(p)+ancillary_index` and stores the measurement result
into classical bit `bit_index`.

See also: [`naive_syndrome_circuit`](@ref), [`shor_ancillary_paulimeasurement`](@ref)"""
function naive_ancillary_paulimeasurement(p::PauliOperator, ancillary_index=1, bit_index=1)
    circuit = AbstractOperation[]
    n = nqubits(p)
    for qubit in 1:n
        if p[qubit] == (1,0)
            push!(circuit, sXCX(qubit, n + ancillary_index))
        elseif p[qubit] == (0,1)
            push!(circuit, sCNOT(qubit, n + ancillary_index))
        elseif p[qubit] == (1,1)
            push!(circuit, sYCX(qubit, n + ancillary_index))
        end
    end
    p.phase[] == 0 || push!(circuit, sX(n + ancillary_index))
    mz = sMRZ(n + ancillary_index, bit_index)
    push!(circuit, mz)

    return circuit
end

function naive_syndrome_circuit(parity_check_tableau, ancillary_index=1, bit_index=1)
    naive_sc = AbstractOperation[]
    ancillaries = 0
    bits = 0
    for check in parity_check_tableau
        append!(naive_sc,naive_ancillary_paulimeasurement(check, ancillary_index+ancillaries, bit_index+bits))
        ancillaries +=1
        bits +=1
    end

    return naive_sc, ancillaries, bit_index:bit_index+bits-1
end

"""Generate the Shor fault-tolerant stabilizer measurement cicuit for a given code instance or parity check tableau.

Use the `ancillary_index` and `bit_index` arguments to offset where the corresponding part the circuit starts.
Ancillary qubits

Returns:
  - The ancillary cat state preparation circuit.
  - The Shor syndrome measurement circuit.
  - The number of ancillary qubits that were added.
  - The list of bit indices that store the final measurement results.

See also: [`naive_syndrome_circuit`](@ref)
"""
function shor_syndrome_circuit end

function shor_syndrome_circuit(code_type::AbstractECC, ancillary_index=1, bit_index=1)
    shor_syndrome_circuit(parity_checks(code_type), ancillary_index, bit_index)
end

"""Shor's Pauli measurement circuit using a multiple entangled ancillary qubits.

A fault-tolerant circuit.

Measures the corresponding PauliOperator by using conditional gates into multiple ancillary
entangled qubits starting at index `nqubits(p)+ancillary_index`
and stores the measurement result into classical bits starting at `bit_index`.
The final measurement result is the XOR of all the bits.

Returns:
  - The ancillary cat state preparation circuit.
  - The Shor syndrome measurement circuit.
  - One more than the index of the last added ancillary qubit.
  - One more than the index of the last added classical bit.

See also: [`naive_syndrome_circuit`](@ref), [`naive_ancillary_paulimeasurement`](@ref)"""
function shor_ancillary_paulimeasurement(p::PauliOperator, ancillary_index=1, bit_index=1)
    init_ancil_index = ancillary_index
    circuit = AbstractOperation[]
    measurements = AbstractOperation[]
    numQubits = nqubits(p)
    for qubit in 1:numQubits
        if p[qubit] == (1,0)
            push!(circuit, sXCZ(qubit, numQubits + ancillary_index))
        elseif p[qubit] == (0,1)
            push!(circuit, sZCZ(qubit, numQubits + ancillary_index))
        elseif p[qubit] == (1,1)
            push!(circuit, sYCZ(qubit, numQubits + ancillary_index))
        end
        if p[qubit] != (0,0)
            push!(measurements, sMRX(numQubits + ancillary_index, bit_index))
            ancillary_index +=1
            bit_index +=1
        end
    end
    circuit = vcat(circuit,measurements)

    cat_state_circuit = AbstractOperation[]
    push!(cat_state_circuit, sHadamard(numQubits + init_ancil_index))
    for i in (init_ancil_index+1):(ancillary_index -1)
        push!(cat_state_circuit, sCNOT(numQubits + (i - 1), numQubits + i))
    end

    return cat_state_circuit, circuit, ancillary_index, bit_index
end

function shor_syndrome_circuit(parity_check_tableau, ancillary_index=1, bit_index=1)
    shor_sc = AbstractOperation[]
    xor_indices = []
    cat_circuit = AbstractOperation[]
    initial_ancillary_index = ancillary_index

    for check in parity_check_tableau
        cat_circ, circ, new_ancillary_index, new_bit_index = shor_ancillary_paulimeasurement(check, ancillary_index, bit_index)
        push!(xor_indices, collect(bit_index:new_bit_index-1))

        append!(shor_sc, circ)
        append!(cat_circuit, cat_circ)

        ancillary_index = new_ancillary_index
        bit_index = new_bit_index
    end

    final_bits = 0
    for indices in xor_indices
        push!(shor_sc, QuantumClifford.ClassicalXOR(indices, bit_index+final_bits))
        final_bits += 1
    end

    return cat_circuit, shor_sc, ancillary_index-initial_ancillary_index, bit_index:bit_index+final_bits-1
end

@testitem "embed PauliOperator" begin
    @test embed(5,3,P"-Y") == P"-__Y__"
    @test embed(5,(3,5),P"-YZ") == P"-__Y_Z"
    @test embed(5,[3,5],P"-YZ") == P"-__Y_Z"
    @test_throws ArgumentError embed(5,[3,5],P"-YZX")
    @test_throws ArgumentError embed(5,3,P"-ZX")
end

using LinearAlgebra: Adjoint
using QuantumClifford: Tableau

"""
TableauCUDA is the type of Tableau with its data stored in CUDA arrays
TableauAdj is the type of Tableau with its data stored in an adjoint of a CUDA arrays

rest of the fastrow, fastcolumn functions are implemented in QuantumClifford.jl
"""

# todo when we use to_gpu, to_cpu the efffect of fastrow, fastcolumn disappears
fastrow(t::TableauCUDA) = t
fastrow(t::TableauAdj) = Tableau(t.phases, t.nqubits, CuArray(t.xzs))
fastcolumn(t::TableauCUDA) = Tableau(t.phases, t.nqubits, CuArray(t.xzs')')
fastcolumn(t::TableauAdj) = t

using Test
using QuantumClifford.ECC.QECCore
using QuantumClifford
using QuantumClifford.ECC
using QuantumClifford.ECC: BCH
using InteractiveUtils
using SparseArrays

import Nemo: GF, matrix, rank, finite_field, polynomial_ring
import Hecke: group_algebra, abelian_group, gens, representation_matrix
import LinearAlgebra

include("test_ecc_base.jl")

# generate instances of all implemented codes to make sure nothing skips being checked

# Goppa Codes
m₁ = 4
t₁ = 2
F, α = finite_field(2, m₁, :α)
R, x = polynomial_ring(F, :x)
g₁ = x^2 + x + α^3
L₁ = [α^i for i in 2:13]

m₂ = 6
F, α = finite_field(2, m₂, :α)
R, x = polynomial_ring(F, :x)
t₂ = 9
g₂ = x^t₂ + 1

m₃ = 3
F, α = finite_field(2, m₃, :α)
R, x = polynomial_ring(F, :x)
t₃ = 2
g₃ = x^t₃ + x + 1

m₄ = 4
t₄ = 2
F, α = finite_field(2, m₄, :α)
R, z = polynomial_ring(F, :z)
g₄ = z^2 + α^7*z + 1
L₄ = [α^i for i in 2:13]

# Lifted Codes
l₁ = 12; GA₁ = group_algebra(GF(2), abelian_group(l)); x = gens(GA)[]
B₁ = reshape([1 + x + x^3 + x^6], (1, 1))
c = LiftedCode(B, repr = representation_matrix)

base_matrix₂ = [0 0 0 0; 0 1 2 5; 0 6 3 1]; l₂ = 3;

const classical_code_instance_args = Dict(
    :RepCode => [3, 4, 5, 6, 7, 8, 9, 10],
    :BCH => [(3, 1), (3, 2), (4, 1), (4, 1), (5, 1), (5, 2), (6, 1), (6, 2)],
    :ReedMuller => [(1, 3), (1, 4), (2, 3), (1, 5), (2, 4), (2, 5), (3, 5)],
    :RecursiveReedMuller => [(1, 3), (1, 4), (2, 3), (1, 5), (2, 4), (2, 5), (3, 5)],
    :Golay => [(23), (24)],
    :Hamming => [2, 3, 4, 5, 6, 7, 8],
    :GallagerLDPC => [(3, 3, 4), (3, 4, 5), (4, 5, 7), (4, 6, 7)],
    :Goppa => [(m₁, t₁, g₁, L₁), (m₂, t₂, g₂), (m₃, t₃, g₃), (m₄, t₄, g₄, L₄)],
    :LiftedCode => [(B₁, repr = representation_matrix), (base_matrix₂, l₂), (base_matrix₂, 5), (base_matrix₂, 7)]
)

function all_testable_classical_code_instances(; maxn=nothing)
    codeinstances = []
    i = 1
    classical_code_args = copy(classical_code_instance_args)
    for t in concretesubtypes(AbstractCECC)
        for args in pop!(classical_code_args, nameof(t), [])
            codeinstance = t(args...)
            !isnothing(maxn) && code_n(codeinstance) > maxn && continue
            push!(codeinstances, codeinstance)
            #@show i, t, code_n(codeinstance), code_k(codeinstance), code_n(codeinstance)-code_k(codeinstance)
            i += 1
        end
    end
    @test isempty(classical_code_args) # if this fails, then some code instances were not tested
    return codeinstances
end

# Required for QuantumCliffordKAExt.
import Atomix, GPUArraysCore, KernelAbstractions

using BenchmarkTools: @belapsed
# Assists in reducing resource demands.
using GPUArrays: AllocCache, @cached, unsafe_free!
using Plots: plot, savefig
using QuantumClifford

@testitem "Graph state CPHASE simulation" begin
    using Random
    import QuantumClifford.GraphSim: GraphState, local_comp!

    test_sizes = [2,10,63,64,65,127,128,129]
    iteration = 250

    @testset "CPHASE correctness" begin
        for _ in 1:iteration
            for n in test_sizes
                s = random_stabilizer(n)
                g = GraphState(s)
                a, b = rand(1:n), rand(1:n)
                while b == a
                    b = rand(1:n)
                end
                gate = sCPHASE(a, b)
                @test canonicalize!(Stabilizer(apply!(g, gate))) == canonicalize!(apply!(s, gate))
            end
        end

        # test a special case where q1, q2 are disconnected and both VOPs not in Z_COMMUTATION_SUBGROUP
        s = S"ZXII XZII IIZX IIXZ"
        gs = GraphState(s)
        gate = sCPHASE(2,3)
        apply!(gs, gate)
        apply!(s, gate)
        @test canonicalize!(Stabilizer(gs)) == canonicalize!(s)

        # test when q1, q2 are disconnected but each connected to other nodes as well
        s = S"+ __XXXYZZ__
              + YY_ZZY_Z_X
              + XZZZY_YZZY
              - YYYY_ZZXXZ
              + XZYZXXZXXZ
              + ZZXYXYX_Y_
              + ___YXZYXY_
              + __ZXYZZXX_
              + Y_YY_____Z
              + ZZY__XXXYX"
        gs = GraphState(s)
        gate = sCPHASE(6,8)
        apply!(gs, gate)
        apply!(s, gate)
        @test canonicalize!(Stabilizer(gs)) == canonicalize!(s)
    end

    @testset "Local Complementation equivalence" begin
        for n in test_sizes
            s = random_stabilizer(n)
            g = GraphState(s)
            @test canonicalize!(Stabilizer(local_comp!(g, rand(1:n)))) == canonicalize!(s)
        end
    end
end

@testitem "ECC Trivariate Tricycle Code" tags=[:ecc, :ecc_bespoke_checks, :oscar_required] begin
    using Oscar
    using QECCore
    import HiGHS
    import JuMP
    using Nemo: matrix, GF
    using QuantumClifford: stab_looks_good, stab_to_gf2
    using QuantumClifford.ECC

    @testset "Trivariate Tricycle Codes" begin
        F2 = GF(2)
        R, (x, y, z) = polynomial_ring(F2, [:x, :y, :z])
        table_i = [
            # n   , k  ,  l, m, p, A                           , B                            ,   C
            (72   , 6  ,  4, 3, 2, 1 + y         + x*y^2       , 1 + y*z       + x^2*y^2      , 1 + x*y^2*z     + x^2*y      ),
            (180  , 12 ,  5, 4, 3, 1 + x^2*y^3*z + x^4*y       , 1 + x^3       + x^4*z^2      , 1 + x^3*y^3     + x^4*y*z^2  ),
            (432  , 12 ,  6, 6, 4, 1 + x*y*z^3   + x^3*y^4*z^2 , 1 + x^3*y*z^2 + x^3*y^2*z^3  , 1 + x^4*y^3*z^3 + x^5*z^2    ),
        ]

        table_iii = [
            # n , k , l, m, p, A         , B        ,   C
            (36 , 3 , 3, 2, 2, 1 + x*y*z , 1 + x^2*z, 1 + x^2*y    ),
            (48 , 3 , 4, 2, 2, 1 + x     , 1 + x*z  , 1 + x*y      ),
            (54 , 3 , 3, 3, 2, 1 + y*z   , 1 + x*z  , 1 + x*y*z    ),
            (60 , 3 , 5, 2, 2, 1 + x*z   , 1 + x*y  , 1 + x*y*z    ),
            (90 , 3 , 5, 3, 2, 1 + x     , 1 + x*y  , 1 + x^2*y^2*z),
        ]

        table_iv = [
            # n  , k  , l, m, p, A                             , B             , C
            (36  , 6  , 3, 2, 2, (1 +       z)*(1 + x        ) , 1 + x         , 1 + x*y*z       ),
            (48  , 6  , 4, 2, 2, (1 + x^2*y*z)*(1 + x*z      ) , 1 + x^3       , 1 + x^3*y*z     ),
            (54  , 9  , 3, 3, 2, (1 +       z)*(1 + y        ) , 1 + x*y*z     , 1 + x^2*y^2     ),
            (108 , 6  , 4, 3, 3, (1 + x^2    )*(1 + x*z      ) , 1 + x^2*y^2   , 1 + x^2*y^2*z^2 ),
            (108 , 18 , 4, 3, 3, (1 + x^2    )*(1 + x*y^2*z^2) , 1 + x^2*y^2*z , 1 + x^2*y^2*z   ),
        ]

        table_v = [
            # n  , k ,  l, m, p, A                          , B                          ,   C
            (36  , 6 ,  3, 2, 2, 1 + x         + x^2*z      , 1 + x*y       + x^2*y      , 1 + x*y*z       + x^2        ),
            (72  , 6 ,  4, 3, 2, 1 + y         + x*y^2      , 1 + y*z       + x^2*y^2    , 1 + x*y^2*z     + x^2*y      ),
            (81  , 6 ,  3, 3, 3, 1 + x         + x*y        , 1 + y         + y*z        , 1 + z           + z*x        ),
            (126 , 6 ,  7, 3, 2, 1 + y^2       + x^4*y      , 1 + x*y       + x^4*y^2*z  , 1 + x^2*y*z     + x^2*y^2    ),
            (135 , 12,  5, 3, 3, 1 + x         + x^3*y^2    , 1 + x*z^2     + x^2*y*z    , 1 + x*y^2*z     + x^2*y*z    ),
            (180 , 12,  5, 4, 3, 1 + x^2*y^3*z + x^4*y      , 1 + x^3       + x^4*z^2    , 1 + x^3*y^3     + x^4*y*z^2  ),
            (288 , 6 ,  8, 4, 3, 1 + y*z       + x^7*y*z^2  , 1 + x^2*y*z   + x^5*z^2    , 1 + x^2*y^3*z   + x^6*y^2*z^2),
            (432 , 12,  6, 6, 4, 1 + x*y*z^3   + x^3*y^4*z^2, 1 + x^3*y*z^2 + x^3*y^2*z^3, 1 + x^4*y^3*z^3 + x^5*z^2    ),
            (588 , 9 ,  7, 7, 4, 1 + y*z       + x^3*y^2*z  , 1 + x*y^4*z   + x^4*y^4*z^2, 1 + x^2*y^2*z   + x^2*y^4    ),
            (648 , 6 ,  6, 6, 6, 1 + x*z^4     + x^3*y*z^4  , 1 + x*y^4*z   + x^5*y*z^5  , 1 + x^2*y*z^2   + x^2*y^2*z^3),
            (648 , 12,  6, 6, 6, 1 + x         + x^4*z      , 1 + y         + x*y*z^4    , 1 + z           + x^3*y^2*z  ),
            (735 , 18,  7, 7, 5, 1 + y^2       + x^6*y^5    , 1 + x^2*y*z   + x^2*y^4*z^3, 1 + x^4*y^5*z^2 + x^5*y      ),
            (840 , 9 ,  8, 7, 5, 1 + y^3*z     + x*y*z^2    , 1 + y^5*z     + x^3*y^4*z  , 1 + x*y^3*z^4   + x^7*y*z    ),
            (1029, 18,  7, 7, 7, 1 + y^2*z^3   + x^5*y^5*z  , 1 + x^2*y^5*z + x^4*z^5    , 1 + x^4*y^6     + x^5*y^4*z^6),
        ]

            table_vi = [
            # n   , k  ,  l, m, p, A                       , B                         ,   C
            (108  , 18 ,  4, 3, 3, (1 + x^2)*(1 + x*y*z^2) , (1 + x^2)*(1 + x^3*y^2*z) ,  1  + x^2*y^2*z^2      ),
            (108  , 60 ,  4, 3, 3, (1 + x^2)*(1 +       z) , (1 + x^2)*(1 + x^2*y*z^2) , (1  + x^2)*(1 + z^2)   )
        ]

        for (n, k, l, m, p, A_poly, B_poly, C_poly) in vcat(table_i, table_iii, table_iv, table_v, table_vi)
            F2 = GF(2)
            R, (x, y, z) = polynomial_ring(F2, [:x, :y, :z])
            I = ideal(R, [x^l - 1, y^m - 1, z^p - 1])
            S, _ = quo(R, I)
            A = S(A_poly)
            B = S(B_poly)
            C = S(C_poly)
            c = TrivariateTricycle(l, m, p, A, B, C)
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            # A TT code is defined on n = 3*l*m*p data qubits.
            @test code_n(c) == n == code_n(stab) == 3*l*m*p
            @test code_k(c) == k == code_k(stab)
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
            @test iszero(mod.(metacheck_matrix_z(c)*parity_matrix_z(c), 2))
            Hz = parity_matrix_z(c)
            Mz = metacheck_matrix_z(c)
            @test Hz != Mz
            @test Hx != Mz
            @test Hx != Hz
            c = MultivariateMulticycle([l,m, p], [A, B, C])
            stab = parity_checks(c)
            mat = matrix(GF(2), stab_to_gf2(stab))
            computed_rank = rank(mat)
            @test computed_rank == code_n(c) - code_k(c)
            # A TT code is defined on n = 3*l*m*p data qubits.
            @test code_n(c) == n == code_n(stab) == 3*l*m*p
            @test code_k(c) == k == code_k(stab)
            @test stab_looks_good(stab, remove_redundant_rows=true) == true
            @test iszero(mod.(metacheck_matrix_z(c)*parity_matrix_z(c), 2))
            Hz = parity_matrix_z(c)
            Mz = metacheck_matrix_z(c)
            @test Hz != Mz
            @test Hx != Mz
            @test Hx != Hz
        end
    end

    @testset "Test novel MM code" begin
        l, m, p, r = 4, 3, 3, 3
        R, (w, x, y, z) = polynomial_ring(GF(2), [:w, :x, :y, :z])
        I = ideal(R, [w^l - 1, x^m - 1, y^p - 1, z^r - 1])
        S, _ = quo(R, I)
        A = S((1 + x^2 )*(1 + w*x*y*z^2))
        B = S((1 + x^2)*(1 + w*x^3*y^2*z))
        C = S(1 + w^2*x^2*y^2*z^2)
        D = S(1 + w^3*x^3*y^3*z^3)
        c = MultivariateMulticycle([l, m, p, r], [A, B, C, D])
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        # A MM code is defined on n = 6*l*m*p*r data qubits.
        @test code_n(c) == code_n(stab) == 6*l*m*p*r
        @test code_k(c) == code_k(stab)
        @test stab_looks_good(stab, remove_redundant_rows=true) == true
        Hx = parity_matrix_x(c)
        Hz = parity_matrix_z(c)
        Mx = metacheck_matrix_x(c)
        Mz = metacheck_matrix_z(c)
        @test iszero(mod.(Mz*Hz, 2))
        @test iszero(mod.(Mx*Hx, 2))
        @test Mz != Mx
        @test Hz != Mz
        @test Hx != Mz
        @test Hx != Mx
        @test Hz != Mx
        @test Hx != Hz

        # Haah's cubic code from Appendix B code D of https://arxiv.org/pdf/1904.02703
        # [[1024, 30, 13 ≤ d ≤ 32]]
        L = 8
        R, (x,y,z) = polynomial_ring(GF(2), [:x,:y,:z])
        I = ideal(R, [x^L-1, y^L-1, z^L-1])
        S, _ = quo(R, I)
        A = S(1 + x + y + z)
        B = S(1 + x*y + x*z + y*z)
        c = MultivariateMulticycle([L,L,L], [A,B])
        stab = parity_checks(c)
        mat = matrix(GF(2), stab_to_gf2(stab))
        computed_rank = rank(mat)
        @test computed_rank == code_n(c) - code_k(c)
        @test code_n(c) == code_n(stab) == 1024
        @test code_k(c) == code_k(stab) == 30
        @test stab_looks_good(stab, remove_redundant_rows=true) == true
        # This code is weight-8 limited.
        @test all(sum(parity_matrix_z(c), dims=2) .== 8)
        @test all(sum(parity_matrix_x(c), dims=2) .== 8)
    end
end

@testitem "Controlled" begin
    using QuantumOpticsBase

    function transform_Zbasis(qubit)
        transformations = Dict(:X => [sHadamard(qubit),], :Y => [sInvPhase(qubit),sHadamard(qubit)], :Z => [sHadamard(qubit), sHadamard(qubit)])
        inverse_transformations = Dict(:X => [sHadamard(qubit),], :Y => [sHadamard(qubit), sPhase(qubit)], :Z => [sHadamard(qubit), sHadamard(qubit)])
        return transformations, inverse_transformations
    end

    function transform_Xbasis(qubit)
        transformations = Dict(:Z => [sHadamard(qubit),], :Y => [sInvPhase(qubit),], :X => [sHadamard(qubit), sHadamard(qubit)])
        inverse_transformations = Dict(:Z => [sHadamard(qubit)], :Y => [sPhase(qubit),], :X => [sHadamard(qubit), sHadamard(qubit)])
        return transformations, inverse_transformations
    end

    function get_gates(control, target)
        transform1, inverse1 = transform_Zbasis(1)
        transform2, inverse2 = transform_Xbasis(2)
        return [transform1[control]..., transform2[target]...], [inverse2[target]..., inverse1[control]...]
    end

    @testset "Controlled gates" begin
        for i in 1:10
            for control in (:X, :Y, :Z)
                for target in (:X, :Y, :Z)
                    random_state = random_destabilizer(2)
                    implemented_gate = eval(Symbol(:s,control,:C,target))(1,2)

                    tr, inv = get_gates(control, target)
                    test_gates = [tr..., sCNOT(1,2), inv...]
                    @test apply!(copy(random_state), implemented_gate) == mctrajectory!(copy(random_state), test_gates)[1]
                end
            end
        end
    end

    transforms = Dict(:X => transform_Xbasis(1), :Z => transform_Zbasis(1))

    @testset "Change of basis" begin
        for to_basis in (:X, :Y, :Z)
            for from_basis in (:X, :Z)
                start_state = Stabilizer(QuantumClifford._T_str(string(from_basis)))
                forward, backward = transforms[from_basis][1][to_basis], transforms[from_basis][2][to_basis]
                mid_state = mctrajectory!(copy(start_state), backward)[1]
                end_state = mctrajectory!(copy(mid_state), forward)[1]
                @test start_state == end_state
                @test mid_state == Stabilizer(QuantumClifford._T_str(string(to_basis)))
            end
        end
    end

    @testset "Explicit control" begin
        for control in (:X, :Z, :Y)
            for target in (:X, :Z, :Y)
                for targetstate in ("X","Y","Z")
                    twoqgate = eval(Symbol(:s,control,:C,target))(1,2)
                    oneqgate = eval(Symbol(:s,target))(2)
                    state0str = string(control)*"I I"*targetstate
                    state1str = "-"*string(control)*"I I"*targetstate
                    state0 = Stabilizer(QuantumClifford._T_str(string(state0str)))
                    state1 = Stabilizer(QuantumClifford._T_str(string(state1str)))
                    @test canonicalize!(twoqgate*state0) == canonicalize!(state0)
                    @test canonicalize!(twoqgate*state1) == canonicalize!(oneqgate*state1)
                end
            end
        end
    end

    @testset "Control-Target swap" begin
        for control in (:X, :Z, :Y)
            for target in (:X, :Z, :Y)
                forwgate = eval(Symbol(:s,control,:C,target))(1,2)
                backgate = eval(Symbol(:s,target,:C,control))(1,2)
                forwgatedense = CliffordOperator(forwgate, 2)
                backgatedense = CliffordOperator(backgate, 2)
                @test forwgatedense == tSWAP*backgatedense*tSWAP
            end
        end

        for control in (:X, :Z, :Y)
            for target in (:X, :Z, :Y)
                forwgate = eval(Symbol(:s,control,:C,target))(1,2)
                backgate = eval(Symbol(:s,target,:C,control))(2,1)
                forwgatedense = CliffordOperator(forwgate, 2)
                backgatedense = CliffordOperator(backgate, 2)
                @test forwgatedense == backgatedense
            end
        end

        for (gate1,gate2) in (
                              (sCNOT(1,2), sZCX(1,2)),
                              (sCPHASE(1,2), sZCZ(1,2)),
                             )
            gate1dense = CliffordOperator(gate1, 2)
            gate2dense = CliffordOperator(gate2, 2)
            @test gate1dense == gate2dense
        end
    end

    @testset "Ket-based definition" begin
        for control in (:X, :Y, :Z)
            for target in (:X, :Y, :Z)
                s = Stabilizer(QuantumClifford._T_str(string(control)))
                k1 = Ket(s)
                s.tab.phases[1] = 0x2
                k2 = Ket(s)
                i = Operator(tId1)
                o = Operator(CliffordOperator(eval(Symbol(:s,target,))(1),1))
                gate = projector(k1)⊗i + (target==:Y ? -im : 1) * projector(k2)⊗o
                implemented_gate = Operator(CliffordOperator(eval(Symbol(:s,control,:C,target))(1,2),2))
                @test gate≈implemented_gate

                target, control = control, target
                s = Stabilizer(QuantumClifford._T_str(string(control)))
                k1 = Ket(s)
                s.tab.phases[1] = 0x2
                k2 = Ket(s)
                i = Operator(tId1)
                o = Operator(CliffordOperator(eval(Symbol(:s,target,))(1),1))
                gate_perm = projector(k1)⊗i + (target==:Y ? -im : 1) * projector(k2)⊗o
                implemented_gate_perm = Operator(CliffordOperator(eval(Symbol(:s,control,:C,target))(1,2),2))
                @test gate_perm≈implemented_gate_perm

                @test permutesystems(gate_perm,[2,1])≈gate
            end
        end
    end

    @testset "Ket-based definition for Y and rY" begin
        for control in (:Z,)
            target = :Y
            for r in (true, false)
                s = Stabilizer(QuantumClifford._T_str(string(control)))
                k1 = Ket(s)
                s.tab.phases[1] = 0x2
                k2 = Ket(s)
                i = Operator(tId1)
                o = Operator(CliffordOperator(eval(Symbol(:s,target,))(1),1))
                gate = projector(k1)⊗i + (r ? -1 : -im) * projector(k2)⊗o # XXX there is a -1 here because global phase is arbitrary and thus our Operator(tY) is NOT im*Operator(X)*Operator(Z)
                implemented_gate = Operator(CliffordOperator(eval(Symbol(:s,control,:C,(r ? :rY : :Y)))(1,2),2))
                @test gate≈implemented_gate
            end
        end
    end
end

@testitem "ECC LPCode representations of commutative algebras" tags=[:ecc, :ecc_bespoke_checks] begin
    using Test
    using QuantumClifford
    using QuantumClifford.ECC
    using QECCore

    import Hecke
    const QuantumCliffordHeckeExt = Base.get_extension(QuantumClifford, :QuantumCliffordHeckeExt)

    codes = vcat(LP04, LP118, test_gb_codes, test_bb_codes, test_mbb_codes, test_coprimeBB_codes, test_hcubic_codes, test_honeycomb_color_codes);

    for c in codes
        @test QECCore.parity_matrix_xz(c) == QuantumCliffordHeckeExt._parity_matrix_xz_if_comm_algebra(c)
    end

end

@testitem "Doctests" tags=[:doctests] begin
    using Documenter
    using QuantumClifford
    using QuantumClifford.Experimental.NoisyCircuits
    using QuantumInterface

    extensions = []

    ENV["HECKE_PRINT_BANNER"] = "false"
    import Hecke
    const QuantumCliffordHeckeExt = Base.get_extension(QuantumClifford, :QuantumCliffordHeckeExt)
    push!(extensions, QuantumCliffordHeckeExt)

    @static if !Sys.iswindows() && Sys.ARCH == :x86_64 && VERSION >= v"1.11"
        ENV["OSCAR_PRINT_BANNER"] = "false"
        import Oscar
        const QuantumCliffordOscarExt = Base.get_extension(QuantumClifford, :QuantumCliffordOscarExt)
        push!(extensions, QuantumCliffordOscarExt)
    end

    import JuMP
    const QuantumCliffordJuMPExt = Base.get_extension(QuantumClifford, :QuantumCliffordJuMPExt)
    push!(extensions, QuantumCliffordJuMPExt)

    ENV["LINES"] = 80    # for forcing `displaysize(io)` to be big enough
    ENV["COLUMNS"] = 80
    DocMeta.setdocmeta!(QuantumClifford, :DocTestSetup, :(using QuantumClifford; using QuantumClifford.ECC); recursive=true)
    modules = [QuantumClifford, QuantumClifford.Experimental.NoisyCircuits, QuantumClifford.ECC, QuantumInterface, extensions...]
    doctestfilters = [r"(QuantumClifford\.|)"]
    doctest(nothing, modules;
            doctestfilters
            #fix=true
           )
    # TODO failures in VSCode related to https://github.com/julia-vscode/TestItemRunner.jl/issues/49
end

"""
$(SIGNATURES)

Trait function to determine if an operation is a Clifford gate.
Users can extend this for custom gate types by defining new methods.

# Examples
```jldoctest
julia> isclifford(sHadamard(1))
true

julia> isclifford(sPhase(1))
true

julia> isclifford(sCNOT(1,2))
true
```
"""
function isclifford end

isclifford(::AbstractCliffordOperator) = true
isclifford(::AbstractSingleQubitOperator) = true
isclifford(::AbstractTwoQubitOperator) = true
isclifford(::AbstractSymbolicOperator) = true

isclifford(::sMX) = true
isclifford(::sMY) = true
isclifford(::sMZ) = true
isclifford(::sMRX) = true
isclifford(::sMRY) = true
isclifford(::sMRZ) = true
isclifford(::PauliMeasurement) = true

isclifford(op::SparseGate) = isclifford(op.cliff)

isclifford(::AbstractOperation) = false

# This must be done explicitly as they are not exported.
using QuantumClifford: mul_left!, mul_right!, Tableau

@inline host_f(x, y; phases::Val{phase_B} = Val(true)) where {phase_B} =
    mul_left!(x, y; phases = phases)

@inline function device_f(
    x, y, synchronize;
    phases::Val{phase_B} = Val(true),
    block_size::Val{block_SZ} = Val(default_block_size),
    batch_size::Val{batch_SZ} = Val(default_batch_size)
    ) where {phase_B, block_SZ, batch_SZ}

    mul_left!(
        x, y;
        phases = phases, block_size = block_size, batch_size = batch_size
        )
    synchronize()

end

@inline function benchmark_KA_mul_pauli_pauli(
    AT, synchronize, path;
    phases::Val{phase_B} = Val(true)
    ) where {phase_B}

    host_time = zeros(Float64, length(n_MiB))
    device_time = zeros(Float64, length(batch_sizes), length(n_MiB))

    # Keep the memory usage sane.
    cache = AllocCache()
    for (i, n) in enumerate(n_MiB)
        @cached cache begin
            # Each qubit requires 2 bits.
            h_p1 = PauliOperator(
                zeros(Cuchar),
                n * MiB >> 1,
                zeros(UInt, cld(n * MiB >> 1, bit_count(UInt)) << 1)
                )
            h_p2 = copy(h_p1)
            d_p1 = PauliOperator(
                AT(u32(h_p1.phase)),
                h_p1.nqubits,
                AT(reinterpret(UInt32, h_p1.xz))
                )
            d_p2 = copy(d_p1)
            synchronize()
            # Trigger compilation before benchmarking.
            host_f(h_p1, h_p2; phases = phases)
            host_time[i] = @belapsed host_f(
                $h_p1, $h_p2; phases = $phases
                ) evals = evals samples = samples seconds = seconds
            for (j, size) in enumerate(batch_sizes)
                device_f(
                    d_p1, d_p2, synchronize;
                    phases = phases, batch_size = Val(size)
                    )
                device_time[j, i] =
                    @belapsed device_f(
                        $d_p1, $d_p2, $synchronize;
                        phases = $phases, batch_size = Val($size)
                        ) evals = evals samples = samples seconds = seconds
            end
        end
    end
    unsafe_free!(cache)

    device_cat = [device_time[i, :] for i = 1 : length(batch_sizes)]
    title =
    "Performance uplift - multiplication (phases = $phase_B)\n\
    Host threads = " * string(Threads.nthreads()) * " / " *
    string(Sys.CPU_THREADS) * ", Device block size = $default_block_size"
    xlabel = "Pauli operator size (MiB)"
    label = hcat(("Device - batch size = " .* string.(batch_sizes))..., "Host")

    plot(
        n_MiB, 10^3 .* hcat(device_cat..., host_time);
        shape = :circle, xticks = n_MiB, xscale = :log2, yscale = :log10,
        title = title, label = label, xlabel = xlabel, ylabel = "Runtime (ms)",
        background_color = :transparent
        )
    savefig("$path/runtime_pauli_pauli_phase_$phase_B.$format")

    plot(
        n_MiB, map(x -> host_time ./ x, device_cat);
        shape = :circle, xticks = n_MiB, xscale = :log2, title = title,
        label = hcat(label[1 : end - 1]...), xlabel = xlabel,
        ylabel = "Ratio (host/device)", background_color = :transparent
        )
    savefig("$path/ratio_pauli_pauli_phase_$phase_B.$format")

end

@inline function benchmark_KA_mul_tableau_pauli(
    AT, synchronize, path;
    phases::Val{phase_B} = Val(true)
    ) where {phase_B}

    host_time = zeros(Float64, length(n_MiB))
    device_time = zeros(Float64, length(batch_sizes), length(n_MiB))
    # Keep the memory usage sane.
    cache = AllocCache()
    for (i, n) in enumerate(n_MiB)
        # Each qubit requires 2 bits.
        nqubits = round(Int, sqrt(n * MiB / 2), RoundUp)
        @cached cache begin
            h_p = PauliOperator(
                zeros(Cuchar),
                nqubits,
                zeros(UInt, cld(nqubits, bit_count(UInt)) << 1)
                )
            h_t = Tableau(
                zeros(Cuchar, nqubits),
                nqubits,
                zeros(UInt, cld(nqubits, bit_count(UInt)) << 1, nqubits)
                )
            d_p = PauliOperator(
                AT(u32(h_p.phase)),
                h_p.nqubits,
                AT(reinterpret(UInt32, h_p.xz))
                )
            d_t = Tableau(
                AT(u32(h_t.phases)),
                h_t.nqubits,
                AT(reinterpret(UInt32, h_t.xzs))
                )
            synchronize()
            # Trigger compilation before benchmarking.
            host_f(h_t, h_p; phases = phases)
            host_time[i] = @belapsed host_f(
                $h_t, $h_p; phases = $phases
                ) evals = evals samples = samples seconds = seconds
            for (j, size) in enumerate(batch_sizes)
                device_f(
                    d_t, d_p, synchronize;
                    phases = phases, batch_size = Val(size)
                    )
                device_time[j, i] =
                    @belapsed device_f(
                        $d_t, $d_p, $synchronize;
                        phases = $phases, batch_size = Val($size)
                        ) evals = evals samples = samples seconds = seconds
            end
        end
    end
    unsafe_free!(cache)

    device_cat = [device_time[i, :] for i = 1 : length(batch_sizes)]
    title =
    "Performance uplift - multiplication (phases = $phase_B)\n\
    Host threads = " * string(Threads.nthreads()) * " / " *
    string(Sys.CPU_THREADS) * ", Device block size = $default_block_size"
    xlabel = "Tableau size (MiB)"
    label = hcat(("Device - batch size = " .* string.(batch_sizes))..., "Host")

    plot(
        n_MiB, 10^3 .* hcat(device_cat..., host_time);
        shape = :circle, xticks = n_MiB, xscale = :log2, yscale = :log10,
        title = title, label = label, xlabel = xlabel, ylabel = "Runtime (ms)",
        background_color = :transparent
        )
    savefig("$path/runtime_tableau_pauli_phase_$phase_B.$format")

    plot(
        n_MiB, map(x -> host_time ./ x, device_cat);
        shape = :circle, xticks = n_MiB, xscale = :log2, title = title,
        label = hcat(label[1 : end - 1]...), xlabel = xlabel,
        ylabel = "Ratio (host/device)", background_color = :transparent
        )
    savefig("$path/ratio_tableau_pauli_phase_$phase_B.$format")

end

@inline function benchmark_KA_mul_leftright(
    AT, synchronize, path;
    phases::Val{phase_B} = Val(true)
    ) where {phase_B}

    path = "$path/mul_leftright"
    mkpath(path)
    benchmark_KA_mul_pauli_pauli(AT, synchronize, path; phases = phases)
    benchmark_KA_mul_tableau_pauli(AT, synchronize, path; phases = phases)

end

@testitem "ECC" tags=[:ecc, :ecc_base] begin
    using Nemo
    using Hecke
    using QuantumClifford.ECC
    using QuantumClifford.ECC: AbstractCECC, QECCore

    include("test_cecc_base.jl")

    codes = all_testable_classical_code_instances()

    @testset "correctness checks for classical ECCs" begin
        for code in codes
            H = parity_matrix(code)
            n, k, s  = code_n(code), code_k(code), size(H, 1)
            @test all(col -> any(H[:, col] .!= 0), 1:n)
            @test size(H, 2) == n
            @test size(H, 1) <= size(H, 2)
            H = matrix(GF(2), H)
            computed_rank = rank(H)
            @test n - k == computed_rank
            @test computed_rank <= s && computed_rank <= n
            @test n > 0 && k > 0
            @test k <= n
            rate = k/n
            @test 0 < rate <= 1.0
        end
    end
end

@testitem "Entanglement" begin
    using Graphs

    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    using QuantumClifford: stab_looks_good, destab_looks_good, mixed_stab_looks_good, mixed_destab_looks_good

    @testset "Clipped gauge of stabilizer states" begin
        for n in test_sizes
            s = random_stabilizer(n)
            s_clipped = copy(s)
            canonicalize_clip!(s_clipped)
            @test logdot(s, s_clipped)==0
            @test stab_looks_good(s_clipped)
            @test canonicalize!(copy(s_clipped))==canonicalize!(copy(s))
            bg = bigram(s_clipped; clip=false)
            rows, columns = size(stabilizerview(s_clipped))
            @test all(count(==(j), bg)==2 for j in 1:columns)
        end
    end

    @testset "Entanglement calculated from clipped/rref for mixed states" begin
        for n in test_sizes
            s = random_destabilizer(rand(1:n), n)
            endpoints = rand(1:n, 2)
            subsystem_range = min(endpoints...):max(endpoints...)
            @test entanglement_entropy(copy(s), subsystem_range, Val(:clip)) == entanglement_entropy(copy(s), subsystem_range, Val(:rref))
        end
    end

    @testset "Entanglement calculated from clipped/graph/rref for pure states" begin
        for n in test_sizes
            s = random_stabilizer(n)
            endpoints = rand(1:n, 2)
            subsystem_range = min(endpoints...):max(endpoints...)
            @test entanglement_entropy(copy(s), subsystem_range, Val(:clip)) == entanglement_entropy(copy(s), subsystem_range, Val(:graph)) == entanglement_entropy(copy(s), subsystem_range, Val(:rref))
        end
    end

    @testset "Entanglement of special cases" begin
        s = S"
        + XZZ_ZZ
        + ZX_ZZ_
        + Z_XZ_Z
        + _ZZXZZ
        + ZZ_ZXZ
        + Z_ZZZX"
        subsystem = 1:3
        @test entanglement_entropy(copy(s), subsystem, Val(:clip))==2
        @test entanglement_entropy(copy(s), subsystem, Val(:graph))==2
        @test entanglement_entropy(copy(s), subsystem, Val(:rref))==2
    end
end

module PauliChannelNonClifford
using LinearAlgebra
using DataStructures: DefaultDict
using DocStringExtensions
import ..QuantumClifford
import ..QuantumClifford:
    AbstractQCState, AbstractOperation, AbstractCliffordOperator, AbstractStabilizer,
    PauliOperator, Stabilizer, MixedDestabilizer, Destabilizer,
    apply!, nqubits, stabilizerview, destabilizerview, rank,
    zero, comm, mul_right!, embed, tensor, ⊗, project!, ghz,
    I, X, Z, expect

export
    GeneralizedStabilizer,
    PauliChannel,
    UnitaryPauliChannel,
    AbstractPauliChannel,
    pcT,
    pcPhase,
    pcRx,
    invsparsity,
    rowdecompose

"""
$(TYPEDEF)

Represents mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is a pure stabilizer state.

```jldoctest
julia> GeneralizedStabilizer(S"-X")
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 1.0+0.0im | + _ | + _

julia> pcT
A unitary Pauli channel P = ∑ ϕᵢ Pᵢ with the following branches:
with ϕᵢ | Pᵢ
 0.853553+0.353553im | + _
 0.146447-0.353553im | + Z

julia> apply!(GeneralizedStabilizer(S"-X"), pcT)
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.146447+0.0im | + Z | + Z
 0.0-0.353553im | + Z | + _
 0.0+0.353553im | + _ | + Z
 0.853553+0.0im | + _ | + _
```

See also: [`PauliChannel`](@ref)
"""
mutable struct GeneralizedStabilizer{T,F} <: AbstractQCState
    stab::T
    destabweights::DefaultDict{Tuple{BitVector, BitVector}, F, F}
end

function GeneralizedStabilizer(state)
    n = nqubits(state)
    md = MixedDestabilizer(state)
    rank(md)==n || throw(ArgumentError(lazy"""Attempting to convert a `Stabilizer`-like object to `GeneralizedStabilizer` object failed, because the initial state does not represent a pure state. Currently only pure states can be used to initialize a `GeneralizedStabilizer` mixture of stabilizer states."""))
    GeneralizedStabilizer(md, DefaultDict(0.0im, (falses(n),falses(n))=>1.0+0.0im)) # TODO maybe it should default to Destabilizer, not MixedDestabilizer
end

GeneralizedStabilizer(s::GeneralizedStabilizer) = s
Base.copy(sm::GeneralizedStabilizer) = GeneralizedStabilizer(copy(sm.stab),copy(sm.destabweights))
Base.:(==)(sm₁::GeneralizedStabilizer, sm₂::GeneralizedStabilizer) = sm₁.stab==sm₂.stab && sm₁.destabweights==sm₂.destabweights

function _sorted_show_entries(s::GeneralizedStabilizer)
    entries = [begin
        left = string(_stabmixdestab(s.stab, di))
        right = string(_stabmixdestab(s.stab, dj))
        (χ, left, right)
    end for ((di,dj), χ) in s.destabweights]
    sort!(entries; by=entry->(entry[2], entry[3]))
    return entries
end

function Base.show(io::IO, s::GeneralizedStabilizer)
    println(io, "A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is")
    show(io,s.stab)
    println(io)
    print(io, "with ϕᵢⱼ | Pᵢ | Pⱼ:")
    for (χ, left, right) in _sorted_show_entries(s)
        println(io)
        print(io, " ")
        print(IOContext(io, :compact => true), χ)
        print(io, " | ", left, " | ", right)
    end
end

function _stabmixdestab(mixeddestab, d)
    destab = destabilizerview(mixeddestab)
    p = zero(PauliOperator, nqubits(mixeddestab))
    for i in eachindex(d)
        if d[i]
            mul_right!(p, destab, i) # TODO check whether you are screwing up the ordering
        end
    end
    p
end

"""
Apply a Clifford gate to a generalized stabilizer state, i.e. a weighted sum of stabilizer states.

```jldoctest
julia> sm = GeneralizedStabilizer(S"-X")
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 1.0+0.0im | + _ | + _

julia> apply!(sm, CliffordOperator(tHadamard))
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ X
𝒮𝓉𝒶𝒷
- Z
with ϕᵢⱼ | Pᵢ | Pⱼ:
 1.0+0.0im | + _ | + _
```

See also: [`GeneralizedStabilizer`](@ref)
"""
function apply!(state::GeneralizedStabilizer, gate::AbstractCliffordOperator)
    apply!(state.stab, gate)
    state
end

"""$(TYPEDSIGNATURES)

Expectation value for the [PauliOperator](@ref) observable given the [`GeneralizedStabilizer`](@ref) state `s`.

```jldoctest genstab
julia> sm = GeneralizedStabilizer(S"-X")
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 1.0+0.0im | + _ | + _

julia> apply!(sm, pcT)
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.146447+0.0im | + Z | + Z
 0.0-0.353553im | + Z | + _
 0.0+0.353553im | + _ | + Z
 0.853553+0.0im | + _ | + _

julia> χ′ = expect(P"-X", sm)
0.7071067811865475 + 0.0im

julia> prob = (real(χ′)+1)/2
0.8535533905932737
```

"""
function QuantumClifford.expect(p::PauliOperator, s::GeneralizedStabilizer) # TODO optimize
    χ′ = zero(valtype(s.destabweights))
    phase, b, c = rowdecompose(p, s.stab)
    for ((dᵢ,dⱼ), χ) in s.destabweights
        _allthreesumtozero(dᵢ,dⱼ,b) || continue
        χ′ += χ * (-1)^(dᵢ'*c)
    end
    return (im)^(phase) * χ′
end

"""Same as `all(==(0), (a.+b.+c) .% 2)`"""
function _allthreesumtozero(a,b,c)
    n = length(a)
    @inbounds @simd for i in 1:n
        odd = (a[i]+b[i]+c[i]) & 1
        if odd != 0
            return false
        end
    end
    true
end

"""Compute the trace of a [`GeneralizedStabilizer`](@ref) state.

```jldoctest trace
julia> using QuantumClifford; using LinearAlgebra;

julia> sm = GeneralizedStabilizer(S"-X");

julia> apply!(sm, pcT)
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.146447+0.0im | + Z | + Z
 0.0-0.353553im | + Z | + _
 0.0+0.353553im | + _ | + Z
 0.853553+0.0im | + _ | + _

julia> tr(sm)
1.0 + 0.0im
```
"""
function LinearAlgebra.tr(sm::GeneralizedStabilizer)
    trace_χ′ = sum(χ for ((P_i, P_j), χ) in sm.destabweights if P_i == P_j; init=0)
    return trace_χ′
end

"""Returns the updated `GeneralizedStabilizer` state sm′ = (χ′, B(S′, D′)),
where (S′, D′) is derived from (S, D) through the traditional stabilizer update,
and χ′ is the updated density matrix after measurement. Note: Λ(χ′) ≤ Λ(χ).
"""
function _projectrand_notnorm(sm::GeneralizedStabilizer, p::PauliOperator, res::Int)
    dict = sm.destabweights
    dtype = valtype(dict)
    tzero = zero(dtype)
    tone = one(dtype)
    stab = sm.stab
    newdict = typeof(dict)(tzero)
    phase, b, c = rowdecompose(p, stab)
    new_stab = copy(stab)
    s_view = stabilizerview(new_stab)
    d_view = destabilizerview(new_stab)
    n = nqubits(new_stab)
    id_op = zero(PauliOperator, n)
    sign = res == 0 ? 1 : -1

    # Implementation of the in-place Pauli measurement quantum operation (Algorithm 2)
    # on a generalized stabilizer by Ted Yoder (Page 8) from [Yoder2012AGO](@cite).
    if all(iszero, b)
        # (Eq. 14-17)
        for ((dᵢ, dⱼ), χ) in dict
            cond_i = im^phase * (-tone)^(dot(dᵢ, c)) == sign # (Eq. 16)
            cond_j = im^phase * (-tone)^(dot(dⱼ, c)) == sign # (Eq. 16)
            if cond_i && cond_j
                newdict[(dᵢ, dⱼ)] += χ
            end
        end
        sm.destabweights = newdict
        return sm, res
    else
        # (Eq. 18-26)
        k_pos = findfirst(!iszero, b)
        # get the k-th stabilizer generator
        sk = s_view[k_pos]
        # update stabilizer generators
        for j in eachindex(b)
            if b[j]
                s_view[j] *= sk
            end
        end
        # update destabilizer generators
        for j in eachindex(c)
            if c[j] && j != k_pos  # cj = 1 and j ≠ k_pos
                d_view[j] *= sk
            end
        end
        d_view[k_pos] = id_op
        d_view[k_pos] = sk
        # replace sk with sign*M
        s_view[k_pos] = sign * p
        # update the χ matrix
        k = falses(n)
        k[k_pos] = true
        for ((dᵢ, dⱼ), χ) in dict
            x, y = dᵢ, dⱼ
            q = one(dtype)
            if dot(dᵢ, k) == 1
                q *= im^phase * (-tone)^dot(dᵢ, c) * sign
                x = dᵢ .⊻ b
            end
            if dot(dⱼ, k) == 1
                q *= conj(im^phase) * (-tone)^dot(dⱼ, c) * sign
                y = dⱼ .⊻ b
            end
            newdict[(x, y)] += χ * q / 2
        end
        sm.destabweights = newdict
        sm.stab = new_stab
        return sm, res
    end
end

"""$(TYPEDSIGNATURES)

Performs a randomized projection of the state represented by the [`GeneralizedStabilizer`](@ref) `sm`,
based on the measurement of a [PauliOperator](@ref) `p`.

Unlike in the case of stabilizer states, the expectation value χ′ of a Pauli operator
with respect to these more general states can be any real number between -1 and 1.
The expectation value can be calculated with `expect(p, sm)`.

```math
\\chi' = \\langle p \\rangle = \\text{expect}(p, sm)
```

To convert χ′ into a probability of projecting on the +1 eigenvalue branch:

```math
\\text{probability}_{1} = \\frac{\\text{real}(\\chi') + 1}{2}
```

!!! note
    Because the possible measurement results are themselves not stabilizer states anymore,
    we can not use the `project!` API, which assumes a stabilizer tableau and reports detailed
    information about whether the tableau and measurement commute or anticommute.

```jldoctest genstab
julia> sm = GeneralizedStabilizer(S"-X");

julia> apply!(sm, pcT)
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.146447+0.0im | + Z | + Z
 0.0-0.353553im | + Z | + _
 0.0+0.353553im | + _ | + Z
 0.853553+0.0im | + _ | + _

julia> χ′ = expect(P"-X", sm)
0.7071067811865475 + 0.0im

julia> prob₁ = (real(χ′)+1)/2
0.8535533905932737

julia> QuantumClifford.PauliChannelNonClifford._projectrand_notnorm(copy(sm), P"X", 0)[1]
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.146447+0.0im | + Z | + Z

julia> QuantumClifford.PauliChannelNonClifford._projectrand_notnorm(copy(sm), P"X", 1)[1]
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.853553+0.0im | + _ | + _
```

See also: [`expect`](@ref)
"""
function QuantumClifford.projectrand!(sm::GeneralizedStabilizer, p::PauliOperator)
    # Compute expectation value
    exp_val = expect(p, sm)
    prob_plus = (real(exp_val) + 1) / 2
    # Randomly choose outcome
    res = rand() < prob_plus ? 0 : 1
    # Apply the corresponding projection
    sm, _ = _projectrand_notnorm(sm, p, res)
    # Normalize the state
    trace = tr(sm)
    for ((dᵢ, dⱼ), χ) in sm.destabweights
        sm.destabweights[(dᵢ, dⱼ)] = χ / trace
    end
    res = (res == 0) ? 0x0 : 0x2
    return sm, res
end

function project!(s::GeneralizedStabilizer, p::PauliOperator)
    throw(MethodError(project!, (s, p)))
end

nqubits(sm::GeneralizedStabilizer) = nqubits(sm.stab)

abstract type AbstractPauliChannel <: AbstractOperation end

"""A Pauli channel datastructure, mainly for use with [`GeneralizedStabilizer`](@ref)

See also: [`UnitaryPauliChannel`](@ref)"""
struct PauliChannel{T,S} <: AbstractPauliChannel
    paulis::T
    weights::S
    function PauliChannel(paulis, weights)
        length(paulis) == length(weights) || throw(ArgumentError(lazy"""
        Attempting to construct a `PauliChannel` failed.
        The length of the vectors of weights and of Pauli operator pairs differs
        ($(length(weights)) and $(length(paulis)) respectively).
        """))
        n = nqubits(paulis[1][1])
        for p in paulis
            n == nqubits(p[1]) == nqubits(p[2]) || throw(ArgumentError(lazy"""
            You are attempting to construct a `PauliChannel` but have provided Pauli operators
            that are not all of the same size (same number of qubits).
            Please ensure that all of the Pauli operators being provided of of the same size.
            """))
        end
        new{typeof(paulis),typeof(weights)}(paulis,weights)
    end
end

function Base.show(io::IO, pc::PauliChannel)
    println(io, "Pauli channel ρ ↦ ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† with the following branches:")
    print(io, "with ϕᵢⱼ | Pᵢ | Pⱼ:")
    for (i, (di,dj)) in enumerate(pc.paulis)
        χ = pc.weights[i]
        println(io)
        print(io, " ")
        print(IOContext(io, :compact => true), χ)
        print(io, " | ", di, " | ", dj)
    end
end

function embed(n::Int,idx,pc::PauliChannel)
    PauliChannel(map(p->(embed(n,idx,p[1]),embed(n,idx,p[2])),pc.paulis), pc.weights)
end

nqubits(pc::PauliChannel) = nqubits(pc.paulis[1][1])

"""Applies a (potentially non-unitary) Pauli channel to a generalized stabilizer.

See also: [`GeneralizedStabilizer`](@ref), [`PauliChannel`](@ref), [`UnitaryPauliChannel`](@ref)
"""
function apply!(state::GeneralizedStabilizer, gate::AbstractPauliChannel; prune_threshold=1e-10)
    nqubits(state) == nqubits(gate) || throw(DimensionMismatch(lazy"GeneralizedStabilizer has $(nqubits(state)) qubits, but PauliChannel has $(nqubits(gate)). Use `embed` to create an appropriately padded PauliChannel."))
    dict = state.destabweights
    stab = state.stab
    dtype = valtype(dict)
    tzero = zero(dtype)
    tone = one(dtype)
    newdict = typeof(dict)(tzero)
    for ((dᵢ,dⱼ), χ) in dict # the state
        for (i, (Pₗ,Pᵣ)) in enumerate(gate.paulis) # the channel
            w = gate.weights[i]
            phaseₗ, dₗ, dₗˢᵗᵃᵇ = rowdecompose(Pₗ,stab)
            phaseᵣ, dᵣ, dᵣˢᵗᵃᵇ = rowdecompose(Pᵣ,stab)
            c = (dot(dₗˢᵗᵃᵇ,dᵢ) + dot(dᵣˢᵗᵃᵇ,dⱼ)) # algorithm 3 (Eq. 29), see https://scottaaronson.com/showcase2/report/ted-yoder.pdf
            dᵢ′ = dₗ .⊻ dᵢ
            dⱼ′ = dᵣ .⊻ dⱼ
            χ′ = χ * w * (-tone)^c * (im)^(phaseₗ-phaseᵣ+4) # Pauli operator M can be decomposed as α*d_b*s_c -- here algorithm 3 utilizes α_l*α† == i^(phase_l-phase_r+4) because (i^phase)† == i^(-phase).
            newdict[(dᵢ′,dⱼ′)] += χ′
        end
    end
    filter!(x -> abs(x[2]) > prune_threshold, newdict)
    state.destabweights = newdict
    state
end

"""
$(TYPEDSIGNATURES)

Tensor product of [`GeneralizedStabilizer`](@ref) states.

# Stabilizer state

```jldoctest
julia> sm = GeneralizedStabilizer(S"-X")
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 1.0+0.0im | + _ | + _

julia> sm ⊗ sm
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z_
+ _Z
𝒮𝓉𝒶𝒷
- X_
- _X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 1.0+0.0im | + __ | + __
```

# Arbitrary state

```jldoctest
julia> using LinearAlgebra; # hide

julia> sm = GeneralizedStabilizer(ghz(2))
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z_
+ _X
𝒮𝓉𝒶𝒷
+ XX
+ ZZ
with ϕᵢⱼ | Pᵢ | Pⱼ:
 1.0+0.0im | + __ | + __

julia> apply!(sm, embed(2, 2, pcT))
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z_
+ _X
𝒮𝓉𝒶𝒷
+ XX
+ ZZ
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.146447+0.0im | + Z_ | + Z_
 0.0-0.353553im | + Z_ | + __
 0.0+0.353553im | + __ | + Z_
 0.853553+0.0im | + __ | + __

julia> newsm = sm ⊗ sm
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z___
+ _X__
+ __Z_
+ ___X
𝒮𝓉𝒶𝒷━━
+ XX__
+ ZZ__
+ __XX
+ __ZZ
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.0214466+0.0im | + Z_Z_ | + Z_Z_
 0.0-0.0517767im | + Z_Z_ | + Z___
 0.0-0.0517767im | + Z_Z_ | + __Z_
 -0.125+0.0im | + Z_Z_ | + ____
 0.0+0.0517767im | + Z___ | + Z_Z_
 0.125+0.0im | + Z___ | + Z___
 0.125+0.0im | + Z___ | + __Z_
 0.0-0.301777im | + Z___ | + ____
 0.0+0.0517767im | + __Z_ | + Z_Z_
 0.125+0.0im | + __Z_ | + Z___
 0.125+0.0im | + __Z_ | + __Z_
 0.0-0.301777im | + __Z_ | + ____
 -0.125+0.0im | + ____ | + Z_Z_
 0.0+0.301777im | + ____ | + Z___
 0.0+0.301777im | + ____ | + __Z_
 0.728553+0.0im | + ____ | + ____

julia> real(tr(newsm))
1.0
```
"""
function (⊗)(state₁::GeneralizedStabilizer, state₂::GeneralizedStabilizer)
    dict₁ = state₁.destabweights
    dict₂ = state₂.destabweights
    dtype = valtype(dict₁)
    tzero = zero(dtype)
    newdict = DefaultDict{Tuple{BitVector,BitVector},dtype}(tzero)
    newstab = state₁.stab ⊗ state₂.stab
    for ((d1_i, d1_j), χ) in dict₁ # χ = ϕᵢⱼ for state₁
        for ((d2_i, d2_j), χ′) in dict₂ # χ′ = ϕₖₗ for state₂
            # Combine the Pauli operators via tensor product: Pᵢ ⊗ Pₖ
            # and Pⱼ ⊗ Pₗ. vcat implements P₁ ⊗ P₂ as bitwise concatenation.
            new_key_i = vcat(d1_i, d2_i)
            new_key_j = vcat(d1_j, d2_j)
            # The new coefficient is ϕᵢⱼ * ϕₖₗ because:
            # ∑ϕᵢⱼ*ϕₖₗ(Pᵢρ₁Pⱼ†) ⊗ (Pₖρ₂Pₗ†) = ∑ϕᵢⱼ*ϕₖₗ(Pᵢ ⊗ Pₖ)(ρ₁ ⊗ ρ₂)(Pⱼ ⊗ Pₗ)† and
            # thus the combined weight is the product of the individual weights.
            newdict[(new_key_i, new_key_j)] += χ * χ′
        end
    end
    return GeneralizedStabilizer(newstab, newdict)
end

"""Tensor product between [`GeneralizedStabilizer`](@ref) and [`Stabilizer`](@ref).

```jldoctest
julia> using LinearAlgebra; # hide

julia> sm = GeneralizedStabilizer(ghz(2))
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z_
+ _X
𝒮𝓉𝒶𝒷
+ XX
+ ZZ
with ϕᵢⱼ | Pᵢ | Pⱼ:
 1.0+0.0im | + __ | + __

julia> apply!(sm, embed(2, 2, pcT))
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z_
+ _X
𝒮𝓉𝒶𝒷
+ XX
+ ZZ
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.146447+0.0im | + Z_ | + Z_
 0.0-0.353553im | + Z_ | + __
 0.0+0.353553im | + __ | + Z_
 0.853553+0.0im | + __ | + __

julia> s = ghz(2)
+ XX
+ ZZ

julia> newsm = sm ⊗ s
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z___
+ _X__
+ __Z_
+ ___X
𝒮𝓉𝒶𝒷━━
+ XX__
+ ZZ__
+ __XX
+ __ZZ
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.146447+0.0im | + Z___ | + Z___
 0.0-0.353553im | + Z___ | + ____
 0.0+0.353553im | + ____ | + Z___
 0.853553+0.0im | + ____ | + ____

julia> real(tr(newsm))
1.0
```
"""
tensor(ops::Union{AbstractStabilizer,GeneralizedStabilizer}...) = tensor(GeneralizedStabilizer.(ops)...)

"""Decompose a Pauli ``P`` in terms of stabilizer and destabilizer rows from a given tableaux.

For given tableaux of rows destabilizer rows ``\\{d_i\\}`` and stabilizer rows ``\\{s_i\\}``,
there are boolean vectors ``b`` and ``c`` such that
``P = i^p \\prod_i d_i^{b_i} \\prod_i s_i^{c_i}``.

This function returns `p`, `b`, `c`.

```
julia> s = MixedDestabilizer(ghz(2))
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z_
+ _X
𝒮𝓉𝒶𝒷
+ XX
+ ZZ

julia> phase, destab_rows, stab_rows = QuantumClifford.rowdecompose(P"XY", s)
(3, Bool[1, 0], Bool[1, 1])

julia> im^3 * P"Z_" * P"XX" * P"ZZ"
+ XY
```
"""
function rowdecompose(pauli,state::Union{MixedDestabilizer, Destabilizer})
    n = nqubits(pauli)
    stab = stabilizerview(state)
    dest = destabilizerview(state)
    b = falses(n)
    c = falses(n)
    Pₜ = zero(PauliOperator, n) # TODO is this the best API choice!?
    for i in 1:n
        if comm(pauli, stab, i) != 0
            b[i] = true
            mul_right!(Pₜ, dest, i)
        end
    end
    for i in 1:n
        if comm(pauli, dest, i) != 0
            c[i] = true
            mul_right!(Pₜ, stab, i)
        end
    end
    p = mod(-Pₜ.phase[],4) # complex conjugate
    return p+pauli.phase[], b, c
end

"""A Pauli channel datastructure, mainly for use with [`GeneralizedStabilizer`](@ref).

More convenient to use than [`PauliChannel`](@ref) when you know your Pauli channel is unitary.

```jldoctest
julia> Tgate = UnitaryPauliChannel(
           (I, Z),
           ((1+exp(im*π/4))/2, (1-exp(im*π/4))/2)
       )
A unitary Pauli channel P = ∑ ϕᵢ Pᵢ with the following branches:
with ϕᵢ | Pᵢ
 0.853553+0.353553im | + _
 0.146447-0.353553im | + Z

julia> PauliChannel(Tgate)
Pauli channel ρ ↦ ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† with the following branches:
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.853553+0.0im | + _ | + _
 0.0+0.353553im | + _ | + Z
 0.0-0.353553im | + Z | + _
 0.146447+0.0im | + Z | + Z
```
"""
struct UnitaryPauliChannel{T,S,P} <: AbstractPauliChannel
    paulis::T
    weights::S
    paulichannel::P # caching the conversion the more general non-unitary type of PauliChannel
    function UnitaryPauliChannel(paulis, weights)
        n = nqubits(paulis[1])
        ws = [w₁*w₂' for w₁ in weights for w₂ in weights]
        ps = [(p₁,p₂) for p₁ in paulis for p₂ in paulis]
        pc = PauliChannel(ps,ws)
        new{typeof(paulis),typeof(weights),typeof(pc)}(paulis,weights,pc)
    end
end
UnitaryPauliChannel(p::UnitaryPauliChannel) = p
UnitaryPauliChannel(p::PauliOperator) = UnitaryPauliChannel([p], [1.0+0.0im])
PauliChannel(p::PauliOperator) = UnitaryPauliChannel(p).paulichannel
PauliChannel(p::UnitaryPauliChannel) = p.paulichannel
Base.copy(p::UnitaryPauliChannel) = UnitaryPauliChannel(map(copy, p.paulis), map(copy, p.weights))
Base.:(==)(p₁::UnitaryPauliChannel, p₂::UnitaryPauliChannel) = p₁.paulis==p₂.paulis && p₁.weights==p₂.weights

function Base.show(io::IO, pc::UnitaryPauliChannel)
    println(io, "A unitary Pauli channel P = ∑ ϕᵢ Pᵢ with the following branches:")
    print(io, "with ϕᵢ | Pᵢ")
    for (i, p) in enumerate(pc.paulis)
        χ = pc.weights[i]
        println(io)
        print(io, " ")
        print(IOContext(io, :compact => true), χ)
        print(io, " | ", p)
    end
end

function embed(n::Int,idx,pc::UnitaryPauliChannel)
    UnitaryPauliChannel(map(p->embed(n,idx,p),pc.paulis), pc.weights)
end

nqubits(pc::UnitaryPauliChannel) = nqubits(pc.paulis[1])

apply!(state::GeneralizedStabilizer, gate::UnitaryPauliChannel; prune_threshold=1e-10) = apply!(state, gate.paulichannel; prune_threshold)

function tensor(pcs::UnitaryPauliChannel...)
    newpaulis = [tensor(ps...) for ps in Iterators.product([pc.paulis for pc in pcs]...)]
    newweights = [prod(ws) for ws in Iterators.product([pc.weights for pc in pcs]...)]
    return UnitaryPauliChannel(newpaulis, newweights)
end

"""
Tensor product between [`UnitaryPauliChannel`](@ref) and [`PauliOperator`](@ref).

```jldoctest
julia> pcT ⊗ P"X"
A unitary Pauli channel P = ∑ ϕᵢ Pᵢ with the following branches:
with ϕᵢ | Pᵢ
 0.853553+0.353553im | + _X
 0.146447-0.353553im | + ZX

julia> pcT ⊗ pcT ⊗ P"X"
A unitary Pauli channel P = ∑ ϕᵢ Pᵢ with the following branches:
with ϕᵢ | Pᵢ
 0.603553+0.603553im | + __X
 0.25-0.25im | + Z_X
 0.25-0.25im | + _ZX
 -0.103553-0.103553im | + ZZX
```
"""
tensor(pcs::Union{UnitaryPauliChannel,PauliOperator}...) = tensor(UnitaryPauliChannel.(pcs)...)
# This also matches calls containing only PauliOperators and no channels, so the
# more-specific PauliOperator vararg method must take priority to avoid recursion.

"""
Apply a [`UnitaryPauliChannel`](@ref) to a [`GeneralizedStabilizer`](@ref) state.

```jldoctest
julia> sm = GeneralizedStabilizer(S"-X")
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 1.0+0.0im | + _ | + _

julia> pcT*sm
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
- X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 0.146447+0.0im | + Z | + Z
 0.0-0.353553im | + Z | + _
 0.0+0.353553im | + _ | + Z
 0.853553+0.0im | + _ | + _
```
"""
Base.:(*)(pc::UnitaryPauliChannel, sm::GeneralizedStabilizer) = apply!(sm, pc.paulichannel)

"""
Calculates the number of non-zero elements in the density matrix `χ`
of a [`GeneralizedStabilizer`](@ref), representing the inverse sparsity
of `χ`. It provides a measure of the state's complexity, with bounds
`Λ(χ) ≤ 4ⁿ`.

```jldoctest heuristic
julia> using QuantumClifford: invsparsity; # hide

julia> sm = GeneralizedStabilizer(S"X")
A mixture ∑ ϕᵢⱼ Pᵢ ρ Pⱼ† where ρ is
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z
𝒮𝓉𝒶𝒷
+ X
with ϕᵢⱼ | Pᵢ | Pⱼ:
 1.0+0.0im | + _ | + _

julia> apply!(sm, pcT) |> invsparsity
4
```

Similarly, it calculates the number of non-zero elements in the density
matrix `ϕᵢⱼ`​ of a PauliChannel, providing a measure of the channel
complexity.

```jldoctest heuristic
julia> invsparsity(pcT)
4
```

See also: [`GeneralizedStabilizer`](@ref)
"""
function invsparsity end

invsparsity(sm::GeneralizedStabilizer) = count(!iszero, values(sm.destabweights::DefaultDict{Tuple{BitVector, BitVector}, ComplexF64, ComplexF64}))
invsparsity(gate::AbstractPauliChannel) = count(!iszero, values(gate.paulichannel.weights::Vector{ComplexF64}))

##
# Predefined Pauli Channels
##

"""Phase rotation gate `Rz(ϕ) = diag(1, e^(iϕ))` as a [`UnitaryPauliChannel`](@ref), for use with [`GeneralizedStabilizer`](@ref).

See also: [`pcT`](@ref), [`pcRx`](@ref)
"""
function pcPhase(ϕ)
    UnitaryPauliChannel(
        (I, Z),
        ((1 + exp(im*ϕ))/2, (1 - exp(im*ϕ))/2)
    )
end

"""The T gate (`Rz(π/4)`) as a [`UnitaryPauliChannel`](@ref), for use with [`GeneralizedStabilizer`](@ref). Equivalent to `pcPhase(π/4)`.

See also: [`pcPhase`](@ref), [`pcRx`](@ref)
"""
const pcT = pcPhase(π/4)

"""X rotation gate `Rx(θ)` as a [`UnitaryPauliChannel`](@ref), for use with [`GeneralizedStabilizer`](@ref).

See also: [`pcPhase`](@ref), [`pcT`](@ref)
"""
function pcRx(θ)
    UnitaryPauliChannel(
        (I, X),
        (cos(θ/2), -im*sin(θ/2))
    )
end
end

using Revise
using QuantumClifford
using QuantumClifford: to_cpu, to_gpu
using CUDA
using BenchmarkTools
using Plots
using ProgressBars
using DataFrames
using CSV

include("surface-code-circuit.jl")

function pftrajectories_threads(frames, ccircuit)
    trajectories = size(frames.frame, 1)
    nthr = min(Threads.nthreads(),trajectories÷(100))
    if nthr>1
        batchsize = trajectories÷nthr
        Threads.@threads for i in 1:nthr
            b = (i-1)*batchsize+1
            e = i==nthr ? trajectories : i*batchsize
            pftrajectories((@view frames[b:e]), ccircuit)
        end
    else
        pftrajectories(frames, ccircuit)
    end
    return frames
end

function get_stats()
    println("Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...")

    # Powers of 2 to benchmark
    powers = reverse(3:19) # start from the hardest one first! (fail fast)
    n_values = 2 .^ powers

    cpu_row_times = Float64[]
    gpu_row_times = Float64[]
    cpu_column_times = Float64[]
    gpu_column_times = Float64[]

    ccircuit = if eltype(circ) <: QuantumClifford.CompactifiedGate
        circ
    else
        compactify_circuit(circ)
    end

    CUDA.allowscalar(false)

    for n in ProgressBar(n_values)

        cpu_frames() = to_cpu(QuantumClifford._create_pauliframe(ccircuit; trajectories=n))
        gpu_frames() = to_gpu(QuantumClifford._create_pauliframe(ccircuit; trajectories=n))
        
        cpu_row() = pftrajectories_threads(fastrow(cpu_frames()), ccircuit)
        cpu_column() = pftrajectories_threads(fastcolumn(cpu_frames()), ccircuit)
        gpu_row() = pftrajectories(fastrow(gpu_frames()), ccircuit), synchronize()
        gpu_column() = pftrajectories(fastcolumn(gpu_frames()), ccircuit), synchronize()

        push!(cpu_row_times, @belapsed $cpu_row())
        push!(cpu_column_times, @belapsed $cpu_column())
        push!(gpu_row_times, @belapsed $gpu_row())
        push!(gpu_column_times, @belapsed $gpu_column())

        # note. this is also measuring the time it takes to move data to gpu
    end
    return DataFrame(
        n_values=n_values,
        cpu_row_times=cpu_row_times,
        cpu_column_times=cpu_column_times,
        gpu_row_times=gpu_row_times,
        gpu_column_times=gpu_column_times
    )
end

function load_stats()
    if isfile("gpu_cpu_comparison.csv")
        DataFrame(CSV.File("gpu_cpu_comparison.csv"))
    else
        get_stats()
    end
end

function save_stats(df)
    CSV.write("gpu_cpu_comparison.csv", df)
end

function plot_result(df)
    my_y_axis(a, b) = begin
        arr = [a..., b...]
        logarr = log.(arr)
        exp.(range(min(logarr...), stop=max(logarr...), length=8))
    end

    cpu_row_col = plot(df.n_values, [df.cpu_row_times, df.cpu_column_times], marker=:circle, label=["row" "column"], xlabel="n", ylabel="Execution Time (s)", title="cpu: row vs column", xticks=df.n_values[1:2:end], xscale=:log2, yticks=my_y_axis(df.cpu_row_times, df.cpu_column_times), yscale=:log10, legend=:topleft)
    gpu_row_col = plot(df.n_values, [df.gpu_row_times, df.gpu_column_times], marker=:circle, label=["row" "column"], xlabel="n", ylabel="Execution Time (s)", title="gpu: row vs column", xticks=df.n_values[1:2:end], xscale=:log2, yticks=my_y_axis(df.gpu_row_times, df.gpu_column_times), yscale=:log10, legend=:topleft)
    gpu_vs_cpu_row = plot(df.n_values, [df.gpu_row_times, df.cpu_row_times], marker=:circle, label=["gpu row" "cpu row"], xlabel="n", ylabel="Execution Time (s)", title="gpu vs cpu (row)", xticks=df.n_values[1:2:end], xscale=:log2, yticks=my_y_axis(df.gpu_row_times, df.cpu_row_times), yscale=:log10, legend=:topleft)
    gpu_vs_cpu_column = plot(df.n_values, [df.gpu_column_times, df.cpu_column_times], marker=:circle, label=["gpu column" "cpu column"], xlabel="n", ylabel="Execution Time (s)", title="gpu vs cpu (column)", xticks=df.n_values[1:2:end], xscale=:log2, yticks=my_y_axis(df.gpu_column_times, df.cpu_column_times), yscale=:log10, legend=:topleft)

    plot(cpu_row_col, gpu_row_col, gpu_vs_cpu_row, gpu_vs_cpu_column, layout=(2, 2), size=(1200, 800))
end

function main()
    df = load_stats()
    save_stats(df)
    plot_result(df)
    savefig("benchmark_surface_code_d5.png")
end

@testitem "Clifford" begin
    using Random
    using QuantumClifford: stab_looks_good, destab_looks_good, mixed_stab_looks_good, mixed_destab_looks_good
    using QuantumClifford: mul_left!

    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    @testset "Low-level tableaux ops" begin
        for n in test_sizes
            p1 = random_pauli(n)
            p11 = copy(p1)
            p2 = random_pauli(n)
            p3 = p2*p1
            s = Stabilizer([p1,p2])
            @test QuantumClifford._mul_left_nonvec!(copy(p1).xz,p2.xz)&3 == mul_left!(copy(p1).xz,p2.xz)&3
            @test prodphase(p2,p1) == mul_left!(p1,p2).phase[]
            mul_left!(p11,s,2)
            mul_left!(s,1,2)
            @test p1 == p11 == p3 == s[1]
        end
    end
    @testset "Clifford Operators" begin
        @testset "Constructors" begin
            @test_throws DimensionMismatch CliffordOperator(T"X")
        end
        @testset "Constructor from PauliOperator" begin
            for n in test_sizes
                l = random_clifford(n)
                pauli = random_pauli(n)
                @test apply!(copy(l), pauli; phases=true) == apply!(l, CliffordOperator(pauli); phases=true)
            end
        end
        @testset "Permutations of qubits" begin
            for c in [tCNOT, tId1⊗tHadamard, tCNOT⊗tCNOT, tensor_pow(tCNOT,6), tensor_pow(tCNOT,7), tensor_pow(tCNOT,6)⊗tPhase, tensor_pow(tCNOT,7)⊗tPhase]
                for rep in 1:5
                    p = randperm(nqubits(c))
                    s = random_stabilizer(nqubits(c))
                    @test permutesystems(c,p)*s[:,p] == (c*s)[:,p]
                end
            end
            for i in 1:5
                p = randperm(125)
                c = rand([tId1, tHadamard, tPhase], 125)
                @test ⊗(c[p]...) == permutesystems(⊗(c...), p)
            end
        end
        @testset "Tensor products" begin
            for n in test_sizes
                for np in [2,3,4]
                    for pow in [1,2,10]
                        s1 = random_stabilizer(n)
                        sps = [random_stabilizer(np) for i in 1:pow]
                        ss = [s1, sps...]
                        c1 = random_clifford(n)
                        cps = repeat([random_clifford(np)],pow)
                        cs = [c1, cps...]
                        res1 = ⊗([c*s for (c,s) in zip(cs,ss)]...)
                        res2 = ⊗(cs...)*⊗(ss...)
                        res3 = (c1*s1) ⊗ (⊗(tensor_pow(cps[1],pow)) * ⊗(sps...))
                        @test res1==res2==res3
                    end
                end
            end
        end
        @testset "Clifford acting on Stabilizer" begin
            for size in test_sizes
                size < 5 && continue
                s = random_stabilizer(size)
                gates = vcat([tCNOT, tHadamard, tPhase], repeat([tId1],size-4))
                gates_perm = randperm(size-1)
                gates = gates[gates_perm]
                big_gate = reduce(⊗,gates)

                s1 = apply!(copy(s),big_gate)
                @test stab_looks_good(s1)

                igates_perm = invperm(gates_perm)
                s2 = copy(s)
                canonicalize!(s2)
                s2 = apply!(s2, [igates_perm[1],igates_perm[1]+1], tCNOT)
                canonicalize!(s2)
                s2 = apply!(s2, [igates_perm[2]+(igates_perm[1]<igates_perm[2])], tHadamard)
                canonicalize!(s2)
                s2 = apply!(s2, [igates_perm[3]+(igates_perm[1]<igates_perm[3])], tPhase)

                @test canonicalize!(s1) == canonicalize!(s2)
            end
        end
        @testset "Clifford acting on (Mixed)(De)Stabilizer" begin
            for size in test_sizes
                size < 2 && continue # TODO remove this line
                d = random_destabilizer(size)
                md = MixedDestabilizer(copy(d),size÷2)
                s = copy(stabilizerview(md))
                c = random_clifford(size)
                @test QuantumClifford._apply_nonthread!(s,c) == stabilizerview(apply!(md,c)) == stabilizerview(MixedDestabilizer(apply!(d,c),size÷2))
                newsize = min(size, 5)
                indices = randperm(size)[1:newsize]
                cn = random_clifford(newsize)
                @test QuantumClifford._apply_nonthread!(s,cn,indices) == stabilizerview(apply!(md,indices,cn)) == stabilizerview(MixedDestabilizer(apply!(d,indices,cn),size÷2))
            end
        end
        @testset "Inversions" begin
            for n in test_sizes
                c = random_clifford(n)
                ci = inv(c; phases=false)
                cip = inv(c)
                id = one(c)
                @test c*cip == cip*c == id
                @test (ci*c).tab.xzs == (c*ci).tab.xzs == id.tab.xzs
            end
        end
    end
end

"""
Benchmark threaded Clifford application.
"""

using QuantumClifford
using Nemo
using StableRNGs
using BenchmarkTools
using DataFrames
using Gadfly; import Cairo, Fontconfig
using Serialization
using CSV
using Glob

## Pick a name for the logs

NAME = "$(length(ARGS)>0 ? ARGS[1] : "")_$(Threads.nthreads())"

## Run the benchmarks and save results

results = []
for _N in [2048:-128:1024+128; 1024:-32:256; 256-32:-16:16; 14:-2:2]
    global N = _N              # TODO understand why global is necessary for eval to work
    global rng = StableRNG(42)
    for s in [
        :(random_destabilizer(rng, N)),
        :(one(Stabilizer, N))
       ]
       s_e = eval(s)
       for  gate in [
                :(random_clifford(rng,N),),
                :(tensor_pow(CNOT,N÷2),),
                :(CNOT,[N÷2,N]),
                :(Hadamard,[N÷2]),
                :(sCNOT(N÷2,N),),
                :(sHadamard(N÷2),)
            ]
            gate_e = eval(gate)
            println((Threads.nthreads(), N, gate, s))
            bench_apply = @benchmark apply!(_s,_g...) setup=(_s=deepcopy($s_e);_g=deepcopy($gate_e))
            push!(results, (;N, gate=string(gate), s=string(s), threads=Threads.nthreads(), trial=bench_apply))
        end
    end
end

serialize("threaded_apply_benchmarks_$(NAME).serialize", results)

## Prepare the results in a data frame and store to disk

DF = DataFrame(results)
for f in [:mean, :maximum, :minimum, :median]
    DF[!,f] .= (x->eval(f)(x).time).(DF[!,:trial])
end

CSV.write("threaded_apply_benchmarks_$(NAME).csv", DF)

## Collate all benchmarks

dfs = []
for f in glob("threaded_apply_benchmarks_*csv")
    df = CSV.read(f, DataFrame)
    df[!,:system] .= split(split(f, "_")[end],".")[1]
    push!(dfs,df)
end
DF = vcat(dfs...)
DF[!, :threadtime] .= DF[:,:minimum] .* DF[:,:threads]
Gadfly.with_theme(style(highlight_width=0.1mm)) do
    p = Gadfly.plot(
        DF,
        color=:threads,
        x=:N, y=:minimum,
        xgroup=:s,
        ygroup=:gate,
        Geom.subplot_grid(Geom.line,free_y_axis=true),
        Scale.y_log10(),
        Scale.x_log10(),
        Scale.color_discrete(),
        Guide.xlabel("Number of qubits\n(grouped by whether the stabilizer is random or diagonal)"),
        Guide.ylabel("Time (ns)\n(grouped by type of Clifford operation)"),
        Guide.colorkey(title="Number of \nthreads"),
    )
    img = PNG("bench_threaded_apply.png", 18cm, 6*8cm, dpi=200)
    draw(img, p)
end
Gadfly.with_theme(style(highlight_width=0.1mm)) do
    p = Gadfly.plot(
        DF,
        color=:threads,
        x=:N, y=:threadtime,
        xgroup=:s,
        ygroup=:gate,
        Geom.subplot_grid(Geom.line,free_y_axis=true),
        Scale.y_log10(),
        Scale.x_log10(),
        Scale.color_discrete(),
        Guide.xlabel("Number of qubits\n(grouped by whether the stabilizer is random or diagonal)"),
        Guide.ylabel("Time × Threads (ns) \n(grouped by type of Clifford operation)"),
        Guide.colorkey(title="Number of \nthreads"),
    )
    img = PNG("bench_threaded_apply_threadtime.png", 18cm, 6*8cm, dpi=200)
    draw(img, p)
end

using Random: AbstractRNG, GLOBAL_RNG


"""
`CircuitCode` is defined by a given encoding circuit `circ`.

- `n`: qubit number
- `circ`: the encoding circuit
- `encode_qubits`: the qubits to be encoded

See also: [`random_all_to_all_circuit_code`](@ref), [`random_brickwork_circuit_code`](@ref)
"""
struct CircuitCode <: AbstractQECC
    n::Int
    circ::Vector{QuantumClifford.AbstractOperation}
    encode_qubits::AbstractArray
end

iscss(::Type{CircuitCode}) = nothing

code_n(c::CircuitCode) = c.n

code_k(c::CircuitCode) = length(c.encode_qubits)

function parity_checks(c::CircuitCode)
    n = code_n(c)
    checks = one(Stabilizer, n)[setdiff(1:n, c.encode_qubits)]
    for op in c.circ
        apply!(checks, op)
    end
    checks
end

"""
Random all-to-all Clifford circuit code [brown2013short](@cite).

The code of `n` qubits is generated by an all-to-all random Clifford circuit of `ngates` gates that encodes a subset of qubits `encode_qubits` into logical qubits.

Because of the random picking, the size of `encode_qubits` is the only thing that matters for the code, referred to as `k`.

See also: [`random_all_to_all_clifford_circuit`](@ref), [`CircuitCode`](@ref)
"""
function random_all_to_all_circuit_code end

function random_all_to_all_circuit_code(rng::AbstractRNG, n::Int, ngates::Int, k::Int)
    CircuitCode(n, random_all_to_all_clifford_circuit(rng, n, ngates), collect(1:k))
end

function random_all_to_all_circuit_code(n::Int, ngates::Int, k::Int)
    CircuitCode(n, random_all_to_all_clifford_circuit(n, ngates), collect(1:k))
end

function random_all_to_all_circuit_code(rng::AbstractRNG, n::Int, ngates::Int, encode_qubits::AbstractArray)
    CircuitCode(n, random_all_to_all_clifford_circuit(rng, n, ngates), encode_qubits)
end

function random_all_to_all_circuit_code(n::Int, ngates::Int, encode_qubits::AbstractArray)
    CircuitCode(n, random_all_to_all_clifford_circuit(n, ngates), encode_qubits)
end


"""
Random brickwork Clifford circuit code [brown2013short](@cite).

The code is generated by a brickwork random Clifford circuit of `nlayers` layers that encodes a subset of qubits `encode_qubits` into logical qubits.

See also: [`random_brickwork_clifford_circuit`](@ref), [`CircuitCode`](@ref)
"""
function random_brickwork_circuit_code end

# TODO it would be nicer if we can use CartesianIndex for `encode_qubits` in brickworks,
# but its conversion to LinearIndex is limited, not supporting non-one step.
function random_brickwork_circuit_code(rng::AbstractRNG, lattice_size::NTuple{N,Int} where {N}, nlayers::Int, encode_qubits::AbstractArray)
    CircuitCode(prod(lattice_size), random_brickwork_clifford_circuit(rng, lattice_size, nlayers), encode_qubits)
end

function random_brickwork_circuit_code(lattice_size::NTuple{N,Int} where {N}, nlayers::Int, encode_qubits::AbstractArray)
    CircuitCode(prod(lattice_size), random_brickwork_clifford_circuit(lattice_size, nlayers), encode_qubits)
end

module QuantumCliffordHeckeExt

using QECCore
import QECCore: code_n, code_s, code_k, rate, distance
using DocStringExtensions

import QuantumClifford, LinearAlgebra

import Hecke: Group, GroupElem, AdditiveGroupElem,
    GroupAlgebra, GroupAlgebraElem, FqFieldElem, representation_matrix, dim, base_ring,
    multiplication_table, coefficients, abelian_group, group_algebra, rand, gens, order,
    is_commutative, FqPolyRingElem, residue_ring, coeff, zero_matrix, mod1, lift, ZZ, gen,
    polynomial_ring, characteristic, isone, mod, factor, zeros, group, EuclideanRingResidueRingElem,
    degree, gcd, nrows, ncols
import Hecke.Generic.MatSpaceElem
import Nemo
import Nemo: characteristic, matrix_repr, GF, ZZ, lift, matrix, rank

import QuantumClifford.ECC: iscss, parity_checks,
    two_block_group_algebra_code, generalized_bicycle_code_as_2bga, bicycle_code_as_2bga, check_repr_commutation_relation,
    Haah_cubic_code_as_2bga, honeycomb_color_code_as_2bga, check_repr_regular_linear, random_qc_ghp_code_matrix_A

import QECCore: AbstractQECC, CSS, AbstractCSSCode,
    hgp, code_k, code_n, code_s, parity_matrix_x, parity_matrix_z, parity_matrix_xz, parity_matrix

import Random
import Random: AbstractRNG, default_rng, randperm

# exported from extension so that Documenter.jl sees them when autogenerating API lists
export hgp, two_block_group_algebra_code, generalized_bicycle_code_as_2bga, bicycle_code_as_2bga, Haah_cubic_code_as_2bga,
    LPCode, LiftedCode, honeycomb_color_code_as_2bga, LaCross, GeneralizedBicycle, ExtendedGeneralizedBicycle,
    GeneralizedHyperGraphProduct

include("util.jl")
include("types.jl")
include("lifted.jl")
include("lacross.jl")
include("lifted_product.jl")
include("generalized_bicycle.jl")
include("extended_generalized_bicycle.jl")
include("generalized_hypergraph_product.jl")

end # module

module QuantumCliffordPlotsExt

using Plots
using QuantumClifford

@recipe function f(s::QuantumClifford.Stabilizer; xzcomponents=:together)
    seriestype  := :heatmap
    aspect_ratio := :equal
    yflip := true
    colorbar := :none
    colorbar_discrete_values := true
    colorbar_ticks := [0,1,2,3]
    colorbar_formatter := i->["I","X","Z","Y"][Int(floor(i+1))]
    clims := (0,3)
    color_palette := [:blue, :green,:red,:black]
    grid := false
    framestyle := :none
    if xzcomponents==:split
        QuantumClifford.stab_to_gf2(s)
    elseif xzcomponents==:together
        h = QuantumClifford.stab_to_gf2(s)
        h[:,1:end÷2] + h[:,end÷2+1:end]*2
    else
        throw(ErrorException("`xzcomponents` should be `:split` or `:together`"))
    end
end

end

@testitem "ECC coprime Bivaraite Bicycle" tags=[:ecc, :ecc_bespoke_checks] begin
    using Nemo
    using Nemo: gcd
    using Hecke
    using JuMP
    using HiGHS
    using Hecke: group_algebra, GF, abelian_group, gens
    using QuantumClifford.ECC: two_block_group_algebra_code, code_k, code_n, distance, DistanceMIPAlgorithm

    @testset "Reproduce Table 2 wang2024coprime" begin
        # [[30,4,6]]
        l=3; m=5;
        GA = group_algebra(GF(2), abelian_group([l*m]))
        𝜋 = gens(GA)[1]
        A = 1 + 𝜋   + 𝜋^2
        B = 𝜋 + 𝜋^3 + 𝜋^8
        c = two_block_group_algebra_code(A, B)
        @test gcd([l,m]) == 1
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
        @test code_n(c) == 30 && code_k(c) == 4

        # [[42,6,6]]
        l=3; m=7;
        GA = group_algebra(GF(2), abelian_group([l*m]))
        𝜋 = gens(GA)[1]
        A = 1 + 𝜋^2 + 𝜋^3
        B = 𝜋 + 𝜋^3 + 𝜋^11
        c = two_block_group_algebra_code(A, B)
        @test gcd([l,m]) == 1
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
        @test code_n(c) == 42 && code_k(c) == 6

        # [[70,6,8]]
        l=5; m=7;
        GA = group_algebra(GF(2), abelian_group([l*m]))
        𝜋 = gens(GA)[1]
        A = 1 + 𝜋 + 𝜋^5;
        B = 1 + 𝜋 + 𝜋^12;
        c = two_block_group_algebra_code(A, B)
        @test gcd([l,m]) == 1
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8
        @test code_n(c) == 70 && code_k(c) == 6

        # [[108,12,6]]
        l=2; m=27;
        GA = group_algebra(GF(2), abelian_group([l*m]))
        𝜋 = gens(GA)[1]
        A = 𝜋^2 + 𝜋^5  + 𝜋^44
        B = 𝜋^8 + 𝜋^14 + 𝜋^47
        c = two_block_group_algebra_code(A, B)
        @test gcd([l,m]) == 1
        i = rand(1:code_k(c))
        @test distance(c, DistanceMIPAlgorithm(logical_qubit=i; solver=HiGHS)) == 6
        @test code_n(c) == 108 && code_k(c) == 12

        # [[126,12,10]]
        l=7; m=9
        GA = group_algebra(GF(2), abelian_group([l*m]))
        𝜋 = gens(GA)[1]
        A = 1   + 𝜋    + 𝜋^58
        B = 𝜋^3 + 𝜋^16 + 𝜋^44
        c = two_block_group_algebra_code(A, B)
        @test gcd([l,m]) == 1
        @test code_n(c) == 126 && code_k(c) == 12
    end
end

@testitem  "ECC GB Codes - additional tests of the distance-finding algorithm" tags=[:ecc, :ecc_bespoke_checks] begin
    using Hecke
    using HiGHS
    using JuMP
    using QuantumClifford.ECC.QECCore: code_k, code_n, distance, rate
    using QuantumClifford.ECC: generalized_bicycle_code_as_2bga, code_k, code_n, DistanceMIPAlgorithm

    @testset "generalized bicycle codes from arXiv:2203.17216" begin
        # codes taken from https://github.com/QEC-pages/GB-codes
        c = generalized_bicycle_code_as_2bga([0, 2], [0, 1], 5)
        @test code_n(c) == 10
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        c = generalized_bicycle_code_as_2bga([0, 3], [0, 1], 11)
        @test code_n(c) == 22
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
        c = generalized_bicycle_code_as_2bga([0, 5], [0, 1], 13)
        @test code_n(c) == 26
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
        c = generalized_bicycle_code_as_2bga([0, 4], [0, 1], 19)
        @test code_n(c) == 38
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
        c = generalized_bicycle_code_as_2bga([0, 8], [0, 1], 29)
        @test code_n(c) == 58
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 7
        c = generalized_bicycle_code_as_2bga([0, 8], [0, 1], 37)
        @test code_n(c) == 74
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8
        c = generalized_bicycle_code_as_2bga([0, 8], [0, 1], 53)
        @test code_n(c) == 106
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 9

        c = generalized_bicycle_code_as_2bga([0, 1, 2, 3], [0, 1], 5)
        @test code_n(c) == 10
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        c = generalized_bicycle_code_as_2bga([0, 1, 2, 5], [0, 1], 11)
        @test code_n(c) == 22
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
        c = generalized_bicycle_code_as_2bga([0, 1, 2, 5], [0, 1], 13)
        @test code_n(c) == 26
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
        c = generalized_bicycle_code_as_2bga([0, 2, 3, 7], [0, 1], 19)
        @test code_n(c) == 38
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 7
        c = generalized_bicycle_code_as_2bga([0, 1, 3, 10], [0, 1], 29)
        @test code_n(c) == 58
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 9
        c = generalized_bicycle_code_as_2bga([0, 1, 4, 14], [0, 1], 37)
        @test code_n(c) == 74
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 11

        c = generalized_bicycle_code_as_2bga([0, 1, 2, 3], [0, 1],  5)
        @test code_n(c) == 10
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        c = generalized_bicycle_code_as_2bga([0, 1, 2, 3], [0, 1],  7)
        @test code_n(c) == 14
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        c = generalized_bicycle_code_as_2bga([0, 1, 2, 5], [0, 1], 11)
        @test code_n(c) == 22
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
        c = generalized_bicycle_code_as_2bga([0, 1, 2, 5], [0, 1], 13)
        @test code_n(c) == 26
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
        c = generalized_bicycle_code_as_2bga([0, 1, 3, 9], [0, 1], 17)
        @test code_n(c) == 34
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 7
        c = generalized_bicycle_code_as_2bga([0, 1, 2, 8], [0, 1], 19)
        @test code_n(c) == 38
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 7
        c = generalized_bicycle_code_as_2bga([0, 1, 3, 9], [0, 1], 23)
        @test code_n(c) == 46
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8
        c = generalized_bicycle_code_as_2bga([0, 1, 3, 10], [0, 1], 29)
        @test code_n(c) == 58
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 9
        c = generalized_bicycle_code_as_2bga([0, 5, 11,17], [0, 1], 31)
        @test code_n(c) == 62
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 10
        c = generalized_bicycle_code_as_2bga([0, 1, 4, 14], [0, 1], 37)
        @test code_n(c) == 74
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 11

        c = generalized_bicycle_code_as_2bga([0, 1, 2, 4, 5, 8], [0, 1], 11)
        @test code_n(c) == 22
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
        c = generalized_bicycle_code_as_2bga([0, 2, 3, 6, 7, 9], [0, 1], 13)
        @test code_n(c) == 26
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
        c = generalized_bicycle_code_as_2bga([0, 1, 2, 3, 4, 8], [0, 1], 19)
        @test code_n(c) == 38
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 7
    end
end

@testitem "Graph states precompiled tables correctness" begin
    import QuantumClifford.GraphSim: GraphState, IP_SQRTX_DECOMPOSITION_TABLE, ISOLATED_CPHASE_TABLE, Z_COMMUTATION_SUBGROUP, SINGLE_QUBIT_MULTIPLICATION_TABLE, gen_graph_state, vops

    @testset "Single Clifford operator decomposition table" begin
        for (k, v) in IP_SQRTX_DECOMPOSITION_TABLE
            # check if each sequence "adds up" to the operator
            t = one(CliffordOperator, 1)
            for u in v
                t = u * t
            end
            @test SingleQubitOperator(t) == k
        end
    end

    @testset "Single qubit operator multiplication table" begin
        for (k, v) in SINGLE_QUBIT_MULTIPLICATION_TABLE
            (v1, v2) = k
            @test v1 * CliffordOperator(v2, 1) == CliffordOperator(v, 1)
        end
    end

    @testset "Isolated CPHASE Table" begin
        for ((connected, U1, U2), res) in ISOLATED_CPHASE_TABLE
            g_init = gen_graph_state(connected, U1, U2)
            # check every entry satisfies the constraint
            for qubit_idx in 1:2
                if CliffordOperator(vops(g_init)[qubit_idx], 1) in Z_COMMUTATION_SUBGROUP
                    @test CliffordOperator(vops(res)[qubit_idx], 1) in Z_COMMUTATION_SUBGROUP
                end
            end
            # check every entry agrees with stabilizer result
            @test canonicalize!(apply!(Stabilizer(g_init), sCPHASE(1, 2))) == canonicalize!(Stabilizer(res))
        end
    end
end

#=============================================================================#
# PauliOperator
function adapt_structure(
    AT::Type{T}, pauli::PauliOperator
    ) where {T <: AbstractArray}

    return PauliOperator(
        adapt(AT, change_type(UInt8, pauli.phase)),
        pauli.nqubits,
        adapt(AT, pauli.xz)
        )

end

function adapt_structure(
    AT::Type{T}, pauli::PauliOperator
    ) where {T <: AbstractGPUArray}

    return PauliOperator(
        adapt(AT, change_type(DeviceUnsigned, pauli.phase)),
        pauli.nqubits,
        adapt(AT, pauli.xz)
        )

end

# Tableau
function adapt_structure(
    AT::Type{T}, tab::Tableau
    ) where {T <: AbstractArray}

    return Tableau(
        adapt(AT, change_type(UInt8, tab.phases)),
        tab.nqubits,
        adapt(AT, tab.xzs)
        )

end

function adapt_structure(
    AT::Type{T}, tab::Tableau
    ) where {T <: AbstractGPUArray}

    return Tableau(
        adapt(AT, change_type(DeviceUnsigned, tab.phases)),
        tab.nqubits,
        adapt(AT, tab.xzs)
        )

end

# Stabilizer
function adapt_structure(
    AT::Type{T}, state::Stabilizer
    ) where {T <: AbstractArray}

    return Stabilizer(adapt(AT, state.tab))

end

# Destabilizer
function adapt_structure(
    AT::Type{T}, state::Destabilizer
    ) where {T <: AbstractArray}

    return Destabilizer(adapt(AT, state.tab))

end

# MixedStabilizer
function adapt_structure(
    AT::Type{T}, state::MixedStabilizer
    ) where {T <: AbstractArray}

    return MixedStabilizer(adapt(AT, state.tab), state.rank)

end

# MixedDestabilizer
function adapt_structure(
    AT::Type{T}, state::MixedDestabilizer
    ) where {T <: AbstractArray}

    return MixedDestabilizer(adapt(AT, state.tab), state.rank)

end
#=============================================================================#

@testitem "ECC LiftedCode" tags=[:ecc, :ecc_bespoke] begin
    using Hecke
    using Hecke: group_algebra, GF, abelian_group, gens, one, representation_matrix
    using QuantumClifford.ECC: LiftedCode, code_k, code_n, code_s, parity_matrix

    l = 12; GA = group_algebra(GF(2), abelian_group(l)); x = gens(GA)[]
    B = reshape([1 + x + x^3 + x^6], (1, 1))
    c = LiftedCode(B, repr = representation_matrix)
    @test_nowarn parity_matrix(c)
    @test_nowarn code_n(c)
    @test_nowarn code_k(c)
    @test_nowarn code_s(c)
    base_matrix = [0 0 0 0; 0 1 2 5; 0 6 3 1]; l = 3;
    c = LiftedCode(base_matrix, l);
    @test_nowarn parity_matrix(c)
    @test_nowarn code_n(c)
    @test_nowarn code_k(c)
    @test_nowarn code_s(c)
end

const BIG_INT_MINUS_ONE = Ref{BigInt}()
const BIG_INT_TWO = Ref{BigInt}()
const BIG_INT_FOUR = Ref{BigInt}()

import WeakDepHelpers: WeakDepCache, method_error_hint_callback

const WEAKDEP_METHOD_ERROR_HINTS = WeakDepCache()

function __init__()
    ENV["NEMO_PRINT_BANNER"] = "false"
    ENV["HECKE_PRINT_BANNER"] = "false"
    ENV["OSCAR_PRINT_BANNER"] = "false"

    BIG_INT_MINUS_ONE[] = BigInt(-1)
    BIG_INT_TWO[] = BigInt(2)
    BIG_INT_FOUR[] = BigInt(4)

    # Register error hint for the `project!` method for GeneralizedStabilizer
    if isdefined(Base.Experimental, :register_error_hint)
        Base.Experimental.register_error_hint(MethodError) do io, exc, argtypes, kwargs
            method_error_hint_callback(WEAKDEP_METHOD_ERROR_HINTS, io, exc, argtypes, kwargs)
            if exc.f === project! && argtypes[1] <: GeneralizedStabilizer
                print(io, """
                \nThe method `project!` is not appropriate for use with`GeneralizedStabilizer`.
                You probably are looking for `projectrand!`.
                `project!` in this library is a low-level "linear algebra" method to verify
                whether a measurement operator commutes with a set of stabilizers, and to
                potentially simplify the tableau and provide the index of the anticommuting
                term in that tableau. This linear algebra operation is not defined for
                `GeneralStabilizer` as there is no single tableau to provide an index into.""")
            elseif exc.f === ECC.distance && length(argtypes)==1
                print(io,"""
                \nThe distance for this code is not in our database. Consider using the MIP-based method:
                `import JuMP, HiGHS; distance(code, DistanceMIPAlgorithm(solver=HiGHS))` or another MIP solver""")
            elseif exc.f === ECC.distance && length(argtypes)==2 && argtypes[2]===ECC.DistanceMIPAlgorithm
                print(io,"""\nPlease first import `JuMP` to make MIP-based distance calculation available.""")
            end
        end
    end
end

@testitem "Inner product between stabilizer states" begin
    using LinearAlgebra
    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    for n in rand(test_sizes)
        s1 = one(Stabilizer, n, basis=:X)
        s2 = one(MixedDestabilizer, n, n)
        @test dot(s1,s2)≈2.0^(-n/2)
        c = random_clifford(n)
        s3 = random_stabilizer(n)
        s4 = random_destabilizer(n)
        @test logdot(s3,s4)==logdot(c*s3,c*s4)
    end
    sa = S" XX
    ZZ"
    sb = S" XZ
    ZX"
    sc = S" XX
    -ZZ"
    @test isnothing(logdot(sa,sb))
    @test isnothing(logdot(S"Y",S"-Y"))
    @test logdot(S"Z",S"X") == 1
    @test logdot(S"X",S"X") == 0
    @test isnothing(logdot(S"X"⊗sa,S"X"⊗sb))
    @test logdot(S"X"⊗sb,S"X"⊗sc) == 1
    @test logdot(S"X"⊗sb,S"Z"⊗sc) == 2
end

abstract type DDimensionalCode <: AbstractCSSCode end

"""Construct the chain complex for the repetition code of length `L`."""
function _repcode_chain_complex(L::Int)
    F = GF(2)
    H = parity_matrix(RepCode(L))
    H = H[1:L-1, :] # (L-1) × L (A5)
    H = matrix(F, H)
    V1 = free_module(F, L-1)
    V0 = free_module(F, L)
    ∂C = hom(V1, V0, H)
    return chain_complex([∂C])
end

"""Construct the chain complex for the dual of the repetition code of length `L`."""
function _dual_repcode_chain_complex(L::Int)
    F = GF(2)
    H = parity_matrix(RepCode(L))
    H = H[1:L-1, :] # (L-1) × L (A5)
    H = matrix(F, H)
    V0 = free_module(F, L-1)
    V1 = free_module(F, L)
    ∂D = hom(V1, V0, transpose(H))
    return chain_complex([∂D])
end

"""Construct the chain complex for the repetition code of length `L`."""
function _repcode_chain_complex_full(L::Int)
    F = GF(2)
    H = parity_matrix(RepCode(L))
    H = matrix(F, H)
    V1 = free_module(F, L)
    V0 = free_module(F, L)
    ∂C = hom(V1, V0, H)
    return chain_complex([∂C])
end

"""
    $TYPEDEF

Constructs the `D`-dimensional surface code using [chain complexes](https://en.wikipedia.org/wiki/Chain_complex)
and ``\\mathbb{F}_2``-[homology](https://en.wikipedia.org/wiki/Homology_(mathematics)).

## Homological Algebra Foundations of Quantum Error Correction

The theory of chain complexes over ``\\mathbb{F}_2`` provides a unified framework for
understanding error-correcting codes, where classical ``[n, k, d]`` codes correspond to
`2`-term complexes and quantum CSS codes arise naturally as `3`-term complexes satisfying
the commutativity condition ``H_Z^T H_X = 0``. The homological framework reveals that:

- Quantum CSS codes arise from chain complexes where boundary operators correspond to parity checks.
- Logical operators correspond to homology classes.
- Higher-dimensional codes can be constructed through products of complexes.

## Chain Complex Structure

A **chain complex** ``C`` of length ``n`` is a sequence of finite-dimensional vector spaces
``C_j`` over ``\\mathbb{F}_2`` connected by boundary operators that are linear transformations
``\\partial_j \\colon C_j \\to C_{j-1}``:

```math
\\begin{aligned}
C : \\{0\\} \\longrightarrow C_n \\xrightarrow{\\partial_n} C_{n-1} \\xrightarrow{\\partial_{n-1}} \\cdots \\xrightarrow{\\partial_2} C_1 \\xrightarrow{\\partial_1} C_0 \\longrightarrow \\{0\\}
\\end{aligned}
```

with boundary operators satisfying ``\\partial_i \\circ \\partial_{i+1} = 0``
(equivalently, ``\\text{im}\\, \\partial_{j+1} \\subseteq \\ker \\partial_j)``.We define:

- **i-chains**: Elements of ``C_i``
- **i-cycles**: ``Z_i(C) := \\ker \\partial_i``
- **i-boundaries**: ``B_i(C) := \\mathrm{im} \\partial_{i+1}``
- **i-th homology**: ``H_i(C) := Z_i(C)/B_i(C)``

## Cohomology of the Dual Complex

Given a chain complex ``C`` with boundary operators ``\\partial_j``, its **cochain complex**
``\\widetilde{C}`` is the *dual* sequence with coboundary maps ``\\delta^i = \\partial_{i+1}^T``:

```math
\\begin{aligned}
\\widetilde{C} : \\{0\\} \\longleftarrow C_0^* \\xleftarrow{\\partial_1^T} C_1^* \\xleftarrow{\\partial_2^T} \\cdots \\xleftarrow{\\partial_n^T} C_n^* \\longleftarrow \\{0\\}
\\end{aligned}
```

where

- **i-cocycles**: ``Z^i(\\widetilde{C}) := \\ker \\partial_{i+1}^T``
- **i-coboundaries**: ``B^i(\\widetilde{C}) := \\mathrm{im} \\partial_i^T``
- **i-th cohomology**: ``H^i(\\widetilde{C}) := Z^i(\\widetilde{C})/B^i(\\widetilde{C})``

!!! note
    The cohomology group ``H^i(\\widetilde{C}) = H(\\partial_{i+1}^T, \\partial_i^T)`` has the same
    rank as the homology group ``H_i(C)`` and corresponds to ``X``-type logical operators in the CSS code
    ``CSS(\\partial_i, \\partial_{i+1}^T)``, while ``H_i(C)`` corresponds to ``Z``-type operators.

### Classical Codes via Chain Complexes and ``\\mathbb{F_2}`` Homology

An ``[n,k,d]`` classical code corresponds to a `2`-term complex:

```math
\\begin{aligned}
\\{0\\} \\longrightarrow C_1 \\xrightarrow{\\partial_1 = H} C_0 \\longrightarrow \\{0\\}
\\end{aligned}
```

where

- ``C_1 = \\mathbb{F}_2^n`` (codeword space)
- ``C_0 = \\mathbb{F}_2^{n-k}`` (syndrome space)
- ``H`` is the parity check matrix

### Quantum CSS Codes via Chain Complexes and ``\\mathbb{F_2}`` Homology

Quantum CSS codes extend this to `3`-term complexes:

```math
\\begin{aligned}
\\{0\\} \\longrightarrow C_2 \\xrightarrow{\\partial_2 = H_Z^T} C_1 \\xrightarrow{\\partial_1 = H_X} C_0 \\longrightarrow \\{0\\}
\\end{aligned}
```

where

- ``C_1 = \\mathbb{F}_2^n`` (physical qubits)
- ``C_2 = \\mathbb{F}_2^{m_Z}`` (`Z`-stabilizers)
- ``C_0 = \\mathbb{F}_2^{m_X}`` (`X`-stabilizers)

with the condition ``\\partial_1 \\partial_2 = H_Z^TH_X = 0`` ensuring that CSS orthogonality is satisfied.

For any chain complex, selecting two consecutive boundary operators
defines a valid CSS code. When qubits are identified with the space ``C_i``,
the code parameters are:

- number of physical qubits: ``n = \\dim C_i``
- number of logical qubits: ``k = \\dim H_i(C) = \\dim H^i(C)``
- code distance: ``d = \\min\\{\\text{wt}(v) | v \\in (H_i(C) \\cup H^i(C))\\backslash\\{0\\}\\}``

!!! note
    Quantum error-correcting codes, which are represented as `3`-term chain complexes, can be
    constructed by applying the homological or hypergraph product to two `2`-term chain complexes.

For a detailed explanation, see the ECC Zoo's writeup on the
[CSS-to-homology correspondence](https://errorcorrectionzoo.org/c/qubit_css#defterm-Qubit_20XCSS-to-homology_20Xcorrespondence).

## D-dimensional Surface Code ([Berthusen_2024](@cite), [Zeng_2019](@cite))

We provide an explicit construction of the `D`-dimensional surface code
within the framework of chain complexes and homology over ``\\mathbb{F_2}``.

The quantum code is obtained by applying the homological product (or hypergraph
product) to two `2`-term chain complexes. Our construction relies on taking the
hypergraph product of these complexes.

## Double Complex

Given chain complexes `C` and `D`, we construct a [double complex](https://en.wikipedia.org/wiki/Double_complex)
derived from the tensor product of two `2`-term chain complexes:

```math
\\begin{aligned}
C \\boxtimes D \\quad \\text{with} \\quad \\partial_i^v = \\partial_i^C \\otimes I_{D_i} \\quad \\text{and} \\quad \\partial_i^h = I_{C_i} \\otimes \\partial_i^D
\\end{aligned}
```

## Total Complex

The total complex is derived from a double complex by taking the direct
sum of vector spaces and boundary maps that share the same dimension:

```math
\\begin{aligned}
\\text{Tot}(C \\boxtimes D)_i = \\bigoplus_{i=j+k} C_j \\otimes D_k = E_i
\\end{aligned}
```

with boundary maps:

```math
\\begin{aligned}
\\partial_i^E = \\bigoplus_{i=j+k} \\partial_j^v \\oplus \\partial_k^h
\\end{aligned}
```

The resulting chain complex, called the tensor product of ``C`` and ``D``, ``C ⊗ D``, enables
the construction of a CSS code when selecting any three consecutive terms in its sequence.

## Subfamilies

### [[L² + (L − 1)², 1, L]] 2D Surface Code

The `2D` surface code is constructed using the hypergraph product of two
repetition codes.Thus, we obtain a new `3`-term chain complex:

```math
\\begin{aligned}
E_2 \\xrightarrow{\\partial_2^E} E_1 \\xrightarrow{\\partial_1^E} E_0
\\end{aligned}
```

#### Examples

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> D = 2; L = 2;

julia> c = DDimensionalSurface(D, L);

julia> code = parity_checks(c)
+ X_X_X
+ _X_XX
+ ZZ__Z
+ __ZZZ

julia> import HiGHS; import JuMP;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(5, 1, 2)
```

When `L = 4`, we get `[[25,1, 4]]` `2D` surface code from [Berthusen_2024](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> D = 2; L = 4;

julia> c = DDimensionalSurface(D, L);

julia> code = parity_checks(c)
+ X___X___________X________
+ _X___X__________XX_______
+ __X___X__________XX______
+ ___X___X__________X______
+ ____X___X__________X_____
+ _____X___X_________XX____
+ ______X___X_________XX___
+ _______X___X_________X___
+ ________X___X_________X__
+ _________X___X________XX_
+ __________X___X________XX
+ ___________X___X________X
+ ZZ______________Z________
+ _ZZ______________Z_______
+ __ZZ______________Z______
+ ____ZZ__________Z__Z_____
+ _____ZZ__________Z__Z____
+ ______ZZ__________Z__Z___
+ ________ZZ_________Z__Z__
+ _________ZZ_________Z__Z_
+ __________ZZ_________Z__Z
+ ____________ZZ________Z__
+ _____________ZZ________Z_
+ ______________ZZ________Z

julia> import HiGHS; import JuMP;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(25, 1, 4)
```

#### Chain Complex

The construction is as follows:

```math
\\begin{aligned}
C = \\left( C_1 \\xrightarrow{\\partial} C_0 \\right) \\quad \\text{and} \\quad D = \\left( D_1 \\xrightarrow{\\partial^T} D_0 \\right)
\\end{aligned}
```

where ``\\partial`` is the ``(L-1) \\times L`` parity check matrix:

```math
\\begin{aligned}
H = \\begin{pmatrix}
1 & 1 & & \\\\
 & 1 & \\ddots & \\\\
 & & \\ddots & 1 \\\\
 & & & 1
\\end{pmatrix}
\\end{aligned}
```

### [[L³ + 2L(L − 1)², 1, min(L, L²)]] 3D Surface Code

The `3D` surface code is obtained by taking the hypergraph product of a `2D` surface code
with a repetition code. Thus, we obtain a new `4`-term chain complex:

```math
\\begin{aligned}
F_3 \\xrightarrow{\\partial_3^F} F_2 \\xrightarrow{\\partial_2^F} F_1 \\xrightarrow{\\partial_1^F} F_0
\\end{aligned}
```

#### Metachecks

- **Z-type** metachecks: ``M_Z^T = \\partial_3^F``

#### Example

Here is an example of `[[12, 1, 2]]` `3D` Surface code with `L = 2` from [Berthusen_2024](@cite).

```jldoctest threeDsurface
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> D = 3; L = 2;

julia> c = DDimensionalSurface(D, L);

julia> code = parity_checks(c)
+ XX__X_____X_
+ __XXX______X
+ _____XX__XX_
+ _______XXX_X
+ Z_Z_Z_______
+ _Z_ZZ_______
+ _____Z_Z_Z__
+ ______Z_ZZ__
+ Z____Z____Z_
+ _Z____Z___Z_
+ __Z____Z___Z
+ ___Z____Z__Z
+ ____Z____ZZZ

julia> code_n(c), code_k(c)
(12, 1)
```

!!! note
    For the `3D` surface code, there is an asymmetry between the `Z`- and `X`-bases [Berthusen_2024](@cite).
    Specifically, the `Z`-distance (``d_Z``) is `4`, whereas the `X`-distance (``d_X``) is `2`. As a result,
    the code has the parameters `[[12, 1, 2]]`.

```jldoctest threeDsurface
julia> import HiGHS; import JuMP;

julia> dz = distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:Z))
4

julia> dx = distance(c, DistanceMIPAlgorithm(solver=HiGHS, logical_operator_type=:X))
2
```

### [[6L⁴ − 12L³ + 10L² − 4L + 1, 1, L²]] 4D Surface Code

The `4D` surface code is constructed by taking the hypergraph product of a
`3D` surface code with a repetition code.  Thus, we obtain a new `5`-term chain complex:

```math
\\begin{aligned}
G_4 \\xrightarrow{\\partial_4^G} G_3 \\xrightarrow{\\partial_3^G} G_2 \\xrightarrow{\\partial_2^G} G_1 \\xrightarrow{\\partial_1^G} G_0
\\end{aligned}
```

#### [[33, 1, 4]]

Here is an example of `[[33, 1, 4]]` `4D` Surface code with `L = 2` from [Berthusen_2024](@cite).

```jldoctest
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> D = 4; L = 2;

julia> c = DDimensionalSurface(D, L);

julia> import HiGHS; import JuMP;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(33, 1, 4)
```

#### Metachecks

Both X and Z-type metachecks available:
- ``M_Z^T = \\partial_4^G``
- ``M_X = \\partial_1^G``

To obtain surface codes of greater dimensionality, we alternate between `C` and `D` and then form a
product with the chain complex representing the `DDimensionalSurface` [Berthusen_2024](@cite).

!!! note
    The procedure described above for the `DDimensionalSurface` can alternatively be performed
    using an `L × L` repetition code and only the chain complex `C`. In this case, the result would
    be the `DDimensionalToric`.

See also: [`DDimensionalToric`](@ref)

### Fields
    $TYPEDFIELDS
"""
struct DDimensionalSurface <: DDimensionalCode
    """Dimension of the Surface code (must be ≥ 2)."""
    D::Int
    """Size parameter determining the `D`-dimensional Surface code family, constructed via hypergraph product of
    `(L - 1) × L` repetition code chain complexes."""
    L::Int

    function DDimensionalSurface(D::Int, L::Int)
        D ≥ 2 || throw(ArgumentError(lazy"Dimension of the Surface code must be at least 2 (got D=$D)."))
        new(D, L)
    end
end

function _total_complex_surface(c::DDimensionalSurface)
    D, L = c.D, c.L
    C = _repcode_chain_complex(L)
    D_chain = _dual_repcode_chain_complex(L)
    current = C
    sequence = [C]
    for dim in 2:D
        next_complex = if dim == 2
            D_chain
        elseif dim == 3
            D_chain
        else
            dim % 2 == 0 ? C : D_chain
        end
        current = tensor_product(current, next_complex)
        current = total_complex(current)
        push!(sequence, current)
    end
    return current
end

function _boundary_maps_surface(c::DDimensionalSurface)
    current = _total_complex_surface(c)
    boundary_maps = Vector{Matrix{Int}}()
    for d in 1:c.D
        ϕ = map(current, d)
        push!(boundary_maps, matrix_to_int(matrix(ϕ)))
    end
    return boundary_maps
end

function _parity_matrix_xz_surface(c::DDimensionalSurface)
    # 2D codes: Oscar returns pcm hx', so we transpose it to convert it back to hx. # See page 11, B2 for reference.
    # 3D and beyond codes: Oscar returns pcm hz', so we transpose it to convert it back to hz. See page 11, 12 - B3, B4, B6, and B7 for reference.
    b = _boundary_maps_surface(c)
    c.D == 2 ? (b[1]', b[2]) : (b[3], b[2]')
end

parity_matrix_xz(c::DDimensionalSurface) = _parity_matrix_xz_surface(c)

"""
    $TYPEDEF

## D-dimensional Toric Code ([Berthusen_2024](@cite), [Zeng_2019](@cite))

The `D`-dimensional toric code is obtained by taking the **iterated tensor product** of a single chain complex:

```math
\\begin{aligned}
C = \\left( \\mathbb{F}_2^L \\xrightarrow{H} \\mathbb{F}_2^L \\right)
\\end{aligned}
```

where `H` is the ``L \\times L`` parity check matrix of the repetition code. The total complex
is built by taking the tensor product ``C^{\\otimes D}`` and forming the associated total complex via direct sums.

!!! note
    D-dimensional toric code construction differs from the surface code as we
    use the full ``L \\times L`` repetition code (rather than ``(L-1) \\times L``). The
    tensor products with identical complexes (rather than alternating complexes) are used.

## Subfamilies

### [[2L², 2, L]] 2D Toric Code

```jldoctest twoDtoric
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> D = 2; L = 2;

julia> c = DDimensionalToric(D, L);

julia> code = parity_checks(c)
+ X_X_XX__
+ _X_XXX__
+ X_X___XX
+ _X_X__XX
+ ZZ__Z_Z_
+ ZZ___Z_Z
+ __ZZZ_Z_
+ __ZZ_Z_Z

julia> import HiGHS; import JuMP;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(8, 2, 2)
```

### [[3L³, 3, min(L, L²)]] 3D Toric Code

```jldoctest threeDtoric
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> D = 3; L = 2;

julia> c = DDimensionalToric(D, L);

julia> import HiGHS; import JuMP;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(24, 3, 2)
```

### [[6L⁴, 6, L²]] 4D Toric Code

```jldoctest fourDtoric
julia> using Oscar; using QuantumClifford; using QuantumClifford.ECC;

julia> D = 4; L = 2;

julia> c = DDimensionalToric(D, L);

julia> import HiGHS; import JuMP;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(96, 6, 4)
```

See also: [`DDimensionalSurface`](@ref)

### Fields
    $TYPEDFIELDS
"""
struct DDimensionalToric <: DDimensionalCode
    """Dimension of the Toric code (must be ≥ 2)."""
    D::Int
    """Size parameter determining the `D`-dimensional Toric code family, constructed via hypergraph product of
    `L × L` repetition code chain complexes."""
    L::Int

    function DDimensionalToric(D::Int, L::Int)
        D ≥ 2 || throw(ArgumentError(lazy"Dimension of the Toric code must be at least 2 (got D=$D)."))
        new(D, L)
    end
end

function _total_complex_toric(c::DDimensionalToric)
    D, L = c.D, c.L
    # we use the full repetition code chain complex
    C = _repcode_chain_complex_full(L)
    current = C
    for _ in 2:D
        current = tensor_product(current, C)
        current = total_complex(current)
    end
    return current
end

function _boundary_maps_toric(c::DDimensionalToric)
    current = _total_complex_toric(c)
    boundary_maps = Vector{Matrix{Int}}()
    for d in 1:c.D
        ϕ = map(current, d)
        push!(boundary_maps, matrix_to_int(matrix(ϕ)))
    end
    return boundary_maps
end

function _parity_matrix_xz_toric(c::DDimensionalToric)
    # 2D codes: Oscar returns pcm hx', so we transpose it to convert it back to hx. # See page 11, B2 for reference.
    # 3D and beyond codes: Oscar returns pcm hz', so we transpose it to convert it back to hz. See page 11, 12 - B3, B4, B6, and B7 for reference.
    b = _boundary_maps_toric(c)
    c.D == 2 ? (b[1]', b[2]) : (b[3], b[2]')
end

parity_matrix_xz(c::DDimensionalToric) = _parity_matrix_xz_toric(c)

parity_matrix_x(c::DDimensionalCode) = parity_matrix_xz(c)[1]

parity_matrix_z(c::DDimensionalCode) = parity_matrix_xz(c)[2]

function _chain_dimensions(C::ComplexOfMorphisms)
    rng = range(C)
    [dim(C[i]) for i in rng]
end

function code_n(c::DDimensionalCode)
    current = isa(c, DDimensionalToric) ? _total_complex_toric(c) : _total_complex_surface(c)
    # dimensions of all chain spaces
    dims = _chain_dimensions(current)
    # [Berthusen_2024](@cite) specifies different selection rules based on dimension, at least up to 4D.
    D = c.D
    if D == 2
        # 2D: sum E₁ total complex dimensions
        return dims[2] # (see A11, page 9): For DDimensionalSurface L² + (L-1)² [Berthusen_2024](@cite)
    elseif D == 3
        # 3D: sum F₁ total complex dimensions
        # F₁ = E₀ ⊗ D₁ ⊕ E₁ ⊗ D₀
        return dims[2] # (see A21, page 10): For DDimensionalSurface L³ + 2L(L − 1)² [Berthusen_2024](@cite)
    elseif D == 4
        # 4D: sum G² total complex dimensions
        # G² = F₁ ⊗ C₁ ⊕ F₂ ⊗ C₀
        return dims[3] # (see A28, page 11): For DDimensionalSurface 6L⁴ − 12L³ + 10L² − 4L + 1 [Berthusen_2024](@cite)
    else
        # TODO Investigate and derive expressions for dimension > 4?
        throw(ErrorException("""
            code_n is only implemented for 2D, 3D, and 4D codes [Berthusen_2024](@cite).
            Received: $D-dimensional code. The current literature does not provide closed-form
            formulas for D > 4. Higher-dimensional codes require further investigation to derive
            generalized formulas."""))
    end
end

function code_k(c::DDimensionalCode)
    # [Berthusen_2024](@cite) uses the following left-to-right notation:
    #   D=2: E₂ → E₁ → E₀                  (qubits in E₁, compute dim H₁(E))
    #   D=3: F₃ → F₂ → F₁ → F₀       (A16) (qubits in F₁, compute dim H₁(F))
    #   D=4: G₄ → G₃ → G₂ → G₁ → G₀  (A23) (qubits in G₂, compute dim H₂(G))
    # Oscar represents the same chain complex with right-to-left notation:
    #   D=2: current_0 ← current_1 ← current_2
    #   D=3: current_0 ← current_1 ← current_2 ← current_3
    #   D=4: current_0 ← current_1 ← current_2 ← current_3 ← current_4
    current = isa(c, DDimensionalToric) ? _total_complex_toric(c) : _total_complex_surface(c)
    i = c.D == 2 ? 1 : 2 # For codes with D ≥ 3: Hx is boundary_maps(c)[3], boundary_maps(c)[2] is Hz'.
    # TODO Does this hold for dimension > 4?
    ∂ᵢ = map(current, i)
    ∂ᵢ₊₁ = map(current, i+1)
    ker_∂ᵢ = kernel(∂ᵢ)[1]
    im_∂ᵢ₊₁ = image(∂ᵢ₊₁)[1]
    dim_ker = dim(ker_∂ᵢ)
    dim_im = dim(im_∂ᵢ₊₁)
    # number of logical qubits == dim ker ∂ᵢ - dim im ∂ᵢ₊₁
    k = dim_ker - dim_im
    return k
end

function metacheck_matrix_x(c::DDimensionalCode)
    c.D ≥ 4 || throw(ArgumentError("`X`-metachecks (`Mx`) require `D ≥ 4` (D=$(c.D))"))
    return Matrix(boundary_maps(c)[4]) # Mx
end

function metacheck_matrix_z(c::DDimensionalCode)
    c.D ≥ 3 || throw(ArgumentError("`Z`-metachecks (`Mz`) require `D ≥ 3` (D=$(c.D))"))
    return Matrix(boundary_maps(c)[1]') # Mz
end

hasmetachecks(c::DDimensionalCode) = c.D >= 4 ? (true, true) : c.D == 3 ? (false, true) : (false, false)
"""
$TYPEDEF

Returns all boundary maps of the chain complex, including both *parity check*
and *metacheck* matrices.

Here are the boundary maps of `[[12, 1, 2]]` `3D` Surface code with
`L = 2` from [Berthusen_2024](@cite).

```jldoctest boundarymaps
julia> using Oscar; using QuantumClifford; using QECCore;

julia> using QuantumClifford.ECC: DDimensionalSurface, boundary_maps, metacheck_matrix_z;

julia> D = 3; L = 2;

julia> c = DDimensionalSurface(D, L);

julia> Mz, Hz, Hx = boundary_maps(c);
```

The parity check matrices of `[[12, 1, 2]]` `3D` Surface code are

```jldoctest boundarymaps
julia> Hx
4×12 Matrix{Int64}:
 1  1  0  0  1  0  0  0  0  0  1  0
 0  0  1  1  1  0  0  0  0  0  0  1
 0  0  0  0  0  1  1  0  0  1  1  0
 0  0  0  0  0  0  0  1  1  1  0  1
```

!!! note
    For `3D` and higher-dimensional codes, `Oscar` returns `Z`-type parity check
    matrix as transpose (``H_Z^T``). We transpose it to convert it back to ``H_Z``.
    See `B3`, page `11` of [Berthusen_2024](@cite).

```jldoctest boundarymaps
julia> Hz'
9×12 adjoint(::Matrix{Int64}) with eltype Int64:
 1  0  1  0  1  0  0  0  0  0  0  0
 0  1  0  1  1  0  0  0  0  0  0  0
 0  0  0  0  0  1  0  1  0  1  0  0
 0  0  0  0  0  0  1  0  1  1  0  0
 1  0  0  0  0  1  0  0  0  0  1  0
 0  1  0  0  0  0  1  0  0  0  1  0
 0  0  1  0  0  0  0  1  0  0  0  1
 0  0  0  1  0  0  0  0  1  0  0  1
 0  0  0  0  1  0  0  0  0  1  1  1
```

Along with the `Z`- and `X`-type parity check matrices, we have a metacheck matrix
specifically for the `Z`-type checks. The classical code derived from this metacheck
matrix has a distance of `d = 2` meaning it can identify (but not correct) a single error
in the `Z`-type syndrome measurements. See page `12` of [Berthusen_2024](@cite) for details.

```jldoctest boundarymaps
julia> Mz'
2×9 adjoint(::Matrix{Int64}) with eltype Int64:
 1  0  1  0  1  0  1  0  1
 0  1  0  1  0  1  0  1  1
```

We can use `metacheck_matrix_z` directly instead of using `boundary_maps`.

```jldoctest boundarymaps
julia> metacheck_matrix_z(c)
2×9 Matrix{Int64}:
 1  0  1  0  1  0  1  0  1
 0  1  0  1  0  1  0  1  1
```

# Metachecks in CSS Codes

The parity-check matrices ``M_Z`` and ``M_X`` are called *metachecks* in CSS
codes. These matrices emerge from the constraints imposed by boundary maps, which
satisfy the condition ``\\partial_{i+1} \\partial_i = 0``. This guarantees that:

```math
\\begin{aligned}
M_Z H_Z = 0 \\quad \\text{and} \\quad M_X H_X = 0,
\\end{aligned}
```

meaning that:

- Valid ``Z``-type syndromes must be in ``\\ker M_Z``
- Valid ``X``-type syndromes must be in ``\\ker M_X``

When measurement errors occur, they distort the syndrome vector ``\\mathbf{s}``,
generating a detectable *metasyndrome*. By examining ``\\mathbf{m}``, we can identify
and correct errors in ``\\mathbf{s}`` before proceeding with standard decoding. This
technique is called *syndrome repair decoding* [Higgott_2023](@cite).
"""
boundary_maps(c::DDimensionalSurface) = _boundary_maps_surface(c)

boundary_maps(c::DDimensionalToric) = _boundary_maps_toric(c)

function _precompile_()
    ds = random_destabilizer(3);
    s = random_stabilizer(3);
    canonicalize!(s);
    canonicalize_rref!(s);
    canonicalize_gott!(s);
    canonicalize!(s,phases=false)
    canonicalize_gott!(s,phases=false)
    canonicalize_rref!(s,phases=false)
    c = random_clifford(3)
    apply!(s, c);
    apply!(s, [1,2], tCNOT);
    apply!(s, sCNOT(1,2));
    project!(s, P"XXX");
    s = S"XX
          ZZ"
    md = MixedDestabilizer(s)
    p = P"XX"
    c = C"X_
          _X
          Z_
          _Z"
    p*md
    c*md
    apply!(md,p,phases=false)
    apply!(md,c,phases=false)
    random_clifford(3)
    random_pauli(3)
    for op in [ sHadamard
                sId1
                sInvPhase
                sPhase
                sX
                sY
                sZ
            ]#subtypes(QuantumClifford.AbstractSingleQubitOperator)
        op(2)*s
    end
    for op in [ sCNOT
                sSWAP
                sCPHASE
            ]#subtypes(QuantumClifford.AbstractTwoQubitOperator)
        op(2,1)*s
    end
    project!(s, p)
    project!(md,p)
end

using PrecompileTools

# precompilation causes allocation performance bugs for <v1.8 https://github.com/JuliaLang/julia/issues/35972
VERSION > v"1.8" && @setup_workload begin
    # Putting some things in `setup` can reduce the size of the
    # precompile file and potentially make loading faster.
    @compile_workload begin
        # all calls in this block will be precompiled, regardless of whether
        # they belong to your package or not (on Julia 1.8 and higher)
        _precompile_()
    end
end

using CUDA
using LinearAlgebra
using QuantumClifford  
function swap_columns_kernel!(d_mat::CuDeviceArray{T,2}, 
                             d_phases::CuDeviceArray{P,1}, 
                             col1::Integer, col2::Integer, N::Integer,
                             update_phases::Bool) where {T, P}
    idx = (blockIdx().x - 1) * blockDim().x + threadIdx().x
    if idx <= N
        temp = d_mat[idx, col1]
        d_mat[idx, col1] = d_mat[idx, col2]
        d_mat[idx, col2] = temp
    end
    if update_phases && idx == 1
        temp_phase = d_phases[col1]
        d_phases[col1] = d_phases[col2]
        d_phases[col2] = temp_phase
    end
    return
end

function gpu_swap_columns!(d_mat::CuArray{T,2}, d_phases::CuVector{P}, 
                          col1::Integer, col2::Integer, update_phases::Bool) where {T, P}
    N = size(d_mat, 1)
    threads = 256
    blocks = cld(N, threads)
    @cuda threads=threads blocks=blocks swap_columns_kernel!(
        d_mat, d_phases, col1, col2, N, update_phases)
    return
end

function pivot_search_kernel!(d_mat::CuDeviceArray{T,2}, pivot_row::Integer, bit::T, 
                             current_col::Integer, r::Integer, d_result) where {T}
    idx = (blockIdx().x - 1) * blockDim().x + threadIdx().x + current_col - 1
    
    if idx <= r
        if (d_mat[pivot_row, idx] & bit) != T(0)
            CUDA.atomic_min!(pointer(d_result), idx)
        end
    end
    return
end

function gpu_pivot_search!(d_mat::CuArray{T,2}, pivot_row::Integer, bit::T, 
                          current_col::Integer, r::Integer)::Int where {T}
    n_cols = r - current_col + 1
    if n_cols <= 0
        return 0
    end
    d_result = CUDA.fill(r + 1, 1)
    threads = min(256, n_cols)
    blocks = cld(n_cols, threads)
    @cuda threads=threads blocks=blocks pivot_search_kernel!(
        d_mat, pivot_row, bit, current_col, r, d_result)
    result = Array(d_result)[1]
    return result > r ? 0 : Int(result)
end

function update_kernel!(d_mat::CuDeviceArray{T,2}, d_phases::CuDeviceArray{P,1},
                       current_col::Integer, pivot_row::Integer, bit::T,
                       r::Integer, total_blocks::Integer, nblocks::Integer, 
                       update_phase::Bool) where {T, P}
    s_pivot = CuDynamicSharedArray(T, total_blocks)
    tid = threadIdx().x
    for idx in tid:blockDim().x:total_blocks
        s_pivot[idx] = d_mat[idx, current_col]
    end
    sync_threads()
    m = (blockIdx().x - 1) * blockDim().x + threadIdx().x
    if m <= r && m != current_col
        if (d_mat[pivot_row, m] & bit) != T(0)
            cnt1 = T(0)
            cnt2 = T(0)
            @inbounds for i in 1:nblocks
                x1 = s_pivot[i]
                z1 = s_pivot[nblocks + i]
                x2 = d_mat[i, m]
                z2 = d_mat[nblocks + i, m]
                newx = x1 ⊻ x2
                newz = z1 ⊻ z2
                x1z2 = x1 & z2
                anti = (x2 & z1) ⊻ x1z2
                inner = (cnt1 ⊻ newx) ⊻ newz ⊻ x1z2
                cnt2 = cnt2 ⊻ (inner & anti)
                cnt1 = cnt1 ⊻ anti
            end
            rcnt1 = count_ones(cnt1)
            rcnt2 = count_ones(cnt2)
            rcnt2_shifted = rcnt2 << 1
            extra_phase_val = rcnt1 ⊻ rcnt2_shifted
            extra_phase = P(extra_phase_val & 0x3)
            @inbounds for b in 1:total_blocks
                d_mat[b, m] = d_mat[b, m] ⊻ s_pivot[b]
            end
            if update_phase
                d_phases[m] = (d_phases[m] + d_phases[current_col] + extra_phase) & P(0x3)
            end
        end
    end
    return
end

function gpu_update_kernel!(d_mat::CuArray{T,2}, d_phases::CuVector{P},
                           current_col::Integer, pivot_row::Integer, bit::T,
                           r::Integer, total_blocks::Integer, nblocks::Integer, 
                           update_phase::Bool) where {T, P}
    threads = 256
    blocks = cld(r, threads)
    shmem_size = sizeof(T) * total_blocks
    @cuda threads=threads blocks=blocks shmem=shmem_size update_kernel!(
        d_mat, d_phases, current_col, pivot_row, bit, r,
        total_blocks, nblocks, update_phase)
    return
end

function gpu_canonicalize!(tableau::QuantumClifford.Tableau{<:CuArray{P}, <:CuArray{T}}, phases::Bool) where {T, P}
    d_mat = tableau.xzs
    d_phases = tableau.phases
    nqubits = tableau.nqubits
    r = size(d_mat, 2)    
    nblocks = size(d_mat, 1) ÷ 2
    total_blk = 2 * nblocks
    bits_per_chunk = count_zeros(zero(T))
    current_col = 1
    for j in 1:nqubits
        pivot_row = (j - 1) ÷ bits_per_chunk + 1
        bit = T(1) << ((j - 1) % bits_per_chunk)
        pivot = gpu_pivot_search!(d_mat, pivot_row, bit, current_col, r)
        if pivot == 0
            continue
        end
        if pivot != current_col
            gpu_swap_columns!(d_mat, d_phases, pivot, current_col, phases)
        end
        gpu_update_kernel!(d_mat, d_phases, current_col, pivot_row, bit,
                          r, total_blk, nblocks, phases)
        current_col += 1
        if current_col > r
            break
        end
    end    
    for j in 1:nqubits
        pivot_row = nblocks + (j - 1) ÷ bits_per_chunk + 1
        bit = T(1) << ((j - 1) % bits_per_chunk)
        pivot = gpu_pivot_search!(d_mat, pivot_row, bit, current_col, r)
        if pivot == 0
            continue
        end
        if pivot != current_col
            gpu_swap_columns!(d_mat, d_phases, pivot, current_col, phases)
        end
        gpu_update_kernel!(d_mat, d_phases, current_col, pivot_row, bit,
                          r, total_blk, nblocks, phases)
        current_col += 1
        if current_col > r
            break
        end
    end
    return tableau
end

function canonicalize!(stab::Stabilizer{<:QuantumClifford.Tableau{<:CuArray{P}, <:CuArray{T}}}; phases::Bool=true) where {T, P}
    gpu_canonicalize!(tab(stab), phases)
    CUDA.synchronize()
    return stab
end

@testitem "Alternative bit packing" tags=[:bitpack] begin
    using Random
    using QuantumClifford: Tableau, mul_left!

    @testset "alternative bit packing" begin
        for n in [1,3] # can not go higher than 4 (limitation from SIMD acting on transposed/strided arrays)
            N = 64*n-2
            s64 = random_stabilizer(N,N);
            _phases = phases(s64);
            xzs64 = tab(s64).xzs;
            xzs64T = collect(xzs64')';
            p64 = random_pauli(N;nophase=true);
            c64_stab = tab(random_destabilizer(N;phases=false));

            _after_p = p64*s64
            after_p = stab_to_gf2(_after_p);
            after_p_phases = phases(_after_p);
            after_can = stab_to_gf2(canonicalize!(copy(s64)));
            _after_clif = apply!(copy(s64),CliffordOperator(c64_stab));
            after_cliff = stab_to_gf2(_after_clif);
            after_cliff_phases = phases(_after_clif);

            after_mul = stab_to_gf2(mul_left!(copy(s64), p64))

            for int in [UInt8, UInt16, UInt32, UInt64]
                p = PauliOperator(p64.phase, N, collect(reinterpret(int,p64.xz)));
                xzs = collect(reinterpret(int, collect(xzs64)));
                xzsT = collect(xzs')';
                _s = Stabilizer(_phases,N,xzs);
                _sT = Stabilizer(_phases,N,xzsT);

                for trans in (true, false)
                    s = trans ? _sT : _s
                    apply_pauli = p*s
                    @test after_p_phases == phases(apply_pauli)
                    canon = canonicalize!(deepcopy(s))
                    @test after_can == stab_to_gf2(canon)

                    cxzs = collect(reinterpret(int, collect(c64_stab.xzs)));
                    cxzsT = collect(cxzs')';
                    _c = CliffordOperator(Tableau(zeros(UInt8,2N),N,cxzs));
                    _cT = CliffordOperator(Tableau(zeros(UInt8,2N),N,cxzsT));

                    for ctrans in (true, false)
                        c = ctrans ? _c : _cT
                        after_clifford = apply!(deepcopy(s),c)
                        @test after_cliff == stab_to_gf2(after_clifford)
                        @test after_cliff_phases == phases(after_clifford)
                    end

                    @test after_mul == stab_to_gf2(mul_left!(copy(s), p))
                end
            end
        end
    end

    @testset "fast column and fast row mul_left correctness" begin
        reinterpret_stab(s) = Stabilizer(Tableau(copy(phases(s)), nqubits(s), collect(reinterpret(UInt8, collect(s.tab.xzs)))))
        reinterpret_p(p) = PauliOperator(p.phase, nqubits(p), collect(reinterpret(UInt8, p.xz)))
        for N in [7,8,9,63,64,65]

            s0 = random_stabilizer(2,N)
            p = random_pauli(N)
            s = copy(s0)
            sr = QuantumClifford.fastrow(copy(s))
            sc = QuantumClifford.fastcolumn(copy(s))

            mul_left!(s, p)
            mul_left!(sr, p)
            mul_left!(sc, p)

            s8 = reinterpret_stab(copy(s0))
            s8r = QuantumClifford.fastrow(copy(s8))
            s8c = QuantumClifford.fastcolumn(copy(s8))
            p8 = reinterpret_p(copy(p))
            mul_left!(s8, p8)
            mul_left!(s8r, p8)
            mul_left!(s8c, p8)

            @test stab_to_gf2(s) == stab_to_gf2(sr) == stab_to_gf2(sc) == stab_to_gf2(s8) == stab_to_gf2(s8r) == stab_to_gf2(s8c)
        end
    end
end

abstract type AbstractNoise end

abstract type AbstractNoiseOp <: AbstractOperation end

"""A method modifying a given state by applying the corresponding noise model. It is non-deterministic, part of the Noise interface."""
function applynoise! end

function applynoise!(state, noise, indices::Base.AbstractVecOrTuple)
    @inbounds @simd for i in indices
        @inline applynoise!(state, noise, i)
    end
    return state
end

# Implementations for Register
function applynoise!(r::Register, n, i::Int)
    applynoise!(quantumstate(r), n, i)
    return r
end
function applynoise!(r::Register, n, indices::Base.AbstractVecOrTuple)
    applynoise!(quantumstate(r), n, indices)
    return r
end

"""Depolarization noise model with total probability of error `p`."""
struct UnbiasedUncorrelatedNoise{T} <: AbstractNoise
    p::T
end
UnbiasedUncorrelatedNoise(p::Integer) = UnbiasedUncorrelatedNoise(float(p))

"""
Depolarization noise model with depolarization probability `p`.

On `n` qubits this applies the channel
`E(rho) = (1-p)rho + p/4^n * sum(P*rho*P)` (where the sum is over all `n`-qubit Pauli operators P, including the identity),
which is equivalent to `E(rho) = (1-p)rho + p/2^n * Id`, where the second term corresponds to a complete mixed state.

With this parameterization,
the total probability of error is `p * (1 - 1/4^n)`,
because the sum over Paulis includes a `1/4^n` chance of sampling the identity.

For the common two-qubit error-probability parameterization, use
`DepolarizationNoise(; two_qubit_error_probability=e)`. This constructs the equivalent
depolarization probability so that the identity occurs with probability `1-e`
and each of the 15 non-identity two-qubit Pauli errors occurs with probability
`e/15`. Be careful if you use this constructor, as it will use the same computed
depolarization probability for all noise operations (two-qubit or not).
"""
struct DepolarizationNoise{T} <: AbstractNoise
    p::T
end
DepolarizationNoise(p::Integer) = DepolarizationNoise(float(p))
DepolarizationNoise(; two_qubit_error_probability) = DepolarizationNoise(two_qubit_error_probability * 16 / 15)

"""Pauli noise model with probabilities `px`, `py`, and `pz` respectively for the three types of Pauli errors."""
struct PauliNoise{T} <: AbstractNoise
    px::T
    py::T
    pz::T
end

function PauliNoise(px::Real, py::Real, pz::Real)
    px, py, pz = float.((px, py, pz))
    px, py, pz = promote(px, py, pz)
    T = typeof(px)
    return PauliNoise{T}(px, py, pz)
end

"""Constructs an unbiased Pauli noise model with total probability of error `p`."""
function PauliNoise(p)
    UnbiasedUncorrelatedNoise(p)
end

function applynoise!(s::AbstractStabilizer,noise::UnbiasedUncorrelatedNoise,i::Int)
    infid = noise.p/3
    r = rand()
    if r<infid
        apply_single_x!(s,i)
    elseif r<2infid
        apply_single_z!(s,i)
    elseif r<3infid
        apply_single_y!(s,i)
    end
    s
end

function applynoise!(s::AbstractStabilizer,noise::PauliNoise,i::Int)
    r = rand()
    if r<noise.px
        apply_single_x!(s,i)
    elseif r<noise.px+noise.pz
        apply_single_z!(s,i)
    elseif r<noise.px+noise.pz+noise.py
        apply_single_y!(s,i)
    end
    s
end

@inline function _apply_pauli_digit!(s::AbstractStabilizer, q::Int, digit::Int)
    if digit == 0
        return s
    elseif digit == 1
        apply_single_x!(s, q)
    elseif digit == 2
        apply_single_z!(s, q)
    elseif digit == 3
        apply_single_y!(s, q)
    #else # to make it easy for the compiler to figure out that this will not throw in actual use
    #    throw(ArgumentError("invalid Pauli digit $digit"))
    end
    return s
end

function _apply_depolarization_pauli!(s::AbstractStabilizer, indices::Base.AbstractVecOrTuple, pauli_idx::Int)
    for i in indices
        pauli_idx, digit = divrem(pauli_idx, 4)
        _apply_pauli_digit!(s, i, digit)
    end
    return s
end

function applynoise!(s::AbstractStabilizer, noise::DepolarizationNoise, indices::Base.AbstractVecOrTuple)
    if rand() >= noise.p
        return s
    end

    pauli_idx = rand(0:4^(length(indices))-1)
    return _apply_depolarization_pauli!(s, indices, pauli_idx)
end

applynoise!(s::AbstractStabilizer, noise::DepolarizationNoise, i::Int) = applynoise!(s, noise, (i,))
applynoise!(s::AbstractStabilizer, noise::DepolarizationNoise, i::Int, j::Int) = applynoise!(s, noise, (i, j))

"""An operator that applies the given `noise` model to the qubits at the selected `indices`."""
struct NoiseOp{N, Q} <: AbstractNoiseOp where {N, Q}
    noise::N #<:AbstractNoise
    indices::NTuple{Q, Int}
end

NoiseOp(noise, indices::AbstractVector{Int}) = NoiseOp(noise, tuple(indices...))

"""A convenient constructor for various types of Pauli errors,
that can be used as circuit gates in simulations.
Returns more specific types when necessary."""
function PauliError end

""""Construct a gate operation that applies an unbiased Pauli error on qubit `q` with probability `p`."""
function PauliError(q::Int,p)
    NoiseOp(PauliNoise(p), [q])
end

""""Construct a gate operation that applies an unbiased Pauli error on all `qubits`, each with independent probability `p`."""
function PauliError(qubits,p)
    NoiseOp(PauliNoise(p), qubits)
end

""""Construct a gate operation that applies a biased Pauli error on  qubit `q` with independent probabilities `px`, `py`, `pz`.
Note that the probability of any error occurring is `px+py+pz`. Because of this, `PauliError(1, p)` is equivalent to `PauliError(1,p/3,p/3,p/3)`.
Similarly, if one wanted to exclude Z errors from `PauliError(1,p/3,p/3,p/3)` while maintaining the same rate of X errors, one could write
`PauliError(1, p*2/3, 0, 0)` (in the sense that Y errors can be interpreted as an X and a Z happening at the same time)."""
function PauliError(q::Int, px, py, pz)
    NoiseOp(PauliNoise(px,py,pz), (q,))
end

""""Construct a gate operation that applies a biased Pauli error on all `qubits` independently, each with  probabilities `px`, `py`, `pz`.
Note that the probability of any error occurring is `px+py+pz`. Because of this, `PauliError(1, p)` is equivalent to `PauliError(1,p/3,p/3,p/3)`.
Similarly, if one wanted to exclude Z errors from `PauliError(1,p/3,p/3,p/3)` while maintaining the same rate of X errors, one could write
`PauliError(1, p*2/3, 0, 0)` (in the sense that Y errors can be interpreted as an X and a Z happening at the same time)."""
function PauliError(qubits, px, py, pz)
    NoiseOp(PauliNoise(px,py,pz), qubits)
end

"""An operator that applies the given `noise` model to all qubits."""
struct NoiseOpAll <: AbstractNoiseOp
    noise::AbstractNoise
end

"""A gate consisting of the given `noise` applied after the given perfect Clifford `gate`."""
struct NoisyGate <: AbstractNoiseOp
    gate::AbstractOperation
    noise::AbstractNoise
end

function apply!(s::AbstractQCState, g::NoisyGate)
    s = applynoise!(
            apply!(s,g.gate),
            g.noise,
            affectedqubits(g.gate)),
    return s
end

function apply!(s::AbstractQCState, mr::NoiseOpAll)
    n = nqubits(s)
    return applynoise!(s, mr.noise, 1:n)
end

function apply!(s::AbstractQCState, mr::NoiseOp)
    return applynoise!(s, mr.noise, affectedqubits(mr))
end

# XXX necessary to resolve ambiguity between apply!(s::AbstractQCState, mr::Noise) and apply!(r::Register, op)
# TODO resolve them in a neater fashion with less repetition
function apply!(r::Register, n::NoisyGate)
    apply!(quantumstate(r), n)
    return r
end
function apply!(r::Register, n::NoiseOpAll)
    apply!(quantumstate(r), n)
    return r
end
function apply!(r::Register, n::NoiseOp)
    apply!(quantumstate(r), n)
    return r
end

##
# petrajectories
##

function applynoise_branches(s::AbstractStabilizer,noise::UnbiasedUncorrelatedNoise,indices; max_order=1)
    n = nqubits(s)
    l = length(indices)
    infid = noise.p/3
    if l==0
        return [s,one(infid)]
    end
    error1 = noise.p
    no_error1 = 1-error1
    no_error = no_error1^l
    results = [(copy(s),no_error,0)] # state, prob, order
    for order in 1:min(max_order,l)
        error_prob = no_error1^(l-order)*infid^order
        for error_indices in combinations(indices, order)
            _applynoise_branches_unbiased_uncorrelated(Val(order),s,error_indices,results,error_prob)
        end
    end
    results
end

function applynoise_branches(s::AbstractStabilizer, noise::DepolarizationNoise, indices::Base.AbstractVecOrTuple; max_order=1)
    n = length(indices)

    if n == 1
        return applynoise_branches(s, UnbiasedUncorrelatedNoise(3noise.p / 4), indices; max_order=max_order)
    end

    pauli_count = 4^n
    pauli_prob = noise.p / pauli_count

    results = [(copy(s), 1 - noise.p + pauli_prob, 0)]

    if max_order >= 1
        for pauli_idx in 1:pauli_count-1
            order = count(!iszero, digits(pauli_idx, base=4, pad=n))
            order <= max_order || continue
            new_state = copy(s)
            _apply_depolarization_pauli!(new_state, indices, pauli_idx)
            push!(results, (new_state, pauli_prob, order))
        end
    end

    return results
end

@generated function _applynoise_branches_unbiased_uncorrelated(::Val{order},s,error_indices,results,error_prob) where {order}
    error_calls = Expr(:block)
    for i in 1:order
        call = quote (apply_single_x!,apply_single_y!,apply_single_z!)[$(Symbol(:i_,i))](new_state,error_indices[$i]) end
        push!(error_calls.args, call)
    end
    # n nested loops, one for each affected qubit, each loop dedicated to the 3 possible errors (X, Y, or Z)
    quote
        @nloops $order i d->1:3 begin
            new_state = copy(s)
            $error_calls
            push!(results,(new_state, error_prob, order))
        end
        results
    end
end

function applybranches(s::AbstractQCState, nop::NoiseOpAll; max_order=1)
    n = nqubits(s)
    return [(state, continue_stat, prob, order) for (state, prob, order) in applynoise_branches(s, nop.noise, 1:n, max_order=max_order)]
end

function applybranches(s::AbstractQCState, nop::NoiseOp; max_order=1)
    return [(state, continue_stat, prob, order) for (state, prob, order) in applynoise_branches(s, nop.noise, affectedqubits(nop), max_order=max_order)]
end

function applybranches(s::AbstractQCState, g::NoisyGate; max_order=1)
    news, _,_,_ = applybranches(s,g.gate,max_order=max_order)[1] # TODO this assumes only one always successful branch for the gate
    return [(state, continue_stat, prob, order) for (state, prob, order) in applynoise_branches(news, g.noise, affectedqubits(g), max_order=max_order)]
end

@testitem "ROCm" tags = [:rocm] begin

    include("implementation/test_platform.jl")

    using AMDGPU: ROCArray, devices, synchronize
    const AT = ROCArray

    const can_run = length(devices()) > 0

    @testset "Device availability" begin
        @test can_run
    end

    if can_run
        test_platform(AT, synchronize)
    end

end

"""
Benchmark quantum_mallows from randoms.jl.
"""

using QuantumClifford: quantum_mallows_bigint, quantum_mallows_int, quantum_mallows_float
using BenchmarkTools
using DataFrames
using Gadfly; import Cairo, Fontconfig
using ProgressLogging
using Random: GLOBAL_RNG

## Run the benchmarks and save results

results = []
@progress for n in [2:2:30; 31:20:200; 200:50:500; 500:100:800][end:-1:1]
    println(n)
    bench = @benchmark quantum_mallows_bigint($GLOBAL_RNG, $n)
    push!(results, (;type=:bigint, trial=bench, n=n))
    n>=500 && continue
    bench = @benchmark quantum_mallows_float($GLOBAL_RNG, $n)
    push!(results, (;type=:float, trial=bench, n=n))
    n>=30 && continue
    bench = @benchmark quantum_mallows_int($GLOBAL_RNG, $n)
    push!(results, (;type=:int, trial=bench, n=n))
end

## Prepare the results in a data frame

DF = DataFrame(results)
for f in [:mean, :maximum, :minimum, :median]
    DF[!,f] .= (x->eval(f)(x).time).(DF[!,:trial])
end

## Collate all benchmarks

Gadfly.with_theme(style(highlight_width=0.1mm)) do
    p = Gadfly.plot(
        DF,
        color=:type,
        x=:n, y=:median,
        Scale.x_log10(),
        Scale.y_log10(),
        Guide.xlabel("Bits"),
        Guide.ylabel("Time (ns)"),
        Guide.colorkey(title="Int Type"),
    )
    img = PNG("bench_mallows.png", 20cm, 15cm, dpi=200)
    draw(img, p)
end

"""
    $TYPEDEF

The **La-cross** code is a quantum LDPC code constructed using the hypergraph product
of two classical seed LDPC codes. It is characterized by its parity check matrix `H`,
which is derived from **circulant** matrices with *specific* properties. These codes were
introduced in [pecorari2025high](@cite).

The La-cross code has two families, distinguished by their boundary conditions:

- **Periodic** boundary (`full_rank = false`):

```math
\\begin{aligned}
\\left[\\left[2n^2, 2k^2, d \\right]\\right]
\\end{aligned}
```

- **Open** boundary (`full_rank = true`): 

```math
\\begin{aligned}
\\left[\\left[(n - k)^2 + n^2, k^2, d \\right]\\right]
\\end{aligned}
```

!!! note
    When `H` is square and circulant (`full_rank=false`), classical checks connect opposite
    endpoints of the `length-n` classical code and give rise to a quantum code with stabilizers
    connecting opposite array boundaries, i.e. with **periodic boundary conditions**. On the
    contrary, **rectangular** parity-check matrices in ``\\mathbb{F}_2^{(n−k)×n}`` give rise to
    a quantum code with stabilizers stretching up to the array extent, i.e. with **open boundary
    conditions**.

# Cyclic Codes and Circulant Matrices

A **cyclic code** is a linear code in which codewords remain valid under cyclic
shifts. A **circulant matrix** is a square matrix where each row is a cyclic shift
of the first row. When the parity-check matrix `H` is circulant, the code is fully
determined by its first row:

```math
\\begin{aligned}
H = \\text{circ}(c_0, c_1, \\dots, c_k, 0, \\dots, 0) \\in \\mathbb{F}_2^{n \\times n}.
\\end{aligned}
```

The elements ``c_i`` (for ``i = 0, 1, \\dots, k``) correspond to the coefficients of
a ``degree-k`` polynomial:

```math
\\begin{aligned}
h(x) = 1 + \\sum_{i=1}^{k} c_i x^i \\in \\mathbb{F}_2[x]/(x^n - 1).
\\end{aligned}
```

This establishes a mapping between ``\\mathbb{F}_2^n`` and the quotient ring
``\\mathbb{F}_2[x]/(x^n - 1)``, where cyclic shifts in ``\\mathbb{F}_2^n`` correspond
to multiplications by `x` in the polynomial ring. Since multiplication by `x` preserves
the ideal structure of ``\\mathbb{F}_2[x]/(x^n - 1)``, cyclic codes correspond to
ideals in this ring. These ideals are in one-to-one correspondence with unitary ``mod-2``
divisors of ``x^n - 1`` with a leading coefficient of 1. Consequently, the fundamental
building blocks of cyclic codes correspond to the factorization of ``x^n - 1``.

!!! note
    For `k = 1`, the generator polynomial ``h(x) = 1 + x`` defines the **repetition code**.

# Polynomial Representation

The first row of a circulant matrix ``H = \\text{circ}(c_0, c_1, c_2, \\dots, c_{n-1})``
can be mapped to the coefficients of a polynomial ``h(x)``. For instance, if the first
row is ``[1, 1, 0, 1]``, the polynomial is: ``h(x) = 1 + x + x^3``. This polynomial-based
representation aids in the analysis and design of cyclic codes. For our implementation of
La-cross codes, we leverage `Hecke.polynomial_ring` to work directly with polynomial rings
rather than manipulating coefficient arrays explicitly.

!!! note
    The **next-to-next-to-nearest neighbor** connectivity implies the use of a *degree-3*
    seed polynomial ``h(x) = 1 + x + x^2 + x^3`` in the ring ``\\mathbb{F}_2[x]/(x^n - 1)`` for
    a specific code length `n`. Additionally, the condition of low stabilizer weight requires
    the polynomial ``1 + x + x^3``.

## [[2n², 2k², d]] La-cross Code

Here is `[[98, 18, 4]]` La-cross code from with ``h(x) = 1 + x + x^3``, `n = 7`,
and `k = 3` from Appendix A of [pecorari2025high](@cite).

```jldoctest lacrosseg
julia> using QuantumClifford; using QuantumClifford.ECC; # hide

julia> import Hecke: GF, polynomial_ring;

julia> n = 7; k = 3; F = GF(2);

julia> R, x = polynomial_ring(F, "x");

julia> h = 1 + x + x^k;

julia> c = LaCross(n, h, false);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(98, 18, 4)
```

## [[(n - k)² + n², k², d]] La-cross Code

Here is `[[65, 9, 4]]` La-cross code from with ``h(x) = 1 + x + x^3``, `n = 7`, `k = 3`
and full rank seed *rectangular* circulant matrix from Appendix A of [pecorari2025high](@cite).

```jldoctest lacrosseg
julia> c = LaCross(n, h, true);

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(65, 9, 4)
```

Here is `[[400, 16, 8]]` La-cross code from with ``h(x) = 1 + x + x^4``, `n = 16`, `k = 4`
from [pecorari2025high](@cite).

```jldoctest lacrosseg
julia> n = 16; k = 4;

julia> R, x = polynomial_ring(F, "x");

julia> h = 1 + x + x^k;

julia> full_rank = true;

julia> c = LaCross(n, h, full_rank);

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(400, 16, 8)
```

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/lacross).

### Fields
    $TYPEDFIELDS
"""
struct LaCross <: AbstractCSSCode
    """The block length of the classical seed code."""
    n::Int
    """The seed vector is represented with a degree-`n` polynomial of the form ``h(x) = \\sum_{i=0}^{n-1} c_i x^i``."""
    h::FqPolyRingElem
    """A flag indicating whether to use the full-rank rectangular matrix (`true`) or the original circulant matrix (`false`)."""
    full_rank::Bool
    function LaCross(n, h, full_rank)
        n <= 0 && throw(ArgumentError("Block length must be positive."))
        new(n, h, full_rank)
    end
end

function parity_matrix_xz(c::LaCross)
    F = GF(2)
    R = parent(c.h)
    x = gen(R)
    _, proj = residue_ring(R, R(x)^c.n-1)
    h = proj(c.h)
    lifted_h = lift(h)
    coeffs = Int[lift(ZZ, coeff(lifted_h, i)) for i in 0:c.n-1]
    H = zero_matrix(F, c.n, c.n)
    for i in 1:c.n
        for j in 1:c.n
            H[i, j] = coeffs[mod1(j-i+1, c.n)]
        end
    end
    H = [Int(lift(ZZ, H[i,j])) for i in 1:nrows(H), j in 1:ncols(H)]
    if c.full_rank == true
        k = degree(c.h)
        H = H[1:c.n-k, :]
        hx, hz = hgp(H,H)
        return hx, hz
    else
        hx, hz = hgp(H,H)
        return hx, hz
    end
end

parity_matrix_x(c::LaCross) = parity_matrix_xz(c)[1]

parity_matrix_z(c::LaCross) = parity_matrix_xz(c)[2]

code_k(c::LaCross) = c.full_rank ? degree(c.h)^2 : 2*degree(c.h)^2

code_n(c::LaCross) = c.full_rank ? (c.n-degree(c.h))^2+c.n^2 : 2*c.n^2

module PureNonClifford

using Random
using Statistics
using LinearAlgebra

import ..QuantumClifford:
    AbstractOperation, AbstractCliffordOperator, AbstractNonCliffordOperator,

    PauliOperator, Stabilizer, MixedDestabilizer,

    apply!, nqubits, stabilizerview, destabilizerview, rank,
    zero, comm,

    sHadamard, sPhase, sX, sCPHASE,

    CliffordOperator,

    isclifford,

    mctrajectory!,

    sT, sCCZ,

    measurements

using DocStringExtensions

export
    sT, sCCZ,
    PureGeneralizedStabilizer,
    EndMeasurementSampleResults,

    emtrajectories,

    isclifford


"""
$(SIGNATURES)

Return the stabilizer extent ξ(op) for a gate.
For Clifford gates, ξ = 1. Users can extend for custom non-Clifford gates.

The extent determines simulation cost: total cost scales as ∏ⱼ ξ(Vⱼ).

From Proposition 2 of [bravyi2019simulation](@cite): For Clifford magic states, ξ(ψ) = F(ψ)⁻¹
where F(ψ) = max_φ |⟨φ|ψ⟩|² is the stabilizer fidelity.

# Examples
```jldoctest
julia> using QuantumClifford.PureNonClifford: stabilizer_extent

julia> stabilizer_extent(sHadamard(1))
1.0

julia> round(stabilizer_extent(sT(1)), digits=3)
1.172

julia> stabilizer_extent(sCCZ(1,2,3)) ≈ 16/9
true
```
"""
function stabilizer_extent end

stabilizer_extent(op::AbstractOperation) = isclifford(op) ? 1.0 : error("stabilizer_extent not defined for $(typeof(op)). Please define a method.")

const _T_EXTENT = (cos(π/8) + tan(π/8) * sin(π/8))^2
stabilizer_extent(::sT) = _T_EXTENT

const _CCZ_EXTENT = 16.0 / 9.0
stabilizer_extent(::sCCZ) = _CCZ_EXTENT

"""
$(SIGNATURES)

Sparsification for MixedDestabilizer states (used during incremental simulation).

This is the core routine for incremental sparsification, applying Lemma 6 of [bravyi2019simulation](@cite) to
MixedDestabilizer states that can continue to have gates applied to them.

Samples k ≥ ||c||₁²/δ² states from the decomposition, preserving the L1 norm
of the coefficient vector (in expectation).

# Arguments
- `coefficients::Vector{ComplexF64}`: Current decomposition coefficients
- `states::Vector{MixedDestabilizer}`: Current stabilizer states
- `delta::Float64`: Per-gate approximation error budget
- `rng::AbstractRNG`: Random number generator

# Returns
Named tuple with fields:
- `states::Vector{MixedDestabilizer}`: Sparsified states
- `coefficients::Vector{ComplexF64}`: Sparsified coefficients
- `k::Int`: Number of terms after sparsification
- `l1_norm::Float64`: L1 norm of coefficient vector

# Note
If the current number of terms is already ≤ k, returns copies without sampling.
This avoids unnecessary variance introduction when already sparse enough.
"""
function sparsify_mixed_destabilizer_decomposition(
    coefficients::Vector{ComplexF64}, 
    states::Vector{<:MixedDestabilizer}, 
    delta::Float64;
    rng::AbstractRNG=Random.GLOBAL_RNG)
    
    n = length(coefficients)
    n == length(states) || throw(DimensionMismatch(
        "Coefficients ($n) and states ($(length(states))) must have same length"))
    delta > 0 || throw(ArgumentError("δ must be positive, got $delta"))
    n > 0 || throw(ArgumentError("Empty decomposition"))
    
    l1_norm = sum(abs, coefficients)
    l1_norm > 0 || throw(ArgumentError("All coefficients are zero"))
    
    k = max(1, ceil(Int, l1_norm^2 / delta^2))
    
    if n <= k
        return (
            states = [copy(s) for s in states],
            coefficients = copy(coefficients),
            k = n,
            l1_norm = l1_norm
        )
    end
    
    abs_coeffs = abs.(coefficients)
    probabilities = abs_coeffs ./ l1_norm
    cumulative_probs = cumsum(probabilities)
    
    sampled_states = Vector{MixedDestabilizer}(undef, k)
    sampled_coefficients = Vector{ComplexF64}(undef, k)
    uniform_weight = l1_norm / k
    
    for i in 1:k
        r = rand(rng)
        selected_idx = something(findfirst(>=(r), cumulative_probs), n)
        
        phase_factor = coefficients[selected_idx] / abs_coeffs[selected_idx]
        sampled_states[i] = copy(states[selected_idx])
        sampled_coefficients[i] = phase_factor * uniform_weight
    end
    
    return (
        states = sampled_states,
        coefficients = sampled_coefficients,
        k = k,
        l1_norm = l1_norm
    )
end

"""
$(TYPEDEF)

Stabilizer decomposition V|+⟩^⊗t = Σⱼ cⱼ|φⱼ⟩ for Clifford magic states.
Used as intermediate step before applying Lifting Lemma.

For Clifford magic states: ξ(ψ) = F(ψ)⁻¹ where F(ψ) = max_φ |⟨φ|ψ⟩|² 
is the stabilizer fidelity (Proposition 2 of [bravyi2019simulation](@cite)).

$(TYPEDFIELDS)
"""
struct MagicStateDecompositionCache
    "Type of gate (:T, :CCZ, :R_theta)"
    gate_type::Symbol
    "Decomposition coefficients cⱼ"
    coefficients::Vector{ComplexF64}
    "Stabilizer states |φⱼ⟩"
    stabilizer_states::Vector{Stabilizer}
    "||c||₁"
    l1_norm::Float64
    "ξ(ψ) = ||c||₁²"
    stabilizer_extent::Float64
    "F(ψ) = 1/ξ(ψ) for Clifford magic states"
    stabilizer_fidelity::Float64
    
    function MagicStateDecompositionCache(gate_type, coeffs, states)
        length(coeffs) == length(states) || throw(DimensionMismatch(
            "Mismatched coefficients ($(length(coeffs))) and states ($(length(states)))"))
        l1 = sum(abs.(coeffs))
        
        if gate_type == :CCZ
            xi = 16.0/9.0
            fidelity = 9.0/16.0
        elseif gate_type == :R_theta || gate_type == :T
            if length(coeffs) == 2
                c1_real = real(coeffs[1])
                c2_mag = abs(coeffs[2])
                sin_half = c2_mag / sqrt(2)
                cos_half = c1_real + sin_half
                xi = (cos_half + tan(π/8) * sin_half)^2
                fidelity = 1.0 / xi
            else
                xi = l1^2
                fidelity = 1.0 / xi
            end
        else
            xi = l1^2
            fidelity = 1.0 / xi
        end
        
        new(gate_type, coeffs, states, l1, xi, fidelity)
    end
end

"""
$(TYPEDEF)

Sum-over-Cliffords decomposition U = Σⱼ cⱼKⱼ where Kⱼ are Clifford unitaries.
Result of applying Lifting Lemma to magic state decomposition.

$(TYPEDFIELDS)
"""
struct CliffordGateDecompositionCache
    "Type of original non-Clifford gate"
    gate_type::Symbol
    "Decomposition coefficients cⱼ"
    coefficients::Vector{ComplexF64}
    "Clifford circuits Kⱼ"
    clifford_operations::Vector{Vector{AbstractOperation}}
    "||c||₁"
    l1_norm::Float64
    "ξ = ||c||₁²"
    stabilizer_extent::Float64
    "Qubits the gate acts on"
    target_qubits::Vector{Int}
    
    function CliffordGateDecompositionCache(gate_type, coeffs, ops, qubits)
        length(coeffs) == length(ops) || throw(DimensionMismatch(
            "Mismatched coefficients ($(length(coeffs))) and operations ($(length(ops)))"))
        l1 = sum(abs.(coeffs))
        xi = l1^2
        new(gate_type, coeffs, ops, l1, xi, qubits)
    end
end

"""
$(SIGNATURES)

Create magic state decomposition R(θ)|+⟩ = Σⱼ cⱼ|φⱼ⟩ from Eq. (26) of [bravyi2019simulation](@cite).

R(θ)|+⟩ = (cos(θ/2) - sin(θ/2))|+⟩ + √2 sin(θ/2)e^(-iπ/4) S|+⟩

Returns optimal decomposition with ξ(R(θ)) = (cos(θ/2) + tan(π/8)sin(θ/2))².

# Arguments
- `θ::Float64`: Rotation angle
- `nqubits::Int=1`: Number of qubits (for multi-qubit states)

# Returns
`MagicStateDecompositionCache` with the optimal decomposition.
"""
function decompose_rotation_magic_state(θ::Float64; nqubits::Int=1)
    cos_half = cos(θ/2)
    sin_half = sin(θ/2)
    
    c1 = ComplexF64(cos_half - sin_half, 0.0)
    c2 = sqrt(2) * sin_half * exp(-im * π/4)
    
    if nqubits == 1
        plus_state = Stabilizer([PauliOperator(0x00, Bool[true], Bool[false])])
        s_plus_state = Stabilizer([PauliOperator(0x00, Bool[true], Bool[true])])
    else
        plus_generators = [zero(PauliOperator, nqubits) for _ in 1:nqubits]
        for i in 1:nqubits
            plus_generators[i][i] = (true, false)
        end
        plus_state = Stabilizer(plus_generators)
        
        s_plus_generators = [zero(PauliOperator, nqubits) for _ in 1:nqubits]
        for i in 1:nqubits
            s_plus_generators[i][i] = (true, true)
        end
        s_plus_state = Stabilizer(s_plus_generators)
    end
    
    return MagicStateDecompositionCache(:R_theta, [c1, c2], [plus_state, s_plus_state])
end

"""
$(SIGNATURES)

Apply Lifting Lemma (Lemma 1) of [bravyi2019simulation](@cite) to convert R(θ)|+⟩ = Σⱼ cⱼ|φⱼ⟩ to R(θ) = Σⱼ cⱼKⱼ.

For a diagonal gate V, if V|+⟩ = Σⱼ cⱼKⱼ|+⟩ where Kⱼ are diagonal Cliffords,
then V = Σⱼ cⱼKⱼ.

# Arguments
- `magic_decomp`: Magic state decomposition from `decompose_rotation_magic_state`
- `qubit::Int`: Target qubit index

# Returns
`CliffordGateDecompositionCache` with the gate decomposition.
"""
function lifting_lemma_single_qubit(magic_decomp::MagicStateDecompositionCache, qubit::Int)
    coeffs = magic_decomp.coefficients
    
    clifford_ops = Vector{Vector{AbstractOperation}}()
    
    if length(coeffs) == 2
        push!(clifford_ops, AbstractOperation[])
        push!(clifford_ops, [sPhase(qubit)])
    else
        throw(ArgumentError("Unexpected number of terms ($(length(coeffs))) in single-qubit decomposition"))
    end
    
    return CliffordGateDecompositionCache(magic_decomp.gate_type, coeffs, clifford_ops, [qubit])
end

"""
$(SIGNATURES)

Create stabilizer state by applying Clifford operations to |+++⟩.
Internal helper for CCZ decomposition.
"""
function create_ccz_stabilizer_state(operations::Vector{<:AbstractOperation})
    state = MixedDestabilizer(Stabilizer([
        PauliOperator(0x00, Bool[true, false, false], Bool[false, false, false]),
        PauliOperator(0x00, Bool[false, true, false], Bool[false, false, false]),
        PauliOperator(0x00, Bool[false, false, true], Bool[false, false, false])
    ]))
    
    for op in operations
        apply!(state, op)
    end
    
    return Stabilizer(stabilizerview(state))
end

"""
$(SIGNATURES)

Create optimal magic state decomposition for CCZ gate using Proposition 2 of [bravyi2019simulation](@cite).

For Clifford magic states: ξ(ψ) = F(ψ)⁻¹ where F(ψ) = max_φ |⟨φ|ψ⟩|².
For CCZ: F(CCZ) = |⟨+++|CCZ|+++⟩|² = 9/16, so ξ(CCZ) = 16/9.

Uses group decomposition |CCZ⟩ = (1/|Q|⟨CCZ|+++⟩) Σ_{q∈Q} q|+++⟩
where Q = ⟨X₁CZ₂,₃, X₂CZ₁,₃, X₃CZ₁,₂⟩ has 8 elements.

# Returns
`MagicStateDecompositionCache` with optimal decomposition achieving ξ(CCZ) = 16/9.
"""
function decompose_CCZ_magic_state()
    stabilizer_fidelity = 9.0/16.0
    overlap_amplitude = sqrt(stabilizer_fidelity)
    
    group_size = 8
    
    optimal_coeff = 1.0 / (group_size * overlap_amplitude)
    
    states = Vector{Stabilizer}()
    coefficients = ComplexF64[]
    
    group_elements = [
        AbstractOperation[],
        [sX(1), sCPHASE(2,3)],
        [sX(2), sCPHASE(1,3)],
        [sX(3), sCPHASE(1,2)],
        [sX(1), sCPHASE(2,3), sX(2), sCPHASE(1,3)],
        [sX(1), sCPHASE(2,3), sX(3), sCPHASE(1,2)],
        [sX(2), sCPHASE(1,3), sX(3), sCPHASE(1,2)],
        [sX(1), sCPHASE(2,3), sX(2), sCPHASE(1,3), sX(3), sCPHASE(1,2)]
    ]
    
    for operations in group_elements
        state = create_ccz_stabilizer_state(operations)
        push!(states, state)
        push!(coefficients, ComplexF64(optimal_coeff, 0.0))
    end
    
    return MagicStateDecompositionCache(:CCZ, coefficients, states)
end

"""
$(SIGNATURES)

Apply Lifting Lemma to convert CCZ magic state decomposition to gate decomposition.

# Arguments
- `magic_decomp`: Magic state decomposition from `decompose_CCZ_magic_state`
- `qubits::Vector{Int}`: Target qubit indices (must be length 3)

# Returns
`CliffordGateDecompositionCache` with the CCZ gate decomposition.
"""
function lifting_lemma_CCZ(magic_decomp::MagicStateDecompositionCache, qubits::Vector{Int})
    length(qubits) == 3 || throw(ArgumentError("CCZ requires exactly 3 qubits, got $(length(qubits))"))
    
    coeffs = magic_decomp.coefficients
    clifford_ops = Vector{Vector{AbstractOperation}}()
    
    term_operations = [
        AbstractOperation[],
        [sX(qubits[1]), sCPHASE(qubits[2], qubits[3])],
        [sX(qubits[2]), sCPHASE(qubits[1], qubits[3])],
        [sX(qubits[3]), sCPHASE(qubits[1], qubits[2])],
        [sX(qubits[1]), sCPHASE(qubits[2], qubits[3]), sX(qubits[2]), sCPHASE(qubits[1], qubits[3])],
        [sX(qubits[1]), sCPHASE(qubits[2], qubits[3]), sX(qubits[3]), sCPHASE(qubits[1], qubits[2])],
        [sX(qubits[2]), sCPHASE(qubits[1], qubits[3]), sX(qubits[3]), sCPHASE(qubits[1], qubits[2])],
        [sX(qubits[1]), sCPHASE(qubits[2], qubits[3]), sX(qubits[2]), sCPHASE(qubits[1], qubits[3]), sX(qubits[3]), sCPHASE(qubits[1], qubits[2])]
    ]
    
    for ops in term_operations
        push!(clifford_ops, ops)
    end
    
    return CliffordGateDecompositionCache(:CCZ, coeffs, clifford_ops, qubits)
end

"""
$(SIGNATURES)

Get CliffordGateDecompositionCache for a non-Clifford gate.
Uses multiple dispatch - users can extend for custom gates.

# Returns
`CliffordGateDecompositionCache` containing the sum-over-Cliffords decomposition.
"""
function get_gate_decomposition end

function get_gate_decomposition(gate::sT)
    magic_decomp = decompose_rotation_magic_state(π/4; nqubits=1)
    gate_decomp = lifting_lemma_single_qubit(magic_decomp, gate.qubit)
    return CliffordGateDecompositionCache(:T, gate_decomp.coefficients, 
                                          gate_decomp.clifford_operations, [gate.qubit])
end

function get_gate_decomposition(gate::sCCZ)
    magic_decomp = decompose_CCZ_magic_state()
    qubits = collect(gate.qubits)
    return lifting_lemma_CCZ(magic_decomp, qubits)
end

function get_gate_decomposition(gate::AbstractOperation)
    if isclifford(gate)
        throw(ArgumentError("Gate $(typeof(gate)) is Clifford, no decomposition needed"))
    else
        throw(ArgumentError("No decomposition defined for $(typeof(gate)). Please define get_gate_decomposition method."))
    end
end

"""
$(TYPEDEF)

Results from computational basis measurement trajectory simulation, analogous to PauliFrame results.

$(TYPEDFIELDS)

# Accessing Results
Use `measurements(result)` to get the measurement matrix.

# Example
```jldoctest
julia> circuit = [sHadamard(1), sT(1), sCNOT(1,2)];

julia> result = emtrajectories(circuit, 2; trajectories=100, delta=0.1);

julia> meas = measurements(result);

julia> size(meas)
(100, 2)

julia> eltype(meas)
Bool
```
"""
struct EndMeasurementSampleResults
    "Measurement outcomes (trajectories × qubits)"
    measurements::Matrix{Bool}
    "Number of sparse stabilizer terms used (k)"
    simulation_cost::Int
    "Target δ parameter"
    approximation_error::Float64
    "Product of gate extents ∏ⱼ ξ(Vⱼ)"
    total_extent::Float64
    "Number of qubits"
    n_qubits::Int
end

function Base.show(io::IO, r::EndMeasurementSampleResults)
    n_trajectories = size(r.measurements, 1)
    
    println(io, "=== End Measurement Sample Results ===")
    println(io, "Qubits: $(r.n_qubits)")
    println(io, "Trajectories: $n_trajectories")
    println(io, "Simulation cost: $(r.simulation_cost) stabilizer terms")
    println(io, "Total extent: $(round(r.total_extent, digits=4))")
    println(io, "Approximation δ: $(r.approximation_error)")
    
    if n_trajectories > 0
        outcomes = Dict{BitVector, Int}()
        for t in 1:n_trajectories
            bv = BitVector(r.measurements[t, :])
            outcomes[bv] = get(outcomes, bv, 0) + 1
        end
        sorted_outcomes = sort(collect(outcomes), by=x->x[2], rev=true)
        
        println(io, "\nMost frequent outcomes:")
        for (i, (bv, count)) in enumerate(sorted_outcomes[1:min(10, length(sorted_outcomes))])
            bits = join(Int.(bv))
            freq = round(100 * count / n_trajectories, digits=2)
            println(io, "  |$bits⟩: $freq%")
        end
        if length(sorted_outcomes) > 10
            println(io, "  ... and $(length(sorted_outcomes) - 10) other outcomes")
        end
    end
end

function Base.show(io::IO, ::MIME"text/plain", r::EndMeasurementSampleResults)
    show(io, r)
end

"""
$(SIGNATURES)

Extract measurement outcomes from simulation results.
Each row is one trajectory, each column is one measured qubit.

Analogous to `measurements` for Pauli frames.

# Example
```jldoctest
julia> circuit = [sHadamard(1), sT(1)];

julia> result = emtrajectories(circuit; trajectories=100);

julia> m = measurements(result);

julia> size(m)
(100, 1)

julia> 0.0 <= sum(m[:, 1] .== false) / size(m, 1) <= 1.0
true
```
"""
measurements(r::EndMeasurementSampleResults) = r.measurements

"""
$(TYPEDEF)
Pure state represented as a weighted sum of stabilizer states:

|ψ⟩ = Σₐ cₐ|φₐ⟩

where:
- `cₐ` are stored in `coefficients`
- `|φₐ⟩` are stored in `states` (as `MixedDestabilizer`)

Similar to `GeneralizedStabilizer` but restricted to pure states. This is the
internal representation used by the low-rank simulation method from [bravyi2019simulation](@cite).

$(TYPEDFIELDS)
"""
mutable struct PureGeneralizedStabilizer
    "MixedDestabilizer states |φₐ⟩ in the decomposition"
    states::Vector{MixedDestabilizer}
    "Coefficients cₐ for each stabilizer state"
    coefficients::Vector{ComplexF64}
    "Per-gate approximation error budget δᵢ"
    delta_per_gate::Float64
    "Running product of gate extents ∏ⱼ ξ(Vⱼ)"
    total_extent::Float64
    "Accumulated approximation error from non-Clifford gates"
    accumulated_approximation_error::Float64
end

"""
$(SIGNATURES)

Create a `PureGeneralizedStabilizer` initialized to the |0⟩ⁿ state.

The `delta_per_gate` parameter controls the approximation error budget
for each non-Clifford gate during sparsification.

See also: [`emtrajectories`](@ref)
"""
function PureGeneralizedStabilizer(n_qubits::Int, delta_per_gate::Float64=0.1)
    n_qubits > 0 || throw(ArgumentError("Number of qubits must be positive, got $n_qubits"))
    initial_state = one(MixedDestabilizer, n_qubits)
    PureGeneralizedStabilizer([initial_state], [ComplexF64(1.0)], delta_per_gate, 1.0, 0.0)
end

nqubits(s::PureGeneralizedStabilizer) = nqubits(s.states[1])

function Base.copy(s::PureGeneralizedStabilizer)
    PureGeneralizedStabilizer(
        [copy(st) for st in s.states],
        copy(s.coefficients),
        s.delta_per_gate,
        s.total_extent,
        s.accumulated_approximation_error
    )
end

"""
$(SIGNATURES)

Apply a Clifford operation to a `PureGeneralizedStabilizer` by applying it to each state.
"""
function apply!(state::PureGeneralizedStabilizer, op::AbstractCliffordOperator)
    for s in state.states
        apply!(s, op)
    end
    state
end

"""
$(SIGNATURES)

Apply a non-Clifford operation to a `PureGeneralizedStabilizer` by expanding the
sum-over-Cliffords decomposition and then sparsifying.
"""
function apply!(state::PureGeneralizedStabilizer, op::AbstractNonCliffordOperator)
    gate_decomp = get_gate_decomposition(op)
    state.total_extent *= stabilizer_extent(op)

    num_decomp_terms = length(gate_decomp.coefficients)
    current_k = length(state.states)

    expanded_states = Vector{MixedDestabilizer}()
    expanded_coefficients = Vector{ComplexF64}()
    sizehint!(expanded_states, current_k * num_decomp_terms)
    sizehint!(expanded_coefficients, current_k * num_decomp_terms)

    for (s, c) in zip(state.states, state.coefficients)
        for (gc, ops) in zip(gate_decomp.coefficients, gate_decomp.clifford_operations)
            new_s = copy(s)
            for cliff_op in ops
                apply!(new_s, cliff_op)
            end
            push!(expanded_states, new_s)
            push!(expanded_coefficients, c * gc)
        end
    end

    sparse_result = sparsify_mixed_destabilizer_decomposition(
        expanded_coefficients, expanded_states, state.delta_per_gate)
    state.states = sparse_result.states
    state.coefficients = sparse_result.coefficients
    state.accumulated_approximation_error += state.delta_per_gate
    state
end

"""
$(SIGNATURES)

Create |x⟩ = |x₁x₂...xₙ⟩ as stabilizer state.
Stabilized by (-1)^xᵢ Zᵢ for each qubit i.
"""
function create_computational_basis_state(bitstring::BitVector)
    n = length(bitstring)
    
    generators = [zero(PauliOperator, n) for _ in 1:n]
    for i in 1:n
        generators[i][i] = (false, true)
        if bitstring[i]
            generators[i].phase[] = 0x02
        end
    end
    
    return Stabilizer(generators)
end

"""
$(SIGNATURES)

Compute inner product ⟨state1|state2⟩ using QuantumClifford's dot function.
Based on Section 4.3, Lemma 3 of [bravyi2019simulation](@cite).
"""
function compute_stabilizer_inner_product(state1::Stabilizer, state2::Stabilizer)
    n = nqubits(state1)
    nqubits(state2) == n || throw(DimensionMismatch(
        "States must have same number of qubits: $n vs $(nqubits(state2))"))
    
    return LinearAlgebra.dot(state1, state2)
end

"""
$(SIGNATURES)

Compute amplitude ⟨x|ψ⟩ where |ψ⟩ = Σ cₐ|φₐ⟩ and x is computational basis state.
Uses O(kn³) algorithm from Section 4.3 of [bravyi2019simulation](@cite).
"""
function compute_amplitude(states::Vector{<:Stabilizer}, 
                          coeffs::Vector{ComplexF64},
                          bitstring::BitVector)
    
    basis_state = create_computational_basis_state(bitstring)
    
    amplitude = zero(ComplexF64)
    for (coeff, state) in zip(coeffs, states)
        overlap = compute_stabilizer_inner_product(basis_state, state)
        amplitude += coeff * overlap
    end
    
    return amplitude
end

"""
$(TYPEDEF)

Cached state for efficient Metropolis sampling.
Stores current bitstring and precomputed amplitude to avoid recomputation.

$(TYPEDFIELDS)
"""
mutable struct MetropolisSamplerState
    "Current bitstring being sampled"
    current_bitstring::BitVector
    "Squared amplitude |⟨x|ψ⟩|² for current bitstring"
    current_amplitude_sq::Float64
    "Stabilizer states in the decomposition"
    states::Vector{Stabilizer}
    "Coefficients for each stabilizer state"
    coefficients::Vector{ComplexF64}
    "Number of qubits"
    n_qubits::Int
end

"""
$(SIGNATURES)

Initialize Metropolis sampler with random starting bitstring.
"""
function initialize_metropolis(states::Vector{<:Stabilizer}, 
                              coeffs::Vector{ComplexF64})
    n = nqubits(states[1])
    
    initial_bitstring = BitVector(rand(Bool, n))
    
    amplitude = compute_amplitude(states, coeffs, initial_bitstring)
    amplitude_sq = abs2(amplitude)
    
    return MetropolisSamplerState(initial_bitstring, amplitude_sq, 
                                  Vector{Stabilizer}(states), coeffs, n)
end

"""
$(SIGNATURES)

Perform single Metropolis step: propose bit flip and accept/reject.
Returns true if proposal was accepted.

This is the core O(kn³) operation for each step, where k is the number
of stabilizer states and n³ comes from the inner product computation.
"""
function metropolis_step!(metro::MetropolisSamplerState)
    flip_position = rand(1:metro.n_qubits)
    proposed_bitstring = copy(metro.current_bitstring)
    proposed_bitstring[flip_position] = !proposed_bitstring[flip_position]
    
    proposed_amplitude = compute_amplitude(metro.states, metro.coefficients, proposed_bitstring)
    proposed_amplitude_sq = abs2(proposed_amplitude)
    
    if proposed_amplitude_sq >= metro.current_amplitude_sq
        metro.current_bitstring = proposed_bitstring
        metro.current_amplitude_sq = proposed_amplitude_sq
        return true
    else
        acceptance_ratio = metro.current_amplitude_sq > 0 ? 
            proposed_amplitude_sq / metro.current_amplitude_sq : 1.0
        if rand() < acceptance_ratio
            metro.current_bitstring = proposed_bitstring
            metro.current_amplitude_sq = proposed_amplitude_sq
            return true
        end
    end
    
    return false
end

"""
$(SIGNATURES)

Run burn-in period to reach equilibrium distribution.
Recommended: burn_in ≈ 10n for shallow circuits, 100n for deep circuits.
"""
function metropolis_mixing!(metro::MetropolisSamplerState, burn_in::Int)
    for _ in 1:burn_in
        metropolis_step!(metro)
    end
end

"""
$(SIGNATURES)

MCMC Metropolis sampling from Section 4.2 of [bravyi2019simulation](@cite).
Complexity: O(k × n³ × T) where T = burn_in + n_samples × thinning.

# Arguments
- `state::PureGeneralizedStabilizer`: Sparse stabilizer decomposition from sum-over-Cliffords
- `n_samples::Int`: Number of measurement outcomes to generate
- `burn_in::Int=0`: Mixing time (0 = auto-tune based on circuit)
- `verbose::Bool=false`: Show progress information

# Returns
`Matrix{Bool}` of size (n_samples, n_qubits) with measurement outcomes.
"""
function sample_measurement_outcomes(state::PureGeneralizedStabilizer, 
                                    n_samples::Int; 
                                    burn_in::Int=0,
                                    verbose::Bool=false)
    
    n_samples > 0 || throw(ArgumentError("Number of samples must be positive, got $n_samples"))
    length(state.states) > 0 || throw(ArgumentError("State must contain at least one stabilizer state"))

    stab_states = [Stabilizer(stabilizerview(s)) for s in state.states]
    n_qubits = nqubits(stab_states[1])

    if burn_in == 0
        circuit_depth_proxy = log2(max(1, length(state.states)))
        burn_in = ceil(Int, 10 * n_qubits * (1 + circuit_depth_proxy / 10))
        if verbose
            @info "Auto-tuned burn-in: $burn_in steps"
        end
    end
    
    if verbose
        @info "Initializing Metropolis sampler with $(length(stab_states)) stabilizer states..."
    end
    metro = initialize_metropolis(stab_states, state.coefficients)
    
    if verbose
        @info "Burn-in: $burn_in steps..."
    end
    metropolis_mixing!(metro, burn_in)
    
    measurements = Matrix{Bool}(undef, n_samples, n_qubits)
    acceptance_count = 0
    total_steps = 0
    
    thinning = max(1, div(n_qubits, 2))
    
    if verbose
        @info "Sampling $n_samples outcomes (thinning=$thinning)..."
    end
    
    for s in 1:n_samples
        for _ in 1:thinning
            accepted = metropolis_step!(metro)
            acceptance_count += accepted ? 1 : 0
            total_steps += 1
        end
        
        measurements[s, :] .= metro.current_bitstring
        
        if verbose && s % max(1, div(n_samples, 10)) == 0
            acceptance_rate = acceptance_count / total_steps
            @info "Progress: $s/$n_samples samples (acceptance rate: $(round(acceptance_rate*100, digits=1))%)"
        end
    end
    
    if verbose
        final_acceptance_rate = acceptance_count / total_steps
        @info "Sampling complete: $(round(final_acceptance_rate*100, digits=1))% acceptance rate"
    end
    
    return measurements
end

"""
$(SIGNATURES)

Compute frequency distribution of measurement outcomes.
"""
function compute_outcome_frequencies(measurements::Matrix{Bool})
    n_samples = size(measurements, 1)
    frequency_dict = Dict{BitVector, Float64}()
    
    for s in 1:n_samples
        bv = BitVector(measurements[s, :])
        frequency_dict[bv] = get(frequency_dict, bv, 0.0) + 1.0
    end
    
    for key in keys(frequency_dict)
        frequency_dict[key] /= n_samples
    end
    
    return frequency_dict
end

"""
$(SIGNATURES)

Validation of simulation parameters.
"""
function validate_simulation_parameters(circuit,
                                       n_qubits::Int,
                                       trajectories::Int,
                                       delta::Float64)

    isempty(circuit) && throw(ArgumentError("Circuit cannot be empty"))
    n_qubits > 0 || throw(ArgumentError("Number of qubits must be positive, got $n_qubits"))
    trajectories > 0 || throw(ArgumentError("Number of trajectories must be positive, got $trajectories"))
    0 < delta < 1 || throw(ArgumentError("Delta must be in (0,1), got $delta"))
    
    if trajectories > 100000
        @warn "Large number of trajectories ($trajectories) may result in long simulation times"
    end
    
    if delta < 0.01
        @warn "Very small delta ($delta) may result in large memory usage and slow simulation"
    end
    
    for (idx, op) in enumerate(circuit)
        validate_operation_qubits(op, n_qubits, idx)
    end
    
    return nothing
end

"""
$(SIGNATURES)

Validate that operation uses valid qubit indices.
"""
function validate_operation_qubits(op::AbstractOperation, n_qubits::Int, idx::Int)
    if op isa sT
        1 ≤ op.qubit ≤ n_qubits || throw(ArgumentError(
            "Operation $idx: sT qubit index $(op.qubit) out of range [1,$n_qubits]"))
        return nothing
    elseif op isa sCCZ
        for q in op.qubits
            1 ≤ q ≤ n_qubits || throw(ArgumentError(
                "Operation $idx: sCCZ qubit index $q out of range [1,$n_qubits]"))
        end
        return nothing
    end
    
    op_type = typeof(op)
    
    if hasfield(op_type, :q)
        qubit = op.q
        1 ≤ qubit ≤ n_qubits || throw(ArgumentError(
            "Operation $idx: qubit index $qubit out of range [1,$n_qubits]"))
    end
    
    if hasfield(op_type, :q1) && hasfield(op_type, :q2)
        q1, q2 = op.q1, op.q2
        1 ≤ q1 ≤ n_qubits || throw(ArgumentError(
            "Operation $idx: qubit index $q1 out of range [1,$n_qubits]"))
        1 ≤ q2 ≤ n_qubits || throw(ArgumentError(
            "Operation $idx: qubit index $q2 out of range [1,$n_qubits]"))
        q1 ≠ q2 || throw(ArgumentError(
            "Operation $idx: two-qubit operation cannot target same qubit $q1"))
    end
    
    return nothing
end

"""
$(SIGNATURES)

Infer number of qubits from circuit operations.
"""
function infer_circuit_nqubits(circuit)
    max_qubit = 1
    for op in circuit
        if op isa sT
            max_qubit = max(max_qubit, op.qubit)
        elseif op isa sCCZ
            max_qubit = max(max_qubit, maximum(op.qubits))
        elseif hasfield(typeof(op), :q)
            max_qubit = max(max_qubit, op.q)
        elseif hasfield(typeof(op), :q1) && hasfield(typeof(op), :q2)
            max_qubit = max(max_qubit, op.q1, op.q2)
        end
    end
    return max_qubit
end

"""
$(SIGNATURES)

Simulate quantum circuit with non-Clifford gates using low-rank stabilizer decomposition.

This is the main entry point for non-Clifford simulation, analogous to `pftrajectories`
for Pauli frame simulation. This method returns **measurement statistics only**, not the
quantum state. Use [`PureGeneralizedStabilizer`](@ref) directly with [`mctrajectory!`](@ref)
if you need access to the state representation.

# Comparison to `mctrajectories` with `GeneralizedStabilizer`
- `emtrajectories`: Only supports unitary gates (no mid-circuit measurements). 
  Performs implicit Z-basis measurements on all qubits at the end. Faster for 
  circuits with many non-Clifford gates due to sparsification.
- `mctrajectories` with `GeneralizedStabilizer`: Supports mid-circuit measurements 
  and more general operations. Provides access to the full density matrix. More 
  general but slower for large numbers of non-Clifford gates.

# Arguments
- `circuit`: Vector of quantum operations (Clifford gates, sT, sCCZ, etc.)
- `trajectories::Int=1000`: Number of measurement samples to generate
- `delta::Float64=0.1`: Approximation error parameter (smaller = more accurate but slower)
- `verbose::Bool=false`: Show detailed progress information

# Returns
`EndMeasurementSampleResults` containing measurement outcomes and simulation statistics.
Use `measurements(result)` to extract the measurement matrix.

# Algorithm
Implements the Sum-over-Cliffords method from Section 2.3.2 of [bravyi2019simulation](@cite)
with incremental sparsification (Section 5.2) after each non-Clifford gate:

1. Initialize with |0⟩ state
2. For each gate:
   - Clifford: apply to all current stabilizer states
   - Non-Clifford: expand decomposition, then sparsify immediately
3. Sample measurement outcomes via Metropolis MCMC (Section 4.2) with implicit Z-basis measurement

# Performance
- Memory: O(k × n) where k ≈ total_extent/δ² (never stores 2^m terms)
- Simulation cost scales as ∏ⱼ ξ(Vⱼ) where Vⱼ are the non-Clifford gates and ξ(T) ≈ 1.172, ξ(CCZ) = 16/9
- Time complexity: O(m × k² × n³) for simulation + O(k × n³ × trajectories) for sampling

# Example
```jldoctest
julia> circuit = [sHadamard(1), sT(1), sHadamard(1)];

julia> result = emtrajectories(circuit; trajectories=100, delta=0.1);

julia> result.simulation_cost > 0
true

julia> meas = measurements(result);

julia> size(meas)
(100, 1)

julia> p0 = sum(meas[:, 1] .== false) / size(meas, 1);

julia> 0.0 <= p0 <= 1.0
true
```

See also: [`PureGeneralizedStabilizer`](@ref), [`measurements`](@ref)
"""
function emtrajectories(circuit;
                        trajectories::Int=1000,
                        delta::Float64=0.1,
                        verbose::Bool=false)

    n_qubits = infer_circuit_nqubits(circuit)
    return emtrajectories(circuit, n_qubits; trajectories, delta, verbose)
end

function emtrajectories(circuit,
                        n_qubits::Int;
                        trajectories::Int=1000,
                        delta::Float64=0.1,
                        verbose::Bool=false)

    validate_simulation_parameters(circuit, n_qubits, trajectories, delta)

    non_clifford_count = count(op -> !isclifford(op), circuit)
    delta_per_gate = non_clifford_count > 0 ? delta / non_clifford_count : delta
    state = PureGeneralizedStabilizer(n_qubits, delta_per_gate)
    mctrajectory!(state, circuit)

    measurements = sample_measurement_outcomes(state, trajectories; verbose)

    return EndMeasurementSampleResults(
        measurements,
        length(state.states),
        state.accumulated_approximation_error,
        state.total_extent,
        n_qubits
    )
end

"""
$(SIGNATURES)

Estimate simulation cost before running full simulation.

This is useful for determining if a circuit is feasible to simulate
and for tuning the delta parameter.

# Arguments
- `circuit`: Vector of quantum operations
- `delta::Float64=0.1`: Approximation error parameter

# Returns
Named tuple with:
- `estimated_k::Int`: Number of stabilizer terms after sparsification (k ≤ 1 + ξ/δ²)
- `total_extent::Float64`: Product ∏ⱼ ξ(Vⱼ) of gate extents
- `non_clifford_count::Int`: Number of non-Clifford gates
- `gate_extents::Vector{Float64}`: Individual gate extents
- `scaling_factor::Float64`: Geometric mean of gate extents

# Performance Guidelines
- k < 1000: Fast simulation (seconds)
- k < 100,000: Moderate simulation (minutes)
- k > 1,000,000: Long simulation (hours), consider larger δ

# Note on Incremental Sparsification
With incremental sparsification, actual memory usage during simulation
is bounded by the maximum k at any single gate, not the final k.
This is typically much smaller than the estimated final k.

# Example
```jldoctest
julia> using QuantumClifford.PureNonClifford: lrcost, stabilizer_extent

julia> circuit = [sHadamard(1), sT(1), sT(1), sT(1), sHadamard(1)];

julia> cost = lrcost(circuit; delta=0.1);

julia> cost.non_clifford_count
3

julia> cost.estimated_k > 0
true

julia> cost.total_extent ≈ stabilizer_extent(sT(1))^3
true
```
"""
function lrcost(circuit; delta::Float64=0.1)
    total_extent = 1.0
    non_clifford_count = 0
    gate_extents = Float64[]
    
    for op in circuit
        if !isclifford(op)
            xi = stabilizer_extent(op)
            total_extent *= xi
            non_clifford_count += 1
            push!(gate_extents, xi)
        end
    end
    
    estimated_k = if non_clifford_count == 0
        1
    else
        ceil(Int, 1 + total_extent / delta^2)
    end
    
    scaling_factor = non_clifford_count > 0 ? 
        total_extent^(1/non_clifford_count) : 1.0
    
    return (
        estimated_k = estimated_k,
        total_extent = total_extent,
        non_clifford_count = non_clifford_count,
        gate_extents = gate_extents,
        scaling_factor = scaling_factor
    )
end

end

@testitem "PauliChannelNonClifford" begin
    using QuantumClifford
    using QuantumClifford: GeneralizedStabilizer, rowdecompose, PauliChannel, invsparsity, mul_left!, mul_right!, mixed_destab_looks_good, tr
    using Test
    using InteractiveUtils
    using Random
    using LinearAlgebra

    @testset "Pauli decomposition into destabilizers" begin
        for n in [1,2,63,64,65,66,300]
            p = random_pauli(n; nophase=false, realphase=true)
            s = random_destabilizer(n)
            phase, b, c = rowdecompose(p,s)
            p0 = zero(p)
            for (i,f) in pairs(b)
                f && mul_right!(p0, destabilizerview(s), i)
            end
            for (i,f) in pairs(c)
                f && mul_right!(p0, stabilizerview(s), i)
            end
            @test (im)^phase*p0 == p
        end
    end

    @testset "PauliChannel T gate ^4 = Id" begin
        tgate = pcT
        state = GeneralizedStabilizer(S"X")

        apply!(state, tgate)
        apply!(state, tgate)
        apply!(state, tgate)
        apply!(state, tgate)

        @test state.destabweights |> values |> collect ≈ [1]
        @test state.destabweights |> keys |> collect == [([1],[1])]
    end

    @testset "Inverse sparsity" begin
        for n in 1:5
            s = random_stabilizer(n)
            gs = GeneralizedStabilizer(s)
            for i in 1:rand(1:4)
                apply!(gs, embed(n, i, pcT))
            end
            # Λ(χ) ≤ 4ⁿ
            @test invsparsity(gs) <= 4^n
            channels = [embed(n, i, pcT) for i in 1:rand(1:4)]
            # Λ(ϕᵢⱼ) ≤ 4ⁿ
            @test all(invsparsity(channel) <= 4^n for channel in channels)
        end
    end

    @testset "PauliChannel: inverse sparsity of k-qubit channels" begin
        # In general, the increase in Λ(χ) due to k-qubit channels is limited to a maximum factor of 16ᵏ.
        k = 10
        for n in 1:10
            for repetition in 1:10
                stab = random_stabilizer(n)
                pauli = random_pauli(n)
                genstab = GeneralizedStabilizer(stab)
                Λ_χ = invsparsity(genstab) # Λ(χ)
                i = rand(1:n)
                nc = embed(n, i, pcT)
                for i in 1:k
                    apply!(genstab, nc) # in-place
                end
                Λ_χ′ = invsparsity(genstab) # Λ(χ′)
                @test (Λ_χ′/Λ_χ) <= 16^k
            end
        end
    end

    @testset "PauliChannel: Λ(χ) ≤ Λ(χ′) ≤ Λ(E)Λ(χ)" begin
        # In general, the complexity of χ increases in the case of evolution through a channel.
        for n in 1:10
            for repetition in 1:10
                stab = random_stabilizer(n)
                pauli = random_pauli(n)
                genstab = GeneralizedStabilizer(stab)
                Λ_χ = invsparsity(genstab) # Λ(χ)
                i = rand(1:n)
                nc = embed(n, i, pcT)
                Λ_E = invsparsity(nc) # Λ(E)
                apply!(genstab, nc) # in-place
                Λ_χ′ = genstab |> invsparsity # Λ(χ′)
                @test Λ_χ <= Λ_χ′ <= Λ_E*Λ_χ # Corollary 14, page 9 of [yoder2012generalization](@cite).
            end
        end
    end

    @testset "PauliMeasurement: Λ(χ′) ≤ Λ(χ)" begin
        # In general, the complexity of χ may decrease in the case of evolution through a measurement.
        for n in 1:10
            for repetition in 1:10
                stab = random_stabilizer(n)
                pauli = random_pauli(n)
                genstab = GeneralizedStabilizer(stab)
                Λ_χ = invsparsity(genstab) # Λ(χ)
                projectrand!(genstab, pauli)[1] # in-place
                Λ_χ′ = invsparsity(genstab) # Λ(χ′)
                @test Λ_χ′ <= Λ_χ # Corollary 14, page 9 of [yoder2012generalization](@cite).
            end
        end
    end

    @testset "Tensor products over generalized stabilizers" begin
        num_trials = 10
        num_qubits = [2,3,4,5] # exclusively multi-qubit
        for n in num_qubits
            for repetition in 1:num_trials
                stab = random_stabilizer(n)
                pauli = random_pauli(n)
                genstab = GeneralizedStabilizer(stab)
                # Apply some (repeated) non-Clifford operations
                i = rand(1:n)
                nc = embed(n, i, pcT)
                apply!(genstab, nc) # in-place
                apply!(genstab, nc) # in-place
                apply!(genstab, nc) # in-place
                newsm = genstab ⊗ genstab
                newsm1 = genstab ⊗ stab
                @test mixed_destab_looks_good(newsm.stab)
                @test real(tr(newsm)) ≈ 1
                @test mixed_destab_looks_good(newsm1.stab)
                @test real(tr(newsm1)) ≈ 1
            end
        end
    end

    @test nqubits(tensor(pcT, P"X", P"Y")) == 3

    @testset "issue 681" begin
        stab = one(Stabilizer, 1)
        genstab = GeneralizedStabilizer(stab)
        apply!(genstab, tPhase)
        apply!(genstab, tHadamard)
        apply!(genstab, pcT)
        apply!(genstab, pcT)
        @test expect(P"X", genstab) ≈ 0.0 atol=1e-10
        @test expect(P"Y", genstab) ≈ 1.0 atol=1e-10
        @test expect(P"Z", genstab) ≈ 0.0 atol=1e-10
        @test expect(P"I", genstab) ≈ 1.0 atol=1e-10
    end

    @test_throws ArgumentError GeneralizedStabilizer(S"XX")
    @test_throws ArgumentError PauliChannel(((P"X", P"Z"), (P"X", P"ZZ")), (1,2))
    @test_throws ArgumentError PauliChannel(((P"X", P"Z"), (P"X", P"Z")), (1,))
    @test_throws ArgumentError UnitaryPauliChannel((P"X", P"ZZ"), (1,2))
    @test_throws ArgumentError UnitaryPauliChannel((P"X", P"Z"), (1,))
    @test_throws MethodError project!(GeneralizedStabilizer(S"X"), P"X")
end

@testitem "Apply Right" begin
    using InteractiveUtils
    using QuantumClifford: AbstractCliffordOperator, CliffordOperator
    
    test_sizes = [1,2,63,64,65,127,128,129]
    
    # SLOW version of apply_right! for testing
    function apply_right_slow!(l::CliffordOperator, r::CliffordOperator; phases=true)
        apply!(r, l; phases)
    end
    function apply_right_slow!(l::CliffordOperator, r::PauliOperator; phases=true)
        apply!(CliffordOperator(r), l; phases)
    end
    function apply_right_slow!(l::CliffordOperator, r::AbstractCliffordOperator; phases=true)
        apply!(CliffordOperator(r, nqubits(l)), l; phases)
    end

    @testset "Apply Right dense operators" begin
        for q in test_sizes
            l = random_clifford(q)
            cliff = random_clifford(q)
            pauli = random_pauli(q)

            @test isequal(apply_right!(copy(l), cliff), apply_right_slow!(l, cliff))
            @inferred apply_right!(copy(l), cliff)

            @test isequal(apply_right!(copy(l), pauli), apply_right_slow!(l, pauli))
            @inferred apply_right!(copy(l), pauli)
        end
    end

    @testset "Apply Right single-qubit" begin
        for q in test_sizes
            l = random_clifford(q)
            q1 = rand(1:q)

            for gate in subtypes(AbstractSingleQubitOperator)
                gate == SingleQubitOperator && continue

                @test isequal(apply_right!(copy(l), gate(q1)), apply_right_slow!(l, gate(q1)))
                @inferred apply_right!(copy(l), gate(q1))
            end
        end
    end

    @testset "Apply Right two-qubit" begin
        for q in test_sizes
            q < 2 && continue

            l = random_clifford(q)
            q1 = rand(1:q); q2 = rand(setdiff(1:q, [q1]))

            for gate in subtypes(AbstractTwoQubitOperator)
                @test isequal(apply_right!(copy(l), gate(q1, q2)), apply_right_slow!(l, gate(q1, q2)))
                @inferred apply_right!(copy(l), gate(q1, q2))
            end
        end
    end
end

include("implementation/benchmark_platform.jl")

using Dates: value, now, UNIXEPOCH
using CUDA: CuArray, devices, synchronize
const AT = CuArray
const path = "CUDA_benchmark_" * string(value(now()) - UNIXEPOCH)

const can_run = length(devices()) > 0

if can_run
    benchmark_platform(AT, synchronize, path)
else
    @info "Unable to run CUDA benchmark. No suitable device was found."
end

@testitem "Word-boundary compaction after qubit removal" begin
    using QuantumClifford
    using QuantumClifford: MixedDestabilizer, projectremoverand!, remove_column!,
        tab, expect, comm, tensor, nqubits, stabilizerview

    function plus_destabilizer(n)
        plus = S"X"
        state = MixedDestabilizer(copy(plus))
        for _ in 2:n
            state = tensor(state, MixedDestabilizer(copy(plus)))
        end
        state
    end

    function pauli_on(n; xs=(), zs=())
        xbits = falses(n)
        zbits = falses(n)
        for i in xs
            xbits[i] = true
        end
        for i in zs
            zbits[i] = true
        end
        PauliOperator(0x0, xbits, zbits)
    end

    function has_compact_xzs(state)
        t = tab(state)
        size(t.xzs, 1) ÷ 2 == cld(nqubits(state), 8 * sizeof(eltype(t.xzs)))
    end

    invariant_sizes = [1, 2, 10, 63, 64, 65, 127, 128, 129]

    @testset "xzs word-count invariant (n=$n)" for n in invariant_sizes
        state = plus_destabilizer(n)
        n > 1 && apply!(state, sZCZ(1, 2))

        state, _ = projectremoverand!(state, projectX!, n)
        @test has_compact_xzs(state)
    end

    @testset "remove_column! compacts direct callers" begin
        state = plus_destabilizer(65)
        removed = remove_column!(copy(stabilizerview(state)), 65)

        @test nqubits(removed) == 64
        @test has_compact_xzs(removed)
        @test comm(pauli_on(64; xs=(1,)), removed, 1) in (0x00, 0x01)
    end

    @testset "expect correctness after word-boundary crossing (n=$n)" for n in [65, 129]
        state = plus_destabilizer(n)
        apply!(state, sZCZ(1, 2))
        apply!(state, sZCZ(2, 3))

        for _ in 1:2
            state, _ = projectremoverand!(state, projectX!, nqubits(state))
        end

        nq = nqubits(state)
        @test expect(pauli_on(nq; xs=(1,), zs=(2,)), state) == 1
        @test expect(pauli_on(nq; xs=(2,), zs=(1, 3)), state) == 1
    end

    @testset "comm consistency after word-boundary crossing" begin
        crossed = plus_destabilizer(65)
        apply!(crossed, sZCZ(1, 2))
        crossed, _ = projectremoverand!(crossed, projectX!, 65)

        direct = plus_destabilizer(64)
        apply!(direct, sZCZ(1, 2))

        op = pauli_on(64; xs=(1,), zs=(2,))
        @test comm(op, stabilizerview(crossed)) ==
            comm(op, stabilizerview(direct)) ==
            zeros(UInt8, length(stabilizerview(crossed)))
    end

    @testset "non-tail removal across word boundary" begin
        state = plus_destabilizer(65)
        apply!(state, sZCZ(64, 65))

        state, _ = projectremoverand!(state, projectX!, 1)

        @test nqubits(state) == 64
        @test has_compact_xzs(state)
        @test expect(pauli_on(64; xs=(63,), zs=(64,)), state) == 1
        @test expect(pauli_on(64; xs=(64,), zs=(63,)), state) == 1
    end

    @testset "repeated removal across multiple word boundaries" begin
        state = plus_destabilizer(130)
        apply!(state, sZCZ(1, 2))

        while nqubits(state) > 63
            state, _ = projectremoverand!(state, projectX!, nqubits(state))
        end

        @test nqubits(state) == 63
        @test has_compact_xzs(state)
        @test expect(pauli_on(63; xs=(1,), zs=(2,)), state) == 1
    end
end

right_repr_matrix(x) = representation_matrix(x, :right)
left_repr_matrix(x) = representation_matrix(x, :left)

"""
$TYPEDEF

Lifted product codes ([panteleev2021degenerate](@cite), [panteleev2022asymptotically](@cite))

A lifted product code is defined by the hypergraph product of a base matrices `A` and the conjugate of another base matrix `B'`.
Here, the hypergraph product is taken over a group algebra, of which the base matrices are consisting.

The binary parity check matrices are obtained by applying `A_repr` and `B_repr` representation maps to each element of the base matrices. These linear transformations convert group algebra elements to their matrix representations while preserving the CSS orthogonality condition.

## Mathematical Framework

Given classical parity-check matrices:

- ``A \\in \\mathbb{F}_q^{m_a \\times n_a}``

- ``B \\in \\mathbb{F}_q^{m_b \\times n_b}``

The lifted product construction produces quantum CSS codes with parity-check matrices:

```math
\\begin{aligned}
    H_X &= [A \\otimes I_{m_b}, -I_{m_a} \\otimes B] \\\\
    H_Z &= [I_{n_a} \\otimes B^*, A^* \\otimes I_{n_b}]
\\end{aligned}
```

### Commutative Group Algebra

When `R` is *commutative*, a single representation suffices since all elements naturally commute. Here ``\\rho(a) = \\lambda(a)`` for all ``a \\in R``.

### Non-Commutative Group Algebra

When `R` is *non-commutative*, distinct representations are essential:

- `A_repr` implements the right regular representation: ``\\rho(a)x = xa``

- `B_repr` implements the left regular representation: ``\\lambda(b)x = bx``

These ensure the critical commutation relation:

```math
\\begin{aligned}
    \\rho(a)\\lambda(b) = \\lambda(b)\\rho(a)
\\end{aligned}
```

which follows from the *associative* property:

```math
\\begin{aligned}
    \\rho(a)\\lambda(b)(x) = b(xa) = (bx)a = \\lambda(b)\\rho(a)(x)
\\end{aligned}
```

## Constructors

Multiple constructors are available:

1. Two base matrices of group algebra elements.

2. Two lifted codes, whose base matrices are for quantum code construction.

3. Two base matrices of group elements, where each group element will be considered as a group algebra element by assigning a unit coefficient.

4. Two base matrices of integers, where each integer represent the shift of a cyclic permutation. The order of the cyclic permutation should be specified.

Below is a list of all constructors:

$METHODLIST

## Examples

A [[882, 24, d ≤ 24]] code from Appendix B of [roffe2023bias](@cite).
We use the 1st constructor to generate the code and check its length and dimension.
During the construction, we do arithmetic operations to get the group algebra elements in base matrices `A` and `B`.
Here `x` is the generator of the group algebra, i.e., offset-1 cyclic permutation, and `GA(1)` is the unit element.

```jldoctest
julia> import Hecke: group_algebra, GF, abelian_group, gens; import LinearAlgebra: diagind; using QuantumClifford.ECC;

julia> l = 63; GA = group_algebra(GF(2), abelian_group(l)); x = gens(GA)[];

julia> A = fill(zero(GA), 7, 7);

julia> A[diagind(A)] .= x^27;

julia> A[diagind(A, -1)] .= x^54;

julia> A[diagind(A, 6)] .= x^54;

julia> A[diagind(A, -2)] .= GA(1);

julia> A[diagind(A, 5)] .= GA(1);

julia> B = reshape([1 + x + x^6], (1, 1));

julia> c1 = LPCode(A, B);

julia> code_n(c1), code_k(c1)
(882, 24)
```

A [[175, 19, d ≤ 10]] code from Eq. (18) in Appendix A of [raveendran2022finite](@cite),
following the 4th constructor.

```jldoctest
julia> import Hecke; using QuantumClifford.ECC;

julia> base_matrix = [0 0 0 0; 0 1 2 5; 0 6 3 1]; l = 7;

julia> c2 = LPCode(base_matrix, l .- base_matrix', l);

julia> code_n(c2), code_k(c2)
(175, 19)
```

## Code subfamilies and convenience constructors for them

- When the base matrices of the `LPCode` are 1×1, the code is called a two-block group-algebra code [`two_block_group_algebra_code`](@ref).
- When the base matrices of the `LPCode` are 1×1 and their elements are sums of cyclic permutations, the code is called a generalized bicycle code [`generalized_bicycle_code_as_2bga`](@ref).
- When the two matrices are adjoint to each other, the code is called a bicycle code [`bicycle_code_as_2bga`](@ref).

## The representation function

We use the default representation function `Hecke.representation_matrix` to convert a `GF(2)`-group algebra element to a binary matrix.
The default representation, provided by `Hecke`, is the permutation representation.

We also accept a custom representation function as detailed in [`LiftedCode`](@ref).

See also: [`LiftedCode`](@ref), [`two_block_group_algebra_code`](@ref), [`generalized_bicycle_code_as_2bga`](@ref), [`bicycle_code_as_2bga`](@ref),
[`Haah_cubic_code_as_2bga`](@ref).

All fields:

$TYPEDFIELDS
"""
struct LPCode <: AbstractCSSCode
    """the first base matrix of the code, whose elements are in a group algebra."""
    A::GroupAlgebraElemMatrix
    """the second base matrix of the code, whose elements are in the same group algebra as `A`."""
    B::GroupAlgebraElemMatrix
    """the group algebra for which elements in `A` and `B` are from."""
    GA::GroupAlgebra
    """
    a function that converts a group algebra element to a binary matrix for `A`;
    default to be the right regular representation for `GF(2)`-algebra."""
    A_repr::Function
    """
    a function that converts a group algebra element to a binary matrix for B;
    default to be the left regular representation for `GF(2)`-algebra."""
    B_repr::Function

    # TODO document and doctest example
    function LPCode(
        A::GroupAlgebraElemMatrix,
        B::GroupAlgebraElemMatrix;
        GA::GroupAlgebra=parent(A[1,1]),
        A_repr::Function=right_repr_matrix,
        B_repr::Function=left_repr_matrix,
        repr::Union{Function,Nothing}=nothing
    )
        if repr !== nothing # override the default A_repr/B_repr (exists for backward compat)
            is_commutative(GA) || throw(ArgumentError("The group algebra must be commutative when using a single `repr` function, which is not the case here. Please specify separate `A_repr` and `B_repr` instead of a single `repr`. The default choice of `A_repr=right_repr_matrix, B_repr=left_repr_matrix` is frequently sufficient."))
            A_repr = B_repr = repr
        end
        all(elem.parent == GA for elem in A) && all(elem.parent == GA for elem in B) || error("The base rings of all elements in both matrices must be the same as the group algebra")
        new(A, B, GA, A_repr, B_repr)
    end

    # TODO document and doctest example
    function LPCode(
        c₁::LiftedCode,
        c₂::LiftedCode;
        GA::GroupAlgebra=c₁.GA,
        A_repr::Function=c₁.repr,
        B_repr::Function=c₂.repr,
        repr::Union{Function,Nothing}=nothing
    )
        if repr !== nothing # override the default A_repr/B_repr (exists for backward compat)
            is_commutative(GA) || throw(ArgumentError("The group algebra must be commutative when using a single `repr` function, which is not the case here. Please specify separate `A_repr` and `B_repr` instead of a single `repr`. The default choice of `A_repr=right_repr_matrix, B_repr=left_repr_matrix` is frequently sufficient."))
            A_repr = B_repr = repr
        end
        # We are using the representation function of each lifted code.
        # We are using their group algebras as well (asserting that they are the same).
        c₁.GA == GA && c₂.GA == GA || error("The base rings of both lifted codes must be the same as the group algebra")
        new(c₁.A, c₂.A, GA, A_repr, B_repr)
    end
end

# TODO document and doctest example
function LPCode(A::FqFieldGroupAlgebraElemMatrix, B::FqFieldGroupAlgebraElemMatrix; GA::GroupAlgebra=parent(A[1,1]))
    LPCode(
        LiftedCode(A; GA=GA, repr=right_repr_matrix),
        LiftedCode(B; GA=GA, repr=left_repr_matrix)
    )
end

# TODO document and doctest example
function LPCode(group_elem_array1::Matrix{<: GroupOrAdditiveGroupElem}, group_elem_array2::Matrix{<: GroupOrAdditiveGroupElem}; GA::GroupAlgebra=group_algebra(GF(2), parent(group_elem_array1[1,1])))
    LPCode(
        LiftedCode(group_elem_array1; GA=GA, repr=right_repr_matrix),
        LiftedCode(group_elem_array2; GA=GA, repr=left_repr_matrix)
    )
end

# TODO document and doctest example
function LPCode(shift_array1::Matrix{Int}, shift_array2::Matrix{Int}, l::Int; GA::GroupAlgebra=group_algebra(GF(2), abelian_group(l)))
    LPCode(
        LiftedCode(shift_array1, l; GA=GA, repr=right_repr_matrix),
        LiftedCode(shift_array2, l; GA=GA, repr=left_repr_matrix)
    )
end

iscss(::Type{LPCode}) = true

function hgp(h₁::GroupAlgebraElemMatrix, h₂::GroupAlgebraElemMatrix)
    r₁, n₁ = size(h₁)
    r₂, n₂ = size(h₂)
    # here we use `permutdims` instead of `transpose` to avoid recursive call
    # convert LinearAlgebra.I to Matrix to fix incompatibility with Julia 1.11.1
    # TODO the performance may be affected by this workaround for large codes
    hx = hcat(kron(h₁, Matrix(LinearAlgebra.I(n₂))), kron(Matrix(LinearAlgebra.I(r₁)), permutedims(group_algebra_conj.(h₂))))
    hz = hcat(kron(Matrix(LinearAlgebra.I(n₁)), h₂), kron(permutedims(group_algebra_conj.(h₁)), Matrix(LinearAlgebra.I(r₂))))
    hx, hz
end

function parity_matrix_xz(c::LPCode)
    A, B = c.A, c.B
    ma, na = size(A)
    mb, nb = size(B)
    # hx = [A ⊗ I  | I  ⊗ B]
    # hz = [I ⊗ B* | A* ⊗ I]
    hx_raw, hz_raw = hgp(A, permutedims(group_algebra_conj.(B)))
    hx_b₁cols = hz_b₁cols = na*mb # size(A ⊗ I, 2) == size(I ⊗ B*, 2)
    hx = hcat(
        concat_lift_repr(c.A_repr, hx_raw[:, 1:hx_b₁cols]), # ρ(A ⊗ I)
        concat_lift_repr(c.B_repr, hx_raw[:, hx_b₁cols+1:end]) # λ(I ⊗ B)
    )
    hz = hcat(
        concat_lift_repr(c.B_repr, hz_raw[:, 1:hz_b₁cols]), # λ(I ⊗ B*)
        concat_lift_repr(c.A_repr, hz_raw[:, hz_b₁cols+1:end]) # ρ(A* ⊗ I)
    )
    # hx = [ρ(A ⊗  I) | λ(I  ⊗ B)]
    # hz = [λ(I ⊗ B*) | ρ(A* ⊗ I)]
    return hx, hz
end

"""A simpler (older) implementation of the parity check matrix representation routine, used purely for testing. Valid only for commuting algebras."""
function _parity_matrix_xz_if_comm_algebra(c::LPCode)
    hx, hz = hgp(c.A, permutedims(group_algebra_conj.(c.B)))
    hx, hz = concat_lift_repr(c.A_repr,hx), concat_lift_repr(c.A_repr,hz)
    return hx, hz
end

parity_matrix_x(c::LPCode) = parity_matrix_xz(c)[1]

parity_matrix_z(c::LPCode) = parity_matrix_xz(c)[2]

parity_checks(c::LPCode) = parity_checks(CSS(parity_matrix_xz(c)...))

code_n(c::LPCode) = size(c.A_repr(zero(c.GA)), 2) * (size(c.A, 2) * size(c.B, 1) + size(c.A, 1) * size(c.B, 2))

code_s(c::LPCode) = size(c.A_repr(zero(c.GA)), 1) * (size(c.A, 1) * size(c.B, 1) + size(c.A, 2) * size(c.B, 2))

"""
$TYPEDSIGNATURES

Two-block group algebra (2BGA) codes, which are a special case of lifted product codes
from two group algebra elements `a` and `b`, used as `1×1` base matrices.
To build them, you pick a group and specific generators for that group,
then you pick two polynomials made of the group generators,
and then, behind the scenes, these two polynomials `a` and `b` are piped
to the lifted product code constructor as the elements of `1×1` matrices.

See also: [`LPCode`](@ref), [`generalized_bicycle_code_as_2bga`](@ref), [`bicycle_code_as_2bga`](@ref), [`Haah_cubic_code_as_2bga`](@ref),
[`honeycomb_color_code_as_2bga`](@ref).

## Examples of 2BGA code subfamilies

### `C₄ x C₂`

Here is an example of a [[56, 28, 2]] 2BGA code from Table 2 of [lin2024quantum](@cite)
build out of polymonials of generators of the direct product `C₄ × C₂`.

```jldoctest
julia> import Hecke: group_algebra, GF, abelian_group, gens; using QuantumClifford.ECC;

julia> GA = group_algebra(GF(2), abelian_group([14,2]));

julia> x, s = gens(GA);

julia> A = 1 + x^7;

julia> B = 1 + x^7 + s + x^8 + s*x^7 + x;

julia> c = two_block_group_algebra_code(A,B);

julia> import HiGHS;

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(56, 28, 2)
```

### Bivariate Bicycle codes

Bivariate Bicycle codes are a class of Abelian 2BGA codes formed by the direct product
of two cyclic groups `ℤₗ × ℤₘ`. The parameters `l` and `m` represent the orders of the
first and second cyclic groups, respectively.

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/qcga).

A [[756, 16, ≤ 34]] code from Table 3 of [bravyi2024high](@cite):

```jldoctest
julia> import Hecke: group_algebra, GF, abelian_group, gens; using QuantumClifford.ECC;

julia> l=21; m=18;

julia> GA = group_algebra(GF(2), abelian_group([l, m]));

julia> x, y = gens(GA);

julia> A = x^3 + y^10 + y^17;

julia> B = y^5 + x^3  + x^19;

julia> c = two_block_group_algebra_code(A,B);

julia> code_n(c), code_k(c)
(756, 16)
```

### Multivariate Bicycle code

The group algebra of the qubit multivariate bicycle (MB) code with r variables is `𝔽₂[𝐺ᵣ]`,
where `𝐺ᵣ = ℤ/l₁ × ℤ/l₂ × ... × ℤ/lᵣ`.

A [[48, 4, 6]] Weight-6 TB-QLDPC code from Appendix A Table 2 of [voss2024multivariatebicyclecodes](@cite).

```jldoctest
julia> import Hecke: group_algebra, GF, abelian_group, gens; using QuantumClifford.ECC;

julia> l=4; m=6;

julia> GA = group_algebra(GF(2), abelian_group([l, m]));

julia> x, y = gens(GA);

julia> z = x*y;

julia> A = x^3 + y^5;

julia> B = x + z^5 + y^5 + y^2;

julia> c = two_block_group_algebra_code(A, B);

julia> import HiGHS

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(48, 4, 6)
```

### Coprime Bivariate Bicycle code

The coprime bivariate bicycle (BB) codes are defined by two polynomials `𝑎(𝑥,𝑦)` and `𝑏(𝑥,𝑦)`,
where `𝑙` and `𝑚` are coprime, and can be expressed as univariate polynomials `𝑎(𝜋)` and `𝑏(𝜋)`,
with generator `𝜋 = 𝑥𝑦`. They can be viewed as a special case of Lifted Product construction
based on abelian group `ℤₗ x ℤₘ` where `ℤⱼ` cyclic group of order `j`.

[[108, 12, 6]] coprime-bivariate bicycle (BB) code from Table 2 of [wang2024coprime](@cite).

```jldoctest
julia> import Hecke: group_algebra, GF, abelian_group, gens; using QuantumClifford.ECC;

julia> l=2; m=27;

julia> GA = group_algebra(GF(2), abelian_group([l*m]));

julia> 𝜋 = gens(GA)[1];

julia> A = 𝜋^2 + 𝜋^5  + 𝜋^44;

julia> B = 𝜋^8 + 𝜋^14 + 𝜋^47;

julia> c = two_block_group_algebra_code(A, B);

julia> import HiGHS

julia> code_n(c), code_k(c), distance(c, DistanceMIPAlgorithm(solver=HiGHS))
(108, 12, 6)
```
"""
function two_block_group_algebra_code(a::GroupAlgebraElem, b::GroupAlgebraElem)
    LPCode([a;;], [b;;])
end

"""
$TYPEDSIGNATURES

Generalized bicycle codes, which are a special case of *abelian* 2GBA codes (and therefore of lifted product codes).
Here the group is chosen as the cyclic group of order `l`,
and the base matrices `a` and `b` are the sum of the group algebra elements corresponding to the shifts `a_shifts` and `b_shifts`.

Behind the scenes, the shifts are converted to the corresponding group algebra elements and piped to [`two_block_group_algebra_code`](@ref).

See also: [`two_block_group_algebra_code`](@ref), [`bicycle_code_as_2bga`](@ref).

## Examples

A [[254, 28, 14 ≤ d ≤ 20]] code from (A1) in Appendix B of [panteleev2021degenerate](@cite).

```jldoctest
julia> import Hecke; using QuantumClifford.ECC

julia> c = generalized_bicycle_code_as_2bga([0, 15, 20, 28, 66], [0, 58, 59, 100, 121], 127);

julia> code_n(c), code_k(c)
(254, 28)
```

An [[70, 8, 10]] *abelian* 2BGA code from Table 1 of [lin2024quantum](@cite), with cyclic group of
order `l = 35`, illustrates that *abelian* 2BGA codes can be viewed as GB codes.

```jldoctest
julia> import Hecke; using QuantumClifford.ECC

julia> l = 35;

julia> c1 = generalized_bicycle_code_as_2bga([0, 15, 16, 18], [0, 1, 24, 27], l);

julia> code_n(c1), code_k(c1)
(70, 8)
```
"""
function generalized_bicycle_code_as_2bga(a_shifts::Array{Int}, b_shifts::Array{Int}, l::Int)
    GA = group_algebra(GF(2), abelian_group(l))
    a = sum(GA[n%l+1] for n in a_shifts)
    b = sum(GA[n%l+1] for n in b_shifts)
    two_block_group_algebra_code(a, b)
end

"""
$TYPEDSIGNATURES

Bicycle codes are a special case of generalized bicycle codes,
where `a` and `b` are conjugate to each other.
The order of the cyclic group is `l`, and the shifts `a_shifts` and `b_shifts` are reverse to each other.
Thus you need to provide only the `a_shifts` and the rest of the conversions and conjugations are taken care of.

See also: [`two_block_group_algebra_code`](@ref), [`generalized_bicycle_code_as_2bga`](@ref), [`Haah_cubic_code_as_2bga`](@ref).
""" # TODO doctest example
function bicycle_code_as_2bga(a_shifts::Array{Int}, l::Int)
    GA = group_algebra(GF(2), abelian_group(l))
    a = sum(GA[n÷l+1] for n in a_shifts)
    two_block_group_algebra_code(a, group_algebra_conj(a))
end

"""
$TYPEDSIGNATURES

Haah’s cubic codes [haah2011local](@cite) can be viewed as generalized bicycle (GB) codes
with the group `G = Cₗ × Cₗ × Cₗ`, where `l` denotes the lattice size. In particular, a GB
code with the group `G = ℤ₃ˣ³` corresponds to a cubic code.

Behind the scenes, this function is just a simple shortcut for preparing the group `G`,
before piping the arguments to [`generalized_bicycle_code_as_2bga`](@ref).

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/haah_cubic).

See also: [`bicycle_code_as_2bga`](@ref), [`generalized_bicycle_code_as_2bga`](@ref), [`two_block_group_algebra_code`](@ref).

## Examples

```jldoctest
julia> import Hecke; using QuantumClifford.ECC;

julia> c = Haah_cubic_code_as_2bga([0, 15, 20, 28, 66], [0, 58, 59, 100, 121], 6);

julia> code_n(c), code_k(c)
(432, 8)
```
"""
function Haah_cubic_code_as_2bga(a_shifts::Array{Int}, b_shifts::Array{Int}, l::Int)
    GA = group_algebra(GF(2), abelian_group([l,l,l]))
    a = sum(GA[n%dim(GA)+1] for n in a_shifts)
    b = sum(GA[n%dim(GA)+1] for n in b_shifts)
    two_block_group_algebra_code(a, b)
end

"""
Haah’s cubic code is defined as ``\\text{LP}(1 + x + y + z, 1 + xy + xz + yz)``
where ``\\text{LP}`` is the lifted product code, and `x`, `y`, `z` are elements
of the ring ``R = \\mathbb{F}_2[x, y, z] / (x^L - 1, y^L - 1, z^L - 1)``. Here
``\\mathbb{F}_2`` is the finite field of order `2` and `L` is the lattice size.
The ring ``R`` is the group algebra ``\\mathbb{F}_qG`` of a finite group `G`, where
``G = (C_L)^3`` and ``C_L`` is the cyclic group of order `L`. This method of Haah's
cubic code construction is outlined in Appendix B of [panteleev2022asymptotically](@cite).

Here is an example of a `[[1024, 30, 13 ≤ d ≤ 32]]` Haah's cubic code from Appendix B,
code D of [panteleev2021degenerate](@cite) on the `8 × 8 × 8` Lattice.

```jldoctest
julia> import Hecke; using QuantumClifford.ECC;

julia> l = 8;

julia> c = Haah_cubic_code_as_2bga(l);

julia> code_n(c), code_k(c)
(1024, 30)
```

See also: [`bicycle_code_as_2bga`](@ref), [`generalized_bicycle_code_as_2bga`](@ref), [`two_block_group_algebra_code`](@ref),
[`honeycomb_color_code_as_2bga`](@ref).
"""
function Haah_cubic_code_as_2bga(l::Int)
    GA = group_algebra(GF(2), abelian_group([l,l,l]))
    x, y, z = gens(GA)
    c = 1 + x + y + z
    d = 1 + x*y + x*z + y*z
    two_block_group_algebra_code(c, d)
end

"""
The honeycomb color codes [eberhardt2024logical](@cite) are exactly the Bivariate
Bicycle (BB) codes defined by the polynomials `c = 1 + x + xy` and `d = 1 + y + xy`,
provided that both `l` and `m` are divisible by three. This `6.6.6` code is an example of BB
code, as it represents a special case.

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/triangular_color).

```jldoctest
julia> import Hecke; using QuantumClifford.ECC;

julia> l = 9; m = 6;

julia> c = honeycomb_color_code_as_2bga(l, m);

julia> code_n(c), code_k(c)
(108, 4)
```

See also: [`bicycle_code_as_2bga`](@ref), [`generalized_bicycle_code_as_2bga`](@ref), [`two_block_group_algebra_code`](@ref),
[`honeycomb_color_code_as_2bga`](@ref).
"""
function honeycomb_color_code_as_2bga(l::Int, m::Int)
    (l % 3 == 0 && m % 3 == 0) || throw(ArgumentError("Both l and m must be divisible by 3"))
    GA = group_algebra(GF(2), abelian_group([l, m]))
    x, y = gens(GA)
    c = 1 + x + x*y
    d = 1 + y + x*y
    two_block_group_algebra_code(c, d)
end

module QuantumCliffordPyQDecodersExt

using PyQDecoders: np, sps, ldpc, pm, PythonCall
using SparseArrays
using QuantumClifford
using QuantumClifford.ECC
using QECCore
import QuantumClifford.ECC: AbstractSyndromeDecoder, decode, batchdecode, parity_checks

abstract type PyBP <: AbstractSyndromeDecoder end

struct PyBeliefPropDecoder <: PyBP # TODO all these decoders have the same fields, maybe we can factor out a common type
    code
    H
    Hx
    Hz
    nx
    nz
    faults_matrix
    pyx
    pyz
end

struct PyBeliefPropOSDecoder <: PyBP # TODO all these decoders have the same fields, maybe we can factor out a common type
    code
    H
    Hx
    Hz
    nx
    nz
    faults_matrix
    pyx
    pyz
end

function PyBeliefPropDecoder(c; maxiter=nothing, bpmethod=nothing, errorrate=nothing)
    Hx = reinterpret(UInt8,collect(parity_matrix_x(c)))
    Hz = reinterpret(UInt8,collect(parity_matrix_z(c)))
    H = parity_checks(c)
    fm = faults_matrix(c)
    max_iter=isnothing(maxiter) ? 0 : maxiter
    bpmethod ∈ (nothing, :productsum, :minsum) || error(lazy"PyBeliefPropDecoder got an unknown belief propagation method argument. `bpmethod` must be one of :productsum, :minsum.")
    bp_method = get(Dict(:productsum => "product_sum", :minsum => "minimum_sum"), bpmethod, "minimum_sum")
    isnothing(errorrate) || 0≤errorrate≤1 || error(lazy"PyBeliefPropDecoder got an invalid error rate argument. `errorrate` must be in the range [0, 1].")
    error_rate = isnothing(errorrate) ? PythonCall.Py(0.0001) : errorrate
    pyx = ldpc.BpDecoder(np.array(Hx); max_iter, bp_method, error_rate) # TODO should be sparse
    pyz = ldpc.BpDecoder(np.array(Hz); max_iter, bp_method, error_rate) # TODO should be sparse
    return PyBeliefPropDecoder(c, H, Hx, Hz, size(Hx, 1), size(Hz, 1), fm, pyx, pyz)
end

function PyBeliefPropOSDecoder(c; maxiter=nothing, bpmethod=nothing, errorrate=nothing, osdmethod=nothing, osdorder=0)
    Hx = reinterpret(UInt8,collect(parity_matrix_x(c)))
    Hz = reinterpret(UInt8,collect(parity_matrix_z(c)))
    H = parity_checks(c)
    fm = faults_matrix(c)
    max_iter=isnothing(maxiter) ? 0 : maxiter
    bpmethod ∈ (nothing, :productsum, :minsum) || error(lazy"PyBeliefPropOSDecoder got an unknown belief propagation method argument. `bpmethod` must be one of :productsum, :minsum.")
    bp_method = get(Dict(:productsum => "product_sum", :minsum => "minimum_sum"), bpmethod, "minimum_sum")
    isnothing(errorrate) || 0≤errorrate≤1 || error(lazy"PyBeliefPropOSDecoder got an invalid error rate argument. `errorrate` must be in the range [0, 1].")
    error_rate = isnothing(errorrate) ? PythonCall.Py(0.0001) : errorrate
    isnothing(osdmethod) || osdmethod ∈ (:zeroorder, :exhaustive, :combinationsweep) || error(lazy"PyBeliefPropOSDecoder got an unknown OSD method argument. `osdmethod` must be one of :zeroorder, :exhaustive, :combinationsweep.")
    osd_method = get(Dict(:zeroorder => "OSD_0", :exhaustive => "OSD_E", :combinationsweep => "OSD_CS"), osdmethod, 0)
    osdorder≥0 || error(lazy"PyBeliefPropOSDecoder got an invalid OSD order argument. `osdorder` must be ≥0.")
    osd_order = osdorder
    pyx = ldpc.BpOsdDecoder(np.array(Hx); max_iter, bp_method, error_rate, osd_method, osd_order) # TODO should be sparse
    pyz = ldpc.BpOsdDecoder(np.array(Hz); max_iter, bp_method, error_rate, osd_method, osd_order) # TODO should be sparse
    return PyBeliefPropOSDecoder(c, H, Hx, Hz, size(Hx, 1), size(Hz, 1), fm, pyx, pyz)
end

parity_checks(d::PyBP) = d.H

function decode(d::PyBP, syndrome_sample)
    row_x = @view syndrome_sample[1:d.nx] # TODO figure out a lower-overhead way to move data to python (and make sure the ecc wiki still works after that change -- a lot of the cruft here is because of rare crashes when running the wiki evaluator)
    row_z = @view syndrome_sample[d.nx+1:end]
    PythonCall.GIL.@lock begin
        guess_z_errors = PythonCall.PyArray(d.pyx.decode(PythonCall.Py(row_x).to_numpy()))
        guess_x_errors = PythonCall.PyArray(d.pyz.decode(PythonCall.Py(row_z).to_numpy()))
        vcat(guess_x_errors, guess_z_errors)
    end
end

struct PyMatchingDecoder <: AbstractSyndromeDecoder # TODO all these decoders have the same fields, maybe we can factor out a common type
    code
    H
    Hx
    Hz
    nx
    nz
    faults_matrix
    pyx
    pyz
end

function PyMatchingDecoder(c; weights=nothing)
    Hx = parity_matrix_x(c) |> collect # TODO keep these sparse
    Hz = parity_matrix_z(c) |> collect
    H = parity_checks(c)
    fm = faults_matrix(c)
    if isnothing(weights)
        pyx = pm.Matching.from_check_matrix(Hx)
        pyz = pm.Matching.from_check_matrix(Hz)
    else
        pyx = pm.Matching.from_check_matrix(Hx, weights=weights)
        pyz = pm.Matching.from_check_matrix(Hz, weights=weights)
    end
    return PyMatchingDecoder(c, H, Hx, Hz, size(Hx, 1), size(Hz, 1), fm, pyx, pyz)
end

parity_checks(d::PyMatchingDecoder) = d.H

function decode(d::PyMatchingDecoder, syndrome_sample)
    row_x = @view syndrome_sample[1:d.nx]
    row_z = @view syndrome_sample[d.nx+1:end]
    PythonCall.GIL.@lock begin
        guess_z_errors = PythonCall.PyArray(d.pyx.decode(PythonCall.Py(row_x).to_numpy()))
        guess_x_errors = PythonCall.PyArray(d.pyz.decode(PythonCall.Py(row_z).to_numpy()))
        vcat(guess_x_errors, guess_z_errors)
    end
end

function batchdecode(d::PyMatchingDecoder, syndrome_samples)
    row_x = @view syndrome_samples[:,1:d.nx]
    row_z = @view syndrome_samples[:,d.nx+1:end]
    guess_z_errors = PythonCall.PyArray(d.pyx.decode_batch(row_x))
    guess_x_errors = PythonCall.PyArray(d.pyz.decode_batch(row_z))
    n_cols_x = size(guess_x_errors, 2)
    hcat(guess_x_errors, guess_z_errors)
end

end

using QuantumClifford:Register, AbstractOperation, applywstatus!, PauliOperator
import QuantumClifford:affectedqubits,affectedbits,applybranches

"""Applies a Pauli correction on the `data_qubits` determined by the `decoder` using the corresponding `syndrome_bits` from the classical register."""
struct DecoderCorrectionGate <: AbstractOperation
    decoder::AbstractSyndromeDecoder# just a function that maps inputbits to an operation on affectedqubits
    data_qubits::Vector{Int}
    syndrome_bits::Vector{Int}

    function DecoderCorrectionGate(dec::AbstractSyndromeDecoder, data_qubits, syndrome_bits)
        qs = collect(Int, data_qubits)
        bs = collect(Int, syndrome_bits)
        bits, qubits = size(parity_checks(dec))
        if length(qs)!=qubits
            throw(ArgumentError(lazy"Decoder expects $qubits qubits, got $(length(data_qubits))"))
        end
        if length(bs)!=bits
            throw(ArgumentError(lazy"Decoder expects $bits bits, got $(length(syndrome_bits))"))
        end
        return new(dec, qs,bs)
    end
end

function QuantumClifford.apply!(state::Register, op::DecoderCorrectionGate)
    targets = op.data_qubits
    key = Vector{Bool}(state.bits[op.syndrome_bits])
    all(iszero, key) && return state
    correction = decode(op.decoder, key)
    correction === nothing && return state
    pauli_operator = PauliOperator(correction)
    apply!(state, targets, pauli_operator)
    return state
end

applybranches(s::Register, op::DecoderCorrectionGate; max_order=1) = [(applywstatus!(copy(s),op)...,1,0)]

affectedqubits(op::DecoderCorrectionGate) = op.data_qubits
affectedbits(op::DecoderCorrectionGate)   = op.syndrome_bits

"""Implemented in a package extension with Hecke."""
function check_repr_commutation_relation end

"""Implemented in a package extension with Hecke."""
function check_repr_regular_linear end

"""Implemented as a package extension with Hecke. Check the [QuantumClifford documentation](http://qc.quantumsavory.org/stable/ECC_API/) for more details on that extension."""
function random_qc_ghp_code_matrix_A end

abstract type AbstractPolynomialCode <: AbstractCECC end

"""
The family of Bose–Chaudhuri–Hocquenghem (BCH) codes, as discovered in 1959 by
Alexis Hocquenghem [hocquenghem1959codes](@cite), and independently in 1960 by
Raj Chandra Bose and D.K. Ray-Chaudhuri [bose1960class](@cite).

The BCH code, denoted as `BCH(m, t)`, is defined by `m`, a positive integer that
specifies the degree of the finite (Galois) field `GF(2ᵐ)`, and `t`, a positive
integer that indicates the number of correctable errors. The binary parity check
matrix can be obtained from the following matrix over ``GF(2ᵐ)`` field elements:

```math
\\begin{aligned}
\\begin{matrix}
1 & (\\alpha^1)^1 & (\\alpha^1)^2 & (\\alpha^1)^3 & \\dots & (\\alpha^1)^{n-1} \\\\
1 & (\\alpha^3)^1 & (\\alpha^3)^2 & (\\alpha^3)^3 & \\dots & (\\alpha^3)^{n-1} \\\\
1 & (\\alpha^5)^1 & (\\alpha^5)^2 & (\\alpha^5)^3 & \\dots & (\\alpha^5)^{n-1} \\\\
\\vdots & \\vdots & \\vdots & \\vdots & \\ddots & \\vdots \\\\
1 & (\\alpha^{2t-1})^1 & (\\alpha^{2t-1})^2 & (\\alpha^{2t-1})^3 & \\dots & (\\alpha^{2t-1})^{n-1}
\\end{matrix}
\\end{aligned}
```

The entries of the matrix are in `GF(2ᵐ)`. Each element in `GF(2ᵐ)` can be represented
by an `m`-tuple (a binary column vector of length `m`). If each entry of `H` is replaced
by its corresponding `m`-tuple, we obtain a binary parity check matrix for the code.

The BCH code is cyclic as its generator polynomial, `g(x)` divides `xⁿ - 1`, so
`mod (xⁿ - 1, g(x)) = 0`.

You might be interested in consulting [bose1960further](@cite) and [error2024lin](@cite)
as well.

The ECC Zoo has an [entry for this family](https://errorcorrectionzoo.org/c/q-ary_bch).
"""
struct BCH <: AbstractPolynomialCode
    m::Int
    t::Int
    function BCH(m, t)
        m < 3 && throw(ArgumentError("m must be greater than or equal to 3"))
        t >= 2^(m - 1) && throw(ArgumentError("t must be less than 2ᵐ ⁻ ¹"))
        m * t > 2^m - 1 && throw(ArgumentError("m*t must be less than or equal to 2ᵐ - 1"))
        new(m, t)
    end
end

"""
Generator Polynomial of BCH Codes

This function calculates the generator polynomial `g(x)` of a `t`-bit error-correcting
BCH code of binary length `n = 2ᵐ - 1`. The binary code is derived from a code over the
finite Galois field `GF(2ᵐ)`.

The generator polynomial `g(x)` is the fundamental polynomial used for encoding and
decoding BCH codes. It has the following properties:

- Roots: It has `α`, `α²`, `α³`, ..., `α²ᵗ` as its roots, where `α` is a primitive element
of the Galois Field `GF(2ᵐ)`.
- Error Correction: A BCH code with generator polynomial `g(x)` can correct up to `t` errors
in a codeword of length `2ᵐ - 1`.
- Minimal Polynomials: `g(x)` is the least common multiple (LCM) of the minimal polynomials
`φᵢ(x)` of `αⁱ` for `i` from `1` to `2ᵗ`.

Useful definitions and background:

Minimal Polynomial: The minimal polynomial of a field element `α` in GF(2ᵐ) is the polynomial
of the lowest degree over `GF(2ᵐ)` that has `α` as a root.

Least Common Multiple (LCM): The LCM of two or more polynomials `fᵢ(x)` is the polynomial
with the lowest degree that is a multiple of all `fᵢ(x)`. It ensures that `g(x)` has all
the roots of `φᵢ(x)` for `i = 1` to `2ᵗ`.

Conway polynomial: The finite Galois field `GF(2ᵐ)` can have multiple distinct primitive
polynomials of the same degree due to existence of several irreducible polynomials of that
degree, each generating the field through different roots.

Nemo.jl uses [Conway polynomial](https://en.wikipedia.org/wiki/Conway_polynomial_(finite_fields)),
a standard way to represent the primitive polynomial for finite Galois fields `GF(pᵐ)` of degree
`m`, where `p` is a prime number.
"""
function generator_polynomial(b::BCH)
    GF2ʳ, a = finite_field(2, b.m, "a")
    GF2x, x = GF(2)["x"]
    minimal_poly = FqPolyRingElem[]
    for i in 1:2 * b.t
        if i % 2 != 0
            push!(minimal_poly, minpoly(GF2x, a ^ i))
        end
    end
    gx = lcm(minimal_poly)
    return gx
end

function parity_matrix(b::BCH)
    GF2ʳ, a = finite_field(2, b.m, "a")
    HField = Matrix{FqFieldElem}(undef, b.t, 2 ^ b.m - 1)
    for i in 1:b.t
        for j in 1:2 ^ b.m - 1
            base = 2 * i - 1
            HField[i, j] = (a ^ base) ^ (j - 1)
        end
    end
    H = Matrix{Bool}(undef, b.m * b.t, 2 ^ b.m - 1)
    for i in 1:b.t
        row_start = (i - 1) * b.m + 1
        row_end = row_start + b.m - 1
        for j in 1:2 ^ b.m - 1
            t_tuple = Bool[]
            for k in 0:b.m - 1
                push!(t_tuple, !is_zero(coeff(HField[i, j], k)))
            end
            H[row_start:row_end, j] .=  vec(t_tuple')
        end
    end
    return H
end

code_n(b::BCH) = 2 ^ b.m - 1

code_k(b::BCH) = 2 ^ b.m - 1 - degree(generator_polynomial(BCH(b.m, b.t)))

@testitem "ECC 2BGA" tags=[:ecc, :ecc_bespoke_checks] begin
    using Hecke
    using JuMP
    using HiGHS
    using Hecke: group_algebra, GF, abelian_group, gens
    using QuantumClifford.ECC: two_block_group_algebra_code, code_k, code_n, distance, DistanceMIPAlgorithm;

    @testset "Reproduce Table 2 lin2024quantum" begin
        # codes taken from Table 2 of [lin2024quantum](@cite)

        # m = 4
        GA = group_algebra(GF(2), abelian_group([4,2]))
        x, s = gens(GA)
        A = 1 + x
        B = 1 + x + s + x^2 + s*x + s*x^3
        c = two_block_group_algebra_code(A,B)
        # [[16, 2, 4]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
        @test code_n(c) == 16 && code_k(c) == 2
        A = 1 + x
        B = 1 + x + s + x^2 + s*x + x^3
        c = two_block_group_algebra_code(A,B)
        # [[16, 4, 4]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
        @test code_n(c) == 16 && code_k(c) == 4
        A = 1 + s
        B = 1 + x + s + x^2 + s*x + x^2
        c = two_block_group_algebra_code(A,B)
        # [[16, 8, 2]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test code_n(c) == 16 && code_k(c) == 8

        # m = 6
        GA = group_algebra(GF(2), abelian_group([6,2]))
        x, s = gens(GA)
        A = 1 + x
        B = 1 + x^3 + s + x^4 + x^2 + s*x
        c = two_block_group_algebra_code(A,B)
        # [[24, 4, 5]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
        @test code_n(c) == 24 && code_k(c) == 4
        A = 1 + x^3
        B = 1 + x^3 + s + x^4 + s*x^3 + x
        c = two_block_group_algebra_code(A,B)
        # [[24, 12, 2]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test code_n(c) == 24 && code_k(c) == 12

        # m = 8
        GA = group_algebra(GF(2), abelian_group([8,2]))
        x, s = gens(GA)
        A = 1 + x^6
        B = 1 + s*x^7 + s*x^4 + x^6 + s*x^5 + s*x^2
        c = two_block_group_algebra_code(A,B)
        # [[32, 8, 4]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
        @test code_n(c) == 32 && code_k(c) == 8
        A = 1 + s*x^4
        B = 1 + s*x^7 + s*x^4 + x^6 + x^3 + s*x^2
        c = two_block_group_algebra_code(A,B)
        # [[32, 16, 2]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test code_n(c) == 32 && code_k(c) == 16

        # m = 10
        GA = group_algebra(GF(2), abelian_group([10,2]))
        x, s = gens(GA)
        A = 1 + x
        B = 1 + x^5 + x^6 + s*x^6 + x^7 + s*x^3
        c = two_block_group_algebra_code(A,B)
        # [[40, 4, 8]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 8
        @test code_n(c) == 40 && code_k(c) == 4
        A = 1 + x^6
        B = 1 + x^5 + s + x^6 + x + s*x^2
        c = two_block_group_algebra_code(A,B)
        # [[40, 8, 5]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 5
        @test code_n(c) == 40 && code_k(c) == 8
        A = 1 + x^5
        B = 1 + x^5 + s + x^6 + s*x^5 + x
        c = two_block_group_algebra_code(A,B)
        # [[40, 20, 2]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test code_n(c) == 40 && code_k(c) == 20

        # m = 12
        GA = group_algebra(GF(2), abelian_group([12,2]))
        x, s = gens(GA)
        A = 1 + s*x^10
        B = 1 + x^3 + s*x^6 + x^4 + x^7 + x^8
        c = two_block_group_algebra_code(A,B)
        # [[48, 8, 6]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 6
        @test code_n(c) == 48 && code_k(c) == 8
        A = 1 + x^3
        B = 1 + x^3 + s*x^6 + x^4 + s*x^9 + x^7
        c = two_block_group_algebra_code(A,B)
        # [[48, 12, 4]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 4
        @test code_n(c) == 48 && code_k(c) == 12
        A = 1 + x^4
        B = 1 + x^3 + s*x^6 + x^4 + x^7 + s*x^10
        c = two_block_group_algebra_code(A,B)
        # [[48, 16, 3]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 3
        @test code_n(c) == 48 && code_k(c) == 16
        A = 1 + s*x^6
        B = 1 + x^3 + s*x^6 + x^4 + s*x^9 + s*x^10
        c = two_block_group_algebra_code(A,B)
        # [[48, 24, 2]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test code_n(c) == 48 && code_k(c) == 24

        # m = 14
        GA = group_algebra(GF(2), abelian_group([14,2]))
        x, s = gens(GA)
        A = 1 + x^8
        B = 1 + x^7 + s + x^8 + x^9 + s*x^4
        c = two_block_group_algebra_code(A,B)
        # [[56, 8, 7]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 7
        @test code_n(c) == 56 && code_k(c) == 8
        A = 1 + x^7
        B = 1 + x^7 + s + x^8 + s*x^7 + x
        c = two_block_group_algebra_code(A,B)
        # [[56, 28, 2]] 2BGA code
        @test distance(c, DistanceMIPAlgorithm(solver=HiGHS)) == 2
        @test code_n(c) == 56 && code_k(c) == 28
    end
end

include("implementation/benchmark_platform.jl")

using Dates: value, now, UNIXEPOCH
import pocl_jll
using OpenCL: CLArray, cl.devices, cl.platforms, cl.finish, cl.queue
const AT = CLArray
const path = "OpenCL_benchmark_" * string(value(now()) - UNIXEPOCH)

const can_run = any(length(devices(platform)) > 0 for platform in platforms())

if can_run
    synchronize() = finish(queue())
    benchmark_platform(AT, synchronize, path)
else
    @info "Unable to run OpenCL benchmark. No suitable device was found."
end

abstract type OperatorDeterminismTrait end

struct DeterministicOperatorTrait <: OperatorDeterminismTrait end
struct NondeterministicOperatorTrait <: OperatorDeterminismTrait end

operatordeterminism(::Type{<:AbstractCliffordOperator}) = DeterministicOperatorTrait()
operatordeterminism(::Type{<:AbstractOperation}) = NondeterministicOperatorTrait()

@testitem "GPU Canonicalization" tags=[:cuda] begin
    using CUDA
    using QuantumClifford
    using Random
    using QuantumClifford: to_cpu, to_gpu, random_tableau
    
    if CUDA.functional()
        @testset "GPU canonicalize! correctness" begin
            for n in [10, 50, 100]
                cpu_stab = random_stabilizer(n)
                gpu_stab = to_gpu(cpu_stab)
                cpu_result = canonicalize!(copy(cpu_stab))
                gpu_result = canonicalize!(copy(gpu_stab))
                cpu_from_gpu = to_cpu(gpu_result)
                @test cpu_result == cpu_from_gpu
            end
        end
        
        @testset "GPU canonicalize! performance" begin
            n = 6000  # Large enough to see GPU benefit
            # Only linear independence is required to achieve full rank.
            # Occurs with unit probability for arbitrarily large qubit counts.
            cpu_stab = Stabilizer(random_tableau(n, n))
            gpu_stab = to_gpu(cpu_stab)
            canonicalize!(copy(gpu_stab))
            gpu_time = @elapsed canonicalize!(copy(gpu_stab))
            # Sanity check, note that for 6000 size Stabilizer cpu version takes 1900-2400 ms on average
            @test 1000 * gpu_time < 1900
        end
        
        @testset "GPU canonicalize! phases option" begin
            n = 50
            cpu_stab = random_stabilizer(n)
            gpu_stab = to_gpu(cpu_stab)
            gpu_result_no_phases = canonicalize!(copy(gpu_stab); phases=false)
            cpu_result_no_phases = canonicalize!(copy(cpu_stab); phases=false)
            
            @test to_cpu(gpu_result_no_phases) == cpu_result_no_phases
        end
    else
        @test_skip "CUDA not functional, skipping GPU canonicalization tests"
    end
end

module QuantumCliffordPyTesseractDecoderExt

using PyTesseractDecoder: tesseract, stim, np, PythonCall
using SparseArrays
using QuantumClifford
using QECCore

import QuantumClifford.ECC
import QuantumClifford.ECC: AbstractSyndromeDecoder, decode, batchdecode, parity_checks

# based on https://github.com/quantumlib/tesseract-decoder/issues/153
function _dem_from_check_matrices(
    check_matrix::SparseMatrixCSC{Bool, Int},
    observables_matrix::SparseMatrixCSC{Bool, Int},
    priors::AbstractVector{<:Real},
)
    num_detectors, num_errors = size(check_matrix)
    num_observables, num_errors2 = size(observables_matrix)
    num_errors == num_errors2 || throw(ArgumentError("check and observable matrices must have the same number of columns"))
    length(priors) == num_errors || throw(DimensionMismatch("expected priors of length $num_errors, got $(length(priors))"))

    dem = stim.DetectorErrorModel()

    for error_col in 1:num_errors
        p = Float64(priors[error_col])
        (0.0 <= p <= 1.0) || throw(DomainError(priors[error_col], "priors must be in the range [0, 1]"))

        targets = PythonCall.Py[]

        for nzidx in nzrange(check_matrix, error_col)
            check_matrix.nzval[nzidx] || continue
            det = check_matrix.rowval[nzidx] - 1
            (0 <= det < num_detectors) || continue
            push!(targets, stim.target_relative_detector_id(det))
        end

        for nzidx in nzrange(observables_matrix, error_col)
            observables_matrix.nzval[nzidx] || continue
            obs = observables_matrix.rowval[nzidx] - 1
            (0 <= obs < num_observables) || continue
            push!(targets, stim.target_logical_observable_id(obs))
        end

        isempty(targets) && continue

        dem.append(stim.DemInstruction(type="error", args=[p], targets=targets))
    end

    return dem
end

function _symptom_to_column_map(
    check_matrix::SparseMatrixCSC{Bool, Int},
    observables_matrix::SparseMatrixCSC{Bool, Int},
)
    num_detectors, num_errors = size(check_matrix)
    num_observables, num_errors2 = size(observables_matrix)
    num_errors == num_errors2 || throw(ArgumentError("check and observable matrices must have the same number of columns"))

    symptom_to_column = Dict{Tuple{Tuple{Vararg{Int}}, Tuple{Vararg{Int}}}, Int}()
    dets = Int[]
    obs = Int[]

    for error_col in 1:num_errors
        empty!(dets)
        empty!(obs)

        for nzidx in nzrange(check_matrix, error_col)
            check_matrix.nzval[nzidx] || continue
            det = check_matrix.rowval[nzidx] - 1
            (0 <= det < num_detectors) || continue
            push!(dets, det)
        end

        for nzidx in nzrange(observables_matrix, error_col)
            observables_matrix.nzval[nzidx] || continue
            o = observables_matrix.rowval[nzidx] - 1
            (0 <= o < num_observables) || continue
            push!(obs, o)
        end

        sort!(dets)
        sort!(obs)
        key = (Tuple(dets), Tuple(obs))
        get!(symptom_to_column, key, error_col)
    end

    return symptom_to_column
end

struct TesseractDecoder <: AbstractSyndromeDecoder
    H
    faults_matrix
    n::Int
    s::Int
    k::Int
    decoder
    error_to_column::Vector{Int}
    nerrors::Int
end

function TesseractDecoder(c; det_beam::Integer=50, priors=nothing, errorrate=nothing)
    H = parity_checks(c)
    s, n = size(H)
    fm = ECC.faults_matrix(H)
    nerrors = 2n

    isnothing(errorrate) || 0 <= errorrate <= 1 || throw(DomainError(errorrate, "`errorrate` must be in the range [0, 1]"))

    prior_vec =
        if !isnothing(priors)
            collect(priors)
        elseif !isnothing(errorrate)
            fill(Float64(errorrate), nerrors)
        else
            fill(0.0001, nerrors)
        end
    length(prior_vec) == nerrors || throw(DimensionMismatch("expected priors of length $nerrors, got $(length(prior_vec))"))

    stab = QuantumClifford.stab_to_gf2(H) # [X | Z]
    check_dense = hcat(@view(stab[:, n+1:end]), @view(stab[:, 1:n])) # [Z | X], maps [X_errors; Z_errors] -> syndrome

    check_sparse = sparse(check_dense)
    fm_sparse = sparse(fm)
    dem = _dem_from_check_matrices(check_sparse, fm_sparse, prior_vec)
    config = tesseract.TesseractConfig(dem=dem, det_beam=Int(det_beam))
    decoder = config.compile_decoder()

    symptom_to_column = _symptom_to_column_map(check_sparse, fm_sparse)
    n_decoder_errors = PythonCall.pyconvert(Int, PythonCall.pybuiltins.len(decoder.errors))
    error_to_column = zeros(Int, n_decoder_errors)
    PythonCall.GIL.@lock begin
        for idx0 in 0:(n_decoder_errors - 1)
            sym = decoder.errors[idx0].symptom
            dets = sort(PythonCall.pyconvert(Vector{Int}, sym.detectors))
            obs = sort(PythonCall.pyconvert(Vector{Int}, sym.observables))
            col = get(symptom_to_column, (Tuple(dets), Tuple(obs)), 0)
            error_to_column[idx0 + 1] = col
        end
    end
    any(==(0), error_to_column) && throw(ArgumentError("unable to map some compiled decoder error indices back to original error columns"))

    k = size(fm, 1) ÷ 2
    return TesseractDecoder(H, fm, n, s, k, decoder, error_to_column, nerrors)
end

parity_checks(d::TesseractDecoder) = d.H

function decode(d::TesseractDecoder, syndrome_sample)
    _s = length(syndrome_sample)
    d.s == _s || throw(ArgumentError(lazy"The syndrome given to `decode` has the wrong dimensions. The syndrome length is $(_s) while it should be $(d.s)"))

    guess = falses(d.nerrors)
    PythonCall.GIL.@lock begin
        idxs = PythonCall.pyconvert(Vector{Int}, d.decoder.decode_to_errors(PythonCall.Py(syndrome_sample).to_numpy()))
        for idx0 in idxs
            (0 <= idx0 < length(d.error_to_column)) || continue
            guess[d.error_to_column[idx0 + 1]] = true
        end
    end
    return guess
end

function batchdecode(d::TesseractDecoder, syndrome_samples)
    samples, _s = size(syndrome_samples)
    d.s == _s || throw(ArgumentError(lazy"The syndromes given to `batchdecode` have the wrong dimensions. The syndrome length is $(_s) while it should be $(d.s)"))

    results = falses(samples, d.nerrors)
    PythonCall.GIL.@lock begin
        for (i, syndrome_sample) in enumerate(eachrow(syndrome_samples))
            idxs = PythonCall.pyconvert(Vector{Int}, d.decoder.decode_to_errors(PythonCall.Py(syndrome_sample).to_numpy()))
            for idx0 in idxs
                (0 <= idx0 < length(d.error_to_column)) || continue
                results[i, d.error_to_column[idx0 + 1]] = true
            end
        end
    end
    return results
end

end

@testitem "Stabilizer-state expectations" begin
    using LinearAlgebra
    using Random
    using StableRNGs
    using Test
    using QuantumClifford
    using QuantumInterface

    function signed_stabilizer_group(state)
        group = [zero(PauliOperator, nqubits(state))]
        for generator in stabilizerview(state)
            products = [generator * element for element in group]
            append!(group, products)
        end
        group
    end

    function expansion_expect(operator_state, state; indices=nothing)
        paulis = signed_stabilizer_group(operator_state)
        if !isnothing(indices)
            paulis = [embed(nqubits(state), indices, pauli) for pauli in paulis]
        end
        value = exp2(-nqubits(operator_state)) * sum(pauli -> expect(pauli, state), paulis)
        @test isreal(value)
        Float64(real(value))
    end

    mixed_state(rng, rank, qubits) = rank == 0 ? maximally_mixed(qubits) :
        MixedDestabilizer(random_stabilizer(rng, rank, qubits))

    function repack_state(state, ::Type{T}) where {T<:Unsigned}
        source_state = MixedDestabilizer(state)
        source = QuantumClifford.tab(source_state)
        target = zero(
            QuantumClifford.Tableau{Vector{UInt8},Matrix{T}},
            length(source),
            nqubits(source),
        )
        phases(target) .= UInt8.(phases(source))
        for row in eachindex(source), qubit in 1:nqubits(source)
            target[row, qubit] = source[row, qubit]
        end
        MixedDestabilizer(target, rank(source_state))
    end

    struct ZeroBasedIndices <: AbstractVector{Int}
        data::Vector{Int}
    end
    Base.size(indices::ZeroBasedIndices) = size(indices.data)
    Base.axes(indices::ZeroBasedIndices) = (0:(length(indices.data) - 1),)
    Base.getindex(indices::ZeroBasedIndices, index::Int) = indices.data[index + 1]

    @testset "pure states and signed generators" begin
        axes = (
            MixedDestabilizer(S"X"),
            MixedDestabilizer(S"Y"),
            MixedDestabilizer(S"Z"),
        )
        negative_axes = (
            MixedDestabilizer(S"-X"),
            MixedDestabilizer(S"-Y"),
            MixedDestabilizer(S"-Z"),
        )
        for (positive, negative) in zip(axes, negative_axes)
            @test expect(positive, positive) == 1.0
            @test expect(negative, negative) == 1.0
            @test expect(positive, negative) == 0.0
            @test expect(negative, positive) == 0.0
        end
        for first_axis in axes, second_axis in axes
            first_axis == second_axis && continue
            @test expect(first_axis, second_axis) ≈ 0.5
        end
        @test expect(MixedDestabilizer(S"-X"), MixedDestabilizer(S"-Y")) ≈ 0.5
        @test expect(MixedDestabilizer(S"X"), MixedDestabilizer(S"-Y")) ≈ 0.5

        bell_state = MixedDestabilizer(bell())
        product_state = MixedDestabilizer(S"Z_ _Z")
        @test expect(bell_state, product_state) ≈ 0.5
        @test expect(product_state, bell_state) ≈ 0.5
        @test expect(MixedDestabilizer(S"-YY ZZ"), bell_state) == 1.0
        @test expect(MixedDestabilizer(S"YY ZZ"), bell_state) == 0.0
    end

    @testset "rank-deficient states" begin
        maximally_mixed_one = maximally_mixed(1)
        maximally_mixed_two = maximally_mixed(2)
        rank_one = MixedDestabilizer(S"Z_")

        pure_z = MixedDestabilizer(S"Z")
        @test expect(pure_z, maximally_mixed_one) == 0.5
        @test expect(maximally_mixed_one, pure_z) == 0.5
        @test expect(maximally_mixed_one, maximally_mixed_one) == 0.5
        @test expect(maximally_mixed_two, maximally_mixed_two) == 0.25
        @test expect(rank_one, rank_one) == 0.5
        @test expect(MixedDestabilizer(S"Z_"), MixedDestabilizer(S"-Z_")) == 0.0
        @test expect(MixedDestabilizer(S"Z_"), MixedDestabilizer(S"X_")) == 0.25
    end

    @testset "redundant generators" begin
        redundant_pure = MixedDestabilizer(S"Z Z")
        pure = MixedDestabilizer(S"Z")
        @test expect(redundant_pure, pure) == 1.0
        @test expect(pure, redundant_pure) == 1.0
        @test expect(redundant_pure, redundant_pure) == 1.0
        @test fidelity(redundant_pure, pure) == 1.0

        redundant_mixed = MixedDestabilizer(S"Z_ Z_")
        mixed = MixedDestabilizer(S"Z_")
        pure_extension = MixedDestabilizer(S"Z_ _Z")
        @test expect(redundant_mixed, mixed) == 0.5
        @test expect(mixed, redundant_mixed) == 0.5
        @test expect(redundant_mixed, redundant_mixed) == 0.5
        @test fidelity(redundant_mixed, pure_extension) ≈ inv(sqrt(2))
        @test fidelity(pure_extension, redundant_mixed) ≈ inv(sqrt(2))
        @test_throws DomainError fidelity(redundant_mixed, mixed)

        redundant_bell = MixedDestabilizer(S"XX ZZ -YY")
        bell_state = MixedDestabilizer(bell())
        @test expect(redundant_bell, bell_state) == 1.0
        @test expect(bell_state, redundant_bell) == 1.0
        @test fidelity(redundant_bell, bell_state) == 1.0
    end

    @testset "ordered subsystem embedding" begin
        ghz_state = MixedDestabilizer(ghz(3))
        @test expect(
            1,
            MixedDestabilizer(S"Z"),
            MixedDestabilizer(bell()),
        ) == 0.5
        @test expect([1, 2], MixedDestabilizer(bell()), ghz_state) == 0.5
        @test expect((1, 3), MixedDestabilizer(bell()), ghz_state) == 0.5

        asymmetric_state = MixedDestabilizer(S"Z__ _Z_ -__Z")
        asymmetric_operator = MixedDestabilizer(S"Z_ -_Z")
        @test expect([1, 3], asymmetric_operator, asymmetric_state) == 1.0
        @test expect([3, 1], asymmetric_operator, asymmetric_state) == 0.0
        zero_based_indices = ZeroBasedIndices([1, 3])
        @test_throws ArgumentError expect(
            zero_based_indices,
            asymmetric_operator,
            asymmetric_state,
        )
        @test zero_based_indices.data == [1, 3]

        bell_state = MixedDestabilizer(bell())
        z_state = MixedDestabilizer(S"Z")
        @test_throws DimensionMismatch expect([1], bell_state, ghz_state)
        @test_throws ArgumentError expect([1, 1], bell_state, ghz_state)
        @test_throws ArgumentError expect([0], z_state, ghz_state)
        @test_throws ArgumentError expect([4], z_state, ghz_state)
        @test_throws DimensionMismatch expect(1, bell_state, ghz_state)
        @test_throws ArgumentError expect(0, z_state, ghz_state)
        @test_throws ArgumentError expect(4, z_state, ghz_state)
    end

    @testset "dimensions, representations, and immutability" begin
        @test_throws DimensionMismatch expect(
            MixedDestabilizer(S"Z"),
            MixedDestabilizer(S"ZZ"),
        )

        pure = S"XX ZZ"
        pure_representations = (
            MixedDestabilizer(copy(pure)),
            fastrow(MixedDestabilizer(copy(pure))),
            fastcolumn(MixedDestabilizer(copy(pure))),
        )
        for operator_state in pure_representations, state in pure_representations
            @test expect(operator_state, state) == 1.0
        end

        mixed = S"Z_"
        mixed_representations = (
            MixedDestabilizer(copy(mixed)),
            fastrow(MixedDestabilizer(copy(mixed))),
            fastcolumn(MixedDestabilizer(copy(mixed))),
        )
        for operator_state in mixed_representations, state in mixed_representations
            @test expect(operator_state, state) == 0.5
        end

        subsystem_state = canonicalize_noncomm(T"Z")
        subsystem_before = copy(subsystem_state)
        converted_subsystem_state = MixedDestabilizer(stabilizerview(subsystem_state))
        pure_z = MixedDestabilizer(S"Z")
        @test expect(converted_subsystem_state, pure_z) == 1.0
        @test expect(pure_z, converted_subsystem_state) == 1.0
        @test fidelity(converted_subsystem_state, pure_z) == 1.0
        @test subsystem_state == subsystem_before

        operator_state = MixedDestabilizer(S"-YY ZZ")
        state = MixedDestabilizer(bell())
        operator_before = copy(operator_state)
        state_before = copy(state)
        @test expect(operator_state, state) == 1.0
        @test operator_state == operator_before
        @test state == state_before

        indexed_operator = MixedDestabilizer(S"X_ _Z")
        indexed_state = MixedDestabilizer(ghz(3))
        indexed_operator_before = copy(indexed_operator)
        indexed_before = copy(indexed_state)
        @test expect(
            [3, 1],
            indexed_operator,
            indexed_state,
        ) == 0.25
        @test indexed_operator == indexed_operator_before
        @test indexed_state == indexed_before
    end

    @testset "packed word representations" begin
        for word_type in (UInt8, UInt16, UInt32, UInt64)
            packed_z = repack_state(MixedDestabilizer(S"Z"), word_type)
            packed_maximally_mixed = repack_state(maximally_mixed(1), word_type)
            @test expect(packed_z, packed_maximally_mixed) == 0.5
            @test expect((1,), packed_z, packed_maximally_mixed) == 0.5
            @test fidelity(packed_z, packed_maximally_mixed) ≈ inv(sqrt(2))

            packed_mixed = repack_state(MixedDestabilizer(S"Z_"), word_type)
            @test expect(packed_mixed, packed_mixed) == 0.5

            packed_pure = repack_state(MixedDestabilizer(bell()), word_type)
            @test expect(packed_pure, packed_pure) == 1.0
            @test fidelity(packed_pure, packed_pure) == 1.0
        end

        long_mixed = MixedDestabilizer([embed(65, 65, P"Z")])
        for word_type in (UInt8, UInt16, UInt32, UInt64)
            packed_long_mixed = repack_state(long_mixed, word_type)
            packed_z = repack_state(MixedDestabilizer(S"Z"), word_type)
            @test expect(packed_long_mixed, packed_long_mixed) == exp2(-64)
            @test expect((65,), packed_z, packed_long_mixed) == 1.0
            @test expect((1,), packed_z, packed_long_mixed) == 0.5
        end
    end

    @testset "independent signed-group expansion" begin
        rng = StableRNG(0x5a17)
        for qubits in 1:5, _ in 1:8
            operator_state = mixed_state(rng, rand(rng, 0:qubits), qubits)
            state = mixed_state(rng, rand(rng, 0:qubits), qubits)
            expected = expansion_expect(operator_state, state)
            value = expect(operator_state, state)
            reverse_value = expect(state, operator_state)
            @test value == reverse_value
            @test value ≈ expected
        end

        for state_qubits in 2:5, _ in 1:8
            operator_qubits = rand(rng, 1:state_qubits)
            operator_state = mixed_state(
                rng,
                rand(rng, 0:operator_qubits),
                operator_qubits,
            )
            state = mixed_state(rng, rand(rng, 0:state_qubits), state_qubits)
            indices = randperm(rng, state_qubits)[1:operator_qubits]
            @test expect(indices, operator_state, state) ==
                expansion_expect(operator_state, state; indices)
        end
    end

    @testset "root fidelity" begin
        @test QuantumClifford.fidelity === QuantumInterface.fidelity

        pure_pairs = (
            (MixedDestabilizer(S"Z"), MixedDestabilizer(S"Z")),
            (MixedDestabilizer(S"Z"), MixedDestabilizer(S"-Z")),
            (MixedDestabilizer(S"Z"), MixedDestabilizer(S"X")),
            (MixedDestabilizer(bell()), MixedDestabilizer(S"Z_ _Z")),
            (MixedDestabilizer(bell()), MixedDestabilizer(S"-YY ZZ")),
        )
        for (state1, state2) in pure_pairs
            @test fidelity(state1, state2) == dot(state1, state2)
        end

        mixed = maximally_mixed(1)
        pure_z = MixedDestabilizer(S"Z")
        @test fidelity(pure_z, mixed) == fidelity(mixed, pure_z)
        @test fidelity(pure_z, mixed) ≈ inv(sqrt(2))
        @test abs2(fidelity(pure_z, mixed)) ≈ expect(pure_z, mixed)

        rank_one = MixedDestabilizer(S"Z_")
        pure_extension = MixedDestabilizer(S"Z_ _Z")
        mutually_unbiased = MixedDestabilizer(S"X_ _X")
        @test fidelity(pure_extension, rank_one) ≈ inv(sqrt(2))
        @test abs2(fidelity(mutually_unbiased, rank_one)) ==
            expect(mutually_unbiased, rank_one) == 0.25
        @test fidelity(MixedDestabilizer(S"-Z_ _Z"), rank_one) == 0.0

        @test_throws DomainError fidelity(maximally_mixed(1), maximally_mixed(1))
        @test_throws DomainError fidelity(
            MixedDestabilizer(S"Z_"),
            MixedDestabilizer(S"X_"),
        )
        @test_throws DimensionMismatch fidelity(
            MixedDestabilizer(S"Z"),
            MixedDestabilizer(S"ZZ"),
        )

        pure_state = MixedDestabilizer(bell())
        mixed_state_value = MixedDestabilizer(S"ZZ")
        pure_before = copy(pure_state)
        mixed_before = copy(mixed_state_value)
        @test fidelity(pure_state, mixed_state_value) ≈ inv(sqrt(2))
        @test pure_state == pure_before
        @test mixed_state_value == mixed_before
    end
end

@testitem "Symbolic Clifford" begin
    using Random
    using QuantumClifford: stab_looks_good, destab_looks_good, mixed_stab_looks_good, mixed_destab_looks_good
    using QuantumClifford: apply_single_x!, apply_single_y!, apply_single_z!
    using InteractiveUtils
    test_sizes = [1,2,10,63,64,65,127,128,129] # Including sizes that would test off-by-one errors in the bit encoding.

    @testset "Small symbolic operators" begin
        for n in test_sizes
            for i in 1:6
                op = enumerate_single_qubit_gates(i, qubit=n, phases=(rand(Bool),rand(Bool)))
                op0 = enumerate_single_qubit_gates(i, qubit=n)
                op_cc = CliffordOperator(op, 1, compact=true)
                op_c = CliffordOperator(op, n)
                @test SingleQubitOperator(op)==SingleQubitOperator(op_cc, n)
                op0_c = CliffordOperator(op0, n)
                s = random_stabilizer(n)
                @test apply!(copy(s),op)==apply!(copy(s),SingleQubitOperator(op))==apply!(copy(s),[n],op_cc)==apply!(copy(s),op_c)
                @test ==(apply!(copy(s),op,phases=false),apply!(copy(s),[n],op_cc,phases=false), phases=false)
                @test apply!(copy(s),op0)==apply!(copy(s),op0_c)
            end
            i = n÷2+1
            @test apply!(copy(s),sX(i)) == apply_single_x!(copy(s),i)
            @test apply!(copy(s),sY(i)) == apply_single_y!(copy(s),i)
            @test apply!(copy(s),sZ(i)) == apply_single_z!(copy(s),i)
            n==1 && continue
            s = random_stabilizer(n)
            i1,i2 = randperm(n)[1:2]
            @test apply!(copy(s),[i1,i2],tCNOT) == apply!(copy(s),sCNOT(i1,i2))
            @test apply!(copy(s),[i1,i2],tSWAP) == apply!(copy(s),sSWAP(i1,i2))
            @test apply!(copy(s),[i1,i2],tCPHASE) == apply!(copy(s),sCPHASE(i1,i2))
        end
        @test_throws DimensionMismatch SingleQubitOperator(tCNOT,1)
        @test_throws DimensionMismatch CliffordOperator(sHadamard(5),2)
        @test_throws ArgumentError CliffordOperator(sHadamard(5),6,compact=true)
    end

    @testset "Convert between small ops" begin
        for op in subtypes(QuantumClifford.AbstractSingleQubitOperator)
            op == SingleQubitOperator && continue
            sop = op(1)
            sqsop = SingleQubitOperator(sop)
            cop = CliffordOperator(sop,1)
            csqop = CliffordOperator(sqsop,1)
            tcop = CliffordOperator(op)
            stcop = SingleQubitOperator(tcop)
            s = random_destabilizer(1)
            @test sop*s == sqsop*s == cop*s == csqop*s == tcop*s == stcop*s
        end
        for op in subtypes(QuantumClifford.AbstractTwoQubitOperator)
            sop = op(1,2)
            cop = CliffordOperator(sop,2)
            ccop = CliffordOperator(sop,2; compact=true)
            @test_throws DimensionMismatch CliffordOperator(op(1,4),3)
            @test_throws ArgumentError CliffordOperator(sop,3; compact=true)
            tcop = CliffordOperator(op)
            s = random_destabilizer(2)
            @test sop*s == cop*s == tcop*s == ccop*s
        end
        for op in subtypes(QuantumClifford.AbstractTwoQubitOperator)
            sop = op(1,10)
            op1 = CliffordOperator(sop,20)
            op2 = sSWAP(2,10)*(CliffordOperator(sop,2; compact=true)⊗tensor_pow(tId1, 18))*CliffordOperator(sSWAP(2,10),20)
            @test op1 == op2
        end
    end

    @testset "SingleQubitOperator inv methods" begin
        for gate_type in filter(gate_type -> gate_type != SingleQubitOperator, subtypes(AbstractSingleQubitOperator))
            n = rand(1:10)
            @test CliffordOperator(inv(SingleQubitOperator(gate_type(n))), n) == inv(CliffordOperator(gate_type(n), n))
            @test CliffordOperator(inv(gate_type(n)), n) == inv(CliffordOperator(gate_type(n), n))
        end
        for i in 1:10
            random_op = random_clifford1(i)
            @test CliffordOperator(inv(random_op), i) == inv(CliffordOperator(random_op, i))
            @test CliffordOperator(inv(SingleQubitOperator(random_op)), i) == inv(CliffordOperator(random_op, i))
        end
    end

    @testset "Consistency checks with Stim" begin
       # see https://github.com/quantumlib/Stim/blob/main/doc/gates.md
       @test CliffordOperator(sCXYZ)       == C"Y X"
       @test CliffordOperator(sCZYX)       == C"Z Y"
       @test CliffordOperator(sSQRTX)      == C"X -Y"
       @test CliffordOperator(sSQRTY)      == C"-Z X"
       @test CliffordOperator(sInvSQRTX)   == C"X Y"
       @test CliffordOperator(sInvSQRTY)   == C"Z -X"
       @test CliffordOperator(sHadamardXY) == C"Y -Z"
       @test CliffordOperator(sHadamardYZ) == C"-X Y"
    end

    @testset "TwoQubitOperator inv methods" begin
        for gate_type in subtypes(QuantumClifford.AbstractTwoQubitOperator)
            n₁ = rand(2: 10)
            n₂ = rand(1:(n₁ - 1))
            @test CliffordOperator(inv(gate_type(n₁, n₂)), n₁) == inv(CliffordOperator(gate_type(n₁, n₂), n₁))
            @test CliffordOperator(inv(gate_type(n₂, n₁)), n₁) == inv(CliffordOperator(gate_type(n₂, n₁), n₁))
            @test CliffordOperator(inv(sZCX(n₁, n₂)), n₁) == inv(CliffordOperator(sCNOT(n₁, n₂), n₁))
            @test CliffordOperator(inv(sXCZ(n₁, n₂)), n₁) == inv(CliffordOperator(sCNOT(n₂, n₁), n₁))
            @test CliffordOperator(inv(sZCrY(n₁, n₂)), n₁) == inv(CliffordOperator(sZCrY(n₁, n₂), n₁))
            @test CliffordOperator(inv(sInvZCrY(n₁, n₂)), n₁) == inv(CliffordOperator(sInvZCrY(n₁, n₂), n₁))
            @test CliffordOperator(inv(sCXSWAP(n₁, n₂)), n₁) == inv(CliffordOperator(sInvSWAPCX(n₁, n₂), n₁))
        end
    end

    @testset "Consistency check with STIM conventions" begin
        # see https://github.com/quantumlib/Stim/blob/main/doc/gates.md
        @test CliffordOperator(sSWAPCX)    == C"IX XX ZZ ZI"
        @test CliffordOperator(sInvSWAPCX) == C"XX XI IZ ZZ"
        @test CliffordOperator(sCZSWAP)    == C"ZX XZ IZ ZI"
        @test CliffordOperator(sCXSWAP)    == C"XX XI IZ ZZ"
        @test CliffordOperator(sISWAP)     == C"ZY YZ IZ ZI"
        @test CliffordOperator(sInvISWAP)  == C"-ZY -YZ IZ ZI"
        @test CliffordOperator(sSQRTZZ)    == C"YZ ZY ZI IZ"
        @test CliffordOperator(sInvSQRTZZ) == C"-YZ -ZY ZI IZ"
        @test CliffordOperator(sSQRTXX)    == C"XI IX -YX -XY"
        @test CliffordOperator(sInvSQRTXX) == C"XI IX YX XY"
        @test CliffordOperator(sSQRTYY)    == C"-ZY -YZ XY YX"
        @test CliffordOperator(sInvSQRTYY) == C"ZY YZ -XY -YX"
    end
end

using InteractiveUtils
versioninfo(;verbose=true)

const JET_PROJECT = normpath(joinpath(@__DIR__, "projects", "jet"))
const test_args = isempty(ARGS) ? ["general"] : ARGS
const JET_flag = length(test_args) == 1 && startswith(only(test_args), "jet")

if JET_flag
    @info "Activating the dedicated JET test environment." project=JET_PROJECT
    using Pkg
    Pkg.activate(JET_PROJECT)
    Pkg.instantiate()
end

CUDA_flag = false
ROCm_flag = false
OpenCL_flag = false
Oscar_flag = false
Tesseract_flag = false

if Sys.iswindows() || Sys.ARCH != :x86_64
    @info "Skipping Oscar tests -- only supported x86_64 *NIX platforms."
else
    Oscar_flag = VERSION >= v"1.11"
    !Oscar_flag && @info "Skipping Oscar tests -- not tested on Julia < 1.11"
end

if Sys.iswindows()
    @info "Skipping Tesseract tests -- only supported *NIX platforms."
else
    Tesseract_flag = true
end

if Sys.iswindows()
    @info "Skipping GPU/OpenCL tests -- only executed on *NIX platforms."
else
    CUDA_flag = get(ENV, "GPU_TEST", "") == "cuda"
    ROCm_flag = get(ENV, "GPU_TEST", "") == "rocm"
    OpenCL_flag = get(ENV, "GPU_TEST", "") == "opencl"

    CUDA_flag && @info "Running with CUDA tests."
    ROCm_flag && @info "Running with ROCm tests."
    OpenCL_flag && @info "Running with OpenCL tests."
    if !any((CUDA_flag, ROCm_flag, OpenCL_flag))
        @info "Skipping GPU/OpenCL tests -- must be explicitly enabled."
        @info "Environment must uniquely set GPU_TEST=cuda/rocm/opencl."
    end
end

using Pkg
CUDA_flag && Pkg.add("CUDA")
ROCm_flag && Pkg.add("AMDGPU")
OpenCL_flag && Pkg.add(["pocl_jll", "OpenCL"])
if any((CUDA_flag, ROCm_flag, OpenCL_flag))
    Pkg.add(
        ["Adapt", "Atomix", "GPUArraysCore", "GPUArrays", "KernelAbstractions"]
    )
end
!JET_flag && Oscar_flag && Pkg.add("Oscar")
!JET_flag && Tesseract_flag && Pkg.add("PyTesseractDecoder")


using TestItemRunner
using QuantumClifford

# filter for the test
testfilter = ti -> begin
    exclude = Symbol[]

    if JET_flag
        return :jet in ti.tags
    else
        push!(exclude, :jet)
    end

    if !Oscar_flag
        push!(exclude, :oscar_required)
    end

    if !Tesseract_flag
        push!(exclude, :tesseract_required)
    end

    if get(ENV, "ECC_TEST", "") == "base"
        return (:ecc in ti.tags) && (:ecc_base in ti.tags) && all(!in(exclude), ti.tags)

    elseif get(ENV, "ECC_TEST", "") == "encoding"
        return (:ecc in ti.tags) && (:ecc_encoding in ti.tags) && all(!in(exclude), ti.tags)

    elseif get(ENV, "ECC_TEST", "") == "decoding"
        return (:ecc in ti.tags) && (:ecc_decoding in ti.tags) && all(!in(exclude), ti.tags)

    elseif get(ENV, "ECC_TEST", "") == "syndromecircuit"
        return (:ecc in ti.tags) && (:ecc_syndrome_circuit_equivalence in ti.tags) && all(!in(exclude), ti.tags)

    elseif get(ENV, "ECC_TEST", "") == "syndromemeasurement"
        return (:ecc in ti.tags) && (:ecc_syndrome_measurement_correctness in ti.tags) && all(!in(exclude), ti.tags)

    elseif get(ENV, "ECC_TEST", "") == "bespoke"
        return (:ecc in ti.tags) && (:ecc_bespoke_checks in ti.tags) && all(!in(exclude), ti.tags)
    else
        push!(exclude, :ecc)
    end

    if CUDA_flag
        return (:cuda in ti.tags) && all(!in(exclude), ti.tags)
    else
        push!(exclude, :cuda)
    end

    if ROCm_flag
        return (:rocm in ti.tags) && all(!in(exclude), ti.tags)
    else
        push!(exclude, :rocm)
    end

    if OpenCL_flag
        return (:opencl in ti.tags) && all(!in(exclude), ti.tags)
    else
        push!(exclude, :opencl)
    end

    if !(VERSION >= v"1.10")
        push!(exclude, :doctests)
        push!(exclude, :aqua)
    end

    if !(Base.Sys.islinux() & (Int===Int64))
        push!(exclude, :bitpack)
    end

    return all(!in(exclude), ti.tags)
end

println("Starting tests with $(Threads.nthreads()) threads out of `Sys.CPU_THREADS = $(Sys.CPU_THREADS)`...")

@run_package_tests filter=testfilter

include("imports.jl")
include("definitions.jl")
include("utilities.jl")
include("benchmark_KA_mul_leftright.jl")

@inline function benchmark_platform(AT, synchronize, path)
    benchmark_KA_mul_leftright(AT, synchronize, path; phases = Val(true))
    benchmark_KA_mul_leftright(AT, synchronize, path; phases = Val(false))
end

# Small sizes for encoding issues, large sizes for race conditions.
const test_sizes = [
    31, 32, 33, 63, 64, 65, 127, 128, 129,
    64 * 1023, 64 * 1024, 64 * 1025, 64 * 2047, 64 * 2048, 64 * 2049
    ]
# The tests are for correctness, not for device memory limits.
const max_rows = 1024
# Keep it reasonable so that local testing remains accessible.
const round_count = 16
# Correctness should be independent of parameter values.
# The omission of the const specifier is intentional, overridden in OpenCL.
block_sizes = rand(1:256, round_count)
const batch_sizes = rand(1:256, round_count)

"""Convert a tableau to a memory layout that is fast for row operations.

In this layout a Pauli string (a row of the tableau) is stored contiguously in memory.
This corresponds to column-major storage of the underlying `xzs` matrix.

**This is the default layout** for stabilizer-like tableau structures (unless otherwise specified).

Optimal for:
- Row operations (e.g., `mul_left!`)
- Canonicalization (`canonicalize!`)
- Projective measurements of arbitrary multi-qubit Paulis (`project!`)
- Applying large dense n-qubit Clifford operations

# Indexing Convention
Regardless of memory layout, indexing is always `xzs[tableau_column_index, tableau_row_index]`.
The X component of qubit `i` in stabilizer `j` is stored at `xzs[i_big, j]` and 
the Z component at `xzs[i_big + end÷2, j]`, where `i_big` accounts for bit packing.

See also: [`fastcolumn`](@ref)"""
function fastrow end

"""Convert a tableau to a memory layout that is fast for column operations.

In this layout a column of the tableau (the bits of a given qubit) is stored 
(mostly) contiguously in memory. This corresponds to row-major storage of the 
underlying `xzs` matrix, implemented via `transpose(collect(transpose(xzs)))`.

Due to bitpacking (e.g., packing 64 bits into a single `UInt64`),
the memory layout is not perfectly contiguous,
but it is still optimal given that some bitwrangling is required to extract a given bit.

**This is the default layout** for [`PauliFrame`](@ref).

Optimal for:
- Column operations (applying single-qubit and two-qubit gates, single-qubit measurements)

# Indexing Convention
Regardless of memory layout, indexing is always `xzs[tableau_column_index, tableau_row_index]`.
The X component of qubit `i` in stabilizer `j` is stored at `xzs[i_big, j]` and 
the Z component at `xzs[i_big + end÷2, j]`, where `i_big` accounts for bit packing.

See also: [`fastrow`](@ref)"""
function fastcolumn end

fastrow(t::Tableau{Tₚᵥ,Tₘ}) where {Tₚᵥ, Tₘ} = t
fastrow(t::Tableau{Tₚᵥ,Tₘ}) where {Tₚᵥ, Tₘ<:Adjoint} = Tableau(t.phases, t.nqubits, collect(t.xzs))
fastcolumn(t::Tableau{Tₚᵥ,Tₘ}) where {Tₚᵥ, Tₘ} = Tableau(t.phases, t.nqubits, collect(t.xzs')')
fastcolumn(t::Tableau{Tₚᵥ,Tₘ}) where {Tₚᵥ, Tₘ<:Adjoint} = t

fastrow(s::Stabilizer) = Stabilizer(fastrow(tab(s)))
fastcolumn(s::Stabilizer) = Stabilizer(fastcolumn(tab(s)))

fastrow(s::Destabilizer) = Destabilizer(fastrow(tab(s)))
fastcolumn(s::Destabilizer) = Destabilizer(fastcolumn(tab(s)))

fastrow(s::MixedStabilizer) = MixedStabilizer(fastrow(tab(s)), rank(s))
fastcolumn(s::MixedStabilizer) = MixedStabilizer(fastcolumn(tab(s)), rank(s))

fastrow(s::MixedDestabilizer) = MixedDestabilizer(fastrow(tab(s)), rank(s))
fastcolumn(s::MixedDestabilizer) = MixedDestabilizer(fastcolumn(tab(s)), rank(s))

macro run_cuda(call, ndrange)
    # destructure the kernel call
    Meta.isexpr(call, :call) || throw(ArgumentError("first argument to @run_cuda should be a function call"))
    f = call.args[1]
    args = call.args[2:end]
    args = [esc(x) for x in args]
    quote
        local kernel = @cuda launch=false $f($(args...))
        local config = CUDA.launch_configuration(kernel.fun)
        local threads = min($(esc(ndrange)), config.threads)
        local blocks = cld($(esc(ndrange)), threads)
        kernel($(args...); threads=threads, blocks=blocks)
    end
end

using BenchmarkTools
using Pkg
using StableRNGs
using QuantumClifford
using Nemo

const SUITE = BenchmarkGroup()

rng = StableRNG(42)

M = Pkg.Operations.Context().env.manifest
V = M[findfirst(v -> v.name == "QuantumClifford", M)].version

# Due to breaking changes in v0.5.0
const tableauCNOT = C"XX
                      IX
                      ZI
                      ZZ"

const s500 = random_stabilizer(rng,500)
const md500 = MixedDestabilizer(random_destabilizer(rng,500),250)
const p500 = random_pauli(rng,500)
const c500 = random_clifford(rng,500)
const cnots250 = tensor_pow(tableauCNOT,250)
const pa1 = random_pauli(rng,100)
const pb1 = random_pauli(rng,100)
const pa2 = random_pauli(rng,1000)
const pb2 = random_pauli(rng,1000)
const pa3 = random_pauli(rng,100_000)
const pb3 = random_pauli(rng,100_000)
const pa4 = random_pauli(rng,20_000_000)
const pb4 = random_pauli(rng,20_000_000)

SUITE["pauli"] = BenchmarkGroup(["pauli"])
# Multiplication of multiqubit Pauli operators of various length.
SUITE["pauli"]["mul"] = BenchmarkGroup(["multiplication"])
SUITE["pauli"]["mul"]["100"]    = @benchmarkable QuantumClifford.mul_left!(a,b) setup=(a=copy(pa1);b=pb1)
SUITE["pauli"]["mul"]["1000"]   = @benchmarkable QuantumClifford.mul_left!(a,b) setup=(a=copy(pa2);b=pb2)
SUITE["pauli"]["mul"]["100000"] = @benchmarkable QuantumClifford.mul_left!(a,b) setup=(a=copy(pa3);b=pb3)
SUITE["pauli"]["mul"]["20000000"] = @benchmarkable QuantumClifford.mul_left!(a,b) setup=(a=copy(pa4);b=pb4)

SUITE["stabilizer"] = BenchmarkGroup(["stabilizer"])
# Canonicalization of random or diagonal tableaux. All three types of canonicalization are benchmarked.
SUITE["stabilizer"]["canon"] = BenchmarkGroup(["canonicalization"])
SUITE["stabilizer"]["canon"]["cano500"] = @benchmarkable canonicalize!(s) setup=(s=copy(s500)) evals=1
SUITE["stabilizer"]["canon"]["gott500"] = @benchmarkable canonicalize_gott!(s) setup=(s=copy(s500)) evals=1
SUITE["stabilizer"]["canon"]["rref500"] = @benchmarkable canonicalize_rref!(s) setup=(s=copy(s500)) evals=1
SUITE["stabilizer"]["canon"]["md_cano500"] = @benchmarkable canonicalize!(md) setup=(md=copy(md500)) evals=1
SUITE["stabilizer"]["canon"]["md_rref500"] = @benchmarkable canonicalize_rref!(md) setup=(md=copy(md500)) evals=1
SUITE["stabilizer"]["canon"]["diag_cano500"] = @benchmarkable canonicalize!(s) setup=(s=one(Stabilizer,500))  evals=1
SUITE["stabilizer"]["canon"]["diag_gott500"] = @benchmarkable canonicalize_gott!(s) setup=(s=one(Stabilizer,500)) evals=1
SUITE["stabilizer"]["canon"]["diag_rref500"] = @benchmarkable canonicalize_rref!(s) setup=(s=one(Stabilizer,500)) evals=1
# Tensor products of tableaux.
SUITE["stabilizer"]["tensor"] = BenchmarkGroup(["tensor product"])
SUITE["stabilizer"]["tensor"]["pow5_20"] = @benchmarkable tensor_pow(s,20) setup=(s=random_stabilizer(5))
SUITE["stabilizer"]["tensor"]["diag_pow5_20"] = @benchmarkable tensor_pow(s,20) setup=(s=one(Stabilizer,500))
# Projection operations.
SUITE["stabilizer"]["project"] = BenchmarkGroup(["project", "measure"])
SUITE["stabilizer"]["project"]["stabilizer"]   = @benchmarkable project!(s,p) setup=(s=copy(s500);p=copy(p500)) evals=1
SUITE["stabilizer"]["project"]["destabilizer"] = @benchmarkable project!(s,p) setup=(s=copy(md500);p=copy(p500)) evals=1
# Partial traces.
SUITE["stabilizer"]["trace"] = BenchmarkGroup(["partial trace", "erase"])
SUITE["stabilizer"]["trace"]["stabilizer"]   = @benchmarkable traceout!(s,[2,4,70]) setup=(s=copy(s500);p=copy(p500)) evals=1
SUITE["stabilizer"]["trace"]["destabilizer"] = @benchmarkable traceout!(s,[2,4,70]) setup=(s=copy(md500);p=copy(p500)) evals=1

SUITE["clifford"] = BenchmarkGroup(["clifford"])
# Tensor products of Clifford operators # TODO finish functionality and add benchmarks
#SUITE["clifford"]["tensor"] = BenchmarkGroup(["tensor product"])
# Applications of various Clifford operators to tableaux.
SUITE["clifford"]["dense"] = BenchmarkGroup(["dense"])
# Both the operator and the state are random dense matrices.
SUITE["clifford"]["dense"]["dense500_on_dense500_stab"]   = @benchmarkable apply!(s,c) setup=(s=copy(s500);c=c500) evals=1
SUITE["clifford"]["dense"]["dense500_on_dense500_destab"] = @benchmarkable apply!(s,c) setup=(s=copy(md500);c=c500) evals=1
# The operator is a small 2-qubit CNOT operator.
SUITE["clifford"]["dense"]["cnot_on_dense500_stab"]   = @benchmarkable apply!(s,[30,200],c) setup=(s=copy(s500);c=tableauCNOT) evals=1
SUITE["clifford"]["dense"]["cnot_on_dense500_destab"] = @benchmarkable apply!(s,[30,200],c) setup=(s=copy(md500);c=tableauCNOT) evals=1
# The state is a diagonal matrix (and the operator is dense large matrix or just a dense 2-qubit CNOT matrix).
SUITE["clifford"]["dense"]["dense500_on_diag500_stab"]   = @benchmarkable apply!(s,c) setup=(s=one(Stabilizer,500);c=c500) evals=1
SUITE["clifford"]["dense"]["dense500_on_diag500_destab"] = @benchmarkable apply!(s,c) setup=(s=one(Destabilizer,500);c=c500) evals=1
SUITE["clifford"]["dense"]["cnot_on_diag500_stab"]   = @benchmarkable apply!(s,[30,200],c) setup=(s=one(Stabilizer,500);c=tableauCNOT) evals=1
SUITE["clifford"]["dense"]["cnot_on_diag500_destab"] = @benchmarkable apply!(s,[30,200],c) setup=(s=MixedDestabilizer(one(Destabilizer,500),250);c=tableauCNOT) evals=1
# The operator is a mostly diagonal matrix (250 CNOTs), while the state is a random dense matrix.
SUITE["clifford"]["dense"]["cnot250_on_dense500_stab"]   = @benchmarkable apply!(s,c) setup=(s=copy(s500);c=cnots250) evals=1
SUITE["clifford"]["dense"]["cnot250_on_dense500_destab"] = @benchmarkable apply!(s,c) setup=(s=copy(md500);c=cnots250) evals=1
# The operator is mostly diagonal and the state is diagonal.
SUITE["clifford"]["dense"]["cnot250_on_diag500_stab"]   = @benchmarkable apply!(s,c) setup=(s=one(Stabilizer,500);c=cnots250) evals=1
SUITE["clifford"]["dense"]["cnot250_on_diag500_destab"] = @benchmarkable apply!(s,c) setup=(s=MixedDestabilizer(one(Destabilizer,500),250);c=cnots250) evals=1
# Tensor products of symbolic Clifford operators # TODO finish functionality and add benchmarks
SUITE["clifford"]["symbolic"] = BenchmarkGroup(["symbolic"])
SUITE["clifford"]["symbolic"]["cnot_on_dense500_stab"]   = @benchmarkable apply!(s,c) setup=(s=copy(s500);c=sCNOT(30,200)) evals=1
SUITE["clifford"]["symbolic"]["cnot_on_dense500_destab"] = @benchmarkable apply!(s,c) setup=(s=copy(md500);c=sCNOT(30,200)) evals=1
SUITE["clifford"]["symbolic"]["cnot_on_diag500_stab"]   = @benchmarkable apply!(s,c) setup=(s=one(Stabilizer,500);c=sCNOT(30,200)) evals=1
SUITE["clifford"]["symbolic"]["cnot_on_diag500_destab"] = @benchmarkable apply!(s,c) setup=(s=MixedDestabilizer(one(Destabilizer,500),250);c=sCNOT(30,200)) evals=1
SUITE["clifford"]["symbolic"]["cnot250_on_dense500_stab"]   = @benchmarkable for i in 1:250 apply!(s,sCNOT(2i-1,2i)) end setup=(s=copy(s500)) evals=1
SUITE["clifford"]["symbolic"]["cnot250_on_dense500_destab"] = @benchmarkable for i in 1:250 apply!(s,sCNOT(2i-1,2i)) end setup=(s=copy(md500)) evals=1
SUITE["clifford"]["symbolic"]["cnot250_on_diag500_stab"]   = @benchmarkable for i in 1:250 apply!(s,sCNOT(2i-1,2i)) end setup=(s=one(Stabilizer,500)) evals=1
SUITE["clifford"]["symbolic"]["cnot250_on_diag500_destab"] = @benchmarkable for i in 1:250 apply!(s,sCNOT(2i-1,2i)) end setup=(s=MixedDestabilizer(one(Destabilizer,500),250)) evals=1


if V > v"0.7.0"

SUITE["circuitsim"] = BenchmarkGroup(["circuitsim"])
function x_diag_circuit(csize)
    circuit = []
    for i in 1:csize
        push!(circuit, sHadamard(i))
        push!(circuit, sCNOT(i, csize+1))
    end
    push!(circuit, sMZ(csize+1,1))
    return circuit
end
SUITE["circuitsim"]["pftrajectories"] = BenchmarkGroup(["pftrajectories"])
SUITE["circuitsim"]["pftrajectories"]["q101_r1"]      = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame(   1,  101, 1); circuit=x_diag_circuit( 100)) evals=1
SUITE["circuitsim"]["pftrajectories"]["q1001_r1"]     = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame(   1, 1001, 1); circuit=x_diag_circuit(1000)) evals=1
SUITE["circuitsim"]["pftrajectories"]["q1001_r100"]   = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame( 100, 1001, 1); circuit=x_diag_circuit(1000)) evals=1
SUITE["circuitsim"]["pftrajectories"]["q1001_r10000"] = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame(1000, 1001, 1); circuit=x_diag_circuit(1000)) evals=1
SUITE["circuitsim"]["mctrajectories"] = BenchmarkGroup(["mctrajectories"])
SUITE["circuitsim"]["mctrajectories"]["q101_r1"]    = @benchmarkable mctrajectory!(state, circuit) setup=(state=Register(one(Stabilizer,  101), [false]); circuit=x_diag_circuit( 100)) evals=1
SUITE["circuitsim"]["mctrajectories"]["q1001_r1"]   = @benchmarkable mctrajectory!(state, circuit) setup=(state=Register(one(Stabilizer, 1001), [false]); circuit=x_diag_circuit(1000)) evals=1

SUITE["circuitsim"]["pftrajectories_union"] = BenchmarkGroup(["pftrajectories_union"])
veccirc = Vector{Union{sHadamard,sCNOT,sMZ}}
SUITE["circuitsim"]["pftrajectories_union"]["q101_r1"]      = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame(   1,  101, 1); circuit=veccirc(x_diag_circuit( 100))) evals=1
SUITE["circuitsim"]["pftrajectories_union"]["q1001_r1"]     = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame(   1, 1001, 1); circuit=veccirc(x_diag_circuit(1000))) evals=1
SUITE["circuitsim"]["pftrajectories_union"]["q1001_r100"]   = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame( 100, 1001, 1); circuit=veccirc(x_diag_circuit(1000))) evals=1
SUITE["circuitsim"]["pftrajectories_union"]["q1001_r10000"] = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame(1000, 1001, 1); circuit=veccirc(x_diag_circuit(1000))) evals=1
SUITE["circuitsim"]["mctrajectories_union"] = BenchmarkGroup(["mctrajectories_union"])
SUITE["circuitsim"]["mctrajectories_union"]["q101_r1"]    = @benchmarkable mctrajectory!(state, circuit) setup=(state=Register(one(Stabilizer,  101), [false]); circuit=veccirc(x_diag_circuit( 100))) evals=1
SUITE["circuitsim"]["mctrajectories_union"]["q1001_r1"]   = @benchmarkable mctrajectory!(state, circuit) setup=(state=Register(one(Stabilizer, 1001), [false]); circuit=veccirc(x_diag_circuit(1000))) evals=1

SUITE["circuitsim"]["pftrajectories_sumtype"] = BenchmarkGroup(["pftrajectories_sumtype"])
SUITE["circuitsim"]["pftrajectories_sumtype"]["q101_r1"]      = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame(   1,  101, 1); circuit=compactify_circuit(x_diag_circuit( 100))) evals=1
SUITE["circuitsim"]["pftrajectories_sumtype"]["q1001_r1"]     = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame(   1, 1001, 1); circuit=compactify_circuit(x_diag_circuit(1000))) evals=1
SUITE["circuitsim"]["pftrajectories_sumtype"]["q1001_r100"]   = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame( 100, 1001, 1); circuit=compactify_circuit(x_diag_circuit(1000))) evals=1
SUITE["circuitsim"]["pftrajectories_sumtype"]["q1001_r10000"] = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame(1000, 1001, 1); circuit=compactify_circuit(x_diag_circuit(1000))) evals=1
SUITE["circuitsim"]["pftrajectories_sumtype"]["q1001_r10000_fastrow"] = @benchmarkable pftrajectories(state,circuit) setup=(state=fastrow(PauliFrame(1000, 1001, 1)); circuit=compactify_circuit(x_diag_circuit(1000))) evals=1
SUITE["circuitsim"]["mctrajectories_sumtype"] = BenchmarkGroup(["mctrajectories_sumtype"])
SUITE["circuitsim"]["mctrajectories_sumtype"]["q101_r1"]    = @benchmarkable mctrajectory!(state, circuit) setup=(state=Register(one(Stabilizer,  101), [false]); circuit=compactify_circuit(x_diag_circuit( 100))) evals=1
SUITE["circuitsim"]["mctrajectories_sumtype"]["q1001_r1"]   = @benchmarkable mctrajectory!(state, circuit) setup=(state=Register(one(Stabilizer, 1001), [false]); circuit=compactify_circuit(x_diag_circuit(1000))) evals=1

end


if V >= v"0.8.20"

using QuantumClifford.ECC
import PyQDecoders, LDPCDecoders

SUITE["ecc"] = BenchmarkGroup(["ecc"])
SUITE["ecc"]["evaluate_decoder"] = BenchmarkGroup(["evaluate_decoder"])
for (cs, c) in [("shor",Shor9()), ("toric8",Toric(8,8))]
    for (ds, d) in [
        [("table",TableDecoder(c)), ("bp",BeliefPropDecoder(c)), ("pybp",PyBeliefPropDecoder(c)), ("pybposd",PyBeliefPropOSDecoder(c))]...,
        (isa(c,Toric) ? [("pymatch",PyMatchingDecoder(c))] : [])...]
        for (ss, s) in [("comm",CommutationCheckECCSetup(0.01)), ("naivesyn",NaiveSyndromeECCSetup(0.01,0)), ("shorsyn",ShorSyndromeECCSetup(0.01,0))]
            SUITE["ecc"]["evaluate_decoder"]["$(cs)_$(ds)_$(ss)"] = @benchmarkable evaluate_decoder($d, $s, 1000)
        end
    end
end


if V > v"0.9.0"

function x_diag_circuit_noisy_measurement(csize)
    circuit = []
    for i in 1:csize
        push!(circuit, PauliError(i, 0.1))
        push!(circuit, sHadamard(i))
        push!(circuit, sCNOT(i, csize+1))
        push!(circuit, sMZ(csize+1,i))
        push!(circuit, ClassicalXOR(1:(i%6+2),i))
    end
    return circuit
end

SUITE["circuitsim"]["compactification"] = BenchmarkGroup(["compactification"])
SUITE["circuitsim"]["compactification"]["no_compact"] = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame(1000, 1001, 1001); circuit=x_diag_circuit_noisy_measurement(1000)) evals=1
SUITE["circuitsim"]["compactification"]["compact"] = @benchmarkable pftrajectories(state,circuit) setup=(state=PauliFrame(1000, 1001, 1001); circuit=compactify_circuit(x_diag_circuit_noisy_measurement(1000))) evals=1

end

end

@testitem "encoding circuits - compare to algebraic construction of encoded state" tags=[:ecc, :ecc_encoding] begin
    using QuantumClifford
    using QuantumClifford.ECC

    include("test_ecc_base.jl")


    # This test verifies that logical measurements on an encoded state match the physical pre-encoded state.
    # This test skips verifying the permutations of qubits during canonicalization are properly undone,
    # i.e. we modify the code we are testing so that the canonicalization does not need any permutations.
    for undoperm in [true, false],
        code in [
            all_testable_code_instances()...,
            S"Y_",
            S"Z_",
            S"X_",
            [random_stabilizer(5,7) for _ in 1:100]...
        ]

        if undoperm==false
            # Pre-process the tableau to remove permutations and negative phases.
            # Usually that is handled by `naive_encoding_circuit`, but we just want to check both branches for its `undoperm` kwarg.
            stab, r, s, xperm, zperm = canonicalize_gott!(parity_checks(code))
            code = stab # using this tableau guarantees we do not need to worry about permutations of the qubits
        end

        circ = naive_encoding_circuit(code; undoperm=true)
        #display(circ)

        # the state to be encoded (k physical qubits)
        pre_encₖ = one(Stabilizer, code_k(code))

        # n-k ancillary qubits in state zero prepended
        pre_encₙ = one(Stabilizer, code_n(code) - code_k(code)) ⊗ pre_encₖ

        # running the encoding circuit
        encodedₙ = mctrajectory!(pre_encₙ, circ)[1] |> canonicalize!

        # creating a valid state purely algebraically
        algebraicₙ = MixedDestabilizer(code)
        algebraicₙ.rank = nqubits(algebraicₙ)
        algebraicₙ = stabilizerview(algebraicₙ) |> canonicalize!

        @test (encodedₙ == algebraicₙ)
    end
end

include("imports.jl")
include("definitions.jl")
include("utilities.jl")
include("test_KA_mul_leftright.jl")

@inline function test_platform(AT, synchronize)
    @testset "mul_leftright" begin
        test_KA_mul_leftright(AT, synchronize)
    end
end

#!/usr/bin/env fish
for jlversion in nightly 1.10.0 1.9.0 1.8.0 1.7.0 1.6.0
    for tag in (git for-each-ref --sort=creatordate --format '%(tag)' refs/tags | tail -n+15)
        for nthreads in 1 4
            for retune in true
                ./run_ttfx_benchmarks.sh -v$jlversion -t$tag -n$nthreads
                ./run_benchmarks.sh -v$jlversion -t$tag -n$nthreads -r$retune
            end
        end
    end
end

#!/usr/bin/env bash
while getopts t:v:n:r: flag
do
    case "${flag}" in
        t) tag=${OPTARG};;
        v) jlversion=${OPTARG};;
        n) nthreads=${OPTARG};;
        r) retune=${OPTARG};;
    esac
done
juliaup default $jlversion
mydir=$(mktemp -d)
cp benchmarks.jl $mydir
git checkout $tag --force
rm -f ../Manifest.toml
export JULIA_NUM_THREADS=$nthreads
cat << EOF | julia -t$nthreads
using Pkg;
Pkg.activate(;temp=true);
Pkg.develop(joinpath(dirname(@__DIR__), "lib", "QECCore"))
pkg"add BenchmarkTools StableRNGs Nemo PkgBenchmark";
pkg"develop .."
using PkgBenchmark
import QuantumClifford
benchmarkpkg(
    QuantumClifford,
    "$tag";
    retune=$retune,
    resultfile="tag=$tag-nthreads=$nthreads-julia=$jlversion.benchmarkresults",
    script="$mydir/benchmarks.jl"
)
EOF
git checkout master --force

#!/usr/bin/env bash
while getopts t:v:n: flag
do
    case "${flag}" in
        t) tag=${OPTARG};;
        v) jlversion=${OPTARG};;
        n) nthreads=${OPTARG};;
    esac
done
juliaup default $jlversion
mydir=$(mktemp -d)
git checkout $tag --force
resfile="tag=$tag-nthreads=$nthreads-julia=$jlversion.ttfxresults"
export JULIA_NUM_THREADS=$nthreads
cat << EOF | julia
using Pkg;
Pkg.activate("$mydir");
pkg"develop .."
Pkg.precompile()
EOF
for i in {1..4}
do
cat << EOF | julia -t$nthreads | tail -n1 >> using_$resfile
using Pkg;
Pkg.activate("$mydir");
println(@elapsed @eval using QuantumClifford)
EOF
cat << EOF | julia -t$nthreads | tail -n1 >> task_$resfile
using Pkg;
Pkg.activate("$mydir");
using QuantumClifford
println(@elapsed @eval canonicalize!(apply!(apply!(random_stabilizer(3),random_clifford(3)),sCNOT(3,1))))
EOF
done
git checkout master --force

# Canonicalization operations

Different types of canonicalization operations are implemented. All of them are types of Gaussian elimination.

## [`canonicalize!`](@ref)

First do elimination on all X components and only then perform elimination on
the Z components. Based on [garcia2012efficient](@cite).
It is used in [`logdot`](@ref) for inner products of stabilizer states.

The final tableaux, if square should look like the following
![](canonicalize.png)

If the tableaux is shorter than a square, the diagonals might not reach all the way to the right.

```@example
using QuantumClifford, CairoMakie
f=Figure()
stabilizerplot_axis(f[1,1], canonicalize!(random_stabilizer(20,30)))
f
```

## [`canonicalize_rref!`](@ref)

Cycle between elimination on X and Z for each qubit. Particularly useful for
tracing out qubits. Based on [audenaert2005entanglement](@cite).
For convenience reasons, the canonicalization starts from the bottom row,
and you can specify as a second argument which columns to be canonicalized
(useful for tracing out arbitrary qubits, e.g., in [`traceout!`](@ref)).

The tableau canonicalization is done in recursive steps, each one of which results in something akin to one of these three options
![](canonicalize_rref.png)

```@example
using QuantumClifford, CairoMakie
f=Figure()
stabilizerplot_axis(f[1,1], canonicalize_rref!(random_stabilizer(20,30),1:30)[1])
f
```

## [`canonicalize_gott!`](@ref)

First do elimination on all X components and only then perform elimination on
the Z components, but without touching the qubits that were eliminated during
the X pass.
Unlike other canonicalization operations, qubit columns are reordered,
providing for a straight diagonal in each block.
Particularly useful as certain blocks of the new created matrix are
related to logical operations of the corresponding code,
e.g. computing the logical X and Z operators of a [`MixedDestabilizer`](@ref).
Based on [gottesman1997stabilizer](@cite).

A canonicalized tableau would look like the following (the right-most block does
not exist for square tableaux).
![](canonicalize_gott.png)

```@example
using QuantumClifford, CairoMakie
f=Figure()
stabilizerplot_axis(f[1,1], canonicalize_gott!(random_stabilizer(30))[1])
f
```

## [`canonicalize_clip!`](@ref)

Convert to the "clipped" gauge of a stabilizer state resulting in a "river" of non-identity operators around the diagonal.

```@example
using QuantumClifford, CairoMakie
f=Figure()
stabilizerplot_axis(f[1,1], canonicalize_clip!(random_stabilizer(30)))
f
```

The properties of the clipped gauge are:

1. Each qubit is the left/right "endpoint" of exactly two stabilizer rows.
2. For the same qubit the two endpoints are always different Pauli operators.

This canonicalization is used to derive the [`bigram`](@ref) a stabilizer state,
which is also related to entanglement entropy in the state.

Introduced in [nahum2017quantum](@cite), with a more detailed explanation of the algorithm in Appendix A of [li2019measurement](@cite).

# [Full API](@id Full-API)

```@raw html
<style>
    .content table td {
        padding-top: 0 !important;
        padding-bottom: 0 !important;
    }
</style>
```

## States

Stabilizer states can be represented with the [`Stabilizer`](@ref), [`Destabilizer`](@ref), [`MixedStabilizer`](@ref), and [`MixedDestabilizer`](@ref) tableau data structures. You probably want to use [`MixedDestabilizer`](@ref) which supports the widest set of operations.

Moreover, a [`MixedDestabilizer`](@ref) can be stored inside a [`Register`](@ref) together with a set of classical bits in which measurement results can be written.

Lastly, for Pauli frame simulations there is the [`PauliFrame`](@ref) type, a tableau in which each row represents a different Pauli frame.

There are [convenience constructors for common types of states and operators](@ref Useful-States-and-Operators).

## Operations

Acting on quantum states can be performed either:

- In a "linear algebra" language where unitaries, measurements, and other operations have separate interfaces. This is an explicitly deterministic lower-level interface, which provides a great deal of control over how tableaux are manipulated. See the [Stabilizer Tableau Algebra Manual](@ref Stabilizer-Tableau-Algebra-Manual) as a primer on these approaches.
- Or in a "circuit" language, where the operators (and measurements and noise) are represented as circuit gates. This is a higher-level interface in which the outcome of an operation can be stochastic. The API for it is centered around the `apply!` function. Particularly useful for [Monte Carlo simulations](@ref noisycircuits_mc) and [Perturbative Expansion Symbolic Results](@ref noisycircuits_perturb).

See the [full list of operations](@ref all-operations) for a list of implemented operations.

## Autogenerated API list

```@autodocs
Modules = [QuantumClifford]
Private = false
```

## Private API

!!! danger "Private Implementation Details"
    These functions are used internally by the library and might be drastically modified or deleted without warning or deprecation.

```@autodocs
Modules = [QuantumClifford]
Private = true
Public = false
```

# [Visualizations](@id Visualizations)

Stabilizers have a plot recipe that can be used with `Plots.jl` or `Makie.jl`. It simply displays the corresponding parity check matrix (extracted with [`stab_to_gf2`](@ref)) as a bitmap image. Circuits can be visualized with `Quantikz.jl`.

Importing the aforementioned packages together with `QuantumClifford` is necessary to enable the plotting functionality (implemented as package extensions).

## `Plots.jl`

In `Plots.jl` we have a simple recipe `plot(s::Stabilizer; xzcomponents=...)`
where `xzcomponents=:split` plots the tableau heatmap in a wide form, X bits on the left, Z bits on the right;
or `xzcomponents=:together` plots them overlapping, with different colors for I, X, Z, and Y.

```@example
using QuantumClifford, Plots
plot(random_stabilizer(20,30), xzcomponents=:split)
```

```@example
using QuantumClifford, Plots
plot(canonicalize!(random_stabilizer(20,30)))
```

```@example
using QuantumClifford, Plots
plot(canonicalize_gott!(random_stabilizer(30))[1], xzcomponents=:split)
```

```@example
using QuantumClifford, Plots
plot(canonicalize_gott!(random_stabilizer(30))[1]; xzcomponents=:together)
```

```@example
using QuantumClifford, Plots
plot(canonicalize_rref!(random_stabilizer(20,30),1:30)[1]; xzcomponents=:together)
```

## `Makie.jl`

Makie's `heatmap` can be directly called on `Stabilizer`.

```@example makie1
using QuantumClifford, CairoMakie
s = S"IIXZ
      ZZIZ
      YYIZ
      IIIZ
      ZZXZ"
f, ax, p = CairoMakie.heatmap(s)
hidedecorations!(ax); hidespines!(ax); # remove ticks and spines
ax.aspect = DataAspect(); # set a one-to-one aspect ratio
f
```

A full Makie recipe is available as well (supporting `xzcomponents`)

```@example makie1
using QuantumClifford, CairoMakie
s = S"IIXZ
      ZZIZ
      YYIZ
      IIIZ
      ZZXZ"
f, ax, p = stabilizerplot(s, xzcomponents=:together)
hidedecorations!(ax); hidespines!(ax)
ax.aspect = DataAspect()
f
```

You can easily add colorbars (and change the colormap) as well:

```@example makie1
using QuantumClifford, CairoMakie
fig = Figure()
ax, p = stabilizerplot(fig[1, 1], s, colormap=cgrad(:heat, 4, categorical = true))
hidedecorations!(ax)
hidespines!(ax)
xlims!(ax, 0.5, size(s,2)+0.5) # otherwise there is padding
ylims!(ax, 0.5, size(s,1)+0.5) # otherwise there is padding
# set the aspect ratio of the plot
ax.aspect = DataAspect()
# set the aspect ratio of the layout
colsize!(fig.layout, 1, Aspect(1, size(s,2)/size(s,1))) 
Colorbar(fig[1, 2], p, ticks = (0:3, ["I", "X", "Z", "Y"]))
fig
```

Or set a completely custom set of colors:

```@example makie1
fig = Figure()
ax, p = stabilizerplot(fig[1, 1], s, colormap=cgrad([:lightgray,RGBf(1,0.4,0.4),RGBf(0.3,1,0.5),RGBf(0.4,0.4,1)], 4, categorical = true))
hidedecorations!(ax)
hidespines!(ax)
xlims!(ax, 0.5, size(s,2)+0.5)
ylims!(ax, 0.5, size(s,1)+0.5)
ax.aspect = DataAspect()
colsize!(fig.layout, 1, Aspect(1, size(s,2)/size(s,1))) 
Colorbar(fig[2, 1], p, ticks = (0:3, ["I", "X", "Z", "Y"]), vertical = false, flipaxis = false)
fig
```

You might have noticed, Makie recipes do not let you edit the axes or figure,
rather they only permit you to set the plot content.
Which is why we use `hidedecorations!`, `hidesplines!`, and `DataAspect`
to further modify the plot. However, these defaults are also available in `stabilizerplot_axis`.

```@example makie1
using QuantumClifford, CairoMakie
f=Figure()
stabilizerplot_axis(f[1,1],random_stabilizer(100))
f
```

## `Quantikz.jl`

With the Quantikz library you can visualize gates or sequences of gates.

```@example
using QuantumClifford, Quantikz
circuit = [sCNOT(1,2), SparseGate(random_clifford(4), [1,4,5,6]), sMZ(4)]
```

# Simulation of Noisy Clifford Circuits

```@meta
DocTestSetup = quote
    using QuantumClifford
end
```

We have support for the simulation of noisy Clifford circuits, providing a framework for exploring noise processes within quantum systems

Both [Monte Carlo](@ref noisycircuits_mc) and [Perturbative Expansion](@ref noisycircuits_perturb) approaches are supported. When performing a perturbative expansion in the noise parameter, the expansion can optionally be performed symbolically, to arbitrary high orders.

Multiple [notebooks with examples](@ref tutandpub) are also available.
For instance, see this tutorial on [entanglement purification for many examples](https://github.com/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Noisy_Circuits_Tutorial_with_Purification_Circuits.ipynb).

# [Monte Carlo simulations of noisy Clifford circuits](@id noisycircuits_mc)

```@meta
DocTestSetup = quote
    using QuantumClifford
    using QuantumClifford.Experimental.NoisyCircuits
    using Quantikz
end
```

!!! warning "Unstable"
    This is experimental functionality with an unstable API.

Import with `using QuantumClifford.Experimental.NoisyCircuits`.

This module enables the simulation of noisy Clifford circuits through a Monte Carlo method where the same circuit is evaluated multiple times with random errors interspersed through it as prescribed by a given error model.

Below is an example of a purification circuit. We first prepare the circuit we desire to use, including a noise model. `Quantikz.jl` is used to visualize the circuit.

```@example 1
using QuantumClifford # hide
using QuantumClifford.Experimental.NoisyCircuits # hide
using Quantikz # hide
good_bell_state = S"XX
                    ZZ"
initial_state = MixedDestabilizer(good_bell_state⊗good_bell_state)

g1 = sCNOT(1,3) # CNOT between qubit 1 and qubit 3 (both with Alice)
g2 = sCNOT(2,4) # CNOT between qubit 2 and qubit 4 (both with Bob)
m = BellMeasurement([sMX(3),sMX(4)]) # Bell measurement on qubit 3 and 4
v = VerifyOp(good_bell_state,[1,2]) # Verify that qubit 1 and 2 indeed form a good Bell pair
epsilon = 0.01 # The error rate
n = NoiseOpAll(UnbiasedUncorrelatedNoise(epsilon))

# This circuit performs a depolarization at rate `epsilon` to all qubits,
# then bilater CNOT operations
# then a Bell measurement
# followed by checking whether the final result indeed corresponds to the correct Bell pair.
circuit = [n,g1,g2,m,v]
```

And we can run a Monte Carlo simulation of that circuit with [`mctrajectories`](@ref).

```@example 1
mctrajectories(initial_state, circuit, trajectories=500)
```

For more examples, see the [notebook comparing the Monte Carlo and Perturbative method](https://nbviewer.jupyter.org/github/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Perturbative_Expansions_vs_Monte_Carlo_Simulations.ipynb) or this tutorial on [entanglement purification for many examples](https://github.com/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Noisy_Circuits_Tutorial_with_Purification_Circuits.ipynb).

## Interface for custom operations

If you want to create a custom gate type (e.g. calling it `Operation`), you need to definite the following methods.

`applywstatus!(s::T, g::Operation)::Tuple{T,Symbol}` where `T` is a tableaux type like [`Stabilizer`](@ref) or a [`Register`](@ref).
The `Symbol` is the status of the operation. Predefined statuses are kept in the `registered_statuses` list, but you can add more.
Be sure to expand this list if you want the trajectory simulators using your custom statuses to output all trajectories.

There is also [`applynoise!`](@ref) which is a convenient way to create a noise model that can then be plugged into the [`NoisyGate`](@ref) struct,
letting you reuse the predefined perfect gates and measurements.
However, you can also just make up your own noise operator simply by implementing [`applywstatus!`](@ref) for it.

You can also consult the [list of implemented operators](@ref noisycircuits_ops).

# [Useful States and Operators](@id Useful-States-and-Operators)

```@meta
DocTestSetup = quote
    using QuantumClifford
    using StableRNGs
    rng = StableRNG(42)
end
```
## States

Stabilizer states can be represented with the [`Stabilizer`](@ref), [`Destabilizer`](@ref), [`MixedStabilizer`](@ref), and [`MixedDestabilizer`](@ref) tableau data structures. You probably want to use [`MixedDestabilizer`](@ref) which supports the widest set of operations.

Moreover, a [`MixedDestabilizer`](@ref) can be stored inside a [`Register`](@ref) together with a set of classical bits in which measurement results can be written.

Below are convenience constructors for common types of states and operators,
already implemented in this library.

## Pauli Operators

Single qubit `PauliOperator` is implemented in [`single_z`] and [`single_x`].

```jldoctest
julia> single_z(4,2)
+ _Z__

julia> single_x(4,3)
+ __X_
```

All identity operators use `zero`.

```jldoctest
julia> zero(PauliOperator, 3)
+ ___

julia> zero(P"XYZXYZ")
+ ______
```

Random Pauli operators are implemented as well (with or without a random phase).

```jldoctest rand
julia> using StableRNGs; rng = StableRNG(42);

julia> random_pauli(rng, 4)
+ ZYY_

julia> random_pauli(rng, 4; nophase=false)
- YZ_X
```

## Stabilizer States

An all-identity stabilizer can be created with `zero`.

```jldoctest
julia> zero(Stabilizer, 3)
+ ___
+ ___
+ ___

julia> zero(Stabilizer, 2, 3)
+ ___
+ ___

julia> zero(S"XIZ
              YZX")
+ ___
+ ___
```

Diagonal stabilizers in different bases are available as well, through `one`.

```jldoctest
julia> one(Stabilizer, 3)
+ Z__
+ _Z_
+ __Z

julia> one(Stabilizer, 3; basis=:Y)
+ Y__
+ _Y_
+ __Y

julia> one(S"XX
             ZZ")
+ Z_
+ _Z
```

A random stabilizer (or destabilizers or Clifford operators) can be created as well. We use the algorithm described in [bravyi2020hadamard](@cite).

```jldoctest rand
julia> random_stabilizer(rng, 2,5)
+ YZXZZ
- XZYYY
```
## Mixed States

Similarly, one can create a diagonal mixed state.

```jldoctest
julia> one(MixedDestabilizer, 2, 3)
𝒟ℯ𝓈𝓉𝒶𝒷
+ X__
+ _X_
𝒳ₗ━━━
+ __X
𝒮𝓉𝒶𝒷━
+ Z__
+ _Z_
𝒵ₗ━━━
+ __Z
```

## Enumerating all Clifford Operations

The algorithm from [koenig2014efficiently](@cite) can be used to enumerate all Clifford operations on a given number of qubits through [`enumerate_cliffords`](@ref).
Or one can use [`random_clifford`](@ref), [`random_stabilizer`](@ref) to directly sample from that set.

```jldoctest
julia> length(enumerate_cliffords(1))
6

julia> length(enumerate_cliffords(2))
720
```

To also enumerate possible phases, you can use [`enumerate_phases`](@ref).

```jldoctest
julia> length(collect(enumerate_phases(tCNOT)))
16

julia> length(collect(enumerate_phases(enumerate_cliffords(2))))
11520
```

## Common entangled states

Bell states and GHZ states have convenience constructors:

```jldoctest
julia> bell()
+ XX
+ ZZ

julia> bell(2)
+ XX__
+ ZZ__
+ __XX
+ __ZZ

julia> ghz(4)
+ XXXX
+ ZZ__
+ _ZZ_
+ __ZZ
```

# Full API (autogenerated)

!!! warning "Unstable"
    This is experimental functionality with an unstable API.

```@autodocs
Modules = [QuantumClifford.Experimental.NoisyCircuits]
Private = false
```

# QuantumClifford.jl

```@meta
DocTestSetup = quote
    using QuantumClifford
end
```

QuantumClifford.jl is a comprehensive library for the study, simulation, and manipulation of Clifford circuits and slightly non-Clifford circuits. For it, we run weekly online "office hours" [for modeling problems in quantum information science](@ref Office-Hours).

This library uses the **tableaux formalism[^1]** with the **destabilizer improvements[^2]**. Moreover, **Pauli frames** are supported for faster repeated simulation of noisy circuits. Various **symbolic and algebraic tools for manipulating, converting, and visualizing states and circuits** are also available. Finite-Clifford-rank tools for modeling circuits with **few non-Clifford gates** are provided. 

[^1]: [gottesman1998heisenberg](@cite)

[^2]: [aaronson2004improved](@cite)

The library consists of a few related components:

- Tools for working with the algebra of Stabilizer Tableaux, through data structures like [`Stabilizer`](@ref), [`MixedDestabilizer`](@ref), and [`PauliOperator`](@ref); canonicalization routines like [`canonicalize!`](@ref) and others; algebraic operations like [`project!`](@ref), partial trace, and more.

- General unitary operation acting on states: [`PauliOperator`](@ref), dense `n×n` [`CliffordOperator`](@ref), sparse small [named single-qubit and two-qubit operators](@ref Symbolic-Clifford-Operators).

- Fast circuit simulators over stabilizer states and small-Clifford-rank non-stabilizer states: Monte Carlo with [`mctrajectories`](@ref); and symbolic perturbative expansions with [`petrajectories`](@ref).

- Even faster simulator over more restricted data structures like Pauli frames with [`pftrajectories`](@ref).

- Support for small-rank non-Clifford states and arbitrary (non-unitary) Pauli channels acting on them, as well as Clifford unitaries and Pauli measurements.

- Generators of sophisticated error correcting codes, related circuits, and their evaluation.

## Stabilizer Tableau Algebra

The Stabilizer Tableau Algebra component of QuantumClifford.jl efficiently handles [pure](@ref Stabilizers) and [mixed stabilizer](@ref Mixed-Stabilizer-States) states of thousands of qubits, along with support for [sparse or dense Clifford operations](@ref Clifford-Operators) acting upon them. It provides operations such as [canonicalization](@ref Canonicalization-of-Stabilizers), [projection](@ref Projective-Measurements), [generation](@ref Generating-a-Pauli-Operator-with-Stabilizer-Generators) , and [partial traces](@ref Partial-Traces). The code is vectorized and multithreaded, offering fast, in-place, and allocation-free implementations. Tools for conversion to [graph states](@ref Graph-States) and for [visualization of tableaux](@ref Visualizations) are available.

See the [Stabilizer Tableau Algebra manual](@ref Stabilizer-Tableau-Algebra-Manual) or the curated list of [useful functions](@ref Full-API).

### Example Usage

```julia
julia> using QuantumClifford

julia> P"X" * P"Z"
-iY

julia> P"X" ⊗ P"Z"
+ XZ

julia> S"-XX
         +ZZ"
- XX
+ ZZ

julia> tCNOT * S"-XX
                 +ZZ"
- X_
+ _Z
```

## Circuit Simulation

The circuit simulation component of QuantumClifford.jl enables Monte Carlo (or symbolic) simulations of noisy Clifford circuits. It provides three main simulation methods: `mctrajectories`, `pftrajectories`, and `petrajectories`. These methods offer varying levels of efficiency, accuracy, and insight.

### Monte Carlo Simulations with Stabilizer Tableaux (`mctrajectories`)

The [`mctrajectories`](@ref) method runs Monte Carlo simulations using a Stabilizer tableau representation (or more general representations) for the quantum states. This simulation methods supports many operations that are not supported by the Pauli frame simulator, but it is much slower.

### Monte Carlo Simulations with Pauli Frames (`pftrajectories`)

The [`pftrajectories`](@ref) method runs Monte Carlo simulations of Pauli frames over a single reference Stabilizer tableau simulation. This approach is much more efficient but supports a smaller class of circuits.

### Symbolic Depth-First Traversal of Quantum Trajectories (`petrajectories`)

The [`petrajectories`](@ref) method performs a depth-first traversal of the most probable quantum trajectories, providing a fixed-order approximation of the circuit's behavior. This approach gives symbolic expressions for various figures of merit instead of just a numeric value.

## Non-Clifford Capabilities

The [`GeneralizedStabilizer`](@ref) type lets you run arbitrary Clifford circuits efficiently and also to run (non-unitary) Pauli Channels with a cost exponential in the number of channel applications.

## Error Correcting Codes

The `QuantumClifford.ECC` submodule can be used to generate the parity checks of many sophisticated codes, as well as to generate different styles of syndrome extraction circuits and to benchmark their performance with many different decoders.

## [Office Hours](@id Office-Hours)

Office hours are held every Friday from 12:30 – 1:30 PM Eastern Time via [Zoom](https://umass-amherst.zoom.us/j/95986275946?pwd=6h7Wbai1bXIai0XQsatNRWaVbQlTDr.1). Before joining, make sure to check the [Julia community events calendar](https://julialang.org/community/#events) to confirm whether office hours are happening, rescheduled, or canceled for the week. Feel free to bring any questions or suggestions!

## Support

QuantumClifford.jl is developed by [many volunteers](https://github.com/QuantumSavory/QuantumClifford.jl/graphs/contributors), managed at [Prof. Krastanov's lab](https://lab.krastanov.org/) at [University of Massachusetts Amherst](https://www.umass.edu/quantum/).

The development effort is supported by The [NSF Engineering and Research Center for Quantum Networks](https://cqn-erc.arizona.edu/), and
by NSF Grant 2346089 "Research Infrastructure: CIRC: New: Full-stack Codesign Tools for Quantum Hardware".

## Bounties

[We run many bug bounties and encourage submissions from novices (we are happy to help onboard you in the field).](https://github.com/QuantumSavory/.github/blob/main/BUG_BOUNTIES.md)

# [Perturbative expansions for simulating noisy Clifford circuits](@id noisycircuits_perturb)

```@meta
DocTestSetup = quote
    using QuantumClifford
    using Quantikz
    using QuantumClifford.ECC
end
```

This module enables the simulation of noisy Clifford circuits through a perturbative expansion in the noise parameter (assuming the noise is small).
Instead of simulating many Monte Carlo trajectories, only the leading order trajectories are exhaustively enumerated and simulated, supporting even obtaining symbolic expressions for figures of merit.

# Purification Circuit Example

Here is an example of a purification circuit (the same circuit seen in the [Monte Carlo example](@ref noisycircuits_mc))

```@example
using QuantumClifford # hide
using Quantikz # hide
using QuantumClifford.ECC # hide
good_bell_state = S"XX
                    ZZ"
canonicalize_rref!(good_bell_state)
initial_state = MixedDestabilizer(good_bell_state⊗good_bell_state)

g1 = sCNOT(1,3) # CNOT between qubit 1 and qubit 3 (both with Alice)
g2 = sCNOT(2,4) # CNOT between qubit 2 and qubit 4 (both with Bob)
m = BellMeasurement([sMX(3),sMX(4)]) # Bell measurement on qubit 3 and 4
v = VerifyOp(good_bell_state,[1,2]) # Verify that qubit 1 and 2 indeed form a good Bell pair
epsilon = 0.01 # The error rate
n = NoiseOpAll(UnbiasedUncorrelatedNoise(epsilon))

# This circuit performs a depolarization at rate `epsilon` to all qubits,
# then bilater CNOT operations
# then a Bell measurement
# followed by checking whether the final result indeed corresponds to the correct Bell pair.
circuit = [n,g1,g2,m,v]

petrajectories(initial_state, circuit)
```

For more examples, see the [notebook comparing the Monte Carlo and Perturbative method](https://nbviewer.jupyter.org/github/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Perturbative_Expansions_vs_Monte_Carlo_Simulations.ipynb) or this tutorial on [entanglement purification](https://github.com/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Noisy_Circuits_Tutorial_with_Purification_Circuits.ipynb).

## Symbolic expansions

The perturbative expansion method works with symbolic variables as well. One can use any of the symbolic libraries available in Julia and simply plug symbolic parameters in lieu of numeric parameters. A detailed example is available as a [Jupyter notebook](https://nbviewer.jupyter.org/github/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Symbolic_Perturbative_Expansions.ipynb).

## Interface for custom operations

If you want to create a custom gate type (e.g. calling it `Operation`), you need to definite the following methods.

`applyop_branches!(s::T, g::Operation; max_order=1)::Vector{Tuple{T,Symbol,Real,Int}}` where `T` is a tableaux type like [`Stabilizer`](@ref) or a [`Register`](@ref).
The `Symbol` is the status of the operation, the `Real` is the probability for that branch, and the `Int` is the order of that branch.

There is also `applynoise_branches!` which is convenient for use in `NoisyGate`, but you can also just make up your own noise operator simply by implementing `applyop_branches!` for it.

You can also consult the [list of implemented operators](@ref noisycircuits_ops).

# Error Correction in Perturbative Expansion Simulations

Here is an example that demonstrates the simulation of a noisy quantum circuit using perturbative expansions, where error correction is incorporated through a `DecoderCorrectionGate`. After encoding the Steane code and introducing noise, the decoder correction gate applies the (hopefully) most likely correction based on the measured syndrome, leading to a noticeable improvement in the logical success rate. This illustrates how perturbative expansion methods can be combined with error-correcting circuits to study performance under noise.

Some of the relevant structures and functions used in this code are:
 - [`Register`](@ref)
 - [`TableDecoder`](@ref)
 - [`DecoderCorrectionGate`](@ref)
 - [`petrajectories`](@ref)

```@example 1
using QuantumClifford
using QuantumClifford.ECC: Steane7, parity_checks, naive_encoding_circuit, naive_syndrome_circuit, TableDecoder, DecoderCorrectionGate, code_n, code_s

code = parity_checks(Steane7()) #creates the stabilizer tableau for the Steane code
data = code_n(code)
checks = code_s(code)
qbits = data+checks
register = Register(one(MixedDestabilizer, qbits), checks) # A register with 13 qubits, 7 data qubits and 6 ancillas
decoder = TableDecoder(code) # creates a decoder based on the Steane code

noiseless_state = one(MixedDestabilizer, data)
encoding_circuit = naive_encoding_circuit(code) # circuit to encode a state in the Steane codespace
mctrajectory!(noiseless_state, encoding_circuit) # applies each gate in ecirc to noiseless_state
verify = VerifyOp(noiseless_state, 1:data) # prepare a "tomographic" verification operation, checking that the first 7 qubits of the register indeed form still the same code word

syndrome_circuit,_,_ = naive_syndrome_circuit(code) # the operations needed to extract the error syndrome
epsilon = 0.1
noise = NoiseOp(UnbiasedUncorrelatedNoise(epsilon), (1:data)) # an op that introduces noise into the circuit

circuit = vcat(encoding_circuit, noise, syndrome_circuit, verify) 
```

we can run perturbative expansions with [`petrajectories`](@ref).

```@example 1
pet = petrajectories(register, circuit; max_order=3)
pet
```
We see that the `true_success` rate is pretty terrible.
In order to improve this rate with the help of error correction, we can use the [`DecoderCorrectionGate`](@ref):

```@example 1
correction_gate = DecoderCorrectionGate(decoder, 1:data, 1:checks) # takes in the decoder, data qubits and syndrome bits as an input and guesses the most probable error correcting Pauli Operation based on the recorded syndrome
```

Let's include the correction gate in our list of circuit operations and place it after syndrome collection.

```@example 1
circuit = vcat(encoding_circuit, noise, syndrome_circuit, correction_gate, verify) 
pet = petrajectories(register, circuit; max_order=3)
pet
```
We can see that the `true_success` rate has gone up significantly.

# [Evaluating an ECC code and decoders](@id ecc_evaluating)

```@meta
DocTestSetup = quote
    using QuantumClifford
    using QuantumClifford.ECC
end
CurrentModule = QuantumClifford.ECC
```

!!! warning "The documentation is incomplete"
    While waiting for a better documentation than the small example below, consider looking into [`evaluate_decoder`](@ref), [`TableDecoder`](@ref), [`BeliefPropDecoder`](@ref), [`PyBeliefPropDecoder`](@ref), [`PyMatchingDecoder`](@ref), [`CommutationCheckECCSetup`](@ref), [`NaiveSyndromeECCSetup`](@ref), [`ShorSyndromeECCSetup`](@ref)

This is a quick and durty example on how to use some of the decoders.

A function to plot the results of 

```@example decoderexample
using CairoMakie

function make_decoder_figure(phys_errors, results, title="")
    minlim = min(minimum(phys_errors),minimum(results[results.!=0]))
    maxlim = min(1, max(maximum(phys_errors),maximum(results[results.!=0])))

    fresults = copy(results)
    fresults[results.==0] .= NaN

    f = Figure()
    a = Axis(f[1,1],
        xscale=log10, yscale=log10,
        limits=(minlim,maxlim,minlim,maxlim),
        aspect=DataAspect(),
        xlabel="physical error rate",
        ylabel="logical error rate",
        title=title)
    lines!(a, [minlim,maxlim],[minlim,maxlim], color=:black)
    for (i,sresults) in enumerate(eachslice(fresults, dims=1))
        scatter!(a, phys_errors, sresults[:,1], marker=:+, color=Cycled(i))
        scatter!(a, phys_errors, sresults[:,2], marker=:x, color=Cycled(i))
    end
    f
end
```

Testing out a lookup table decoder on a small code.

```@example decoderexample
using QuantumClifford
using QuantumClifford.ECC

mem_errors = 0.001:0.0005:0.01
codes = [Shor9()]
results = zeros(length(codes), length(mem_errors), 2)

for (ic, c) in pairs(codes)
    for (i,m) in pairs(mem_errors)
        setup = CommutationCheckECCSetup(m)
        decoder = TableDecoder(c)
        r = evaluate_decoder(decoder, setup, 10000)
        results[ic,i,:] .= r
    end
end

make_decoder_figure(mem_errors, results, "Shor's code with a lookup table decoder")
```

Testing out the toric code with a decoder provided by the python package `pymatching` (provided in julia by the meta package `PyQDecoders.jl`).

```@example decoderexample
import PyQDecoders

mem_errors = 0.001:0.005:0.1
codes = [Toric(4,4), Toric(6,6)]
results = zeros(length(codes), length(mem_errors), 2)

for (ic, c) in pairs(codes)
    for (i,m) in pairs(mem_errors)
        setup = ShorSyndromeECCSetup(m, 0)
        decoder = PyMatchingDecoder(c)
        r = evaluate_decoder(decoder, setup, 1000)
        results[ic,i,:] .= r
    end
end

make_decoder_figure(mem_errors, results, "Toric code with a MWPM decoder")
```

# [ECC example with Pauli Frames](@id noisycircuits_pf_ecc_example)

```@meta
DocTestSetup = quote
    using QuantumClifford
    using Quantikz
end
```

!!! warning "The documentation is incomplete"
    Waiting for a better documentation than the small example below.
    Check out also the page on [ECC performance evaluators](@ref ecc_evaluating)


Consider Steane 7-qubit code:

```@example 1
using QuantumClifford
using QuantumClifford.ECC: Steane7, naive_syndrome_circuit, naive_encoding_circuit, parity_checks, code_s, code_n
using Quantikz

code = Steane7()
H = parity_checks(code)
```

... and the corresponding encoding circuit
```@example 1
ecirc = naive_encoding_circuit(code)
```

... and the corresponding syndrome measurement circuit (the non-fault tolerant one)
```@example 1
scirc, _ = naive_syndrome_circuit(code)
```

The most straightforward way to start sampling syndromes is to set up a table of Pauli frames.

```@example 1
circuit = [ecirc..., scirc...]
nframes = 4
frames = pftrajectories(circuit; trajectories=nframes) # run the sims
pfmeasurements(frames)                                 # extract the measurements
```

The [`pftrajectories`](@ref) function is multithreaded.
If you want more low-level control over these Pauli frame simulations, check out the [`PauliFrame`](@ref) structure,
the other methods of [`pftrajectories`](@ref), and the circuit compactifaction function [`compactify_circuit`](@ref).

If you want to model Pauli errors, use:

- The helper [`PauliError`](@ref) for unbiased Pauli noise operation acting on a given qubit
- The lower level [`NoiseOp`](@ref) (for a single qubit) or [`NoiseOpAll`](@ref) (for all qubits) parameterized with a particular noise type, e.g. [`UnbiasedUncorrelatedNoise`](@ref)

```@example 1
errprob = 0.1
errors = [PauliError(i,errprob) for i in 1:code_n(code)]
fullcircuit = [ecirc..., errors..., scirc...]
```

And running this noisy simulation:
```@example 1
frames = pftrajectories(fullcircuit; trajectories=nframes)
pfmeasurements(frames)
```

# [Noise Processes](@id noise)

```@meta
DocTestSetup = quote
    using QuantumClifford
    using StableRNGs
    rng = StableRNG(42)
end
```

As seen in the list of [possible gates](@ref all-operations),
the simulator is capable of modeling different types of noise.
If that is your goal, please consider using the available
[Monte Carlo simulator](@ref noisycircuits_mc) or the
[Symbolic Perturbative Expansion system](@ref noisycircuits_perturb).

The implemented types of noise include:

- [`UnbiasedUncorrelatedNoise`](@ref)
- [`PauliNoise`](@ref)

The low-level functionality to work with noise is `applynoise!`,
but most of the time you would probably just want to use
[`PauliError`](@ref),  [`NoisyGate`](@ref), [`NoiseOp`](@ref) and [`NoiseOpAll`](@ref).

# [Tutorials and Publications](@id tutandpub)

This list has a number of notebooks with tutorials, examples, and reproduction of published results (some of these results originally obtained with this very library).

## On the topic of explicit use of the Tableaux formalism for Stabilizer states 

- [Quantum coding with low-depth random circuits](https://github.com/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Stabilizer_Codes_Based_on_Random_Circuits.ipynb) reproducing results from [gullans2021quantum](@cite). [view on nbviewer.jupyter.org](https://nbviewer.jupyter.org/github/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Stabilizer_Codes_Based_on_Random_Circuits.ipynb)


## On the Monte Carlo and Perturbative Expansions for **Noisy** Clifford circuits

- [In-depth study of multi-partite entanglement purification circuits](https://github.com/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Noisy_Circuits_Tutorial_with_Purification_Circuits.ipynb) reproducing results from [krastanov2020heterogeneous](@cite). [view on nbviewer.jupyter.org](https://nbviewer.jupyter.org/github/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Noisy_Circuits_Tutorial_with_Purification_Circuits.ipynb)
- [Comparing the Monte Carlo and Perturbative method for noisy circuit simulations](https://github.com/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Perturbative_Expansions_vs_Monte_Carlo_Simulations.ipynb). [view on nbviewer.jupyter.org](https://nbviewer.jupyter.org/github/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Perturbative_Expansions_vs_Monte_Carlo_Simulations.ipynb)
- [Showcasing symbolic perturbative expansions of noisy circuits](https://github.com/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Symbolic_Perturbative_Expansions.ipynb). [view on nbviewer.jupyter.org](https://nbviewer.jupyter.org/github/QuantumSavory/QuantumClifford.jl/blob/master/docs/src/notebooks/Symbolic_Perturbative_Expansions.ipynb)

# [Graph States](@id Graph-States)

!!! warning "The `graphstate` API is not considered stable"
    `graphstate` returns a lot of information about encoding a given stabilizer state in a graph. A different API is being designed that streamlines the work with graph states.

Conversion to and from [graph states](https://en.wikipedia.org/wiki/Graph_state) is possible.

Consider a GHZ state:

```@example
using QuantumClifford # hide
ghz(4)
```

It can be converted to a graph state with [`graphstate`](@ref)

```julia
graphstate(ghz(4))[1]
```

```@eval
using Random; Random.seed!(1); using QuantumClifford, GraphMakie, CairoMakie;
f = Figure(size=(200,200))
a = Axis(f[1,1])
graphplot!(a,graphstate(ghz(4))[1])
hidedecorations!(a); hidespines!(a)
a.aspect = DataAspect()
save("ghz4graph.png", f); nothing
```

![](ghz4graph.png)

Notice that the initial GHZ state was not in the typical graph state form. We can see that explicitly by converting back and forth between the two forms:

```jldoctest graph
julia> using Graphs, QuantumClifford

julia> ghz(4)
+ XXXX
+ ZZ__
+ _ZZ_
+ __ZZ

julia> Stabilizer(Graph(ghz(4)))
+ XZZZ
+ ZX__
+ Z_X_
+ Z__X
```

There is a set of single-qubit operations that can convert any stabilizer tableau into a state representable as a graph. These transformations are performed implicitly by the `Graph` constructor when converting from a `Stabilizer`. If you need the explicit transformation you can use the [`graphstate`](@ref) function that specifies which qubits require a Hadamard, Inverse Phase, or Phase Flip gate. The [`graph_gatesequence`](@ref) or [`graph_gate`](@ref) helper functions can be used to generate the exact operations:

```jldoctest graph
julia> s = ghz(4)
+ XXXX
+ ZZ__
+ _ZZ_
+ __ZZ

julia> g, h_idx, ip_idx, z_idx = graphstate(s);

julia> gate = graph_gate(h_idx, ip_idx, z_idx, nqubits(s))
X₁ ⟼ + X___
X₂ ⟼ + _Z__
X₃ ⟼ + __Z_
X₄ ⟼ + ___Z
Z₁ ⟼ + Z___
Z₂ ⟼ + _X__
Z₃ ⟼ + __X_
Z₄ ⟼ + ___X

julia> canonicalize!(apply!(s,gate)) == canonicalize!(Stabilizer(g))
true
```

These converters also provides for a convenient way to create graph and cluster states, by using the helper constructors provided in `Graphs.jl`.

```jldoctest graph
julia> Stabilizer(grid([4,1])) # Linear cluster state
+ XZ__
+ ZXZ_
+ _ZXZ
+ __ZX

julia> Stabilizer(grid([2,2])) # Small 2D cluster state
+ XZZ_
+ ZX_Z
+ Z_XZ
+ _ZZX
```

Graphs are represented with the `Graphs.jl` package and plotting can be done both in `Plots.jl` and `Makie.jl` (with `GraphMakie`).

# [Mixed Stabilizer States](@id Mixed-Stabilizer-States)

```@meta
DocTestSetup = quote
    using QuantumClifford
end
```

The [`Stabilizer`](@ref) and [`Destabilizer`](@ref) have some support for mixed
states (by being initialized with an incomplete list of stabilizer generators),
but for most purposes one would use the `Mixed*` data structures.

Mixed stabilizer states are implemented with [`MixedStabilizer`](@ref) and
[`MixedDestabilizer`](@ref), the latter of which is the preferred data structure
for most tasks as it is much faster by virtue of tracking the destabilizer
generators.

```jldoctest mix
julia> s = S"XXX
             IZZ";

julia> Destabilizer(s)
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z__
+ _X_
𝒮𝓉𝒶𝒷━
+ XXX
+ _ZZ
```

Unlike `Destabilizer`, `MixedDestabilizer` also tracks the logical
operation generators.

```jldoctest mix
julia> m = MixedDestabilizer(s)
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z__
+ _X_
𝒳ₗ━━━
+ _XX
𝒮𝓉𝒶𝒷━
+ XXX
+ _ZZ
𝒵ₗ━━━
+ Z_Z

julia> stabilizerview(m)
+ XXX
+ _ZZ

julia> destabilizerview(m)
+ Z__
+ _X_

julia> logicalxview(m)
+ _XX

julia> logicalzview(m)
+ Z_Z
```

# Gottesman Canonicalization

To obtain the logical operators we perform a different type of canonicalization,
described in Gottesman's thesis and implemented in [`canonicalize_gott!`](@ref).
Unlike [`canonicalize!`](@ref) which uses only row operations,
`canonicalize_gott!` performs column swaps as well. `MixedDestabilizer` undoes
those swaps by default when instantiated, but that behavior can be turned off,
if you prefer to work with the canonicalized tableau.

```jldoctest mix
julia> s = S"XXX
             ZIZ";

julia> MixedDestabilizer(s)
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z__
+ __X
𝒳ₗ━━━
+ _X_
𝒮𝓉𝒶𝒷━
+ XXX
+ Z_Z
𝒵ₗ━━━
+ ZZ_

julia> MixedDestabilizer(s; undoperm=false)
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z__
+ _X_
𝒳ₗ━━━
+ __X
𝒮𝓉𝒶𝒷━
+ XXX
+ ZZ_
𝒵ₗ━━━
+ Z_Z
```

`Destabilizer` and `MixedStabilizer` do not use any column swaps on
instantiation as they do not track the logical operators.

# Suggested reading

For the basis of the tableaux methods first read [gottesman1998heisenberg](@cite) followed by the more efficient approach described in [aaronson2004improved](@cite).

The tableaux can be canonicalized (i.e. Gaussian elimination can be performed on them) in a number of different ways, and considering the different approaches provides useful insight. The following methods are implemented in this library:

- The default one: [garcia2012efficient](@cite)
- Useful when in need of tracing out a set of qubits: [audenaert2005entanglement](@cite)
- Useful when defining logical operators of codes: [gottesman1997stabilizer](@cite)

For the use of these methods in error correction and the subtle overlap between the two fields consider these resources. They are also useful in defining some of the specific constraints in commutation between rows in the tableaux:

- [steane2007tutorial](@cite)
- [calderbank1998quantum](@cite)
- [mackay2004sparse](@cite)
- [wilde2009logical](@cite)

These publications describe the uniform sampling of random stabilizer states:

- [koenig2014efficiently](@cite)
- [bravyi2020hadamard](@cite)
- [berg2020simple](@cite)
- [li2019measurement](@cite)

For circuit construction routines (for stabilizer measurements for a given code):
- [cleve1997efficient](@cite)
- [gottesman1997stabilizer](@cite) (and its erratum)
- [grassl2002algorithmic](@cite)
- [grassl2011variations](@cite)

For quantum code construction routines:
- [cleve1997efficient](@cite)
- [gottesman1996class](@cite)
- [gottesman1997stabilizer](@cite)
- [yu2013all](@cite)
- [chao2018quantum](@cite)
- [kitaev2003fault](@cite)
- [fowler2012surface](@cite)
- [knill1996concatenated](@cite)
- [steane1999quantum](@cite)
- [campbell2012magic](@cite)
- [anderson2014fault](@cite)
- [wang2024coprime](@cite)
- [voss2024multivariatebicyclecodes](@cite)
- [lin2024quantum](@cite)
- [bravyi2024high](@cite)
- [haah2011local](@cite)
- [landahl2011color](@cite)
- [wang2023abelian](@cite)
- [naghipour2015quantum](@cite)

For classical code construction routines:
- [muller1954application](@cite)
- [reed1954class](@cite)
- [raaphorst2003reed](@cite)
- [abbe2020reed](@cite)
- [djordjevic2021quantum](@cite)
- [hocquenghem1959codes](@cite)
- [bose1960class](@cite)
- [bose1960further](@cite)
- [error2024lin](@cite)
- [golay1949notes](@cite)
- [huffman2010fundamentals](@cite)
- [bhatia2018mceliece](@cite)

For minimum distance calculation of quantum codes:
- [vardy1997intractability](@cite)
- [Sabo:2022smk](@cite)
- [kapshikar2023hardness](@cite)
- [landahl2011color](@cite)
- [white2006new](@cite)
- [pryadko2023qdistrnd](@cite)
- [makhorin2008glpk](@cite)
- [Lubin2023](@cite)
- [huangfu2018parallelizing](@cite)
- [wang2022distanceboundsgeneralizedbicycle](@cite)

# References

```@bibliography
```

# [Operations - Gates, Measurements, and More](@id all-operations)

```@meta
DocTestSetup = quote
    using QuantumClifford
    using StableRNGs
    rng = StableRNG(42)
end
```

## Operations

Acting on quantum states can be performed either:

- In a "linear algebra" language where unitaries, measurements, and other operations have separate interfaces. This is an explicitly deterministic lower-level interface, which provides a great deal of control over how tableaux are manipulated. See the [Stabilizer Tableau Algebra Manual](@ref Stabilizer-Tableau-Algebra-Manual) as a primer on these approaches.
- Or in a "circuit" language, where the operators (and measurements and noise) are represented as circuit gates. This is a higher-level interface in which the outcome of an operation can be stochastic. The API for it is centered around the `apply!` function. Particularly useful for [Monte Carlo simulations](@ref noisycircuits_mc) and [Perturbative Expansion Symbolic Results](@ref noisycircuits_perturb).

In the circuit language, all operations can be applied on a state with the [`apply!`](@ref) function. Whether they are deterministic and their computational complexity is listed in the table below. A list of lower-level "linear algebra style" functions for more control over how an operation is performed is also given.

```@raw html
<style>
td > code {
    white-space: pre;
}
.content table td, .content table th {
	padding: 0 1em;
}
</style>
```

| Type | Deterministic | 𝒪(nˣ) | Low-level functions 
|:--|:-:|---|---|
|`AbstractOperation                      `|  |   |                        |
|` ├─ AbstractCliffordOperator           `|  |   |                        |
|` │   ├─ AbstractSymbolicOperator       `|  |   |                        |
|` │   │   ├─ AbstractSingleQubitOperator`|  |   |                        |
|` │   │   │   ├─ SingleQubitOperator    `|✔️ | n |                        |
|` │   │   │   ├─ sHadamard              `|✔️ | n |                        |
|` │   │   │   ├─ sId1                   `|✔️ | n |                        |
|` │   │   │   ├─ sInvPhase              `|✔️ | n |                        |
|` │   │   │   ├─ sPhase                 `|✔️ | n |                        |
|` │   │   │   ├─ sX                     `|✔️ | n |                        |
|` │   │   │   ├─ sY                     `|✔️ | n |                        |
|` │   │   │   └─ sZ                     `|✔️ | n |                        |
|` │   │   └─ AbstractTwoQubitOperator   `|  |   |                        |
|` │   │       ├─ sCNOT                  `|✔️ | n |                        |
|` │   │       ├─ sCPHASE                `|✔️ | n |                        |
|` │   │       └─ sSWAP                  `|✔️ | n |                        |
|` │   │                                 `|  |   |                        |
|` │   ├─ CliffordOperator               `|✔️ | n³|                        |
|` │   ├─ PauliOperator                  `|✔️ | n²|                        |
|` │   └─ SparseGate                     `|✔️ |kn²|                        |
|` ├─ AbstractMeasurement                `|  |   |                        |
|` │   ├─ PauliMeasurement               `|❌ | n²| [`project!`](@ref), [`projectrand!`](@ref) |
|` │   ├─ sMX                            `|❌ | n²| [`projectX!`](@ref)    |
|` │   ├─ sMY                            `|❌ | n²| [`projectY!`](@ref)    |
|` │   └─ sMZ                            `|❌ | n²| [`projectZ!`](@ref)    |
|` │                                     `|  |   |                        |
|` ├─ AbstractResetMeasurement           `|  |   |                        |
|` │   ├─ sMRX                           `|❌ | n²| [`projectX!`](@ref)   |
|` │   ├─ sMRY                           `|❌ | n²| [`projectY!`](@ref)   |
|` │   └─ sMRZ                           `|❌ | n²| [`projectZ!`](@ref)   |
|` │                                     `|  |   |                        |
|` ├─ BellMeasurement                    `|❌ | n²|                        |
|` ├─ NoiseOp                            `|❌ |  ?| [`applynoise!`](@ref)  |
|` ├─ NoiseOpAll                         `|❌ |  ?| [`applynoise!`](@ref)  |
|` ├─ NoisyGate                          `|❌ |  ?| [`applynoise!`](@ref)  |
|` ├─ Reset                              `|✔️ |kn²| [`reset_qubits!`](@ref)|
|` │                                     `|  |   |                        |
|` ├─ AbstractNonCliffordOperator        `|  |   |                        |
|` │   ├─ sT                             `|✔️ |exp|                        |
|` │   └─ sCCZ                           `|✔️ |exp|                        |
|` └─ AbstractPauliChannel               `|  |   |                        |
|`     ├─ PauliChannel                   `|✔️ |exp|                        |
|`     └─ UnitaryPauliChannel            `|✔️ |exp|                        |

## Details of Operations Supported by [`apply!`](@ref)

### Unitary Gates

We distinguish between symbolic gates like [`sCNOT`](@ref) that have specialized (fast) `apply!` methods (usually just for single and two qubit gates) and general tableau representation of gates like [`CliffordOperator`](@ref) that can represent any multi-qubit gate.

Predefined unitary gates are available, like [`sCNOT`](@ref), [`sHadamard`](@ref), etc.

```@example 1
using QuantumClifford # hide
using Quantikz # hide
[sCNOT(2,4),sHadamard(2),sCPHASE(1,3),sSWAP(2,4)]
```

Any arbitrary tableaux can be used as a gate too. 

They can be specified by giving a Clifford operator tableaux and the indices on which it acts
(particularly useful for gates acting on a small part of a circuit):

```@example 1
using QuantumClifford # hide
using Quantikz # hide
SparseGate(tCNOT, [2,4])
```

The Clifford operator tableaux can be completely arbitrary.
```@example 1
SparseGate(random_clifford(3), [2,4,5])
```

If the Clifford operator acts on all qubits, we do not need to specify indices, just use the operator.

### Noisy Gates

Each gate can be followed by noise applied to the qubits on which it has acted.
This is done by wrapping the given gate into a [`NoisyGate`](@ref)

```@example 1
ε = 0.03 # X/Y/Z error probability
noise = UnbiasedUncorrelatedNoise(ε)
noisy_gate = NoisyGate(SparseGate(tCNOT, [2,4]), noise)
```

In circuit diagrams the noise is not depicted, but after each application of the gate defined in `noisy_gate`, a noise operator will also be applied. The example above is of Pauli Depolarization implemented by [`UnbiasedUncorrelatedNoise`](@ref).

One can also apply only the noise operator by using [`NoiseOp`](@ref) which acts only on specified qubits. Or alternatively, one can use [`NoiseOpAll`](@ref) in order to apply noise to all qubits.

```@example 1
[NoiseOp(noise, [4,5]), NoiseOpAll(noise)]
```

The machinery behind noise processes and different types of noise is detailed in [the section on noise](@ref noise)

### Coincidence Measurements

Global parity measurements involving single-qubit projections and classical communication are implemented with [`BellMeasurement`](@ref). One needs to specify the axes of measurement and the qubits being measured. If the parity is trivial, the circuit continues, if the parity is non-trivial, the circuit ends and reports a detected failure.
This operator is frequently used in the simulation of entanglement purification.

```@example 1
BellMeasurement([sMX(1), sMY(3), sMZ(4)])
```

There is also [`NoisyBellMeasurement`](@ref) that takes the bit-flip probability of a single-qubit measurement as a third argument.

### Stabilizer Measurements

A measurement over one or more qubits can also be performed, e.g., a direct stabilizer measurement on multiple qubits without the use of ancillary qubits. When applied to multiple qubits, this differs from `BellMeasurement` as it performs a single projection, unlike `BellMeasurement` which performs a separate projection for every single qubit involved. This measurement is implemented in [`PauliMeasurement`](@ref) which requires a Pauli operator on which to project and the index of the classical bit in which to store the result. Alternatively, there are [`sMX`](@ref), [`sMZ`](@ref), [`sMY`](@ref) if you are measuring a single qubit.

```@example 1
[PauliMeasurement(P"XYZ", 1), sMZ(2, 2)]
```

### Reset Operations

The [`Reset`](@ref) operations lets you trace out the specified qubits and set their state to a specific tableau.

```@example 1
new_state = random_stabilizer(3)
qubit_indices = [1,2,3]
Reset(new_state, qubit_indices)
```

It can be done anywhere in a circuit, not just at the beginning.

### Non-Clifford Gates

The gates [`sT`](@ref) (T gate, π/8 phase rotation) and [`sCCZ`](@ref) (controlled-controlled-Z) are non-Clifford gates. They work with [`PureGeneralizedStabilizer`](@ref) states and are simulated via [`apply!`](@ref) and [`mctrajectory!`](@ref) as usual or directly with [`emtrajectories`](@ref), which performs end-of-circuit Z-basis measurements using the sum-over-Cliffords decomposition.

### Pauli Channels

[`UnitaryPauliChannel`](@ref) and [`PauliChannel`](@ref) represent non-Clifford channels as weighted sums of Pauli operators. They work with [`GeneralizedStabilizer`](@ref) states via [`apply!`](@ref), [`mctrajectory!`](@ref), and [`expect`](@ref).

Predefined channels include [`pcT`](@ref) (the T gate as a Pauli channel), [`pcPhase`](@ref)`(ϕ)` (arbitrary phase rotation), and [`pcRx`](@ref)`(θ)` (X rotation).

# Data Structures Options

## [Choosing Appropriate Tableau Data Structure](@id Choosing-Appropriate-Data-Structure)

There are four different data structures used to represent stabilizer states. If
you will never need projective measurements you probably would want to use
[`Stabilizer`](@ref). If you require projective measurements, but only on pure
states, [`Destabilizer`](@ref) should be the appropriate data structure. If
mixed stabilizer states are involved, [`MixedStabilizer`](@ref) would be
necessary.

[`Stabilizer`](@ref) is simply a list of Pauli operators in a tableau form. As a
data structure it does not enforce the requirements for a pure stabilizer state
(the rows of the tableau do not necessarily commute, nor are they forced to be
Hermitian; the tableau might be underdetermined, redundant, or contradictory).
It is up to the user to ensure that the initial values in the tableau are
meaningful and consistent.

[`canonicalize!`](@ref), [`project!`](@ref), and [`generate!`](@ref) can accept
an under determined (mixed state) `Stabilizer` instance and operate correctly.
`canonicalize!` can also accept a redundant `Stabilizer` (i.e. not all rows are
independent), leaving as many identity rows at the bottom of the canonicalized
tableau as the number of redundant stabilizers in the initial tableau.

`canonicalize!` takes ``\mathcal{O}(n^3)`` steps. `generate!` expects a
canonicalized input and then takes ``\mathcal{O}(n^2)`` steps. `project!` takes
``\mathcal{O}(n^3)`` for projecting on commuting operators due to the need to
call `canonicalize!` and `generate!`. If the projections is on an anticommuting
operator (or if `keep_result=false`) then it takes ``\mathcal{O}(n^2)`` steps.

[`MixedStabilizer`](@ref) provides explicit tracking of the rank of the mixed
state and works properly when the projection is on a commuting operator not in
the stabilizer (see table below for details). Otherwise it has the same
performance as `Stabilizer`.

The canonicalization can be made unnecessary if we track the destabilizer
generators. There are two data structures capable of that.

[`Destabilizer`](@ref) stores both the destabilizer and stabilizer states.
`project!` called on it never requires a stabilizer canonicalization, hence it
runs in ``\mathcal{O}(n^2)``. However, `project!` will raise an exception if you
try to project on a commuting state that is not in the stabilizer as that would
be an expensive ``\mathcal{O}(n^3)`` operation.

[`MixedDestabilizer`](@ref) tracks both the destabilizer operators and the
logical operators in addition to the stabilizer generators. It does not require
canonicalization for measurements and its `project!` operations always takes
``\mathcal{O}(n^2)``.

For the operation `_, anticom_index, result = project!(...)` we have the following behavior:

| projection | [`Stabilizer`](@ref) | [`MixedStabilizer`](@ref) | [`Destabilizer`](@ref) | [`MixedDestabilizer`](@ref) |
|---|---|---|---|---|
| on anticommuting operator `anticom_index>0` `result===nothing`| correct result in ``\mathcal{O}(n^2)`` steps | same as `Stabilizer` | same as `Stabilizer` | same as `Stabilizer` |
| on commuting operator in the stabilizer `anticom_index==0` `result!==nothing`| ``\mathcal{O}(n^3)``; or ``\mathcal{O}(n^2)`` if `keep_result=false` | ``\mathcal{O}(n^3)`` | ``\mathcal{O}(n^2)`` if the state is pure, throws exception otherwise | ``\mathcal{O}(n^2)`` |
| on commuting operator out of the stabilizer[^1]  `anticom_index==rank` `result===nothing`| ``\mathcal{O}(n^3)``, but the user needs to manually include the new operator to the stabilizer; or ``\mathcal{O}(n^2)`` if `keep_result=false` but then result indistinguishable from cell above and `anticom_index==0` | ``\mathcal{O}(n^3)`` and rank goes up by one | not applicable if the state is pure, throws exception otherwise | ``\mathcal{O}(n^2)`` and rank goes up by one |

Notice the results when the projection operator commutes with the state but is not generated by the stabilizers of the state (the last row of the table). In that case we have `_, anticom_index, result = project!(...)` where both `anticom_index==rank` and `result===nothing`, with `rank` being the new rank after projection, one more than the number of rows in the tableau before the measurement. 

[^1]:

    This can occur only if the state being projected is mixed. Both `Stabilizer`
    and `Destabilizer` can be used for mixed states by simply providing fewer
    stabilizer generators than qubits at initialization. This can be useful for
    low-level code that tries to avoid the extra memory cost of using
    `MixedStabilizer` and `MixedDestabilizer` but should be avoided otherwise.
    `project!` works correctly or raises an explicit warning on all 4 data
    structures.

## Non-Clifford State Representations

For circuits containing non-Clifford gates, two state types are available:

[`PureGeneralizedStabilizer`](@ref) represents a pure state as a superposition (with arbitrary amplitudes) of stabilizer states. It supports the non-Clifford gates [`sT`](@ref) and [`sCCZ`](@ref). Use directly with [`apply!`](@ref) and [`mctrajectory!`](@ref) as usual, but be aware that it has limited support for measurements. Use it with [`emtrajectories`](@ref) to sample Z-basis measurement outcomes at the end of a circuit. This is the right choice when you have a unitary circuit (no mid-circuit measurements) and only need measurement statistics at the end.

[`GeneralizedStabilizer`](@ref) represents a mixed state as a weighted sum ∑ ϕᵢⱼ Pᵢ ρ Pⱼ†, i.e. a weighted sum of "basis" density matrices, each of which is itself represented as a (projector on) stabilizer state. It supports arbitrary (non-unitary) Pauli channels such as [`PauliChannel`](@ref) and [`UnitaryPauliChannel`](@ref), applied via [`apply!`](@ref). Use it with [`mctrajectory!`](@ref). Can be used with [`expect`](@ref) as well. Pauli measurements on arbitrary (non-unitary) Pauli channels are also supported via [`projectrand!`](@ref) which performs a randomized projection of the state represented by the [`GeneralizedStabilizer`](@ref), based on the measurement of a [PauliOperator](@ref).

## [Bit Packing in Integers and Array Order](@id Bit-Packing-in-Integers-and-Array-Order)

We do not use boolean arrays to store information about the qubits as this would be wasteful (7 out of 8 bits in the boolean would be unused). Instead, we use all 8 qubits in a byte and perform bitwise logical operations as necessary. Implementation details of the object in RAM can matter for performance. The library permits any of the standard `UInt` types to be used for packing the bits, and larger `UInt` types (like `UInt64`) are usually faster as they permit working on 64 qubits at a time (instead of 1 if we used a boolean, or 8 if we used a byte).

Moreover, how a tableau is stored in memory can affect performance, as a row-major storage
usually permits more efficient use of the CPU cache (for the particular algorithms we use).

Both of these parameters are [benchmarked](bench_intsize.png) (testing the application of a Pauli operator, which is an $\mathcal{O}(n^2)$ operation; and testing the canonicalization of a Stabilizer, which is an $\mathcal{O}(n^3)$ operation). Row-major UInt64 is the best performing and it is  used by default in this library.

# [Stabilizer Tableau Algebra Manual](@id Stabilizer-Tableau-Algebra-Manual)

```@meta
DocTestSetup = quote
    using QuantumClifford
end
```

The library consists of two main parts: Tools for working with the algebra of Stabilizer tableaux and tools specifically for efficient Circuit Simulation. This chapter discusses the former "lower level" Stabilizer tableau algebra tools.

# Pauli Operators

The [`PauliOperator`](@ref) object represents multi-qubit Pauli operator
(``±\{1,i\}\{I,Z,X,Y\}^{\otimes n}``). It is stored in memory as a phase (a
single byte where `0x0,0x1,0x2,0x3` corresponds to $1,i,-1,-i$) and two
bit-arrays, for X and for Z components.

You can create them with a `P` string.

```jldoctest
julia> P"-iXZ"
-iXZ
```

Or by specifying phase and X/Z components:

```jldoctest
julia> PauliOperator(0x0,Bool[0,1,0],Bool[0,0,1])
+ _XZ
```

Both underscore and I can be used for identity.

```jldoctest
julia> P"I_XYZ"
+ __XYZ
```

Multiplication with scalars or other Pauli operators works as expected, as well
as tensor products of Pauli operators.

```jldoctest
julia> -1im*P"X"
-iX

julia> P"X" * P"Z"
-iY

julia> P"X" ⊗ P"Z"
+ XZ
```

One can check for commutativity with [`comm`](@ref).

```jldoctest
julia> comm(P"X",P"Z")
0x01

julia> comm(P"XX",P"ZZ")
0x00
```

And check the phase of a product with [`prodphase`](@ref).

```jldoctest
julia> prodphase(P"X", P"Z")
0x03

julia> prodphase(P"X", P"iZ")
0x00

julia> prodphase(P"X",P"Y")
0x01
```

Indexing operations are available.

```jldoctest
julia> p = P"IXYZ";

julia> p[1], p[2], p[3], p[4]
((false, false), (true, false), (true, true), (false, true))

julia> p = P"III";

julia> p[2] = (true, true);

julia> p
+ _Y_
```

Including fancy indexing:

```jldoctest
julia> P"IXYZ"[[2,3]]
+ XY

julia> P"IXYZ"[[false,true,true,false]]
+ XY
```

The operator is represented in memory by bit arrays (much denser than using byte
arrays).

```jldoctest
julia> p = P"-IXYZ";

julia> p.nqubits, p.xz
(4, UInt64[0x0000000000000006, 0x000000000000000c])
```

Views that give just the X or Z components of the `xz` bitarray are available through [`xview`](@ref) and [`zview`](@ref).

```jldoctest
julia> xview(P"XYZI")
1-element view(::Vector{UInt64}, 1:1) with eltype UInt64:
 0x0000000000000003
```

The convenience methods [`xbit`](@ref) and [`zbit`](@ref) give you Bool (GF2) vectors.

```jldoctest
julia> xbit(P"XYZI")
4-element Vector{Bool}:
 1
 1
 0
 0
```

# [Stabilizers](@id Stabilizers)

A [`Stabilizer`](@ref) object is a tableau of Pauli operators. When the tableau is
meant to represent a (pure or mixed) stabilizer state, all of these operators
should commute (but that is not enforced, rather `Stabilizer` is a generic
tableau data structure). It is stored in memory as a phase list and a bit-matrix
for X and Z components. It can be instantiated by an `S` string, or with a
number of different constructors.

!!! tip "Stabilizers and Destabilizers"
    In many cases you probably would prefer to use the [`MixedDestabilizer`](@ref)
    data structure, as it caries a lot of useful additional information, like tracking
    rank and destabilizer operators. `Stabilizer` has mostly a pedagogical value, and it
    is also used for slightly faster simulation of a particular subset of Clifford
    operations.
    See also the [data structures discussion page](@ref Choosing-Appropriate-Data-Structure).

```jldoctest
julia> S"-XX
         +ZZ"
- XX
+ ZZ

julia> Stabilizer([P"-XX",P"+ZZ"])
- XX
+ ZZ

julia> Stabilizer([0x2, 0x0],
                  Bool[1 1;
                       0 0],
                  Bool[0 0;
                       1 1])
- XX
+ ZZ
```

Direct sums can be performed,

```jldoctest
julia> S"-XX" ⊗ S"ZZ"
- XX__
+ __ZZ
```

Indexing operations are available, including fancy indexing. Be careful about how phase information gets transferred during sub-indexing.

```jldoctest
julia> s = S"-XYZ
             -ZIX
             +XIZ";

julia> s[1]
- XYZ

julia> s[1,2]
(true, true)

julia> s[[3,1]]
+ X_Z
- XYZ

julia> s[[3,1],[2]]
+ _
- Y
```

Consistency at creation is not verified so nonsensical stabilizers can be
created, both in terms of content and shape.

```jldoctest
julia> S"iX
         +Z"
+iX
+ Z
```

Similarly to the Pauli operators, a bit array representation is used.

```jldoctest stab
julia> s = S"-XXX
             +ZZI
             -IZZ"
- XXX
+ ZZ_
- _ZZ

julia> phases(s), tab(s).xzs
(UInt8[0x02, 0x00, 0x02], UInt64[0x0000000000000007 0x0000000000000000 0x0000000000000000; 0x0000000000000000 0x0000000000000003 0x0000000000000006])
```

And there are convenience functions that can extract the corresponding binary
check matrix.

```jldoctest stab
julia> stab_to_gf2(s)
3×6 Matrix{Bool}:
 1  1  1  0  0  0
 0  0  0  1  1  0
 0  0  0  0  1  1
```

# [Canonicalization of Stabilizers](@id Canonicalization-of-Stabilizers)

Canonicalization (akin to Gaussian elimination over F(2,2)) is implemented in
the [`canonicalize!`](@ref) function.
Besides the default canonicalization prescription,
alternative ones are available as described in the
[canonicalization page](@ref Canonicalization-operations).

```jldoctest
julia> s = S"-XXX
             +ZZX
             +III";

julia> canonicalize!(s)
+ YY_
+ ZZX
+ ___
```

If phases are inconsequential, the operations can be faster by not tracking and
updating them.

```jldoctest
julia> s = S"-XXX
             +ZZX
             +III";

julia> canonicalize!(s; phases=false)
- YY_
+ ZZX
+ ___
```

These operations are in place (as customarily signified by "!").

```jldoctest
julia> s = S"-XXX
             +ZZX
             +III";

julia> canonicalize!(s; phases=false);

julia> s
- YY_
+ ZZX
+ ___
```

# [Projective Measurements](@id Projective-Measurements)

The [`project!`](@ref) function is used to perform generic projective measurements.

!!! tip "Single qubit projections"
    If you know your Pauli measurement operator acts on a single qubit, there are
    much faster projection functions available, discussed in the next section.
    Namely [`projectX!`](@ref), [`projectY!`](@ref), and [`projectZ!`](@ref).

To observe the effect of different projections, we will start with a GHZ state.

```jldoctest proj
julia> s = S"-XXX
             +ZZI
             -IZZ";
```

The [`project!`](@ref) function returns the new stabilizer, the index where the
anticommutation was detected, and the result of the projection (`nothing` being
an undetermined result). For instance here we project on an operator that does
not commute with all stabilizer generators.

```jldoctest proj
julia> project!(copy(s), P"ZII")[1]
+ Z__
+ ZZ_
- _ZZ
```

Importantly, when there is an undetermined result, we return `nothing` **and
leave the phase of the new stabilizer the same as the phase of the projection
operator**. If you want to perform a Monte Carlo simulation, you need to
randomize the phase of the stabilizer at the anticommuting index yourself. For
instance, one can do:

```jldoctest proj
julia> newstate, anticomindex, result = project!(copy(s), P"XII")
       if isnothing(result)
           phases(newstate)[anticomindex] = rand([0x0,0x2])
       end
       result, anticomindex
(nothing, 2)
```

Of course, this is a rather cumbersome way to run a simulation, so we also provide
[`projectrand!`](@ref) which does the necessary randomization automatically,
for cases where you do not need the fine grained control of `project!`.

We can project on a commuting operator, hence no anticommuting terms (the
index is zero), and the result is perfectly determined (-1, or in our convention
to represent the phase, 0x2).

```jldoctest proj
julia> project!(copy(s), P"-ZZI")
(Stabilizer 3×3, 0, 0x02)
```

When the projection is consistent with the stabilizer (i.e. the measurement
result is not `nothing`), this would trigger an expensive canonicalization
procedure in order to calculate the measurement result (unless we are using more
advanced data structures to represent the state, which are discussed later). If
all you want to know is whether the projection is consistent with the
stabilizer, but you do not care about the measurement result, you can skip the
canonicalization and calculation of the result.

```jldoctest proj
julia> project!(copy(s), P"-ZZI", keep_result=false)
(Stabilizer 3×3, 0, nothing)
```

Lastly, in either case, you can skip the calculation of the phases as well, if
they are unimportant.

```jldoctest proj
julia> project!(copy(s), P"ZZI", phases=false)
(Stabilizer 3×3, 0, 0x00)
```

## Sparse single-qubit measurements

In many circumstances only a single-qubit operator is being measured. In that case one should use the [`projectX!`](@ref), [`projectY!`](@ref), and [`projectZ!`](@ref) functions as they are much faster thanks to tracking only a single qubit.
They have versions that randomize the phase as necessary as well:  [`projectXrand!`](@ref), [`projectYrand!`](@ref), and [`projectZrand!`](@ref).

## Gate-like interface

If you do not need all this boilerplate, and especially if you want to perform the randomization automatically, you can use the gate-like "symbolic/sparse/named" operations [`sMX`](@ref), [`sMY`](@ref), and [`sMZ`](@ref), that perform the measurement and the necessary randomization of phase. If the measurement result is to be stored, you can use the [`Register`](@ref) structure that stores both stabilizer tableaux and bit values.

```
julia> state = Register(ghz(3), [false,false])
Register{Vector{UInt8}, Matrix{UInt64}}(Rank 3 stabilizer
+ Z__
+ _X_
+ __X
═════
+ XXX
+ ZZ_
+ Z_Z
═════
, Bool[0, 0])

julia> apply!(state, sMX(3,2)) # which qubit is measured and in which bit it is stored
Register{Vector{UInt8}, Matrix{UInt64}}(Rank 3 stabilizer
+ Z__
+ _X_
+ Z_Z
═════
+ XXX
+ ZZ_
- __X
═════
, Bool[0, 1])

julia> bitview(state)
2-element Vector{Bool}:
 0
 1
```

Or you can use the [`projectXrand!`](@ref), [`projectYrand!`](@ref), and [`projectZrand!`](@ref) if you prefer a function-call interface.


# [Partial Traces](@id Partial-Traces)

Partial trace (using [`traceout!`](@ref)) over even a single qubit might cause many of them to decohere due to entanglement.

```jldoctest
julia> ghz = S"XXX
               ZZ_
               _ZZ";

julia> traceout!(ghz, [1])
+ _ZZ
+ ___
+ ___
```

This is somewhat more elegant when the datastructure being used explicitly supports mixed states.

```jldoctest
julia> ghz = MixedStabilizer(S"XXX
                               ZZ_
                               _ZZ");

julia> traceout!(ghz, [1])
+ _ZZ
```


# [Generating a Pauli Operator with Stabilizer Generators](@id Generating-a-Pauli-Operator-with-Stabilizer-Generators)

The [`generate!`](@ref) function attempts to generate a Pauli operator by
multiplying together the operators belonging to a given stabilizer (or reports
their independence). This particular function requires the stabilizer to be
already canonicalized.

```jldoctest gen
julia> s = S"-XXX
             +ZZI
             -IZZ";

julia> s = canonicalize!(s)
- XXX
- Z_Z
- _ZZ
```

It modifies the Pauli operator in place, reducing it to identity if possible.
The leftover phase is present to indicate if the phase itself could not have
been canceled. The list of indices specifies which rows of the stabilizer were
used to generated the desired Pauli operator.

```jldoctest gen
julia> generate!(P"XYY", s)
(- ___, [1, 3])
```

Phases can be neglected, for higher performance.

```jldoctest gen
julia> generate!(P"XYY", s, phases=false)
(+ ___, [1, 3])
```

If the Pauli operator can not be generated by the stabilizer, `nothing` value is
returned.

```jldoctest gen
julia> generate!(P"ZZZ", s)

julia> generate!(P"XZX", s)

julia> generate!(P"YYY", s)
```

# [Clifford Operators](@id Clifford-Operators)

The [`CliffordOperator`](@ref) structure represents a linear mapping between
stabilizers (which should also preserve commutation relationships, but that is
not checked at instantiation).
These are n-qubit dense tableaux, representing an operation on n-qubit states. For single- or two-qubit gates, it is much more efficient to use small sparse/named/[symbolic Clifford operators](@ref Symbolic-Clifford-Operators).
A number of predefined Clifford operators are available,
their name prefixed with `t` to mark them as dense tableaux.

```jldoctest
julia> tHadamard
X₁ ⟼ + Z
Z₁ ⟼ + X

julia> tPhase
X₁ ⟼ + Y
Z₁ ⟼ + Z

julia> tCNOT
X₁ ⟼ + XX
X₂ ⟼ + _X
Z₁ ⟼ + Z_
Z₂ ⟼ + ZZ

julia> tId1
X₁ ⟼ + X
Z₁ ⟼ + Z
```

Chaining and tensor products are possible. Same for qubit permutations.

```jldoctest
julia> tHadamard ⊗ tPhase
X₁ ⟼ + Z_
X₂ ⟼ + _Y
Z₁ ⟼ + X_
Z₂ ⟼ + _Z

julia> tHadamard * tPhase
X₁ ⟼ - Y
Z₁ ⟼ + X

julia> permutesubsystem(tCNOT, [2,1])
X₁ ⟼ + X_
X₂ ⟼ + XX
Z₁ ⟼ + ZZ
Z₂ ⟼ + _Z
```

You can create custom Clifford operators with C-strings or with a list of Pauli
operators.

```jldoctest
julia> C"-ZZ
         +_Z
         -X_
         +XX"
X₁ ⟼ - ZZ
X₂ ⟼ + _Z
Z₁ ⟼ - X_
Z₂ ⟼ + XX

julia> CliffordOperator([P"-ZZ", P"_Z", P"-X_", P"XX"])
X₁ ⟼ - ZZ
X₂ ⟼ + _Z
Z₁ ⟼ - X_
Z₂ ⟼ + XX
```

Naturally, the operators can be applied to stabilizer states. This includes high
performance in-place operations (and the phase can be neglected with
`phases=false` for faster computation).

```jldoctest
julia> tCNOT * S"X_"
+ XX

julia> s = S"X_";

julia> apply!(s,tCNOT)
+ XX
```

Sparse applications where a small Clifford operator is applied only on a particular subset of a larger stabilizer is also possible, but in such circumstances it is useful to consider using [symbolic/sparse/named operators](@ref Symbolic-Clifford-Operators) too.

```jldoctest
julia> s = S"Z_YX";

julia> apply!(s, [4,2], tCNOT) # Apply the CNOT on qubits 4 and 2
+ ZXYX
```

Pauli operators act as Clifford operators too (but they are rather boring, as
they only change signs).

```jldoctest
julia> P"XII" * S"ZXX"
- ZXX
```

Internally, the `CliffordOperator` structure simply stores the tableau representation of the operation.

The `apply!` function is efficiently multithreaded for `CliffordOperators`. To start multithreaded Julia, use `julia -t<N>`
where `<N>` specifies the number of threads.

# [Symbolic/Sparse/Named Clifford Operators](@id Symbolic-Clifford-Operators)

Much faster implementations for a number of common Clifford operators are available. They are stored as special
named small structs, instead of as a full tableau. These are the subtypes of `AbstractSingleQubitOperator` and
`AbstractTwoQubitOperator`. Currently these are:

```@example subtypes
using QuantumClifford # hide
using InteractiveUtils # hide
subtypes(QuantumClifford.AbstractSingleQubitOperator)
```

```@example subtypes
subtypes(QuantumClifford.AbstractTwoQubitOperator)
```

Generally, they have the prefix `s` for symbolic/small/sparse.
They are used slightly differently, as one needs to specify the qubits on which they act while instantiating them:

```jldoctest
julia> sHadamard(2)
sHadamard on qubit 2
X₁ ⟼ + Z
Z₁ ⟼ + X

julia> sHadamard(2)*S"XXX"
+ XZX

julia> sCNOT(2,3)*S"XYY"
- XXZ
```

The `apply!` function is efficiently multithreaded for these symbolic operators as well. To start multithreaded Julia, use `julia -t<N>`
where `<N>` specifies the number of threads.

Symbolic projectors on single qubits also exist: [`sMX`](@ref), [`sMY`](@ref), [`sMZ`](@ref). When used with the [`Register`](@ref) state representation, they can store the measurement results in the corresponding classical register.

# Destabilizers

Slightly abusing the name: What we call "destabilizers" here is a stabilizer and
its destabilizing operators saved together. They are implemented with the
[`Destabilizer`](@ref) object and are initialized from a stabilizer.

```jldoctest destab
julia> s=S"-XXX
           -ZZI
           +IZZ";

julia> d = Destabilizer(s)
𝒟ℯ𝓈𝓉𝒶𝒷
+ Z__
+ _XX
+ __X
𝒮𝓉𝒶𝒷━
- XXX
- ZZ_
+ _ZZ
```

They have convenience methods to extract only the stabilizer and destabilizer
pieces:

```jldoctest destab
julia> stabilizerview(d)
- XXX
- ZZ_
+ _ZZ

julia> destabilizerview(d)
+ Z__
+ _XX
+ __X
```

Importantly commuting projections are much faster when tracking the destabilizer
as canonicalization is not necessary (an ``\mathcal{O}(n^2)`` complexity because it avoids
the expensive ``\mathcal{O}(n^3)`` canonicalization operation).

```jldoctest destab
julia> project!(d,P"ZZI")
(Destablizer 3×3, 0, 0x02)
```

Non-commuting projections are just as fast as when using only stabilizers.

```jldoctest destab
julia> project!(d,P"ZZZ")
(Destablizer 3×3, 1, nothing)
```

Clifford operations can be applied the same way they are applied to stabilizers.

```jldoctest destab
julia> apply!(d,tCNOT⊗tHadamard)
𝒟ℯ𝓈𝓉𝒶𝒷
- X_Z
+ _XZ
+ X__
𝒮𝓉𝒶𝒷━
+ _ZX
- _Z_
+ ZZX
```

# Mixed States

Both the `Stabilizer` and `Destabilizer` structures have more general forms
that enable work with mixed stabilizer states.
They are the [`MixedStabilizer`](@ref) and [`MixedDestabilizer`](@ref) structures,
described in [Mixed States](@ref Mixed-Stabilizer-States).
More information that can be seen in the [data structures page](@ref Choosing-Appropriate-Data-Structure),
which expands upon the algorithms available for each structure.

## Expectations and Fidelity

An `n`-qubit stabilizer tableau with `r` independent generators represents the
normalized density operator

```math
\rho_S = 2^{-n}\sum_{g\in S}g = \frac{P_S}{2^{n-r}},
```

where ``S`` is the signed stabilizer group and ``P_S`` projects onto its common
``+1`` eigenspace. A rank-`n` tableau is pure. A rank-deficient tableau is the
maximally mixed state on a stabilized subspace of dimension ``2^{n-r}``.

[`expect`](@ref) accepts a stabilizer state as the operator as well as a
[`PauliOperator`](@ref). For two state arguments it returns their
Hilbert--Schmidt expectation ``\operatorname{Tr}(\rho_A\rho_B)``. When the
operator state is pure, this is the probability of its projector.

```jldoctest metrics
julia> mixed = maximally_mixed(1);

julia> expect(MixedDestabilizer(S"Z"), mixed)
0.5

julia> expect(mixed, mixed) # purity of I/2
0.5
```

The indexed form embeds the operator in a larger system at the given indices, leaving the identity on all other qubits.

```jldoctest metrics
julia> expect([1, 3], MixedDestabilizer(bell()), MixedDestabilizer(ghz(3)))
0.5
```

[`fidelity`](@ref) uses the root-fidelity convention. For two pure states it
returns their overlap and delegates to `LinearAlgebra.dot`. If exactly one
state is pure, its square is the corresponding pure-state projector
expectation.

```jldoctest metrics
julia> fidelity(MixedDestabilizer(S"Z"), mixed)
0.7071067811865476
```

# Random States and Circuits

[`random_clifford`](@ref), [`random_stabilizer`](@ref), and [`enumerate_cliffords`](@ref) can be used for the generation of random states.

# Full ECC API (autogenerated)

```@autodocs
Modules = [QuantumClifford.ECC]
Private = false
```

## Implemented in an extension requiring `Hecke.jl`

```@autodocs
Modules = [QuantumCliffordHeckeExt]
Private = false
```

## Implemented in an extension requiring `Oscar.jl`

```@autodocs
Modules = [QuantumCliffordOscarExt]
Private = false
```

## Implemented in an extension requiring `JuMP.jl`

```@autodocs
Modules = [QuantumCliffordJuMPExt]
Private = false
```

# [Operators in Circuit Simulations](@id noisycircuits_ops)

```@meta
DocTestSetup = quote
    using QuantumClifford
    using Quantikz
end
```

!!! warning "Unstable"
    This is experimental functionality with an unstable API.

Too see a condensed list of all operations [check out the API docs](@ref all-operations).

## Unitary Gates

We distinguish between symbolic gates like [`sCNOT`](@ref) that have specialized (fast) `apply!` methods (usually just for single and two qubit gates) and general tableau representation of gates like [`CliffordOperator`](@ref) that can represent any multi-qubit gate.

Predefined unitary gates are available, like [`sCNOT`](@ref), [`sHadamard`](@ref), etc.

```@example 1
using QuantumClifford # hide
using Quantikz # hide
[sCNOT(2,4),sHadamard(2),sCPHASE(1,3),sSWAP(2,4)]
```

Any arbitrary tableaux can be used as a gate too.

They can be specified by giving a Clifford operator tableaux and the indices on which it acts
(particularly useful for gates acting on a small part of a circuit):

```@example 1
using QuantumClifford # hide
using Quantikz # hide
SparseGate(tCNOT, [2,4])
```

The Clifford operator tableaux can be completely arbitrary.
```@example 1
SparseGate(random_clifford(3), [2,4,5])
```

If the Clifford operator acts on all qubits, we do not need to specify indices, just use the operator.

## Noisy Gates

Each gate can be followed by noise applied to the qubits on which it has acted.
This is done by wrapping the given gate into a [`NoisyGate`](@ref)

```@example 1
ε = 0.03 # X/Y/Z error probability
noise = UnbiasedUncorrelatedNoise(ε)
noisy_gate = NoisyGate(SparseGate(tCNOT, [2,4]), noise)
```

In circuit diagrams the noise is not depicted, but after each application of the gate defined in `noisy_gate`, a noise operator will also be applied. The example above is of Pauli Depolarization implemented by [`UnbiasedUncorrelatedNoise`](@ref).

One can also apply only the noise operator by using [`NoiseOp`](@ref) which acts only on specified qubits. Or alternatively, one can use [`NoiseOpAll`](@ref) in order to apply noise to all qubits.

```@example 1
[NoiseOp(noise, [4,5]), NoiseOpAll(noise)]
```

## Coincidence Measurements

Global parity measurements involving single-qubit projections and classical communication are implemented with [`BellMeasurement`](@ref). One needs to specify the axes of measurement and the qubits being measured. If the parity is trivial, the circuit continues, if the parity is non-trivial, the circuit ends and reports a detected failure.
This operator is frequently used in the simulation of entanglement purification.

```@example 1
BellMeasurement([sMX(1), sMY(3), sMZ(4)])
```

There is also [`NoisyBellMeasurement`](@ref) that takes the bit-flip probability of a single-qubit measurement as a third argument.

## Stabilizer Measurements

A measurement over one or more qubits can also be performed, e.g., a direct stabilizer measurement on multiple qubits without the use of ancillary qubits. When applied to multiple qubits, this differs from `BellMeasurement` as it performs a single projection, unlike `BellMeasurement` which performs a separate projection for every single qubit involved. This measurement is implemented in [`PauliMeasurement`](@ref) which requires a Pauli operator on which to project and the index of the classical bit in which to store the result. Alternatively, there are [`sMX`](@ref), [`sMZ`](@ref), [`sMY`](@ref) if you are measuring a single qubit.

```@example 1
[PauliMeasurement(P"XYZ", 1), sMZ(2, 2)]
```

TODO: SparseMeasurement, NoisyMeasurement

## Verification Operations

At the end of many circuits one might want to check whether they performed correctly. The [`VerifyOp`](@ref) operation corresponds to an unphysical perfect tomographic operation, checking whether the state of the qubits at the given indices is indeed what is expected. If it is, the operation reports a success, otherwise it reports an undetected error.

```@example 1
desired_state = random_stabilizer(5)
qubit_indices = [1,2,3,4,7]
VerifyOp(desired_state, qubit_indices)
```

## Reset Operations

The [`Reset`](@ref) operations lets you trace out the specified qubits and set their state to a specific tableau.

```@example 1
new_state = random_stabilizer(3)
qubit_indices = [1,2,3]
Reset(new_state, qubit_indices)
```

It can be done anywhere in a circuit, not just at the beginning.

## Gates Conditioned on Classical Bits


[`ConditionalGate`](@ref) is a conditional gate that performs one of two provided gates, depending on the value of a given classical bit.

[`IndexedDecisionGate`](@ref) is a conditional gate that performs one of the supplied `gates`, depending on the output of `decisionfunction` applied to the entire classical bit register.

```@example 1
gate1 = SparseGate(tCNOT,   [1,2])
gate2 = sCPHASE(1,2)
gate3 = SparseGate(tSWAP,   [1,3])
cg = ConditionalGate(gate1, gate2, 2)
dg = IndexedDecisionGate([gate1,gate2,gate3], bit_register->1) # it will always perform gate1
[sMX(4,1), sMZ(5,2), cg, dg]
```

TODO: Split `ConditionalGate` into quantum conditional and classical conditional
